bool Common_PhytoTreatment_WeatherOriented_OpeningPredicate (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Vineyard* pEA = App_GetVineyard((Activity*)pChantier);
  int now = pCurrentSim->Clock(); 
//printf("\nt = %d entree Common_PhytoTreatment_WeatherOriented_OP chantier : '%s'", now, pChantier->InstanceName());
  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);

  bool result = FALSE;

  int nbRequested = pChantier->GetIntConstValue(NEED_FOR_NEXT_FAVOURABLE_DAYS);

  int typeChantier = App_GetDistributedActivitySetType(pChantier);
//printf("\n\ttypeChantier = %d", typeChantier);
//printf("\n\tnbRequested = %d", nbRequested);
  //
  // recuperation date nominale de l'intervention (cf. OP_PhytoTreatments_Body)
  // ------------------------------------------------------------
  int nominalDate = pChantier->GetIntConstValue(ACTIVITY_NOMINAL_DATE);
  //
  // etabissement nb jours d'anticipation (cad avant la date nominale)
  //-------------------------------------------------------------
  
  tm* pTm_now = ClockValueToTm(now);
  int jd_now = pTm_now->tm_yday;
  delete pTm_now;
  tm* pTm_nominal = ClockValueToTm(nominalDate);
  int jd_nominal = pTm_nominal->tm_yday;
  delete pTm_nominal;
  int deltaJulianDays = jd_nominal - jd_now; 
//printf("\n\tdeltaJulianDays = %d", deltaJulianDays);

  //
  // etabissement attitude vis-a-vis d'une prevision de pluie
  //-------------------------------------------------------------
  bool avantPluie;  
  // TRUE  : attitude = "si pluie pr�vue, alors je traite avant"
  // FALSE : attitude = "si pluie pr�vue, je parie qu'elle sera de courte duree,
  //                     donc je prends le risque d'attendre la fin de la pluie"
  //
  if(deltaJulianDays >= 2) {    // AVANT-VEILLE ou avant
                                // on passe avant ou apres la pluie prevue
	// captage option par d�faut du manager
	avantPluie = App_GetIntDecisionOption(pEA, 
										  OPT_PHYTO_TREATMENT_RAIN_ANTICIPATION);
	// si pression maladie elevee, on passe avant
	if(avantPluie == FALSE) {
	  int powderyMildewLevel = App_GetIntPestInfo(pEA, POWDERY_MILDEW_LEVEL); 
	  int downyMildewLevel   = App_GetIntPestInfo(pEA, DOWNY_MILDEW_LEVEL);
	  if((powderyMildewLevel > 1)  
		 ||
		 (downyMildewLevel > 1)) {  // forte pression maladie
		avantPluie = TRUE;
	  }
	  if(avantPluie == FALSE) {
		Entity* pComposedProgram = 
		  (Entity*)pChantier->GetFirstContainer(PHYTO_TREATMENT_COMPOSED_PROGRAM,
												TRUE);
		int flagMildew = pConduite->GetIntConstValue(FLAG_MILDEW);
		int protection =
		  pComposedProgram->GetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE);
		if(flagMildew                // risque mildiou avere 
		   && 
		   (protection == 0)) {     //  ET vigne non encore protegee
		  avantPluie = TRUE;
		}
	  }
	}
  }
  else
	avantPluie = TRUE;         // la VEILLE, on passe avant la pluie prevue
  
  //
  // Recuperation des stations meteo pour cette EA
  //----------------------------------------------
  float totalArea = (float)0.;     // pour etablissement indicateurs (plus loin)
  pEntityTab* pWSList = new pEntityTab();
  pEntityTab pPlotList = pEA->GetElementTab();
  int nbPlots = pPlotList.size();
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot_i = (Entity*)pPlotList[i];
	float area_i = pPlot_i->GetFloatConstValue(AREA);
	totalArea += area_i;
	Entity* pWS_i = pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
	pWSList->push_back_ifnew(pWS_i);
  }
//printf("\nstations meteo :");pWSList->display_names();

  // etablissement previsions pluie pour ces stations
  //-------------------------------------------------
  int nbWS = pWSList->size();
  for(int i=0;i<nbWS;i++) {
	Entity* pWS_i = (Entity*)pWSList->get_element(i);
	char* pathName_i = pWS_i->GetStringConstValue(PATH_NAME_ATTRIBUTE);
//printf("\n\tpath : '%s'", pathName_i);
	
	//
	// dans la section ci-dessous, bornes des plages de pr�visions � valider !!!
	// De plus, il faut avoir des plages differentes pour le mildiou :
	// --> voir plus bas
	//
	float cumulPluie_J;
	float cumulPluie_JP1;
	float cumulPluie_JP2;
	if(nbRequested == 1) {
	  cumulPluie_J = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 12)
		+ pWS_i->GetFloatVarValue(RAINFALL);
	  
	  cumulPluie_JP1 = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 24, 47);
	  
	  cumulPluie_JP2 = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 48, 61);
	}
	else {
	  cumulPluie_J = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 23)
		+ pWS_i->GetFloatVarValue(RAINFALL);
	  
	  cumulPluie_JP1 = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 24, 38);
	  
	  cumulPluie_JP2 = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 39, 61);
	}
	float cumulPluie_JP3;   // pour mildiou
	cumulPluie_JP3 = 
	  SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 71)
	  + pWS_i->GetFloatVarValue(RAINFALL);
	
	pWS_i->ClearFloatTabValues(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY);
	pWS_i->AddFloatValueElement(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
								cumulPluie_J);
	pWS_i->AddFloatValueElement(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
								cumulPluie_JP1);
	pWS_i->AddFloatValueElement(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
								cumulPluie_JP2);
	pWS_i->AddFloatValueElement(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
								cumulPluie_JP3);
	Date laDate = ClockValueToDate(now);
//printf("\n%d-%s-%d %dH ", laDate.mday, MonthToChar(laDate.month), laDate.year, laDate.hour); printf("prevision pluie J JP1 JP2 '%s' : %5.1f %5.1f %5.1f", pWS_i->InstanceName(), cumulPluie_J, cumulPluie_JP1, cumulPluie_JP2);
//printf("\n%d-%s-%d %dH ", laDate.mday, MonthToChar(laDate.month), laDate.year, laDate.hour); printf("prevision pluie JP3 '%s' : %5.1f", pWS_i->InstanceName(), cumulPluie_JP3);
  }
  delete pWSList;

  // etablissement indicateurs pour l'ensemble des parcelles : selon la
  // situation (position/date nominale, duree periode correcte requise, ..)
  // une ou l'autre des 4 conditions suivantes doit �tre respect�e sur une 
  // proportion suffisante de la surface a traiter:
  // condition 1 : meteo ok aujourd'hui
  // condition 2 : meteo ok aujourd'hui et demain
  // condition 3 : meteo ok aujourd'hui et demain, et pas ok apr�s-demain
  // condition 4old : meteo ok aujourd'hui, et pas ok demain ni apr�s-demain
  // condition 4new : meteo ok aujourd'hui, et pas ok demain et ok apr�s-demain
  // condition 5 (anti-mildiou) : lire dans setFlagMildew_Body, case R0
  //                              applicable ici dans tous les cas
  //
  // 'meteo ok' := somme des pluies horaires < seuil fixe
  //
  // ==>
  // 1 on examine tour a tour chaque parcelle p_i
  //   1.1 on examine tour � tour chaque condition C_j
  //       SI    C_j respectee 
  //       ALORS proportionRespectCondition_i += p_i.surface/surfaceTotale
  // 2 selon la situation, on utilise proportionRespectCondition_[1 2 3 ou 4]
  //   pour renvoyer TRUE ou FALSE
  //-------------------------------------------------
  float seuilPluie = GetRealParameterValue("virtualManager", "rainfallThresholdForPhytoTreatment");
  float proportionRespectCondition_1 = (float)0.;
  float proportionRespectCondition_2 = (float)0.;
  float proportionRespectCondition_3 = (float)0.;
  float proportionRespectCondition_4 = (float)0.;
  //bool respectCondition_i_1 = FALSE;  // pour trace
  //bool respectCondition_i_2 = FALSE;  //     "
  //bool respectCondition_i_3 = FALSE;  //     "
  //bool respectCondition_i_4 = FALSE;  //     "
  //bool respectCondition_i_5 = FALSE;  //     "

  bool antiMildewNeeded = FALSE;
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot_i = (Entity*)pPlotList[i];
	float area_i = pPlot_i->GetFloatConstValue(AREA);
	float proportionSurface_i = area_i/totalArea;
//printf("\n'%s'\tprop surf.=%3.2f ", pPlot_i->InstanceName(), proportionSurface_i);
	Entity* pWS_i = pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
	pFloatTab* rainFallVector = 
	  pWS_i->GetFloatTabConstValue(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY);

	if(typeChantier == ANTI_MILDIOU) {
	  //
	  // evaluation du besoin de traiter
	  //
	  bool respectCondition_niv = FALSE;  // pour trace
	  bool respectCondition_dis = FALSE;  // pour trace
	  float cumulPluie_JP3 = rainFallVector->get_element(3);
	  if(cumulPluie_JP3 > seuilPluie) {
		respectCondition_niv = TRUE; // pour trace
//printf(" respectCondition_niv : %d\n", respectCondition_niv);
		// examen distribution
		respectCondition_dis = TRUE;
//printf("\nApp_GetFlagMildew case R0 avec foyersPrimaires : completer l'estimation de la distribution");
	  }
	  if(respectCondition_niv && respectCondition_dis) {
		antiMildewNeeded = TRUE;
	  }
	}
	if((typeChantier != ANTI_MILDIOU)
	   ||
	   (antiMildewNeeded == TRUE)) {
	  float cumulPluie_J = rainFallVector->get_element(0);
	  if(cumulPluie_J < seuilPluie) {
		//respectCondition_i_1 = TRUE;// pour trace
		proportionRespectCondition_1 += proportionSurface_i;
		float cumulPluie_JP1 = rainFallVector->get_element(1);
		if(cumulPluie_JP1 < seuilPluie) {
		  //respectCondition_i_2 = TRUE;// pour trace
		  proportionRespectCondition_2 += proportionSurface_i;
		  float cumulPluie_JP2 = rainFallVector->get_element(2);
		  if(cumulPluie_JP2 >= seuilPluie) {
			//respectCondition_i_3 = TRUE;// pour trace
			proportionRespectCondition_3 += proportionSurface_i;
		  }
		}
		else {
		  float cumulPluie_JP2 = rainFallVector->get_element(2);
		  //if(cumulPluie_JP2 >= seuilPluie) {     // old
		  if(cumulPluie_JP2 < seuilPluie) {      // new
			//respectCondition_i_4 = TRUE;// pour trace
			proportionRespectCondition_4 += proportionSurface_i;
		  }
		}
	  }
	};
//printf("%d %d %d %d", respectCondition_i_1, respectCondition_i_2, respectCondition_i_3, respectCondition_i_4);
  }

  float seuilRespect = GetRealParameterValue("virtualManager", "satisfactionThresholdForPhytoTreatment");
  bool respectCondition_1 = (proportionRespectCondition_1 >= seuilRespect);
  bool respectCondition_2 = (proportionRespectCondition_2 >= seuilRespect);
  bool respectCondition_3 = (proportionRespectCondition_3 >= seuilRespect);
  bool respectCondition_4 = (proportionRespectCondition_4 >= seuilRespect);
//printf("\nproportion respect : %3.2f %3.2f %3.2f %3.2f", proportionRespectCondition_1, proportionRespectCondition_2, proportionRespectCondition_3, proportionRespectCondition_4);
//printf("\n           respect : %d    %d    %d    %d", respectCondition_1, respectCondition_2, respectCondition_3, respectCondition_4);

  //
  // evaluation finale de la condition d'ouverture
  //----------------------------------------------

  if((typeChantier == ANTI_MILDIOU)
	 &&
	 (antiMildewNeeded == FALSE)) {
	result = FALSE;
  }
  else {
	if(deltaJulianDays >= 1) {       // on est avant la date nominale
	  if(  (nbRequested == 2)              // il faut 2 jours OK ...
		   &&
		   avantPluie) {
		if(respectCondition_3) {           // ... et on les a, mais il pleut apres
		  result = TRUE;
		}
	  }
	  else
		if((nbRequested == 1)              // il faut 1 jour OK ...
		   &&
		   avantPluie
		   && 
		   respectCondition_4) {           // ... et on l'a, mais il pleut apres
		  result = TRUE;
		}
	}
	else {                         // on est � la date nominale ou bien apres
	  if(  (nbRequested == 2)              // il faut 2 jours OK ...
		   &&
		   avantPluie
		   && 
		   respectCondition_2) {           // ... et on les a
		result = TRUE;
	  }
	  else
		if((nbRequested == 1)              // il faut 1 jour OK ...
		   &&
		   avantPluie
		   && 
		   respectCondition_1) {           // ... et on l'a
		  result = TRUE;
	  }
	}
  }
  if((nbRequested == 2) && result)
	pChantier->SetIntConstValue(NEED_FOR_NEXT_FAVOURABLE_DAYS, 1);

//printf("\nCommon_PhytoTreatment_WeatherOriented_OP pChantier : '%s' returns %d", pChantier->InstanceName(), result);
  return result;
}
