void SetRowSoilManagement_TillageStrategy (Entity* pEA)
//---------------------------------------------
// Description  : Etablissement du mode d'entretien du sol des rangees
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  //
  // recuperation du plotInternalPatternSet de l'EA
  //
  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pConduite->GetSuperEntity();
  Entity* optionSet //PlotInternalPatternOptionSet
	= pARB->GetEntityConstValue(PLOT_PATTERN_OPTION_SET_ATTRIBUTE);
  //
  // boucle sur les parcelles
  //
  int nbPlots = pEA->GetNumberOfElements();
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot_i = pEA->GetElement(i);
	int alleyWidth = pPlot_i->GetIntConstValue(ALLEY_WIDTH);
	//
	// attribution du PlotInternalPatternOptionSubset
	//
	Entity* optionSubset = optionSet->GetElement(1);
	bool largeWidth = FALSE;
	if(alleyWidth  >= 200) {
	  largeWidth = TRUE;
	  optionSubset = optionSet->GetElement(0);
	}
	//      
	//recuperation de p, q et r et attribution aux parcelles
	//
	float q = 
	  optionSubset->GetFloatConstValue(OPT_RIDING_ORIENTED_INTER_ROW_PROPORTION);
	pPlot_i->SetFloatConstValue(RIDING_ORIENTED_INTER_ROW_PROPORTION, q);
	float p = 
	  optionSubset->GetFloatConstValue(OPT_GRASS_STRIP_ALLEY_WIDTH_RATIO);
	pPlot_i->SetFloatConstValue(GRASS_STRIP_ALLEY_WIDTH_RATIO, p);
	float r = 
	  optionSubset->GetFloatConstValue(OPT_CROP_ROW_ALLEY_WIDTH_RATIO); 
	pPlot_i->SetFloatConstValue(CROP_ROW_ALLEY_WIDTH_RATIO, r); 
	
	Entity* pVegetal_i = pPlot_i->GetComponent(VEGETAL_COMPARTMENT);
	int nbRows = pVegetal_i->GetNumberOfElements();

	//
	//attribution des soilManagementModality aux rangees
	//
	if(largeWidth) {       // parcelles larges travaillees tous les inter-rangs
	  for(int j=0;j<nbRows;j++) {
		Entity* pRow_i_j = pVegetal_i->GetElement(j);
		switch (j) {
		case 0 : {   // inter-rang stabilise
		  pRow_i_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
		}
		case 1 : {   // inter-rang travaille
		  pRow_i_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE); break;
		}
		case 2 : {   // rang voisin d'inter-rang stabilise
		  pRow_i_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
		}
		case 3 : {   //rang non voisin d'inter-rang stabilise
		  if((r > 0) && (q < 0.5))
			pRow_i_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		  else
			pRow_i_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		  break;
		}	    
		}
	  }
	}
	else {                // parcelles etroites desherbees chimiquement en plein 
	  for(int j=0;j<nbRows;j++) {
		Entity* pRow_i_j = pVegetal_i->GetElement(j);
		switch (j) {
		case 0 : {   // inter-rang stabilise
		  pRow_i_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
		}
		case 1 : {   // inter-rang travaille
		  pRow_i_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		  pPlot_i->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
		  pPlot_i->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
		  pPlot_i->SetFloatVarValue(PERCENT_SPRING_TILLED, (float)-1.);
		  break;
		}
		case 2 : {   // rang voisin d'inter-rang stabilise
		  pRow_i_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
		}
		case 3 : {   //rang non voisin d'inter-rang stabilise
		  pRow_i_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
		}	    
		}
	  }
	}
	//
	//attribution des surfaces aux rangees
	//
	pPlot_i->ExecVoidMethod(ASSIGN_RELATIVE_AREA_TO_ROWS);
  }
}
