int pruningOperationNominalSpeed_whenGetInt_Body(MonitorMethod* pM)
//---------------------------------------------
// Definition de la fonction qui sera declenchee lors de
// chaque acces de la variable surveillee.
//---------------------------------------------
{
  Descriptor* pVD = pM->GetDescriptorArgValue(MONITOREDDESCRIPTOR_ARGUMENT);
  int value = pM->GetIntArgValue(CURRENTINTVALUE_ARGUMENT);
  //
  // si ce calcul a deja ete fait, on ne le refait pas
  //
  if(value > -9)
	return value;

  Entity* pOt = pVD->DescribedEntity();
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);

  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nentree '%s'::pruningOperationNominalSpeed_WGI plot '%s'", pOt->InstanceName(), pPlot->InstanceName());
  //
  // captage de l'option de pre-taille
  //
  Entity* pEA = App_GetVineyard((Activity*)pInst);
  int optPretaille = App_GetIntDecisionOption(pEA,
											  OPT_PRE_PRUNING_MODALITY);
  //
  // determination caractere PreTaille vs. nonPreTaille
  //
  bool isPrePruned = FALSE;
  switch (optPretaille) {
  case NONE : {
	// intentionnally blank
	break;
  }
  case ALL_PLOTS : {
	isPrePruned = TRUE;
	break;
  }
  case ALL_BUT_GOB : {
	if(! pInst->IsInstanceOf(GOBELET_PRUNING_ACTIVITY))
	  isPrePruned = TRUE;
	break;
  }
  case LARGE : {
	int alleyWidth = pPlot->GetIntConstValue(ALLEY_WIDTH);
	if(alleyWidth >= 200)    // cm
	  isPrePruned = TRUE;
	break;
  }
  case ROYAT : {
	if(pInst->IsInstanceOf(ROYAT_PRUNING_ACTIVITY))
	  isPrePruned = TRUE;
	break;
  }
  case VIGOROUS : {
	// a coder
	//if(cond)  
	//  isPrePruned = TRUE;
	break;
  }
  case ROYAT_VIGOROUS : {
	if(pInst->IsInstanceOf(ROYAT_PRUNING_ACTIVITY))
	  isPrePruned = TRUE;
	if(! isPrePruned) {
	  // a coder
	  //if(cond)  
	  //  isPrePruned = TRUE;
	}
	break;
  }
  }  // fin switch

  char* tmp = pInst->ClassName();                     // "royatPruningActivity"
  char cle1[20] = "\0";
  strncpy(cle1, tmp, strlen(tmp)-strlen("Activity")); // -> "royatPruning"
  char cle2[20] = "\0";
  if(isPrePruned) {
	sprintf(cle2, "%s%s", "speed", "PrePruned");
  }
  else {
	sprintf(cle2, "%s%s", "speed", "NotPrePruned");
  }
//printf("\ncle1 : '%s' cle2 : '%s'", cle1, cle2);
  value = GetIntParameterValue(cle1,   
							   cle2);  // maintenir sur 2 lignes 
  //     pour empecher la transformation automatique par Solfege

  //
  // on value le descripteur pour eviter une nouvelle evaluation
  // (cf. note en haut de bloc)
  //
  pOt->SetIntVarValue(NOMINAL_INT_QUANTITY_SPEED, value);

//printf("\n'%s'::pruningOperationNominalSpeed_WGI plot '%s' sets and returns %d", pOt->InstanceName(), pPlot->InstanceName(), value);
  return value;
};
