float sumUpSoilHumidityVector_Body(EntityMethod* pM)
//--------------------------------------------------
// renvoie un scalaire a partir du vecteur des humidites sur les unit. hydro.
//--------------------------------------------------
{
  Entity* pRow = pM->DescribedEntity();
  float result = (float)0.;

  pFloatTab* mhydasVector 
	= pRow->GetFloatTabConstValue(SOIL_HUMIDITY_VECTOR_FROM_MHYDAS);

  if(! mhydasVector) {
	if(gMyTraceWarnings)
	  printf("\npour '%s', sumUpSoilHumidityVector n'a pas trouve de vecteur (attendu de OpenFluid).\nValeur -9 retournee.\n", pRow->InstanceName());
	return (float)-9.;
  }

  /*
  // option possible : on renvoie la moyenne
  //
  float total = 0.;
  int nbValues = mhydasVector->size();
  for(int i=0;i<nbValues;i++) {
	total += mhydasVector->get_element(i);
  }
  result = total/(float)nbValues;
  */
  //
  // option prise : on renvoie le max
  //
  int nbValues = mhydasVector->size();
  for(int i=0;i<nbValues;i++) {
	float val_i = mhydasVector->get_element(i);
	if(val_i > result)
	  result = val_i;
  }
 
//printf("\n'%s'::sumUpSoilHumidityVector renvoie %5.3f", pRow->InstanceName(), result);
  return result;
};
