BasicEntity* Body_BestActivitySetSelector_Standard (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : le meilleur jeu d'activite
//              : ou NULL si tous les jeux sont elimines (convention cdiese)
// Comment      : version 130218 (5.4)
//---------------------------------------------
{
  Entity* pARB = pM->DescribedEntity();
  Entity* pDisjunctionToSort = pM->GetEntityArgValue(ACTIVITY_SETS_ARGUMENT);
  int nbSets = pDisjunctionToSort->GetNumberOfElements();

  BasicEntity* result = NULL;

  //===========================================================================
  // Regle de preference 0 : (+ JPR 130226) élimination des jeux Ja tels que :
  // Il existe un jeu Jb où un perf_i est alloué à l'activité valeur de son 
  //                                             PrimitiveActivityAttribute
  // alors que perf_i est alloué dans Ja à une autre activité.
  // Règle restreinte heuristiquement aux jeux d'une seule activité.
  //===========================================================================
  int nbSetsToRemove = 0;
  pEntityTab* setsToRemove = new pEntityTab();
  pEntityDTab* assocList = new Tableau<pEntityTab*>();
  //
  // parcours des InstructionSet pour construire le double tableau :
  //   assocList_0      assocList_1   assocList_2
  // ((p0 A p1 A p2 B)  (p1 C p2 B)   (p3 D p4 E))
  //       set_0            set_1        set_2
  //
//printf("\nnbSets = %d", nbSets);
  for(int i=0;i<nbSets;i++) {
	Entity* pSet_i = pDisjunctionToSort->GetElement(i);
//((InstructionSetConjunction*)pSet_i)->SpecialDisplay();
	pEntityTab* assocList_i = new pEntityTab();
	assocList->push_back(assocList_i);
	int nbSingle_i = pSet_i->GetNumberOfElements();
	//
	// parcours des single's de InstructionSet i
	//
	for(int k_i=0;k_i<nbSingle_i;k_i++) {
	  SingleInstructionSet* pSingle_k_i = 
		(SingleInstructionSet*)pSet_i->GetElement(k_i);
	  Entity* pInst_k_i = pSingle_k_i->GetAct();
//printf("\n\t\tBody_BestActivitySetSelector_Standard pInst_[%d][%d] : '%s' (%x)", i, k_i, pInst_k_i->InstanceName(), pInst_k_i);
	  
	  Entity* pV_alloc_k_i = pSingle_k_i->GetEntityConstValue(ALLOCATION_ATTRIBUTE);
//printf("\n\tpV_alloc_k_i en %x", pV_alloc_k_i);
	  pEntityTab* perfList_k_i = ((InstructionAllocation*)pV_alloc_k_i)->ExtractPerfSet();
//printf("\n");perfList_k_i->display_names();printf(" = ");perfList_k_i->display();printf("\n");
	  int nbPerf_k_i = perfList_k_i->size();
	  //
	  // parcours des performers alloués au single's de InstructionSet i
	  //
	  for(int n_k_i=0;n_k_i<nbPerf_k_i;n_k_i++) {
		Entity* pPerf_n_k_i = (Entity*)perfList_k_i->get_nth(n_k_i);
		int pushed = assocList_i->push_back_ifnew(pPerf_n_k_i);
		if(pushed) assocList_i->push_back(pInst_k_i);
	  }
	  delete perfList_k_i; // + JPR 130325
	}
  }  
  //
  // parcours des couples de listes (perf act)_i (perf act)_j  j != i
  // ((p0 A p1 A p2 B)  (p1 C p2 B)   (p3 D p4 E))
  //
  for(int i=0;i<nbSets;i++) {     // (p0 A p1 A p2 B)
	pEntityTab* assocList_i = assocList->get_nth(i);
//printf("\n\ni = %d assocList_[%d] : ", i, i);assocList_i->display_names();
	int nbElem_i = assocList_i->size();

	for(int j=i+1;j<nbSets;j++) {   // (p1 C p2 B)
	  if(j == i) continue;

	  int nbSingle_i = pDisjunctionToSort->GetElement(i)->GetNumberOfElements();
	  int nbSingle_j = pDisjunctionToSort->GetElement(j)->GetNumberOfElements();
	  if((nbSingle_i != 1) || (nbSingle_i != 1)) continue;

	  pEntityTab* assocList_j = assocList->get_nth(j);
//printf("\nj = %d assocList_[%d] : ", j, j);assocList_j->display_names();

	  int nbElem_j = assocList_j->size();
	  for(int ki=0;ki<nbElem_i;ki=ki+2) {
		Entity* pPerf_ki = (Entity*)assocList_i->get_nth(ki);                            // p0 p1 p2
		int position_ki_in_j = GetPosition(*assocList_j, pPerf_ki);                      // -9  0  1
//printf("\n%x : position_ki_in_j = %d\n", pPerf_ki, position_ki_in_j);
		if(position_ki_in_j >= 0) {
		  BasicEntity* candidateActivity_ki = assocList_i->get_nth(ki+1);                //     A  B
		  BasicEntity* candidateActivity_kj = assocList_j->get_nth(position_ki_in_j+1);  //     C  B
		  BasicEntity* currentAllocation_ki = 
			pPerf_ki->GetEntityConstValue(PRIMITIVE_ACTIVITY_ATTRIBUTE);                 //     A  B
//if(currentAllocation_ki)printf("\ncurrentAllocation_[%d] = '%s' (%x)", ki, currentAllocation_ki->InstanceName(), currentAllocation_ki);
//else printf("\ncurrentAllocation_[%d] = %x", ki, currentAllocation_ki);
		  if((candidateActivity_ki == currentAllocation_ki)
			 &&
			 (candidateActivity_kj != currentAllocation_ki)) {
			BasicEntity* setToRemove = pDisjunctionToSort->GetElement(j);            // pSet
//printf("\n\t==> elimination 1 de pSet_[%d] : %x", j, setToRemove);
			setsToRemove->push_back_ifnew(setToRemove);
		  }
		  else if((candidateActivity_kj == currentAllocation_ki)
				  &&
				  (candidateActivity_ki != currentAllocation_ki)) {
			BasicEntity* setToRemove = pDisjunctionToSort->GetElement(i);
//printf("\n\t==> elimination 2 de pSet_[%d] : %x", i, setToRemove);
			setsToRemove->push_back_ifnew(setToRemove);
		  }
		}
	  }
	}
  }
  nbSetsToRemove = setsToRemove->size();
  for(int k=0;k<nbSetsToRemove;k++) {
	BasicEntity* pSet_k = setsToRemove->get_nth(k);
	pDisjunctionToSort->RemoveElement(pSet_k, FALSE);
  }
  for(int i=0;i<nbSets;i++) {
	delete assocList->get_nth(i);
  }
  delete assocList;
  nbSets = pDisjunctionToSort->GetNumberOfElements();

//printf("\napres regle 0 / continuite d'activite");
//((InstructionSetConjunction*)pDisjunctionToSort)->SpecialDisplay();

  //===========================================================================
  // Regle de preference 1 : classement des jeux par ordre croissant de 
  //                         la priorite max sur les activites du jeu
  //===========================================================================

  Entity* pConduite =  (Entity*)pARB->GetComponent(ACTIVITY);
  Entity* pEA = pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
  Tableau<DescriptedEntity*>* pElemTabCopy = new Tableau<DescriptedEntity*>();
  for(int i=0;i<nbSets;i++) {
	Entity* pSet_i = pDisjunctionToSort->GetElement(i);
//((InstructionSetConjunction*)pSet_i)->SpecialDisplay();
	pElemTabCopy->push_back(pSet_i);
	int nbSingle_i = pSet_i->GetNumberOfElements();
	float maxPriority_i = D_FLOATMAX;
	float totalPriority_i = (float)0.;
	for(int j=0;j<nbSingle_i;j++) {
	  Entity* pSingle_i_j = pSet_i->GetElement(j);
	  Entity* pInst_i_j = 
		pSingle_i_j->GetEntityConstValue(PRIMITIVE_ACTIVITY_ATTRIBUTE);
	  // modif JPR 120907 : exploitation de la priorite des operations
	  // int priority_i_j = pInst_i_j->GetIntConstValue(ALLOCATION_PRIORITY_DEGREE);
	  int priority_i_j = 1;
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pInst_i_j->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) { 
		char* nomClasse = pInst_i_j->ClassName();
		BasicEntity* pPhasicPlan = pInst_i_j->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
																TRUE);
		int numPhase = App_GetPhaseIndex((Activity*)pPhasicPlan) + 1;
		if(pPhasicPlan == NULL) {
		  printf("\nBody_BestActivitySetSelector_Standard : pas de plan de phase trouve !\n");
		  exit(0);    
		}
		priority_i_j = App_GetOperationPriority (pEA, nomClasse, STANDARD_VALUE_PRIORITY_TAB, numPhase);
//printf("\n\tpOt en %x\tpriority = %d", pOt, priority_i_j);
	  }

	  if(priority_i_j < maxPriority_i) maxPriority_i = priority_i_j;
	  totalPriority_i += priority_i_j;
	}
	pSet_i->SetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE, maxPriority_i);
	double meanPriority_i = totalPriority_i / nbSingle_i;
	pSet_i->SetDoubleVarValue(ANONYMOUS_DOUBLE_ATTRIBUTE, meanPriority_i);
//printf("\n\tset[%d] %x priority max = %f mean = %f", i, pSet_i, maxPriority_i, meanPriority_i);
  }
  SortUp(pElemTabCopy, ANONYMOUS_FLOAT_ATTRIBUTE);
  pDisjunctionToSort->RemoveElements();
  pDisjunctionToSort->AddElements(*((Tableau<BasicEntity*>*)pElemTabCopy));
//printf("\n1 ");pDisjunctionToSort->DisplayElementTab();
  delete pElemTabCopy;

  //===========================================================================
  // Regle de preference 2 : parmi les ex-aequo au premier rang
  //                         classement des jeux par ordre décroissant de 
  //                         mobilisation d'unités de MO (JPR 121018)
  //===========================================================================

  pElemTabCopy = new Tableau<DescriptedEntity*>();
  int maxNbPerf = 0;
  float priority_ref;
  for(int i=0;i<nbSets;i++) {
	Entity* pSet_i = pDisjunctionToSort->GetElement(i);
	float priority_i = pSet_i->GetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE);
	if(i==0) {
	  priority_ref = priority_i;
	}
	if(priority_ref < priority_i) {  // modif bug 130208
	  pSet_i->SetIntVarValue(ANONYMOUS_INT_ATTRIBUTE, -D_INTMAX);
	}
	else {
//printf("\nex aequo n° %d %x\n", i, pSet_i);
	  InstructionSetAllocation* tmp = (InstructionSetAllocation*)pSet_i->GetEntityConstValue(SET_ALLOCATION_ATTRIBUTE);
	  InstructionAllocation* pV_alloc_i = tmp->ExtractVAlloc();
	  pEntityTab* perfList_i = pV_alloc_i->ExtractPerfSet();
//printf("\nex aequo n° %d %x perf : ", i, pSet_i);perfList_i->display_names();
	  int nbPerf_i = perfList_i->size();
	  delete perfList_i; // + JPR 130114 <- MLK
	  pV_alloc_i->DeleteInDepth(); // + JPR 130114 <- MLK // modif JPR 130124
	  pSet_i->SetIntVarValue(ANONYMOUS_INT_ATTRIBUTE, nbPerf_i);
	}
	pElemTabCopy->push_back(pSet_i);
  }
  SortDown(pElemTabCopy, ANONYMOUS_INT_ATTRIBUTE);
  pDisjunctionToSort->RemoveElements();
  pDisjunctionToSort->AddElements(*((Tableau<BasicEntity*>*)pElemTabCopy));
//printf("\n2 ");pDisjunctionToSort->DisplayElementTab();
  delete pElemTabCopy;
  
  //===========================================================================
  // Regle de preference 3 : parmi les ex-aequo au premier rang
  //                         classement des jeux par ordre décroissant de 
  //                         priorité moyenne (JPR 130214)
  //===========================================================================

  pElemTabCopy = new Tableau<DescriptedEntity*>();
  int nbPerf_ref;
  float maxPriority_ref;
  bool areTrellisings = FALSE;
  bool arePhytoTreatments = FALSE;
  int isTrellisingExclusive = -9;
  for(int i=0;i<nbSets;i++) {
	Entity* pSet_i = pDisjunctionToSort->GetElement(i);
	int nbSingle_i = pSet_i->GetNumberOfElements();
	// détection présence Trellising et Trt Phyto
	if(! areTrellisings || ! arePhytoTreatments) {
	  for (int k=nbSingle_i-1;k>=0;k--) {
		SingleInstructionSet* pSingle_i_k = (SingleInstructionSet*)(pSet_i->GetElement(k));
		PrimitiveActivity* pInst_i_k = pSingle_i_k->GetAct();
		UserClassIdTab idTab = pInst_i_k->AncestorIds();
		idTab.push_back(pInst_i_k->ClassId());
		if(GetPosition(idTab, TRELLISING_ACTIVITY) >= 0) {
		  areTrellisings = TRUE;
		  if(isTrellisingExclusive < 0)
			isTrellisingExclusive = 
			  App_GetAllocationExclusivity(pARB, "trellisingActivity");
		}
		else if(GetPosition(idTab, PHYTO_TREATMENT_ACTIVITY) >= 0) {
		  arePhytoTreatments = TRUE;
		}
	  }
	}
	float maxPriority_i = pSet_i->GetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE);
	int nbPerf_i = pSet_i->GetIntVarValue(ANONYMOUS_INT_ATTRIBUTE);
	if(i==0) {
	  maxPriority_ref = maxPriority_i;
	  nbPerf_ref = nbPerf_i;
	}
	if((maxPriority_ref < maxPriority_i)
	   ||
	   (nbPerf_ref > nbPerf_i)) { 
	  pSet_i->SetDoubleVarValue(ANONYMOUS_DOUBLE_ATTRIBUTE, D_DOUBLEMAX);
	}
	else {
//printf("\nex aequo n° %d %x meanPriority : %f", i, pSet_i, pSet_i->GetDoubleVarValue(ANONYMOUS_DOUBLE_ATTRIBUTE));
	}
	pElemTabCopy->push_back(pSet_i);
  }
  // application conditionnelle de ce critère de sélection
  if(arePhytoTreatments
	 ||
	 ! areTrellisings
	 ||
	 (isTrellisingExclusive == 1))
	SortUp(pElemTabCopy, ANONYMOUS_DOUBLE_ATTRIBUTE);
  pDisjunctionToSort->RemoveElements();
  pDisjunctionToSort->AddElements(*((Tableau<BasicEntity*>*)pElemTabCopy));
//printf("\n3 ");pDisjunctionToSort->DisplayElementTab();
  delete pElemTabCopy;

  //===========================================================================
  // Choix final : arbitrairement le premier jeu parmi les survivants
  //===========================================================================

  if(pDisjunctionToSort->GetNumberOfElements() > 0) { 
	result = pDisjunctionToSort->GetElement(0);
  }
  else {
	//result reste NULL
  }
  // ajout corollaire JPR 130226
  // (l'application ne doit pas modifier les éléments de la disjonction en 
  // entrée ; on rajoute donc les éléments éliminés par la Règle 0)
  for(int k=0;k<nbSetsToRemove;k++) {
	BasicEntity* pSet_k = setsToRemove->get_nth(k);
	pDisjunctionToSort->AddElement(pSet_k);
  }
  delete setsToRemove;
  
  return result;
}
