int distributedActivitySetEndDate_whenSetInt_Body(MonitorMethod* pM)
//---------------------------------------------
// Definition de la fonction qui sera declenchee lors de
// chaque modification de la variable surveillee.
//---------------------------------------------
// Quand un chantier se termine, on memorise ses dates de debut et de fin
// en prevision de l'ecriture, en fin de simulation, d'un fichier de
// commandes pour le logiciel statistique R (specifiquement un gantt-chart)//
//---------------------------------------------
{
  Descriptor* pVD = pM->GetDescriptorArgValue(MONITOREDDESCRIPTOR_ARGUMENT);
  Entity* pChantier = pVD->DescribedEntity();
  //int oldValue = pM->GetIntArgValue(CURRENTINTVALUE_ARGUMENT);
  //
  // modification JPR 130314 (5.5) pour que les 'gantt charts' ne montrent
  // plus les dates d'ouverture/fermeture, mais les dates de début et de fin
  // des opérations des chantiers
  /*
  int endClock = pM->GetIntArgValue(CANDIDATEINTVALUE_ARGUMENT);
  int begClock = pChantier->GetIntVarValue(BEG_DATE);
  */
  int begClock = pChantier->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
  int endClock = pChantier->GetIntConstValue(ACTUAL_REALIZATION_END_DATE);

  if((begClock >= 0) && (endClock >= 0))  {
	// pour les chantiers ouverts mais qui n'ont pas pu avoir de realisation
	// (notamment / cond. de faisabilite)
	Entity* pConduite = 
	  (Entity*)pChantier->GetFirstContainer(VINEYARD_CONTROL_SEQUENCE, FALSE);
	Entity* pARB = pConduite->GetSuperEntity();
	
	Entity* pMemoryItem = new DistributedActivitySetMemoryItem();
	pMemoryItem->SetStringConstValue(ACTIVITY_NAME_ATTRIBUTE, 
									 pChantier->ClassName());  // obsolete
	pMemoryItem->SetEntityConstValue(ACTIVITY_ATTRIBUTE, 
									 pChantier);
	pMemoryItem->SetIntVarValue(BEG_DATE, begClock);
	pMemoryItem->SetIntVarValue(END_DATE, endClock);
	pARB->AddEntityValueElement(DISTRIBUTED_ACTIVITY_SET_MEMORY, pMemoryItem);
  }
  return endClock;
};
