Plot::Plot(char* name) {
// =========================================================
// Une classe de Entity : 'Plot'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PLOT);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  AddComponentClassId(VEGETAL_COMPARTMENT);
  AddComponentClassId(SOIL_RESERVOIR);
  Descriptor* pD;
  pD = new WeatherStationAttribute();     AddConstantDescriptor(pD);
  pD = new Latitude();                    AddConstantDescriptor(pD);
  pD = new Longitude();                   AddConstantDescriptor(pD);
  pD = new Village();                     AddConstantDescriptor(pD);
  pD = new Area();                        AddConstantDescriptor(pD);
  pD = new AlleyWidth();                  AddConstantDescriptor(pD);
  pD = new PlantSpacing();                AddConstantDescriptor(pD);
  pD = new YearOfPlantation();            AddConstantDescriptor(pD);
  pD = new LandUse();                     AddConstantDescriptor(pD);
  pD = new PlaceName();                   AddConstantDescriptor(pD);
  pD = new SoilType();                    AddConstantDescriptor(pD);
  pD = new SoilManagementGroupName();     AddConstantDescriptor(pD);
  pD = new Stoniness();                   AddConstantDescriptor(pD);
  pD = new PruningMode();                 AddConstantDescriptor(pD);
  pD = new TrellisMode();                 AddConstantDescriptor(pD);
  pD = new GrapeVarietyAttribute();       AddConstantDescriptor(pD);
  pD = new CropRowAlleyWidthRatio();      AddConstantDescriptor(pD);
  pD = new GrassStripAlleyWidthRatio();   AddConstantDescriptor(pD);
  pD = new RidingOrientedInterRowProportion();AddConstantDescriptor(pD);
  pD = new LastTillageOperationClock();   AddConstantDescriptor(pD);
  pD = new CumulativeRainfallFromMhydasInteraction();AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromLastTillage();AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromEarlyWinter();AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromEarlyWinterForInitst();AddVariableDescriptor(pD);
  pD = new PercentAntiMildewTreated();    AddVariableDescriptor(pD);
  pD = new PercentAutumnTilled();         AddVariableDescriptor(pD);
  pD = new PercentClipped();              AddVariableDescriptor(pD);
  pD = new PercentDebranched();           AddVariableDescriptor(pD);
  pD = new PercentExtraPhytoTreated();    AddVariableDescriptor(pD);
  pD = new PercentFertilized();           AddVariableDescriptor(pD);
  pD = new PercentInitSpringTilled();     AddVariableDescriptor(pD);
  pD = new PercentPlanted();              AddVariableDescriptor(pD);
  pD = new PercentPruned();               AddVariableDescriptor(pD);
  pD = new PercentRegularPhytoTreated();  AddVariableDescriptor(pD);
  pD = new PercentShootThinned();         AddVariableDescriptor(pD);
  pD = new PercentSpringTilled();         AddVariableDescriptor(pD);
  pD = new PercentSpringWeeded();         AddVariableDescriptor(pD);
  pD = new PercentTrellised();            AddVariableDescriptor(pD);
  pD = new PercentWeeded();               AddVariableDescriptor(pD);
  pD = new PercentWinterTilled();         AddVariableDescriptor(pD);
  Method* pM;
  pM = new IsMotorizationPossible();      AddMethod (pM);
  pM = new AssignRelativeAreaToRows();    AddMethod (pM);
  pM = new ReturnPassedRowsFrequency();   AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetInstanceName(name);

  // pour tri sur motorisable : non motorisable (chantiet AntiMildiou)
  pD = new AnonymousIntAttribute();       AddVariableDescriptor(pD);

  Entity* pVegetal = new VegetalCompartment();
  AddComponent(pVegetal);
  for(int i=0;i<4;i++) {
	Entity* pRow_i = pVegetal->GetElement(i);
	char rowName[100] = "\0";;
	sprintf(rowName, "%s_%d", name, i+1);
	pRow_i->SetInstanceName(rowName);
  }

  Entity* pReservoir = new SoilReservoir();
  AddComponent(pReservoir);
};
