bool regularPhytoTreatmentsIteration_openingPredicate_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// Doit renvoyer vrai pour que l'activit� puisse �tre ouverte.
//---------------------------------------------------------------------------
  Entity* pIterate = pM->DescribedEntity();
  Entity* pEA = App_GetVineyard((Activity*)pIterate);
//printf("\nentree '%s'_OP", pIterate->InstanceName());

  bool result = FALSE;
  
  int option = App_GetIntDecisionOption(pEA, OPT_REGULAR_PHYTO_TREATMENTS_O_P);
  //
  // etablissement de la liste des cepages de la 1ere vague
  //
  Entity* pConduite = 
	pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  int powderyMildewMngt = 
	pConduite->GetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE);
  
  Entity* pVarGroupSet = App_GetVarietyGroupSet(powderyMildewMngt);
  
  pVarGroupSet->SetEntityArgValue(GET_RANKED_WAVE_LIST, VINEYARD_ARGUMENT, pEA);
  pVarGroupSet->SetIntArgValue(GET_RANKED_WAVE_LIST, STAGE_INDEX_ARGUMENT, 0);
  pEntityTab* firstWaveList = pVarGroupSet->ExecEntityTabMethod(GET_RANKED_WAVE_LIST);

  pEntityTab* localVarietyList = pEA->GetEntityTabConstValue(GRAPE_VARIETY_LIST_ATTRIBUTE);
  
  int nbElem = firstWaveList->size();
  for(int i=nbElem-1;i>=0;i--) {
	BasicEntity* pVariety = firstWaveList->get_element(i);
	if(GetPosition(*localVarietyList, pVariety) < 0) {
	  firstWaveList->remove(i);
	}
  }
  //
  // etablissement presence early et/ou late dans les cepages de la 1ere vague
  //
  bool areEarly = FALSE;
  bool areLate = FALSE;
  nbElem = firstWaveList->size();
  int k=-1;
  while((! areEarly || ! areLate)
		&&
		(k < nbElem-1)) {
	Entity* pVar = (Entity*)firstWaveList->get_element(++k);
	if(pVar->GetIntConstValue(IS_EARLY))
	  areEarly = TRUE;
	else
	  areLate = TRUE;
  }  
  delete firstWaveList;
//printf("\n'%s'_OP areEarly =%d areLate = %d", pIterate->InstanceName(), areEarly, areLate);
  if(! areEarly && ! areLate) {
	printf("!!! '%s'_OP ni early ni late !!!\n", pIterate->InstanceName());
	exit(0);
  }
  //
  // recherche des varietes-guides early et late pour cette EA
  //
  char* guidingEarlyVarietyName = 
	App_GetStringDecisionOption (pEA, GUIDING_EARLY_VARIETY_ATTRIBUTE);
  Entity* guidingEarlyVariety = GetNamedEntity("grapeVariety", guidingEarlyVarietyName);
  char* guidingLateVarietyName = 
	App_GetStringDecisionOption (pEA, GUIDING_LATE_VARIETY_ATTRIBUTE);
  Entity* guidingLateVariety = GetNamedEntity("grapeVariety", guidingLateVarietyName); 
  //
  // etablissement liste des IsoAgeingEntity relatives aux varietes-guides
  //
  pEntityTab* pEarlyIsoAgeingAttributeList = 
	App_GetIsoAgeingEntityList(pEA, guidingEarlyVariety, NULL);	  
  int nbElemEarly = pEarlyIsoAgeingAttributeList->size();
  pEntityTab* pLateIsoAgeingAttributeList = 
	App_GetIsoAgeingEntityList(pEA, guidingLateVariety, NULL);
  int nbElemLate = pLateIsoAgeingAttributeList->size();
  //
  //
  //
  bool allOKForEarly = TRUE;
  bool allOKForLate = TRUE;
  switch(option)  {
  case 1 : { // D1
	if(! areEarly) {
	  printf("!!! '%s'_OP pas de early et cas 'D1' !!!\n", pIterate->InstanceName());
	  exit(0);
	}
	for(int i=0;i<nbElemEarly;i++)  {
	  Entity* pIsoAgeingEntity = 
		(Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
	  Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
	  int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
	  if(codeStade < 6) { //budBreak
		allOKForEarly = FALSE;
		break;
	  }
	}
	break;
  }
  case 2 : { // D2
	if(areEarly) {
	  for(int i=0;i<nbElemEarly;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 9) { //3-4 feuilles
		  allOKForEarly = FALSE;
		  break;
		}
	  }
	}
	if(areLate) {
	  for(int i=0;i<nbElemLate;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pLateIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 6) { //budBreak
		  allOKForLate = FALSE;
		  break;
		}
	  }
	}
	break;
  }
  case 3 : { // D3
	if(areEarly) {
	  for(int i=0;i<nbElemEarly;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 11) { //4-5 feuilles
		  allOKForEarly = FALSE;
		  break;
		}
	  }
	}
	if(areLate) {
	  for(int i=0;i<nbElemLate;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pLateIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 9) { //2-3 feuilles
		  allOKForLate = FALSE;
		  break;
		}
	  }
	}
	break;
  }
  case 4 : { // D4
	if(areEarly) {
	  for(int i=0;i<nbElemEarly;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 12) { //5-6 feuilles
		  allOKForEarly= FALSE;
		  break;
		}
	  }
	}
	if(areLate) {
	  for(int i=0;i<nbElemLate;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pLateIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 10) { //3-4 feuilles
		  allOKForLate = FALSE;
		  break;
		}
	  }
	}
	break;
  }
  case 5 : { // D5
	if(areEarly) {
	  for(int i=0;i<nbElemEarly;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 15) { //boutons floraux agglomeres
		  allOKForEarly = FALSE;
		  break;
		}
	  }
	}
	if(areLate) {
	  for(int i=0;i<nbElemLate;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pLateIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 12) { //5-6 feuilles
		  allOKForLate = FALSE;
		  break;
		}
	  }
	}
	break;
  }
  case 6 : { // D6
	if(! areLate) {
	  printf("!!! '%s'_OP pas de late et cas 'D6' !!!\n", pIterate->InstanceName());
	  exit(0);
	}
	for(int i=0;i<nbElemLate;i++)  {
	  Entity* pIsoAgeingEntity = 
		(Entity*)pLateIsoAgeingAttributeList->get_element(i);
	  Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
	  int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
	  if(codeStade < 12) { //5-6 feuilles
		allOKForLate = FALSE;
		break;
	  }
	}
	break;
  }
  default : {
	printf("\n'%s'_OP passage inattendu par 'default'\n", pIterate->InstanceName());
	exit(0);
  }
  }	

  result = allOKForEarly && allOKForLate;
	 
  delete pEarlyIsoAgeingAttributeList;		 
  delete pLateIsoAgeingAttributeList;

//printf("\n'%s'_OP returns %d", pIterate->InstanceName(), result);
  return result;
};
