int weekDayMorning_setThisTimeSlotBegValue_Body(EntityMethod* pM) {
//-----------------------------------------------------------------
// (commentaire �ventuel)
//-----------------------------------------------------------------
  AvailabilityTimeSlot* pTimeSlot = (AvailabilityTimeSlot*)(pM->DescribedEntity());
  int result;

  int now = pCurrentSim->Clock();
  //
  // recuperation TimeSlot precedent
  //
  Entity* pTimetable = pTimeSlot->GetSuperSet();
  pEntityTab pElemTab = pTimetable->GetElementTab();
  int nbSlots = pElemTab.size();
  int thisSlotIndex = GetPosition(pElemTab, pTimeSlot);
  int prevSlotIndex = thisSlotIndex-1;
  if(thisSlotIndex == 0)
	prevSlotIndex = nbSlots-1;
  Entity* prevTimeSlot = (Entity*)pElemTab[prevSlotIndex];
  //
  // recuperation date de fin du TimeSlot precedent
  //
  int prevTimeSlotEndDate = prevTimeSlot->GetIntVarValue(END_DATE);
  tm* pTm;
  if(prevTimeSlotEndDate < 0) {
	//
	// JPR 121210 : dans le cas d'un début de simulation un jour non travaillé (e.g. samedi)
	// le prevTimeSlotEndDate est -9. Dans ce cas, lors du UpdateSituation du prochain jour
	// travaillé (e.g. lundi), le slot précédent ne doit pas être l'après-midi du vendredi,
	// mais l'après-midi de la veille. On crée donc un pTm marqué de la veille (avec le -24)
	// puis on établiera l'heure avec le switch général.
	//
	int unInstantDeLaVeille = now-24;
	if(unInstantDeLaVeille < 0) unInstantDeLaVeille = 0;
    pTm = ClockValueToTm(unInstantDeLaVeille);
  }
  else {
    pTm = ClockValueToTm(prevTimeSlotEndDate);
  }
  //
  // recuperation du jour dans la semaine et forcage du jour
  // modif JPR 121210 :
  //  cette écupération est identique dans les 2 cas if ... else ci-dessus
  int wday = pTm->tm_wday;
//printf("\nwday = %d", wday);
  int delay = -9; 
  switch (nbSlots) {
  case 10 : {       // semaine de 5 jours
	switch (wday) {
	case VEN : { delay = 3; break; }
	case SAM : { delay = 2; break; }
	default  : { delay = 1; break; }
	}
	break;
  }
  case 12 : {       // semaine de 6 jours
	switch (wday) {
	case SAM : { delay = 2; break; }
	default  : { delay = 1; break; }
	} 
	break;
  }
  case 14 : {       // semaine de 7 jours
	delay = 1;
	break;
  }
  }
  pTm->tm_mday = pTm->tm_mday + delay;

  //
  // forcage de l'heure (descripteur du SeasonalPlan)
  //
  Entity* pSeasonalPlan = 
	pTimetable->GetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE);;
  //
  // determination si l'instant courant est dans un jour ferie ou de conge
  //
  Entity* pAnnualPlan = pSeasonalPlan->GetSuperSet();
  Entity* pCalendar = pAnnualPlan->GetEntityConstValue(OFF_WORK_CALENDAR_ATTRIBUTE);
  pCalendar->SetIntArgValue(IS_CLOCK_VALUE_IN_CALENDAR, CLOCK_ARGUMENT, now);
  bool isOff = pCalendar->ExecPredicate(IS_CLOCK_VALUE_IN_CALENDAR);
  float begHour;
  if(isOff) {
	//
	// jour ferie ou de conge -> l'intervalle de dispo est reduit a rien
	// -> date de debut = date de fin
	//
	begHour = pSeasonalPlan->GetFloatConstValue(WORK_DAY_MORNING_END_HOUR);
	pTm->tm_hour = (int)floor(begHour);
  }
  else  {
	begHour = pSeasonalPlan->GetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR);
	pTm->tm_hour = (int)ceil(begHour);
  }
  pTm->tm_isdst = -1;// 120704
  mktime(pTm);
  int thisTimeSlotBegDate = StructTmToClockValue(pTm);
  delete pTm;
  if(thisTimeSlotBegDate < 0)
    result = now;
  else
    result = thisTimeSlotBegDate;
	
//printf("\nweekDayMorning_setThisTimeSlotBegValue returns %d", result);
  return result;
};
