void App_DeallocateMiscellaneousDynamicEntities ()
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pPS = pCurrentSim->SimulatedEntity();
  Entity* pCS = pPS->GetComponent(CONTROLLED_SYSTEM);
  Entity* pACS = pCS->GetEntityConstValue(ATTACHED_ENTITY);
  Entity* pVineyardSet = pACS->GetComponent(VINEYARD_SET);
  //
  // PestInfoMemoryItems
  //
  Entity* pMemory = 
	pVineyardSet->GetEntityConstValue(PEST_INFO_MEMORY_ATTRIBUTE);
  int nbItems = pMemory->GetNumberOfElements();
  for(int i=nbItems-1;i>=0;i--) {
	Entity* pItem_i = pMemory->GetElement(i);
//printf("\ndelete %s", pItem_i->InstanceName());
	delete (PestInfoMemoryItem*)pItem_i;
  }
  //
  // DistributedActivitySetMemoryItem
  //
  int nbEA = pVineyardSet->GetNumberOfElements();
  for(int i=nbEA-1;i>=0;i--) {
	Entity* pEA_i = pVineyardSet->GetElement(i);
	Entity* pConduite = pEA_i->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	Entity* pARB = pConduite->GetSuperEntity();
	pEntityTab* pItemTab = 
	  pARB->GetEntityTabValue(DISTRIBUTED_ACTIVITY_SET_MEMORY);
	int nbItems = pItemTab->size();
	for(int i=0;i<nbItems;i++) {
	  BasicEntity* pItem_i = pItemTab->get_element(i);
//printf("\ndelete %s", pItem_i->InstanceName());
	  delete (DistributedActivitySetMemoryItem*)pItem_i;
	}
  }
  //
  // Les LastOperationMemoryItem residuels de fin de simulation,
  // ceux non desalloues par le MemoryItemGarbaging du lendemain
  //
  pEntityTab* pMemoryItemTab = GetEntityList(LAST_OPERATIONS_MEMORY_ITEM);
  nbItems = pMemoryItemTab->size();
  for(int i=nbItems-1;i>=0;i--) {
	BasicEntity* pItem_i = pMemoryItemTab->get_element(i);
//printf("\ndelete %s", pItem_i->InstanceName());
	delete (LastOperationsMemoryItem*)pItem_i;
  }
}
