void App_DepthBioPhysicalSettings (char fileName[])
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
//printf("\nApp_DepthBioPhysicalSettings('%s')\n", fileName);
  FILE* pF = fopen(fileName,"r");

  Entity* pPS = pCurrentSim->SimulatedEntity();
  Entity* pCS = pPS->GetComponent(CONTROLLED_SYSTEM);
  Entity* pACS = pCS->GetEntityConstValue(ATTACHED_ENTITY);
  Entity* pVineyardSet = pACS->GetComponent(VINEYARD_SET);
  Entity* pWeatherStationSet = pACS->GetComponent(WEATHER_STATION_SET);
  int nbWS = pWeatherStationSet->GetNumberOfElements();
  Entity* pDS = pPS->GetComponent(MANAGER);
  Entity* pStrategy = pDS->GetComponent(STRATEGY);

  
  char nomEA[10], nomPlot[50], refCad[30], commune[30], lieudit[30], cepage[30], occSol[10], age[10], IR[10], IC[10], taille[10], palissage[10], sol[30], cailloux[10], grpeGestionSol[30];  // modif JPR 1312
  float coordX, coordY, superficie;

  char nomEA_ref[10] = "\0";

  Entity* pVineyard = NULL;
  while(TRUE) {
	int i = fscanf(pF,
				   "%s %s %s %f %f %s %s %s %s %f %s %s %s %s %s %s %s %s",
				   nomEA, nomPlot, refCad, &coordX, &coordY, commune, lieudit, cepage, occSol, &superficie, age, IR, IC, taille, palissage, sol, cailloux, grpeGestionSol);  // modif JPR 1312
	if(i == EOF)
	  break;
printf("\n\tstr1 : '%s' '%s' '%s' '%s' %f %f '%s' '%s'\n", nomEA, nomPlot, refCad, palissage, coordX, coordY, cailloux, grpeGestionSol);  // modif JPR 1312

	if(strncmp(nomEA, "//", 2)) { // + JPR 121107 : possibilité de lignes en commentaire
	  //
	  // si changement de nom de EA, instanciation d'une nouvelle EA
	  // et ajout comme element du VineyardSet
	  //
	  if(strcmp(nomEA, nomEA_ref)) {
		pVineyard = new Vineyard();
		pVineyard->SetInstanceName(nomEA);
//printf("\ncreation du Vineyard %x '%s'", pVineyard, nomEA);
		pVineyard->ClearEntityTabValues(GRAPE_VARIETY_LIST_ATTRIBUTE);
		pVineyardSet->AddElement(pVineyard);
		pVineyard->SetFloatConstValue(AREA_WITH_GRAPEVINE, (float)0.);
		
		strcpy(nomEA_ref, nomEA);
		//
		// instanciation du plan de conduite
		//
		Entity* pPlan = new Activity();
		pVineyard->SetEntityConstValue(CONTROL_PLAN_ATTRIBUTE, pPlan);
		Entity* pARB = new VineyardActivitiesResourcesBlock();
		pARB->SetEntityConstValue(ATTACHED_ENTITY, pVineyard);
		pARB->AddComponent(pPlan);
		Entity* pARBSet = pStrategy->GetComponent(ACTIVITIES_RESOURCES_BLOCK_SET);
		pARBSet->AddElement(pARB);
	  }
	  //
	  // instanciation d'une nouvelle parcelle
	  //
	  if(pVineyard
		 &&
		 ! strcmp(occSol, "Vigne")) {
		Entity* pPlot = new Plot(nomPlot);
//printf("\n\t -> plot %x '%s'", pPlot, nomPlot);
		pPlot->SetFloatConstValue(LATITUDE, coordX);
		pPlot->SetFloatConstValue(LONGITUDE, coordY);
		pPlot->SetFloatConstValue(AREA, superficie);
		float x = pVineyard->GetFloatConstValue(AREA_WITH_GRAPEVINE);
		pVineyard->SetFloatConstValue(AREA_WITH_GRAPEVINE, x + superficie);
		// (code cadastral not used)
		
		int yearOfPlantation = atoi(age);
		pPlot->SetIntConstValue(YEAR_OF_PLANTATION, yearOfPlantation);
		// si la plantation a lieu l'annee N de debut de simulation 
		// (ou bien l'annee N ou N+1, si la simulation commence apres le 01/07)
		// la valeur par d�faut (-1.) PERCENT_PLANTED passe a 0.
		Date* dateDebutSim = pCurrentSim->BeginningDate();
		tm* pTm = StructDateToTm(dateDebutSim);
		int begSimMonth = pTm->tm_mon;
		int begSimYear = pTm->tm_year+1900;
		if((yearOfPlantation == begSimYear)
		   ||
		   ((begSimMonth > 6) && (yearOfPlantation == begSimYear+1)))
		  pPlot->SetFloatVarValue(PERCENT_PLANTED, (float)0.);
		delete pTm;
		
		pPlot->SetIntConstValue(ALLEY_WIDTH, atoi(IR));
		pPlot->SetIntConstValue(PLANT_SPACING, atoi(IC));
		pPlot->SetStringConstValue(PRUNING_MODE, taille);
		if(! strcmp(taille, "GOB")) {
		  //
		  // pas de palissage pour les parcelles taillees en gobelet
		  //
		  pPlot->SetFloatVarValue(PERCENT_TRELLISED, (float)-1.);
		}
		if(strcmp(cepage, "carignan")) { // + JPR 130126
		  //
		  // pas de ExtraPhytoTreatment pour les parcelles non en carignan
		  //
		  pPlot->SetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED, (float)-1.);
		}
		pPlot->SetStringConstValue(TRELLIS_MODE, palissage);
		pPlot->SetStringConstValue(SOIL_TYPE, sol);
		pPlot->SetStringConstValue(STONINESS, cailloux);
		pPlot->SetStringConstValue(VILLAGE, commune);
		pPlot->SetStringConstValue(PLACE_NAME, lieudit);
		pPlot->SetStringConstValue(LAND_USE, occSol);
		Entity* pVariety = GetNamedEntity("grapeVariety", cepage);
		pPlot->SetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE, 
								   pVariety);
		pVineyard->AddEntityValueElement(GRAPE_VARIETY_LIST_ATTRIBUTE,
										 pVariety);
		//
		// captage eventuel du groupe de gestion du sol (1312)
		// (si '*', le groupe sera determine dans AppControlSettings
		// en connaissance de l'ensemble des groupes de gestion
		pPlot->SetStringConstValue(SOIL_MANAGEMENT_GROUP_NAME, grpeGestionSol)
		//
		// etablissement de la WeatherStation la plus proche
		//
		Entity* pNearestWS = NULL;
		float distanceToNearestWS = D_FLOATMAX;
		for(int i=0;i<nbWS;i++) {
		  Entity* pWS_i = pWeatherStationSet->GetElement(i);
		  float distance_i = App_DistanceToWeatherStation(pWS_i, coordX, coordY);
		  if(distance_i < distanceToNearestWS) {
			pNearestWS = pWS_i;
			distanceToNearestWS = distance_i;
		  }
		}
		pPlot->SetEntityConstValue(WEATHER_STATION_ATTRIBUTE, pNearestWS);
		
		pVineyard->AddElement(pPlot); 
	  }
	} // fin if("//")
  } // fin while
  fclose(pF);
//printf("\nfin App_DepthBioPhysicalSettings('%s')", fileName);
}
