float App_GetExpectedDuration (Entity* pPlot, bool isPlotMotorizable, UserClassId otClassId, char* optionSerPar, char* manualMotorizedValue, float passedRowFrequency, float manualNominalSpeed, float motorizedNominalSpeed)
//---------------------------------------------
// Description  : renvoie la durée prévisible d'une opération donnée sur une 
//              : parcelle donnée 
// Precondition : 
// Retour       :       
// Comment      : modif JPR 130130 sur le cas manualMotorizedValue = ""
//---------------------------------------------
{
  float result;
  float alleyWidth =(float) pPlot->GetIntConstValue(ALLEY_WIDTH) / (float)100.;
  float vitesseOperation;

  int cas;
  //
  // La formule pour la vitesse est différente selon que l'opération est
  // motorisée ou manuelle. mais quand le chantier est en parallèle, 
  // l'indicateur manuel/motorisé est vide. On choisit alors la formule
  // en fonction du caractère mororisable ou non de la parcelle.
  //
  if(! strcmp(optionSerPar, "PAR")
	 ||
	 ! strcmp(manualMotorizedValue, "")) {
	//
	// formule de la vitesse selon que la parcelle est motorisable ou pas
	//
	if(otClassId >=0) {
	  pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							OPERATION_CLASS_ARGUMENT,
							otClassId);
	  isPlotMotorizable =
		pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	}
	else {
	  // isPlotMotorizable est alors passé en paramètre
	}
	if(isPlotMotorizable) {
	  cas = 1;  // f(motorizedNominalSpeed)
	}
	else {
	  cas = 2;  // f(manualNominalSpeed)
	}
  }
  else {    // "SER" && ("MOTORIZED" ...
	if(! strcmp(manualMotorizedValue, "MOTORIZED")) {
	  cas = 1;
	}
	else {  //            ou "MANUAL")
	  cas = 2;
	}
  }
  switch(cas) {
  case 1 : {
//printf("\n\talleyWidth : %f\t passedRowFrequency : %f", alleyWidth,  passedRowFrequency);
	vitesseOperation = 
	  alleyWidth * motorizedNominalSpeed / 12 / passedRowFrequency;
	break;
  }
  case 2 : {
	float plantSpacing = pPlot->GetIntConstValue(PLANT_SPACING) / (float)100.;
//printf("\n\talleyWidth : %f\tplantSpacing : %f", alleyWidth, plantSpacing);
	vitesseOperation = 
	  alleyWidth * plantSpacing * manualNominalSpeed / (float)10000.;
	break;
  }
  }

  float area = pPlot->GetFloatConstValue(AREA);
//printf("\n\tarea : %f\tvitesseOperation : %f", area, vitesseOperation);
  result = area / vitesseOperation;
  /*
  if(otClassId > -1)
	printf("\n'%s' ser/par : '%s' isPlotMotorizable : %d ot : '%s', expectedDuration = %f", pPlot->InstanceName(), optionSerPar, isPlotMotorizable, ClassIdToCharTab[otClassId], result);
  else
	printf("\n'%s' ser/par : '%s' isPlotMotorizable : %d ot : '%s', expectedDuration = %f", pPlot->InstanceName(), optionSerPar, isPlotMotorizable, "", result);
  */
  return result;
}
