bool App_IsStageReachedForEarlyGuidingVariety (Vineyard* pEA, char* nomStade_arg)
//---------------------------------------------
// Description  : Renvoie 'vrai' si le stade 'nomStade_arg' est atteint pour
//                la variete designee comme guide 'precoce' dans le fichier 
//                des options de conduite.
//                Cette variete n'est pas necessairement cataloguee 'precoce'
//                auquel cas, c'est la plus precoce des 'tardives' de l'EA.
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pConduite->GetSuperEntity();
  Entity* dec_optionSet //DecisionOptionSet
	= pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
  char* guidingEarlyVarietyName = 
	dec_optionSet->GetStringConstValue(GUIDING_EARLY_VARIETY_ATTRIBUTE);
  Entity* guidingEarlyVariety = 
	GetNamedEntity("grapeVariety", guidingEarlyVarietyName); 

  bool result = TRUE;

  pEntityTab* pEarlyIsoAgeingAttributeList = 
	App_GetIsoAgeingEntityList(pEA, guidingEarlyVariety, NULL);
  int nbElemEarly = pEarlyIsoAgeingAttributeList->size();
  
  for(int i=0;i<nbElemEarly;i++)  {
	Entity* pIsoAgeingEntity = 
	  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
	Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE); 
	pEntityTab* pStadeTab = pAge->GetEntityTabConstValue(STAGE_TAB);
	int currentIndex = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
	int nbStages = pStadeTab->size();
	for(int i=0;i<nbStages;i++) {
	  Entity* pStage_i = (Entity*)pStadeTab->get_element(i);
	  char* nomStade_i = pStage_i->GetStringConstValue(STAGE_NAME);
	  if(! strcmp(nomStade_i, nomStade_arg)) {
		if(i > currentIndex) {
		  result = FALSE;
		}
		break;
	  }
	}
	if(! result)
	  break;
  }
  delete pEarlyIsoAgeingAttributeList;

//printf(" App_IsStageReachedForEarlyGuidingVariety(%s, %s) returns %d", pEA->InstanceName(), nomStade_arg);
  return result;
}
