ConcurrentFertilizations::ConcurrentFertilizations(Vineyard* pEA, int season, int numPhase) {
// =========================================================
// Une classe de Entity : 'ConcurrentFertilizations'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_FERTILIZATIONS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToFertilize();   AddMethod (pM);
  pM = new AddNewSituatedFertilizations();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Fertilizations);

  //
  // predicat d'ouverture du chantier
  //
  int minBegDate;
  if(season == 1) {   // AUTUMN
	minBegDate = pCurrentSim->Clock();
	AssignBody(OPENING_PREDICATE, Body_OP_Fertilizations_OnDate);
  }
  else {              // not AUTUMN
	int jDay = App_GetIntDecisionOption(pEA, 
										OPT_SPRING_FERT_MIN_BEG_DATE);
	minBegDate = App_JulianDayToClockFromBegSim(jDay);
	jDay =  App_GetIntDecisionOption(pEA, 
									 OPT_SPRING_FERT_MAX_BEG_DATE);
	int maxBegDate = App_JulianDayToClockFromBegSim(jDay);
	SetIntVarValue(MAX_BEG_DATE, maxBegDate);
	
	int option = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_O_P);
	if((option == END_THIN)
	   ||
	   (option == END_THIN_CW))
	  AssignBody(OPENING_PREDICATE, Body_OP_Fertilizations_OnChain);
	else if((option == EARLY_FEB)
			||
			(option == EARLY_MAR))
	  AssignBody(OPENING_PREDICATE, Body_OP_Fertilizations_OnDate);
	else {
	  printf("\nDans construction '%s', option invalide hors automne : %d\n", InstanceName(), option);
	  exit(0);
	}
	  
  }
  SetIntVarValue(MIN_BEG_DATE, minBegDate);

  //
  // predicat de fermeture             du chantier
  //          d'ouverture au plus tard du chantier
  //
  switch (numPhase) {
  case 1 : {
	AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_Fertilizations_Phase1);
	AssignBody(CLOSING_PREDICATE, Body_CP_Phase1);
	break;
  }
  case 3 : {
	AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_Fertilizations_Phase3); 
	AssignBody(CLOSING_PREDICATE, Body_CP_Fertilizations_Phase3); 
	break;
  }
  default : {
	printf("\n!!! Construction d'un '%s' avec un numero de phase illegal : %d\n", InstanceName(), numPhase);
	exit(0);
  }
  }
};
