pEntityTab* getRankedWaveList_Body(EntityMethod* pM)
//--------------------------------------------------
// renvoie la liste des varietes a traiter phyto, en fct d'un rang de priorite en arg.
// localVarietyList : {a b c d e f g h}
//                   IN      NOT_IN    IN   
// pVarGroupSet : ( {a b}  {a b c d}  {g h} )   
// ==> 
// result :
// pour rank=1  : {a b}
// pour rank=2  : {a b e f}
// pour rank=3  : {a b e f g h}
// pour rank>3  : {a b c d e f g h} // et pas {a b e f c d g h}  !!
// pour rank=-9 : {a b c d e f g h}
//--------------------------------------------------
{
  Entity* pVarGroupSet = pM->DescribedEntity();
  Entity* pVineyard = pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  int stageIndex = pM->GetIntArgValue(STAGE_INDEX_ARGUMENT);
  //stageIndex = compteur d'iterations
//printf("\ngetRankedWaveList sur '%s', EA : '%s' rang=%d", pVarGroupSet->InstanceName(), pVineyard->InstanceName(), stageIndex); 
  pEntityTab* result = new pEntityTab();

  int nbVarGroups = pVarGroupSet->GetNumberOfElements();

  pEntityTab* localVarietyList = 
	pVineyard->GetEntityTabConstValue(GRAPE_VARIETY_LIST_ATTRIBUTE);
  if((nbVarGroups == 0)
	 ||
	 (stageIndex == -9)) {
	result->push_back(*localVarietyList);
  }
  else {
	if(stageIndex < nbVarGroups) {
	  for(int rank=0;rank<=stageIndex;rank++)  {
		Entity* pGroup_rk = pVarGroupSet->GetElement(rank);
		pEntityTab pVarietyTab_rk = pGroup_rk->GetElementTab();
		
		int inOutMode = pGroup_rk->GetIntConstValue(MEMBERSHIP_MODE);
		if(inOutMode == IN) {
		  result->push_back_ifnew(pVarietyTab_rk);
		}
		else {
		  int nbLocals = localVarietyList->size();
		  for(int k=0;k<nbLocals;k++) {
			BasicEntity* localVar_k = localVarietyList->get_element(k);
			if(GetPosition(pVarietyTab_rk, localVar_k) < 0)
			  result->push_back_ifnew(localVar_k);
		  }
		}
	  }
	}
	else {
	  //
	  // au dernier rang, on renvoie toutes les cepages
	  //
	  result->push_back(*localVarietyList);
	}
  }
//printf("\ngetRankedWaveList sur '%s', EA : '%s' rang=%d returns :", pVarGroupSet->InstanceName(), pVineyard->InstanceName(), stageIndex);result->display_names();
  return result;
};
