bool plotWithSeveralOperations_holdingCondition_Body(EntityMethod* pM) {
//----------------------------------------------------------------------
// Methode d'une InconstencyCondition ou ActivitiesResourcesInconsistentCommitment.
// Le corps examine l'etat du systeme et doit renvoyer vrai si et seulement si
// l'etat justifie que la contrainte soit appliquee a l'activite ou a
// la ressource qui est la valeur de l'argument REFERENCEENTITY_ARGUMENT.
// L'argument CANDIDATEENTITYTABVALUE_ARGUMENT est un ensemble de ressources
// candidates a l'allocation.
// L'argument CANDIDATEENTITYVALUE_ARGUMENT est l'alloc. de ress. candidates.
//----------------------------------------------------------------------
  Entity* pE = pM->DescribedEntity();
  bool result = FALSE;
//printf("\nplotWithSeveralOperations_HC pE : '%s'", pE->InstanceName());
  Entity* pISA = (Entity*)pM->GetEntityArgValue(CANDIDATEENTITYVALUE_ARGUMENT);
  // jeu (A B)
  //      A : <(p1),    ot1, w1> 
  //      B : <(p2 p1), ot2, w2> 
  //  - structure U : ((ot1                    (PLOT p1)    (PERF w1)   )
  //                   (ot2                    (PLOT p1 p2) (PERF w2)   )
  //                   (p1 (PRUN ot1) (CHW ot2)(PLOT p2)    (PERF w1 w2))
  //                   (p2            (CHW ot2)(PLOT p1)    (PERF w2)   )
  //                   (w1 (PRUN ot1)          (PLOT p1)                )
  //                   (w2 (CHW ot2)           (PLOT p1 p2)             )
  //                  )
//((InstructionSetAllocation*)pISA)->SpecialDisplay();
  //
  // parcours des lignes de la struture U (pISA)
  //
  int nbUsageItems = pISA->GetNumberOfElements();
  for(int i=0;i<nbUsageItems;i++) {
	Entity* pUsageItem = pISA->GetElement(i);
	//
	// on ne regarde que les lignes ne portant pas sur une operation
	// donc : (p1 ...)(p2 ...)(w1 ...) et (w2 ...)
	//
	if(pUsageItem->IsDirectInstanceOf(RESOURCE_USAGE_ITEM)) {
	  Entity* pRscUsed = pUsageItem->GetEntityConstValue(RESOURCE_USED);
	  //
	  // on ne regarde que les lignes portant sur un 'operatedObject'
	  // donc : (p1 ...) puis (p2 ...)
	  //
      if(pRscUsed->IsInstanceOf(OPERATED_OBJECT)) {
		Entity* pObj = pRscUsed->GetEntityConstValue(RESOURCE_ENTITY);
		//
		// on ne regarde que les lignes dont 'operatedObject' est une PLOT
		// peut-etre (p1 ...) et (p2 ...)
		//
		if(pObj->IsInstanceOf(PLOT)) {
		  // (p1 ...)
		  // puis
		  // (p2 ...)
		  pEntityTab* pCoengOtTab = new pEntityTab();
		  // pCoengOtTab --> ()
		  // ((PRUN ot1) (CHW ot2) (PERF w1))
		  int nbCoengItems = pUsageItem->GetNumberOfElements();  // = 3
		  for(int j=0;j<nbCoengItems;j++) {
			Entity* pCoengItem = pUsageItem->GetElement(j);
			// e.g. (PRUN ot1)         puis CHW ot2)
			UserClassId pCoengObjId = pCoengItem->GetIntVarValue(RESOURCE_ID);
			// PRUN                    puis CHW
			if(IsDescendantOf(pCoengObjId, OPERATION)) {
			  pEntityTab* pRscTab 
				= pCoengItem->GetEntityTabConstValue(RESOURCE_LIST);
			  pCoengOtTab->push_back_ifnew(* pRscTab);
			  // pCoengOtTab --> (ot1) puis --> (ot1 ot2)
			}
		  }
		  int nbCoengOt = pCoengOtTab->size();   // = 2
		  delete  pCoengOtTab;
		  if(nbCoengOt > 1) {
			result = TRUE;
			break;
		  }
		}
	  }
	}
	if(result == TRUE)
	  break;
  }
//printf("\nplotWithSeveralOperations_HC returns %d", result);
  return result;
};
