int returnPhytoTreatmentOperationSubclass_Body(EntityMethod* pM)
//-----------------------------------------------------------------
// renvoie une classe d'ot de traitement adaptee au materiel, parcelle, strategie
//-----------------------------------------------------------------
{
  Entity* pInst = pM->DescribedEntity();
  BasicEntity* plotArgument = pM->GetEntityArgValue(PLOT_ARGUMENT);
  Entity* pChantier = pM->GetEntityArgValue(DISTRIBUTED_ACTIVITY_SET_ARGUMENT); 
  // ligne ci-dessus : + JPR 130129, car l'appel de cette méthode est remontée avant 
  // l'ajout de l'activité à son chantier, dans AddNewSituatedPhTr. On ne peut donc plus
  // le trouver avec le GetSuperSet (voir plus loin)
  int sprayerTypeRegular = 
	pM->GetIntArgValue(SPRAYER_TYPE_REGULAR_OPTION_ARGUMENT);
  int sprayerTypeAtBeginning = 
	pM->GetIntArgValue(SPRAYER_TYPE_AT_BEGINNING_OPTION_ARGUMENT);
  int sprayNumberAtBeginning = 
	pM->GetIntArgValue(SPRAY_NUMBER_AT_BEGINNING_OPTION_ARGUMENT);
  int result = -9;

  //
  // !!! y compris pour operation manuelle
  //
  if(pInst->IsInstanceOf(MANUAL_PHYTO_TREATMENT_ACTIVITY)) {
	result = BACK_SPRAYING_OPERATION;
  }
  else {
	int sprayerType = -9;
	
	//Entity* pChantier = pInst->GetSuperSet(); // - JPR 130129
	int typeChantier = App_GetDistributedActivitySetType(pChantier);
	
	switch(typeChantier) {
	case EXTRA_PHYTO : {
	  sprayerType = sprayerTypeRegular;
	  break;
	}
	case ANTI_MILDIOU : {   // optional
	  sprayerType = sprayerTypeRegular;
	  break;
	}
	case REGULAR_PHYTO : {
	  //Entity* pIterate = (Entity*)pInst->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
	  Entity* pIterate = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
	  // ligne ci-dessus : modif JPR 130129 (pInst n'est pas encore ajoutée au chantier
	  // (voir commentaire plus haut)
	  int iterationIndex = pIterate->GetIntVarValue(REPLICATION_COUNTER); // 0, 1, etc...
	  
	  sprayerType = sprayerTypeRegular;
	  if(iterationIndex < sprayNumberAtBeginning) {
		sprayerType = sprayerTypeAtBeginning;
	  }
	}
	}
	  
	switch (sprayerType) {
	case HAND_HELD : {
	  result = HAND_HELD_GUN_OPERATED_SPRAYING;
	  break;
	}
	case VERTICAL : {
	  result = VERTICAL_RAIL_OPERATED_SPRAYING;
	  break;
	}
	case AIR_ASSISTED : {
	  result = AIR_ASSISTED_SPRAYING;
	  break;
	}
	case BACK_CARRIED : { // !!
	  result = BACK_SPRAYING_OPERATION;
	  printf("\n!!! '%s'::returnPhytoTreatmentOperationSubclass sprayerType non compatible avec operation motorisee : 'BACK_CARRIED'\n", pInst->InstanceName());
	  break;
	}
	default : {
	  printf("\n!!! '%s'::returnPhytoTreatmentOperationSubclass sprayerType non gere : '%s'\n", pInst->InstanceName(), App_EnumToChar(sprayerType));
	  exit(0);
	}
	}  // fin switch sprayerType
  }

//printf("\n'%s'::returnPhytoTreatmentOperationSubclass returns '%s'", pInst->InstanceName(), ClassIdToCharTab[result]);
  return result;
};



