bool springTillagesIteration_openingPredicate_Body(EntityMethod* pM) {
//--------------------------------------------------------------------
// Doit renvoyer vrai pour que l'activit� puisse �tre ouverte.
//--------------------------------------------------------------------
  Entity* pIterate = pM->DescribedEntity();
  Entity* pEA = App_GetVineyard((Activity*)pIterate);
  bool result = FALSE;

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year +1;
  delete pTm;

  int clockOuverture; 

  int option = App_GetIntDecisionOption(pEA, OPT_FIRST_SPRING_TILLAGE_O_P);
  switch (option) {
  case INIT_SPRING_TILLAGE : {
	Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	Boolean error = FALSE;
	int option2 = App_GetIntDecisionOption(pEA, OPT_INIT_SPRING_TILLAGE_O_P);
	if(option2 == NONE)
	  error = TRUE;
	else {
	  pEntityTab pActTab = pConduite->GetDepthElementTab(ACTIVITY);
	  if(GetPosition(pActTab, CONCURRENT_INIT_SPRING_TILLAGES) < 0
		 &&
		 GetPosition(pActTab, SERIAL_INIT_SPRING_TILLAGES) < 0) {
		error = TRUE;
	  }
	}
	if(error) {
	  printf("\n!!! Option INIT_SPRING_TILLAGE interdite pour l'ouverture de '%s' :\n!!! pas de [Concurrent Serial]InitSpringTillages dans la conduite '%s'.\n", pIterate->InstanceName(), pConduite->InstanceName());
	  exit(0);
	}
	//result = TRUE;
	result = Body_CP_InitSpringTillages_Phase3(pM);
	break;
  }
  case EARLY_MAR : {
	clockOuverture = DateToClockValue(1, 3, year);  // 1er mars
	if(now >= clockOuverture)
	  result = TRUE;
	break;
  }
  case MID_MAR : {
	clockOuverture = DateToClockValue(15, 3, year);  // 15 juilletmars
	if(now >= clockOuverture)
	  result = TRUE;
	break;
  }
  case EARLY_APR : {
	clockOuverture = DateToClockValue(1, 4, year);  // 1er avril
	if(now >= clockOuverture)
	  result = TRUE;
	break;
  }
  case MID_APR : {
	clockOuverture = DateToClockValue(15, 4, year);  // 15 juilletavril
	if(now >= clockOuverture)
	  result = TRUE;
	break;
  }
  case WINTER_RAIN_BASED : {  // + JPR 130309
	result = TRUE;
	break;
  }
  default : {
	printf("\n'%s'_OP option d'ouverture inconnue : %d", pIterate->InstanceName(), option);
	exit(0);
  } 
  } 

//printf("\n'%s'_OP returns %d", pIterate->InstanceName(), result);
  return result;
};
