// --------------------------------------------
// Finalisation de la simulation non autonome
// --------------------------------------------
void FinalizeOpenSimulation (char* dirFile) {

  // ---------------------------------------------
  // Affichage somme des durees des episodes de simulation 
  // ---------------------------------------------
  //PrintChrono();
  //printf("\nduree totale des RunOpenSimulation : '%s'\n", gTimeString);
  //CloseChrono(); // RAZ et fermeture chronometre RunOpenSimulation

  //InitChrono();  // re-ouverture du chronometre pour FinalizeOpenSimulation

  // ---------------------------------------------
  // Lecture des directives finales de simulation
  // (celles qui succ�dent � la directive RUN dans
  // un simulateur autonome)
  // ---------------------------------------------
  C_ParseDirectiveFile(dirFile);
  //
  // Preparation R gantt charts
  // 
  App_MakeGanttChartCommandFiles();

  //
  // Desallocation des activites et des operations ...
  // - non commencees (*) ou entamees en l'instant de fin de simulation,
  //   donc non desallouees par un MIOS pour celles qui sont dans un chantier
  // - tq un chantier se termine avec elles, donc non desallouees par le MIOS
  //
  DeallocatePrimitiveActivityTab();
  DeallocateOperationTab();
  //
  // Desallocation des entites creees par l'application (et non par le moteur)
  // en cours de simulation et connues pour ne pas etre desallouees avant.
  //
  App_DeallocateMiscellaneousDynamicEntities();
  //
  // Desallocation generale :
  // - donc a ne pas programmer dans *.dir
  // - appel aux fonctions specialisees (au lieu de C_DeleteAll)
  // pour pouvoir y inserer un MemoryReport sans argument
  // (cad non conditionne a l'option de trace -V)
  //
  DeleteEntitySpecs();
  C_DeleteEntityInstances();
  DeleteMonitors();
  DeleteParameters();
  C_DeleteFileInstances();
  DeleteOutputSpecs();
  delete pCurrentSim;
  //O_MemoryReport();
  DeleteEntityClasses();

  //PauseChrono();
  //PrintChrono();
  //printf("\nduree FinalizeOpenSimulation : '%s'\n", gTimeString);
  //CloseChrono(); // RAZ et fermeture chronometre FinalizeOpenSimulation
}
