bool OpeningCondition_ShootThinnings_OnSurface (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  // pChantier :    chantier ShootThinnings de la phase 2 ou 3
  // selon le client (= code appelant) de la presente fonction

  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_SHOOT_THINNINGS_O_P);

  //int now = pCurrentSim->Clock();
  
  int nbPlots = pEA->GetNumberOfElements();
  float seuil = (float) -9.;

  switch (option)  {
	
  case ONE_PLOT_PRUNED : {
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  int isPruned = 
		App_FloatEQ(pPlot_k->GetFloatVarValue(PERCENT_PRUNED), (float)1.);
	  if(isPruned) {
		result = TRUE;
		break;
	  }
	}
	break;
  }
  case SURF_PRUNED_3 : {
	seuil = (float)3.;
	break;
  }
  case SURF_PRUNED_12 : {
	seuil = (float)12.;
	break;
  }
  case SURF_PRUNED_17 : {
	seuil = (float)17.;
	break;
  }
  case SURF_PRUNED_MAJ : {
	float totalArea = pEA->GetFloatConstValue(AREA_WITH_GRAPEVINE);;
	float cumulPruned = (float)0.;
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float surf_k = pPlot_k->GetFloatConstValue(AREA);
	  int isPruned =  
		App_FloatEQ(pPlot_k->GetFloatVarValue(PERCENT_PRUNED), (float)1.);
	  if(isPruned) {
		cumulPruned += surf_k;
		if(cumulPruned > totalArea*0.75) {
		  result = TRUE;
		  break;
		} 
	  }
	}
	break;
  }
  case NONE : {
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  pPlot_k->SetFloatVarValue(PERCENT_SHOOT_THINNED, (float)-1.);
	}
	break;
  }
  default : {
	printf("\n'%s'::OpeningCondition_ShootThinnings_OnSurface option inconnue : %d", pChantier->InstanceName(), option);
  }
	
} // fin switch
  if(seuil > 0.) {
	float cumulPruned = (float)0.;
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float surf_k = pPlot_k->GetFloatConstValue(AREA);
	  int isPruned =  
		App_FloatEQ(pPlot_k->GetFloatVarValue(PERCENT_PRUNED), (float)1.);
	  if(isPruned) {
		cumulPruned += surf_k;
		if(cumulPruned > seuil) {
		  result = TRUE;
		  break;
		}
	  }
	}
  }
//printf("\n'%s'::OpeningCondition_ShootThinnings_OnSurface returns %d", pChantier->InstanceName(), result);
  return result;
}
