bool antiPowderyMildewClosingPredicate_Body(EntityMethod* pM)
//-----------------------------------------------------------
// renvoie vrai ssi il y a lieu d'arreter la serie de traitement anti-oidium
//-----------------------------------------------------------
{
  Entity* pIteration = pM->DescribedEntity();
//printf("\n'%s'::antiPowderyMildewClosingPredicate", pIteration->InstanceName());
  Vineyard* pEA = (Vineyard*)App_GetVineyard((Activity*)pIteration);

  bool result = false;

  int option = App_GetIntDecisionOption(pEA, OPT_POWDERY_MILDEW_CLOSING);

  switch (option) {
  case 0 : {             // BERRY-TOUCH
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "beginningOfBerryTouch");
	break;
  }
  case 1 : {             // EARLY_RIPENING
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "beginningOfBerryRipening");
	break;
  }
  case 2 : {             // END_RIPENING
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "endOfBerryRipening");
	break;
  }
  case 3 : {             // AUGUST
	//=================================================
	// recuperation de la date de debut du chantier Regular
	//=================================================
	//
	Entity* iteratedActivity = pIteration->GetElement(0);
	int actualRegularBegDate = D_INTMAX;
	if(iteratedActivity->IsInstanceOf(VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN)) {
	  Entity* pChantier0 = iteratedActivity->GetElement(0);
	  int actualRegularBegDate0 = 
		pChantier0->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
	  if(actualRegularBegDate0 < actualRegularBegDate)
		actualRegularBegDate = actualRegularBegDate0;
	  Entity* pChantier1 = iteratedActivity->GetElement(1);
	  int actualRegularBegDate1 = 
		pChantier1->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
	  if(actualRegularBegDate1 < actualRegularBegDate)
		actualRegularBegDate = actualRegularBegDate1;
	}
	else {
	  actualRegularBegDate = 
		iteratedActivity->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
	}
//printf("\n\tactualRegularBegDate = %d\n", actualRegularBegDate);
	tm* pTm_now = ClockValueToTm(pCurrentSim->Clock());
	int year_now = pTm_now->tm_year;
	pTm_now->tm_mon = 7; // aout
	pTm_now->tm_mday = 1;
	mktime(pTm_now);
	int clock_seuil = StructTmToClockValue(pTm_now);
	delete pTm_now;
	
	if (actualRegularBegDate >= clock_seuil)
	  result = TRUE;
	break;
  }
  }
  
//printf("\nantiPowderyMildewClosingPredicate(%s) returns %d", pIteration->InstanceName(), result);
	return result;
};
