Conduite5::Conduite5(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'Conduite5'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE5);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetEntityConstValue(VINEYARD_ATTRIBUTE, pEA);

  SetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_POWDERY_MILDEW_MANAGEMENT));
  SetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_DOWNY_MILDEW_MANAGEMENT));

  int fertSeason = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_SEASON);
//printf("\nconstruction '%s' avec fertSeason %d\n", InstanceName(), fertSeason);
  Activity* pAct;
  // ==================================================
  // phase 1 
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase1 = new VineyardPhaseConjunctivePlan();  
  //--------------------------------------------------  
  char* optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 0, AUTUMN_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentAutumnTillages(pEA);
  else
    pAct = new SerialAutumnTillages(pEA);
  pAct->AssignBody(MAX_BEG_STATE_PREDICATE, Body_CP_Phase1);
  Entity* pOpt = new ActivityOptional();
  pOpt->AddElement(pAct);
  pPhase1->AddElement(pOpt);    
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 0, FERTILIZATIONS_MANAGEMENT);  
  if((fertSeason == 1) || (fertSeason == 3)) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	else
	  pAct = new SerialFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	pOpt->AddElement(pAct);
	pPhase1->AddElement(pOpt);
  }  
  //--------------------------------------------------
  this->AddElement(pPhase1);
  pPhase1->AssignBody(CLOSING_PREDICATE, Body_CP_Phase1);
  // ==================================================
  // phase 2
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase2 = new VineyardPhaseConjunctivePlan();  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, AUTUMN_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentAutumnTillages(pEA);
  else
    pAct = new SerialAutumnTillages(pEA);
  pAct->AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_OptionalPhase2);
  pOpt = new ActivityOptional();
  pOpt->AddElement(pAct);
  pPhase2->AddElement(pOpt);   
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 2);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 2);

  pPhase2->AddElement(pAct);    
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 2);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 2);  
  //--------------------------------------------------
  pPhase2->AddElement(pAct);  
  Entity* pOptPhase2 = new VineyardPhaseOptionalPlan();
  pOptPhase2->AddElement(pPhase2);
  pPhase2->AssignBody(OPENING_PREDICATE,
							  Body_OP_OptionalPhase2);
  pPhase2->AssignBody(MAX_BEG_STATE_PREDICATE,
							  Body_MBS_OptionalPhase2);
  pPhase2->AssignBody(CLOSING_PREDICATE,
							  Body_CP_alwaysTrue);

  this->AddElement(pOptPhase2);
  // ==================================================
  // phase 3
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase3 = new VineyardPhaseConjunctivePlan();
    
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 3);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 3);

  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CHEMICAL_WEEDINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }
  else {
    pAct = new SerialMotorizedChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 3);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 3);
 
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, INIT_SPRING_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentInitSpringTillages(pEA);
  else
    pAct = new SerialInitSpringTillages(pEA);

  pPhase3->AddElement(pAct);    
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, FERTILIZATIONS_MANAGEMENT);   
  if(fertSeason >= 2) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	else
	  pAct = new SerialFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	
	pOpt->AddElement(pAct);
	pPhase3->AddElement(pOpt);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SPRING_TILLAGES_MANAGEMENT);
  pAct = new SpringTillagesIteration(pEA, optionSerPar);
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PHYTO_MANAGEMENT);
  pAct = new PhytoTreatmentComposedProgram(pEA, optionSerPar);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, DEBRANCHINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }
  else {
    pAct = new SerialMotorizedDebranchings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SPRING_CHEMICAL_WEEDINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentSpringChemicalWeedings(pEA);
    pPhase3->AddElement(pAct); 
  }
  else {
    pAct = new SerialMotorizedSpringChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualSpringChemicalWeedings(pEA);
    pPhase3->AddElement(pAct); 
  }  
  //--------------------------------------------------
  pAct = new SerialTrellisings(pEA);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CLIPPINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentClippings(pEA);
  else
    pAct = new SerialClippings(pEA);

  pPhase3->AddElement(pAct);    
  //--------------------------------------------------
  pOpt = new ActivityOptional();
  pAct = new SerialPlantations(pEA);
  
  pOpt->AddElement(pAct);
  pPhase3->AddElement(pOpt);    
  //--------------------------------------------------

  this->AddElement(pPhase3);
  pPhase3->AssignBody(OPENING_PREDICATE, Body_OP_Phase3);
  pPhase3->AssignBody(CLOSING_PREDICATE, Body_CP_Phase3);

};
