pEntityTab* selectNewPlotsToDebranch_Body(EntityMethod* pM) {
//---------------------------------
// renvoie un tableau de parcelles a epamprer
//-------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToDebranch_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* manualMotorized 
	= pM->GetStringArgValue(MANUAL_MOTORIZED_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : alleyWidth * plantSpacing * _manualDebranchingOperation_speed_
  //   cas MOT : alleyWidth * _chemicalDebrancherOperatedSpraying_speed_ /12 / passedRowFrequency
  //
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)gIntParam_manualDebranchingOperation_speed_; // plus faible valeur vs. "backSprayingOperation" "speed" 
  float motorizedNominalSpeed = gRealParam_chemicalDebrancherOperatedSpraying_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											manualMotorized,
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f\n", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(! strcmp(manualMotorized, "MOTORIZED")) {
	if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
	if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;
  }
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f nbPlotMax = %d\n", nbRsc, dureePlageTravail, DTotW, nbPlotMax);

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
	   &&
	   (GetPosition(*pInCoursePlots, pPlot_i) < 0)
	   &&
	   App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_DEBRANCHED), (float)0.)) {
	  
	  pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							OPERATION_CLASS_ARGUMENT,
							MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable =
		pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\n'%s' isPlotMotorizable/MOTORIZED_SPRAYING = %d", pPlot_i->InstanceName(), isPlotMotorizable);
	  //
	  // le App_AssignTurnedOffActivitiesOnPlots a mis a -1 le PERCENT_DEBRANCHED
	  // des parcelles exclues pour raison de shootIntensity.
	  //
	  int modality = 
		App_GetIntDecisionOption(pVineyard, OPT_DEBRANCHING_MODALITY);
	  bool isPureChem = (modality == PART_CHEM) || (modality == WHOLE_CHEM);
	  bool isPureMeca = (modality == PART_MECA) || (modality == WHOLE_MECA);
	  bool isMixed = (modality == PART_MECA_CHEM) || (modality == WHOLE_MECA_CHEM);

	  if(isPureChem) {
		//
		// elimination de parcelles sur le critere motorisable ou non
		// - seulement effectif dans le cas "SER" (en "PAR, c'est dans 
		//   AddNewSituated qu'on regardera le critere pour decider du
		//   type d'operation)
		// - si "MANUAL", on elimine les parcelles motorisables
		//   si "MOTORIZED, on elimine les parcelles non motorisables
		//
		if(! strcmp(serParOption, "SER")) {
		  if(! strcmp(manualMotorized, "MANUAL")) {
			if(isPlotMotorizable)
			  continue;
		  }
		  else if(! strcmp(manualMotorized, "MOTORIZED")) { 
			if(! isPlotMotorizable)
			  continue;
		  }
		}
	  }
	  else if(isPureMeca) {
		//
		// elimination de parcelles dans le cas "SER" (id. ci-dessus)
		// - si "MANUAL", on elimine rien
		//   si "MOTORIZED, on elimine toutes les parcelles
		//
		if(! strcmp(serParOption, "SER")) {
		  if(! strcmp(manualMotorized, "MOTORIZED")) { 
			continue;
		  }
		}
	  }
	  else if(isMixed) {
		Entity* pVariety = pPlot_i->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
		int shootIntensity = pVariety->GetIntConstValue(SHOOT_INTENSITY);
		if(! strcmp(manualMotorized, "MANUAL")) {
		  //
		  // elimination de parcelles avec shootIntensity=2 et motorisables
		  //
		  if(isPlotMotorizable && (shootIntensity == 2))
			continue;
		}
		else {                         // "MOTORIZED"
		  //
		  // elimination de parcelles avec shootIntensity<2 ou non motorisables
		  //
		  if((! isPlotMotorizable) || (shootIntensity < 2))
			continue;
		}		
	  }
	  result->push_back(pPlot_i);
	  float duration_i = App_GetExpectedDuration(pPlot_i, 
												 isPlotMotorizable,  
												 -9, // otClaaaId
												 serParOption,
												 manualMotorized, // "MOTORIZED",
												 passedRowFrequency,
												 manualNominalSpeed,
												 motorizedNominalSpeed);
		alreadyChosenDuration+= duration_i;
		if(! strcmp(manualMotorized, "MOTORIZED")) {
		  if(duration_i > (float)1.0) nbPlotMax--;
		}
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	}
  }  // fin boucle / parcelles

//printf("\nt = %d selectPlotsToDebranch returns :", pCurrentSim->Clock());result->display_names();
  return result;
};
