pEntityTab* selectNewPlotsToFertilize_Body(EntityMethod* pM) {
//----------------------------------------------------------
// renvoie un tableau de parcelles a fertiliser
//----------------------------------------------------------
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//----------------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToFertilize_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : sans objet
  //   cas MOT : alleyWidth * _tillageOperation_speed_ /12 / passedRowFrequency
  //
  //UserClassId otClassId = FERTILIZATION_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)-9; 
  float motorizedNominalSpeed = gRealParam_fertilizationOperation_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots,  
											pChantier,
											serParOption,
											"MOTORIZED",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	bool isPlotMotorizable = pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	// !!! ci-dessus : sans spécifier OPERATION_CLASS_ARGUMENT ???
	if(isPlotMotorizable) {
	  //
	  // on elimine les parcelles taillees ET . partiellement broyees
	  //                                      . OU pas broyees mais a broyer
	  //
	  if(App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_PRUNED), (float)1.)
		 &&
		 App_FloatGT(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED), (float)-1.)
		 &&
		 App_FloatLT(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED), (float)1.))
		continue;
	  
	  if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		 &&
		 (GetPosition(*pInCoursePlots, pPlot_i) < 0)
		 &&
		 App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_FERTILIZED), (float)0.)) {
		result->push_back(pPlot_i);
		float duration_i = App_GetExpectedDuration(pPlot_i, 
												   TRUE, // isPlotMotorizable
												   -9, // otClassId
												   serParOption,
												   "MOTORIZED",
												   passedRowFrequency,
												   manualNominalSpeed,
												   motorizedNominalSpeed);
		  alreadyChosenDuration+= duration_i;
		  if(duration_i > (float)1.0) nbPlotMax--;
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	  }
	}
	else {
	  //
	  // on elimine les parcelles non motorisables
	  //
	  pPlot_i->SetFloatVarValue(PERCENT_FERTILIZED, (float)-1.);
	}
  }
//printf("\nt = %d selectPlotsToFertilize returns :", pCurrentSim->Clock());result->display_names();
  return result;
};
