BasicEntity* virtualRegionManager_bestActivitySetSelector_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// Choisit (et eventuellement modifie) le meilleur jeu d'activites
// parmi des jeux vehicules par l'argument ACTIVITY_SETS_ARGUMENT.
//---------------------------------------------------------------------------
  Entity* pE = pM->DescribedEntity();
  Entity* pARB = pM->GetEntityArgValue(ACTIVITIES_RESOURCES_BLOCK_ARGUMENT);
  Entity* pSetDisj = pM->GetEntityArgValue(ACTIVITY_SETS_ARGUMENT);
  // ((A1 B C) (A2 B D))
//printf("\n");CoutDateFromClock(pCurrentSim->Clock(), ISO_8601);printf("\tbestActivitySetSelector sur :");((InstructionSetDisjunction*)pSetDisj)->SpecialDisplay();
  //
  // Ultimement, deleguer le travail a une methode des ARB qui renvoie
  // la bonne valeur pour ce result. Transmettre pSetDisj en argument
  // de cette m�thode des ARB.
  // Le corps de cette methode d'ARB est surcharge de maniere specifique
  // pour chaque instance d'ARB, creee dans App_DepthBioPhysicalSettings
  //

  BasicEntity* result = NULL;

  pEntityTab setTab = pSetDisj->GetElementTab();
  int nbSets = setTab.size();
  //
  // REGLE CHOIX 0 : on selectionne le premier venu parmi jes jeux qui
  // possede une activite "...Weeding..."
  //
  // ((A1   B   C) (A2   B   Weeding) (A2   C   Weeding))
  //   
  // -> on choisit le jeu (A2 B Weeding)
  //
  //
  // REGLE CHOIX 1 : on selectionne le premier venu parmi jes jeux qui
  // poss�de l'activit� (l'operation, en fait) de plus forte priorite
  //
  // ((A1   B   C) (A2   B   D))
  //   30   40 70  30   40  60               <- priorite
  // -> on choisit le jeu (A1 B C)
  //
  //
  // REGLE CHOIX 2 : s'il y a un jeu contenant une activit� presque finie,
  // une activit� de TAILLE presque finie (seuil .90), 
  // alors on selectionne ce jeu.
  //
  // ((A1     B   C)  (A2    B    D))
  //   .30   .40 .60  .30   .40  .95            <- degre de realisation
  // -> on choisit le jeu (A2 B D)
  //
  //
  // REGLE CHOIX 2 : s'il y a un jeu contenant une activit� urgente,
  // alors on selectionne ce jeu.
  //
  // ((A1     B   C)  (A2    B    D))
  //   .30   .40 .60  .30   .40  .95
  // -> on choisit le jeu (A2 B D)
  //
  for(int i=0;i<nbSets;i++) {
	BasicEntity* pSet = setTab.get_element(i);
	
	pEntityTab singleTab = pSet->GetElementTab();
	int nbSingles = singleTab.size();
	for(int j=0;j<nbSingles;j++) {
	  Entity* pSingle = (Entity*)singleTab.get_element(j);
	  Entity* pInst = 
		pSingle->GetEntityConstValue(PRIMITIVE_ACTIVITY_ATTRIBUTE);
	  if(strstr(pInst->InstanceName(), "Weeding") != NULL) {
		result = pSet;
		break;
	  }
	}
	/*
	if(i == 0) {
	  pEntityTab singleTab = pSet->GetElementTab();
	  int nbSingles = singleTab.size();
	  for(int j=0;j<nbSingles;j++) {
		Entity* pSingle = (Entity*)singleTab.get_element(j);
		Entity* pAlloc = pSingle->GetEntityConstValue(ALLOCATION_ATTRIBUTE);
		pEntityTab* pRscTab = 
		  ((InstructionAllocation*)pAlloc)->ExtractRscSetButOperation();
		Entity* pInst = 
		  pSingle->GetEntityConstValue(PRIMITIVE_ACTIVITY_ATTRIBUTE);
//printf("\nselected '%s'\n    rsc : ", pInst->InstanceName()); pRscTab->display_names();
		delete pRscTab;
	  }
	*/
	if(result)  // + JPR 101104
	  break;
  }
  if(! result)
        // 0 : vraisemblablement un jeu de forte priorite d'allocation
	result = setTab.get_element(0);

  return result;
};
