bool Body_CP_AutumnTillages (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a labourer l'ont ete (condition 1)
//                  OU
//                - une date max a ete atteinte (condition 2)
//                  . soit une date calendaire :          // si
//                              NOV, DEC ou               //   phase
//                              la taille doit commencer  //         2
//                  . soit la taille doit commencer immediatement // si phase 1
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  int now = pCurrentSim->Clock();
  //
  // condition 1
  //
  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_AUTUMN_TILLED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	//
	// condition 2
	//
	bool debutTaille = OpeningCondition_Prunings_OnDate(pChantier);
	Vineyard* pEA = App_GetVineyard((Activity*)pChantier);
	if(debutTaille) {
	  int optionFermeture = App_GetIntDecisionOption(pEA,
													 OPT_AUTUMN_TILLAGE_C_P);
	  if(optionFermeture == BEG_PRUN)
		result = TRUE;
	  else {
		Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
		Entity* pPhase1 = pConduite->GetElement(0);
		int dateFermeturePhase1 = pPhase1->GetIntVarValue(END_DATE);
		int dateMax;
		tm* pTm = ClockValueToTm(now);
		int year = pTm->tm_year + 1900;
		delete pTm;
		if(dateFermeturePhase1 < now) {
		  if(optionFermeture == NOVEMBER) {
			dateMax = DateToClockValue(30, 11, year);
		  }
		  else {             // DECEMBER
			dateMax = DateToClockValue(31, 12, year);
		  }		  
		}
		if(now > dateMax)
		  result = TRUE;
	  }
	}
	else {
	  result = FALSE;
	}
  }
//printf("\n'%s'::Body_CP_AutumnTillages returns %d", pChantier->InstanceName(), result);
  return result;
}
