bool Common_PhytoTreatment_OnDate_OpeningPredicate (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Vineyard* pEA = App_GetVineyard((Activity*)pChantier);
  int now = pCurrentSim->Clock();
//printf("\nt = %d entree Common_PhytoTreatment_OnDate_OP chantier : '%s'", now, pChantier->InstanceName());

  tm* pTm = ClockValueToTm(now);

  int now_hour = pTm->tm_hour; // + JPR 130224 pour restriction ouverture a la 'wakeUpHour' pour Regular

  int wday = pTm->tm_wday;// modif JPR 121214 (5.1)
  // si Dimanche ou Samedi, on se donnera jusqu'à lundi soir
  // au lieu du soir même
  if(wday == 0) pTm->tm_mday =  pTm->tm_mday + 1;  // modif JPR 130114
  else if(wday == 6) pTm->tm_mday =  pTm->tm_mday + 2;  // modif JPR 130114
  pTm->tm_hour = 23;
  mktime(pTm);
  int ceSoir = StructTmToClockValue(pTm);
  delete pTm; 

  bool result = FALSE;
  //=================================================
  // etablissement de la date de debut du chantier Regular
  // pour cette iteration
  //=================================================
  Entity* pMother = pChantier->GetSuperSet();
  Entity* pComposedPrgm = 
	(Entity*)pMother->GetFirstContainer(PHYTO_TREATMENT_COMPOSED_PROGRAM, 
										TRUE);
  Entity* regularIteration = pComposedPrgm->GetElement(0); // par convention
  int regularIterationIndex = regularIteration->GetIntVarValue(REPLICATION_COUNTER);
  Entity* iteratedActivity = regularIteration->GetElement(0);
  int actualRegularBegDate = D_INTMAX;
  if(iteratedActivity->IsInstanceOf(VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN)) {
	//
	// cas SERIAL  : iterate(conj(chantierManual, chantierMotorized))
	//         (voir constructeur de RegularPhytoTreatmentsIteration)
	//
	Entity* pChantier0 = iteratedActivity->GetElement(0);
	int actualRegularBegDate0 =
	  pChantier0->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
	if((actualRegularBegDate0 > -9)  // correction JPR 130228
	   &&
	   (actualRegularBegDate0 < actualRegularBegDate))
	  actualRegularBegDate = actualRegularBegDate0;
	Entity* pChantier1 = iteratedActivity->GetElement(1);
	int actualRegularBegDate1 = 
	  pChantier1->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
	if((actualRegularBegDate1 > -9)  // correction JPR 130228
	   &&
	   (actualRegularBegDate1 < actualRegularBegDate))
	  actualRegularBegDate = actualRegularBegDate1;
  }
  else {
	//
	// cas CONCURRENT : iterate(chantierManual)      ou bien  
	//                  iterate(chantierMotorized))
	//
	actualRegularBegDate = 
	  iteratedActivity->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
  }
//printf("\n\tactualRegularBegDate = %d\n", actualRegularBegDate);

  //=================================================
  // calcul fenetre pour extra-oidium et/ou anti-mildiou
  // sert aussi comme minBegDate du prochain Regular
  //=================================================
  int cadence = App_GetIntDecisionOption(pEA, 
										 OPT_PHYTO_TREATMENT_CADENCE);
  int delay;
  if(cadence > 0) {
	if(cadence < 15) {
	  delay = (cadence / 2) - 1;
	}
	else {
	  delay = 11 - 1;
	}
  }
  else {    // cadence 'au moins X jours'
	delay = 11 - 1;
  }
//printf("\n\tnow=%d actualRegularBegDate=%d delay=%d", now, actualRegularBegDate, delay*24);

  int typeChantier = App_GetDistributedActivitySetType(pChantier);
  if(typeChantier == ANTI_MILDIOU) {
	//=================================================
	// test de l'ouverture sur position p.r � debut chantier 'regular'
	// + imposition d'un delai court (3j) pour commencer les operations
	//=================================================
	if(now < actualRegularBegDate + (delay+1)*24) {
	  result = TRUE;
	  pChantier->SetIntVarValue(MIN_BEG_DATE, now);
	  pChantier->SetIntVarValue(MAX_BEG_DATE, ceSoir);
//((Activity*)pChantier)->PrintDates();
	}
  }
  else if(typeChantier == EXTRA_PHYTO) {
	//=================================================
	// test de l'ouverture .....
	// 
	//=================================================
	int wakeUpHour = GetIntParameterValue("morningUpdateSituation", "normalHour");
	if(now_hour == wakeUpHour) { // + JPR 130226
	  int thisRegularIterationIndex =
		pChantier->GetIntConstValue(REGULAR_PHYTO_TREATMENT_INDEX);
	  //  + JPR 130223 : pour qu'un nouveau chantier 'Extra' puisse etre ouvert
	  // il faut qu'un nouveau chantier 'Regular' l'ait ete. La valeur initiale 
	  // de RegularPhytoTreatmentIndex est -9 : on peut donc ouvrir un chantier
	  // 'Extra' apres le premier 'regular'. Une fois realise (ou pas) cet
	  //  'Extra', son RegularPhytoTreatmentIndex passe a 0, et il faut attendre
	  //  un nouveau 'Regular' (index=1) pour que le test ci-dessous soit vrai.
	  if(regularIterationIndex > thisRegularIterationIndex) {
		int actualExtraBegDate =
		  pChantier->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
//printf("\n\tactualExtraBegDate=%d", actualExtraBegDate);
		// modif JPR 121001 : date min ramenée au debut du jour
		//                    date max ramenée au debut du jour suivant
		if((actualExtraBegDate < 0)
		   ||
		   (actualExtraBegDate < actualRegularBegDate)) {
		  
		  int thisTreatmentMinClock = actualRegularBegDate + delay*24;
//printf("\nthisTreatmentMinClock = %d transforme en ", thisTreatmentMinClock);
		  tm* tm_tmp = ClockValueToTm(thisTreatmentMinClock);
		  tm_tmp->tm_hour = gIntParam_morningUpdateSituation_specialHour_;
		  mktime(tm_tmp);
		  thisTreatmentMinClock = (int)StructTmToClockValue(tm_tmp);
//printf(" %d", thisTreatmentMinClock);

		  int thisTreatmentMaxClock = actualRegularBegDate + (delay+3)*24;
		  delete tm_tmp; // + JPR 130124
//printf("\nthisTreatmentMaxClock = %d transforme en ", thisTreatmentMaxClock);
		  tm_tmp = ClockValueToTm(thisTreatmentMaxClock);
		  tm_tmp->tm_mday = tm_tmp->tm_mday +1;
		  tm_tmp->tm_hour = gIntParam_morningUpdateSituation_specialHour_;
		  mktime(tm_tmp);
		  thisTreatmentMaxClock = (int)StructTmToClockValue(tm_tmp);
		  delete tm_tmp; // + JPR 130124
//printf(" %d", thisTreatmentMaxClock);

		  if((now >= thisTreatmentMinClock)
			 &&
			 (now < thisTreatmentMaxClock)) {
			result = TRUE;
			pChantier->SetIntVarValue(MIN_BEG_DATE, now);
			pChantier->SetIntVarValue(MAX_BEG_DATE, ceSoir);
		  }
		}
	  }
	// fin modif JPR 121001
	}
  }
  else {             // REGULAR
	int wakeUpHour = ReturnManagerWakeUpHour();
	if(now_hour == wakeUpHour) { // + JPR 130224
	  int antiMildewJustDone = 
		pComposedPrgm->GetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE);
	  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	  Boolean flag_mildew = pConduite->GetIntConstValue(FLAG_MILDEW);
	  if((antiMildewJustDone ==0) && flag_mildew)
		result = TRUE;
	  else {
		Entity* pRegularIteration 
		  = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
		int iterationIndex = pRegularIteration->GetIntVarValue(REPLICATION_COUNTER);
		if(iterationIndex == 0)
		  result = TRUE;
		else  {
		  if((cadence > 0)
			 &&
			 (now >= actualRegularBegDate + (cadence - 2)*24))
			result = TRUE;
		  else if((cadence < 0)
				  &&
				  (now >= actualRegularBegDate - cadence*24))
			result = TRUE;
		}
	  }
	}
  }
//((Activity*)pChantier)->PrintDates();

//printf("\nt = %d Common_PhytoTreatment_OnDate_OP chantier : '%s' returns %d", now, pChantier->InstanceName(), result);
  return result;
}
