void dumpOperationRecords_Body(EntityMethod* pM)
//----------------------------------------------
// ecrit sur un fichier externe le contenu de la memoire des operations du manager
//----------------------------------------------
{
  //
  // recuperation de la memoire des operations du manager 
  // alimentee dans AchievementDegreeMonitor
  //
  Entity* pManager = pM->DescribedEntity();
  Entity* pOtRecordingStructure = 
	  pManager->GetEntityConstValue(OPERATION_RECORDING_ATTRIBUTE);
  int nbRecords = pOtRecordingStructure->GetNumberOfElements();
  //
  // parcours des enregistrements memorises
  //
  for(int k=0;k<nbRecords;k++) {
	Entity* pRecordItem_k = pOtRecordingStructure->GetElement(k);
	//
	// recuperation YMD, plot, activite, operation, duree
	// 
	int year_k = pRecordItem_k->GetIntConstValue(RECORDED_YEAR);
	int month_k = pRecordItem_k->GetIntConstValue(RECORDED_MONTH);
	int day_k = pRecordItem_k->GetIntConstValue(RECORDED_DAY);
	char* plot_k = pRecordItem_k->GetStringConstValue(RECORDED_PLOT_NAME);
	char* cha_k = pRecordItem_k->GetStringConstValue(RECORDED_CHANTIER_CLASS_NAME);  // 120516 4.6
	char* act_k = pRecordItem_k->GetStringConstValue(RECORDED_ACTIVITY_CLASS_NAME);
	char* ot_k = pRecordItem_k->GetStringConstValue(RECORDED_OPERATION_CLASS_NAME);
	int nbHours_k = pRecordItem_k->GetIntConstValue(RECORDED_IN_DAY_DURATION);
	//
	// recuperation listes de performers, ressources, produits phyto
	// 
	pEntityTab* perfList_k = 
	  pRecordItem_k->GetEntityTabConstValue(RECORDED_PERFORMER_LIST);
	pEntityTab* rscList_k = 
	  pRecordItem_k->GetEntityTabConstValue(RECORDED_RESOURCE_LIST);
	TableauString* productList_k = 
	  pRecordItem_k->GetStringTabConstValue(RECORDED_PHYTO_PRODUCT_LIST);
	//
	// calcul du jour de semaine (LUN, ...)
	// 
    tm* pTm = new tm();
	pTm->tm_year = year_k;pTm->tm_mon = month_k;pTm->tm_mday = day_k;
	mktime(pTm);
	int wday_k = pTm->tm_wday;
	delete pTm;
	//
	// ecriture des champs jour de semaine, YMD, plot, act, operation, duree
	// gFileBDD est instancie, ouvert et ferme dans la fonction main(...)
	// 
	FILE* pF = gFileBDD->GetPhysicalFile();
	fprintf(pF, "\n%s %d %d %d %s %s %s %s %d",  // 120516 4.6
			ShortWeekDayNameToCharTab[wday_k], year_k+1900, month_k+1, day_k, 
			plot_k, cha_k, act_k, ot_k, nbHours_k);
	//
	// calcul de l'effectif alloue a l'activite pour les 7 types de MO Perm
	// dans l'ordre : pATT, pPT, pTT, pTOT, pMTM, pP, pVG
	// par exemple  :   2    0    0    0     1    0    0
	//
	pIntTab* profilMO = App_SummarizePerformerPool(perfList_k);
	//
	// ecriture des 7 champs pour les types de MO
	// 
	for(int p=0;p<7; p++) fprintf(pF, " %d", profilMO->get_nth(p));
    delete profilMO;
	//
	// calcul du nb de Rsc allouees a l'operation pour les 5 types d'outils
	// dans l'ordre : TRACTOR, PULVE, TILLAGE_TOOL, GRINDER, autres
	// par exemple  :    1       1           0         0       0
	//
	pIntTab* profilTools = App_SummarizeToolSet(rscList_k);
	//
	// ecriture des 5 champs pour les types d'outils
	// 
	for(int p=0;p<5; p++) fprintf(pF, " %d", profilTools->get_nth(p));
    delete profilTools;
	//
	// calcul des 2 champs anti-oidium et anti-mildiou pour les traitements
	// par exemple  :          oidium          -
	// seulement si liste renseignee dans AchievementDegreeMonitor
	//
	if(productList_k) {  
	  TableauString* profilProd = new TableauString("-", 2);
	  int nbProds = productList_k->size();
	  for (int p = 0;p<nbProds;p++) {
		char* pProd_k_p = productList_k->get_nth(p);
		if(strstr(pProd_k_p, "oidium"))
		  profilProd->set_nth(0, "oidium");
		else if(strstr(pProd_k_p, "mildiou"))
		  profilProd->set_nth(1, "mildiou");
	  }
	  //
	  // ecriture des 2 champs pour les produits phyto
	  // 
	  for(int p=0;p<2; p++) fprintf(pF, " %s", profilProd->get_nth(p));
	  delete profilProd;
	}
  }
};
