void grapevineAgeingProcess_initializeProcess_Body(ProcessMethod* pM)
//---------------------------------------------
// Definition de la fonction qui code l'initialisation du processus continu.
//---------------------------------------------
{
  ContinuousProcess* pCP = pM->DescribedContinuousProcess();
  Entity* pIsoAgeingEntity = pCP->ProcessedEntity();
  //
  // etablissement du jour julien courant
  //
  int currentClock = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(currentClock);
  int currentJulianDay = pTm->tm_yday+1;
  delete pTm;
  //
  // parcours des stades et arret sur le premier dont le jour d'atteinte pleine
  // est superieur au jour julien courant
  //
  int initialStageIndex = 0;
  Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
  pEntityTab* pStageTab = pAge->GetEntityTabConstValue(STAGE_TAB);
  int nbStages = pStageTab->size();
  for(int k=0;k<nbStages;k++) {
    Entity* pStage_k = (Entity*)pStageTab->get_element(k);
    int achievementDay_k = pStage_k->GetIntConstValue(DAY_OF_ACHIEVEMENT);

    if( achievementDay_k <= currentJulianDay) {
      initialStageIndex++;
    }
    else {
      break;
    }
  }
  int firstStage = initialStageIndex-1;
  if(initialStageIndex==0) {
    firstStage = nbStages-1;
  }
  pAge->SetIntVarValue(CURRENT_STAGE_INDEX, firstStage);
};
