pEntityTab* selectNewPlotsToSpringWeed_Body(EntityMethod* pM) {
//-----------------------------------------------------------
// renvoie un tableau de parcelles a desherber au printemps
//----------------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToSpringWeed_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* manualMotorized 
	= pM->GetStringArgValue(MANUAL_MOTORIZED_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : alleyWidth * plantSpacing * backSprayingOperation_speed_
  //   cas MOT : alleyWidth * _horizontalRailOperatedSpraying_speed_ /12 / passedRowFrequency!!!!!!!!!!!!!!!!
  //
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)gIntParam_backSprayingOperation_speed_;
  float motorizedNominalSpeed = gRealParam_horizontalRailOperatedSpraying_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											manualMotorized,
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail; // + JPR 130131;
  if(! strcmp(manualMotorized, "MOTORIZED")) { 
	if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
	if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;
  }

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
	  if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
	   &&
	   (GetPosition(*pInCoursePlots, pPlot_i) < 0)
	   &&
	   App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_SPRING_WEEDED), (float)0.)) {
	  pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							  OPERATION_CLASS_ARGUMENT,
							  MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable =
		pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable = %d", isPlotMotorizable);
	  result->push_back(pPlot_i);
	  float duration_i = App_GetExpectedDuration(pPlot_i, 
												 isPlotMotorizable,
												 -9, // otClassId
												 serParOption,
												 manualMotorized,
												 passedRowFrequency,
												 manualNominalSpeed,
												 motorizedNominalSpeed);
	  alreadyChosenDuration+= duration_i;
	  if(! strcmp(manualMotorized, "MOTORIZED")) { 
		if(duration_i > (float)1.0) nbPlotMax--;
	  }
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	}
  }
//printf("\nt = %d selectPlotsToSpringWeed returns :", pCurrentSim->Clock());result->display_names();
  return result;
};
