bool springTillagesIteration_closingPredicate_Body(EntityMethod* pM) {
  //--------------------------------------------------------------------
  // Doit renvoyer vrai pour que l'activit� puisse �tre ferm�e.
  //--------------------------------------------------------------------
  Entity* pIterate = pM->DescribedEntity();
  Vineyard* pEA = App_GetVineyard((Activity*)pIterate);
  bool result = FALSE;

  Entity* pPhase = pIterate->GetSuperSet();
  Entity* pConduite = pPhase->GetSuperSet();
  int indexPhase = pConduite->GetElementPosition(pPhase);
 
  int option = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_ITERATION_C_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)    // sept, oct, etc.
	year = year + 1;
  delete pTm;

  int clockFermeture;
  switch (option) {
  case EARLY_JUN : {
	clockFermeture = DateToClockValue(1, 6, year);  // 1er juin
	break;
  }
  case EARLY_JUL : {
	clockFermeture = DateToClockValue(1, 7, year);  // 1er juillet
	break;
  }
  case MID_JUL : {
	clockFermeture = DateToClockValue(15, 7, year);  // 15 juillet
	break;
  }
  case TEN_AUG : {
	clockFermeture = DateToClockValue(10, 8, year);  // 10 aout
	break;
  }
  default : {
	printf("\n'%s'_CP option de fermeture inconnue : %d", pIterate->InstanceName(), option);
	exit(0);

  } 
  } 
//printf("\n'%s'_CP now = %d clockFermeture %d", pIterate->InstanceName(), now, clockFermeture);
  if((now >= clockFermeture)
	 ||   // + JPR 130425 (5.6)
	 (pIterate->GetIntVarValue(REPLICATION_IN_DRY_PERIOD_COUNTER)
	  >=
	  pIterate->GetIntConstValue(MAX_REPLICATION_NUMBER_IN_DRY_PERIOD)))
	result = TRUE;

//printf("\t --> returns %d", result);
  return result;
};
