int updateSeasonCurrentIndex_Body(EntityMethod* pM)
//--------------------------------------------------
// modifie l'index pointant sur la saison en cours dans un AnnualEmploymentPlan
//--------------------------------------------------
{
  Entity* pEmploymentPlan = pM->DescribedEntity();
  int nbSeasons = pEmploymentPlan->GetNumberOfElements();
  //
  // currentIndex est initialise a -9 dans le constructeur du pEmploymentPlan
  // ==> a l'initialisation de la simulation, le plan est parcouru
  //     depuis son debut pour trouver la saison courante
  // ==> ensuite, le plan est parcouru a partir de la saison courante
  //
  int currentIndex = pEmploymentPlan->GetIntVarValue(CURRENT_ELEMENT_INDEX);
//printf("\nentree updateSeasonCurrentIndex_Body sur '%s' currentIndex = %d\n", pEmploymentPlan->InstanceName(), currentIndex);
  //
  // initialisation de l'index en fonction de la date courante
  // (= date de debut de la simulation, puisque l'evenement 
  //  updateSeasonCurrentIndexEvent est lance en t=0, qui invoque la
  //  presente methode dans la methode exec de son processus)
  //
  int candidateIndex = 0;
  for(int i=0;i<nbSeasons;i++) {
	if(currentIndex < 0) {
	  candidateIndex = i;
	}
	else {
	  candidateIndex = currentIndex + 1 + i;
	  if(candidateIndex >= nbSeasons)
		candidateIndex = currentIndex + 1 + i - nbSeasons;
	}
//printf("\n\tau candidateIndex = %d", candidateIndex);
	Entity* pSeasonalPlan = pEmploymentPlan->GetElement(candidateIndex);
//printf("\tseasonalPlan '%s'\n", pSeasonalPlan->InstanceName());
	//-------------------------
	Method* pOpeningMeth = 
	  pSeasonalPlan->GetMethodWithBody(TIMETABLE_OPENING_PREDICATE); 
	EntityPredicate*  pM_OP = (EntityPredicate*)pOpeningMeth;
	Method* pClosingMeth = 
	  pSeasonalPlan->GetMethodWithBody(TIMETABLE_CLOSING_PREDICATE);
	EntityPredicate*  pM_CP = (EntityPredicate*)pClosingMeth;
	//-------------------------
	if(pOpeningMeth) {  // IL Y A UN  OPENING	
	  Boolean isOpenable = pM_OP->Body(pM_OP);
	  if(isOpenable) {     // candidateIndex openable
		if(pClosingMeth) {
		  Boolean isClosable = pM_CP->Body(pM_CP);
		  if(isClosable) { // candidateIndex closable
			currentIndex = candidateIndex;
			break;
		  }
		  else {           // candidateIndex not closable
			// on va regarder la saison suivante
		  }
		}
	  }
	  else {               // candidateIndex not openable
		currentIndex = candidateIndex -1;
		if(candidateIndex == 0)
		  currentIndex = nbSeasons - 1;
		else
		  currentIndex = candidateIndex -1;
		break;
	  }
	}
	else {  // PAS DE OPENING
	  if(pClosingMeth) {
		Boolean isClosable = pM_CP->Body(pM_CP);
		if(isClosable) { // candidateIndex closable
		  currentIndex = candidateIndex;
		  break;
		}
		else {           // candidateIndex not closable
		  // on va regarder la saison suivante
		}
	  }
	  else {
		printf("\n!!! updateSeasonCurrentIndex_Body sur '%s'\n    la saison %k n'a ni Opening ni ClosingPredicate.\n", pEmploymentPlan->InstanceName(), candidateIndex);
		exit(0);
	  }
	}
  }
//printf("\n!!! updateSeasonCurrentIndex_Body sur '%s' nouvel index = %d", pEmploymentPlan->InstanceName(), currentIndex);
  pEmploymentPlan->SetIntVarValue(CURRENT_ELEMENT_INDEX, currentIndex);
  //
  // l'attachement d'une nouvelle AvailabilityTimetable (propre a la nouvelle
  // periode ouverte) a l'unite de MO qui possede cet AnnualEmploymentPlan
  // est fait dans le processus updateSeasonCurrentIndexProcess
  //
  return currentIndex;
};
