float App_GetIntPestHistory (Vineyard* pEA, UserDescriptorId descId)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float result = (float)-9.;
  
  Entity* pVineyardSet = (Entity*)pEA->GetSuperSet();

  BasicEntity* pPestMemory = 
	pVineyardSet->GetEntityConstValue(PEST_INFO_MEMORY_ATTRIBUTE);

  int now = pCurrentSim->Clock();

  int nbItems = pPestMemory->GetNumberOfElements();
//printf("\n\tnbItems -> %d", nbItems);
  int total = 0;
  int prevInstant = 0;
  for(int k=0;k<nbItems;k++) {
	Entity* pPestMemoryItem_k = pPestMemory->GetElement(k);
	Descriptor* pCD = pPestMemoryItem_k->GetDescriptor(descId);
	if (pCD->ClassType() != INT)
	  BadDescriptorValueType(pVineyardSet, pCD->ClassName(), "App_GetIntPestInfo");
	int instant_k = pPestMemoryItem_k->GetIntConstValue(INSTANT_ATTRIBUTE);
	int value_k = ((IntConstantDescriptor*)pCD)->GetIntValue();
//printf("\n\tinstant_k = %d value_k = %d", instant_k, value_k);
	int ref = now;
	if(k > 0) {
	  ref = prevInstant;
	}
	int timeInterval = ClockIntervalToTimeInterval(ref - instant_k);
//printf("\n\ttimeInterval = %d", timeInterval);
	total += value_k * timeInterval;  // secondes
//printf("\n\ttotal -> %d", total);
	prevInstant = instant_k;
	//
	// arret si pestInfo trop ancienne
	//
	int memoryScope = GetIntParameterValue("virtualManager", "pestMemoryScope");  // jours
	int seuil = memoryScope * 24;  // heures
	int delta = (now - instant_k);
//printf("\n\tmemoryScope = %d delta = %d seuil = %d", memoryScope, delta, seuil);
	if(delta > seuil)
	  break;
  }
  //
  // calcul moyenne
  //
//printf("\n\t(float)total = %f now = %d prevInstant = %d", (float)total, now, prevInstant);
  result = ((float)total) / (now - prevInstant) / (float)3600;

//printf("\nApp_GetIntPestHistory('%s', %s) returns %f", pEA->InstanceName(), DescIdToCharTab[descId], result);
  return result;
}
