bool Body_CP_RegularPhytoTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si plus de parcelles a traiter 
// Comment      : créé en 5.3 +  MODIF JPR 130127 (manuel/motorized)
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  bool isSerialManual = pChantier->IsInstanceOf(SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS);
  bool isSerialMotorized = pChantier->IsInstanceOf(SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS);

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_REGULAR_PHYTO_TREATED);
	int isDone = TRUE;
	if(isSerialManual || isSerialMotorized) {
	  pPlot_k->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							  OPERATION_CLASS_ARGUMENT,
							  MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable =
		pPlot_k->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	  if(isSerialManual) {
		if( ! isPlotMotorizable) {
		  isDone = App_FloatEQ(percentDone, (float)1.)
		    	|| App_FloatEQ(percentDone, (float)-1.); // + JPR 130220
//printf("\n'%s' %d percentDone = %f isDone = %d", pPlot_k->InstanceName(), isPlotMotorizable, percentDone, isDone);
		}
	  }
	  else  if(isPlotMotorizable) {
		isDone = App_FloatEQ(percentDone, (float)1.)
		      || App_FloatEQ(percentDone, (float)-1.); // + JPR 130220
//printf("\n'%s' %d percentDone = %f isDone = %d", pPlot_k->InstanceName(), isPlotMotorizable, percentDone, isDone);
	  }
	}
	else { // Concurrent
	isDone =    App_FloatEQ(percentDone, (float)1.)
	         || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	}
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

//printf("\n'%s'::Body_CP_RegularPhytoTreatments returns %d", pChantier->InstanceName(), result);
  return result;
}
