bool Body_CP_ShootThinnings_Phase2 (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a broyer l'ont ete (condition 1)
//                  OU
//                - le chantier de labours d'automne est fermé (condition 2) 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  //int now = pCurrentSim->Clock();
  //
  // condition 1
  //
  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_SHOOT_THINNED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	//
	// condition 2
	//
	Entity* pAutumnTillages = NULL;
	Entity* pConjunction = pChantier->GetSuperSet();
	pEntityTab pElemTab = pConjunction->GetDepthElementTab(ACTIVITY);
	int nbElem = pElemTab.size();
	for(int k=0;k<nbElem;k++) {
	  Entity* pElem_k = (Entity*)pElemTab.get_element(k);
	  if(pElem_k->IsInstanceOf(CONCURRENT_AUTUMN_TILLAGES)
		 ||
		 pElem_k->IsInstanceOf(SERIAL_AUTUMN_TILLAGES)) {
		pAutumnTillages = pElem_k;
		break;
	  }
	}
	if(pAutumnTillages) {
	  int situation = pAutumnTillages->GetIntVarValue(SITUATION);
//printf("\n'%s'::Body_CP_ShootThinnings_Phase2 situation de '%s': %d", pChantier->InstanceName(), pAutumnTillages->InstanceName(), situation);
	  result = (situation == CLOSED);
	}
	else {
	  printf("\n'%s'::Body_CP_ShootThinnings_Phase2 : pas de chantier AutumTillage trouve !\n", pChantier->InstanceName());
	  exit(0);
	}
  }

//printf("\n'%s'::Body_CP_ShootThinnings_Phase2 returns %d", pChantier->InstanceName(), result);
  return result;
}
