bool Body_OP_PhytoTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
//printf("\nt = %d entree Body_OP_PhytoTreatments pChantier : '%s'", pCurrentSim->Clock(), pChantier->InstanceName());
  Vineyard* pEA = App_GetVineyard((Activity*)pChantier);

  int typeChantier = App_GetDistributedActivitySetType(pChantier);

  //
  // cascade de tests partiels d'ouverture
  // -------------------------------------
  bool result = FALSE;
  bool result_primary = TRUE;
  if(typeChantier != REGULAR_PHYTO) {
	result_primary =            // EXTRA ou ANTI_MILDEW seulement
	  Common_PhytoTreatment_Primary_OpeningPredicate(pChantier);
  }
  if(result_primary) {
	bool result_onDate = 
	  Common_PhytoTreatment_OnDate_OpeningPredicate(pChantier);
	
	if(result_onDate) {
	  //
	  // etabissement date souhaitable (= nominale) de l'intervention
	  // ------------------------------------------------------------
	  int minBegDate = pChantier->GetIntVarValue(MIN_BEG_DATE);
	  int cadence = App_GetIntDecisionOption(pEA, 
										 OPT_PHYTO_TREATMENT_CADENCE);
//printf("\n\ttypeChantier = %d", typeChantier);
//printf("\n\tcadence = %d", cadence);
//printf("\n\tminBegDate = %d", minBegDate);
	  int nominalDate = (float)0.;
	  if((typeChantier == ANTI_MILDIOU)
		 ||
		 (typeChantier == EXTRA_PHYTO)) {
		nominalDate = minBegDate;
	  }
	  else {           // REGULAR_PHYTO
		Entity* pIterate = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
		int iterationIndex = pIterate->GetIntVarValue(REPLICATION_COUNTER);
//printf("\n\titerationIndex = %d", iterationIndex);
		if(iterationIndex == 0)
		  nominalDate = minBegDate;
		else {
		  if(cadence > 0) {                  // par convention "X jours nominalement"
			if(cadence < 15)
			  nominalDate = minBegDate + (cadence / 2)*24 ; // cad last minBegdate + cadence
			else
			  nominalDate = minBegDate + (cadence - 11)*24 ; // 
		  }
		  else {                             // par convention "X jours minimum"
			nominalDate = minBegDate + (-cadence - 8)-24 ; // 
			// parce que le URS a etabli la minBegDate comme la date minimale � laquelle
			// on peut avancer un Regular, compte tenu de l'opportunite d'un AM
		  }
		}
	  }
	  pChantier->SetIntConstValue(ACTIVITY_NOMINAL_DATE, nominalDate);
//printf("\n\tnominalDate = %d", nominalDate);

	  result = 
		Common_PhytoTreatment_WeatherOriented_OpeningPredicate(pChantier);
	}
  }
  if(result) {
	  
	if(typeChantier == REGULAR_PHYTO) {
	  //
	  // etablit AntiMildewScheduled pour AddNewSituatedPhytoTreatment
	  //
	  pChantier->SetEntityArgValue(SET_SCHEDULED_ANTI_MILDEW, 
								   VINEYARD_ARGUMENT, pEA);
	  pChantier->ExecVoidMethod(SET_SCHEDULED_ANTI_MILDEW);
	}
	else if(typeChantier == EXTRA_PHYTO) {  // + JPR 130223
	  Entity* pMother = pChantier->GetSuperSet();
	  Entity* pComposedPrgm = 
		(Entity*)pMother->GetFirstContainer(PHYTO_TREATMENT_COMPOSED_PROGRAM, 
											TRUE);
	  Entity* regularIteration = pComposedPrgm->GetElement(0); // par convention
	  int regularIterationIndex = regularIteration->GetIntVarValue(REPLICATION_COUNTER);
	  pChantier->SetIntConstValue(REGULAR_PHYTO_TREATMENT_INDEX, regularIterationIndex);
	}
	  
	//pChantier->RemoveElements(); // fait dans URS de l'it�ration du chantier
	
	//=================================================
	// creation des activites relatives a chaque parcelle
	//=================================================
	
	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide
	
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots);
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	
	pChantier->ExecPredicate(ADD_NEW_SITUATED_PHYTO_TREATMENTS);
	//     ---------------------------------------------
	
	delete pTerminatedPlots;
	delete pInCoursePlots;

	pChantier->SetIntConstValue(ACTUAL_REALIZATION_BEG_DATE, -9);
  }
//printf("\nt = %d Body_OP_PhytoTreatments pChantier : '%s' returns %d", pCurrentSim->Clock(), pChantier->InstanceName(), result);
  return result;
};
