bool OpeningCondition_SpringTillages (Entity* pChantier, int replicationNumber, int prevTillageClock)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  // ci-dessous - JPR 120730 Dhivine_4.9
  //Entity* pIterate = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
  bool result = FALSE;

  int optionFirst = App_GetIntDecisionOption(pEA, OPT_FIRST_SPRING_TILLAGE_O_P);
  int optionGen = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P);
//printf("\n'%s'::OpeningCondition_SpringTillages (%s, %s)", pChantier->InstanceName(), App_EnumToChar(optionFirst), App_EnumToChar(optionGen));

  int localCase = 3;

  if(optionFirst == INIT_SPRING_TILLAGE) {
	if(optionGen == WEED_COVER)
	  localCase = 1;
  }
  else if(optionFirst == WINTER_RAIN_BASED) {// case WINTER_RAIN_BASED
	if(replicationNumber == 0) // + JPR 130309
	  localCase = 4;  // + JPR 130308 (5.5)
  }
  else {
	// ci-dessous - JPR 120730 Dhivine_4.9
//printf("\n'%s'::OpeningCondition_SpringTillages (%s) replicationNumber = %d", pChantier->InstanceName(), App_EnumToChar(optionGen), replicationNumber);
	if(replicationNumber == 0)
	  localCase = 2;	  
  }

  switch (localCase) {
  case 1 : {
	result = OpeningCondition_SpringTillages_OnWeed(pChantier);
	break;
  }
  case 2 : {
	result = TRUE;
	break;
  }
  case 3 : {
	int option2 = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P_SCOPE);
	float seuil;
	switch (option2) {
	case FARM_SCOPE : {
	  float totalArea = pEA->GetFloatConstValue(AREA_WITH_GRAPEVINE);
	  seuil = totalArea * (float)0.75;
	  break;
	}
	case PLOT_SCOPE : {
	  seuil = (float)2.;
	  break;
	}
	case PLOT_GROUP_SCOPE : {
	  seuil = (float)5.;
	  break;
	}
	}
	int now = pCurrentSim->Clock();
	pEntityTab pPlotList = pEA->GetElementTab();
	int nbPlots = pPlotList.size();
	
	switch (optionGen) {
	case OPTIMIZATION : {
	  //
	  // on ouvre si une surface definie de l'EA est soumise
	  // a une forte pluie dans les 24h precedentes
	  // ---------------------------------------------
	  // Recuperation des stations meteo pour cette EA
	  //
	  Tableau<DescriptedEntity*>* pWSList = new Tableau<DescriptedEntity*>();
	  for(int i=0;i<nbPlots;i++) {
		Entity* pPlot_i = (Entity*)pPlotList[i];
		Entity* pWS_i = pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
		int added = pWSList->push_back_ifnew(pWS_i);
		if(added) {
		  char* pathName_i = pWS_i->GetStringConstValue(PATH_NAME_ATTRIBUTE);
		  float value_i =  // pluie des 24h precedentes, hormis l'heure en cours
			SumUpMemoryFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 24);
//printf("\n\t%s pluie[-1 -24] = %f", pWS_i->InstanceName(), value_i);
		  pWS_i->SetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE, value_i);
		}
	  }
	  //
	  // Tri par pluie decroissante (pour autoriser l'arret
	  // de la boucle qd tout espoir est perdu -cf. 'else')
	  //
	  //pWSList->display_names();
	  SortDown(pWSList, ANONYMOUS_FLOAT_ATTRIBUTE);
	  //pWSList->display_names();
	  
	  float aggregatedArea = (float)0.;
	  float aggregatedRainfall = (float)0.;
	  int nbWS = pWSList->size();
	  for(int k=0;k<nbWS;k++) {
		Entity* pWS_k = (Entity*)pWSList->get_element(k);
		float rainfall_k =
		  pWS_k->GetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE);
		if((k == 0) && (rainfall_k < (float)30.)) {
		  //
		  // si la pluie de la WS la plus pluvieuse est insuffisante
		  // il n'y a plus d'espoir
		  //
		  break;
		}
		pEntityTab* pPlotList_k = new pEntityTab();
		float totalArea_k = (float)0;
		// recuperation liste de parcelles rattachees a cette pWS
		for(int i=0;i<nbPlots;i++) {
		  Entity* pPlot_i = (Entity*)pPlotList[i];
		  if(! strcmp(pPlot_i->GetStringConstValue(LAND_USE), "Vigne")) {
			if(pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE) == pWS_k) {
			  pPlotList_k->push_back(pPlot_i);
			  totalArea_k += pPlot_i->GetFloatConstValue(AREA);
			}
		  }
		}
		// somme de pluie ponderee
		aggregatedRainfall = (aggregatedRainfall * aggregatedArea) 
		  + (rainfall_k * totalArea_k);      // numerateur 
		aggregatedArea += totalArea_k;       // denominateur  
		// nouvelle somme de pluie ponderee :
		aggregatedRainfall = aggregatedRainfall / aggregatedArea;
//printf("\n\taggregatedRainfall = %fmm sur aggregatedArea = %fha", aggregatedRainfall, aggregatedArea);	
		
		if(aggregatedRainfall >= (float)30.) {
		  if(aggregatedArea >= seuil) {
			result = TRUE;
			break;
		  }
		}
		else {
		  // plus aucune chance de satisfaire le critere : ca va
		  // encore baisser avec les pWS suivantes (moins pluvieuses)
		  break;
		}
	  }
	  break;
	}
	case OPPORTUNITY : {
	  printf("\n'%s'::OpeningCondition_SpringTillages cas %s non codé.\n", pChantier->InstanceName(), App_EnumToChar(optionGen));
	  exit(0);
	  break;
	}
	default : {
	  // ci-dessous - JPR 120730 Dhivine_4.9
	  //int prevTillageClock = pIterate->GetIntConstValue(PREVIOUS_REPLICATION_REF_DATE);
//printf("\n'%s'::OpeningCondition_SpringTillages prevTillageClock = %d\n", pChantier->InstanceName(), prevTillageClock);
	  int minNbDays;
	  int dryPeriodLengthThreshold;   // + JPR 130308
	  float rainfallThreshold;
	  switch (optionGen) {
	  case LOW_RAIN_INTENSITY : {   // modif JPR 130225 (3 fois)
		minNbDays = 30; rainfallThreshold = 40.0; dryPeriodLengthThreshold = 1000; break;
	  }
	  case MEDIUM_RAIN_INTENSITY : {
		minNbDays = 21; rainfallThreshold = 30.0; dryPeriodLengthThreshold = 1000; break;
	  }
	  case HIGH_RAIN_INTENSITY : {
		minNbDays = 15; rainfallThreshold = 20.0; dryPeriodLengthThreshold = 1000; break;
	  }
	  case LOW_RAIN_INTENSITY_OR_LONG_DRY_PERIOD : {   // + JPR 130308 (3 fois)
		minNbDays = 30; rainfallThreshold = 40.0; dryPeriodLengthThreshold = 45; break;
	  }
	  case MEDIUM_RAIN_INTENSITY_OR_LONG_DRY_PERIOD : {
		minNbDays = 21; rainfallThreshold = 30.0; dryPeriodLengthThreshold = 45; break;
	  }
	  case HIGH_RAIN_INTENSITY_OR_LONG_DRY_PERIOD : {
		minNbDays = 15; rainfallThreshold = 20.0; dryPeriodLengthThreshold = 45; break;
	  }
	  }
	  //
	  // test sur nb jours mini
	  //
	  if(prevTillageClock > -9) {// 120731
		if(now - prevTillageClock > 24 * dryPeriodLengthThreshold) {// + JPR 130308
		  result = TRUE;	
		  Entity* pIterate = ((Activity*)pChantier)->IsIterated();  // modif JPR 130425 (5.6)
		  if(pIterate) { // normalement vrai
			int currentCounter = pIterate->GetIntVarValue(REPLICATION_IN_DRY_PERIOD_COUNTER);
			pIterate->SetIntVarValue(REPLICATION_IN_DRY_PERIOD_COUNTER, currentCounter+1);
		  }
		}
		else if(now - prevTillageClock > 24 * minNbDays) {
//printf("\n!!!!! seuil de nb de jours (%d) atteint", minNbDays);
		  int option = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P_SCOPE);
		  float areaScope;
		  switch (option) {
		  case FARM_SCOPE : {
			float totalArea = pEA->GetFloatConstValue(AREA_WITH_GRAPEVINE);
			areaScope = totalArea * (float)0.75; break;
		  }
		  case PLOT_SCOPE : {
			areaScope = (float)2.; break;
		  }
		  case PLOT_GROUP_SCOPE : {
			areaScope = (float)5.; break;
		  }
		  }
		  //
		  // test sur quantité de pluie mini sur l'areaScope
		  //
		  float aggregatedArea = (float)0.;
		  for(int k=0;k<nbPlots;k++) {
			Entity* pPlot_k = (Entity*)pPlotList[k];
			if(pPlot_k->GetFloatVarValue(PERCENT_SPRING_TILLED) < 0) continue; // + JPR 120904
			float rainfall_k = 
			  pPlot_k->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_LAST_TILLAGE);
			float area_k = pPlot_k->GetFloatConstValue(AREA);
			
			if(rainfall_k >= rainfallThreshold) {
			  aggregatedArea += area_k;
//printf("\n\t'%s' rainfall_k > %f sur aggregatedArea = %fha / %fHa", pPlot_k->InstanceName(), rainfallThreshold, aggregatedArea, areaScope); // 120904
			  if(aggregatedArea >= areaScope) {
//printf("\n!!!!! seuil de pluie (%f) sur le areascope (%f) atteint", rainfallThreshold, areaScope);
				result = TRUE;	
				break;
			  }
			}
		  }
		}
		else {
//printf("\n!!!!! seuil de nb de jours NON atteint : %d-%d <= 24*%d", now, prevTillageClock, minNbDays);
		}
	  }
	  break; 
	}  // fin default
	}  // fin switch (optionGen)
	break;
  } // fin case 3
  case 4 : {  // + JPR 130308 (5.5)
	pEntityTab pPlotList = pEA->GetElementTab();
	int nbPlots = pPlotList.size();
	int option = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P_SCOPE);
	float areaScope;
	switch (option) {
	case FARM_SCOPE : {
	  float totalArea = pEA->GetFloatConstValue(AREA_WITH_GRAPEVINE);
	  areaScope = totalArea * (float)0.75; break;
	}
	case PLOT_SCOPE : {
	  areaScope = (float)2.; break;
	}
	case PLOT_GROUP_SCOPE : {
	  areaScope = (float)5.; break;
	}
	}
	//
	// test sur quantité de pluie mini sur l'areaScope
	//
	float aggregatedArea = (float)0.;
	float lowRainfallThreshold;
	float highRainfallThreshold;
	int year = pCurrentSim->BeginningDate()->year+1;  // 130309
	Date* dateOP1 = GetDateParameterValue("finCumulPluie", "declenchementSiPluieFaible");
	Date* dateOP2 = GetDateParameterValue("finCumulPluie", "declenchementSiPluieMoyenne");
	Date* dateOP3 = GetDateParameterValue("finCumulPluie", "declenchementSiPluieForte");
	int clockDateOP1 = DateToClockValue(dateOP1->mday, dateOP1->month, year);
	int clockDateOP2 = DateToClockValue(dateOP2->mday, dateOP2->month, year);
	int clockDateOP3 = DateToClockValue(dateOP3->mday, dateOP3->month, year);
	bool readyForOPtesting = FALSE;
	int now = pCurrentSim->Clock();
	float lb = GetRealParameterValue("virtualManager", "lowRainfallThresholdForWinterRainBasedSpringTillage");
	float ub = GetRealParameterValue("virtualManager", "highRainfallThresholdForWinterRainBasedSpringTillage");
	if((now >= clockDateOP1) && (now <= clockDateOP1 + 24)) {
	  lowRainfallThreshold = 0.0;
	  highRainfallThreshold = lb;
	  readyForOPtesting = TRUE;
	}
	else if((now >= clockDateOP2) && (now <= clockDateOP2 + 24)) {
	  lowRainfallThreshold = lb;
	  highRainfallThreshold = ub;
	  readyForOPtesting = TRUE;
	}
	else if((now >= clockDateOP3) && (now <= clockDateOP3 + 24)) {
	  lowRainfallThreshold = ub;
	  highRainfallThreshold = D_FLOATMAX;
	  readyForOPtesting = TRUE;
	}
	if(readyForOPtesting) {
	  for(int k=0;k<nbPlots;k++) {
		Entity* pPlot_k = (Entity*)pPlotList[k];
		if(pPlot_k->GetFloatVarValue(PERCENT_SPRING_TILLED) < 0) continue; // + JPR 120904
		float rainfall_k = 
		  pPlot_k->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_EARLY_WINTER);
		float area_k = pPlot_k->GetFloatConstValue(AREA);
		
		if((rainfall_k >= lowRainfallThreshold)
		   &&
		   (rainfall_k <= highRainfallThreshold)) {
		  aggregatedArea += area_k;
//printf("\n\t'%s' [%f < rainfall_k < %f] sur aggregatedArea = %fha / %fHa", pPlot_k->InstanceName(), lowRainfallThreshold, highRainfallThreshold, aggregatedArea, areaScope); // 120904
		  if(aggregatedArea >= areaScope) {
//printf("\n!!!!! seuil de pluie depuis debut hiver ([%f %f]) sur le areascope (%f) atteint", lowRainfallThreshold, highRainfallThreshold, areaScope); // modif 130425
			result = TRUE;	
			break;
		  }
		}
	  }
	}
	break;
  } // fin case 4

  } // fin switch (localcase)

  // + JPR 120726
  /*  transport 120823 vers le OpeningPrdicate
  if(result == TRUE) {
	Entity* pSTIteration = pChantier->GetSuperSet();
	pSTIteration->SetIntConstValue(PREVIOUS_REPLICATION_REF_DATE, -9);
//printf("\n\t'%s'\t REF_DATE  = -9", pSTIteration->InstanceName());
  }
  */
//printf("\n'%s'::OpeningCondition_SpringTillages(%d, %d) returns %d (%s)", pChantier->InstanceName(),replicationNumber, prevTillageClock, result, App_EnumToChar(optionGen));
  return result;
}
