void assignRelativeAreaToRows_Body(EntityMethod* pM)
//--------------------------------------------------
// repartit la surface de la parcelle entre les quatre types de rangees
//--------------------------------------------------
{
  Entity* pPlot = pM->DescribedEntity();
  float q = 
	pPlot->GetFloatConstValue(RIDING_ORIENTED_INTER_ROW_PROPORTION);
  float p = 
	pPlot->GetFloatConstValue(GRASS_STRIP_ALLEY_WIDTH_RATIO);
  float r = 
	pPlot->GetFloatConstValue(CROP_ROW_ALLEY_WIDTH_RATIO);
  //
  // visite des (4) rangs
  //
  Entity* pVegetal = pPlot->GetComponent(VEGETAL_COMPARTMENT);

  bool isPlotWithGrass = FALSE;
  int nbRows = pVegetal->GetNumberOfElements();
  float prop = (float)0.25;
  for(int i=0;i<nbRows;i++) {
	Entity* pRow_i = pVegetal->GetElement(i);
	switch (i) {
	case 0 : {            // inter-rang stabilise
	  int modality = pRow_i->GetIntConstValue(SOIL_MANAGEMENT_MODALITY); 
	  if (modality == GRASS_COVER){
		isPlotWithGrass = TRUE;
		prop = (p*q);
	  }
	  else {
		prop = (q*(1-r));
	  }
	  break;
	}
	case 1 : {            // inter-rang travaille
	  prop = ((1-r)*(1-q));
	  break;
	}
	case 2 : {            // rang voisin d'un inter-rang stabilise
	  if (isPlotWithGrass) {
		prop = (q*(1+r-p));
	  }
	  else if(q == 1) {
		prop = r;
	  }
	  else {
		prop = (2*q*r);
	  }
	  break;
	}
	case 3 : {          // rang non voisin d'un inter-rang stabilise
	  if (q == 1) { // cas particulier: si que des inter-rangs stabilises pas de rang 3
		prop = 0;
	  }
	  else {
		prop = (r*(1-2*q));
	  }
	  break;
	}
	default : {
	  printf("\nassignRelativeAreaToRows : '%s' nombre de rangees illegal\n", pPlot->InstanceName());
	  exit(0);
	}
	}
	pRow_i->SetFloatConstValue(RELATIVE_AREA, prop);
//printf("\nassignRelativeAreaToRows : '%s'/'%s' = %3.2f\n", pRow_i->InstanceName(), pPlot->InstanceName(), prop);
  }
};
