
void regularPhytoTreatmentsIteration_updateReactivatedSon_Body(EntityMethod* pM)
//---------------------------------------------------------------------------
// Si les conditions d'une nouvelle mise en oeuvre de l'activité itérée
// sont satisfaites, ce sera fait avec les propriétés qui lui sont données
// dans cette fonction.
//---------------------------------------------------------------------------
{
  Entity* pIteration = pM->DescribedEntity();
  Entity* pSon = pIteration->GetElement();
  Vineyard* pEA = App_GetVineyard((Activity*)pIteration);
//printf("\nt=%d DEB '%s'::URS", pCurrentSim->Clock(), pIteration->InstanceName());
  //
  // RAZ des Percent..Treated sur les parcelles a traiter;
  //
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k); 
	// ci-dessous modif JPR 130225 : RAZ sans condition 'isDone'
	pPlot_k->SetFloatVarValue(PERCENT_REGULAR_PHYTO_TREATED, (float)0.);
	//pPlot_k->SetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED, (float)0.);  // +/- JPR 130225
	//pPlot_k->SetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED, (float)0.);  // +/- JPR 130225
  }

  int cadence = App_GetIntDecisionOption(pEA, 
										 OPT_PHYTO_TREATMENT_CADENCE);
  // convention :
  // . -X pour la cadence "X jours minimum"       (e.g. 14 jours minimum)
  // .  X pour la cadence "X jours nominalement"  (e.g. 12 ou 14)

  int prevBegClock =  pSon->GetIntVarValue(BEG_DATE);
//printf("\nDEB '%s'::URS '%s'::prevBegClock = %d (now=%d)\n", pIteration->InstanceName(), pSon->InstanceName(), prevBegClock, pCurrentSim->Clock());
//((Activity*)pSon)->DisplaySituation();
  
  //
  // "X jours nominalement : on ouvre deux jours avant la date nominale de traitement
  // "X jours minimum" : on ouvre a la date nominale de traitement
  //
  int delay;
  int nextBegClock, minBegDate;
  if(cadence > 0) { 
	if(cadence < 15) {
	  delay = (cadence / 2) - 1;
	}
	else {
	  delay = 11 - 1;
	}
  }
  else { 
	delay = 11 - 1;
  } 
  nextBegClock = prevBegClock + (delay+1)*24;
  tm* pTm = ClockValueToTm(nextBegClock);
  //
  // determination heure du UpdateReactivatedSon
  //
  pTm->tm_hour = ReturnManagerWakeUpHour();
  mktime(pTm);
  minBegDate = StructTmToClockValue(pTm);
//printf("\n'%s'::URS '%s'::nextBegClock = %d", pIteration->InstanceName(), pSon->InstanceName(), minBegDate);
  delete pTm;
  pSon->SetIntVarValue(MIN_BEG_DATE, minBegDate);

  pEntityTab* pListeChantiers = new pEntityTab();
  if(pSon->IsInstanceOf(VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN)) {
	pListeChantiers->push_back(pSon->GetElementTab());
  }
  else {  // pSon est un chantier
	pListeChantiers->push_back(pSon);
  }
  //
  // gestion des desallocations : on desalloue les activites
  // issues du dernier selectNewPlots de l'iteration precedente...
  // (on ne desalloue pas ici les operations, parce que les activites
  // primitives iterees, par conception, toutes fermees ; les operations
  // ont donc ete terminees et le moteur les a alors desallouees)
  //
  int nbChantiers = pListeChantiers->size();
  for(int k=0;k<nbChantiers;k++) {
	Activity* pChantier = (Activity*)pListeChantiers->get_element(k);
//pChantier->DisplaySituation();
	//int nbAct = pChantier->GetNumberOfElements();  // modif JPR 120612
	int nbAct = pChantier->GetNumberOfOperands();  // + modif GetOperand
	for(int i=nbAct-1;i>=0;i--) {
	  PrimitiveActivity* pAct = (PrimitiveActivity*)pChantier->GetOperand(i);
	  //
	  // ... sauf la derniere activite fermee, parce que c'est pendant sa
	  // fermeture (et celle du chantier) qu'est invoque le present URS ;
	  // --> ne pas terminer la fermeture sur un objet desalloue !
	  // (sa desallocation sera faite dans le DeallocatePrimitiveActivityTab
	  // en fin de main)
	  //
	  int now = pCurrentSim->Clock();
	  int endDate = pAct->GetIntVarValue(END_DATE);
//printf("\n'%s'::URS '%s'::endDate=%d now=%d", pIteration->InstanceName(), pAct->InstanceName(), endDate, now);
	  if(endDate != now) {
		pAct->DeleteInDepth();
//printf("\nif ");pChantier->DisplaySituation();
	  }
	  //else { // - 120603
		pChantier->RemoveElement(pAct);
//printf("\nelse ");pChantier->DisplaySituation();
	  //}      // - 120603
	}
//pChantier->DisplaySituation();
  }
  delete pListeChantiers;
//((Activity*)pSon)->DisplaySituation();
//printf("\n'FIN %s'::URS '%s'\n", pIteration->InstanceName(), pSon->InstanceName());
};
