int setFlagMildew_Body(EntityMethod* pM)
//--------------------------------------
// etablit le descripteur FlagMildew de la conduite (mildewWarningProcess)
//--------------------------------------
{
  Entity* pConduite = pM->DescribedEntity();

  Vineyard* pVineyard = 
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);

  int now = pCurrentSim->Clock();
  if(pConduite->GetIntConstValue(FLAG_MILDEW) == 1) {
//printf("\nt = %d setFlagMildew_Body  FLAG_MILDEW", now);
	return TRUE;
  }

  Boolean result = FALSE;
  int downyMildewMngt = 
	pConduite->GetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE);
  
  switch (downyMildewMngt) {
  case R0 : {
	int foyersPrimaires = App_GetIntPestInfo(pVineyard, 
											 DOWNY_MILDEW_PRIMARY_INFECTION);
	if(foyersPrimaires == OUI) {
	  //
	  // Recuperation des stations meteo pour cette EA
	  //----------------------------------------------
	  pEntityTab* pWSList = new pEntityTab();
	  pEntityTab pPlotList = pVineyard->GetElementTab();
	  int nbPlots = pPlotList.size();
	  for(int i=0;i<nbPlots;i++) {
		Entity* pPlot_i = (Entity*)pPlotList[i];
		Entity* pWS_i = pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
		pWSList->push_back_ifnew(pWS_i);
	  }
//printf("\nstations meteo :");pWSList->display_names();
	  // parcours des stations
	  // si un pr�sente un total de pluie > S1 et pluie pas trop repartie
	  // alors result = TRUE;
	  int nbWS = pWSList->size();
	  for(int i=0;i<nbWS;i++) {
		Entity* pWS_i = (Entity*)pWSList->get_element(i);
		char* pathName_i = pWS_i->GetStringConstValue(PATH_NAME_ATTRIBUTE);
//printf("\n\tpath : '%s'", pathName_i);
		float cumulPluie_JP3;
		cumulPluie_JP3 = 
		  SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 71)
		  + pWS_i->GetFloatVarValue(RAINFALL);
		pWS_i->ClearFloatTabValues(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY);
		pWS_i->AddFloatValueElement(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
									cumulPluie_JP3);
//Date laDate = ClockValueToDate(pCurrentSim->Clock());
//printf("\n%d-%s-%d %dH ", laDate.mday, MonthToChar(laDate.month), laDate.year, laDate.hour); printf("prevision pluie JP3 '%s' : %5.1f", pWS_i->InstanceName(), cumulPluie_JP3);
	  }
	  delete pWSList;
	  
	  // etablissement indicateur pour l'ensemble des parcelles :
	  // les 2 conditions suivantes doivent �tre respect�es sur une 
	  // au moins une parcelle � traiter :
	  // condition_niv : suffisamment de pluie dans le 3 prochains jours (> seuil fixe)
	  // condition_dis : distribution +- homog�ne sur les 3 jours
	  // ==>
	  // 1 on examine tour a tour chaque parcelle p_i
	  //       on examine le couple de conditions 1 et 2
	  //       SI    C1 et C2 respectees 
	  //       ALORS respectCondition = TRUE
	  //             break
	  //-------------------------------------------------
	  float seuilPluie = gRealParam_virtualManager_rainfallThresholdForPhytoTreatment_;
	  bool respectCondition_niv = FALSE;  // pour trace
	  bool respectCondition_dis = FALSE;  // pour trace
	  for(int i=0;i<nbPlots;i++) {
		Entity* pPlot_i = (Entity*)pPlotList[i];
//printf("\n'%s' ", pPlot_i->InstanceName());
		Entity* pWS_i = pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
		pFloatTab* rainFallVector = 
		  pWS_i->GetFloatTabConstValue(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY);
		float cumulPluie_JP3 = rainFallVector->get_element(0);
		if(cumulPluie_JP3 > seuilPluie) {
		  respectCondition_niv = TRUE; // pour trace
//printf(" respectCondition_niv : %d\n", respectCondition_niv);
		  // examen distribution
		  respectCondition_dis = TRUE;
//printf("\nApp_GetFlagMildew case R0 avec foyersPrimaires : completer l'estimation de la distribution");
		}
		if(respectCondition_niv && respectCondition_dis) {
		  result = TRUE;
		  break;
		}
	  }
	}
	break;
  }
  case S : {
	// result remains FALSE
	break;
  }
  default : {
	int foyersPrimaires = App_GetIntPestInfo(pVineyard, 
											 DOWNY_MILDEW_PRIMARY_INFECTION);
	if(foyersPrimaires == OUI) {
	  result = TRUE;
	}
	else {
	  int downyMildewLevel  = App_GetIntPestInfo(pVineyard, 
												 DOWNY_MILDEW_LEVEL);
	  float downyMildewRisk = App_GetFloatPestInfo(pVineyard, 
												   DOWNY_MILDEW_RISK_LEVEL);
	  // externalisation des seuils (1401)
	  int dmlThreshold = GetIntParameterValue("virtualManager", "downyMildewLevelThresholdForFlagUp");
	  float dmrThreshold = GetRealParameterValue("virtualManager", "downyMildewRiskThresholdForFlagUp");
	  if((downyMildewLevel >= dmlThreshold) && (downyMildewRisk > dmrThreshold)) // == -> >= (1401)
		result = TRUE;
	}
	break;
  }
  }
  pConduite->SetIntConstValue(FLAG_MILDEW, result);

//printf("\n'%s'::SetFlagMildew sets and returns %d", pConduite->InstanceName(), result);
  return result;
};
