bool tillageOperation_feasibilityCondition_Body(EntityMethod* pM) {
//-----------------------------------------------------------------
// M�thode invoqu�e alors que l'activit� est ouverte.
// Doit renvoyer vrai si l'op�ration est maintenant faisable.
//-----------------------------------------------------------------
  Operation* pOt = (Operation*)(pM->DescribedEntity());
//printf("\nentree '%s'::FC", pOt->InstanceName());
  bool result = myFloatAreaOperation_feasibilityCondition_Body(pM);
  if(result == FALSE) {
//printf("\n'%s'::FC returns %d / non trafficalility", pOt->InstanceName(), result);
	return result;
  }

  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nentree '%s'::FC plot '%s'\n", pOt->InstanceName(), pPlot->InstanceName());
  
  //
  // visite des 2 inter-rangs
  //
  Entity* pVegetal = pPlot->GetComponent(VEGETAL_COMPARTMENT);

  int nbRows = pVegetal->GetNumberOfElements();
  float maxHumidity = 0.;
  for(int j=0;j<nbRows;j++) {
	Entity* pRow_j = pVegetal->GetElement(j);
	int modality = pRow_j->GetIntConstValue(SOIL_MANAGEMENT_MODALITY);
	if((j == 0)// inter-rang avec fonction de passage
	   ||
	   (j == 1)) {      // inter-rang toujours nu (labour ou chimie)
	  if(modality == TILLAGE) {
		float humidity_j = pRow_j->ExecFloatMethod(SUM_UP_SOIL_HUMIDITY_VECTOR);
		if(humidity_j < -D_float_EPS) { // pas de couplage avec Mhydas/OpenFluid
		  maxHumidity = (float)-9.0;
		  break;
		}
		if(humidity_j > maxHumidity)
		  maxHumidity = humidity_j;
	  }
	} 
	else {
	  // sans objet
	}
  }
  //
  // test
  //
  float threshold;

  if(maxHumidity < -D_float_EPS) { // pas de couplage avec Mhydas/OpenFluid
	maxHumidity = pOt->GetFloatConstValue(LAST_SEVEN_DAYS_RAINFALL);
	threshold = GetRealParameterValue("workabilityRainMaxThreshold", "tillageOperation");
  }
  else {
	//
	// captage de la periode de l'annee
	//
	Entity* pVineyard = pPlot->GetSuperSet();
	Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	Entity* pARB = pPlan->GetSuperEntity();
	Entity* pMultiPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
	Entity* pWorkerPool = pMultiPool->GetElement(0); // par convention
	Entity* pAnyWorker = pWorkerPool->GetElement(0);
	Entity* pEmploymentPlan = 
	  pAnyWorker->GetEntityConstValue(ANNUAL_EMPLOYMENT_PLAN_ATTRIBUTE);
	int periodIndex = pEmploymentPlan->GetIntVarValue(CURRENT_ELEMENT_INDEX);
//printf("\n\tperiodIndex = %d", periodIndex);
	bool isPeakPeriod = FALSE;
	if((periodIndex == 4)
	   ||
	   (periodIndex == 5))
	  isPeakPeriod = TRUE;
	
	if(! isPeakPeriod) {
	  //
	  // prevision de pluie sur 3 jours
	  //
	  Entity* pWS = pPlot->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
	  char* pathName = pWS->GetStringConstValue(PATH_NAME_ATTRIBUTE);
	  float cumulPluie_JP3 = 
		SumUpPredictionFloatFieldValue(pathName, FLD_RAINFALL, 1, 71)
		+ pWS->GetFloatVarValue(RAINFALL);
//printf("\n\tcumulPluie_JP3 = %4.1f", cumulPluie_JP3);
	  if(cumulPluie_JP3 > (float)10.)
		threshold = GetRealParameterValue("workabilityHumidityMaxThresholdIfRain", "nonPeakPeriod");
	  else
		threshold = GetRealParameterValue("workabilityHumidityMaxThreshold", "nonPeakPeriod");
	}
	else {
	  threshold = GetRealParameterValue("workabilityHumidityMaxThreshold", "peakPeriod");
	}
  }
//printf("\n\t-->maxHumidity = %f\t--> threshold = %3.2f", maxHumidity, threshold);
  if(maxHumidity > threshold)
	result = FALSE;

  if(! result) 
	if(gMyTraceWarnings)
	  printf("\n'%s'::FC returns FALSE / humidite du sol", pOt->InstanceName());
//printf("\n'%s'::FC returns %d", pOt->InstanceName(), result);
  return result;
};
