void App_DeallocatePrimitiveActivities (Activity* pChantier)
//---------------------------------------------
// Description  : desallocation des activites primitives du chantier
// Precondition : 
// Retour       : 
// Comment      : a invoquer lors de la fermeture du chantier
//              : puisqu'il n'y aura pas de MIOS a cause de cette fermeture
//              : et que c'est ce MIOS qui desalloue les primitives presentes
//---------------------------------------------
{
//printf("\nApp_DeallocatePrimitiveActivities('%s')", pChantier->InstanceName());
  pEntityTab pInstList = pChantier->GetDepthElementTab(PRIMITIVE_ACTIVITY);
  int nbInst = pInstList.size();
  for(int k=nbInst-1;k>=0;k--) {
	PrimitiveActivity* pAct = (PrimitiveActivity*)pInstList.get_element(k);
	Entity* pOt = NULL;
	Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
//printf("\n\tpOt en %x", pOt);
	if(pOt) ((Operation*)pOt)->DeleteInDepth();
//printf("\n\t'%s'", pAct->InstanceName());
	pAct->DeleteInDepth();
  }
}
