BasicEntity* Body_BestActivitySetSelector_OnlyOnOperationPriority (EntityMethod* pM)
//---------------------------------------------
// Choisit (et eventuellement modifie) le meilleur jeu d'activites
// parmi des jeux vehicules par l'argument ACTIVITY_SETS_ARGUMENT.
//
// CRITERE 1 : on selectionne le premier venu parmi jes jeux qui
// possede l'activite (l'operation, en fait) de plus forte priorite
//
// ((A1   B   C)  (A2   B   D))
//   25   40  70   30   40  60               <- priorite
// -> on choisit le jeu (A1 B C) parce que 25 < 30
//---------------------------------------------
{
  Entity* pARB = pM->DescribedEntity();
  Entity* pDisjunctionToSort = pM->GetEntityArgValue(ACTIVITY_SETS_ARGUMENT);
  int nbSets = pDisjunctionToSort->GetNumberOfElements();

  BasicEntity* result = NULL;

  //===========================================================================
  // Regle de preference : classement des jeux par ordre croissant de 
  //                       la priorite moyenne des activites du jeu
  //===========================================================================

  Tableau<DescriptedEntity*>* pElemTabCopy = new Tableau<DescriptedEntity*>();
  for(int i=0;i<nbSets;i++) {
	Entity* pSet_i = pDisjunctionToSort->GetElement(i);
	pElemTabCopy->push_back(pSet_i);
	int nbSingle_i = pSet_i->GetNumberOfElements();
	float strongestPriority_i = D_FLOATMAX;
	for(int j=0;j<nbSingle_i;j++) {
	  Entity* pSingle_i_j = pSet_i->GetElement(j);
	  Entity* pInst_i_j = 
		pSingle_i_j->GetEntityConstValue(PRIMITIVE_ACTIVITY_ATTRIBUTE);
	  int priority_i_j = 
		pInst_i_j->GetIntConstValue(ALLOCATION_PRIORITY_DEGREE);
	  if(priority_i_j < strongestPriority_i)
		strongestPriority_i = priority_i_j;
	}
	float priority_i = strongestPriority_i;
//printf("\n\tset[%d] strongest priority = %f", i, priority_i);
	pSet_i->SetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE, priority_i);
  }
  SortUp(pElemTabCopy, ANONYMOUS_FLOAT_ATTRIBUTE);
  pDisjunctionToSort->RemoveElements();
  pDisjunctionToSort->AddElements(*((Tableau<BasicEntity*>*)pElemTabCopy));
  delete pElemTabCopy;

  //===========================================================================
  // Choix final : arbitrairement le premier jeu parmi les survivants
  //===========================================================================

  if(pDisjunctionToSort->GetNumberOfElements() > 0) { 
	result = pDisjunctionToSort->GetElement(0);
  }
  else {
	//result reste NULL
  }

  return result;
}
