bool Body_CP_Trellisings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a "clipper" l'ont ete (condition 1)
//                  OU // abandonné 110210
//                - on a atteint le 15/07 (condition 2) (
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_TRELLISED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

  /* 
  // remarque NK 110210 : "pour trellisings, on peut enlever la cond. sur la
  // date, elle n'est pas tres utile et ca risque de bloquer le clippings."
  if(! result) {
	// renvoyer TRUE ssi on a atteint le 15/07
	// 
	int now = pCurrentSim->Clock();
	tm* pTm = ClockValueToTm(now);
	int month = pTm->tm_mon;
	int year = pTm->tm_year + 1900;
	if(month > 7)    //  sept, etc.
	  year = year + 1;
	delete pTm;
	
	int clockOuverture = DateToClockValue(15, 7, year);
	if(now >= clockOuverture)
	  result = TRUE;
  }
  */

//printf("\n'%s'::Body_CP_Trellisings returns %d", pChantier->InstanceName(), result);
  return result;
}
