bool OpeningCondition_ChemicalWeedings (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_CHEMICAL_WEEDING_O_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year + 1;
  delete pTm;

  switch (option)  {

  case MID_JAN : {
	int clockOuverture = DateToClockValue(15, 1, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case MID_FEB : {
	int clockOuverture = DateToClockValue(15, 2, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case EARLY_MAR : {
	int clockOuverture = DateToClockValue(1, 3, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case MID_MAR : {
	int clockOuverture = DateToClockValue(15, 3, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case END_PRUN_THIN : {
	//
	// on simule ici un Before(And(Prunings, Thinnings), ChemicalWeedings)
	// qu'on ne peut pas installer tel quel dans le plan, parce que lie
	// seulement a la presente option END_PRUN_THIN et pas a MID_JAN, etc.
	// 
	Entity* pThinnings = NULL;
	Entity* pPrunings = NULL;
	result = TRUE;

	int clockOuverture = DateToClockValue(25, 2, year);
	if(now < clockOuverture) {
	  result = FALSE;
	  break;
	}
	
	BasicEntity* pPhaseConjunctivePlan = pChantier->GetSuperSet();
	pEntityTab pElemTab = pPhaseConjunctivePlan->GetElementTab();
	int nbElem = pElemTab.size();
	for(int k=0;k<nbElem;k++) {
	  Entity* pElem_k = (Entity*)pElemTab.get_element(k);
	  if(pElem_k->IsInstanceOf(CONCURRENT_PRUNINGS)
		 ||
		 pElem_k->IsInstanceOf(SERIAL_PRUNINGS)) {
		pPrunings = pElem_k;
		if(pPrunings->GetIntVarValue(SITUATION) != CLOSED) {
		  result = FALSE;
		  break;
		}
	  }
	  if(pElem_k->IsInstanceOf(CONCURRENT_SHOOT_THINNINGS)
		 ||
		 pElem_k->IsInstanceOf(SERIAL_SHOOT_THINNINGS)) {
		pThinnings = pElem_k;
		if(pThinnings->GetIntVarValue(SITUATION) != CLOSED) {
		  result = FALSE;
		  break;
		}
	  }
	  if(pPrunings && pThinnings)
		break;
	}
	break;
  };
  }
//printf("\n'%s'::OpeningCondition_ChemicalWeedings returns %d", pChantier->InstanceName(), result);
  return result;
}
