bool addNewSituatedDebranchings_Body(EntityMethod* pM)
//----------------------------------------------------
// ajoute au chantier d'épamprage des activites sur de nouvelles parcelles
//----------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\naddNewSituatedDebranchings_Body sur '%s'", pChantier->InstanceName());
  //-------------------------------------------------
  // les parcelles en cours d'operation
  // -> argument de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedDebranchings : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des epamprages
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);

  char* manualMotorizedValue;
  if(! strcmp(optionSerPar, "PAR"))
	 manualMotorizedValue = "";
  else {
	if(pChantier->IsInstanceOf(SERIAL_MANUAL_DEBRANCHINGS))
	  manualMotorizedValue = "MANUAL";
	else
	  manualMotorizedValue = "MOTORIZED";
  }
//printf("\n\tmanualMotorizedValue = '%s'", manualMotorizedValue);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a desherber
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_DEBRANCH, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_DEBRANCH,  
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_DEBRANCH,  
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_DEBRANCH, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_DEBRANCH, 
								 MANUAL_MOTORIZED_ARGUMENT,
								 manualMotorizedValue);
  pEntityTab* plotsToDebranchTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_DEBRANCH);
  //  ----------------------------------------------------------
//printf("\n\tplotsToDebranchTab : "); plotsToDebranchTab->display_names(); 
  int nbPlots = plotsToDebranchTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToDebranchTab->get_element(i);
	pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
						  OPERATION_CLASS_ARGUMENT,
						  MOTORIZED_SPRAYING_OPERATION);
	bool isPlotMotorizable =
	  pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable/MOTORIZED_SPRAYING = %d", isPlotMotorizable);
    Activity* pAct;
	//
	// creation d'une activite d'epamprage
	//
	//
	int modality = 
	  App_GetIntDecisionOption(pVineyard, OPT_DEBRANCHING_MODALITY);
	bool isPureChem = (modality == PART_CHEM) || (modality == WHOLE_CHEM);
	bool isPureMeca = (modality == PART_MECA) || (modality == WHOLE_MECA);
	bool isMixed = (modality == PART_MECA_CHEM) || (modality == WHOLE_MECA_CHEM);
	Entity* pVariety = 
	  pPlot->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
	int shootIntensity = pVariety->GetIntConstValue(SHOOT_INTENSITY);

	if(! strcmp(optionSerPar, "SER")) {
	  if(! strcmp(manualMotorizedValue, "MOTORIZED")) {  
		pAct = new MotorizedChemicalDebranchingActivity(pVineyard);
		// l'activite MotorizedMecanicalDebranchingActivity n'est pas encore
		// introduite dans la base
	  }
	  else {                         // "MANUAL"
		if(isPureChem) { 
		  pAct = new ManualChemicalDebranchingActivity(pVineyard);
		}
		else if(isPureMeca) { 
		  pAct = new ManualMechanicalDebranchingActivity(pVineyard);
		}
		else if(isMixed) {
		  if(shootIntensity < 2) {
			pAct = new ManualMechanicalDebranchingActivity(pVineyard);
		  }
		  else { 
			pAct = new ManualChemicalDebranchingActivity(pVineyard);
		  }
		}		
	  }
	}
	else {                          // "PAR"
	  if(isPureChem) {
		if(isPlotMotorizable)
		  pAct = new MotorizedChemicalDebranchingActivity(pVineyard);
		else
		  pAct = new ManualChemicalDebranchingActivity(pVineyard);
	  }
	  else if(isPureMeca) { 
		pAct = new ManualMechanicalDebranchingActivity(pVineyard);
	  }
	  else if(isMixed) {
		if(isPlotMotorizable && (shootIntensity == 2))
		  pAct = new MotorizedChemicalDebranchingActivity(pVineyard);
		else { 
		  if(isPlotMotorizable)// shootIntensity < 2
			pAct = new ManualMechanicalDebranchingActivity(pVineyard);
		  else                 // shootIntensity == 2
			pAct = new ManualChemicalDebranchingActivity(pVineyard);
		}
	  }		
	}
	//
	// priorite d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewDebranchings sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce Debranching au chantier
	//	
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToDebranchTab;
//printf("\naddNewSituatedDebranchings_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};
