bool addNewSituatedInitSpringTillages_Body(EntityMethod* pM)
//----------------------------------------------------------
// ajoute au chantier de labour de reprise des activites sur de nouvelles parcelles
//----------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> argument de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedInitSpringTillages : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des labours
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a labourer
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL,  
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pEntityTab* plotsToInitSpringTillTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL);
  //  ----------------------------------------------------------
//printf("\n\tplotsToInitSpringTillTab : "); plotsToInitSpringTillTab->display_names(); printf("\n");
//pChantier->DisplaySituation();
  int nbPlots = plotsToInitSpringTillTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToInitSpringTillTab->get_element(i);
    Activity* pAct;
	//
	// creation d'une activite de labour de reprise
	//
	pAct = new InitSpringTillageActivity(pVineyard);
	//
	// priorites d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// coder choix ss-classe d'operation en fonction de la largeur IR
	//
	pAct->SetEntityArgValue(RETURN_TILLAGE_OPERATION_SUBCLASS,
							PLOT_ARGUMENT, pPlot);
	pAct->SetIntArgValue(RETURN_TILLAGE_OPERATION_SUBCLASS,
						 SEASON_ARGUMENT, INITSPRING);
	int otClasId = pAct->ExecIntMethod(RETURN_TILLAGE_OPERATION_SUBCLASS);
	pAct->SetIntVarValue(OPERATION_CLASS_ID, otClasId);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedInitSpringTillages sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce InitSpringTillage au chantier this
	//
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToInitSpringTillTab;
//printf("\naddNewSituatedInitSpringTillages_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};
