void App_AssignIsoAgeingEntityToPlots (Entity* pVineyardSet)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int nbEA = pVineyardSet->GetNumberOfElements();
  for(int i=0;i<nbEA;i++) {
	Entity* pEA_i = pVineyardSet->GetElement(i);
	Entity* pConduite = pEA_i->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	Entity* pARB = pConduite->GetSuperEntity();
	Entity* dec_optionSet //DecisionOptionSet
	  = pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
	char* guidingEarlyVariety = 
	  dec_optionSet->GetStringConstValue(GUIDING_EARLY_VARIETY_ATTRIBUTE);
	char* guidingLateVariety = 
	  dec_optionSet->GetStringConstValue(GUIDING_LATE_VARIETY_ATTRIBUTE);


	int nbPlots = pEA_i->GetNumberOfElements();
	for(int j=0;j<nbPlots;j++) {
	  Entity* pPlot_i_j = pEA_i->GetElement(j);

	  Entity* variety_i_j = 
		pPlot_i_j->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
	  Entity* ws_i_j = 
		pPlot_i_j->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);

	  char* thisVarietyName = variety_i_j->InstanceName();
	  int isEarly = ! strcmp(thisVarietyName, guidingEarlyVariety);
	  int isLate  = ! strcmp(thisVarietyName, guidingLateVariety);
	  if(isEarly || isLate) {
		//
		// recherche d'une IsoAgeingEntity deja instanciee
		//
		pEntityTab* IAE_list = GetEntityList(ISO_AGEING_ENTITY);
		int nbIAE = IAE_list->size();
		Entity* pIAE = NULL;
		for(int k=0;k<nbIAE;k++) {
		  Entity* pIAE_k = (Entity*)IAE_list->get_element(k);
		  bool sameWS = 
			(ws_i_j == pIAE_k->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE));
		  bool sameVariety = 
			(variety_i_j == pIAE_k->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE));
		  if(sameWS && sameVariety) {
			pIAE = pIAE_k;
			break;
		  }
		}
		//
		// si recherche infructueuse, alors instantiation d'une nouvelle
		//
		if(! pIAE) {
		  pIAE = new IsoAgeingEntity();
//printf("\n'%s' : instanciation de '%s'", pPlot_i_j->InstanceName(), pIAE->InstanceName());
		  pIAE->SetEntityConstValue(WEATHER_STATION_ATTRIBUTE, ws_i_j);
		  pIAE->SetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE, variety_i_j);
		}
		else {
//printf("\n'%s' : on a trouve '%s'", pPlot_i_j->InstanceName(), pIAE->InstanceName());
		}
		pEA_i->AddEntityValueElement(ISO_AGEING_ENTITY_SET_ATTRIBUTE,
									 pIAE);
		Entity* pVegetalComp = pPlot_i_j->GetComponent(VEGETAL_COMPARTMENT);
		Entity* pCropRow;
		pCropRow= pVegetalComp->GetElement(2);
		pCropRow->GetComponent(GRAPEVINE)->SetEntityConstValue(ISO_AGEING_ENTITY_ATTRIBUTE, pIAE);
		pCropRow = pVegetalComp->GetElement(3);
		pCropRow->GetComponent(GRAPEVINE)->SetEntityConstValue(ISO_AGEING_ENTITY_ATTRIBUTE, pIAE);
		
	  }
	  else {
		// pas de recherche/instantiation de IsoAgeingEntity :
		// pPlot_i_j, non porteuse d'une variete-guide, ne sera jamais
		// "interrogee" sur le stade atteint (via une  IsoAgeingEntity)
//printf("\n'%s' : variete pas guide", pPlot_i_j->InstanceName());
	  }
	}
  }
}
