float App_GetAlreadyChosenActivitiesDuration (pEntityTab* pInCoursePlots, Entity* pChantier, char* optionSerPar, char* manualMotorizedValue, float passedRowFrequency, float manualNominalSpeed, float motorizedNominalSpeed)
//---------------------------------------------
// Description  : renvoie la prévision de la durée consommée par les opérations
//              : en cours
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float result = (float)0.0;
  UserClassId chantierClassId = pChantier->ClassId();

  UserClassId otClassId = -9; // valeur par défaut pour les chantiers SerialManual

  int nbAlreadyChosen = pInCoursePlots->size();
  for(int i=0;i<nbAlreadyChosen;i++) {
	Entity* pPlot_i = (Entity*)pInCoursePlots->get_element(i);
	float percentAchieved = (float)0.;
	switch (chantierClassId) {
	case SERIAL_PLANTATIONS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_PLANTED);
		otClassId = PLANTATION_OPERATION; break;}
	case SERIAL_FERTILIZATIONS :
	case CONCURRENT_FERTILIZATIONS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_FERTILIZED); 
		otClassId = FERTILIZATION_OPERATION; break;}
	case SERIAL_PRUNINGS :
	case CONCURRENT_PRUNINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_PRUNED); 
		otClassId = PRUNING_OPERATION; break;}
	case SERIAL_SHOOT_THINNINGS :
	case CONCURRENT_SHOOT_THINNINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED); 
		otClassId = SHOOT_THINNING_OPERATION; break;}
	case SERIAL_AUTUMN_TILLAGES : 
	case CONCURRENT_AUTUMN_TILLAGES : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_AUTUMN_TILLED); 
		otClassId = TILLAGE_OPERATION; break;}
	case SERIAL_WINTER_TILLAGES :
	case CONCURRENT_WINTER_TILLAGES : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_WINTER_TILLED);  
		otClassId = TILLAGE_OPERATION; break;}
	case SERIAL_INIT_SPRING_TILLAGES :
	case CONCURRENT_INIT_SPRING_TILLAGES : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_INIT_SPRING_TILLED);  
		otClassId = TILLAGE_OPERATION; break;}
	case SERIAL_SPRING_TILLAGES :
	case CONCURRENT_SPRING_TILLAGES : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_SPRING_TILLED);  
		otClassId = TILLAGE_OPERATION; break;}  

	case SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_REGULAR_PHYTO_TREATED); break;} // modif JPR 130130
	case SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS :
	case CONCURRENT_REGULAR_PHYTO_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_REGULAR_PHYTO_TREATED);    
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

	case SERIAL_EXTRA_PHYTO_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED); break;} // modif JPR 130130
	case CONCURRENT_EXTRA_PHYTO_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED);     
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

	case SERIAL_ANTI_MILDEW_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED); break;} // modif JPR 130130
	case CONCURRENT_ANTI_MILDEW_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED);     
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

 	case SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_SPRING_WEEDED); break;}
	case SERIAL_MOTORIZED_SPRING_CHEMICAL_WEEDINGS :
	case CONCURRENT_SPRING_CHEMICAL_WEEDINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_SPRING_WEEDED);      
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

	case SERIAL_MANUAL_CHEMICAL_WEEDINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_WEEDED); break;}
	case SERIAL_MOTORIZED_CHEMICAL_WEEDINGS :
	case CONCURRENT_CHEMICAL_WEEDINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_WEEDED);     
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

	case SERIAL_MANUAL_DEBRANCHINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_DEBRANCHED);break;}
	case SERIAL_MOTORIZED_DEBRANCHINGS :
	case CONCURRENT_DEBRANCHINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_DEBRANCHED);       
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

	case SERIAL_CLIPPINGS :
	case CONCURRENT_CLIPPINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_CLIPPED);  
		otClassId = CLIPPING_OPERATION; break;}
	case SERIAL_TRELLISINGS :
	case CONCURRENT_TRELLISINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_TRELLISED);  
		otClassId = TRELLISING_OPERATION;  break;}
	default : {
	}
	}
	float duration_i = App_GetExpectedDuration(pPlot_i,
											   FALSE, // isPlotMotorizable
											   otClassId,
											   optionSerPar,
											   manualMotorizedValue, 
											   passedRowFrequency,
											   manualNominalSpeed,
											   motorizedNominalSpeed)
	  * ((float)1. - percentAchieved);
	result+= duration_i;
  }
//printf("\nalreadyChosenDuration = %f", result);
  return result;
}
