bool Body_CP_SpringTillages (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a labourer l'ont ete (condition 1)
//                  OU (modif JPR 120730)
//                - même si toutes les parcelles ne sont pas faites, on ferme
//                  le chantier si le suivant demande à être ouvert
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
//((Activity*)pChantier)->DisplaySituation();
//printf("\nDEB '%s'::Body_CP_SpringTillages", pChantier->InstanceName());
  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_SPRING_TILLED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	// ci-dessous modif JPR 120730 Dhivine_4.9
	Entity* pIterate = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION,
													FALSE);
	int currentReplicationNumber 
	  = pIterate->GetIntVarValue(REPLICATION_COUNTER);
	int targettedReplicationNumber = currentReplicationNumber + 1; 
	int prevTillageClock = 
	  pIterate->GetIntConstValue(PREVIOUS_REPLICATION_REF_DATE);
	result = OpeningCondition_SpringTillages(pChantier,
												targettedReplicationNumber,
												prevTillageClock);
  }

//printf("\n'%s'::Body_CP_SpringTillages returns %d", pChantier->InstanceName(), result);
  return result;
}
