bool OpeningCondition_SpringChemicalWeedings (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_SPRING_CHEMICAL_WEEDING_O_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  delete pTm;
  switch (option)  {
	
  case END_DEBR : {
	bool allDone = TRUE;
	Entity* pEA = App_GetVineyard((Activity*)pChantier);
	int nbPlots = pEA->GetNumberOfElements();
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float percentDone = pPlot_k->GetFloatVarValue(PERCENT_DEBRANCHED);
	  int isDone =    App_FloatEQ(percentDone, (float)1.)
		           || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	  if(! isDone) {
		allDone = FALSE;
		break;
	  }
	}
	if(allDone)
	  result = TRUE;
	break;
  }
  case EARLY_JUN : {
	if(month > 7)       // sept, etc.
	  year = year + 1;
	int clockOuverture = DateToClockValue(01, 06, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case NONE : {
	int nbPlots = pEA->GetNumberOfElements();
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  pPlot_k->SetFloatVarValue(PERCENT_SPRING_WEEDED, (float)-1.);
	}
	break;
  }
  default : {
	printf("\n'%s'::OpeningCondition_SpringChemicalWeedings option inconnue : %d", pChantier->InstanceName(), option);
  }
	
  }
//printf("\n'%s'::OpeningCondition_SpringChemicalWeedings returns %d", pChantier->InstanceName(), result);
  return result;
}
