bool addNewSituatedShootThinnings_Body(EntityMethod* pM)
//------------------------------------------------------
// ajoute au chantier de broyage des activites sur de nouvelles parcelles
//------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> argument de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedShootThinnings : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Vineyard* pVineyard = (Vineyard*)App_GetVineyard((Activity*)pChantier);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());
  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
//printf("\n\tpConduite : '%s'", pConduite->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des broyages
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a broyer
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_SHOOT_THIN, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_SHOOT_THIN,  
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_SHOOT_THIN,  
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_SHOOT_THIN, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pEntityTab* plotsToShootThinTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_SHOOT_THIN);
  //  ----------------------------------------------------------
//printf("\n\tplotsToShootThinTab : "); plotsToShootThinTab->display_names(); 
  int nbPlots = plotsToShootThinTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  int numPhase = App_GetPhaseIndex((Activity*)pPhasicPlan) + 1;
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToShootThinTab->get_element(i);
    Activity* pAct;
	//
	// creation d'une activite de broyage
	//
	pAct = new ShootThinningActivity(pVineyard);
	//
	// priorites d'allocation
	//
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// coder choix ss-classe d'operation en fonction de la largeur IR
	//
	pAct->SetEntityArgValue(RETURN_SHOOT_THINNING_OPERATION_SUBCLASS,
							PLOT_ARGUMENT, pPlot);
	int otClasId = pAct->ExecIntMethod(RETURN_SHOOT_THINNING_OPERATION_SUBCLASS);
	pAct->SetIntVarValue(OPERATION_CLASS_ID, otClasId);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedShootThinnings '%s' sur '%s' pPlot : '%s'", pAct->InstanceName(), pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce ShootThinning au chantier this
	//	
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  /* essai 120615
  pEntityTab pTmpTab = pChantier->GetDepthElementTab(ACTIVITY_MEETING_ANY);
  Activity* pLastAny = (Activity*)pTmpTab.get_nth(pTmpTab.size()-1);
  if(nbPlots == 0) {
	printf("\npnbPlots == %d --> LastAny : '%s'  <- WAITING", nbPlots, pLastAny->InstanceName());
	pLastAny->SetIntVarValue(SITUATION, WAITING);
	pLastAny->GetElement(0)->SetIntVarValue(SITUATION, WAITING);
  }
  else  {
	printf("\npnbPlots == %d --> LastAny : '%s'  <- WAITING", nbPlots, pLastAny->InstanceName());
	pLastAny->SetIntVarValue(SITUATION, SLEEPING);
	pLastAny->GetElement(0)->SetIntVarValue(SITUATION, SLEEPING);
  }
  */
  delete plotsToShootThinTab;
  //pChantier->DisplaySituation();
//printf("\naddNewSituatedShootThinnings_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};
