void grapevineAgeingProcess_goOneStepForwardProcess_Body(ProcessMethod* pM)
//---------------------------------------------
// Definition de la fonction qui code l'avancee du processus continu.
//---------------------------------------------
{
  ContinuousProcess* pCP = pM->DescribedContinuousProcess();
  Entity* pVegetation = pCP->ProcessedEntity();
  //
  // etablissement du jour julien courant
  //
  int currentClock = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(currentClock);
  int currentJulianDay = pTm->tm_yday;
  //
  // examen du stade courant ...
  //
  Entity* pAge = pVegetation->GetEntityConstValue(AGE_ATTRIBUTE);
  pEntityTab* pStageTab = pAge->GetEntityTabConstValue(STAGE_TAB);

  int currentIndex = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
  Entity* pCurrentStage = (Entity*)pStageTab->get_element(currentIndex);
  int jourAtteinteCurrentStage = pCurrentStage->GetIntConstValue(DAY_OF_ACHIEVEMENT);
//printf("\njourAtteinteCurrentStage = %d", jourAtteinteCurrentStage);

  int nextStageIndex = currentIndex + 1;
  if(currentIndex == pStageTab->size()-1) {
    nextStageIndex = 0;
  }
  Entity* pNextStage = (Entity*)pStageTab->get_element(nextStageIndex);
  int jourAtteinteNextStage = pNextStage->GetIntConstValue(DAY_OF_ACHIEVEMENT);
//printf("\njourAtteinteNextStage    = %d", jourAtteinteNextStage);
  //
  // culture perenne : retour au premier stade si le dernier est atteint
  //
  int seuilAtteinte = jourAtteinteNextStage;
  if(currentJulianDay > jourAtteinteNextStage)
    seuilAtteinte = jourAtteinteNextStage + 366;
  //
  // recherche de la somme de degres-jours a atteindre quand on est : 
  //  au stade FLO, VER ou MAT 
  // et recherche de la somme de degres-jours actuelle
  //

  if((currentIndex >= 0) && (currentIndex<3)){

    float thermalTimeFromBbkToAchieve = pNextStage->GetFloatConstValue(THERMAL_TIME_FROM_BBK_TO_ACHIEVE);
    float currentThermalTimeFromBbk = pAge->GetFloatVarValue(THERMAL_TIME_FROM_BBK);

    if((currentIndex == 2) 
       && 
       (currentJulianDay>335)){
      pAge->SetIntVarValue(CURRENT_STAGE_INDEX, nextStageIndex);
//printf("\n nextStageIndex= %d", nextStageIndex);
    }
    if(currentThermalTimeFromBbk > thermalTimeFromBbkToAchieve) {
      pAge->SetIntVarValue(CURRENT_STAGE_INDEX, nextStageIndex);
    }
  }
  //
  // ou si stade maturite, stade recolte atteint quand j = jMat+1
  //
  else if(currentIndex == 3) {
    int dayWhenAchieved = pCurrentStage->GetIntVarValue(DAY_WHEN_ACHIEVED);
    if(currentJulianDay == dayWhenAchieved + 1){
//printf("\n currentJulianDay = %d dayWhenAchieved =%d", currentJulianDay,dayWhenAchieved);
	pAge->SetIntVarValue(CURRENT_STAGE_INDEX, nextStageIndex);
    }
  }
  //
  // ... ou changement de stade si sa date d'atteinte pleine est depassee
  // ou si somme degres-jour atteinte
  //

//printf("\ncurrentJulianDay = %d seuil = %d (jourAtteinteNextStage = %d)\n", currentJulianDay, seuilAtteinte, jourAtteinteNextStage);
  else if((currentIndex == 4)
	  &&
	  (currentJulianDay>jourAtteinteNextStage)) {
    int dayWhenAchieved = pCurrentStage->GetIntVarValue(DAY_WHEN_ACHIEVED);
    if(currentJulianDay == dayWhenAchieved + 1){
	pAge->SetIntVarValue(CURRENT_STAGE_INDEX, nextStageIndex);
    }
  }
  else if(currentJulianDay >= seuilAtteinte) {
    pAge->SetIntVarValue(CURRENT_STAGE_INDEX, nextStageIndex);
    

//printf("\n%d/%d/%d (jour %d) passage du stade '%s' au stade '%s'",
//       pTm->tm_mday, pTm->tm_mon+1, pTm->tm_year+1900, currentJulianDay,
//       pCurrentStage->GetStringConstValue(STAGE_NAME),
//       pNextStage->GetStringConstValue(STAGE_NAME));
  }
  delete pTm;
};
