RegularPhytoTreatmentsIteration::RegularPhytoTreatmentsIteration(Vineyard* pEA, char* optionSerPar) {
// =========================================================
// Une classe de Entity : 'RegularPhytoTreatmentsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(REGULAR_PHYTO_TREATMENTS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new DownyMildewPressure();         AddConstantDescriptor(pD);
  pD = new DownyMildewToClose();          AddConstantDescriptor(pD);
  pD = new PowderyMildewToClose();        AddConstantDescriptor(pD);
  Method* pM;
  pM = new AntiPowderyMildewClosingPredicate();AddMethod (pM);
  pM = new AntiDownyMildewAtLeastClosingPredicate();AddMethod (pM);
  pM = new AntiDownyMildewUnderPressureClosingPredicate();AddMethod (pM);
  AssignBody(UPDATE_REACTIVATED_SON, regularPhytoTreatmentsIteration_updateReactivatedSon_Body);
  AssignBody(OPENING_PREDICATE, regularPhytoTreatmentsIteration_openingPredicate_Body);
  AssignBody(CLOSING_PREDICATE, regularPhytoTreatmentsIteration_closingPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Activity* pAct;
  // --------------------------------------------------
  if(! strcmp(optionSerPar, "PAR")) {
	pAct = new ConcurrentRegularPhytoTreatments(pEA);
  }
  else {
	//
	pAct = new VineyardIteratedConjunctiveSubplan();
	Activity* pManualSeq = new SerialManualRegularPhytoTreatments(pEA);
	pAct->AddElement(pManualSeq);
	Activity* pMotorSeq = new SerialMotorizedRegularPhytoTreatments(pEA);
	pAct->AddElement(pMotorSeq);
  }
  // --------------------------------------------------
  AddElement(pAct);
};
