void setScheduledAntiMildew_Body(EntityMethod* pM)
//------------------------------------------------
// pour un chantier ouvert, etablit s'il est programme avec un anti-mildiou
//------------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  Vineyard* pEA = (Vineyard*)pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  //Entity* pIterate = pChantier->GetSuperSet();
  Entity* pIterate = ((Activity*)pChantier)->IsIterated();  // modif JPR 120302
//printf("\tpIterate : '%s'", pIterate->InstanceName());

  int result = FALSE;

  int downyMildewMngt = 
	pConduite->GetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE);
  int powderyMildewMngt = 
	pConduite->GetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE);

  Entity* pARB = pConduite->GetSuperEntity();
  Entity* dec_optionSet //DecisionOptionSet
	= pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
  char* guidingEarlyVarietyName = 
	dec_optionSet->GetStringConstValue(GUIDING_EARLY_VARIETY_ATTRIBUTE);
  Entity* guidingEarlyVariety = 
	GetNamedEntity("grapeVariety", guidingEarlyVarietyName);
  char* guidingLateVarietyName = 
	  dec_optionSet->GetStringConstValue(GUIDING_LATE_VARIETY_ATTRIBUTE);
  Entity* guidingLateVariety = 
	GetNamedEntity("grapeVariety", guidingLateVarietyName); 


  switch (downyMildewMngt) {
  case S : {
	result = TRUE;
	break;
  }
  case R0 : {
	result = FALSE;  // pour clarte
	break;
  }
  case F3 : {
	int rank = pIterate->GetIntVarValue(REPLICATION_COUNTER); // 0, 1, ...
	if(rank < 3)
	  result = TRUE;
	break;
  }
  case F2 : {
	int rank = pIterate->GetIntVarValue(REPLICATION_COUNTER);
	if(rank < 2)
	  result = TRUE;
	break;
  }
  case R1 : {
	int rank = pIterate->GetIntVarValue(REPLICATION_COUNTER);
	if(powderyMildewMngt == G) {
	  if(rank < 1)
		result = TRUE;
	}
	else {
	  if(rank < 2)
		result = TRUE;
	}
	break;
  }
  case RFLO :
  case FFLO : {
	pEntityTab* pLateIsoAgeingAttributeList = 
	  App_GetIsoAgeingEntityList(pEA, guidingLateVariety, NULL);
	int nbElemLate = pLateIsoAgeingAttributeList->size();

	bool allOKForLate = TRUE;
	for(int i=0;i<nbElemLate;i++)  {
	  Entity* pIsoAgeingEntity = 
		(Entity*)pLateIsoAgeingAttributeList->get_element(i);
	  Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
	  int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
	  if(codeStade >= 26) { //fin floraison
		allOKForLate = FALSE;
		break;
	  }
	}
	if(downyMildewMngt == FFLO) {
	  if(allOKForLate)
		result = TRUE;
	}
	else {
	  //
	  // etablissement liste des IsoAgeingEntity relatives aux varietes-guides
	  // (en principe 1 seule Late et 1 seule Early, 
	  //  mais on installe une boucle pour genaralisation possible)
	  //
	  pEntityTab* pEarlyIsoAgeingAttributeList = 
		App_GetIsoAgeingEntityList(pEA, guidingEarlyVariety, NULL);	  
	  int nbElemEarly = pEarlyIsoAgeingAttributeList->size();
	  
	  bool allOKForEarly = TRUE;
	  
	  for(int i=0;i<nbElemEarly;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade <= 18) {       //debut floraison
		  allOKForEarly = FALSE;
		  break;
		}
	  }
	  if(allOKForLate && allOKForEarly)
		result = TRUE;
	}
	delete pLateIsoAgeingAttributeList;
	break;
  }
  }
//printf("\n'%s'::setScheduledAntiMildew -> %d", pChantier->InstanceName(), result);
  pChantier->SetIntConstValue(ANTI_MILDEW_SCHEDULED, result);
};
