void App_Body_mySortActivitySetsInARB (EntityMethod* pM)
//---------------------------------------------
// Description  :  // + JPR 121222
// Precondition : 
// Retour       :
// Comment      : version 130113 avec réduction nb Trt Phyto 
//              : complété par règle 0 (130131)
//---------------------------------------------
{
  Entity* pARB = pM->DescribedEntity();
  Entity* pSetToSort = pM->GetEntityArgValue(ACTIVITY_SET_ARGUMENT);
  int nbSingle = pSetToSort->GetNumberOfElements();
//printf("\nDEB mySort nbSingle = %d\n", nbSingle);
//((InstructionSetConjunction*)pSetToSort)->SpecialDisplay(); printf("\n");

  //===========================================================================
  // Regle 0 : avant l'heure normale de début le matin, que des traitements
  //           (JPR 130131)
  //===========================================================================
  int now = pCurrentSim->Clock();
  tm* pTm  = ClockValueToTm(now);
  int hour = pTm->tm_hour;
  if(hour < GetIntParameterValue("morningUpdateSituation", "normalHour")) {
	pEntityTab* tmp  = new pEntityTab();
	for (int k=nbSingle-1;k>=0;k--) {
	  SingleInstructionSet* pSingle = (SingleInstructionSet*)(pSetToSort->GetElement(k));
	  PrimitiveActivity* pInst = pSingle->GetAct();
//printf("\n\tpInst : %s\n", pInst->InstanceName());
	  UserClassIdTab idTab = pInst->AncestorIds();
	  idTab.push_back(pInst->ClassId());
	  if(GetPosition(idTab, PHYTO_TREATMENT_ACTIVITY) >= 0) {
		tmp->push_front(pSingle);
	  }
	  else nbSingle--;
		
	}
	pSetToSort->RemoveElements();
//tmp->display_names();
	pSetToSort->AddElements(*tmp);
	delete tmp;
  }
//printf("\nDEB mySort nbSingle après regle 0  = %d\n", nbSingle);
  delete pTm;

  //===========================================================================
  // Regle 1 : Tri des activites par force de priorite d'allocation 
  //           decroissante
  //===========================================================================
  //===========================================================================
  // Regle 2 générale : reduction combinatoire de l'allocation de ressources
  //          Les specifications MAX interviennent en dernier, 
  //          dans chaque inconsistentSet :
  //   (MAX_1 DISJ_1 MAX_2 ANYONE) --> (DISJ_1 ANYONE MAX_1 MAX_2)
  //===========================================================================
  //===========================================================================
  // Regle 2 spécifique : 
  //         Si le jeu comporte au moins un trellising :
  //         - si "allocation exclusive au trellising" : ([Trt Phyto] Trellisings)
  //         - sinon : jeu en entrée trié  par ordre décroissantde priorité 
  //           d'allocation
  //         Si pas de trellising : jeu en entrée trié  par ordre décroissant
  //         de priorité d'allocation.
  //===========================================================================

  // détection présence Trellising, Trt Phyto
  bool areTrellisings = FALSE;
  bool arePhytoTreatments = FALSE;
  pEntityTab* trellisingTab = new pEntityTab();
  pEntityTab* otherThanTrellisingTab = new pEntityTab();
  pEntityTab* allActivityTab = new pEntityTab();
  pEntityTab* phytoTreatmentTab = new pEntityTab();
  int isTrellisingExclusive = -9; // JPR 130212
  for (int k=nbSingle-1;k>=0;k--) {
    SingleInstructionSet* pSingle = (SingleInstructionSet*)(pSetToSort->GetElement(k));
	allActivityTab->push_front(pSingle);              // toutes
    PrimitiveActivity* pInst = pSingle->GetAct();
	Boolean toPull = FALSE;
	UserClassIdTab idTab = pInst->AncestorIds();
	idTab.push_back(pInst->ClassId());
	if(GetPosition(idTab, TRELLISING_ACTIVITY) >= 0) {
	  areTrellisings = TRUE;
	  trellisingTab->push_front(pSingle);             // Trellising
	  if(isTrellisingExclusive < 0)
		isTrellisingExclusive = 
		  App_GetAllocationExclusivity(pARB, "trellisingActivity");
	}
	else {
	  otherThanTrellisingTab->push_front(pSingle);    // autres que Trellising
	  if(GetPosition(idTab, PHYTO_TREATMENT_ACTIVITY) >= 0) {
		phytoTreatmentTab->push_front(pSingle);       // Trt Phyto
		arePhytoTreatments = TRUE;
	  }
	}
  }
	  
  if(arePhytoTreatments) {
	int nbTreatments = phytoTreatmentTab->size();
	Entity* pConduite = pARB->GetComponent(ACTIVITY);
	Entity* pVineyard = pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
	int maxNbTrtToKeep = App_GetResourceNumberFromDistributedActivitySetClassId(pVineyard, CONCURRENT_REGULAR_PHYTO_TREATMENTS); 
	for(int i=nbTreatments-maxNbTrtToKeep-1;i>=0;i--) {
//printf("\ni = %d maxNbTrtToKeep+i-1 = %d\n", i, maxNbTrtToKeep+i-1);
	  BasicEntity* pSingleToScratch = phytoTreatmentTab->get_element(maxNbTrtToKeep+i);
	  allActivityTab->remove_first(pSingleToScratch);
	  otherThanTrellisingTab->remove_first(pSingleToScratch);
	  //delete pSingleToScratch; // à visiter
	}
  }
//printf("\ntrellisingTab  : ");trellisingTab->display_names();
//printf("\notherThanTrellisingTab  : ");otherThanTrellisingTab->display_names();
//printf("\nphytoTreatmentTab  : ");phytoTreatmentTab->display_names();
//printf("\nallActivityTab  : ");allActivityTab->display_names();
  //
  // reconstitution de la liste des éléments de pSetToSort, version 130313 (5.5)
  //
  pSetToSort->RemoveElements();
  if(areTrellisings) {
	if(isTrellisingExclusive == 1) {
	  if(arePhytoTreatments) {
		pSetToSort->AddElements(*phytoTreatmentTab);
	  }
	  pSetToSort->AddElements(*trellisingTab);
	}
	else {
	  InstructionSetConjunction* ISC_tmp = new InstructionSetConjunction();
	  ISC_tmp->AddElements(*allActivityTab);
	  // tri des autres activités que les éventuels Trellisings
	  ISC_tmp->SortByAllocPriorityThenPushMaxSpecToBack();
	  pSetToSort->AddElements(ISC_tmp->GetElementTab());	
	  delete ISC_tmp;
	}
  }
  else {  // no Trellising
	InstructionSetConjunction* ISC_tmp = new InstructionSetConjunction();
	ISC_tmp->AddElements(*allActivityTab);
	// tri de toutes les activités (sauf éventuellement qq Trt Phyto)
	ISC_tmp->SortByAllocPriorityThenPushMaxSpecToBack();
	pSetToSort->AddElements(ISC_tmp->GetElementTab());	
	delete ISC_tmp;
  }
  delete trellisingTab;
  delete otherThanTrellisingTab;
  delete phytoTreatmentTab;  // + JPR 130113
  delete allActivityTab;  // + JPR 130113
//printf("\nFIN App_Body_mySortActivitySetsInARB");
}
