int App_GetResourceNumberFromDistributedActivitySetClassId(Entity* pVineyard, UserClassId chantierClassId)
//---------------------------------------------
// Description  : renvoie ...
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int result;
  EntitySpec* pES = NULL;
  int isMotorized;;
  pEntityTab* pWorkerList = new pEntityTab();
  pEntityTab* tmp;

  switch (chantierClassId) {
	// toutes activités MANUELLES
  case SERIAL_PLANTATIONS : {
	pES = new ManualWorkerEntitySpec(); 
	pES->ReferentEntity(pVineyard);
	pES->Expand();	// + JPR 130121
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 0; 
	break;
  }
  case SERIAL_PRUNINGS :
  case CONCURRENT_PRUNINGS : {
	pES = new PruningExecutorEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();	// + JPR 130121
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 0; 
	break;
  }
  case SERIAL_TRELLISINGS :
  case CONCURRENT_TRELLISINGS : {
	pES = new GreenWorkExecutorEntitySpec(); 
	pES->ReferentEntity(pVineyard);
	pES->Expand();	// + JPR 130121
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 0; 
	break;
  }

	// toutes activités MOTORISEES
  case SERIAL_FERTILIZATIONS :
  case CONCURRENT_FERTILIZATIONS :
  case SERIAL_SHOOT_THINNINGS :
  case CONCURRENT_SHOOT_THINNINGS :
  case SERIAL_CLIPPINGS :
  case CONCURRENT_CLIPPINGS :
  case SERIAL_AUTUMN_TILLAGES : 
  case CONCURRENT_AUTUMN_TILLAGES :
  case SERIAL_WINTER_TILLAGES :
  case CONCURRENT_WINTER_TILLAGES :
  case SERIAL_INIT_SPRING_TILLAGES :
  case CONCURRENT_INIT_SPRING_TILLAGES :
  case SERIAL_SPRING_TILLAGES :
  case CONCURRENT_SPRING_TILLAGES :
  case SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS :
  case SERIAL_MOTORIZED_SPRING_CHEMICAL_WEEDINGS :
  case SERIAL_MOTORIZED_CHEMICAL_WEEDINGS :
  case SERIAL_MOTORIZED_DEBRANCHINGS : {
	pES = new TractorDriverEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 1;
	break;
  } 

	// activités MIXTES MANUELLES (chimique ou mécanique) + MOTORISEES
  case CONCURRENT_DEBRANCHINGS : {
	pES = new TractorDriverEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	pES = new ManualWorkerEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	pES = new GreenWorkExecutorEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = -1;
	break;
  } 

	// activités MIXTES MANUELLES + MOTORISEES
  case CONCURRENT_REGULAR_PHYTO_TREATMENTS :
  case CONCURRENT_EXTRA_PHYTO_TREATMENTS :
  case CONCURRENT_ANTI_MILDEW_TREATMENTS :
  case CONCURRENT_SPRING_CHEMICAL_WEEDINGS :
  case CONCURRENT_CHEMICAL_WEEDINGS :
  case SERIAL_EXTRA_PHYTO_TREATMENTS :
  case SERIAL_ANTI_MILDEW_TREATMENTS : { 
	pES = new TractorDriverEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	pES = new ManualWorkerEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = -1;
	break;
  }

	// toutes activités MANUELLES
  case SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS :
  case SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS :
  case SERIAL_MANUAL_CHEMICAL_WEEDINGS : {
	pES = new ManualWorkerEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 0;
	break;
  }

	// toutes activités MANUELLES (chimique ou mécanique)
  case SERIAL_MANUAL_DEBRANCHINGS : {
	pES = new ManualWorkerEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	pES = new GreenWorkExecutorEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 0;
	break;
  }
  default : {
	printf("\nApp_GetResourceNumberForDistributedActivitySet ne sait pas gérer le chantier de classe '%ds'\n", ClassIdToCharTab[chantierClassId]);
	exit(0);
  }
  }
  //
  // quantité de ressources dispo pour le travail en parallèle
  // pour le calcul des heures de travail disponibles DTotW
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pMultiPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  
  // nb workers
  int nbWorkers = pWorkerList->size();
  int nbAvailableWorkers = 0;
  for(int i=0;i<nbWorkers;i++) {
	Entity* pMO_i = (Entity*)pWorkerList->get_element(i);
	if(pMO_i->GetIntVarValue(AVAILABILITY_STATUS))
	  nbAvailableWorkers++;
  }
  delete pWorkerList;
  
  // nb tractors
  Entity* pEquipmentPool = pMultiPool->GetElement(1); // par convention
  int nbTractors = pEquipmentPool->GetDepthElementTab(TRACTOR).size();

  switch(isMotorized) {
  case 0 : {  // chantiers manuels
	result = nbAvailableWorkers;
	break;
  }
  case 1 :  {  // chantiers motorisés
	result = nbTractors;
	if(nbAvailableWorkers < result)
	  result = nbAvailableWorkers;
	break;
  }
  case -1 : {  // chantiers mixtes
	result = nbAvailableWorkers;
	break;
  }
  }
  
//printf("\nnbAvailableWorkers = %d nbTractors = %d isMotorized = %d -> nbRsc = %d\n", nbAvailableWorkers, nbTractors, isMotorized, result);
};
