bool Body_CP_InitSpringTillages_Phase3 (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si 
//                - plus de parcelles a labourer
//                  OU
//                - une date max a ete atteinte (condition 2)
//                
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_INIT_SPRING_TILLED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	int now = pCurrentSim->Clock();
	tm* pTm = ClockValueToTm(now);
	int month = pTm->tm_mon;
	int year = pTm->tm_year + 1900;
	if(month > 7)       // sept, etc.
	  year = year +1;
	delete pTm;
	int clockOuverture; 

	int option = App_GetIntDecisionOption(pEA, OPT_FIRST_SPRING_TILLAGE_O_P);
	switch (option) {
	case INIT_SPRING_TILLAGE : {
	  result = FALSE;
	  break;
	}
	case EARLY_MAR : {
	  clockOuverture = DateToClockValue(1, 3, year);  // 1er mars
	  if(now >= clockOuverture)
		result = TRUE;
	  break;
	}
	case MID_MAR : {
	  clockOuverture = DateToClockValue(15, 3, year);  // 15 mars
	  if(now >= clockOuverture)
		result = TRUE;
	  break;
	}
	case EARLY_APR : {
	  clockOuverture = DateToClockValue(1, 4, year);  // 1er avril
	  if(now >= clockOuverture)
		result = TRUE;
	  break;
	}
	case MID_APR : {
	  clockOuverture = DateToClockValue(15, 4, year);  // 15 avril
	  if(now >= clockOuverture)
		result = TRUE;
	  break;
	}
	default : {
	  printf("\n'%s'_CP option inconnue : %d", pChantier->InstanceName(), option);
	  exit(0);
	  
	} 
	}
  }

//printf("\n'%s'::Body_CP_InitSpringTillages_Phase3 returns %d", pChantier->InstanceName(), result);
  return result;
}
