bool OpeningCondition_InitSpringTillages (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();

  int option = App_GetIntDecisionOption(pEA, OPT_INIT_SPRING_TILLAGE_O_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;	
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year + 1;
  delete pTm;
  switch (option)  {
	
  case MID_JAN : {
	int clockOuverture = DateToClockValue(15, 1, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case EARLY_FEB : {
	int clockOuverture = DateToClockValue(1, 2, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case MID_FEB : {
	int clockOuverture = DateToClockValue(15, 2, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case END_THIN_FERT : {
	result = TRUE;
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float percentThin = pPlot_k->GetFloatVarValue(PERCENT_SHOOT_THINNED);
	  float percentFert = pPlot_k->GetFloatVarValue(PERCENT_FERTILIZED);
	  int isNotThinned =    App_FloatGT(percentThin, (float)-1.)
		              && App_FloatLT(percentThin, (float)1.);
	  int isNotFertilized = App_FloatGT(percentFert, (float)-1.)
		              && App_FloatLT(percentFert, (float)1.);
	  if((isNotThinned) || (isNotFertilized)) {
		result = FALSE;
		break;
	  }
	}
	break;
  }
  case END_THIN_CW : {
	result = TRUE;
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float percentThin = pPlot_k->GetFloatVarValue(PERCENT_SHOOT_THINNED);
	  float percentWeed = pPlot_k->GetFloatVarValue(PERCENT_WEEDED);
	  int isNotThinned =    App_FloatGT(percentThin, (float)-1.)
		              && App_FloatLT(percentThin, (float)1.);
	  int isNotWeeded =     App_FloatGT(percentWeed, (float)-1.)
		              && App_FloatLT(percentWeed, (float)1.);
//printf("\n\t%s percentThin = %f isNotThinned = %d", pPlot_k->InstanceName(), percentThin, isNotThinned);
//printf("\n\t%s percentWeed = %f isNotWeeded = %d", pPlot_k->InstanceName(), percentWeed, isNotWeeded);
	  if((isNotThinned) || (isNotWeeded)) {
		result = FALSE;
		break;
	  }
	}
	break;
  };
  case END_THIN_CW_FERT : {
	result = TRUE;
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float percentThin = pPlot_k->GetFloatVarValue(PERCENT_SHOOT_THINNED);
	  float percentWeed = pPlot_k->GetFloatVarValue(PERCENT_WEEDED);
	  float percentFert = pPlot_k->GetFloatVarValue(PERCENT_FERTILIZED);
	  int isNotThinned = App_FloatGT(percentThin, (float)-1.)
		              && App_FloatLT(percentThin, (float)1.);
	  int isNotWeeded =  App_FloatGT(percentWeed, (float)-1.)
		              && App_FloatLT(percentWeed, (float)1.);
	  int isNotFertilized = App_FloatGT(percentFert, (float)-1.)
		              && App_FloatLT(percentFert, (float)1.);
	  if((isNotThinned) || (isNotWeeded) || (isNotFertilized)) {
		result = FALSE;
		break;
	  }
	}
	break;
  }
  case NONE : {
	int nbPlots = pEA->GetNumberOfElements();
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  pPlot_k->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
	}
	break;
  }
  case WINTER_RAIN_BASED : {  // + JPR 130425 (5.6)
	pEntityTab pPlotList = pEA->GetElementTab();
	int nbPlots = pPlotList.size();
	int option = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P_SCOPE);
	float areaScope;
	switch (option) {
	case FARM_SCOPE : {
	  float totalArea = pEA->GetFloatConstValue(AREA_WITH_TILLED_GRAPEVINE);
	  areaScope = totalArea * (float)0.75; break;
	}
	case PLOT_SCOPE : {
	  areaScope = (float)2.; break;
	}
	case PLOT_GROUP_SCOPE : {
	  areaScope = (float)5.; break;
	}
	}
	//
	// test sur quantité de pluie mini sur l'areaScope
	//
	float aggregatedArea = (float)0.;
	float rainfallThreshold;
	Date* datePrecoce = GetDateParameterValue("finCumulPluie", "declenchementInitSiPluieForte");
	datePrecoce->year = pCurrentSim->BeginningDate()->year+1;
	tm* tmDatePrecoce = StructDateToTm(datePrecoce);
	int clockDatePrecoce = StructTmToClockValue(tmDatePrecoce); 
	delete tmDatePrecoce;
	Date* dateTardive = GetDateParameterValue("finCumulPluie", "declenchementInitSiPluieFaible");
	dateTardive->year = pCurrentSim->BeginningDate()->year+1;
	tm* tmDateTardive = StructDateToTm(dateTardive);
	int clockDateTardive = StructTmToClockValue(tmDateTardive); 
	delete tmDateTardive;

	bool readyForEarlyOPtesting = FALSE;
	bool readyForLateOPtesting = FALSE;
	int now = pCurrentSim->Clock();
	float ub = GetRealParameterValue("virtualManager", "rainfallThresholdForWinterRainBasedInitSpringTillage");
	if((now >= clockDatePrecoce) && (now <= clockDatePrecoce + 24)) {
	  rainfallThreshold = ub;
	  readyForEarlyOPtesting = TRUE;
	}
	else if((now >= clockDateTardive) && (now <= clockDateTardive + 24)) {
	  readyForLateOPtesting = TRUE;
	}
	if(readyForEarlyOPtesting) {
	  for(int k=0;k<nbPlots;k++) {
		Entity* pPlot_k = (Entity*)pPlotList[k];
		if(pPlot_k->GetFloatVarValue(PERCENT_INIT_SPRING_TILLED) < 0) continue;
		float rainfall_k = 
		  pPlot_k->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_EARLY_WINTER_FOR_INITST);
		float area_k = pPlot_k->GetFloatConstValue(AREA);
		if(rainfall_k >= rainfallThreshold) {  // modif JPR 130509 (cf. ValidationDhivine p11
		  aggregatedArea += area_k;
//printf("\n\t'%s' [rainfall_k=%f >= %f] sur aggregatedArea = %fha / %fHa", pPlot_k->InstanceName(), rainfall_k, rainfallThreshold, aggregatedArea, areaScope); // 120904
		  if(aggregatedArea >= areaScope) {
//printf("\n!!!!! seuil de pluie depuis debut hiver pour initst (%f) sur le areascope (%f) atteint", rainfallThreshold, areaScope); // modif 130425
			result = TRUE;	
			break;
		  }
		}
	  }
	}
	else if(readyForLateOPtesting) {
	  result = TRUE;
	}
	break;
  }
  default : {
	printf("\n'%s'::OpeningCondition_InitSpringTillages option inconnue : %d", pChantier->InstanceName(), option);
  }
	
  }

  // + JPR 120726
  if(result == TRUE) {
	Entity* pPhase = pChantier->GetSuperSet();
	Entity* pSTIteration = (Entity*)pPhase->GetClassNamedElement(SPRING_TILLAGES_ITERATION);
//printf("\n\t'%s'\t REF_DATE  = -9", pSTIteration->InstanceName());
	pSTIteration->SetIntConstValue(PREVIOUS_REPLICATION_REF_DATE, -9);
  }
//printf("\n'%s'::OpeningCondition_InitSpringTillages returns %d", pChantier->InstanceName(), result);
  return result;
}
