FarmWorker::FarmWorker() {
// =========================================================
// Une classe de Entity : 'FarmWorker'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FARM_WORKER);
  //SetParentClassId(SINGLE_WORKER); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new IsManager();                   AddConstantDescriptor(pD);
  pD = new AnnualEmploymentPlanAttribute();AddConstantDescriptor(pD);
  pD = new WorkingTimeYearlyUpperBound(); AddConstantDescriptor(pD);
  pD = new WorkingTimeDailyUpperBound();  AddConstantDescriptor(pD);
  pD = new WorkBeginningHour();           AddConstantDescriptor(pD);
  pD = new LastRainfallClock();           AddConstantDescriptor(pD);
  pD = new WorkingTimeYearlyLeft();       AddVariableDescriptor(pD);
  pD = new WorkingTimeDailyLeft();        AddVariableDescriptor(pD);
  pD = new WorkingTimeWeeklyLeft();       AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromWorkBeginning();AddVariableDescriptor(pD);
   TemporaryMonitor->AttachToDescriptor(this, WORKING_TIME_WEEKLY_LEFT);
   TemporaryMonitor->AttachToDescriptor(this, WORKING_TIME_DAILY_LEFT);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  // un descripteur par heritage : AvailabilityTimetableAttribute
  // qui pointe sur une instance de AvailabilityTimetable 
  // (affecte dans updateSeasonCurrentIndexProcess_execProcess_Body)

  // contraintes standard sur les heures de travail
  SetIntConstValue(WORKING_TIME_DAILY_UPPER_BOUND, GetIntParameterValue("standardWorkingTime", "day"));
  SetIntConstValue(WORKING_TIME_YEARLY_UPPER_BOUND, GetIntParameterValue("standardWorkingTime", "year"));

  // contrainte de disponibilite relative au cumul de pluie recue
  // depuis le debut de la journee de travail
  Entity* pCtr = new LowCumulativeRainSuffered();
  AddEntityValueElement(STATE_AVAILABILITY_ATTRIBUTE, pCtr);
};
