float operationNominalDuration_Body(EntityMethod* pM)
//-------------------------------------------------
// returns the previsionnal duration of the operation of a primitive activity
//-------------------------------------------------
{
  float result = (float)0.;
  Entity* pV_alloc  
	= pM->GetEntityArgValue(CANDIDATEENTITYVALUE_ARGUMENT);
  Entity* ooSet = pV_alloc->GetComponent(ALLOCATED_OPERATED_OBJECT_SET);
  int nbOO = ooSet->GetNumberOfElements();
  //
  // pas d'objets operes encore alloues : duree nulle
  //
  Entity* pInst = pM->DescribedEntity();
  if(nbOO > 0) {
	Entity* otSpec = pInst->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	int now = pCurrentSim->Clock();
	if(!otSpec) {
	  //
	  // pas de specification d'operation :
	  // - si specification necessaire (cas general) : arret simulation
	  // - si specification non necessaire : on renvoie -9
	  //
	  int otSpecNotRequired  = pInst->GetIntConstValue(NO_OPERATION_SPEC);
	  if(! otSpecNotRequired)
		App_Exception(ERR_NO_OT_SPEC, now, pInst);
	  else
		result = -9;
	} 
	else {
	  Entity* pOt = otSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  UserDescriptorId qtyDescId = pOt->GetIntConstValue(QUANTITY_DESCRIPTOR_ID);
	  int opEntityId = pOt->GetIntConstValue(OPERATED_ENTITY_ID);

	  int nbInvolvedEntities = 0;
	  pEntityTab* ooList = new pEntityTab();
	  for(int k=0;k<nbOO;k++) {
		Entity* pObj_k = ooSet->GetElement(k);
		Entity* oo = pObj_k->GetEntityConstValue(RESOURCE_ENTITY);
		if(oo->IsInstanceOf(opEntityId))
		  ooList->push_back(oo);
		else
		  ooList->push_back(oo->GetDepthElementTab(opEntityId));
	  } 
//printf("\n\tooList : ");ooList->display_names();
	  int nbOO = ooList->size();
	  float totalQty = (float)0.;
	  for(int j=0;j<nbOO;j++) {
		Entity* pOO = (Entity*)ooList->get_element(j);
		totalQty += pOO->GetFloatConstValue(qtyDescId);
	  }
	  delete ooList;
	  float speed  = ((FloatQuantityGranulatedOperation*)pOt)->GetFloatQuantitySpeed();
//printf("\n\ttotalQty = %f\tspeed = %f\ttotalQty/speed = %f", totalQty, speed, totalQty / speed);
	  result = ceil(totalQty / speed);
	}
  }
//printf("\noperationNominalDuration_Body pour '%s' returns %f", pInst->InstanceName(), result);
  return result;
};
