BasicEntity* returnSoilManagementGroupOnProfile_Body(EntityMethod* pM)
//--------------------------------------------------------
// renvoie le groupe de gestion en fonction des proprietes de la parcelle
//--------------------------------------------------------
{
  Entity* pPlot = pM->DescribedEntity();
  BasicEntity* result = NULL;  // SoilManagementGroup

  char* soilManagementGroupSet = 
	pM->GetStringArgValue(MANAGEMENT_GROUP_SET_ARGUMENT);
  
  Entity* pSMGroupSet = GetNamedEntity(SOIL_MANAGEMENT_GROUP_SET, 
									soilManagementGroupSet);
  int nbGroups = pSMGroupSet->GetNumberOfElements();

  for (int i=0;i<nbGroups;i++) {
	//
	// la parcelle pPlot releve-t-elle du groupe de gestion i ?
	//
	Entity* pSMGroup_i = (Entity*)pSMGroupSet->GetElement(i);
	RelationalOperator op_i = (RelationalOperator)pSMGroup_i->GetIntConstValue(PLOT_PROFILE_OPERATOR);
	pDescValueSpecTab* pDVSTab_i = pSMGroup_i->GetDescValueSpecTabValue(PLOT_PROFILE);
	
	int nbDVS_i = pDVSTab_i->size();
	Boolean allDVSsatisfied_i = TRUE;
	for (int k=0;k<nbDVS_i;k++)  {
	  //
	  // le critere k du groupe i est-il satisfait pour la parcelle pPlot .
	  //
	  DescValueSpec* pDVS_i_k = pDVSTab_i->get_element(k);
	  Boolean pDVS_i_k_satisfied = pDVS_i_k->IsInDomain(pPlot);
	  if (op_i == IN) {
		if(! pDVS_i_k_satisfied) {
		  allDVSsatisfied_i = FALSE;
if(gMyTraceWarnings) printf("\npour le groupe '%s' (op IN), le critere '%s' n'est pas satisfait par '%s'", pSMGroup_i->InstanceName(), DescIdToCharTab[pDVS_i_k->GetDescId()], pPlot->InstanceName());
		  break;
		}
		else {
if(gMyTraceWarnings) printf("\npour le groupe '%s' (op IN), le critere '%s' est satisfait par '%s'", pSMGroup_i->InstanceName(), DescIdToCharTab[pDVS_i_k->GetDescId()], pPlot->InstanceName());
		}
	  }
	  else {  // NOT_IN
		if(pDVS_i_k_satisfied) {
		  allDVSsatisfied_i = FALSE;
if(gMyTraceWarnings) printf("\npour le groupe '%s' (op NOT_IN), le critere '%s' est satisfait par '%s'", pSMGroup_i->InstanceName(), DescIdToCharTab[pDVS_i_k->GetDescId()], pPlot->InstanceName());
		  break;
		}
		else {
if(gMyTraceWarnings) printf("\npour le groupe '%s' (op NOT_IN), le critere '%s' n'est pas satisfait par '%s'", pSMGroup_i->InstanceName(), DescIdToCharTab[pDVS_i_k->GetDescId()], pPlot->InstanceName());
		}
	  }
	  if(! allDVSsatisfied_i) {
		break;
	  }
	}
	if(allDVSsatisfied_i) {
	  if(gMyTraceWarnings) printf("\n\t==>le groupe '%s' (op IN) contient la parcelle '%s'", pSMGroup_i->InstanceName(), pPlot->InstanceName());
	  result = pSMGroup_i;
	  break;
	}
  }
  return result;  // SoilManagementGroup*
};
