int updateOffPeriodCurrentIndex_Body(EntityMethod* pM)
//-------------------------------------------------
// modifie l'index pointant sur la periode en cours dans un OffWorkCalendar
//-------------------------------------------------
{
  Entity* pCalendar = pM->DescribedEntity();
  int nbPeriods = pCalendar->GetNumberOfElements();

  int now = pCurrentSim->Clock();
  //
  // currentIndex est initialise a -9 dans le constructeur du pCalendar
  // ==> a l'initialisation de la simulation, le calendrier est parcouru
  //     depuis son debut pour trouver la periode courante
  // ==> ensuite, le calendrier est parcouru a partir de la periode courante
  //
  int currentIndex = pCalendar->GetIntVarValue(CURRENT_ELEMENT_INDEX);
//printf("\nentree updatePeriodCurrentIndex_Body sur '%s' currentIndex = %d\n", pCalendar->InstanceName(), currentIndex);
  //
  // initialisation de l'index en fonction de la date courante
  // (= date de debut de la simulation, puisque l'evenement 
  //  updateSeasonCurrentIndexEvent est lance en t=0, qui invoque la
  //  presente methode dans la methode exec de son processus)
  //
  int candidateIndex = 0;
  for(int i=0;i<nbPeriods;i++) {
	if(currentIndex < 0) {
	  candidateIndex = i;
	}
	else {
	  candidateIndex = currentIndex + 1 + i;
	  if(candidateIndex >= nbPeriods)
		break;
	}
//printf("\n\tau candidateIndex = %d", candidateIndex);
	Entity* pPeriod = pCalendar->GetElement(candidateIndex);
//printf("\tperiod '%s'\n", pPeriod->InstanceName());
	//-------------------------
	//
	// les dates de debut et de fin sont au format aaaa-mm-jj par convention
	//
	char* begValue = pPeriod->GetStringConstValue(BEGINNING_CALENDAR_DATE);
	char* strBeg = strdup(begValue);
	char* yStrBeg = strtok(strBeg, "-");
	char* mStrBeg = strtok(NULL, "-");
	char* dStrBeg = strtok(NULL, "-");
	int yBeg = atoi(yStrBeg);
	int mBeg = atoi(mStrBeg);
	int dBeg = atoi(dStrBeg);
	int clockBeg = DateToClockValue(dBeg, mBeg, yBeg, 0, 0, 0);
	free(strBeg);

	if(now < clockBeg) {
	  currentIndex = candidateIndex - 1;
	  break;
	}
  }
//printf("\n!!! updatePeriodCurrentIndex_Body sur '%s' nouvel index = %d", pCalendar->InstanceName(), currentIndex);
  pCalendar->SetIntVarValue(CURRENT_ELEMENT_INDEX, currentIndex);

  return currentIndex;
};
