bool OpeningCondition_SpringTillages_OnWeed (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P_SCOPE);

  bool result = FALSE;
  
  float areaThreshold;
  switch (option) {
  case FARM_SCOPE : {
	float totalArea = pEA->GetFloatConstValue(AREA_WITH_TILLED_GRAPEVINE);
	areaThreshold = totalArea * (float)0.75;
	break;
  }
  case PLOT_SCOPE : {
	areaThreshold = (float)2.;
	break;
  }
  case PLOT_GROUP_SCOPE : {
	areaThreshold = (float)5.;
	break;
  }
  }

  float cumulCovered = (float)0.;
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);

	float aggregatedGrassCover_p = (float)-9.;
	float aggregatedGrassCover = (float)-9.;
	Entity* pVegetalCompartment = pPlot_k->GetComponent(VEGETAL_COMPARTMENT);
	// rang de passage ---------------------------
	Entity* pRow_k_0 = pVegetalCompartment->GetElement(0);
	int modality_p = pRow_k_0->GetIntConstValue(SOIL_MANAGEMENT_MODALITY);
	if((modality_p == TILLAGE) || (modality_p == MIXED_TILLAGE_CW)) {
	  aggregatedGrassCover_p = 
		pRow_k_0->ExecFloatMethod(SUM_UP_GRASS_COVER_VECTOR);
	}
	// rang travaille ---------------------------
	Entity* pRow_k_1 = pVegetalCompartment->GetElement(1);
	int modality_t = pRow_k_1->GetIntConstValue(SOIL_MANAGEMENT_MODALITY);
	if((modality_t == TILLAGE) || (modality_t == MIXED_TILLAGE_CW)) {
	  float meanGrassCover_t = 
		pRow_k_1->ExecFloatMethod(SUM_UP_GRASS_COVER_VECTOR);
	  float q_k = (float)0.;
	  if(App_FloatGT(aggregatedGrassCover_p, (float)0.)) {
		q_k = pPlot_k->GetFloatConstValue(RIDING_ORIENTED_INTER_ROW_PROPORTION);
		aggregatedGrassCover = (aggregatedGrassCover_p * q_k) 
		                       + (meanGrassCover_t     * (1. - q_k));
	  }
	} 
	else aggregatedGrassCover = aggregatedGrassCover_p;
	//             ---------------------------
	// seulement si la parcelle est suffisamment enherbee
	// on regarde la surface de la parcelle
	float weedThreshold = gRealParam_virtualManager_weedThresholdForTillageOpening_;
	if(aggregatedGrassCover >= weedThreshold) {
	  float surf_k = pPlot_k->GetFloatConstValue(AREA);
	  cumulCovered += surf_k;
	  if(cumulCovered > areaThreshold) {
		result = TRUE;
		break;
	  } 
	}		
  }

  // + JPR 120726
  /*  transport 120823 vers le OpeningPrdicate
  if(result == TRUE) {
	Entity* pSTIteration = pChantier->GetSuperSet();
	pSTIteration->SetIntConstValue(PREVIOUS_REPLICATION_REF_DATE, -9);
//printf("\n\t'%s'\t REF_DATE  = -9", pSTIteration->InstanceName());
  }
  */
//printf("\n'%s'::OpeningCondition_SpringTillages_OnWeed returns %d", pChantier->InstanceName(), result);
  return result;
}
