bool addNewSituatedPhytoTreatments_Body(EntityMethod* pM)
//-------------------------------------------------------
// ajoute au chantier de traitement phyto. des activites sur de nouvelles parcelles
//-------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\naddNewSituatedPhytoTreatments_Body sur '%s'", pChantier->InstanceName());
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> arguments de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedPhytoTreatments : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des traitements
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);

  char* manualMotorizedValue;
  if(! strcmp(optionSerPar, "PAR"))
	 manualMotorizedValue = "";
  else { // modif 120516 4.6
	if(pChantier->IsInstanceOf(SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS))
	  manualMotorizedValue = "MANUAL";
	else if(pChantier->IsInstanceOf(SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS))
	  manualMotorizedValue = "MOTORIZED";
	else
	  manualMotorizedValue = ""; 
  }
//printf("\n\tmanualMotorizedValue = '%s'", manualMotorizedValue);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a traiter
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT, 
							   VINEYARD_ARGUMENT, 
							   pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT, 
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots); 
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT, 
							   SERIAL_PARALLEL_ARGUMENT,
							   optionSerPar);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT, 
							   MANUAL_MOTORIZED_ARGUMENT,
							   manualMotorizedValue);
  pEntityTab* plotsToProtectTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT);
  //  ----------------------------------------------------------
//printf("\n\tplotsToProtectTab : "); plotsToProtectTab->display_names(); 
  int nbPlots = plotsToProtectTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  Boolean headingActInSerialActivitySet = FALSE;
  if(! strcmp(optionSerPar, "SER")
	 &&
	 pChantier->GetNumberOfElements() == 0)
	headingActInSerialActivitySet = TRUE;
  
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToProtectTab->get_element(i);
    Activity* pAct;
	pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
						  OPERATION_CLASS_ARGUMENT,
						  MOTORIZED_SPRAYING_OPERATION);
	bool isPlotMotorizable = pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable = %d", isPlotMotorizable);
	//
	// creation d'une activite de traitement phyto.
	//
	if(! strcmp(optionSerPar, "SER")) { // modif 120516 4.6
	  if(! strcmp(manualMotorizedValue, "MOTORIZED")) {  
		pAct = new MotorizedPhytoTreatmentActivity(pVineyard);
		//pas de 'UserClassId otClassId = xx;" ?
	  }
	  else if(! strcmp(manualMotorizedValue, "MANUAL")) {
		pAct = new ManualPhytoTreatmentActivity(pVineyard);
		//pas de 'UserClassId otClassId = xx;" ?
	  }
	  else {        // manualMotorizedValue : ""
		if(isPlotMotorizable) { 
		  pAct = new MotorizedPhytoTreatmentActivity(pVineyard);
		}
		else {
		  pAct = new ManualPhytoTreatmentActivity(pVineyard);
		}
	  }
	}
	else {
	  // choix manuel/motorise en fonction de plusieurs criteres
	  // mais provisoirement un seul critere : parcelle motorisable ou pas
	  //
	  if(isPlotMotorizable) { 
		pAct = new MotorizedPhytoTreatmentActivity(pVineyard);
	  }
	  else {
		pAct = new ManualPhytoTreatmentActivity(pVineyard);
	  }
	}
	//
	// priorites d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// etablir la liste des produits de traitement
	//
	int typeChantier = App_GetDistributedActivitySetType(pChantier);
	Entity* pComposedProgram = 
	  (Entity*)pChantier->GetFirstContainer(PHYTO_TREATMENT_COMPOSED_PROGRAM,
											TRUE);
	TableauString* list = new Tableau<char*>;
	if(typeChantier == ANTI_MILDIOU) {
	  list->push_back(strdup("anti-mildiou"));
	  pComposedProgram->SetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE,
										 TRUE);
	}
	else if(typeChantier == EXTRA_PHYTO) {
	  list->push_back(strdup("anti-oidium"));
	}
	else {               // REGULAR
	  Entity* pSuperSet = pChantier->GetSuperSet();
	  Entity* pIteration = pSuperSet;
	  if(pSuperSet->IsInstanceOf(VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN)) {
		//
		// cas SERIAL  : iterate(conj(chantierManual, chantierMotorized))
		//         (voir constructeur de RegularPhytoTreatmentsIteration)
		//
		pIteration = pSuperSet->GetSuperSet();
	  }
	  bool powderyMildewToClose 
		= pIteration->GetIntConstValue(POWDERY_MILDEW_TO_CLOSE);
	  if(! powderyMildewToClose)
		list->push_back(strdup("anti-oidium"));


	  int flagMildew = pConduite->GetIntConstValue(FLAG_MILDEW);
	  int antiMildiouScheduled = 
		pChantier->GetIntConstValue(ANTI_MILDEW_SCHEDULED);
	  if((flagMildew == TRUE) || (antiMildiouScheduled == TRUE)) {
		bool downyMildewToClose = pIteration->GetIntConstValue(DOWNY_MILDEW_TO_CLOSE);
		if(! downyMildewToClose) {
		  list->push_back(strdup("anti-mildiou"));
		  pComposedProgram->SetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE,
										   TRUE);
		}
	  }
	  else {
		pComposedProgram->SetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE,
										   FALSE);
	  }
	}
//printf("\n'%s'::PHYTO_TREATMENT_LIST : ", pAct->InstanceName());list->display();
	pAct->SetStringTabConstValue(PHYTO_TREATMENT_LIST, list);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\nt=%d sur pPlot : '%s' : '%s'", pCurrentSim->Clock(), pPlot->InstanceName(), pAct->InstanceName());
	//
	// ajout de ce PhytoTreatment au chantier
	// (seulement si un produit a été désigné)
	//	
	if(list->size() > 0) {
	  //
	  // choix ss-classe d'operation en fonction de ...
	  // (besoin d'avoir attache l'activite au chantier : fait ci-dessus)
	  //
	  // remonté avant l'ajout au chantier (JPR 130129) parce que :
	  // voir dans READ_ME_versions le passage à 5.3
	  //
	  pAct->SetEntityArgValue(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS,
							  PLOT_ARGUMENT, pPlot);
	  pAct->SetEntityArgValue(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS,
							  DISTRIBUTED_ACTIVITY_SET_ARGUMENT, pChantier);
	  pAct->SetIntArgValue(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS,
						   SPRAYER_TYPE_REGULAR_OPTION_ARGUMENT, 
						   App_GetIntDecisionOption (pVineyard, 
													 OPT_SPRAYER_TYPE_REGULAR));
	  pAct->SetIntArgValue(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS,
						   SPRAYER_TYPE_AT_BEGINNING_OPTION_ARGUMENT, 
						   App_GetIntDecisionOption (pVineyard, 
													 OPT_SPRAYER_TYPE_AT_BEGINNING));
	  pAct->SetIntArgValue(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS,
						   SPRAY_NUMBER_AT_BEGINNING_OPTION_ARGUMENT, 
						   App_GetIntDecisionOption (pVineyard, 
													 OPT_SPRAY_NUMBER_AT_BEGINNING));
	  int otClasId = pAct->ExecIntMethod(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS);
	  pAct->SetIntVarValue(OPERATION_CLASS_ID, otClasId);

	  if(! strcmp(optionSerPar, "PAR")){
		pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
		pChantier->AddOperand(pAct);
	  }
	  else {
		((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	  }
	}
  }
//printf("\n==>");pChantier->DisplaySituation();printf("\n");
  delete plotsToProtectTab;
//printf("\naddNewSituatedPhytoTreatments_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};
