bool addNewSituatedSpringChemicalWeedings_Body(EntityMethod* pM)
//--------------------------------------------------------------
// ajoute au chantier de desherbage de printemps des activites sur de nouvelles parcelles
//--------------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\naddNewSituatedSpringChemicalWeedings_Body sur '%s'", pChantier->InstanceName());
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> arguments de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN,
                                                                                         TRUE);
  if(pPhasicPlan == NULL) {
        printf("\naddNewSituatedSpringChemicalWeedings : pas de plan de phase trouve !\n");
        exit(0);   
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
        (Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des desherbages de printemps
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
        optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);

  char* manualMotorizedValue;
  if(! strcmp(optionSerPar, "PAR"))
	 manualMotorizedValue = "";
  else {
	if(pChantier->IsInstanceOf(SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS))
	  manualMotorizedValue = "MANUAL";
	else
	  manualMotorizedValue = "MOTORIZED";
  }
//printf("\n\tmanualMotorizedValue = '%s'", manualMotorizedValue);
       
  //-------------------------------------------------
  // determination des nouvelles parcelles a desherber au printemps
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_SPRING_WEED, 
							   VINEYARD_ARGUMENT, pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_SPRING_WEED, 
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_SPRING_WEED, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_SPRING_WEED,
							   SERIAL_PARALLEL_ARGUMENT,
							   optionSerPar);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_SPRING_WEED,
							   MANUAL_MOTORIZED_ARGUMENT,
							   manualMotorizedValue);
  
  pEntityTab* plotsToSpringWeedTab
        = pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_SPRING_WEED);
  //  ----------------------------------------------------------
//printf("\n\tplotsToSpringWeedTab : "); plotsToSpringWeedTab->display_names();
  int nbPlots = plotsToSpringWeedTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  Boolean headingActInSerialActivitySet = FALSE;
  if(! strcmp(optionSerPar, "SER")
	 &&
	 pChantier->GetNumberOfElements() == 0)
	headingActInSerialActivitySet = TRUE;
  
  bool actInstantiated;
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToSpringWeedTab->get_element(i);
    Activity* pAct;
	actInstantiated = FALSE;
	//
	// creation d'une activite de desherbage
	//
	/* version ecrite par NP+JPR

	if(! strcmp(optionSerPar, "SER")) {
	  if(! strcmp(manualMotorizedValue, "MOTORIZED")) { 
		pAct = new MotorizedChemicalWeedingActivity(pVineyard);
		UserClassId otClassId = HORIZONTAL_RAIL_OPERATED_SPRAYING;  // provisoire
        
		pAct->SetIntVarValue(OPERATION_CLASS_ID, otClassId);
		actInstantiated = TRUE;
	  }
	  else {  
		pAct = new ManualChemicalWeedingActivity(pVineyard);
		// otClassId = ? a faire ?
		actInstantiated = TRUE;
	  }
	}
	else {
	  // choix manuel/motorise en fonction de plusieurs criteres
	  // mais provisoirement un seul critere : parcelle motorisable ou pas
	  //
	  pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							OPERATION_CLASS_ARGUMENT,
							MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable = pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable = %d", isPlotMotorizable);
	  if(isPlotMotorizable) { 
		pAct = new MotorizedChemicalWeedingActivity(pVineyard);
		UserClassId otClassId = HORIZONTAL_RAIL_OPERATED_SPRAYING;  // provisoire
        
		pAct->SetIntVarValue(OPERATION_CLASS_ID, otClassId);
		actInstantiated = TRUE;
	  }
	  else {
		pAct = new ManualChemicalWeedingActivity(pVineyard);
		// otClassId = ? a faire ?
		actInstantiated = TRUE;
	  } 
	}
	*/
	// version JPR 110210 :
	//
	// Y compris en SER :
	// choix manuel/motorise en fonction de plusieurs criteres
	// mais provisoirement un seul critere : parcelle motorisable ou pas
	// <- la version remplacee cree deux SpringCW sur la meme parcelle :
	// . un qd cette meth est appelee sur le chantier SerialManual
	// . un qd cette meth est appelee sur le chantier SerialMotorized
	// (sur MG16_16 -la derniere-, et pas les autres !)
	//
	pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
						  OPERATION_CLASS_ARGUMENT,
						  MOTORIZED_SPRAYING_OPERATION);
	bool isPlotMotorizable = pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable = %d", isPlotMotorizable);
	if(isPlotMotorizable) { 
	  pAct = new MotorizedChemicalWeedingActivity(pVineyard);
	  UserClassId otClassId = HORIZONTAL_RAIL_OPERATED_SPRAYING;  // provisoire
	  
	  pAct->SetIntVarValue(OPERATION_CLASS_ID, otClassId);
	  actInstantiated = TRUE;
	}
	else {
	  pAct = new ManualChemicalWeedingActivity(pVineyard);
	  // otClassId = ? a faire ?
	  actInstantiated = TRUE;
	}

	if(actInstantiated) {  // securite utile ?
	  //
	  // priorite d'allocation
	  //
	  int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	  int allocPriority = 
		App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								  STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	  pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	  pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	  //
	  // designation de pPlot comme objet opere par pAct
	  //
	  Entity* pOOSpec = new OperatedObjectSpecification();
	  pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	  pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	  pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans '%s' sur '%s' pPlot : '%s'", pAct->InstanceName(), pVineyard->InstanceName(), pPlot->InstanceName());
	  //
	  // ajout de ce ChemicalWeeding au chantier
	  //  
	  if(! strcmp(optionSerPar, "PAR")){
		pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
		pChantier->AddOperand(pAct);
	  }
	  else {
		((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	  }     
	}
  }
  delete plotsToSpringWeedTab;
//printf("\naddNewSituatedSpringChemicalWeedings_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};
