void clearPerfAllocationAndUpdateSituation_execProcess_Body(ProcessMethod* pM)
//---------------------------------------------
// Definition de la fonction qui code l'execution du processus ponctuel.
//---------------------------------------------
// La validité de la spécification SAME_PREVIOUS_ENTITIES sur les spéc. de
// performers des activités primitives est limitée à la demi-journée. 
// Autrement dit, qd SAME_PREVIOUS_ENTITIES est spécifié, les performers
// doivent rester les mêmes jusqu'à la fin de la demi-journée en cours, mais
// pourront changer dans la prochaine.
// Il faut donc, lors des débuts des demi-journées, effacer la trace des
// performers alloués lors de la demi-journée précédente. C'est le descr.
// developpedList de la spéc.de performers de l'activité. (ajout 121211 5.1)
//---------------------------------------------
{
  int now = pCurrentSim->Clock();
  tm* pTm_now = ClockValueToTm(now);
  int hour = pTm_now->tm_hour;
  int mon = pTm_now->tm_mon;
  int day = pTm_now->tm_mday;
  delete pTm_now;
  //
  // la date a atteindre pour entrer dans la periode speciale
  bool clearToDo = FALSE;
  bool inSpecialHours = FALSE;
  if(((mon == 3) && (day == 30))  // 30 avril -> specialHour pour le 1er mai
	 ||
	 ((mon > 3) && (mon < 7))     // mai, ... ,juillet
	 ||
	 (mon == 7) && (day < 31)) {  // 31 aout -> normalHour pour 1er sept
	inSpecialHours = TRUE;
  }
  if((inSpecialHours
	  &&
	  (hour == GetIntParameterValue("morningUpdateSituation", "specialHour")))
	 ||
	 (hour == GetIntParameterValue("morningUpdateSituation", "normalHour"))
	 ||
	 (hour == GetIntParameterValue("afternoonUpdateSituation", "normalHour")))
	clearToDo = TRUE;
	  
  if(clearToDo) {
	DiscreteProcess* pCP = pM->DescribedDiscreteProcess();
	Manager* pManager = (Manager*)(pCP->ProcessedEntity());
	Strategy* pStrategy = (Strategy*)(pManager->GetComponent(STRATEGY));
	Entity* 
	  pArbSet = pStrategy->GetComponent(ACTIVITIES_RESOURCES_BLOCK_SET);
	int nbArb = pArbSet->GetNumberOfElements();
//printf("\n>> t=%d nbArb = %d\n", now, nbArb);
	for (int k=0;k<nbArb;k++) {
	  ActivitiesResourcesBlock* 
		pArb = (ActivitiesResourcesBlock*)(pArbSet->GetElement(k));
//printf("\n>> t=%d nbArb = %d pArb '%s'\n", now, nbArb, pArb->InstanceName());
	  Activity* 
		pAct = (Activity*)(pArb->GetComponent(ACTIVITY));
	  pEntityTab tmp = pAct->GetDepthElementTab(PRIMITIVE_ACTIVITY);
//printf("\ntmp :: ");tmp.display_names();
	  pEntityTab* tmp2 = new pEntityTab();
	  int nbInst = tmp.size();
//printf("\tnbInst = %d", nbInst);
	  for (int k=0;k<nbInst;k++) {
		Entity* pInst = (Entity*)tmp[k];
		if(pInst->GetIntVarValue(SITUATION) == IN_COURSE) {
		  Entity* perfSpec 
			= pInst->GetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE);
		  if(perfSpec) {
			pEntityTab* devList = perfSpec->GetEntityTabVarValue(DEVELOPPED_LIST);
//devList->display_names(); 
			int nbElem = devList->size();
			for(int m=nbElem-1;m>=0;m--) {
			  BasicEntity* pElem_m_tmp = devList->get_nth(m);
			  Entity* pElem_m = (Entity*)pElem_m_tmp;
			  devList->remove(m);
			  DeleteEntity(pElem_m);
			}
//devList->display_names(); 
		  }
		  tmp2->push_back(pInst);
		}
	  }
//printf("\ntmp2 :: ");tmp2->display_names();
	  delete tmp2; // + JPR 130114 <- MLK
	}
	//
	// ajout: RAZ PrimitiveActivityAttribute des performers JPR 130226 
	//
	pEntityTab* perfList = GetEntityList(FARM_WORKER);
//printf("\ndans clearPerfAllocationAndUpdateSituation_execProcess_Body perfPool : ");perfList->display_names();
	int nbPerf = perfList->size();
	for(int i=0;i<nbPerf;i++) {
	  Entity* pPerf_i = (Entity*)perfList->get_nth(i);
	  pPerf_i->SetEntityConstValue(PRIMITIVE_ACTIVITY_ATTRIBUTE, NULL);
	}	
  }
  //
  // corps prédéfini de l'event 
  //
  updateSituationProcess_execProcess_Body(pM);
};
