bool isClockValueInCalendar_Body(EntityMethod* pM)
//------------------------------------------------
// renvoie 'vrai' ssi la valeur d'horloge en argument est dans le OffWorkCalendar
//------------------------------------------------
// - currentPeriod est la periode du calendrier qui contient l'horloge courante
//   ou bien la p�riode la plus r�cente pr�cedant l'horloge courante
//   (mise � jour dans  updateSeasonCurrentIndexProcess)
//------------------------------------------------
{
  Entity* pCalendar = pM->DescribedEntity();
  int clockArgument = pM->GetIntArgValue(CLOCK_ARGUMENT);
  bool result = FALSE;

  int nbPeriods = pCalendar->GetNumberOfElements();

  int currentPeriodIndex = pCalendar->GetIntVarValue(CURRENT_ELEMENT_INDEX);

  if(currentPeriodIndex < 0) currentPeriodIndex = 0;  // + JPR 110105

  Entity* pCurrentPeriod;
  for(int cpt=0;cpt<nbPeriods;cpt++) {

	int index_cpt = currentPeriodIndex+cpt;
	if(index_cpt > nbPeriods-1)
	  index_cpt = index_cpt - nbPeriods;
	pCurrentPeriod = pCalendar->GetElement(index_cpt);

	pCurrentPeriod->SetIntArgValue(IS_CLOCK_VALUE_IN_PERIOD,
								   CLOCK_ARGUMENT, clockArgument);
	bool isClockInCurrent 
	  = pCurrentPeriod->ExecPredicate(IS_CLOCK_VALUE_IN_PERIOD);
	if(isClockInCurrent) {
	  result = TRUE;
	  break;
	}
  }
//printf("\n'%s'::isClockValueInCalendar(%d) currentPeriod : [%s %s] returns %d", pCalendar->InstanceName(), pCurrentPeriod->GetStringConstValue(BEGINNING_CALENDAR_DATE), pCurrentPeriod->GetStringConstValue(END_CALENDAR_DATE), result)
  return result;
};
