bool isClockValueInPeriod_Body(EntityMethod* pM)
//----------------------------------------
// renvoie 'vrai' ssi la valeur d'horloge en argument est dans la WorkSinglePeriod
//----------------------------------------
{
  Entity* pPeriod = pM->DescribedEntity();
  int clockArgument = pM->GetIntArgValue(CLOCK_ARGUMENT);
  bool result = FALSE;

  //
  // les dates de debut et de fin sont au format aaaa-mm-jj par convention
  //
  char* begValue = pPeriod->GetStringConstValue(BEGINNING_CALENDAR_DATE);
  char* strBeg = strdup(begValue);
  char* yStrBeg = strtok(strBeg, "-");
  char* mStrBeg = strtok(NULL, "-");
  char* dStrBeg = strtok(NULL, "-");
  int yBeg = atoi(yStrBeg);
  int mBeg = atoi(mStrBeg);
  int dBeg = atoi(dStrBeg);
  int clockBeg = DateToClockValue(dBeg, mBeg, yBeg, 0, 0, 0);
  free(strBeg);
  
  int clockEnd;
  char* endValue = pPeriod->GetStringConstValue(END_CALENDAR_DATE);
  char* strEnd = strdup(endValue);
  if(strlen(strEnd) > 0) {
	char* yEnd = strtok(strEnd, "-");
	char* mEnd = strtok(NULL, "-");
	char* dEnd = strtok(NULL, "-");
	clockEnd = DateToClockValue(atoi(dEnd), atoi(mEnd), atoi(yEnd), 23, 0, 0);
  }
  else {
	//
	// la valeur "" pour la date de fin implique une periode de un jour
	//
	clockEnd = DateToClockValue(dBeg, mBeg, yBeg, 23, 0, 0);
  }
  free(strEnd);

  if((clockArgument >= clockBeg)
	 &&
	 (clockArgument <= clockEnd))
	result = TRUE;
//printf("[%s %s]=[%d %d]::isClockValueInPeriod(%d) returns %d", begValue, endValue, clockBeg, clockEnd, clockArgument, result);
  return result;
};
