bool lowCumulativeRainSuffered_stateRelatedPredicate_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// Doit renvoyer vrai si la contrainte est satisfaite.
// Celle-ci porte sur l'etat de la ressource a laquelle la contrainte est attachee.
// La ressource est la valeur de l'argument CANDIDATEENTITY_ARGUMENT.
//---------------------------------------------------------------------------
// Rsc attachee : FarmWorker (pMO)
// Cette contrainte est testee lors de chaque determination par le moteur
// de la disponibilite de la ressource. 
// Si ce predicat renvoie FALSE, la ressource est declaree indisponible.
//---------------------------------------------------------------------------
  //Entity* pMO = pM->GetEntityArgValue(CANDIDATEENTITY_ARGUMENT);
  Entity* pCtr = pM->DescribedEntity(); // JPR 120207 <- nouveau DIESE 5.8
  Entity* pMO = pCtr->GetEntityConstValue(DESCRIBED_RESOURCE);

  bool result = TRUE;

  bool critere1 = TRUE;
  // VRAI, sauf dans la situation d'indisponibilite :
  // - pMO a subi plus de X mm de pluie depuis le debut de la journee
  //   ET . on est le matin
  //      OU
  //      . on est l'apres-midi et la derniere pluie date de moins de 4 heures
  float cumulativeRainSuffered = 
	pMO->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_WORK_BEGINNING);
  float threshold = gRealParam_arretMainDOeuvre_seuilCumulPluieJour_;
//printf("\n'%s' lowCumulativeRainSuffered_SRP %f >? %f", pMO->InstanceName(), cumulativeRainSuffered, threshold);
  if(cumulativeRainSuffered > threshold ) {
	Entity* pEmploymentPlan = 
	  pMO->GetEntityConstValue(ANNUAL_EMPLOYMENT_PLAN_ATTRIBUTE);
	int currentIndex = 
	  pEmploymentPlan->GetIntVarValue(CURRENT_ELEMENT_INDEX);
	  Entity* pSeasonalPlan = pEmploymentPlan->GetElement(currentIndex);
	Entity* pRATT = pSeasonalPlan->GetEntityConstValue(TIMETABLE_ATTRIBUTE);
	currentIndex = pRATT->GetIntVarValue(CURRENT_ELEMENT_INDEX);
	Entity* pSlot = pRATT->GetElement(currentIndex);
//printf("\n'%s' lowCumulativeRainSuffered_SRP pSlot : '%s'", pMO->InstanceName(), pSlot->InstanceName());
	if(pSlot->IsInstanceOf(WEEK_DAY_MORNING)) {
	  critere1 = FALSE;
	}
	else {
	  int lastRainClock = pMO->GetIntConstValue(LAST_RAINFALL_CLOCK);
	  if((pCurrentSim->Clock() - lastRainClock) < 4)  // 4 heures
		critere1 = FALSE;	  
	}
  }
  bool critere2 = TRUE;
  if(critere1) {
	//
	// critere2 : si pluie > seuil dans les 6h precedentes
	// alors la ressource est declaree indisponible
	// ---------------------------------------------
	// Recuperation des stations meteo pour cette EA
	//
	pEntityTab* pWSList = GetEntityList(WEATHER_STATION);
	int nbWS = pWSList->size();
	for(int i=0;i<nbWS;i++) {
	  Entity* pWS_i = (Entity*)pWSList->get_nth(i);
	  char* pathName_i = pWS_i->GetStringConstValue(PATH_NAME_ATTRIBUTE);
	  float value_i =  // pluie des 6h precedentes, hormis l'heure en cours
		SumUpMemoryFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 6);
//printf("\n\t%s pluie[-1 -6] = %f", pWS_i->InstanceName(), value_i);
	  if(value_i > threshold) {
//printf("\n'%s' lowCumulativeRainSuffered_SRP critere2 FALSE", pMO->InstanceName());
		critere2 = FALSE;
	  }
	}
  }
  result = critere1 && critere2;

//printf("\n'%s' lowCumulativeRainSuffered_SRP returns %d", pMO->InstanceName(), result);
  return result;
};
