int morningUpdateSituationEvent_defineNextEventClockTime_Body(EventMethod* pM)
//---------------------------------------------
// Fonction de generation d'un nouvel evenement.
// Methode : 'SetDefineNextEventClockTime'
// . pNextEvent a ete instancie par la methode standard
// . sa date candidate tient deje compte de la specification
//   des delais min et max e ajouter e la precedente occurrence.
//---------------------------------------------
{
//printf("\nentree morningUpdateSituationEvent_defineNextEventClockTime en t = %d", pCurrentSim->Clock());
  int nextEventClockTime;
  Event* pNextEvent = pM->DescribedEvent();
  Event* pPreviousEvent = pM->GetEventArgValue(PREVIOUS_EVENT_ARGUMENT); 
  int previousEventClockTime = pPreviousEvent->OccurrenceClockTime();
  
  int clockTimeUnit = pCurrentSim->ClockTimeUnit();
  if(clockTimeUnit == HOUR        // horloge = 1 HOUR
	 ||
	 clockTimeUnit == MINUTE) {   // horloge = 30 MIN

	tm* pNextEventTm = ClockValueToTm(previousEventClockTime); // val. init
	int prevHour = pNextEventTm->tm_hour;
	//printf("\nprevHour = %d", prevHour);

	const int morningSpecialHour =   // + JPR 121002
	  gIntParam_morningUpdateSituation_specialHour_;
	int morningHour = 
	  gIntParam_morningUpdateSituation_normalHour_;
	int afternoonHour =  
	  gIntParam_afternoonUpdateSituation_normalHour_;
//printf("\nprevHour = %d morningSpecialHour = %d morningHour = %d afternoonHour = %d", prevHour, morningSpecialHour, morningHour, afternoonHour);
	if(prevHour == morningSpecialHour) {  
	  // les '+ 1' parce que le reveil est à 9h de nov a janvier
	  pNextEventTm->tm_hour = prevHour + 2;     // 4h -> 6h
	}
	else if(prevHour == morningSpecialHour + 2) {
	  pNextEventTm->tm_hour = morningHour;      // 6h -> 8h
	}
	else if(prevHour <= morningHour + 1) {      // 8h -> 10h
	  pNextEventTm->tm_hour = prevHour + 2;     // 9h -> 11h
	}
	else if(prevHour == morningHour + 2) {
	  if((pNextEventTm->tm_mon > 0) && (pNextEventTm->tm_mon < 8))
		pNextEventTm->tm_hour = prevHour + 2;   // 10h -> 12h  // + JPR 130306
	  else
		pNextEventTm->tm_hour = afternoonHour;  // 10h -> 14h
	}
	else if(prevHour == morningHour + 3) {
	  pNextEventTm->tm_hour = afternoonHour;    // 11h -> 14h
	}
	else if(prevHour == morningHour + 4) {
	  pNextEventTm->tm_hour = afternoonHour;    // 12h -> 14h
	}
	else if(prevHour == afternoonHour) {
	  pNextEventTm->tm_hour = prevHour + 2;     // 14h -> 16h
	}
	else if(prevHour == afternoonHour + 2) {    
	  pNextEventTm->tm_hour = prevHour + 2;     // 14h -> 18h  // + JPR 130306
	}
	else if(prevHour == afternoonHour + 4) {
	  pNextEventTm->tm_mday += 1;               // 18h -> 4h ou 8h ou 9h
	  pNextEventTm->tm_hour = ReturnManagerWakeUpHour();
	}
	//
	// determination instant du UpdateSituation
	//
	nextEventClockTime = 
	  DateToClockValue(pNextEventTm->tm_mday,
					   pNextEventTm->tm_mon+1,
					   pNextEventTm->tm_year+1900,
                       pNextEventTm->tm_hour, 
                       0, 0);
	delete pNextEventTm;  
  }
	else {
	//
	// horloge = 1 DAY
	//
	nextEventClockTime = previousEventClockTime +1;
  }
  
//printf("\n\t--> nextEventClockTime : %d", nextEventClockTime);
  return nextEventClockTime;
};
