void  setRowSoilManagement_Body(EntityMethod* pM)
//------------------------------------------
// etablit le mode de gestion de chaque rangee de la parcelle
//------------------------------------------
{
  Entity* pPlot = pM->DescribedEntity();
  Entity* pVegetal = pPlot->GetComponent(VEGETAL_COMPARTMENT);
  int nbRows = pVegetal->GetNumberOfElements();

  int rowManagement = pPlot->GetIntConstValue(ROW_MANAGEMENT);
  float q = pPlot->GetFloatConstValue(RIDING_ORIENTED_INTER_ROW_PROPORTION);
  float p = pPlot->GetFloatConstValue(GRASS_STRIP_ALLEY_WIDTH_RATIO);
  float r = pPlot->GetFloatConstValue(CROP_ROW_ALLEY_WIDTH_RATIO); 

  switch(rowManagement) {

  case GRASS_COVERING_TILLAGE : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, GRASS_COVER); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE); 
		pPlot->SetFloatVarValue(PERCENT_WEEDED, (float)-1.); // AB 130514
		break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);break; // à valider
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);break; // à valider
	  }	    
	  }
	}
	break; 
  }
  case GRASS_COVERING : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, GRASS_COVER); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE); break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		if((r > 0) && (q < 0.5))
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		else
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		break;
	  }	    
	  }
	}
	break; 
  }
  case CW_IN_SPACE : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE); break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		if((r > 0) && (q < 0.5))
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		else
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		break;
	  }	    
	  }
	}
	break; 
  }
  case CW_IN_TIME : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
		/* old 
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, MIXED_TILLAGE_CW); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); 
		pPlot->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
		pPlot->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
		pPlot->SetFloatVarValue(PERCENT_SPRING_TILLED, (float)-1.);
		break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		if((r > 0) && (q < 0.5))
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		else
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		break;
	  }
		*/
		// new AB 1401 : "affecter un mode d'entretien du sol
		// aux inter-rangs travaillés et non aux inter-rangs stabilisés"
      case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
        pPlot->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
        pPlot->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
        pPlot->SetFloatVarValue(PERCENT_SPRING_TILLED, (float)-1.);
        break;
      }
      case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, MIXED_TILLAGE_CW); break;
      }
      case 2 : {   // rang voisin d'inter-rang stabilise
        pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
      }
      case 3 : {   //rang non voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
        break;
      }
	  }
	}
	break; 
  }
  case TOTAL_CW : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); 
		pPlot->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
		pPlot->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
		pPlot->SetFloatVarValue(PERCENT_SPRING_TILLED, (float)-1.);
		break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		if((r > 0) && (q < 0.5))
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		else
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		break;
	  }	    
	  }
	}
	break; 
  }
  case TILLAGE : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE); break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		if((r > 0) && (q < 0.5))
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		else
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		break;
	  }	    
	  }
	}
	break;
  }
  case TOTAL_TILLAGE : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE);
		pPlot->SetFloatVarValue(PERCENT_WEEDED, (float)-1.); // + JPR 120907
		break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break; // à valider
	  }	    
	  }
	}
	break; 
  }	
  }
};






































