################
#  Descriptor  #
################

Descriptor ActivityAttribute {
      ClassSymbol               : ACTIVITY_ATTRIBUTE
      ClassName                 : activityAttribute
      ClassComment              : descripteur des DistributedActivitySetMemoryItem
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : ACTIVITY
}
#==============================================
Descriptor ActivityNameAttribute {
      ClassSymbol               : ACTIVITY_NAME_ATTRIBUTE
      ClassName                 : activityNameAttribute
      ClassComment              : descripteur des DistributedActivitySetMemoryItem
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor ActivityNominalDate {
      ClassSymbol               : ACTIVITY_NOMINAL_DATE
      ClassName                 : activityNominalDate
      ClassComment              : instant optimal de debut de realisation d'un chantier
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor ActualRealizationBegDate {
      ClassSymbol               : ACTUAL_REALIZATION_BEG_DATE
      ClassName                 : actualRealizationBegDate
      ClassComment              : horloge lors de la premiere progression d'operation sur une des parcelles du chantier
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor ActualRealizationEndDate {
      ClassSymbol               : ACTUAL_REALIZATION_END_DATE
      ClassName                 : actualRealizationEndDate
      ClassComment              : horloge lors de la derniere progression d'operation sur une des parcelles du chantier
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor ActuallyOperatedAreaPercentage {
      ClassSymbol               : ACTUALLY_OPERATED_AREA_PERCENTAGE
      ClassName                 : actuallyOperatedAreaPercentage
      ClassComment              : Lorsqu'une OT est terminee, pourcentage de la surface qui a reellement subi l'effet
      SubClass                  : CONSTANT
      Type                      : INT
      AddSubDomain              : [ 0 ; 100 ]
}
#==============================================
Descriptor AgeAttribute {
      ClassSymbol               : AGE_ATTRIBUTE
      ClassName                 : ageAttribute
      ClassComment              : age exprime par la classe PlantAge
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : PLANT_AGE
}
#==============================================
Descriptor AlleyWidth {
      ClassSymbol               : ALLEY_WIDTH
      ClassName                 : alleyWidth
      ClassComment              : ecartement des rangs de vigne
      ClassUnity                : cm
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor AllocationPriorityOptionSetAttribute {
      ClassSymbol               : ALLOCATION_PRIORITY_OPTION_SET_ATTRIBUTE
      ClassName                 : allocationPriorityOptionSetAttribute
      ClassComment              : pointeur sur l'objet encapsulant les priorites d'allocation par activite et phase
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
}
#==============================================
Descriptor AnnualEmploymentPlanAttribute {
      ClassSymbol               : ANNUAL_EMPLOYMENT_PLAN_ATTRIBUTE
      ClassName                 : annualEmploymentPlanAttribute
      ClassComment              : l'instance de AnnualEmploymentPlan attachee a un FarmWorker
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
}
#==============================================
Descriptor AntiMildewScheduled {
      ClassSymbol               : ANTI_MILDEW_SCHEDULED
      ClassName                 : antiMildewScheduled
      ClassComment              : pour un chantier, vrai ssi un anti-mildiou a ete programme
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor AntiMildewTreatmentJustDone {
      ClassSymbol               : ANTI_MILDEW_TREATMENT_JUST_DONE
      ClassName                 : antiMildewTreatmentJustDone
      ClassComment              : passe � 1 quand un anti-mildiou est 'ouvert', passe � 0 qd un traitement 'ouvert' est sans anti-mildiou
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor Area {
      ClassSymbol               : AREA
      ClassName                 : area
      ClassComment              : superficie
      ClassUnity                : ha
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor AreaWithGrapevine {
      ClassSymbol               : AREA_WITH_GRAPEVINE
      ClassName                 : areaWithGrapevine
      ClassComment              : superficie en vigne
      ClassUnity                : ha
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor AreaWithTilledGrapevine {
      ClassSymbol               : AREA_WITH_TILLED_GRAPEVINE
      ClassName                 : areaWithTilledGrapevine
      ClassComment              : superficie en vigne entretenue par travail du sol
      ClassUnity                : ha
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor AutumnTillagesManagement {
      ClassSymbol               : AUTUMN_TILLAGES_MANAGEMENT
      ClassName                 : autumnTillagesManagement
      ClassComment              : necessairement en serie (SER) ou possiblement en parallele (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor BeginningCalendarDate {
      ClassSymbol               : BEGINNING_CALENDAR_DATE
      ClassName                 : beginningCalendarDate
      ClassComment              : date de debut d'une periode non travaillee, feriee ou de conge
      SubClass                  : CONSTANT
      Type                      : STRING
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor ChemicalWeedingsManagement {
      ClassSymbol               : CHEMICAL_WEEDINGS_MANAGEMENT
      ClassName                 : chemicalWeedingsManagement
      ClassComment              : nécessairement en série (SER) ou possiblement en parallèle (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor ClippingsManagement {
      ClassSymbol               : CLIPPINGS_MANAGEMENT
      ClassName                 : clippingsManagement
      ClassComment              : nécessairement en série (SER) ou possiblement en parallèle (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor CommercialFormulation {
      ClassSymbol               : COMMERCIAL_FORMULATION
      ClassName                 : commercialFormulation
      ClassComment              : RoundUp, ...
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor CommercialFormulationDose {
      ClassSymbol               : COMMERCIAL_FORMULATION_DOSE
      ClassName                 : commercialFormulationDose
      ClassComment              : quantite de produit commercial par hectare
      ClassUnity                : kg ou l selon le produit commercial
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor CommercialFormulationList {
      ClassSymbol               : COMMERCIAL_FORMULATION_LIST
      ClassName                 : commercialFormulationList
      ClassComment              : (RoundUp, ...)
      SubClass                  : CONSTANT
      Type                      : STRING_TAB
}
#==============================================
Descriptor ControlPlanAttribute {
      ClassSymbol               : CONTROL_PLAN_ATTRIBUTE
      ClassName                 : controlPlanAttribute
      ClassComment              : la plan par lequel une EA est conduit
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : ACTIVITY
}
#==============================================
Descriptor ControlPlanClassNameAttribute {
      ClassSymbol               : CONTROL_PLAN_CLASS_NAME_ATTRIBUTE
      ClassName                 : controlPlanClassNameAttribute
      ClassComment              : descripteur de Vineyard pointant sur son plan de conduite
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor CropRowAlleyWidthRatio {
      ClassSymbol               : CROP_ROW_ALLEY_WIDTH_RATIO
      ClassName                 : cropRowAlleyWidthRatio
      ClassComment              : largeur bande entretenue homogene autour des ceps / ecartement entre 2 rangs
      ClassUnity                : %
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor CumulativeRainfallFromEarlyWinter {
      ClassSymbol               : CUMULATIVE_RAINFALL_FROM_EARLY_WINTER
      ClassName                 : cumulativeRainfallFromEarlyWinter
      ClassComment              : descripteur de Plot ; cumul depuis date parametree
      ClassUnity                : mm
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor CumulativeRainfallFromEarlyWinterForInitst {
      ClassSymbol               : CUMULATIVE_RAINFALL_FROM_EARLY_WINTER_FOR_INITST
      ClassName                 : cumulativeRainfallFromEarlyWinterForInitst
      ClassComment              : descripteur de Plot ; cumul depuis date parametree
      ClassUnity                : mm
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor CumulativeRainfallFromLastTillage {
      ClassSymbol               : CUMULATIVE_RAINFALL_FROM_LAST_TILLAGE
      ClassName                 : cumulativeRainfallFromLastTillage
      ClassComment              : descripteur de Plot ; RAZ qd percentAchieved d'un Tillage passe a 1
      ClassUnity                : mm
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor CumulativeRainfallFromMhydasInteraction {
      ClassSymbol               : CUMULATIVE_RAINFALL_FROM_MHYDAS_INTERACTION
      ClassName                 : cumulativeRainfallFromMhydasInteraction
      ClassComment              : cumul de pluie depuis la derniere prise d'info Mhydas
      ClassUnity                : mm
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor CumulativeRainfallFromWorkBeginning {
      ClassSymbol               : CUMULATIVE_RAINFALL_FROM_WORK_BEGINNING
      ClassName                 : cumulativeRainfallFromWorkBeginning
      ClassComment              : cumul de pluie depuis le premier travail dans le jour courant
      ClassUnity                : mm
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor CurrentSlotToBeExtended {
      ClassSymbol               : CURRENT_SLOT_TO_BE_EXTENDED
      ClassName                 : currentSlotToBeExtended
      ClassComment              : 1 ssi la terminaison d'une operation justifie de prolonger le TimeSlot en cours
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor CurrentStageIndex {
      ClassSymbol               : CURRENT_STAGE_INDEX
      ClassName                 : currentStageIndex
      ClassComment              : indice du stade courant dans le tableau des stades
      SubClass                  : VARIABLE
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor DailyRainfallForecastFromCurrentDay {
      ClassSymbol               : DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY
      ClassName                 : dailyRainfallForecastFromCurrentDay
      ClassComment              : hauteurs de pluie (mm) pr�vues dans les jours a venir (index 0 pour aujourd'hui)
      SubClass                  : CONSTANT
      Type                      : FLOAT_TAB
}
#==============================================
Descriptor DayOfAchievement {
      ClassSymbol               : DAY_OF_ACHIEVEMENT
      ClassName                 : dayOfAchievement
      ClassComment              : jour (julien) d'atteinte d'un stade
      SubClass                  : CONSTANT
      Type                      : INT
      AddSubDomain              : [ 1 ; 366 ]
}
#==============================================
Descriptor DayWhenAchieved {
      ClassSymbol               : DAY_WHEN_ACHIEVED
      ClassName                 : dayWhenAchieved
      ClassComment              : numero julien du jour auquel le stade est completement realise
      SubClass                  : VARIABLE
      Type                      : INT
      SetDefaultValue           : -1
}
#==============================================
Descriptor DaysNumber {
      ClassSymbol               : DAYS_NUMBER
      ClassName                 : daysNumber
      ClassComment              : age en nombre de jours julien
      SubClass                  : VARIABLE
      Type                      : INT
}
#==============================================
Descriptor DebranchingsManagement {
      ClassSymbol               : DEBRANCHINGS_MANAGEMENT
      ClassName                 : debranchingsManagement
      ClassComment              : nécessairement en série (SER) ou possiblement en parallèle (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor DecisionOptionSetAttribute {
      ClassSymbol               : DECISION_OPTION_SET_ATTRIBUTE
      ClassName                 : decisionOptionSetAttribute
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : DECISION_OPTION_SET
}
#==============================================
Descriptor DistributedActivitySetMemory {
      ClassSymbol               : DISTRIBUTED_ACTIVITY_SET_MEMORY
      ClassName                 : distributedActivitySetMemory
      ClassComment              : container des DistributedActivitySetMemoryItem's des ARB's
      SubClass                  : VARIABLE
      Type                      : ENTITY_TAB
}
#==============================================
Descriptor DownyMildewLevel {
      ClassSymbol               : DOWNY_MILDEW_LEVEL
      ClassName                 : downyMildewLevel
      ClassComment              : 0=no 1=scarse 2=frequNoDammage 3=freqAndDommage
      SubClass                  : CONSTANT
      Type                      : INT
      AddSubDomain              : [ 0 ; 3 ]
}
#==============================================
Descriptor DownyMildewManagementAttribute {
      ClassSymbol               : DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE
      ClassName                 : downyMildewManagementAttribute
      ClassComment              : element de l'enum. DownyMildewManagementModalities
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor DownyMildewPressure {
      ClassSymbol               : DOWNY_MILDEW_PRESSURE
      ClassName                 : downyMildewPressure
      ClassComment              : niveau de pression oidium calcule des que .....
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor DownyMildewPrimaryInfection {
      ClassSymbol               : DOWNY_MILDEW_PRIMARY_INFECTION
      ClassName                 : downyMildewPrimaryInfection
      ClassComment              : 0=NON 1 OUI
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor DownyMildewRiskLevel {
      ClassSymbol               : DOWNY_MILDEW_RISK_LEVEL
      ClassName                 : downyMildewRiskLevel
      ClassComment              : -5 : no risk +5 : high risk level
      SubClass                  : CONSTANT
      Type                      : FLOAT
      AddSubDomain              : [ -5. ; +5. ]
}
#==============================================
Descriptor DownyMildewToClose {
      ClassSymbol               : DOWNY_MILDEW_TO_CLOSE
      ClassName                 : downyMildewToClose
      ClassComment              : vrai s'il ya lieu d'arreter les traitements anti-mildiou
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor EndCalendarDate {
      ClassSymbol               : END_CALENDAR_DATE
      ClassName                 : endCalendarDate
      ClassComment              : date de fin d'une periode non travaillee, feriee ou de conge (vide si = debut)
      SubClass                  : CONSTANT
      Type                      : STRING
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor FarmWorkerAttribute {
      ClassSymbol               : FARM_WORKER_ATTRIBUTE
      ClassName                 : farmWorkerAttribute
      ClassComment              : la FarmWorker dotee de l'AnnualEmploymentPlan par ce descripteur
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : FARM_WORKER
}
#==============================================
Descriptor FertilizationsManagement {
      ClassSymbol               : FERTILIZATIONS_MANAGEMENT
      ClassName                 : fertilizationsManagement
      ClassComment              : necessairement en serie (SER) ou possiblement en parallele (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor FirstSpringTillageDate {
      ClassSymbol               : FIRST_SPRING_TILLAGE_DATE
      ClassName                 : firstSpringTillageDate
      ClassComment              : instant de debut du premier labour dans le chantier SpringTillages
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor FlagMildew {
      ClassSymbol               : FLAG_MILDEW
      ClassName                 : flagMildew
      ClassComment              : vrai des que App_GetFlagMildew a renvoye vrai dans une campagne
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor GrapeVarietyAttribute {
      ClassSymbol               : GRAPE_VARIETY_ATTRIBUTE
      ClassName                 : grapeVarietyAttribute
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
}
#==============================================
Descriptor GrapeVarietyListAttribute {
      ClassSymbol               : GRAPE_VARIETY_LIST_ATTRIBUTE
      ClassName                 : grapeVarietyListAttribute
      ClassComment              : les varietes effectivement presentes sur une exploitation
      SubClass                  : CONSTANT
      Type                      : ENTITY_TAB
}
#==============================================
Descriptor GrassCoverVectorFromMhydas {
      ClassSymbol               : GRASS_COVER_VECTOR_FROM_MHYDAS
      ClassName                 : grassCoverVectorFromMhydas
      ClassComment              : pour une Row, vect. des couvertures sol sur les unit. hydro. identifiees dans Mhydas
      SubClass                  : CONSTANT
      Type                      : FLOAT_TAB
}
#==============================================
Descriptor GrassStripAlleyWidthRatio {
      ClassSymbol               : GRASS_STRIP_ALLEY_WIDTH_RATIO
      ClassName                 : grassStripAlleyWidthRatio
      ClassComment              : largeur bande entretenue enherbee / ecartement entre 2 rangs
      ClassUnity                : %
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor GrassTypeAttribute {
      ClassSymbol               : GRASS_TYPE_ATTRIBUTE
      ClassName                 : grassTypeAttribute
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : GRASS_TYPE
}
#==============================================
Descriptor GuidingEarlyVarietyAttribute {
      ClassSymbol               : GUIDING_EARLY_VARIETY_ATTRIBUTE
      ClassName                 : guidingEarlyVarietyAttribute
      ClassComment              : nom d'instance du cepage precoce guide pour un viticulteur donne
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor GuidingLateVarietyAttribute {
      ClassSymbol               : GUIDING_LATE_VARIETY_ATTRIBUTE
      ClassName                 : guidingLateVarietyAttribute
      ClassComment              : nom d'instance du cepage tardif guide pour un viticulteur donne
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor GuidingVarietiesAttribute {
      ClassSymbol               : GUIDING_VARIETIES_ATTRIBUTE
      ClassName                 : guidingVarietiesAttribute
      ClassComment              : liste des cepages guides pour un viticulteur donne
      SubClass                  : CONSTANT
      Type                      : STRING_TAB
}
#==============================================
Descriptor HasEarlyVariety {
      ClassSymbol               : HAS_EARLY_VARIETY
      ClassName                 : hasEarlyVariety
      ClassComment              : 1 si au moins une variete precoce est presente sur l'exploitation, 0 sinon
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor HasLateVariety {
      ClassSymbol               : HAS_LATE_VARIETY
      ClassName                 : hasLateVariety
      ClassComment              : 1 si au moins une variete tardive est presente sur l'exploitation, 0 sinon
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor InOutMode {
      ClassSymbol               : IN_OUT_MODE
      ClassName                 : inOutMode
      ClassComment              : C_IN=0 : l'element est dans l'ensemble ; C_OUT=1 : l'element n'est pas dans l'ensemble
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor InitSpringTillagesManagement {
      ClassSymbol               : INIT_SPRING_TILLAGES_MANAGEMENT
      ClassName                 : initSpringTillagesManagement
      ClassComment              : necessairement en serie (SER) ou possiblement en parallele (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor IsAllocationExclusive {
      ClassSymbol               : IS_ALLOCATION_EXCLUSIVE
      ClassName                 : isAllocationExclusive
      ClassComment              : TRUE seulement si doit etre la seulle allouee dans un jeu d'activites (hors TrtPhyto)
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor IsEarly {
      ClassSymbol               : IS_EARLY
      ClassName                 : isEarly
      ClassComment              : 1 : variete precoce ; 0 tardive
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor IsManager {
      ClassSymbol               : IS_MANAGER
      ClassName                 : isManager
      ClassComment              : 1 ssi le FarmWorker est chef d'exploitation (plusieurs possibles), 0 sinon
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor IsoAgeingEntityAttribute {
      ClassSymbol               : ISO_AGEING_ENTITY_ATTRIBUTE
      ClassName                 : isoAgeingEntityAttribute
      ClassComment              : entite d'iso-dvlpment attachee a une vigne
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : ISO_AGEING_ENTITY
}
#==============================================
Descriptor IsoAgeingEntitySetAttribute {
      ClassSymbol               : ISO_AGEING_ENTITY_SET_ATTRIBUTE
      ClassName                 : isoAgeingEntitySetAttribute
      ClassComment              : ens. des entites d'iso-dvlpment identifiables dans un SimTerritory
      SubClass                  : CONSTANT
      Type                      : ENTITY_TAB
      AddSubDomain              : ISO_AGEING_ENTITY
}
#==============================================
Descriptor JulianTimeToAchieve {
      ClassSymbol               : JULIAN_TIME_TO_ACHIEVE
      ClassName                 : julianTimeToAchieve
      ClassComment              : nombre theorique de jours pour passer au stade suivant
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor LaiForMowing {
      ClassSymbol               : LAI_FOR_MOWING
      ClassName                 : laiForMowing
      ClassComment              : lai de reference pour la tonte
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor LaiForSenescence {
      ClassSymbol               : LAI_FOR_SENESCENCE
      ClassName                 : laiForSenescence
      ClassComment              : lai a partir duquel on calcule la senescence
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.3
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor LandUse {
      ClassSymbol               : LAND_USE
      ClassName                 : landUse
      ClassComment              : Vigne, Champ
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor LastOperationsMemoryAttribute {
      ClassSymbol               : LAST_OPERATIONS_MEMORY_ATTRIBUTE
      ClassName                 : lastOperationsMemoryAttribute
      ClassComment              : valeur : LastOperationsMemory, sur-ensemble de Last<X>MemoryItem's
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : LAST_OPERATIONS_MEMORY
}
#==============================================
Descriptor LastRainfallClock {
      ClassSymbol               : LAST_RAINFALL_CLOCK
      ClassName                 : lastRainfallClock
      ClassComment              : valeur d'horloge lors de la pluie la plus recente
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor LastSevenDaysRainfall {
      ClassSymbol               : LAST_SEVEN_DAYS_RAINFALL
      ClassName                 : lastSevenDaysRainfall
      ClassComment              : hauteur de pluie dans les sept jours precedents
      ClassUnity                : mm
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor LastTillageOperationClock {
      ClassSymbol               : LAST_TILLAGE_OPERATION_CLOCK
      ClassName                 : lastTillageOperationClock
      ClassComment              : date du dernier labour sur la parcelle
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor LastWeatherPrintClock {
      ClassSymbol               : LAST_WEATHER_PRINT_CLOCK
      ClassName                 : lastWeatherPrintClock
      ClassComment              : horloge au moment du dernier affichage ecran de la date et de la pluie
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor Latitude {
      ClassSymbol               : LATITUDE
      ClassName                 : latitude
      ClassComment              : latitude en ........
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor LeafAreaIndexRate {
      ClassSymbol               : LEAF_AREA_INDEX_RATE
      ClassName                 : leafAreaIndexRate
      ClassComment              : taux de croissance foliaire journalier
      SubClass                  : CONSTANT
      Type                      : FLOAT
      SetDefaultValue           : 0.9
      SetToDefaultValue         : TRUE
      AddSubDomain              : [ 0. ; 1. ]
}
#==============================================
Descriptor LeafAreaIndexResidual {
      ClassSymbol               : LEAF_AREA_INDEX_RESIDUAL
      ClassName                 : leafAreaIndexResidual
      ClassComment              : LAI apres tonte ou au depart
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.3
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor LeafLifeSpanMin {
      ClassSymbol               : LEAF_LIFE_SPAN_MIN
      ClassName                 : leafLifeSpanMin
      ClassComment              : LLSmin correspond � un gpe fonctionnel
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 600
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor Longitude {
      ClassSymbol               : LONGITUDE
      ClassName                 : longitude
      ClassComment              : longitude en .........
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor MaxReplicationNumberInDryPeriod {
      ClassSymbol               : MAX_REPLICATION_NUMBER_IN_DRY_PERIOD
      ClassName                 : maxReplicationNumberInDryPeriod
      ClassComment              : descripteur de SpringTillageIteration
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 99
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor MeanPriorityDegree {
      ClassSymbol               : MEAN_PRIORITY_DEGREE
      ClassName                 : meanPriorityDegree
      ClassComment              : degre moyen de priorite (d'allocation) sur les primitives d'un jeu
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor MembershipMode {
      ClassSymbol               : MEMBERSHIP_MODE
      ClassName                 : membershipMode
      ClassComment              : IN : les elements sont supposes dans le conteneur ; NOT_IN : ... hors du conteneur
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 1
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor MinPercentageToBeginOperation {
      ClassSymbol               : MIN_PERCENTAGE_TO_BEGIN_OPERATION
      ClassName                 : minPercentageToBeginOperation
      ClassComment              : pourcentage de realisation mini avant fin (demi)journee pour pouvoir demarrer
      SubClass                  : CONSTANT
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor NeedForNextFavourableDays {
      ClassSymbol               : NEED_FOR_NEXT_FAVOURABLE_DAYS
      ClassName                 : needForNextFavourableDays
      ClassComment              : besoin en nb mini de prochains jours en conditions favorables
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 2
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor NominalFloatQuantitySpeed {
      ClassSymbol               : NOMINAL_FLOAT_QUANTITY_SPEED
      ClassName                 : nominalFloatQuantitySpeed
      ClassComment              : vitesse de reference (nominale) des operations motorisees
      ClassUnity                : km par heure
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : -9.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor NominalIntQuantitySpeed {
      ClassSymbol               : NOMINAL_INT_QUANTITY_SPEED
      ClassName                 : nominalIntQuantitySpeed
      ClassComment              : vitesse de reference (nominale) des operations manuelles
      ClassUnity                : nb souches par heure
      SubClass                  : VARIABLE
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor NumberOfTractors {
      ClassSymbol               : NUMBER_OF_TRACTORS
      ClassName                 : numberOfTractors
      ClassComment              : nombre de tracteurs dans l'exploitation
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor NumberOfWorkers {
      ClassSymbol               : NUMBER_OF_WORKERS
      ClassName                 : numberOfWorkers
      ClassComment              : nombre d'unités de MO dans l'exploitation
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor OffWorkCalendarAttribute {
      ClassSymbol               : OFF_WORK_CALENDAR_ATTRIBUTE
      ClassName                 : offWorkCalendarAttribute
      ClassComment              : pointeur sur le calendrier des jours feries et de conge pour cet AnnualEmploymentPlan
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : OFF_WORK_CALENDAR
}
#==============================================
Descriptor OperatedPlotsAttribute {
      ClassSymbol               : OPERATED_PLOTS_ATTRIBUTE
      ClassName                 : operatedPlotsAttribute
      ClassComment              : les parcelles en cours dans une IteratedActivityConjunction
      SubClass                  : CONSTANT
      Type                      : ENTITY_TAB
      AddSubDomain              : PLOT
}
#==============================================
Descriptor OperatedVineyardSubArea {
      ClassSymbol               : OPERATED_VINEYARD_SUB_AREA
      ClassName                 : operatedVineyardSubArea
      ClassComment              : partie de la superficie de l'exploitation opérée pour le chantier décrit
      ClassUnity                : ha
      SubClass                  : VARIABLE
      Type                      : FLOAT
}
#==============================================
Descriptor OperationPriorityOptionSetAttribute {
      ClassSymbol               : OPERATION_PRIORITY_OPTION_SET_ATTRIBUTE
      ClassName                 : operationPriorityOptionSetAttribute
      ClassComment              : pointeur sur l'objet encapsulant les priorites d'operation par activite et phase
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
}
#==============================================
Descriptor OperationRecordingAttribute {
      ClassSymbol               : OPERATION_RECORDING_ATTRIBUTE
      ClassName                 : operationRecordingAttribute
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : OPERATION_RECORDING_STRUCTURE
}
#==============================================
Descriptor OptActualDownyMildewRiskThreshold {
      ClassSymbol               : OPT_ACTUAL_DOWNY_MILDEW_RISK_THRESHOLD
      ClassName                 : optActualDownyMildewRiskThreshold
      ClassComment              : risque observe minimum pour continuer a traiter anti mildiou
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor OptAutumnTillageCP {
      ClassSymbol               : OPT_AUTUMN_TILLAGE_C_P
      ClassName                 : optAutumnTillageCP
      ClassComment              : NOVEMBER ; DECEMBER ; BEG_PRUN
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptAutumnTillageOP {
      ClassSymbol               : OPT_AUTUMN_TILLAGE_O_P
      ClassName                 : optAutumnTillageOP
      ClassComment              : END_HARV ; MID_OCT ; NONE
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptChemicalWeedingOP {
      ClassSymbol               : OPT_CHEMICAL_WEEDING_O_P
      ClassName                 : optChemicalWeedingOP
      ClassComment              : END_PRUN_THIN ; MID_JAN ; MID_FEB ; EARLY_MAR ; MID_MAR
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptCropRowAlleyWidthRatio {
      ClassSymbol               : OPT_CROP_ROW_ALLEY_WIDTH_RATIO
      ClassName                 : optCropRowAlleyWidthRatio
      ClassComment              : valeur de reference pour les CropRowAlleyWidthRatio des parcelles
      ClassUnity                : %
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor OptDebranchingModality {
      ClassSymbol               : OPT_DEBRANCHING_MODALITY
      ClassName                 : optDebranchingModality
      ClassComment              : PART_CHEM ; PART_MECA ; PART_MECA_CHEM ; WHOLE_CHEM ; WHOLE_MECA ; WHOLE_MECA_CHEM
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptDownyMildewAtLeastClosing {
      ClassSymbol               : OPT_DOWNY_MILDEW_AT_LEAST_CLOSING
      ClassName                 : optDownyMildewAtLeastClosing
      ClassComment              : 0:pea-sized, ...
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptDownyMildewManagement {
      ClassSymbol               : OPT_DOWNY_MILDEW_MANAGEMENT
      ClassName                 : optDownyMildewManagement
      ClassComment              : R0 ; R1 ; RFLO ; F2 ; F3 ; FFLO ; S
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptDownyMildewUnderPressureClosing {
      ClassSymbol               : OPT_DOWNY_MILDEW_UNDER_PRESSURE_CLOSING
      ClassName                 : optDownyMildewUnderPressureClosing
      ClassComment              : 0: pea-sized; ...
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptExtraPhytoTreatmentsOP {
      ClassSymbol               : OPT_EXTRA_PHYTO_TREATMENTS_O_P
      ClassName                 : optExtraPhytoTreatmentsOP
      ClassComment              : de 0 (pression nulle) a 3 (pression elevee)
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptFertilizationOP {
      ClassSymbol               : OPT_FERTILIZATION_O_P
      ClassName                 : optFertilizationOP
      ClassComment              : NONE ; END_HARVEST ; MID_OCT ; END_THIN ; END_THIN_CW ; EARLY_FEB ; EARLY_MAR
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptFertilizationSeason {
      ClassSymbol               : OPT_FERTILIZATION_SEASON
      ClassName                 : optFertilizationSeason
      ClassComment              : 0 : no; 1 : Autumn; 2 : Spring; 3 : les deux
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptFirstSpringTillageOP {
      ClassSymbol               : OPT_FIRST_SPRING_TILLAGE_O_P
      ClassName                 : optFirstSpringTillageOP
      ClassComment              : INIT_SPRING_TILLAGE ; EARLY_MAR ; MID_MAR ; EARLY_APR ; MID_APR
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptGrassStripAlleyWidthRatio {
      ClassSymbol               : OPT_GRASS_STRIP_ALLEY_WIDTH_RATIO
      ClassName                 : optGrassStripAlleyWidthRatio
      ClassComment              : valeur de reference pour les GrassStripAlleyWidthRatio des parcelles
      ClassUnity                : %
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor OptInitSpringTillageOP {
      ClassSymbol               : OPT_INIT_SPRING_TILLAGE_O_P
      ClassName                 : optInitSpringTillageOP
      ClassComment              : MID_JAN ; EARLY_FEB ; MID_FEB ; END_THIN_FERT ; END_THIN_CW ; END_THIN_CW_FERT ; NONE
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptPastDownyMildewPressureThreshold {
      ClassSymbol               : OPT_PAST_DOWNY_MILDEW_PRESSURE_THRESHOLD
      ClassName                 : optPastDownyMildewPressureThreshold
      ClassComment              : nivau d'attaque observe minimum pour continuer a traiter anti mildiou
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor OptPhytoTreatmentCadence {
      ClassSymbol               : OPT_PHYTO_TREATMENT_CADENCE
      ClassName                 : optPhytoTreatmentCadence
      ClassComment              : delai de retour du prochain traitement phyto
      ClassUnity                : jour
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptPhytoTreatmentRainAnticipation {
      ClassSymbol               : OPT_PHYTO_TREATMENT_RAIN_ANTICIPATION
      ClassName                 : optPhytoTreatmentRainAnticipation
      ClassComment              : on passe ... BEFORE : avant une pluie prevue ; AFTER : ... apres ...
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptPlantationOP {
      ClassSymbol               : OPT_PLANTATION_O_P
      ClassName                 : optPlantationOP
      ClassComment              : MID_FEB ; MID_MAR ; LATE_MAR ; EARLY_APR
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptPowderyMildewClosing {
      ClassSymbol               : OPT_POWDERY_MILDEW_CLOSING
      ClassName                 : optPowderyMildewClosing
      ClassComment              : 0:berry_touch ; 1:beg_ripening ; 2:end_ripening ; 3:august
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptPowderyMildewManagement {
      ClassSymbol               : OPT_POWDERY_MILDEW_MANAGEMENT
      ClassName                 : optPowderyMildewManagement
      ClassComment              : E1 ; E2 ; E3 ; G ; SG1 ; SG4
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptPrePruningModality {
      ClassSymbol               : OPT_PRE_PRUNING_MODALITY
      ClassName                 : optPrePruningModality
      ClassComment              : NONE ; ALL_PLOTS ; ALL_BUT_GOB ; LARGE ROYAT ; VIGOROUS ; ROYAT_VIGOROUS
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptPruningMinBegDate {
      ClassSymbol               : OPT_PRUNING_MIN_BEG_DATE
      ClassName                 : optPruningMinBegDate
      ClassComment              : jj/mm/aaaa
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptPruningOP {
      ClassSymbol               : OPT_PRUNING_O_P
      ClassName                 : optPruningOP
      ClassComment              : 0:earlyNov ; 1:midNov ; 2:endNov ; 3:earlyDec
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptRegularPhytoTreatmentsOP {
      ClassSymbol               : OPT_REGULAR_PHYTO_TREATMENTS_O_P
      ClassName                 : optRegularPhytoTreatmentsOP
      ClassComment              : de 1 (demarrage. precoce) a 6 (dem. tardif)
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptRidingOrientedInterRowProportion {
      ClassSymbol               : OPT_RIDING_ORIENTED_INTER_ROW_PROPORTION
      ClassName                 : optRidingOrientedInterRowProportion
      ClassComment              : valeur de reference pour les RidingOrientedInterRowProportion des parcelles
      ClassUnity                : %
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor OptShootThinningsOP {
      ClassSymbol               : OPT_SHOOT_THINNINGS_O_P
      ClassName                 : optShootThinningsOP
      ClassComment              : ONE_PLOT_PRUNED ; SURF_PRUNED_3 ; SURF_PRUNED_12 ; SURF_PRUNED_17 ; SURF_PRUNED_MAJ
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptSprayNumberAtBeginning {
      ClassSymbol               : OPT_SPRAY_NUMBER_AT_BEGINNING
      ClassName                 : optSprayNumberAtBeginning
      ClassComment              : 1 ou 2, typiquement
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor OptSprayPathAtBeginning {
      ClassSymbol               : OPT_SPRAY_PATH_AT_BEGINNING
      ClassName                 : optSprayPathAtBeginning
      ClassComment              : frequence de passage dans les IR au debut de l'iteration de traitements
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor OptSprayPathRegular {
      ClassSymbol               : OPT_SPRAY_PATH_REGULAR
      ClassName                 : optSprayPathRegular
      ClassComment              : frequence de passage dans les IR pour les traitements dans le cas general
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor OptSprayPathSinceFlowering {
      ClassSymbol               : OPT_SPRAY_PATH_SINCE_FLOWERING
      ClassName                 : optSprayPathSinceFlowering
      ClassComment              : frequence de passage dans les IR pour les traitements apres la floraison
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor OptSprayerTypeAtBeginning {
      ClassSymbol               : OPT_SPRAYER_TYPE_AT_BEGINNING
      ClassName                 : optSprayerTypeAtBeginning
      ClassComment              : cf. Enum_SprayerTypeOptions
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptSprayerTypeRegular {
      ClassSymbol               : OPT_SPRAYER_TYPE_REGULAR
      ClassName                 : optSprayerTypeRegular
      ClassComment              : cf. Enum_SprayerTypeOptions
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptSpringChemicalWeedingOP {
      ClassSymbol               : OPT_SPRING_CHEMICAL_WEEDING_O_P
      ClassName                 : optSpringChemicalWeedingOP
      ClassComment              : EARLY_JUN ; END_DEBR ; NONE
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptSpringFertMaxBegDate {
      ClassSymbol               : OPT_SPRING_FERT_MAX_BEG_DATE
      ClassName                 : optSpringFertMaxBegDate
      ClassComment              : jj/mm/aaaa
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptSpringFertMinBegDate {
      ClassSymbol               : OPT_SPRING_FERT_MIN_BEG_DATE
      ClassName                 : optSpringFertMinBegDate
      ClassComment              : jj/mm/aaaa
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptSpringTillagesIterationCP {
      ClassSymbol               : OPT_SPRING_TILLAGES_ITERATION_C_P
      ClassName                 : optSpringTillagesIterationCP
      ClassComment              : EARLY_JUNE ; EARLY_JUL ; MID_JUL ; TEN_AUGUST
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptSpringTillagesOP {
      ClassSymbol               : OPT_SPRING_TILLAGES_O_P
      ClassName                 : optSpringTillagesOP
      ClassComment              : WEED_COVER ; OPTIMIZATION ; OPPORTUNITY
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor OptSpringTillagesOPScope {
      ClassSymbol               : OPT_SPRING_TILLAGES_O_P_SCOPE
      ClassName                 : optSpringTillagesOPScope
      ClassComment              : FARM_SCOPE ; PLOT_SCOPE ; PLOT_GROUP_SCOPE
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor PathNameAttribute {
      ClassSymbol               : PATH_NAME_ATTRIBUTE
      ClassName                 : pathNameAttribute
      ClassComment              : chemin complet du fichier externe des donnees meteo de cette station
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor PercentAntiMildewTreated {
      ClassSymbol               : PERCENT_ANTI_MILDEW_TREATED
      ClassName                 : percentAntiMildewTreated
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
}
#==============================================
Descriptor PercentAutumnTilled {
      ClassSymbol               : PERCENT_AUTUMN_TILLED
      ClassName                 : percentAutumnTilled
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentClipped {
      ClassSymbol               : PERCENT_CLIPPED
      ClassName                 : percentClipped
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentDebranched {
      ClassSymbol               : PERCENT_DEBRANCHED
      ClassName                 : percentDebranched
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentExtraPhytoTreated {
      ClassSymbol               : PERCENT_EXTRA_PHYTO_TREATED
      ClassName                 : percentExtraPhytoTreated
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
}
#==============================================
Descriptor PercentFertilized {
      ClassSymbol               : PERCENT_FERTILIZED
      ClassName                 : percentFertilized
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentInitSpringTilled {
      ClassSymbol               : PERCENT_INIT_SPRING_TILLED
      ClassName                 : percentInitSpringTilled
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentPlanted {
      ClassSymbol               : PERCENT_PLANTED
      ClassName                 : percentPlanted
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : -1.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentPruned {
      ClassSymbol               : PERCENT_PRUNED
      ClassName                 : percentPruned
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentRegularPhytoTreated {
      ClassSymbol               : PERCENT_REGULAR_PHYTO_TREATED
      ClassName                 : percentRegularPhytoTreated
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
}
#==============================================
Descriptor PercentShootThinned {
      ClassSymbol               : PERCENT_SHOOT_THINNED
      ClassName                 : percentShootThinned
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentSpringTilled {
      ClassSymbol               : PERCENT_SPRING_TILLED
      ClassName                 : percentSpringTilled
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentSpringWeeded {
      ClassSymbol               : PERCENT_SPRING_WEEDED
      ClassName                 : percentSpringWeeded
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentTrellised {
      ClassSymbol               : PERCENT_TRELLISED
      ClassName                 : percentTrellised
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentWeeded {
      ClassSymbol               : PERCENT_WEEDED
      ClassName                 : percentWeeded
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PercentWinterTilled {
      ClassSymbol               : PERCENT_WINTER_TILLED
      ClassName                 : percentWinterTilled
      ClassComment              : -1. si sans objet ou dans [0. 1.]
      SubClass                  : VARIABLE
      Type                      : FLOAT
      SetDefaultValue           : 0.
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PestInfoMemoryAttribute {
      ClassSymbol               : PEST_INFO_MEMORY_ATTRIBUTE
      ClassName                 : pestInfoMemoryAttribute
      ClassComment              : attribut de VineyardSet : memoire des avertissements maladie
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
}
#==============================================
Descriptor PesticideSubtype {
      ClassSymbol               : PESTICIDE_SUBTYPE
      ClassName                 : pesticideSubtype
      ClassComment              : (preLevee, postLevee), (AntiMildiou, AntiOidium), ...
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor PesticideType {
      ClassSymbol               : PESTICIDE_TYPE
      ClassName                 : pesticideType
      ClassComment              : herbicide, fongicide, nematicide, ...
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "herbicide"
      AddSubDomain              : "fongicide"
}
#==============================================
Descriptor PhytoManagement {
      ClassSymbol               : PHYTO_MANAGEMENT
      ClassName                 : phytoManagement
      ClassComment              : necessairement en serie (SER) ou possiblement en parallele (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor PhytoTreatmentList {
      ClassSymbol               : PHYTO_TREATMENT_LIST
      ClassName                 : phytoTreatmentList
      ClassComment              : elements : anti-oidium anti-mildiou
      SubClass                  : CONSTANT
      Type                      : STRING_TAB
}
#==============================================
Descriptor PlaceName {
      ClassSymbol               : PLACE_NAME
      ClassName                 : placeName
      ClassComment              : lieu dit ou est situe la parcelle
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor PlantAttribute {
      ClassSymbol               : PLANT_ATTRIBUTE
      ClassName                 : plantAttribute
      ClassComment              : pointeur sur une instance de vegetation
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : VEGETATION
}
#==============================================
Descriptor PlantSpacing {
      ClassSymbol               : PLANT_SPACING
      ClassName                 : plantSpacing
      ClassComment              : ecartement entre les plants de vignes (sur le rang)
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor PlotPattern {
      ClassSymbol               : PLOT_PATTERN
      ClassName                 : plotPattern
      ClassComment              : instance de PlotInternalPatternOptionSubset
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
}
#==============================================
Descriptor PlotPatternOptionSetAttribute {
      ClassSymbol               : PLOT_PATTERN_OPTION_SET_ATTRIBUTE
      ClassName                 : plotPatternOptionSetAttribute
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
}
#==============================================
Descriptor PlotProfile {
      ClassSymbol               : PLOT_PROFILE
      ClassName                 : plotProfile
      ClassComment              : conjonction de specifications de domaines de valeurs
      SubClass                  : CONSTANT
      Type                      : DESCVALUESPEC_TAB
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PlotProfileOperator {
      ClassSymbol               : PLOT_PROFILE_OPERATOR
      ClassName                 : plotProfileOperator
      ClassComment              : IN=1 ou NOT_IN=0
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : 1
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor PowderyMildewFlagShoot {
      ClassSymbol               : POWDERY_MILDEW_FLAG_SHOOT
      ClassName                 : powderyMildewFlagShoot
      ClassComment              : 0=NON 1=OUI
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor PowderyMildewLevel {
      ClassSymbol               : POWDERY_MILDEW_LEVEL
      ClassName                 : powderyMildewLevel
      ClassComment              : 0=no 1=scarse 2=frequNoDammage 3=freqAndDommage
      SubClass                  : CONSTANT
      Type                      : INT
      AddSubDomain              : [ 0 ; 3 ]
}
#==============================================
Descriptor PowderyMildewManagementAttribute {
      ClassSymbol               : POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE
      ClassName                 : powderyMildewManagementAttribute
      ClassComment              : element de l'enum. PowderyMildewManagementModalities
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor PowderyMildewToClose {
      ClassSymbol               : POWDERY_MILDEW_TO_CLOSE
      ClassName                 : powderyMildewToClose
      ClassComment              : vrai s'il ya lieu d'arreter les traitements anti-oidium
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor PreviousReplicationRefDate {
      ClassSymbol               : PREVIOUS_REPLICATION_REF_DATE
      ClassName                 : previousReplicationRefDate
      ClassComment              : dans une iteration, au-dela de la premiere, date de la precedente activite iteree
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor PruningMode {
      ClassSymbol               : PRUNING_MODE
      ClassName                 : pruningMode
      ClassComment              : R, G, GOB
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor PruningsManagement {
      ClassSymbol               : PRUNINGS_MANAGEMENT
      ClassName                 : pruningsManagement
      ClassComment              : necessairement en serie (SER) ou possiblement en parallele (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor Rainfall {
      ClassSymbol               : RAINFALL
      ClassName                 : rainfall
      ClassComment              : quantite de precipitation tombee dans le pas du processus de lecture meteo
      ClassUnity                : mm
      SubClass                  : VARIABLE
      Type                      : FLOAT
}
#==============================================
Descriptor RecordedActivityClassName {
      ClassSymbol               : RECORDED_ACTIVITY_CLASS_NAME
      ClassName                 : recordedActivityClassName
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor RecordedChantierClassName {
      ClassSymbol               : RECORDED_CHANTIER_CLASS_NAME
      ClassName                 : recordedChantierClassName
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor RecordedDay {
      ClassSymbol               : RECORDED_DAY
      ClassName                 : recordedDay
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor RecordedInDayDuration {
      ClassSymbol               : RECORDED_IN_DAY_DURATION
      ClassName                 : recordedInDayDuration
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor RecordedJulianDay {
      ClassSymbol               : RECORDED_JULIAN_DAY
      ClassName                 : recordedJulianDay
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor RecordedMonth {
      ClassSymbol               : RECORDED_MONTH
      ClassName                 : recordedMonth
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor RecordedOperationClassName {
      ClassSymbol               : RECORDED_OPERATION_CLASS_NAME
      ClassName                 : recordedOperationClassName
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor RecordedPerformerList {
      ClassSymbol               : RECORDED_PERFORMER_LIST
      ClassName                 : recordedPerformerList
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : ENTITY_TAB
}
#==============================================
Descriptor RecordedPhytoProductList {
      ClassSymbol               : RECORDED_PHYTO_PRODUCT_LIST
      ClassName                 : recordedPhytoProductList
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : STRING_TAB
}
#==============================================
Descriptor RecordedPlotName {
      ClassSymbol               : RECORDED_PLOT_NAME
      ClassName                 : recordedPlotName
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor RecordedResourceList {
      ClassSymbol               : RECORDED_RESOURCE_LIST
      ClassName                 : recordedResourceList
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : ENTITY_TAB
}
#==============================================
Descriptor RecordedYear {
      ClassSymbol               : RECORDED_YEAR
      ClassName                 : recordedYear
      ClassComment              : attribut de OperationRecordedItem
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor RegularPhytoTreatmentIndex {
      ClassSymbol               : REGULAR_PHYTO_TREATMENT_INDEX
      ClassName                 : regularPhytoTreatmentIndex
      ClassComment              : numero d'ordre du chantier 'Regular' auquel est attache ce chantier 'Extra'
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor RelativeArea {
      ClassSymbol               : RELATIVE_AREA
      ClassName                 : relativeArea
      ClassComment              : pour une rangee, surface relative p.r. a la parcelle
      SubClass                  : CONSTANT
      Type                      : FLOAT
      AddSubDomain              : [ 0. ; 1. ]
}
#==============================================
Descriptor ReplicationInDryPeriodCounter {
      ClassSymbol               : REPLICATION_IN_DRY_PERIOD_COUNTER
      ClassName                 : replicationInDryPeriodCounter
      ClassComment              : descripteur de SpringTillageIteration
      SubClass                  : VARIABLE
      Type                      : INT
      SetDefaultValue           : 0
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor RidingOrientedInterRowProportion {
      ClassSymbol               : RIDING_ORIENTED_INTER_ROW_PROPORTION
      ClassName                 : ridingOrientedInterRowProportion
      ClassComment              : nombre d'inter-rangs avec fonction de passage / nombre d'inter-rangs
      ClassUnity                : %
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor RowManagement {
      ClassSymbol               : ROW_MANAGEMENT
      ClassName                 : rowManagement
      ClassComment              : GRASS_COVERING, etc
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor SeasonalEmploymentPlanAttribute {
      ClassSymbol               : SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE
      ClassName                 : seasonalEmploymentPlanAttribute
      ClassComment              : l'instance de SeasonalEmploymentPlan attachee a une Timetable
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : SEASONAL_EMPLOYMENT_PLAN
}
#==============================================
Descriptor ShootIntensity {
      ClassSymbol               : SHOOT_INTENSITY
      ClassName                 : shootIntensity
      ClassComment              : niveau de production des pampres
      SubClass                  : CONSTANT
      Type                      : INT
      AddSubDomain              : [ 0 ; 2 ]
}
#==============================================
Descriptor ShootThinningsManagement {
      ClassSymbol               : SHOOT_THINNINGS_MANAGEMENT
      ClassName                 : shootThinningsManagement
      ClassComment              : necessairement en serie (SER) ou possiblement en parallele (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor SkippedPlotsAttribute {
      ClassSymbol               : SKIPPED_PLOTS_ATTRIBUTE
      ClassName                 : skippedPlotsAttribute
      ClassComment              : les parcelles non traitees lors d'une iteration d'un chantier
      SubClass                  : CONSTANT
      Type                      : ENTITY_TAB
}
#==============================================
Descriptor SoilHumidityVectorFromMhydas {
      ClassSymbol               : SOIL_HUMIDITY_VECTOR_FROM_MHYDAS
      ClassName                 : soilHumidityVectorFromMhydas
      ClassComment              : pour une Row, vecteur des humidites sur les unit. hydro. identifiees dans Mhydas
      SubClass                  : CONSTANT
      Type                      : FLOAT_TAB
}
#==============================================
Descriptor SoilManagementGroupName {
      ClassSymbol               : SOIL_MANAGEMENT_GROUP_NAME
      ClassName                 : soilManagementGroupName
      ClassComment              : nom d'une instance de SoilManagementGroup, dscripteur de Plot
      SubClass                  : CONSTANT
      Type                      : STRING
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor SoilManagementGroupSetName {
      ClassSymbol               : SOIL_MANAGEMENT_GROUP_SET_NAME
      ClassName                 : soilManagementGroupSetName
      ClassComment              : nom d'une instance de SoilManagementGroupSet, descripteur d'ARB
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor SoilManagementModality {
      ClassSymbol               : SOIL_MANAGEMENT_MODALITY
      ClassName                 : soilManagementModality
      ClassComment              : symbole de la strategie d'entretien du sol d'un IR/R (Enum_SoilManagementModalities)
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor SoilManagementOption {
      ClassSymbol               : SOIL_MANAGEMENT_OPTION
      ClassName                 : soilManagementOption
      ClassComment              : symbole de la strategie d'entretien du sol d'un ARB (Enum_SoilManagementOptions)
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor SoilType {
      ClassSymbol               : SOIL_TYPE
      ClassName                 : soilType
      ClassComment              : TR, TB, TN, calcosol
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor SpringChemicalWeedingsManagement {
      ClassSymbol               : SPRING_CHEMICAL_WEEDINGS_MANAGEMENT
      ClassName                 : springChemicalWeedingsManagement
      ClassComment              : nécessairement en série (SER) ou possiblement en parallèle (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor SpringTillagesManagement {
      ClassSymbol               : SPRING_TILLAGES_MANAGEMENT
      ClassName                 : springTillagesManagement
      ClassComment              : necessairement en serie (SER) ou possiblement en parallele (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor StageName {
      ClassSymbol               : STAGE_NAME
      ClassName                 : stageName
      ClassComment              : nom du stade phenologique
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor StageTab {
      ClassSymbol               : STAGE_TAB
      ClassName                 : stageTab
      ClassComment              : tableau de stades phenologiques
      SubClass                  : CONSTANT
      Type                      : ENTITY_TAB
}
#==============================================
Descriptor StandardValuePriorityTab {
      ClassSymbol               : STANDARD_VALUE_PRIORITY_TAB
      ClassName                 : standardValuePriorityTab
      ClassComment              : priorites d'allocation par phase pour une classe d'activites primitives
      SubClass                  : CONSTANT
      Type                      : INT_TAB
}
#==============================================
Descriptor Stoniness {
      ClassSymbol               : STONINESS
      ClassName                 : stoniness
      ClassComment              : N, P, B
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor Temperature {
      ClassSymbol               : TEMPERATURE
      ClassName                 : temperature
      ClassComment              : temperature moyenne de l'air pendant le pas du processus de lecture meteo
      SubClass                  : VARIABLE
      Type                      : FLOAT
}
#==============================================
Descriptor TerminatedPlotsAttribute {
      ClassSymbol               : TERMINATED_PLOTS_ATTRIBUTE
      ClassName                 : terminatedPlotsAttribute
      ClassComment              : les parcelles terminees dans un chantier
      SubClass                  : CONSTANT
      Type                      : ENTITY_TAB
}
#==============================================
Descriptor ThermalTimeFromBbk {
      ClassSymbol               : THERMAL_TIME_FROM_BBK
      ClassName                 : thermalTimeFromBbk
      SubClass                  : VARIABLE
      Type                      : FLOAT
}
#==============================================
Descriptor ThermalTimeFromBbkToAchieve {
      ClassSymbol               : THERMAL_TIME_FROM_BBK_TO_ACHIEVE
      ClassName                 : thermalTimeFromBbkToAchieve
      ClassComment              : nombre thorique de deg.j entre le debourrement de la vigne et le stade X
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor ThermalTimeFromEmergence {
      ClassSymbol               : THERMAL_TIME_FROM_EMERGENCE
      ClassName                 : thermalTimeFromEmergence
      ClassComment              : age en degres.jour depuis la levee
      ClassUnity                : degres.jour
      SubClass                  : VARIABLE
      Type                      : FLOAT
}
#==============================================
Descriptor ThermalTimeFromSowing {
      ClassSymbol               : THERMAL_TIME_FROM_SOWING
      ClassName                 : thermalTimeFromSowing
      ClassComment              : age en degres.jour depuis le semis
      ClassUnity                : �C
      SubClass                  : VARIABLE
      Type                      : FLOAT
}
#==============================================
Descriptor ThermalTimeToAchieve {
      ClassSymbol               : THERMAL_TIME_TO_ACHIEVE
      ClassName                 : thermalTimeToAchieve
      ClassComment              : nombre theorique de degres.jour pour passer au stade suivant depuis le semis
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor ThermalTimeWhenAchieved {
      ClassSymbol               : THERMAL_TIME_WHEN_ACHIEVED
      ClassName                 : thermalTimeWhenAchieved
      ClassComment              : degres.jour accumules depuis le semis quand le stade est atteint
      ClassUnity                : �C
      SubClass                  : VARIABLE
      Type                      : FLOAT
}
#==============================================
Descriptor TimetableAttribute {
      ClassSymbol               : TIMETABLE_ATTRIBUTE
      ClassName                 : timetableAttribute
      ClassComment              : instance de RecurrentAvailabilityTimetable attachee a un SeasonalEmploymentPlan
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
}
#==============================================
Descriptor ToolClassName {
      ClassSymbol               : TOOL_CLASS_NAME
      ClassName                 : toolClassName
      ClassComment              : le nom de classe d'un materiel lie a l'entite decrite
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor TrellisMode {
      ClassSymbol               : TRELLIS_MODE
      ClassName                 : trellisMode
      ClassComment              : 1.1 , 1.1.2, 1.2.2
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor Village {
      ClassSymbol               : VILLAGE
      ClassName                 : village
      ClassComment              : commune ou est situee la parcelle
      SubClass                  : CONSTANT
      Type                      : STRING
}
#==============================================
Descriptor VineyardAttribute {
      ClassSymbol               : VINEYARD_ATTRIBUTE
      ClassName                 : vineyardAttribute
      ClassComment              : descripteur d'un VineyardControlPlan pointant sur le Vineyard
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
}
#==============================================
Descriptor WeatherStationAttribute {
      ClassSymbol               : WEATHER_STATION_ATTRIBUTE
      ClassName                 : weatherStationAttribute
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : WEATHER_STATION
}
#==============================================
Descriptor WeekDayNumber {
      ClassSymbol               : WEEK_DAY_NUMBER
      ClassName                 : weekDayNumber
      ClassComment              : 0 : dimanche, 1 : lundi, ... 6 : samedi pour un AvailabilityTimeSlot
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor Width {
      ClassSymbol               : WIDTH
      ClassName                 : width
      ClassComment              : largeur de quelque chose
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor WinterBeginningClock {
      ClassSymbol               : WINTER_BEGINNING_CLOCK
      ClassName                 : winterBeginningClock
      ClassComment              : descripteur de WeatherStation ; valeur parametree
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor WinterBeginningClockForInitst {
      ClassSymbol               : WINTER_BEGINNING_CLOCK_FOR_INITST
      ClassName                 : winterBeginningClockForInitst
      ClassComment              : descripteur de WeatherStation ; valeur parametree
      SubClass                  : CONSTANT
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor WinterTillagesManagement {
      ClassSymbol               : WINTER_TILLAGES_MANAGEMENT
      ClassName                 : winterTillagesManagement
      ClassComment              : necessairement en serie (SER) ou possiblement en parallele (PAR) sur les parcelles
      SubClass                  : CONSTANT
      Type                      : STRING
      AddSubDomain              : "SER"
      AddSubDomain              : "PAR"
}
#==============================================
Descriptor WorkBeginningHour {
      ClassSymbol               : WORK_BEGINNING_HOUR
      ClassName                 : workBeginningHour
      ClassComment              : heure a laquelle un premier travail a ete fait ce jour
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor WorkDayAfternoonBegHour {
      ClassSymbol               : WORK_DAY_AFTERNOON_BEG_HOUR
      ClassName                 : workDayAfternoonBegHour
      ClassComment              : heure d'embauche l'apres-midi (14h15 : 14,25)
      ClassUnity                : heures decimales
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor WorkDayAfternoonEndHour {
      ClassSymbol               : WORK_DAY_AFTERNOON_END_HOUR
      ClassName                 : workDayAfternoonEndHour
      ClassComment              : heure de fin de travail l'apres-midi (17h : 17,0)
      ClassUnity                : heures decimales
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor WorkDayAfternoonExtendedEndHour {
      ClassSymbol               : WORK_DAY_AFTERNOON_EXTENDED_END_HOUR
      ClassName                 : workDayAfternoonExtendedEndHour
      ClassComment              : heure maximale de fin de travail l'apres-midi (17h30 : 17,5)
      ClassUnity                : heures decimales
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor WorkDayMorningBegHour {
      ClassSymbol               : WORK_DAY_MORNING_BEG_HOUR
      ClassName                 : workDayMorningBegHour
      ClassComment              : heure d'embauche matinale (8h45 : 8,75)
      ClassUnity                : heures decimales
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor WorkDayMorningEndHour {
      ClassSymbol               : WORK_DAY_MORNING_END_HOUR
      ClassName                 : workDayMorningEndHour
      ClassComment              : heure de fin de travail en matinee (12h : 12,0)
      ClassUnity                : heures decimales
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor WorkDayMorningExtendedEndHour {
      ClassSymbol               : WORK_DAY_MORNING_EXTENDED_END_HOUR
      ClassName                 : workDayMorningExtendedEndHour
      ClassComment              : heure maximale de fin de travail en matinee (12h30 : 12,5)
      ClassUnity                : heures decimales
      SubClass                  : CONSTANT
      Type                      : FLOAT
}
#==============================================
Descriptor WorkOrganizationOptionSetAttribute {
      ClassSymbol               : WORK_ORGANIZATION_OPTION_SET_ATTRIBUTE
      ClassName                 : workOrganizationOptionSetAttribute
      ClassComment              : pointeur sur l'objet encapsulant les options de conduite
      SubClass                  : CONSTANT
      Type                      : P_ENTITY
      AddSubDomain              : WORK_ORGANIZATION_OPTION_SET
}
#==============================================
Descriptor WorkingTimeDailyLeft {
      ClassSymbol               : WORKING_TIME_DAILY_LEFT
      ClassName                 : workingTimeDailyLeft
      ClassComment              : nb d'heures de travail restant pour le jour en cours
      SubClass                  : VARIABLE
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor WorkingTimeDailyUpperBound {
      ClassSymbol               : WORKING_TIME_DAILY_UPPER_BOUND
      ClassName                 : workingTimeDailyUpperBound
      ClassComment              : nb d'heures max de travail par jour
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor WorkingTimeWeeklyLeft {
      ClassSymbol               : WORKING_TIME_WEEKLY_LEFT
      ClassName                 : workingTimeWeeklyLeft
      ClassComment              : nb d'heures de travail restant pour la semaine en cours
      SubClass                  : VARIABLE
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor WorkingTimeWeeklyUpperBound {
      ClassSymbol               : WORKING_TIME_WEEKLY_UPPER_BOUND
      ClassName                 : workingTimeWeeklyUpperBound
      ClassComment              : nb d'heures max de travail par semaine
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor WorkingTimeYearlyLeft {
      ClassSymbol               : WORKING_TIME_YEARLY_LEFT
      ClassName                 : workingTimeYearlyLeft
      ClassComment              : nb d'heures de travail restant pour l'annee en cours
      SubClass                  : VARIABLE
      Type                      : INT
      SetDefaultValue           : -9
      SetToDefaultValue         : TRUE
}
#==============================================
Descriptor WorkingTimeYearlyUpperBound {
      ClassSymbol               : WORKING_TIME_YEARLY_UPPER_BOUND
      ClassName                 : workingTimeYearlyUpperBound
      ClassComment              : nb d'heures max de travail par an
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor YearOfPlantation {
      ClassSymbol               : YEAR_OF_PLANTATION
      ClassName                 : yearOfPlantation
      ClassComment              : millesime (yyyy) de l'annee de plantation
      SubClass                  : CONSTANT
      Type                      : INT
}
#==============================================
Descriptor YearWhenAchieved {
      ClassSymbol               : YEAR_WHEN_ACHIEVED
      ClassName                 : yearWhenAchieved
      ClassComment              : millesime auquel le stade est completement realise
      SubClass                  : VARIABLE
      Type                      : INT
}
#==============================================

