##############
#  Activity  #
##############

PrimitiveActivity AutumnTillageActivity {
      ClassSymbol               : AUTUMN_TILLAGE_ACTIVITY
      ClassName                 : "autumnTillageActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : TILLAGE_ACTIVITY

}
#==============================================
PrimitiveActivity ChemicalWeedingActivity {
      ClassSymbol               : CHEMICAL_WEEDING_ACTIVITY
      ClassName                 : "chemicalWeedingActivity"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_ACTIVITY

      AddConstantDescriptor     : CommercialFormulationList   --- 
}
#==============================================
PrimitiveActivity ClippingActivity {
      ClassSymbol               : CLIPPING_ACTIVITY
      ClassName                 : "clippingActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_ACTIVITY

      OverloadedVarDesc value   : OperationClassId   CLIPPING_OPERATION 
}
#==============================================
NonPrimitiveActivity ConcurrentAntiMildewTreatments {
      ClassSymbol               : CONCURRENT_ANTI_MILDEW_TREATMENTS
      ClassName                 : "concurrentAntiMildewTreatments"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : AddNewSituatedPhytoTreatments
      AddMethod                 : SelectNewPlotsToPhytoProtect
}
#==============================================
NonPrimitiveActivity ConcurrentAutumnTillages {
      ClassSymbol               : CONCURRENT_AUTUMN_TILLAGES
      ClassName                 : "concurrentAutumnTillages"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToAutumnTill
      AddMethod                 : AddNewSituatedAutumnTillages
}
#==============================================
NonPrimitiveActivity ConcurrentChemicalWeedings {
      ClassSymbol               : CONCURRENT_CHEMICAL_WEEDINGS
      ClassName                 : "concurrentChemicalWeedings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToWeed
      AddMethod                 : AddNewSituatedChemicalWeedings
}
#==============================================
NonPrimitiveActivity ConcurrentClippings {
      ClassSymbol               : CONCURRENT_CLIPPINGS
      ClassName                 : "concurrentClippings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToClip
      AddMethod                 : AddNewSituatedClippings
}
#==============================================
NonPrimitiveActivity ConcurrentClippingsIteration {
      ClassSymbol               : CONCURRENT_CLIPPINGS_ITERATION
      ClassName                 : "concurrentClippingsIteration"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : DISTRIBUTED_ACTIVITY_SET_ITERATION

}
#==============================================
NonPrimitiveActivity ConcurrentDebranchings {
      ClassSymbol               : CONCURRENT_DEBRANCHINGS
      ClassName                 : "concurrentDebranchings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToDebranch
      AddMethod                 : AddNewSituatedDebranchings
}
#==============================================
NonPrimitiveActivity ConcurrentDistributedActivitySet {
      ClassSymbol               : CONCURRENT_DISTRIBUTED_ACTIVITY_SET
      ClassName                 : "concurrentDistributedActivitySet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ACTIVITY_CONJUNCTION
      SetMonitorToDescriptor    : EndDate 	DistributedActivitySetEndDateMonitor

      AddConstantDescriptor     : TerminatedPlotsAttribute   --- 
      AddConstantDescriptor     : SkippedPlotsAttribute   --- 
      AddConstantDescriptor     : NeedForNextFavourableDays   --- 
      AddConstantDescriptor     : ActualRealizationBegDate   --- 
      AddConstantDescriptor     : ActualRealizationEndDate   --- 
      AddConstantDescriptor     : ActivityNominalDate   --- 
      AddConstantDescriptor     : AllocationPriorityDegree   --- 
      AddVariableDescriptor     : OperatedVineyardSubArea   --- 
}
#==============================================
NonPrimitiveActivity ConcurrentExtraPhytoTreatments {
      ClassSymbol               : CONCURRENT_EXTRA_PHYTO_TREATMENTS
      ClassName                 : "concurrentExtraPhytoTreatments"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddConstantDescriptor     : RegularPhytoTreatmentIndex   --- 
      AddMethod                 : AddNewSituatedPhytoTreatments
      AddMethod                 : SelectNewPlotsToPhytoProtect
}
#==============================================
NonPrimitiveActivity ConcurrentFertilizations {
      ClassSymbol               : CONCURRENT_FERTILIZATIONS
      ClassName                 : "concurrentFertilizations"
      signatureConstructeur     : "(Vineyard* pEA, int season, int numPhase)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToFertilize
      AddMethod                 : AddNewSituatedFertilizations
}
#==============================================
NonPrimitiveActivity ConcurrentInitSpringTillages {
      ClassSymbol               : CONCURRENT_INIT_SPRING_TILLAGES
      ClassName                 : "concurrentInitSpringTillages"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToInitSpringTill
      AddMethod                 : AddNewSituatedInitSpringTillages
}
#==============================================
NonPrimitiveActivity ConcurrentPrunings {
      ClassSymbol               : CONCURRENT_PRUNINGS
      ClassName                 : "concurrentPrunings"
      signatureConstructeur     : "(Vineyard* pEA, int numPhase)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToPrune
      AddMethod                 : AddNewSituatedPrunings
}
#==============================================
NonPrimitiveActivity ConcurrentRegularPhytoTreatments {
      ClassSymbol               : CONCURRENT_REGULAR_PHYTO_TREATMENTS
      ClassName                 : "concurrentRegularPhytoTreatments"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddConstantDescriptor     : AntiMildewScheduled   --- 
      AddMethod                 : AddNewSituatedPhytoTreatments
      AddMethod                 : SelectNewPlotsToPhytoProtect
      AddMethod                 : SetScheduledAntiMildew
}
#==============================================
NonPrimitiveActivity ConcurrentShootThinnings {
      ClassSymbol               : CONCURRENT_SHOOT_THINNINGS
      ClassName                 : "concurrentShootThinnings"
      signatureConstructeur     : "(Vineyard* pVineyard, int numPhase)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : AddNewSituatedShootThinnings
      AddMethod                 : SelectNewPlotsToShootThin
}
#==============================================
NonPrimitiveActivity ConcurrentSpringChemicalWeedings {
      ClassSymbol               : CONCURRENT_SPRING_CHEMICAL_WEEDINGS
      ClassName                 : "concurrentSpringChemicalWeedings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToSpringWeed
      AddMethod                 : AddNewSituatedSpringChemicalWeedings
}
#==============================================
NonPrimitiveActivity ConcurrentSpringTillages {
      ClassSymbol               : CONCURRENT_SPRING_TILLAGES
      ClassName                 : "concurrentSpringTillages"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddConstantDescriptor     : FirstSpringTillageDate   --- 
      AddMethod                 : SelectNewPlotsToSpringTill
      AddMethod                 : AddNewSituatedSpringTillages
}
#==============================================
NonPrimitiveActivity ConcurrentTrellisings {
      ClassSymbol               : CONCURRENT_TRELLISINGS
      ClassName                 : "concurrentTrellisings"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToTrellis
      AddMethod                 : AddNewSituatedTrellisings
}
#==============================================
NonPrimitiveActivity ConcurrentWinterTillages {
      ClassSymbol               : CONCURRENT_WINTER_TILLAGES
      ClassName                 : "concurrentWinterTillages"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : CONCURRENT_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToWinterTill
      AddMethod                 : AddNewSituatedWinterTillages
}
#==============================================
NonPrimitiveActivity Conduite1 {
      ClassSymbol               : CONDUITE1
      ClassName                 : "conduite1"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_CONTROL_SEQUENCE

}
#==============================================
NonPrimitiveActivity Conduite2 {
      ClassSymbol               : CONDUITE2
      ClassName                 : "conduite2"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_CONTROL_SEQUENCE

}
#==============================================
NonPrimitiveActivity Conduite3 {
      ClassSymbol               : CONDUITE3
      ClassName                 : "conduite3"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_CONTROL_SEQUENCE

}
#==============================================
NonPrimitiveActivity Conduite4 {
      ClassSymbol               : CONDUITE4
      ClassName                 : "conduite4"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_CONTROL_SEQUENCE

}
#==============================================
NonPrimitiveActivity Conduite5 {
      ClassSymbol               : CONDUITE5
      ClassName                 : "conduite5"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_CONTROL_SEQUENCE

}
#==============================================
PrimitiveActivity DebranchingActivity {
      ClassSymbol               : DEBRANCHING_ACTIVITY
      ClassName                 : "debranchingActivity"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_ACTIVITY

}
#==============================================
NonPrimitiveActivity DistributedActivitySetIteration {
      ClassSymbol               : DISTRIBUTED_ACTIVITY_SET_ITERATION
      ClassName                 : "distributedActivitySetIteration"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ACTIVITY_ITERATION

}
#==============================================
NonPrimitiveActivity ExtraPhytoTreatmentsIteration {
      ClassSymbol               : EXTRA_PHYTO_TREATMENTS_ITERATION
      ClassName                 : "extraPhytoTreatmentsIteration"
      signatureConstructeur     : "(Vineyard* pEA, char* optionSerPar)"
      instanceList              : "yes"
      SetParentClassId          : DISTRIBUTED_ACTIVITY_SET_ITERATION

      OverloadedMethod body     : UpdateReactivatedSon   extraPhytoTreatmentsIteration_updateReactivatedSon_Body
      OverloadedMethod body     : OpeningPredicate   extraPhytoTreatmentsIteration_openingPredicate_Body
      OverloadedMethod body     : ClosingPredicate   extraPhytoTreatmentsIteration_closingPredicate_Body
}
#==============================================
PrimitiveActivity FertilizationActivity {
      ClassSymbol               : FERTILIZATION_ACTIVITY
      ClassName                 : "fertilizationActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_ACTIVITY

      OverloadedVarDesc value   : OperationClassId   FERTILIZATION_OPERATION 
}
#==============================================
PrimitiveActivity FormationPruningActivity {
      ClassSymbol               : FORMATION_PRUNING_ACTIVITY
      ClassName                 : "formationPruningActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : PRUNING_ACTIVITY

}
#==============================================
PrimitiveActivity GobeletPruningActivity {
      ClassSymbol               : GOBELET_PRUNING_ACTIVITY
      ClassName                 : "gobeletPruningActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : PRUNING_ACTIVITY

}
#==============================================
PrimitiveActivity GuyotPruningActivity {
      ClassSymbol               : GUYOT_PRUNING_ACTIVITY
      ClassName                 : "guyotPruningActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : PRUNING_ACTIVITY

}
#==============================================
PrimitiveActivity InitSpringTillageActivity {
      ClassSymbol               : INIT_SPRING_TILLAGE_ACTIVITY
      ClassName                 : "initSpringTillageActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : TILLAGE_ACTIVITY

}
#==============================================
PrimitiveActivity ManualChemicalDebranchingActivity {
      ClassSymbol               : MANUAL_CHEMICAL_DEBRANCHING_ACTIVITY
      ClassName                 : "manualChemicalDebranchingActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : DEBRANCHING_ACTIVITY

      AddConstantDescriptor     : CommercialFormulationList   --- 
      OverloadedVarDesc value   : OperationClassId   BACK_SPRAYING_OPERATION 
}
#==============================================
PrimitiveActivity ManualChemicalWeedingActivity {
      ClassSymbol               : MANUAL_CHEMICAL_WEEDING_ACTIVITY
      ClassName                 : "manualChemicalWeedingActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : CHEMICAL_WEEDING_ACTIVITY

      OverloadedVarDesc value   : OperationClassId   BACK_SPRAYING_OPERATION 
}
#==============================================
PrimitiveActivity ManualMechanicalDebranchingActivity {
      ClassSymbol               : MANUAL_MECHANICAL_DEBRANCHING_ACTIVITY
      ClassName                 : "manualMechanicalDebranchingActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : DEBRANCHING_ACTIVITY

      OverloadedVarDesc value   : OperationClassId   MANUAL_DEBRANCHING_OPERATION 
}
#==============================================
PrimitiveActivity ManualPhytoTreatmentActivity {
      ClassSymbol               : MANUAL_PHYTO_TREATMENT_ACTIVITY
      ClassName                 : "manualPhytoTreatmentActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : PHYTO_TREATMENT_ACTIVITY

      OverloadedVarDesc value   : OperationClassId   BACK_SPRAYING_OPERATION 
}
#==============================================
PrimitiveActivity MotorizedChemicalDebranchingActivity {
      ClassSymbol               : MOTORIZED_CHEMICAL_DEBRANCHING_ACTIVITY
      ClassName                 : "motorizedChemicalDebranchingActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : DEBRANCHING_ACTIVITY

      AddConstantDescriptor     : CommercialFormulationList   --- 
}
#==============================================
PrimitiveActivity MotorizedChemicalWeedingActivity {
      ClassSymbol               : MOTORIZED_CHEMICAL_WEEDING_ACTIVITY
      ClassName                 : "motorizedChemicalWeedingActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : CHEMICAL_WEEDING_ACTIVITY

}
#==============================================
PrimitiveActivity MotorizedPhytoTreatmentActivity {
      ClassSymbol               : MOTORIZED_PHYTO_TREATMENT_ACTIVITY
      ClassName                 : "motorizedPhytoTreatmentActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : PHYTO_TREATMENT_ACTIVITY

}
#==============================================
PrimitiveActivity PhytoTreatmentActivity {
      ClassSymbol               : PHYTO_TREATMENT_ACTIVITY
      ClassName                 : "phytoTreatmentActivity"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_ACTIVITY

      AddConstantDescriptor     : PhytoTreatmentList   --- 
      AddConstantDescriptor     : CommercialFormulationList   --- 
      AddConstantDescriptor     : CommercialFormulationDose   --- 
      AddMethod                 : ReturnPhytoTreatmentOperationSubclass
}
#==============================================
NonPrimitiveActivity PhytoTreatmentComposedProgram {
      ClassSymbol               : PHYTO_TREATMENT_COMPOSED_PROGRAM
      ClassName                 : "phytoTreatmentComposedProgram"
      signatureConstructeur     : "(Vineyard* pEA, char* optionSerPar)"
      instanceList              : "yes"
      SetParentClassId          : ACTIVITY_CONJUNCTION

      AddConstantDescriptor     : AntiMildewTreatmentJustDone   --- 
}
#==============================================
PrimitiveActivity PlantationActivity {
      ClassSymbol               : PLANTATION_ACTIVITY
      ClassName                 : "plantationActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_ACTIVITY

      OverloadedVarDesc value   : OperationClassId   PLANTATION_OPERATION 
}
#==============================================
PrimitiveActivity PruningActivity {
      ClassSymbol               : PRUNING_ACTIVITY
      ClassName                 : "pruningActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_ACTIVITY

      OverloadedConstDesc value : AllocationPriorityDegree   50 
      OverloadedVarDesc value   : OperationClassId   PRUNING_OPERATION 
}
#==============================================
NonPrimitiveActivity RegularPhytoTreatmentsIteration {
      ClassSymbol               : REGULAR_PHYTO_TREATMENTS_ITERATION
      ClassName                 : "regularPhytoTreatmentsIteration"
      signatureConstructeur     : "(Vineyard* pEA, char* optionSerPar)"
      instanceList              : "yes"
      SetParentClassId          : DISTRIBUTED_ACTIVITY_SET_ITERATION

      AddConstantDescriptor     : DownyMildewPressure   --- 
      AddConstantDescriptor     : DownyMildewToClose   --- 
      AddConstantDescriptor     : PowderyMildewToClose   --- 
      AddMethod                 : AntiPowderyMildewClosingPredicate
      AddMethod                 : AntiDownyMildewAtLeastClosingPredicate
      AddMethod                 : AntiDownyMildewUnderPressureClosingPredicate
      OverloadedMethod body     : UpdateReactivatedSon   regularPhytoTreatmentsIteration_updateReactivatedSon_Body
      OverloadedMethod body     : OpeningPredicate   regularPhytoTreatmentsIteration_openingPredicate_Body
      OverloadedMethod body     : ClosingPredicate   regularPhytoTreatmentsIteration_closingPredicate_Body
}
#==============================================
PrimitiveActivity RoyatPruningActivity {
      ClassSymbol               : ROYAT_PRUNING_ACTIVITY
      ClassName                 : "royatPruningActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : PRUNING_ACTIVITY

}
#==============================================
NonPrimitiveActivity SerialAntiMildewTreatments {
      ClassSymbol               : SERIAL_ANTI_MILDEW_TREATMENTS
      ClassName                 : "serialAntiMildewTreatments"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : AddNewSituatedPhytoTreatments
      AddMethod                 : SelectNewPlotsToPhytoProtect
}
#==============================================
NonPrimitiveActivity SerialAutumnTillages {
      ClassSymbol               : SERIAL_AUTUMN_TILLAGES
      ClassName                 : "serialAutumnTillages"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToAutumnTill
      AddMethod                 : AddNewSituatedAutumnTillages
}
#==============================================
NonPrimitiveActivity SerialChemicalWeedings {
      ClassSymbol               : SERIAL_CHEMICAL_WEEDINGS
      ClassName                 : "serialChemicalWeedings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToWeed
      AddMethod                 : AddNewSituatedChemicalWeedings
}
#==============================================
NonPrimitiveActivity SerialClippings {
      ClassSymbol               : SERIAL_CLIPPINGS
      ClassName                 : "serialClippings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToClip
      AddMethod                 : AddNewSituatedClippings
}
#==============================================
NonPrimitiveActivity SerialClippingsIteration {
      ClassSymbol               : SERIAL_CLIPPINGS_ITERATION
      ClassName                 : "serialClippingsIteration"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : DISTRIBUTED_ACTIVITY_SET_ITERATION

}
#==============================================
NonPrimitiveActivity SerialDebranchings {
      ClassSymbol               : SERIAL_DEBRANCHINGS
      ClassName                 : "serialDebranchings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToDebranch
      AddMethod                 : AddNewSituatedDebranchings
}
#==============================================
NonPrimitiveActivity SerialDistributedActivitySet {
      ClassSymbol               : SERIAL_DISTRIBUTED_ACTIVITY_SET
      ClassName                 : "serialDistributedActivitySet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ACTIVITY_MEETING_ANY
      SetMonitorToDescriptor    : EndDate 	DistributedActivitySetEndDateMonitor

      AddConstantDescriptor     : TerminatedPlotsAttribute   --- 
      AddConstantDescriptor     : SkippedPlotsAttribute   --- 
      AddConstantDescriptor     : NeedForNextFavourableDays   --- 
      AddConstantDescriptor     : ActualRealizationBegDate   --- 
      AddConstantDescriptor     : ActualRealizationEndDate   --- 
      AddConstantDescriptor     : ActivityNominalDate   --- 
      AddConstantDescriptor     : AllocationPriorityDegree   --- 
      AddVariableDescriptor     : OperatedVineyardSubArea   --- 
}
#==============================================
NonPrimitiveActivity SerialExtraPhytoTreatments {
      ClassSymbol               : SERIAL_EXTRA_PHYTO_TREATMENTS
      ClassName                 : "serialExtraPhytoTreatments"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddConstantDescriptor     : RegularPhytoTreatmentIndex   --- 
      AddMethod                 : AddNewSituatedPhytoTreatments
      AddMethod                 : SelectNewPlotsToPhytoProtect
}
#==============================================
NonPrimitiveActivity SerialFertilizations {
      ClassSymbol               : SERIAL_FERTILIZATIONS
      ClassName                 : "serialFertilizations"
      signatureConstructeur     : "(Vineyard* pEA, int season, int numPhase)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToFertilize
      AddMethod                 : AddNewSituatedFertilizations
}
#==============================================
NonPrimitiveActivity SerialInitSpringTillages {
      ClassSymbol               : SERIAL_INIT_SPRING_TILLAGES
      ClassName                 : "serialInitSpringTillages"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToInitSpringTill
      AddMethod                 : AddNewSituatedInitSpringTillages
}
#==============================================
NonPrimitiveActivity SerialManualChemicalWeedings {
      ClassSymbol               : SERIAL_MANUAL_CHEMICAL_WEEDINGS
      ClassName                 : "serialManualChemicalWeedings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_CHEMICAL_WEEDINGS

}
#==============================================
NonPrimitiveActivity SerialManualDebranchings {
      ClassSymbol               : SERIAL_MANUAL_DEBRANCHINGS
      ClassName                 : "serialManualDebranchings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DEBRANCHINGS

}
#==============================================
NonPrimitiveActivity SerialManualRegularPhytoTreatments {
      ClassSymbol               : SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS
      ClassName                 : "serialManualRegularPhytoTreatments"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_REGULAR_PHYTO_TREATMENTS

}
#==============================================
NonPrimitiveActivity SerialManualSpringChemicalWeedings {
      ClassSymbol               : SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS
      ClassName                 : "serialManualSpringChemicalWeedings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_SPRING_CHEMICAL_WEEDINGS

}
#==============================================
NonPrimitiveActivity SerialMotorizedChemicalWeedings {
      ClassSymbol               : SERIAL_MOTORIZED_CHEMICAL_WEEDINGS
      ClassName                 : "serialMotorizedChemicalWeedings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_CHEMICAL_WEEDINGS

}
#==============================================
NonPrimitiveActivity SerialMotorizedDebranchings {
      ClassSymbol               : SERIAL_MOTORIZED_DEBRANCHINGS
      ClassName                 : "serialMotorizedDebranchings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DEBRANCHINGS

}
#==============================================
NonPrimitiveActivity SerialMotorizedRegularPhytoTreatments {
      ClassSymbol               : SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS
      ClassName                 : "serialMotorizedRegularPhytoTreatments"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_REGULAR_PHYTO_TREATMENTS

}
#==============================================
NonPrimitiveActivity SerialMotorizedSpringChemicalWeedings {
      ClassSymbol               : SERIAL_MOTORIZED_SPRING_CHEMICAL_WEEDINGS
      ClassName                 : "serialMotorizedSpringChemicalWeedings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_SPRING_CHEMICAL_WEEDINGS

}
#==============================================
NonPrimitiveActivity SerialPlantations {
      ClassSymbol               : SERIAL_PLANTATIONS
      ClassName                 : "serialPlantations"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToPlant
      AddMethod                 : AddNewSituatedPlantations
}
#==============================================
NonPrimitiveActivity SerialPrunings {
      ClassSymbol               : SERIAL_PRUNINGS
      ClassName                 : "serialPrunings"
      signatureConstructeur     : "(Vineyard* pEA, int numPhase)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToPrune
      AddMethod                 : AddNewSituatedPrunings
}
#==============================================
NonPrimitiveActivity SerialRegularPhytoTreatments {
      ClassSymbol               : SERIAL_REGULAR_PHYTO_TREATMENTS
      ClassName                 : "serialRegularPhytoTreatments"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddConstantDescriptor     : AntiMildewScheduled   --- 
      AddMethod                 : AddNewSituatedPhytoTreatments
      AddMethod                 : SelectNewPlotsToPhytoProtect
      AddMethod                 : SetScheduledAntiMildew
}
#==============================================
NonPrimitiveActivity SerialShootThinnings {
      ClassSymbol               : SERIAL_SHOOT_THINNINGS
      ClassName                 : "serialShootThinnings"
      signatureConstructeur     : "(Vineyard* pVineyard, int numPhase)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToShootThin
      AddMethod                 : AddNewSituatedShootThinnings
}
#==============================================
NonPrimitiveActivity SerialSpringChemicalWeedings {
      ClassSymbol               : SERIAL_SPRING_CHEMICAL_WEEDINGS
      ClassName                 : "serialSpringChemicalWeedings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToSpringWeed
      AddMethod                 : AddNewSituatedSpringChemicalWeedings
}
#==============================================
NonPrimitiveActivity SerialSpringTillages {
      ClassSymbol               : SERIAL_SPRING_TILLAGES
      ClassName                 : "serialSpringTillages"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddConstantDescriptor     : FirstSpringTillageDate   --- 
      AddMethod                 : SelectNewPlotsToSpringTill
      AddMethod                 : AddNewSituatedSpringTillages
}
#==============================================
NonPrimitiveActivity SerialTrellisings {
      ClassSymbol               : SERIAL_TRELLISINGS
      ClassName                 : "serialTrellisings"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToTrellis
      AddMethod                 : AddNewSituatedTrellisings
}
#==============================================
NonPrimitiveActivity SerialTrellisingsIteration {
      ClassSymbol               : SERIAL_TRELLISINGS_ITERATION
      ClassName                 : "serialTrellisingsIteration"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : DISTRIBUTED_ACTIVITY_SET_ITERATION

}
#==============================================
NonPrimitiveActivity SerialWinterTillages {
      ClassSymbol               : SERIAL_WINTER_TILLAGES
      ClassName                 : "serialWinterTillages"
      signatureConstructeur     : "(Vineyard* pVineyard)"
      instanceList              : "yes"
      SetParentClassId          : SERIAL_DISTRIBUTED_ACTIVITY_SET

      AddMethod                 : SelectNewPlotsToWinterTill
      AddMethod                 : AddNewSituatedWinterTillages
}
#==============================================
PrimitiveActivity ShootThinningActivity {
      ClassSymbol               : SHOOT_THINNING_ACTIVITY
      ClassName                 : "shootThinningActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_ACTIVITY

      OverloadedVarDesc value   : OperationClassId   SHOOT_THINNING_OPERATION 
      AddMethod                 : ReturnShootThinningOperationSubclass
}
#==============================================
PrimitiveActivity SpringTillageActivity {
      ClassSymbol               : SPRING_TILLAGE_ACTIVITY
      ClassName                 : "springTillageActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : TILLAGE_ACTIVITY

}
#==============================================
NonPrimitiveActivity SpringTillagesIteration {
      ClassSymbol               : SPRING_TILLAGES_ITERATION
      ClassName                 : "springTillagesIteration"
      signatureConstructeur     : "(Vineyard* pEA, char* optionSerPar)"
      instanceList              : "yes"
      SetParentClassId          : DISTRIBUTED_ACTIVITY_SET_ITERATION

      AddConstantDescriptor     : PreviousReplicationRefDate   --- 
      AddConstantDescriptor     : MaxReplicationNumberInDryPeriod   --- 
      AddVariableDescriptor     : ReplicationInDryPeriodCounter   --- 
      OverloadedMethod body     : UpdateReactivatedSon   springTillagesIteration_updateReactivatedSon_Body
      OverloadedMethod body     : OpeningPredicate   springTillagesIteration_openingPredicate_Body
      OverloadedMethod body     : ClosingPredicate   springTillagesIteration_closingPredicate_Body
}
#==============================================
PrimitiveActivity TillageActivity {
      ClassSymbol               : TILLAGE_ACTIVITY
      ClassName                 : "tillageActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_ACTIVITY

      OverloadedVarDesc value   : OperationClassId   TILLAGE_OPERATION 
      AddMethod                 : ReturnTillageOperationSubclass
}
#==============================================
PrimitiveActivity TrellisingActivity {
      ClassSymbol               : TRELLISING_ACTIVITY
      ClassName                 : "trellisingActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : VINEYARD_ACTIVITY

      OverloadedVarDesc value   : OperationClassId   TRELLISING_OPERATION 
}
#==============================================
PrimitiveActivity VineyardActivity {
      ClassSymbol               : VINEYARD_ACTIVITY
      ClassName                 : "vineyardActivity"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PRIMITIVE_ACTIVITY

      AddConstantDescriptor     : MinPercentageToBeginOperation   --- 
      AddConstantDescriptor     : MeanPriorityDegree   --- 
      AddMethod                 : OperationNominalDuration
      OverloadedMethod body     : SetUserOperationName   vineyardActivity_setUserOperationName_Body
      OverloadedMethod body     : MaxBegStatePredicate   vineyardActivity_maxBegStatePredicate_Body
}
#==============================================
NonPrimitiveActivity VineyardControlSequence {
      ClassSymbol               : VINEYARD_CONTROL_SEQUENCE
      ClassName                 : "vineyardControlSequence"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ACTIVITY_BEFORE

      AddConstantDescriptor     : VineyardAttribute   --- 
      AddConstantDescriptor     : FlagMildew   --- 
      AddConstantDescriptor     : DownyMildewManagementAttribute   --- 
      AddConstantDescriptor     : PowderyMildewManagementAttribute   --- 
      AddMethod                 : SetFlagMildew
}
#==============================================
NonPrimitiveActivity VineyardIteratedConjunctiveSubplan {
      ClassSymbol               : VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN
      ClassName                 : "vineyardIteratedConjunctiveSubplan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ACTIVITY_CONJUNCTION

}
#==============================================
NonPrimitiveActivity VineyardPhaseConjunctivePlan {
      ClassSymbol               : VINEYARD_PHASE_CONJUNCTIVE_PLAN
      ClassName                 : "vineyardPhaseConjunctivePlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ACTIVITY_CONJUNCTION

}
#==============================================
NonPrimitiveActivity VineyardPhaseOptionalPlan {
      ClassSymbol               : VINEYARD_PHASE_OPTIONAL_PLAN
      ClassName                 : "vineyardPhaseOptionalPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ACTIVITY_OPTIONAL

}
#==============================================
PrimitiveActivity WinterTillageActivity {
      ClassSymbol               : WINTER_TILLAGE_ACTIVITY
      ClassName                 : "winterTillageActivity"
      signatureConstructeur     : "(Vineyard* pEA)"
      instanceList              : "yes"
      SetParentClassId          : TILLAGE_ACTIVITY

}
#==============================================

