############
#  Entity  #
############

Entity AgroClimaticSystem {
      ClassSymbol               : AGRO_CLIMATIC_SYSTEM
      ClassName                 : "agroClimaticSystem"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      AddComponentClassId       : WEATHER_STATION_SET
      AddComponentClassId       : VINEYARD_SET

}
#==============================================
Entity AllocationPriorityOptionSet {
      ClassSymbol               : ALLOCATION_PRIORITY_OPTION_SET
      ClassName                 : "allocationPriorityOptionSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : ALLOCATION_PRIORITY_OPTION_SUBSET

}
#==============================================
Entity AllocationPriorityOptionSubset {
      ClassSymbol               : ALLOCATION_PRIORITY_OPTION_SUBSET
      ClassName                 : "allocationPriorityOptionSubset"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : StandardValuePriorityTab   --- 
      AddConstantDescriptor     : IsAllocationExclusive   --- 
}
#==============================================
Entity AnnualEmploymentPlan {
      ClassSymbol               : ANNUAL_EMPLOYMENT_PLAN
      ClassName                 : "annualEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : SEASONAL_EMPLOYMENT_PLAN

      AddConstantDescriptor     : FarmWorkerAttribute   --- 
      AddConstantDescriptor     : OffWorkCalendarAttribute   --- 
      AddMethod                 : UpdateSeasonCurrentIndex
      AddMethod                 : AttachFarmWorkerToTimetables
}
#==============================================
Entity AprilEmploymentPlan {
      ClassSymbol               : APRIL_EMPLOYMENT_PLAN
      ClassName                 : "aprilEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SEASONAL_EMPLOYMENT_PLAN

      OverloadedMethod body     : TimetableOpeningPredicate   aprilEmploymentPlan_timetableOpeningPredicate_Body
}
#==============================================
Entity AprilNormalHoursEmploymentPlan {
      ClassSymbol               : APRIL_NORMAL_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "aprilNormalHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : APRIL_EMPLOYMENT_PLAN

}
#==============================================
Entity AprilReducedHoursEmploymentPlan {
      ClassSymbol               : APRIL_REDUCED_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "aprilReducedHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : APRIL_EMPLOYMENT_PLAN

}
#==============================================
Entity CropRow {
      ClassSymbol               : CROP_ROW
      ClassName                 : "cropRow"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ROW
      AddComponentClassId       : GRAPEVINE
      AddComponentClassId       : SOIL_SURFACE

}
#==============================================
Entity DecisionOptionSet {
      ClassSymbol               : DECISION_OPTION_SET
      ClassName                 : "decisionOptionSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : OptFertilizationSeason   --- 
      AddConstantDescriptor     : OptSpringFertMinBegDate   --- 
      AddConstantDescriptor     : OptSpringFertMaxBegDate   --- 
      AddConstantDescriptor     : OptPruningMinBegDate   --- 
      AddConstantDescriptor     : OptSprayerTypeRegular   --- 
      AddConstantDescriptor     : OptSprayerTypeAtBeginning   --- 
      AddConstantDescriptor     : OptSprayNumberAtBeginning   --- 
      AddConstantDescriptor     : OptSprayPathAtBeginning   --- 
      AddConstantDescriptor     : OptSprayPathRegular   --- 
      AddConstantDescriptor     : OptSprayPathSinceFlowering   --- 
      AddConstantDescriptor     : OptFertilizationOP   --- 
      AddConstantDescriptor     : OptPruningOP   --- 
      AddConstantDescriptor     : OptRegularPhytoTreatmentsOP   --- 
      AddConstantDescriptor     : GuidingEarlyVarietyAttribute   --- 
      AddConstantDescriptor     : GuidingLateVarietyAttribute   --- 
      AddConstantDescriptor     : OptDownyMildewManagement   --- 
      AddConstantDescriptor     : OptPowderyMildewManagement   --- 
      AddConstantDescriptor     : OptPhytoTreatmentCadence   --- 
      AddConstantDescriptor     : OptPhytoTreatmentRainAnticipation   --- 
      AddConstantDescriptor     : OptExtraPhytoTreatmentsOP   --- 
      AddConstantDescriptor     : OptPowderyMildewClosing   --- 
      AddConstantDescriptor     : OptPastDownyMildewPressureThreshold   --- 
      AddConstantDescriptor     : OptActualDownyMildewRiskThreshold   --- 
      AddConstantDescriptor     : OptDownyMildewAtLeastClosing   --- 
      AddConstantDescriptor     : OptDownyMildewUnderPressureClosing   --- 
      AddConstantDescriptor     : OptAutumnTillageCP   --- 
      AddConstantDescriptor     : OptSpringTillagesOP   --- 
      AddConstantDescriptor     : OptFirstSpringTillageOP   --- 
      AddConstantDescriptor     : OptSpringTillagesOPScope   --- 
      AddConstantDescriptor     : OptSpringTillagesIterationCP   --- 
      AddConstantDescriptor     : OptAutumnTillageOP   --- 
      AddConstantDescriptor     : OptShootThinningsOP   --- 
      AddConstantDescriptor     : OptInitSpringTillageOP   --- 
      AddConstantDescriptor     : OptChemicalWeedingOP   --- 
      AddConstantDescriptor     : OptPlantationOP   --- 
      AddConstantDescriptor     : OptDebranchingModality   --- 
      AddConstantDescriptor     : OptPrePruningModality   --- 
      AddConstantDescriptor     : OptSpringChemicalWeedingOP   --- 
}
#==============================================
Entity DistributedActivitySetMemoryItem {
      ClassSymbol               : DISTRIBUTED_ACTIVITY_SET_MEMORY_ITEM
      ClassName                 : "distributedActivitySetMemoryItem"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : ActivityNameAttribute   --- 
      AddConstantDescriptor     : ActivityAttribute   --- 
      AddVariableDescriptor     : BegDate   --- 
      AddVariableDescriptor     : EndDate   --- 
}
#==============================================
Entity FebruaryMarchEmploymentPlan {
      ClassSymbol               : FEBRUARY_MARCH_EMPLOYMENT_PLAN
      ClassName                 : "februaryMarchEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SEASONAL_EMPLOYMENT_PLAN

      OverloadedMethod body     : TimetableOpeningPredicate   februaryMarchEmploymentPlan_timetableOpeningPredicate_Body
}
#==============================================
Entity FebruaryMarchNormalHoursEmploymentPlan {
      ClassSymbol               : FEBRUARY_MARCH_NORMAL_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "februaryMarchNormalHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FEBRUARY_MARCH_EMPLOYMENT_PLAN

}
#==============================================
Entity FebruaryMarchReducedHoursEmploymentPlan {
      ClassSymbol               : FEBRUARY_MARCH_REDUCED_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "februaryMarchReducedHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FEBRUARY_MARCH_EMPLOYMENT_PLAN

}
#==============================================
Entity GrapeVariety {
      ClassSymbol               : GRAPE_VARIETY
      ClassName                 : "grapeVariety"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : IsEarly   --- 
      AddConstantDescriptor     : ShootIntensity   0 
}
#==============================================
Entity Grapevine {
      ClassSymbol               : GRAPEVINE
      ClassName                 : "grapevine"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : VEGETATION

      AddConstantDescriptor     : IsoAgeingEntityAttribute   --- 
}
#==============================================
Entity GrapevineAge {
      ClassSymbol               : GRAPEVINE_AGE
      ClassName                 : "grapevineAge"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PLANT_AGE

}
#==============================================
Entity Grass {
      ClassSymbol               : GRASS
      ClassName                 : "grass"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : VEGETATION

      AddConstantDescriptor     : GrassTypeAttribute   --- 
}
#==============================================
Entity GrassAge {
      ClassSymbol               : GRASS_AGE
      ClassName                 : "grassAge"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PLANT_AGE

      AddVariableDescriptor     : ThermalTimeFromEmergence   --- 
}
#==============================================
Entity GrassType {
      ClassSymbol               : GRASS_TYPE
      ClassName                 : "grassType"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : LeafAreaIndexRate   --- 
      AddConstantDescriptor     : LeafLifeSpanMin   --- 
      AddConstantDescriptor     : LaiForMowing   --- 
      AddVariableDescriptor     : LeafAreaIndexResidual   --- 
      AddVariableDescriptor     : LaiForSenescence   --- 
}
#==============================================
Entity InterRow {
      ClassSymbol               : INTER_ROW
      ClassName                 : "interRow"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ROW
      AddComponentClassId       : GRASS
      AddComponentClassId       : SOIL_SURFACE
      AddComponentClassId       : SOIL_RESERVOIR

}
#==============================================
Entity IsoAgeingEntity {
      ClassSymbol               : ISO_AGEING_ENTITY
      ClassName                 : "isoAgeingEntity"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : WeatherStationAttribute   --- 
      AddConstantDescriptor     : GrapeVarietyAttribute   --- 
      AddConstantDescriptor     : AgeAttribute   --- 
}
#==============================================
Entity LastOperationsMemory {
      ClassSymbol               : LAST_OPERATIONS_MEMORY
      ClassName                 : "lastOperationsMemory"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : LAST_OPERATIONS_MEMORY_ITEM

}
#==============================================
Entity LastOperationsMemoryItem {
      ClassSymbol               : LAST_OPERATIONS_MEMORY_ITEM
      ClassName                 : "lastOperationsMemoryItem"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : ToolClassName   --- 
}
#==============================================
Entity LastPesticideApplicationsMemoryItem {
      ClassSymbol               : LAST_PESTICIDE_APPLICATIONS_MEMORY_ITEM
      ClassName                 : "lastPesticideApplicationsMemoryItem"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : LAST_OPERATIONS_MEMORY_ITEM

      AddConstantDescriptor     : PesticideType   --- 
      AddConstantDescriptor     : PesticideSubtype   --- 
      AddConstantDescriptor     : CommercialFormulation   --- 
      AddConstantDescriptor     : CommercialFormulationDose   --- 
      AddConstantDescriptor     : ActuallyOperatedAreaPercentage   --- 
}
#==============================================
Entity LastTillageOperationsMemoryItem {
      ClassSymbol               : LAST_TILLAGE_OPERATIONS_MEMORY_ITEM
      ClassName                 : "lastTillageOperationsMemoryItem"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : LAST_OPERATIONS_MEMORY_ITEM

}
#==============================================
Entity ManagerAnnualEmploymentPlan {
      ClassSymbol               : MANAGER_ANNUAL_EMPLOYMENT_PLAN
      ClassName                 : "managerAnnualEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ANNUAL_EMPLOYMENT_PLAN

}
#==============================================
Entity MayAugustEmploymentPlan {
      ClassSymbol               : MAY_AUGUST_EMPLOYMENT_PLAN
      ClassName                 : "mayAugustEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SEASONAL_EMPLOYMENT_PLAN

      OverloadedMethod body     : TimetableOpeningPredicate   mayAugustEmploymentPlan_timetableOpeningPredicate_Body
}
#==============================================
Entity MayAugustExtendedHoursEmploymentPlan {
      ClassSymbol               : MAY_AUGUST_EXTENDED_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "mayAugustExtendedHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MAY_AUGUST_EMPLOYMENT_PLAN

}
#==============================================
Entity MayAugustNormalHoursEmploymentPlan {
      ClassSymbol               : MAY_AUGUST_NORMAL_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "mayAugustNormalHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MAY_AUGUST_EMPLOYMENT_PLAN

}
#==============================================
Entity MayAugustReducedHoursEmploymentPlan {
      ClassSymbol               : MAY_AUGUST_REDUCED_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "mayAugustReducedHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MAY_AUGUST_EMPLOYMENT_PLAN

}
#==============================================
Entity NovemberJanuaryEmploymentPlan {
      ClassSymbol               : NOVEMBER_JANUARY_EMPLOYMENT_PLAN
      ClassName                 : "novemberJanuaryEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SEASONAL_EMPLOYMENT_PLAN

      OverloadedMethod body     : TimetableOpeningPredicate   novemberJanuaryEmploymentPlan_timetableOpeningPredicate_Body
}
#==============================================
Entity NovemberJanuaryNormalHoursEmploymentPlan {
      ClassSymbol               : NOVEMBER_JANUARY_NORMAL_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "novemberJanuaryNormalHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : NOVEMBER_JANUARY_EMPLOYMENT_PLAN

}
#==============================================
Entity NovemberJanuaryReducedHoursEmploymentPlan {
      ClassSymbol               : NOVEMBER_JANUARY_REDUCED_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "novemberJanuaryReducedHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : NOVEMBER_JANUARY_EMPLOYMENT_PLAN

}
#==============================================
Entity OffWorkCalendar {
      ClassSymbol               : OFF_WORK_CALENDAR
      ClassName                 : "offWorkCalendar"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : OFF_WORK_SINGLE_PERIOD

      AddMethod                 : UpdateOffPeriodCurrentIndex
      AddMethod                 : IsClockValueInCalendar
}
#==============================================
Entity OffWorkSinglePeriod {
      ClassSymbol               : OFF_WORK_SINGLE_PERIOD
      ClassName                 : "offWorkSinglePeriod"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : BeginningCalendarDate   --- 
      AddConstantDescriptor     : EndCalendarDate   --- 
      AddMethod                 : IsClockValueInPeriod
}
#==============================================
Entity OperationPriorityOptionSet {
      ClassSymbol               : OPERATION_PRIORITY_OPTION_SET
      ClassName                 : "operationPriorityOptionSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : OPERATION_PRIORITY_OPTION_SUBSET

}
#==============================================
Entity OperationPriorityOptionSubset {
      ClassSymbol               : OPERATION_PRIORITY_OPTION_SUBSET
      ClassName                 : "operationPriorityOptionSubset"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : StandardValuePriorityTab   --- 
}
#==============================================
Entity OperationRecordingItem {
      ClassSymbol               : OPERATION_RECORDING_ITEM
      ClassName                 : "operationRecordingItem"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : RecordedYear   --- 
      AddConstantDescriptor     : RecordedMonth   --- 
      AddConstantDescriptor     : RecordedDay   --- 
      AddConstantDescriptor     : RecordedJulianDay   --- 
      AddConstantDescriptor     : RecordedPlotName   --- 
      AddConstantDescriptor     : RecordedActivityClassName   --- 
      AddConstantDescriptor     : RecordedChantierClassName   --- 
      AddConstantDescriptor     : RecordedOperationClassName   --- 
      AddConstantDescriptor     : RecordedInDayDuration   --- 
      AddConstantDescriptor     : RecordedResourceList   --- 
      AddConstantDescriptor     : RecordedPerformerList   --- 
      AddConstantDescriptor     : RecordedPhytoProductList   --- 
}
#==============================================
Entity OperationRecordingStructure {
      ClassSymbol               : OPERATION_RECORDING_STRUCTURE
      ClassName                 : "operationRecordingStructure"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : OPERATION_RECORDING_ITEM

}
#==============================================
Entity PestInfoMemory {
      ClassSymbol               : PEST_INFO_MEMORY
      ClassName                 : "pestInfoMemory"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : PEST_INFO_MEMORY_ITEM

}
#==============================================
Entity PestInfoMemoryItem {
      ClassSymbol               : PEST_INFO_MEMORY_ITEM
      ClassName                 : "pestInfoMemoryItem"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : InstantAttribute   --- 
      AddConstantDescriptor     : PowderyMildewFlagShoot   --- 
      AddConstantDescriptor     : PowderyMildewLevel   --- 
      AddConstantDescriptor     : DownyMildewPrimaryInfection   --- 
      AddConstantDescriptor     : DownyMildewLevel   --- 
      AddConstantDescriptor     : DownyMildewRiskLevel   --- 
}
#==============================================
Entity PhenoStage {
      ClassSymbol               : PHENO_STAGE
      ClassName                 : "phenoStage"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : ThermalTimeToAchieve   --- 
      AddConstantDescriptor     : StageName   --- 
      AddConstantDescriptor     : JulianTimeToAchieve   --- 
      AddConstantDescriptor     : DayOfAchievement   --- 
      AddVariableDescriptor     : DayWhenAchieved   --- 
      AddVariableDescriptor     : ThermalTimeWhenAchieved   --- 
      AddVariableDescriptor     : YearWhenAchieved   --- 
}
#==============================================
Entity PlantAge {
      ClassSymbol               : PLANT_AGE
      ClassName                 : "plantAge"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : StageTab   --- 
      AddConstantDescriptor     : IsoAgeingEntityAttribute   --- 
      AddVariableDescriptor     : DaysNumber   --- 
      AddVariableDescriptor     : CurrentStageIndex   --- 
      AddVariableDescriptor     : ThermalTimeFromSowing   --- 
      AddMethod                 : SetDayWhenStageAchieved
      AddMethod                 : GetDayWhenStageAchieved
      AddMethod                 : GetActualThermalTimeFromEmergence
}
#==============================================
Entity Plot {
      ClassSymbol               : PLOT
      ClassName                 : "plot"
      signatureConstructeur     : "(char* name)"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      AddComponentClassId       : VEGETAL_COMPARTMENT
      AddComponentClassId       : SOIL_RESERVOIR

      AddConstantDescriptor     : WeatherStationAttribute   --- 
      AddConstantDescriptor     : Latitude   --- 
      AddConstantDescriptor     : Longitude   --- 
      AddConstantDescriptor     : Village   --- 
      AddConstantDescriptor     : Area   --- 
      AddConstantDescriptor     : AlleyWidth   --- 
      AddConstantDescriptor     : PlantSpacing   --- 
      AddConstantDescriptor     : YearOfPlantation   --- 
      AddConstantDescriptor     : LandUse   --- 
      AddConstantDescriptor     : PlaceName   --- 
      AddConstantDescriptor     : SoilType   --- 
      AddConstantDescriptor     : SoilManagementGroupName   --- 
      AddConstantDescriptor     : Stoniness   --- 
      AddConstantDescriptor     : PruningMode   --- 
      AddConstantDescriptor     : TrellisMode   --- 
      AddConstantDescriptor     : GrapeVarietyAttribute   --- 
      AddConstantDescriptor     : RowManagement   --- 
      AddConstantDescriptor     : CropRowAlleyWidthRatio   --- 
      AddConstantDescriptor     : GrassStripAlleyWidthRatio   --- 
      AddConstantDescriptor     : RidingOrientedInterRowProportion   --- 
      AddConstantDescriptor     : LastTillageOperationClock   --- 
      AddVariableDescriptor     : CumulativeRainfallFromMhydasInteraction   --- 
      AddVariableDescriptor     : CumulativeRainfallFromLastTillage   --- 
      AddVariableDescriptor     : CumulativeRainfallFromEarlyWinter   --- 
      AddVariableDescriptor     : CumulativeRainfallFromEarlyWinterForInitst   --- 
      AddVariableDescriptor     : PercentAntiMildewTreated   --- 
      AddVariableDescriptor     : PercentAutumnTilled   --- 
      AddVariableDescriptor     : PercentClipped   --- 
      AddVariableDescriptor     : PercentDebranched   --- 
      AddVariableDescriptor     : PercentExtraPhytoTreated   --- 
      AddVariableDescriptor     : PercentFertilized   --- 
      AddVariableDescriptor     : PercentInitSpringTilled   --- 
      AddVariableDescriptor     : PercentPlanted   --- 
      AddVariableDescriptor     : PercentPruned   --- 
      AddVariableDescriptor     : PercentRegularPhytoTreated   --- 
      AddVariableDescriptor     : PercentShootThinned   --- 
      AddVariableDescriptor     : PercentSpringTilled   --- 
      AddVariableDescriptor     : PercentSpringWeeded   --- 
      AddVariableDescriptor     : PercentTrellised   --- 
      AddVariableDescriptor     : PercentWeeded   --- 
      AddVariableDescriptor     : PercentWinterTilled   --- 
      AddMethod                 : IsMotorizationPossible
      AddMethod                 : AssignRelativeAreaToRows
      AddMethod                 : ReturnPassedRowsFrequency
      AddMethod                 : SetRowSoilManagement
      AddMethod                 : ReturnSoilManagementGroupOnProfile
}
#==============================================
Entity PlotInternalPatternOptionSet {
      ClassSymbol               : PLOT_INTERNAL_PATTERN_OPTION_SET
      ClassName                 : "plotInternalPatternOptionSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : PLOT_INTERNAL_PATTERN_OPTION_SUBSET

}
#==============================================
Entity PlotInternalPatternOptionSubset {
      ClassSymbol               : PLOT_INTERNAL_PATTERN_OPTION_SUBSET
      ClassName                 : "plotInternalPatternOptionSubset"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : OptCropRowAlleyWidthRatio   --- 
      AddConstantDescriptor     : OptGrassStripAlleyWidthRatio   --- 
      AddConstantDescriptor     : OptRidingOrientedInterRowProportion   --- 
}
#==============================================
Entity RetiredWorkerAnnualEmploymentPlan {
      ClassSymbol               : RETIRED_WORKER_ANNUAL_EMPLOYMENT_PLAN
      ClassName                 : "retiredWorkerAnnualEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ANNUAL_EMPLOYMENT_PLAN

}
#==============================================
Entity Row {
      ClassSymbol               : ROW
      ClassName                 : "row"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : RelativeArea   --- 
      AddConstantDescriptor     : SoilManagementModality   --- 
      AddConstantDescriptor     : LastOperationsMemoryAttribute   --- 
      AddConstantDescriptor     : SoilHumidityVectorFromMhydas   --- 
      AddConstantDescriptor     : GrassCoverVectorFromMhydas   --- 
      AddMethod                 : SumUpGrassCoverVector
      AddMethod                 : SumUpSoilHumidityVector
}
#==============================================
Entity SeasonalEmploymentPlan {
      ClassSymbol               : SEASONAL_EMPLOYMENT_PLAN
      ClassName                 : "seasonalEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : WorkDayMorningBegHour   --- 
      AddConstantDescriptor     : WorkDayMorningEndHour   --- 
      AddConstantDescriptor     : WorkDayMorningExtendedEndHour   --- 
      AddConstantDescriptor     : WorkDayAfternoonBegHour   --- 
      AddConstantDescriptor     : WorkDayAfternoonEndHour   --- 
      AddConstantDescriptor     : WorkDayAfternoonExtendedEndHour   --- 
      AddConstantDescriptor     : TimetableAttribute   --- 
      AddConstantDescriptor     : WorkingTimeWeeklyUpperBound   --- 
      AddConstantDescriptor     : CurrentSlotToBeExtended   --- 
      AddMethod                 : TimetableOpeningPredicate
      AddMethod                 : TimetableClosingPredicate
}
#==============================================
Entity SeptemberOctoberEmploymentPlan {
      ClassSymbol               : SEPTEMBER_OCTOBER_EMPLOYMENT_PLAN
      ClassName                 : "septemberOctoberEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SEASONAL_EMPLOYMENT_PLAN

      OverloadedMethod body     : TimetableOpeningPredicate   septemberOctoberEmploymentPlan_timetableOpeningPredicate_Body
}
#==============================================
Entity SeptemberOctoberNormalHoursEmploymentPlan {
      ClassSymbol               : SEPTEMBER_OCTOBER_NORMAL_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "septemberOctoberNormalHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SEPTEMBER_OCTOBER_EMPLOYMENT_PLAN

}
#==============================================
Entity SeptemberOctoberReducedHoursEmploymentPlan {
      ClassSymbol               : SEPTEMBER_OCTOBER_REDUCED_HOURS_EMPLOYMENT_PLAN
      ClassName                 : "septemberOctoberReducedHoursEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SEPTEMBER_OCTOBER_EMPLOYMENT_PLAN

}
#==============================================
Entity SoilManagementGroup {
      ClassSymbol               : SOIL_MANAGEMENT_GROUP
      ClassName                 : "soilManagementGroup"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : PlotProfile   --- 
      AddConstantDescriptor     : PlotProfileOperator   --- 
      AddConstantDescriptor     : PlotPattern   --- 
      AddConstantDescriptor     : RowManagement   --- 
}
#==============================================
Entity SoilManagementGroupSet {
      ClassSymbol               : SOIL_MANAGEMENT_GROUP_SET
      ClassName                 : "soilManagementGroupSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : SOIL_MANAGEMENT_GROUP

}
#==============================================
Entity SoilReservoir {
      ClassSymbol               : SOIL_RESERVOIR
      ClassName                 : "soilReservoir"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

}
#==============================================
Entity SoilSurface {
      ClassSymbol               : SOIL_SURFACE
      ClassName                 : "soilSurface"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

}
#==============================================
Entity SpecialWorkerAnnualEmploymentPlan {
      ClassSymbol               : SPECIAL_WORKER_ANNUAL_EMPLOYMENT_PLAN
      ClassName                 : "specialWorkerAnnualEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ANNUAL_EMPLOYMENT_PLAN

}
#==============================================
Entity StandardWorkerAnnualEmploymentPlan {
      ClassSymbol               : STANDARD_WORKER_ANNUAL_EMPLOYMENT_PLAN
      ClassName                 : "standardWorkerAnnualEmploymentPlan"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : ANNUAL_EMPLOYMENT_PLAN

}
#==============================================
Entity VarietyGroup {
      ClassSymbol               : VARIETY_GROUP
      ClassName                 : "varietyGroup"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : GRAPE_VARIETY

      AddConstantDescriptor     : MembershipMode   --- 
}
#==============================================
Entity VarietyGroupSet {
      ClassSymbol               : VARIETY_GROUP_SET
      ClassName                 : "varietyGroupSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : VARIETY_GROUP

      AddMethod                 : GetRankedWaveList
}
#==============================================
Entity VegetalCompartment {
      ClassSymbol               : VEGETAL_COMPARTMENT
      ClassName                 : "vegetalCompartment"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : ROW

}
#==============================================
Entity Vegetation {
      ClassSymbol               : VEGETATION
      ClassName                 : "vegetation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

}
#==============================================
Entity Vineyard {
      ClassSymbol               : VINEYARD
      ClassName                 : "vineyard"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : PLOT

      AddConstantDescriptor     : ControlPlanClassNameAttribute   --- 
      AddConstantDescriptor     : ControlPlanAttribute   --- 
      AddConstantDescriptor     : HasEarlyVariety   --- 
      AddConstantDescriptor     : HasLateVariety   --- 
      AddConstantDescriptor     : GrapeVarietyListAttribute   --- 
      AddConstantDescriptor     : IsoAgeingEntitySetAttribute   --- 
      AddConstantDescriptor     : AreaWithGrapevine   --- 
      AddConstantDescriptor     : NumberOfTractors   --- 
      AddConstantDescriptor     : NumberOfWorkers   --- 
      AddConstantDescriptor     : AreaWithTilledGrapevine   --- 
}
#==============================================
Entity VineyardSet {
      ClassSymbol               : VINEYARD_SET
      ClassName                 : "vineyardSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : VINEYARD

      AddConstantDescriptor     : PestInfoMemoryAttribute   --- 
}
#==============================================
Entity WeatherStation {
      ClassSymbol               : WEATHER_STATION
      ClassName                 : "weatherStation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : InstantAttribute   --- 
      AddConstantDescriptor     : Latitude   --- 
      AddConstantDescriptor     : Longitude   --- 
      AddConstantDescriptor     : PathNameAttribute   --- 
      AddConstantDescriptor     : DailyRainfallForecastFromCurrentDay   --- 
      AddConstantDescriptor     : WinterBeginningClock   --- 
      AddConstantDescriptor     : WinterBeginningClockForInitst   --- 
      AddVariableDescriptor     : Rainfall   --- 
      AddVariableDescriptor     : Temperature   --- 
}
#==============================================
Entity WeatherStationSet {
      ClassSymbol               : WEATHER_STATION_SET
      ClassName                 : "weatherStationSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : WEATHER_STATION

      AddConstantDescriptor     : LastWeatherPrintClock   --- 
}
#==============================================
Entity WorkOrganizationOptionSet {
      ClassSymbol               : WORK_ORGANIZATION_OPTION_SET
      ClassName                 : "workOrganizationOptionSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY
      ElementClassId            : WORK_ORGANIZATION_OPTION_SUBSET

}
#==============================================
Entity WorkOrganizationOptionSubset {
      ClassSymbol               : WORK_ORGANIZATION_OPTION_SUBSET
      ClassName                 : "workOrganizationOptionSubset"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : BD_ENTITY

      AddConstantDescriptor     : ChemicalWeedingsManagement   --- 
      AddConstantDescriptor     : AutumnTillagesManagement   --- 
      AddConstantDescriptor     : PhytoManagement   --- 
      AddConstantDescriptor     : FertilizationsManagement   --- 
      AddConstantDescriptor     : ShootThinningsManagement   --- 
      AddConstantDescriptor     : WinterTillagesManagement   --- 
      AddConstantDescriptor     : InitSpringTillagesManagement   --- 
      AddConstantDescriptor     : SpringTillagesManagement   --- 
      AddConstantDescriptor     : SpringChemicalWeedingsManagement   --- 
      AddConstantDescriptor     : DebranchingsManagement   --- 
      AddConstantDescriptor     : ClippingsManagement   --- 
      AddConstantDescriptor     : PruningsManagement   --- 
}
#==============================================

