###############
#  Operation  #
###############

Operation AirAssistedSpraying {
      ClassSymbol               : AIR_ASSISTED_SPRAYING
      ClassName                 : "airAssistedSpraying"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MOTORIZED_SPRAYING_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   airAssistedSpraying_stateTransitionProcedure_Body
}
#==============================================
Operation BackSprayingOperation {
      ClassSymbol               : BACK_SPRAYING_OPERATION
      ClassName                 : "backSprayingOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MANUAL_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   backSprayingOperation_stateTransitionProcedure_Body
      OverloadedMethod body     : FeasibilityCondition   backSprayingOperation_feasibilityCondition_Body
}
#==============================================
Operation ChemicalDebrancherOperatedSpraying {
      ClassSymbol               : CHEMICAL_DEBRANCHER_OPERATED_SPRAYING
      ClassName                 : "chemicalDebrancherOperatedSpraying"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MOTORIZED_SPRAYING_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   chemicalDebrancherOperatedSpraying_stateTransitionProcedure_Body
}
#==============================================
Operation ClippingOperation {
      ClassSymbol               : CLIPPING_OPERATION
      ClassName                 : "clippingOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MOTORIZED_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   clippingOperation_stateTransitionProcedure_Body
}
#==============================================
Operation FertilizationOperation {
      ClassSymbol               : FERTILIZATION_OPERATION
      ClassName                 : "fertilizationOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MOTORIZED_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   fertilizationOperation_stateTransitionProcedure_Body
}
#==============================================
Operation GrinderOperatedShootThinning {
      ClassSymbol               : GRINDER_OPERATED_SHOOT_THINNING
      ClassName                 : "grinderOperatedShootThinning"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SHOOT_THINNING_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   grinderOperatedShootThinning_stateTransitionProcedure_Body
}
#==============================================
Operation HandHeldGunOperatedSpraying {
      ClassSymbol               : HAND_HELD_GUN_OPERATED_SPRAYING
      ClassName                 : "handHeldGunOperatedSpraying"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MOTORIZED_SPRAYING_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   handHeldGunOperatedSpraying_stateTransitionProcedure_Body
}
#==============================================
Operation HorizontalRailOperatedSpraying {
      ClassSymbol               : HORIZONTAL_RAIL_OPERATED_SPRAYING
      ClassName                 : "horizontalRailOperatedSpraying"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MOTORIZED_SPRAYING_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   horizontalRailOperatedSpraying_stateTransitionProcedure_Body
}
#==============================================
Operation ManualDebranchingOperation {
      ClassSymbol               : MANUAL_DEBRANCHING_OPERATION
      ClassName                 : "manualDebranchingOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MANUAL_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   manualDebranchingOperation_stateTransitionProcedure_Body
}
#==============================================
Operation ManualOperation {
      ClassSymbol               : MANUAL_OPERATION
      ClassName                 : "manualOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MY_FLOAT_AREA_OPERATION

      AddVariableDescriptor     : NominalIntQuantitySpeed   --- 
      OverloadedConstDesc value : SuspensionThreshold   1.0 
      OverloadedMethod body     : SetUserFloatQuantitySpeed   manualOperation_setUserFloatQuantitySpeed_Body
}
#==============================================
Operation MotorizedOperation {
      ClassSymbol               : MOTORIZED_OPERATION
      ClassName                 : "motorizedOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MY_FLOAT_AREA_OPERATION

      AddVariableDescriptor     : NominalFloatQuantitySpeed   --- 
      OverloadedConstDesc value : SuspensionThreshold   1.0 
      OverloadedMethod body     : SetUserFloatQuantitySpeed   motorizedOperation_setUserFloatQuantitySpeed_Body
}
#==============================================
Operation MotorizedSprayingOperation {
      ClassSymbol               : MOTORIZED_SPRAYING_OPERATION
      ClassName                 : "motorizedSprayingOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MOTORIZED_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   motorizedSprayingOperation_stateTransitionProcedure_Body
      OverloadedMethod body     : FeasibilityCondition   motorizedSprayingOperation_feasibilityCondition_Body
}
#==============================================
Operation MyFloatAreaOperation {
      ClassSymbol               : MY_FLOAT_AREA_OPERATION
      ClassName                 : "myFloatAreaOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FLOAT_QUANTITY_GRANULATED_OPERATION

      OverloadedConstDesc value : QuantityDescriptorId   AREA 
      OverloadedMethod body     : FeasibilityCondition   myFloatAreaOperation_feasibilityCondition_Body
}
#==============================================
Operation PlantationOperation {
      ClassSymbol               : PLANTATION_OPERATION
      ClassName                 : "plantationOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MANUAL_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   plantationOperation_stateTransitionProcedure_Body
}
#==============================================
Operation PruningOperation {
      ClassSymbol               : PRUNING_OPERATION
      ClassName                 : "pruningOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MANUAL_OPERATION
      SetMonitorToDescriptor    : NominalIntQuantitySpeed 	PruningOperationNominalSpeedMonitor

      OverloadedConstDesc value : Step   1 
      OverloadedMethod body     : StateTransitionProcedure   pruningOperation_stateTransitionProcedure_Body
}
#==============================================
Operation RotaryOperatedShootThinning {
      ClassSymbol               : ROTARY_OPERATED_SHOOT_THINNING
      ClassName                 : "rotaryOperatedShootThinning"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SHOOT_THINNING_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   rotaryOperatedShootThinning_stateTransitionProcedure_Body
}
#==============================================
Operation RotaryOperatedTillage {
      ClassSymbol               : ROTARY_OPERATED_TILLAGE
      ClassName                 : "rotaryOperatedTillage"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : TILLAGE_OPERATION

}
#==============================================
Operation ShootThinningOperation {
      ClassSymbol               : SHOOT_THINNING_OPERATION
      ClassName                 : "shootThinningOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MOTORIZED_OPERATION

}
#==============================================
Operation SpringTineOperatedTillage {
      ClassSymbol               : SPRING_TINE_OPERATED_TILLAGE
      ClassName                 : "springTineOperatedTillage"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : TILLAGE_OPERATION

}
#==============================================
Operation TillageOperation {
      ClassSymbol               : TILLAGE_OPERATION
      ClassName                 : "tillageOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MOTORIZED_OPERATION

      AddConstantDescriptor     : LastSevenDaysRainfall   --- 
      OverloadedMethod body     : StateTransitionProcedure   tillageOperation_stateTransitionProcedure_Body
      OverloadedMethod body     : FeasibilityCondition   tillageOperation_feasibilityCondition_Body
}
#==============================================
Operation TrellisingOperation {
      ClassSymbol               : TRELLISING_OPERATION
      ClassName                 : "trellisingOperation"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MANUAL_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   trellisingOperation_stateTransitionProcedure_Body
}
#==============================================
Operation VerticalRailOperatedSpraying {
      ClassSymbol               : VERTICAL_RAIL_OPERATED_SPRAYING
      ClassName                 : "verticalRailOperatedSpraying"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : MOTORIZED_SPRAYING_OPERATION

      OverloadedMethod body     : StateTransitionProcedure   verticalRailOperatedSpraying_stateTransitionProcedure_Body
}
#==============================================

