##############
#  Resource  #
##############

SingleResource AirAssistedSprayer {
      ClassSymbol               : AIR_ASSISTED_SPRAYER
      ClassName                 : "airAssistedSprayer"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SPRAYER

}
#==============================================
AggregatedResource AirAssistedSprayingResourceSet {
      ClassSymbol               : AIR_ASSISTED_SPRAYING_RESOURCE_SET
      ClassName                 : "airAssistedSprayingResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE

}
#==============================================
SingleResource BackSprayer {
      ClassSymbol               : BACK_SPRAYER
      ClassName                 : "backSprayer"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SPRAYER

}
#==============================================
AggregatedResource ChemicalDebrancherSprayingResourceSet {
      ClassSymbol               : CHEMICAL_DEBRANCHER_SPRAYING_RESOURCE_SET
      ClassName                 : "chemicalDebrancherSprayingResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE

}
#==============================================
SingleResource Clipper {
      ClassSymbol               : CLIPPER
      ClassName                 : "clipper"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_EQUIPMENT

}
#==============================================
AggregatedResource ClippingResourceSet {
      ClassSymbol               : CLIPPING_RESOURCE_SET
      ClassName                 : "clippingResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE

}
#==============================================
SingleResource CollectorPane {
      ClassSymbol               : COLLECTOR_PANE
      ClassName                 : "collectorPane"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_EQUIPMENT

}
#==============================================
SingleResource DebranchingSprayer {
      ClassSymbol               : DEBRANCHING_SPRAYER
      ClassName                 : "debranchingSprayer"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SPRAYER

}
#==============================================
SingleResource FarmEquipment {
      ClassSymbol               : FARM_EQUIPMENT
      ClassName                 : "farmEquipment"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SINGLE_TOOL

      AddConstantDescriptor     : Width   --- 
}
#==============================================
SingleResource FarmWorker {
      ClassSymbol               : FARM_WORKER
      ClassName                 : "farmWorker"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SINGLE_WORKER
      SetMonitorToDescriptor    : WorkingTimeWeeklyLeft 	TemporaryMonitor
      SetMonitorToDescriptor    : WorkingTimeDailyLeft 	TemporaryMonitor

      AddConstantDescriptor     : IsManager   --- 
      AddConstantDescriptor     : AnnualEmploymentPlanAttribute   --- 
      AddConstantDescriptor     : WorkingTimeYearlyUpperBound   --- 
      AddConstantDescriptor     : WorkingTimeDailyUpperBound   --- 
      AddConstantDescriptor     : WorkBeginningHour   --- 
      AddConstantDescriptor     : LastRainfallClock   --- 
      AddVariableDescriptor     : WorkingTimeYearlyLeft   --- 
      AddVariableDescriptor     : WorkingTimeDailyLeft   --- 
      AddVariableDescriptor     : WorkingTimeWeeklyLeft   --- 
      AddVariableDescriptor     : CumulativeRainfallFromWorkBeginning   --- 
}
#==============================================
AvailabilityTimetable FarmWorkerAvailabilityTimetable {
      ClassSymbol               : FARM_WORKER_AVAILABILITY_TIMETABLE
      ClassName                 : "farmWorkerAvailabilityTimetable"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : RECURRENT_AVAILABILITY_TIMETABLE

      AddConstantDescriptor     : SeasonalEmploymentPlanAttribute   --- 
}
#==============================================
AggregatedResource FertilizationResourceSet {
      ClassSymbol               : FERTILIZATION_RESOURCE_SET
      ClassName                 : "fertilizationResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE

}
#==============================================
SingleResource Grinder {
      ClassSymbol               : GRINDER
      ClassName                 : "grinder"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_EQUIPMENT

}
#==============================================
AggregatedResource GrinderShootThinningResourceSet {
      ClassSymbol               : GRINDER_SHOOT_THINNING_RESOURCE_SET
      ClassName                 : "grinderShootThinningResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE

}
#==============================================
AggregatedResource HandHeldGunSprayingResourceSet {
      ClassSymbol               : HAND_HELD_GUN_SPRAYING_RESOURCE_SET
      ClassName                 : "handHeldGunSprayingResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE

}
#==============================================
SingleResource HandHeldSprayGun {
      ClassSymbol               : HAND_HELD_SPRAY_GUN
      ClassName                 : "handHeldSprayGun"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SPRAYER

}
#==============================================
SingleResource HorizontalRailSprayer {
      ClassSymbol               : HORIZONTAL_RAIL_SPRAYER
      ClassName                 : "horizontalRailSprayer"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SPRAYER

}
#==============================================
AggregatedResource HorizontalRailSprayingResourceSet {
      ClassSymbol               : HORIZONTAL_RAIL_SPRAYING_RESOURCE_SET
      ClassName                 : "horizontalRailSprayingResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE

}
#==============================================
AvailabilityConstraint LowCumulativeRainSuffered {
      ClassSymbol               : LOW_CUMULATIVE_RAIN_SUFFERED
      ClassName                 : "lowCumulativeRainSuffered"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : STATE_AVAILABILITY_CONSTRAINT

      OverloadedMethod body     : StateRelatedPredicate   lowCumulativeRainSuffered_stateRelatedPredicate_Body
}
#==============================================
SingleResource NonPermanentFarmWorker {
      ClassSymbol               : NON_PERMANENT_FARM_WORKER
      ClassName                 : "nonPermanentFarmWorker"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_WORKER

}
#==============================================
SingleResource NonPermanentManualFarmWorker {
      ClassSymbol               : NON_PERMANENT_MANUAL_FARM_WORKER
      ClassName                 : "nonPermanentManualFarmWorker"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : NON_PERMANENT_FARM_WORKER

}
#==============================================
SingleResource NonPermanentTractorDriver {
      ClassSymbol               : NON_PERMANENT_TRACTOR_DRIVER
      ClassName                 : "nonPermanentTractorDriver"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : NON_PERMANENT_FARM_WORKER

}
#==============================================
SingleResource PermanentAllTaskTractorDriver {
      ClassSymbol               : PERMANENT_ALL_TASK_TRACTOR_DRIVER
      ClassName                 : "permanentAllTaskTractorDriver"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PERMANENT_MULTI_TASK_WORKER

}
#==============================================
SingleResource PermanentFarmWorker {
      ClassSymbol               : PERMANENT_FARM_WORKER
      ClassName                 : "permanentFarmWorker"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_WORKER

}
#==============================================
AvailabilityTimetable PermanentFarmWorkerFiveDayTimetable {
      ClassSymbol               : PERMANENT_FARM_WORKER_FIVE_DAY_TIMETABLE
      ClassName                 : "permanentFarmWorkerFiveDayTimetable"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_WORKER_AVAILABILITY_TIMETABLE

}
#==============================================
AvailabilityTimetable PermanentFarmWorkerSevenDayTimetable {
      ClassSymbol               : PERMANENT_FARM_WORKER_SEVEN_DAY_TIMETABLE
      ClassName                 : "permanentFarmWorkerSevenDayTimetable"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_WORKER_AVAILABILITY_TIMETABLE

}
#==============================================
AvailabilityTimetable PermanentFarmWorkerSixDayTimetable {
      ClassSymbol               : PERMANENT_FARM_WORKER_SIX_DAY_TIMETABLE
      ClassName                 : "permanentFarmWorkerSixDayTimetable"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_WORKER_AVAILABILITY_TIMETABLE

}
#==============================================
SingleResource PermanentManualFarmWorker {
      ClassSymbol               : PERMANENT_MANUAL_FARM_WORKER
      ClassName                 : "permanentManualFarmWorker"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PERMANENT_FARM_WORKER

}
#==============================================
SingleResource PermanentMultiTaskManualWorker {
      ClassSymbol               : PERMANENT_MULTI_TASK_MANUAL_WORKER
      ClassName                 : "permanentMultiTaskManualWorker"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PERMANENT_MANUAL_FARM_WORKER

}
#==============================================
SingleResource PermanentMultiTaskWorker {
      ClassSymbol               : PERMANENT_MULTI_TASK_WORKER
      ClassName                 : "permanentMultiTaskWorker"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PERMANENT_FARM_WORKER

}
#==============================================
SingleResource PermanentPreferentialTractorDriver {
      ClassSymbol               : PERMANENT_PREFERENTIAL_TRACTOR_DRIVER
      ClassName                 : "permanentPreferentialTractorDriver"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PERMANENT_MULTI_TASK_WORKER

}
#==============================================
SingleResource PermanentPruner {
      ClassSymbol               : PERMANENT_PRUNER
      ClassName                 : "permanentPruner"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PERMANENT_MANUAL_FARM_WORKER

}
#==============================================
SingleResource PermanentTillageOrientedTractorDriver {
      ClassSymbol               : PERMANENT_TILLAGE_ORIENTED_TRACTOR_DRIVER
      ClassName                 : "permanentTillageOrientedTractorDriver"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PERMANENT_MULTI_TASK_WORKER

}
#==============================================
SingleResource PermanentTillageTractorDriver {
      ClassSymbol               : PERMANENT_TILLAGE_TRACTOR_DRIVER
      ClassName                 : "permanentTillageTractorDriver"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PERMANENT_TRACTOR_DRIVER

}
#==============================================
SingleResource PermanentTractorDriver {
      ClassSymbol               : PERMANENT_TRACTOR_DRIVER
      ClassName                 : "permanentTractorDriver"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PERMANENT_FARM_WORKER

}
#==============================================
SingleResource PermanentVegetationGrower {
      ClassSymbol               : PERMANENT_VEGETATION_GROWER
      ClassName                 : "permanentVegetationGrower"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : PERMANENT_MANUAL_FARM_WORKER

}
#==============================================
SingleResource PruningMachine {
      ClassSymbol               : PRUNING_MACHINE
      ClassName                 : "pruningMachine"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_EQUIPMENT

}
#==============================================
SingleResource RotaryCultivator {
      ClassSymbol               : ROTARY_CULTIVATOR
      ClassName                 : "rotaryCultivator"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : TILLAGE_TOOL

}
#==============================================
AggregatedResource RotaryTillageResourceSet {
      ClassSymbol               : ROTARY_TILLAGE_RESOURCE_SET
      ClassName                 : "rotaryTillageResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : TILLAGE_RESOURCE_SET

}
#==============================================
SingleResource Sprayer {
      ClassSymbol               : SPRAYER
      ClassName                 : "sprayer"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_EQUIPMENT

}
#==============================================
SingleResource Spreader {
      ClassSymbol               : SPREADER
      ClassName                 : "spreader"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_EQUIPMENT

}
#==============================================
SingleResource SpringTineCultivator {
      ClassSymbol               : SPRING_TINE_CULTIVATOR
      ClassName                 : "springTineCultivator"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : TILLAGE_TOOL

}
#==============================================
AggregatedResource SpringTineTillageResourceSet {
      ClassSymbol               : SPRING_TINE_TILLAGE_RESOURCE_SET
      ClassName                 : "springTineTillageResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : TILLAGE_RESOURCE_SET

}
#==============================================
SingleResource Tank {
      ClassSymbol               : TANK
      ClassName                 : "tank"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_EQUIPMENT

}
#==============================================
AggregatedResource TillageResourceSet {
      ClassSymbol               : TILLAGE_RESOURCE_SET
      ClassName                 : "tillageResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE

}
#==============================================
SingleResource TillageTool {
      ClassSymbol               : TILLAGE_TOOL
      ClassName                 : "tillageTool"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_EQUIPMENT

}
#==============================================
SingleResource Tractor {
      ClassSymbol               : TRACTOR
      ClassName                 : "tractor"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_EQUIPMENT

}
#==============================================
SingleResource TrellisingMachine {
      ClassSymbol               : TRELLISING_MACHINE
      ClassName                 : "trellisingMachine"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : FARM_EQUIPMENT

}
#==============================================
SingleResource VerticalRailSprayer {
      ClassSymbol               : VERTICAL_RAIL_SPRAYER
      ClassName                 : "verticalRailSprayer"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : SPRAYER

}
#==============================================
AggregatedResource VerticalRailSprayingResourceSet {
      ClassSymbol               : VERTICAL_RAIL_SPRAYING_RESOURCE_SET
      ClassName                 : "verticalRailSprayingResourceSet"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE

}
#==============================================
AvailabilityTimeSlot WeekDayAfternoon {
      ClassSymbol               : WEEK_DAY_AFTERNOON
      ClassName                 : "weekDayAfternoon"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : WEEK_DAY_PART

      OverloadedMethod body     : SetThisTimeSlotBegValue   weekDayAfternoon_setThisTimeSlotBegValue_Body
      OverloadedMethod body     : SetThisTimeSlotEndValue   weekDayAfternoon_setThisTimeSlotEndValue_Body
}
#==============================================
AvailabilityTimeSlot WeekDayMorning {
      ClassSymbol               : WEEK_DAY_MORNING
      ClassName                 : "weekDayMorning"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : WEEK_DAY_PART

      OverloadedMethod body     : SetThisTimeSlotBegValue   weekDayMorning_setThisTimeSlotBegValue_Body
      OverloadedMethod body     : SetThisTimeSlotEndValue   weekDayMorning_setThisTimeSlotEndValue_Body
}
#==============================================
AvailabilityTimeSlot WeekDayPart {
      ClassSymbol               : WEEK_DAY_PART
      ClassName                 : "weekDayPart"
      signatureConstructeur     : "()"
      instanceList              : "yes"
      SetParentClassId          : AVAILABILITY_TIME_SLOT

      AddConstantDescriptor     : WeekDayNumber   --- 
}
#==============================================

