bool regularPhytoTreatmentsIteration_closingPredicate_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// Doit renvoyer vrai pour que l'activit� puisse �tre ferm�e.
//---------------------------------------------------------------------------
  Entity* pIteration = pM->DescribedEntity();
  bool result = FALSE;
//printf("\nentree '%s'_closingPredicate_Body", pIteration->InstanceName());

  //
  // condition prealable : chantier termine (= ttes parcelles faites)
  // =====================================================
  Entity* pChantier = pIteration->GetElement(0);
  int situation = pChantier->GetIntVarValue(SITUATION);
  if(situation != WAITING) {
//printf("\nt = %d '%s'_CP renvoie %d (chantier ouvert)", pCurrentSim->Clock(), pIteration->InstanceName(), result);
	return FALSE;
  }
  //
  // critere d'arret : le risque est devenu faible
  // =========================================
  //
  //  OIDIUM
  //
  bool powderyMildewToClose = 
	pIteration->ExecPredicate(ANTI_POWDERY_MILDEW_CLOSING_PREDICATE);

  pIteration->SetIntConstValue(POWDERY_MILDEW_TO_CLOSE, powderyMildewToClose);
//if(powderyMildewToClose) printf("\n\t  !! POWDERY_MILDEW_TO_CLOSE !!");
  //
  // MILDIOU (modif JPR 140117)
  //
  bool downyMildewToClose = FALSE;
  bool downyMildewToClose_atLeast = 
	pIteration->ExecPredicate(ANTI_DOWNY_MILDEW_AT_LEAST_CLOSING_PREDICATE);
//printf("\nANTI_DOWNY_MILDEW_AT_LEAST_CLOSING_PREDICATE -> %d", downyMildewToClose_atLeast);

  if(downyMildewToClose_atLeast) {
	int pressureAlreadyObserved = pIteration->GetIntConstValue(DOWNY_MILDEW_PRESSURE);
	// valeur init = -9
	// 0 ssi pressureAlreadyObserved <= 0 ET ! pressureExists(t-1)
	// 1 ssi pressureExists(t-1)
//printf("\n\tpressureAlreadyObserved = %d", pressureAlreadyObserved);
	if(pressureAlreadyObserved <= 0) { // pas encore fait  // JPR 120306 : < -> <=
	  bool pressureExists = FALSE;
	  // 
	  // evaluation du niveau de pression present
	  //
	  Vineyard* pEA = App_GetVineyard((Activity*)pChantier);
	  int downyMildewLevel = App_GetIntPestInfo(pEA, DOWNY_MILDEW_LEVEL);
	  int threshold1 = gIntParam_virtualManager_actualDownyMildewLevelThreshold_;
//printf("\n\tdownyMildewLevel = %d threshold1 = %d", downyMildewLevel, threshold1);
	  if(downyMildewLevel > threshold1) {
		float downyMildewRiskLevel = App_GetFloatPestInfo(pEA, DOWNY_MILDEW_RISK_LEVEL);
		float threshold2 = App_GetFloatDecisionOption(pEA, 
													  OPT_ACTUAL_DOWNY_MILDEW_RISK_THRESHOLD);
//printf("\n\tdownyMildewRiskLevel = %12.10f threshold2 = %12.10f", downyMildewRiskLevel, threshold2);
		if(downyMildewRiskLevel > threshold2)
		  pressureExists = TRUE;
	  }
//printf("\n\t--> pressureExists / downyMildewRiskLevel = %d", pressureExists);
	  if(! pressureExists) {
		// 
		// evaluation du niveau d'attaque passe (moyenne/j)
		//
		float pastPressureLevel = App_GetIntPestHistory (pEA, DOWNY_MILDEW_LEVEL);
		// 
		// capture du seuil accepte sur niveau de pression passe
		//
		float threshold3 = App_GetFloatDecisionOption(pEA, 
													 OPT_PAST_DOWNY_MILDEW_PRESSURE_THRESHOLD);
//printf("\n\tpastPressureLevel = %12.10f threshold3 = %12.10f", pastPressureLevel, threshold3);
		if(pastPressureLevel > threshold3) {
		  pressureExists = TRUE;
		}
	  }
	  // 
	  // Memorisation au profit du prochain examen
	  //
//printf("\n\t--> pressureExists final = %d", pressureExists);
// JPR140117 : reste a coder le "dans les 30 jours qui suivent cet arrêt" de l'expression 
// "chantiers mildiou susceptibles de reprendre si la pression devient forte dans les 30 jours 
// qui suivent cet arrêt [= date ou AtLeastClosingPredicate devient vraie]"
// AB 140120 : "Inutile de le coder. c'est mieux sans cette restriction."
	  pIteration->SetIntConstValue(DOWNY_MILDEW_PRESSURE, pressureExists);
	} // fin case (pressureAlreadyObserved < 0)

	downyMildewToClose = 
	  pIteration->ExecPredicate(ANTI_DOWNY_MILDEW_UNDER_PRESSURE_CLOSING_PREDICATE);
//printf("\nANTI_DOWNY_MILDEW_UNDER_PRESSURE_CLOSING_PREDICATE -> %d", downyMildewToClose);
  } // fin case 'downyMildewToClose_atLeast vrai'

  pIteration->SetIntConstValue(DOWNY_MILDEW_TO_CLOSE, downyMildewToClose);
//if(downyMildewToClose) printf("\n\t  !! DOWNY_MILDEW_TO_CLOSE !!");
  //
  // test sur les 2 maladies
  //
  if(powderyMildewToClose
	 &&
	 downyMildewToClose) {
	result = TRUE;
  }

//printf("\nt = %d '%s'_CP renvoie %d", pCurrentSim->Clock(), pIteration->InstanceName(), result);
  return result;
};
