float motorizedOperation_setUserFloatQuantitySpeed_Body(EntityMethod* pM) {
//
// Retourne la vitesse de l'op�ration.
// (surcharge une �ventuelle valeur du descripteur FloatQuantitySpeed).
//
  Operation* pOt = (Operation*)(pM->DescribedEntity());
  
  float currentValue = pOt->GetFloatConstValue(FLOAT_QUANTITY_SPEED);
  if(currentValue > (float)-8.)
	return currentValue;
  //
  // FloatQuantitySpeed est -9. par construction de l'operation,
  // puis devient > 0. dans ce corps de methode.
  // Pour une instance d'operation, on ne poursuit donc compl�tement 
  // le present calcul de la vitesse qu'une seule fois.
  //
  float result;

  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);

  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nentree '%s'::setUserFloatQuantitySpeed plot '%s'", pOt->InstanceName(), pPlot->InstanceName());

  float alleyWidth = pPlot->GetIntConstValue(ALLEY_WIDTH) / (float)100.;
  //
  // vitesse nominale en km par heure :
  // - valeur affectee par construction
  //
  float nominalSpeed = pOt->GetFloatVarValue(NOMINAL_FLOAT_QUANTITY_SPEED);
//printf("\n\talleyWidth = %3.2f nominalSpeed = %f", alleyWidth, nominalSpeed);

  // cas particulier TILLAGE
  //
  if(pOt->IsInstanceOf(TILLAGE_OPERATION)) {
	//Entity* pConduite = ((Activity*)pInst)->RootActivity();
	//Entity* pARB      = pConduite->GetSuperEntity();
	//int sm = pARB->GetIntConstValue(SOIL_MANAGEMENT_OPTION);  // JPR 1312 : desc. supprimé
	int sm = pPlot->GetIntConstValue(ROW_MANAGEMENT);  // modif JPR 1312
	if((sm == GRASS_COVERING_TILLAGE)
	   ||
	   (sm == TOTAL_TILLAGE)) {
	  float reductionRate = GetRealParameterValue("tillageOperation", "speedReductionRate");
	  nominalSpeed = nominalSpeed * reductionRate;
	}
  }
  //
  // Calcul fr�quence de passage dans les inter-rangs :
  // - 0.5 si le tracteur ne passe qu'un IR /2
  // - 1.0 si le tracteur ne passe dans tous les IR
  //
  pPlot->SetEntityArgValue(RETURN_PASSED_ROWS_FREQUENCY,
						   OPERATION_ARGUMENT, pOt);
  float passedRowsFrequency = 
	pPlot->ExecFloatMethod(RETURN_PASSED_ROWS_FREQUENCY);

  result = alleyWidth * nominalSpeed / (float)12. / passedRowsFrequency;

  pOt->SetFloatConstValue(FLOAT_QUANTITY_SPEED, result);

//printf("\n'%s'::setUserFloatQuantitySpeed plot '%s' returns %f", pOt->InstanceName(), pPlot->InstanceName(), result);
  return result;
};
