pEntityTab* selectNewPlotsToPhytoProtect_Body(EntityMethod* pM)
//-------------------------------------------------------------
// renvoie un tableau de parcelles a traiter
//------------------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToPhytoProtect_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard = pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  char* manualMotorized 
	= pM->GetStringArgValue(MANUAL_MOTORIZED_ARGUMENT);
//printf("\npChantier : '%s' manualMotorized = '%s'", pChantier->InstanceName(), manualMotorized);
  
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();
//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();
  //
  // on va établir une liste de parcelles possiblement traitées dans la plage 
  // de travail, où DTotW heures de travail sont disponibles.
  // cad telle que la durée totale des traitements soit égale ou sup. à DTotW
  // --> dans la boucle sur les parcelles, on s'arretera qd on aura selectionné 
  // des parcelles dont la somme des durée d'opération aura dépassé DTotW
  //
  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : alleyWidth * plantSpacing * _backSprayingOperation_speed_
  //   cas MOT : alleyWidth * _verticalRailOperatedSpraying_speed_ /12 / passedRowFrequency
  //
  //UserClassId otClassId = MOTORIZED_SPRAYING_OPERATION;
  float passedRowFrequency = (float)0.5;  // approximation
  float manualNominalSpeed = (float)gIntParam_backSprayingOperation_speed_; 
  float motorizedNominalSpeed = gRealParam_verticalRailOperatedSpraying_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier, 
											serParOption,
											manualMotorized, //"" modif JPR 130127
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(! strcmp(manualMotorized, "MOTORIZED")) {
	if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
	if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;
  }

  pEntityTab* result = new pEntityTab();

  int typeChantier = App_GetDistributedActivitySetType(pChantier);
  switch(typeChantier) {
  case EXTRA_PHYTO : {
//printf("\nEXTRA_PHYTO");
	//
	// on selectionne toutes (et seulement) les parcelles en carignan
	//
	for(int i=0;i<nbPlots;i++) {
//printf("\ni = %d alreadyChosen = %f DTotW = %f result->size()=%d", i, alreadyChosenDuration, DTotW, result->size());
	  if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	  }
	  else {
		if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		  break;
	  }

	  Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	  // JPR 130228 test 'carignan' remonté ici
	  Entity* pVariety = pPlot_i->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
	  if(! strcmp(pVariety->InstanceName(), "carignan")) {
		pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
								OPERATION_CLASS_ARGUMENT,
								MOTORIZED_SPRAYING_OPERATION);
		bool isPlotMotorizable =
		  pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\n%s isPlotMotorizable = %d", pPlot_i->InstanceName(), isPlotMotorizable);
		//
		// pour chantier "série", elimination de parcelles sur le critere motorisable
		// ou non (voir note dans 'REGULAR') // + JPR 120405
		//
		if(! strcmp(serParOption, "SER")) {
//printf("\n%s isPlotMotorizable = %d", pPlot_i->InstanceName(), isPlotMotorizable);
		  if(! strcmp(manualMotorized, "MANUAL")) {
			if(isPlotMotorizable) {
			  pPlot_i->SetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED, (float)-1.0);  // JPR 130126
			  continue;
			}
		  }
		  else if(! strcmp(manualMotorized, "MOTORIZED")) { 
			if(! isPlotMotorizable) {
			  pPlot_i->SetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED, (float)-1.0);  // JPR 130126
			  continue;
			}
		  }
		}
		if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		   &&
		   (GetPosition(*pInCoursePlots, pPlot_i) < 0)) {
		  //printf("\t carignan");
		  result->push_back(pPlot_i);
		  
		  float duration_i = App_GetExpectedDuration(pPlot_i, 
													 isPlotMotorizable, 
													 -9, // otClaaaId
													 serParOption,
													 manualMotorized,
													 passedRowFrequency,
													 manualNominalSpeed,
													 motorizedNominalSpeed);
		  alreadyChosenDuration+= duration_i;
		  if(! strcmp(manualMotorized, "MOTORIZED")) {
			if(duration_i > (float)1.0) nbPlotMax--;
		  }
		  //printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
		}
	  } // nouveau test carignan
	}
	break;
  }
  case ANTI_MILDIOU : {
	//printf("\nANTI_MILDIOU");
	//
	// préambule : (variante 130306)
	// en SER : les Motorisables d'abord, les NON Motor. ensuite
	// en PAR : les NON Motor. d'abord, les Motorisables ensuite 
	//
	for(int i=0;i<nbPlots;i++) {
	  Plot* pPlot_i = (Plot*)pPlotTab.get_element(i);
	  pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							  OPERATION_CLASS_ARGUMENT,
							  MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable =
		pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	  if(isPlotMotorizable)
		pPlot_i->SetIntVarValue(ANONYMOUS_INT_ATTRIBUTE, 0);
	  else
		pPlot_i->SetIntVarValue(ANONYMOUS_INT_ATTRIBUTE, 1);
	}
	if(! strcmp(serParOption, "SER"))
	  SortUp((pDescriptedEntityTab*)&pPlotTab, ANONYMOUS_INT_ATTRIBUTE);
	else
	  SortDown((pDescriptedEntityTab*)&pPlotTab, ANONYMOUS_INT_ATTRIBUTE);

	for(int i=0;i<nbPlots;i++) {
//printf("\ni = %d alreadyChosen = %f DTotW = %f result->size()=%d nbRsc=%d", i, alreadyChosenDuration, DTotW, result->size(), nbRsc);
	  if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	  }
	  else {
		if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		  break;
	  }

	  Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	  pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							  OPERATION_CLASS_ARGUMENT,
							  MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable =
		pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	  //
	  // pour chantier "série", elimination de parcelles sur le critere motorisable
	  // ou non (voir note dans 'REGULAR') // + JPR 120405
	  //
	  if(! strcmp(serParOption, "SER")) {
//printf("\n%s isPlotMotorizable = %d", pPlot_i->InstanceName(), isPlotMotorizable);
		if(! strcmp(manualMotorized, "MANUAL")) {
		  if(isPlotMotorizable) {
			pPlot_i->SetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED, (float)-1.0);  // JPR 130225
			continue;
		  }
		}
		else if(! strcmp(manualMotorized, "MOTORIZED")) { 
		  if(! isPlotMotorizable) {
			pPlot_i->SetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED, (float)-1.0);  // JPR 130225
			continue;
		  }
		}
	  }
	  if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		 &&
		 (GetPosition(*pInCoursePlots, pPlot_i) < 0)) {
		result->push_back(pPlot_i);
//printf("\n + %s", pPlot_i->InstanceName());printf(" isPlotMotorizable = %d", isPlotMotorizable);
		
		float duration_i = App_GetExpectedDuration(pPlot_i, 
												   isPlotMotorizable, 
												   -9, // otClassId
												   serParOption,
												   manualMotorized,
												   passedRowFrequency,
												   manualNominalSpeed,
												   motorizedNominalSpeed);
		alreadyChosenDuration+= duration_i;
		if(! strcmp(manualMotorized, "MOTORIZED")) {
		  if(duration_i > (float)1.0) nbPlotMax--;
		}
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	  }
	}
	break;
  }
  default : {                              // REGULAR
//printf("\nREGULAR");
	//
	// recuperation de la sequence de vagues de varietes
	//
	Entity* pConduite = 
	  pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	Boolean flag_mildiou = 
	  pConduite->GetIntConstValue(FLAG_MILDEW);
	int powderyMildewMngt =
	  pConduite->GetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE);
	int downyMildewMngt = 
	  pConduite->GetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE);
	Entity* pVarGroupSet = App_GetVarietyGroupSet(powderyMildewMngt);
	//
	// recuperation du numero d'ordre du chantier dans l'iteration
	//
	Entity* pIteration = 
	  (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
	pEntityTab* rankedWaveList;
	int rank =  pIteration->GetIntVarValue(REPLICATION_COUNTER);		
	pVarGroupSet->SetEntityArgValue(GET_RANKED_WAVE_LIST, VINEYARD_ARGUMENT, 
									pVineyard);
	pVarGroupSet->SetIntArgValue(GET_RANKED_WAVE_LIST, STAGE_INDEX_ARGUMENT, 
								 rank);
	Entity* pComposedProgram = pIteration->GetSuperSet();  // par construction
	Boolean antiMildiouJustDone = 
	  pComposedProgram->GetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE);
	//
	// ssi strategie R0, perturbation de la selection en f� du mildiou
	//
	if((downyMildewMngt == R0)
	   ||
	   (downyMildewMngt == RFLO)) {
	  if(flag_mildiou) {  // f(foyers primaires, ...)
		pVarGroupSet->SetIntArgValue(GET_RANKED_WAVE_LIST, 
									 STAGE_INDEX_ARGUMENT, 
									 -9);// on renvoie tout
	  }
	}
	//
	// etablissement de la liste des cepages a traiter, en f� du rang
	//
	rankedWaveList	= 
	  pVarGroupSet->ExecEntityTabMethod(GET_RANKED_WAVE_LIST);
	//
	// examen des parcelles de l'EA
	//
	for(int i=0;i<nbPlots;i++) {
	  if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	  }
	  else {
		if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		  break;
	  }

	  Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	  if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		 &&
		 (GetPosition(*pInCoursePlots, pPlot_i) < 0)) {
		pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
								OPERATION_CLASS_ARGUMENT,
								MOTORIZED_SPRAYING_OPERATION);
		bool isPlotMotorizable =
		  pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
		//
		// elimination de parcelles sur le critere motorisable ou non
		// - seulement utile dans le cas "SER" (en "PAR, c'est dans 
		//   AddNewSituated qu'on regardera le crit�re pour d�cider du
		//   type d'operation)
		// - si "MANUAL", on elimine les parcelles motorisables
		//   si "MOTORIZED, on elimine les parcelles non motorisables
		//
		if(! strcmp(serParOption, "SER")) {
		  if(! strcmp(manualMotorized, "MANUAL")) {
			if(isPlotMotorizable)
			  continue;
		  }
		  else if(! strcmp(manualMotorized, "MOTORIZED")) { 
			if(! isPlotMotorizable)
			  continue;
		  }
		}
		// le cas des parcelles 'pas a traiter' est traite dans le switch
		//
		// la variete figure-t-elle dans la vague de celles a traiter ?
		//
		Entity* pVariety_i = 
		  pPlot_i->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
		if(GetPosition(*rankedWaveList, pVariety_i) >=0) {
		  result->push_back(pPlot_i);
//printf("\n + %s", pPlot_i->InstanceName());printf(" isPlotMotorizable = %d", isPlotMotorizable);
		  float duration_i = App_GetExpectedDuration(pPlot_i, 
													 isPlotMotorizable, 
													 -9, // otClassId
													 serParOption,
													 manualMotorized,
													 passedRowFrequency,
													 manualNominalSpeed,
													 motorizedNominalSpeed);
//printf("\tduration_i = %f", duration_i);
		  alreadyChosenDuration+= duration_i;
		  if(! strcmp(manualMotorized, "MOTORIZED")) {
			if(duration_i > (float)1.0) nbPlotMax--;
		  }
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
		}
		else {
		  pPlot_i->SetFloatVarValue(PERCENT_REGULAR_PHYTO_TREATED, (float)-1.0);  // JPR 130126
		}
	  }
	}
	delete rankedWaveList;
  }  // fin REGULAR
  } // fin switch
  
//printf("\nt = %d selectPlotsToPhytoProtect case %d returns :", pCurrentSim->Clock(), typeChantier);result->display_names();
//printf("\n");if(pCurrentSim->Clock() > 5000) {printf("\n"); exit(0);}
  return result;
};
