// ==============================================
// Fichier : UserActivity.h
// Type    : source C++
// 
// Description : déclaration des classes des 'Activity'.
// ==============================================
  
#ifndef _User_ACTIVITY_HH
#define _User_ACTIVITY_HH
  
#include "UserTypes.h"
  
// ==============================================

class ConcurrentDistributedActivitySet : public ActivityConjunction
{
  public :
    ConcurrentDistributedActivitySet();
};

// ==============================================

class ConcurrentExtraPhytoTreatments : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentExtraPhytoTreatments();
  public :
    ConcurrentExtraPhytoTreatments(Vineyard* pVineyard);
};

// ==============================================

class ConcurrentFertilizations : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentFertilizations();
  public :
    ConcurrentFertilizations(Vineyard* pEA, int season, int numPhase);
};

// ==============================================

class ConcurrentInitSpringTillages : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentInitSpringTillages();
  public :
    ConcurrentInitSpringTillages(Vineyard* pVineyard);
};

// ==============================================

class ConcurrentPrunings : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentPrunings();
  public :
    ConcurrentPrunings(Vineyard* pEA, int numPhase);
};

// ==============================================

class ConcurrentRegularPhytoTreatments : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentRegularPhytoTreatments();
  public :
    ConcurrentRegularPhytoTreatments(Vineyard* pVineyard);
};

// ==============================================

class ConcurrentShootThinnings : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentShootThinnings();
  public :
    ConcurrentShootThinnings(Vineyard* pVineyard, int numPhase);
};

// ==============================================

class ConcurrentSpringChemicalWeedings : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentSpringChemicalWeedings();
  public :
    ConcurrentSpringChemicalWeedings(Vineyard* pVineyard);
};

// ==============================================

class ConcurrentSpringTillages : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentSpringTillages();
  public :
    ConcurrentSpringTillages(Vineyard* pVineyard);
};

// ==============================================

class ConcurrentTrellisings : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentTrellisings();
};

// ==============================================

class ConcurrentWinterTillages : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentWinterTillages();
  public :
    ConcurrentWinterTillages(Vineyard* pVineyard);
};

// ==============================================

class DistributedActivitySetIteration : public ActivityIteration
{
  public :
    DistributedActivitySetIteration();
};

// ==============================================

class ExtraPhytoTreatmentsIteration : public DistributedActivitySetIteration
{
  public :
    ExtraPhytoTreatmentsIteration();
  public :
    ExtraPhytoTreatmentsIteration(Vineyard* pEA, char* optionSerPar);
};

// ==============================================

class PhytoTreatmentComposedProgram : public ActivityConjunction
{
  public :
    PhytoTreatmentComposedProgram();
  public :
    PhytoTreatmentComposedProgram(Vineyard* pEA, char* optionSerPar);
};

// ==============================================

class RegularPhytoTreatmentsIteration : public DistributedActivitySetIteration
{
  public :
    RegularPhytoTreatmentsIteration();
  public :
    RegularPhytoTreatmentsIteration(Vineyard* pEA, char* optionSerPar);
};

// ==============================================

class SerialClippingsIteration : public DistributedActivitySetIteration
{
  public :
    SerialClippingsIteration();
  public :
    SerialClippingsIteration(Vineyard* pEA);
};

// ==============================================

class SerialDistributedActivitySet : public ActivityMeetingAny
{
  public :
    SerialDistributedActivitySet();
};

// ==============================================

class SerialExtraPhytoTreatments : public SerialDistributedActivitySet
{
  public :
    SerialExtraPhytoTreatments();
  public :
    SerialExtraPhytoTreatments(Vineyard* pEA);
};

// ==============================================

class SerialFertilizations : public SerialDistributedActivitySet
{
  public :
    SerialFertilizations();
  public :
    SerialFertilizations(Vineyard* pEA, int season, int numPhase);
};

// ==============================================

class SerialInitSpringTillages : public SerialDistributedActivitySet
{
  public :
    SerialInitSpringTillages();
  public :
    SerialInitSpringTillages(Vineyard* pVineyard);
};

// ==============================================

class SerialPlantations : public SerialDistributedActivitySet
{
  public :
    SerialPlantations();
  public :
    SerialPlantations(Vineyard* pVineyard);
};

// ==============================================

class SerialPrunings : public SerialDistributedActivitySet
{
  public :
    SerialPrunings();
  public :
    SerialPrunings(Vineyard* pEA, int numPhase);
};

// ==============================================

class SerialRegularPhytoTreatments : public SerialDistributedActivitySet
{
  public :
    SerialRegularPhytoTreatments();
  public :
    SerialRegularPhytoTreatments(Vineyard* pEA);
};

// ==============================================

class SerialShootThinnings : public SerialDistributedActivitySet
{
  public :
    SerialShootThinnings();
  public :
    SerialShootThinnings(Vineyard* pVineyard, int numPhase);
};

// ==============================================

class SerialSpringChemicalWeedings : public SerialDistributedActivitySet
{
  public :
    SerialSpringChemicalWeedings();
  public :
    SerialSpringChemicalWeedings(Vineyard* pVineyard);
};

// ==============================================

class SerialSpringTillages : public SerialDistributedActivitySet
{
  public :
    SerialSpringTillages();
  public :
    SerialSpringTillages(Vineyard* pVineyard);
};

// ==============================================

class SerialTrellisings : public SerialDistributedActivitySet
{
  public :
    SerialTrellisings();
  public :
    SerialTrellisings(Vineyard* pVineyard);
};

// ==============================================

class SerialTrellisingsIteration : public DistributedActivitySetIteration
{
  public :
    SerialTrellisingsIteration();
  public :
    SerialTrellisingsIteration(Vineyard* pEA);
};

// ==============================================

class SerialWinterTillages : public SerialDistributedActivitySet
{
  public :
    SerialWinterTillages();
  public :
    SerialWinterTillages(Vineyard* pVineyard);
};

// ==============================================

class SpringTillagesIteration : public DistributedActivitySetIteration
{
  public :
    SpringTillagesIteration();
  public :
    SpringTillagesIteration(Vineyard* pEA, char* optionSerPar);
};

// ==============================================

class VineyardActivity : public PrimitiveActivity
{
  public :
    VineyardActivity();
};

// ==============================================

class VineyardControlSequence : public ActivityBefore
{
  public :
    VineyardControlSequence();
};

// ==============================================

class VineyardIteratedConjunctiveSubplan : public ActivityConjunction
{
  public :
    VineyardIteratedConjunctiveSubplan();
};

// ==============================================

class VineyardPhaseConjunctivePlan : public ActivityConjunction
{
  public :
    VineyardPhaseConjunctivePlan();
};

// ==============================================

class VineyardPhaseOptionalPlan : public ActivityOptional
{
  public :
    VineyardPhaseOptionalPlan();
};

// ==============================================

class ChemicalWeedingActivity : public VineyardActivity
{
  public :
    ChemicalWeedingActivity();
};

// ==============================================

class ClippingActivity : public VineyardActivity
{
  public :
    ClippingActivity();
  public :
    ClippingActivity(Vineyard* pEA);
};

// ==============================================

class ConcurrentAntiMildewTreatments : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentAntiMildewTreatments();
  public :
    ConcurrentAntiMildewTreatments(Vineyard* pEA);
};

// ==============================================

class ConcurrentAutumnTillages : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentAutumnTillages();
  public :
    ConcurrentAutumnTillages(Vineyard* pEA);
};

// ==============================================

class ConcurrentChemicalWeedings : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentChemicalWeedings();
  public :
    ConcurrentChemicalWeedings(Vineyard* pVineyard);
};

// ==============================================

class ConcurrentClippings : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentClippings();
  public :
    ConcurrentClippings(Vineyard* pVineyard);
};

// ==============================================

class ConcurrentClippingsIteration : public DistributedActivitySetIteration
{
  public :
    ConcurrentClippingsIteration();
  public :
    ConcurrentClippingsIteration(Vineyard* pEA);
};

// ==============================================

class ConcurrentDebranchings : public ConcurrentDistributedActivitySet
{
  public :
    ConcurrentDebranchings();
  public :
    ConcurrentDebranchings(Vineyard* pVineyard);
};

// ==============================================

class Conduite1 : public VineyardControlSequence
{
  public :
    Conduite1();
  public :
    Conduite1(Vineyard* pEA);
};

// ==============================================

class Conduite2 : public VineyardControlSequence
{
  public :
    Conduite2();
  public :
    Conduite2(Vineyard* pEA);
};

// ==============================================

class Conduite3 : public VineyardControlSequence
{
  public :
    Conduite3();
  public :
    Conduite3(Vineyard* pEA);
};

// ==============================================

class Conduite4 : public VineyardControlSequence
{
  public :
    Conduite4();
  public :
    Conduite4(Vineyard* pEA);
};

// ==============================================

class Conduite5 : public VineyardControlSequence
{
  public :
    Conduite5();
  public :
    Conduite5(Vineyard* pEA);
};

// ==============================================

class DebranchingActivity : public VineyardActivity
{
  public :
    DebranchingActivity();
};

// ==============================================

class FertilizationActivity : public VineyardActivity
{
  public :
    FertilizationActivity();
  public :
    FertilizationActivity(Vineyard* pEA);
};

// ==============================================

class ManualChemicalDebranchingActivity : public DebranchingActivity
{
  public :
    ManualChemicalDebranchingActivity();
  public :
    ManualChemicalDebranchingActivity(Vineyard* pEA);
};

// ==============================================

class ManualChemicalWeedingActivity : public ChemicalWeedingActivity
{
  public :
    ManualChemicalWeedingActivity();
  public :
    ManualChemicalWeedingActivity(Vineyard* pEA);
};

// ==============================================

class ManualMechanicalDebranchingActivity : public DebranchingActivity
{
  public :
    ManualMechanicalDebranchingActivity();
  public :
    ManualMechanicalDebranchingActivity(Vineyard* pEA);
};

// ==============================================

class MotorizedChemicalDebranchingActivity : public DebranchingActivity
{
  public :
    MotorizedChemicalDebranchingActivity();
  public :
    MotorizedChemicalDebranchingActivity(Vineyard* pEA);
};

// ==============================================

class MotorizedChemicalWeedingActivity : public ChemicalWeedingActivity
{
  public :
    MotorizedChemicalWeedingActivity();
  public :
    MotorizedChemicalWeedingActivity(Vineyard* pEA);
};

// ==============================================

class PhytoTreatmentActivity : public VineyardActivity
{
  public :
    PhytoTreatmentActivity();
};

// ==============================================

class PlantationActivity : public VineyardActivity
{
  public :
    PlantationActivity();
  public :
    PlantationActivity(Vineyard* pEA);
};

// ==============================================

class PruningActivity : public VineyardActivity
{
  public :
    PruningActivity();
  public :
    PruningActivity(Vineyard* pEA);
};

// ==============================================

class RoyatPruningActivity : public PruningActivity
{
  public :
    RoyatPruningActivity();
  public :
    RoyatPruningActivity(Vineyard* pEA);
};

// ==============================================

class SerialAntiMildewTreatments : public SerialDistributedActivitySet
{
  public :
    SerialAntiMildewTreatments();
  public :
    SerialAntiMildewTreatments(Vineyard* pEA);
};

// ==============================================

class SerialAutumnTillages : public SerialDistributedActivitySet
{
  public :
    SerialAutumnTillages();
  public :
    SerialAutumnTillages(Vineyard* pEA);
};

// ==============================================

class SerialChemicalWeedings : public SerialDistributedActivitySet
{
  public :
    SerialChemicalWeedings();
  public :
    SerialChemicalWeedings(Vineyard* pVineyard);
};

// ==============================================

class SerialClippings : public SerialDistributedActivitySet
{
  public :
    SerialClippings();
  public :
    SerialClippings(Vineyard* pVineyard);
};

// ==============================================

class SerialDebranchings : public SerialDistributedActivitySet
{
  public :
    SerialDebranchings();
  public :
    SerialDebranchings(Vineyard* pVineyard);
};

// ==============================================

class SerialManualChemicalWeedings : public SerialChemicalWeedings
{
  public :
    SerialManualChemicalWeedings();
  public :
    SerialManualChemicalWeedings(Vineyard* pVineyard);
};

// ==============================================

class SerialManualDebranchings : public SerialDebranchings
{
  public :
    SerialManualDebranchings();
  public :
    SerialManualDebranchings(Vineyard* pVineyard);
};

// ==============================================

class SerialManualRegularPhytoTreatments : public SerialRegularPhytoTreatments
{
  public :
    SerialManualRegularPhytoTreatments();
  public :
    SerialManualRegularPhytoTreatments(Vineyard* pVineyard);
};

// ==============================================

class SerialManualSpringChemicalWeedings : public SerialSpringChemicalWeedings
{
  public :
    SerialManualSpringChemicalWeedings();
  public :
    SerialManualSpringChemicalWeedings(Vineyard* pVineyard);
};

// ==============================================

class SerialMotorizedChemicalWeedings : public SerialChemicalWeedings
{
  public :
    SerialMotorizedChemicalWeedings();
  public :
    SerialMotorizedChemicalWeedings(Vineyard* pVineyard);
};

// ==============================================

class SerialMotorizedDebranchings : public SerialDebranchings
{
  public :
    SerialMotorizedDebranchings();
  public :
    SerialMotorizedDebranchings(Vineyard* pVineyard);
};

// ==============================================

class SerialMotorizedRegularPhytoTreatments : public SerialRegularPhytoTreatments
{
  public :
    SerialMotorizedRegularPhytoTreatments();
  public :
    SerialMotorizedRegularPhytoTreatments(Vineyard* pVineyard);
};

// ==============================================

class SerialMotorizedSpringChemicalWeedings : public SerialSpringChemicalWeedings
{
  public :
    SerialMotorizedSpringChemicalWeedings();
  public :
    SerialMotorizedSpringChemicalWeedings(Vineyard* pVineyard);
};

// ==============================================

class ShootThinningActivity : public VineyardActivity
{
  public :
    ShootThinningActivity();
  public :
    ShootThinningActivity(Vineyard* pEA);
};

// ==============================================

class TillageActivity : public VineyardActivity
{
  public :
    TillageActivity();
  public :
    TillageActivity(Vineyard* pEA);
};

// ==============================================

class TrellisingActivity : public VineyardActivity
{
  public :
    TrellisingActivity();
  public :
    TrellisingActivity(Vineyard* pEA);
};

// ==============================================

class WinterTillageActivity : public TillageActivity
{
  public :
    WinterTillageActivity();
  public :
    WinterTillageActivity(Vineyard* pEA);
};

// ==============================================

class AutumnTillageActivity : public TillageActivity
{
  public :
    AutumnTillageActivity();
  public :
    AutumnTillageActivity(Vineyard* pEA);
};

// ==============================================

class FormationPruningActivity : public PruningActivity
{
  public :
    FormationPruningActivity();
  public :
    FormationPruningActivity(Vineyard* pEA);
};

// ==============================================

class GobeletPruningActivity : public PruningActivity
{
  public :
    GobeletPruningActivity();
  public :
    GobeletPruningActivity(Vineyard* pEA);
};

// ==============================================

class GuyotPruningActivity : public PruningActivity
{
  public :
    GuyotPruningActivity();
  public :
    GuyotPruningActivity(Vineyard* pEA);
};

// ==============================================

class InitSpringTillageActivity : public TillageActivity
{
  public :
    InitSpringTillageActivity();
  public :
    InitSpringTillageActivity(Vineyard* pEA);
};

// ==============================================

class ManualPhytoTreatmentActivity : public PhytoTreatmentActivity
{
  public :
    ManualPhytoTreatmentActivity();
  public :
    ManualPhytoTreatmentActivity(Vineyard* pEA);
};

// ==============================================

class MotorizedPhytoTreatmentActivity : public PhytoTreatmentActivity
{
  public :
    MotorizedPhytoTreatmentActivity();
  public :
    MotorizedPhytoTreatmentActivity(Vineyard* pEA);
};

// ==============================================

class SpringTillageActivity : public TillageActivity
{
  public :
    SpringTillageActivity();
  public :
    SpringTillageActivity(Vineyard* pEA);
};

#endif  // _User_ACTIVITY_HH
