// ==============================================
// Fichier : UserArgument.h
// Type    : source C++
// 
// Description : Déclarations des classes des 'Argument'.
// ==============================================
  
#ifndef _User_ARGUMENT_HH
#define _User_ARGUMENT_HH
  
#include "UserTypes.h"
  

// ==============================================

class ClockArgument : public IntArgument {
  public :
    ClockArgument();
};


// ==============================================

class DayWhenAchievedArgument : public IntArgument {
  public :
    DayWhenAchievedArgument();
};


// ==============================================

class DaysNumberArgument : public IntArgument {
  public :
    DaysNumberArgument();
};


// ==============================================

class DistributedActivitySetArgument : public EntityArgument {
  public :
    DistributedActivitySetArgument();
};


// ==============================================

class FarmWorkerArgument : public EntityArgument {
  public :
    FarmWorkerArgument();
};


// ==============================================

class InCoursePlotsArgument : public EntityTabArgument {
  public :
    InCoursePlotsArgument();
};


// ==============================================

class ManagementGroupSetArgument : public StringArgument {
  public :
    ManagementGroupSetArgument();
};


// ==============================================

class ManualMotorizedArgument : public StringArgument {
  public :
    ManualMotorizedArgument();
};


// ==============================================

class OperationArgument : public EntityArgument {
  public :
    OperationArgument();
};


// ==============================================

class OperationClassArgument : public IntArgument {
  public :
    OperationClassArgument();
};


// ==============================================

class PlotArgument : public EntityArgument {
  public :
    PlotArgument();
};


// ==============================================

class SeasonArgument : public IntArgument {
  public :
    SeasonArgument();
};


// ==============================================

class SelectedPlotsArgument : public EntityTabArgument {
  public :
    SelectedPlotsArgument();
};


// ==============================================

class SerialParallelArgument : public StringArgument {
  public :
    SerialParallelArgument();
};


// ==============================================

class SprayNumberAtBeginningOptionArgument : public IntArgument {
  public :
    SprayNumberAtBeginningOptionArgument();
};


// ==============================================

class SprayerTypeAtBeginningOptionArgument : public IntArgument {
  public :
    SprayerTypeAtBeginningOptionArgument();
};


// ==============================================

class SprayerTypeRegularOptionArgument : public IntArgument {
  public :
    SprayerTypeRegularOptionArgument();
};


// ==============================================

class StageIndexArgument : public IntArgument {
  public :
    StageIndexArgument();
};


// ==============================================

class TemperatureArgument : public FloatArgument {
  public :
    TemperatureArgument();
};


// ==============================================

class TerminatedPlotsArgument : public EntityTabArgument {
  public :
    TerminatedPlotsArgument();
};


// ==============================================

class VineyardArgument : public EntityArgument {
  public :
    VineyardArgument();
};

#endif  // _User_ARGUMENT_HH
