// ==============================================
// Fichier : UserCondition.h
// Type    : source C++
// 
// Description : déclaration des classes des 'Condition'.
// ==============================================
  
#ifndef _User_CONDITION_HH
#define _User_CONDITION_HH
  
#include "UserTypes.h"
  
// ==============================================

class AtLeastOnePlot : public OccurrenceDomain
{
  public :
    AtLeastOnePlot();
};

// ==============================================

class EquipmentMultiLocalization : public ResourceSharingViolationCondition
{
  public :
    EquipmentMultiLocalization();
};

// ==============================================

class EquipmentUbiquityCondition : public OccurrenceCrossDomain
{
  public :
    EquipmentUbiquityCondition();
};

// ==============================================

class FarmWorkerMultiLocalization : public ResourceSharingViolationCondition
{
  public :
    FarmWorkerMultiLocalization();
};

// ==============================================

class FarmWorkerMultiOccupation : public ResourceSharingViolationCondition
{
  public :
    FarmWorkerMultiOccupation();
};

// ==============================================

class FarmWorkerMultiOccupied : public OccurrenceCrossDomain
{
  public :
    FarmWorkerMultiOccupied();
};

// ==============================================

class FarmWorkerUbiquityCondition : public OccurrenceCrossDomain
{
  public :
    FarmWorkerUbiquityCondition();
};

// ==============================================

class MoreThanOnePlot : public OccurrenceDomain
{
  public :
    MoreThanOnePlot();
};

// ==============================================

class MoreThanOneTask : public OccurrenceDomain
{
  public :
    MoreThanOneTask();
};

// ==============================================

class NeutralInconsistencyCondition : public OccurrenceCrossDomain
{
  public :
    NeutralInconsistencyCondition();
};

// ==============================================

class OnlyPhytoTreatmentsAtEarlyMorning : public ActivityInconsistencyCondition
{
  public :
    OnlyPhytoTreatmentsAtEarlyMorning();
};

// ==============================================

class PlotWithSeveralOperations : public ActivitiesResourcesInconsistentCommitment
{
  public :
    PlotWithSeveralOperations();
};

// ==============================================

class TooLateInWorkDayForActivityBeginning : public ActivityInconsistencyCondition
{
  public :
    TooLateInWorkDayForActivityBeginning();
};

#endif  // _User_CONDITION_HH
