// ==============================================
// Fichier : UserConstantDescriptor.h
// Type    : source C++
// 
// Description : déclaration des classes des 'ConstantDescriptor'.
// ==============================================
  
#ifndef _User_CONSTANTDESCRIPTOR_HH
#define _User_CONSTANTDESCRIPTOR_HH
  
// ------------------------------
// Includes
// ------------------------------
#include "UserTypes.h"
  

// ==============================================

class ActivityAttribute : public EntityConstantDescriptor {
  public :
    ActivityAttribute();
};


// ==============================================

class ActivityNameAttribute : public StringConstantDescriptor {
  public :
    ActivityNameAttribute();
};


// ==============================================

class ActivityNominalDate : public IntConstantDescriptor {
  public :
    ActivityNominalDate();
};


// ==============================================

class ActualRealizationBegDate : public IntConstantDescriptor {
  public :
    ActualRealizationBegDate();
};


// ==============================================

class ActualRealizationEndDate : public IntConstantDescriptor {
  public :
    ActualRealizationEndDate();
};


// ==============================================

class ActuallyOperatedAreaPercentage : public IntConstantDescriptor {
  public :
    ActuallyOperatedAreaPercentage();
};


// ==============================================

class AgeAttribute : public EntityConstantDescriptor {
  public :
    AgeAttribute();
};


// ==============================================

class AlleyWidth : public IntConstantDescriptor {
  public :
    AlleyWidth();
};


// ==============================================

class AllocationPriorityOptionSetAttribute : public EntityConstantDescriptor {
  public :
    AllocationPriorityOptionSetAttribute();
};


// ==============================================

class AnnualEmploymentPlanAttribute : public EntityConstantDescriptor {
  public :
    AnnualEmploymentPlanAttribute();
};


// ==============================================

class AntiMildewScheduled : public IntConstantDescriptor {
  public :
    AntiMildewScheduled();
};


// ==============================================

class AntiMildewTreatmentJustDone : public IntConstantDescriptor {
  public :
    AntiMildewTreatmentJustDone();
};


// ==============================================

class Area : public FloatConstantDescriptor {
  public :
    Area();
};


// ==============================================

class AreaWithGrapevine : public FloatConstantDescriptor {
  public :
    AreaWithGrapevine();
};


// ==============================================

class AreaWithTilledGrapevine : public FloatConstantDescriptor {
  public :
    AreaWithTilledGrapevine();
};


// ==============================================

class AutumnTillagesManagement : public StringConstantDescriptor {
  public :
    AutumnTillagesManagement();
};


// ==============================================

class BeginningCalendarDate : public StringConstantDescriptor {
  public :
    BeginningCalendarDate();
};


// ==============================================

class ChemicalWeedingsManagement : public StringConstantDescriptor {
  public :
    ChemicalWeedingsManagement();
};


// ==============================================

class ClippingsManagement : public StringConstantDescriptor {
  public :
    ClippingsManagement();
};


// ==============================================

class CommercialFormulation : public StringConstantDescriptor {
  public :
    CommercialFormulation();
};


// ==============================================

class CommercialFormulationDose : public FloatConstantDescriptor {
  public :
    CommercialFormulationDose();
};


// ==============================================

class CommercialFormulationList : public StringTabConstantDescriptor {
  public :
    CommercialFormulationList();
};


// ==============================================

class ControlPlanAttribute : public EntityConstantDescriptor {
  public :
    ControlPlanAttribute();
};


// ==============================================

class ControlPlanClassNameAttribute : public StringConstantDescriptor {
  public :
    ControlPlanClassNameAttribute();
};


// ==============================================

class CropRowAlleyWidthRatio : public FloatConstantDescriptor {
  public :
    CropRowAlleyWidthRatio();
};


// ==============================================

class CurrentSlotToBeExtended : public IntConstantDescriptor {
  public :
    CurrentSlotToBeExtended();
};


// ==============================================

class DailyRainfallForecastFromCurrentDay : public FloatTabConstantDescriptor {
  public :
    DailyRainfallForecastFromCurrentDay();
};


// ==============================================

class DayOfAchievement : public IntConstantDescriptor {
  public :
    DayOfAchievement();
};


// ==============================================

class DebranchingsManagement : public StringConstantDescriptor {
  public :
    DebranchingsManagement();
};


// ==============================================

class DecisionOptionSetAttribute : public EntityConstantDescriptor {
  public :
    DecisionOptionSetAttribute();
};


// ==============================================

class DownyMildewLevel : public IntConstantDescriptor {
  public :
    DownyMildewLevel();
};


// ==============================================

class DownyMildewManagementAttribute : public IntConstantDescriptor {
  public :
    DownyMildewManagementAttribute();
};


// ==============================================

class DownyMildewPressure : public IntConstantDescriptor {
  public :
    DownyMildewPressure();
};


// ==============================================

class DownyMildewPrimaryInfection : public IntConstantDescriptor {
  public :
    DownyMildewPrimaryInfection();
};


// ==============================================

class DownyMildewRiskLevel : public FloatConstantDescriptor {
  public :
    DownyMildewRiskLevel();
};


// ==============================================

class DownyMildewToClose : public IntConstantDescriptor {
  public :
    DownyMildewToClose();
};


// ==============================================

class EndCalendarDate : public StringConstantDescriptor {
  public :
    EndCalendarDate();
};


// ==============================================

class FarmWorkerAttribute : public EntityConstantDescriptor {
  public :
    FarmWorkerAttribute();
};


// ==============================================

class FertilizationsManagement : public StringConstantDescriptor {
  public :
    FertilizationsManagement();
};


// ==============================================

class FirstSpringTillageDate : public IntConstantDescriptor {
  public :
    FirstSpringTillageDate();
};


// ==============================================

class FlagMildew : public IntConstantDescriptor {
  public :
    FlagMildew();
};


// ==============================================

class GrapeVarietyAttribute : public EntityConstantDescriptor {
  public :
    GrapeVarietyAttribute();
};


// ==============================================

class GrapeVarietyListAttribute : public EntityTabConstantDescriptor {
  public :
    GrapeVarietyListAttribute();
};


// ==============================================

class GrassCoverVectorFromMhydas : public FloatTabConstantDescriptor {
  public :
    GrassCoverVectorFromMhydas();
};


// ==============================================

class GrassStripAlleyWidthRatio : public FloatConstantDescriptor {
  public :
    GrassStripAlleyWidthRatio();
};


// ==============================================

class GrassTypeAttribute : public EntityConstantDescriptor {
  public :
    GrassTypeAttribute();
};


// ==============================================

class GuidingEarlyVarietyAttribute : public StringConstantDescriptor {
  public :
    GuidingEarlyVarietyAttribute();
};


// ==============================================

class GuidingLateVarietyAttribute : public StringConstantDescriptor {
  public :
    GuidingLateVarietyAttribute();
};


// ==============================================

class GuidingVarietiesAttribute : public StringTabConstantDescriptor {
  public :
    GuidingVarietiesAttribute();
};


// ==============================================

class HasEarlyVariety : public IntConstantDescriptor {
  public :
    HasEarlyVariety();
};


// ==============================================

class HasLateVariety : public IntConstantDescriptor {
  public :
    HasLateVariety();
};


// ==============================================

class InOutMode : public IntConstantDescriptor {
  public :
    InOutMode();
};


// ==============================================

class InitSpringTillagesManagement : public StringConstantDescriptor {
  public :
    InitSpringTillagesManagement();
};


// ==============================================

class IsAllocationExclusive : public IntConstantDescriptor {
  public :
    IsAllocationExclusive();
};


// ==============================================

class IsEarly : public IntConstantDescriptor {
  public :
    IsEarly();
};


// ==============================================

class IsManager : public IntConstantDescriptor {
  public :
    IsManager();
};


// ==============================================

class IsoAgeingEntityAttribute : public EntityConstantDescriptor {
  public :
    IsoAgeingEntityAttribute();
};


// ==============================================

class IsoAgeingEntitySetAttribute : public EntityTabConstantDescriptor {
  public :
    IsoAgeingEntitySetAttribute();
};


// ==============================================

class JulianTimeToAchieve : public IntConstantDescriptor {
  public :
    JulianTimeToAchieve();
};


// ==============================================

class LaiForMowing : public FloatConstantDescriptor {
  public :
    LaiForMowing();
};


// ==============================================

class LandUse : public StringConstantDescriptor {
  public :
    LandUse();
};


// ==============================================

class LastOperationsMemoryAttribute : public EntityConstantDescriptor {
  public :
    LastOperationsMemoryAttribute();
};


// ==============================================

class LastRainfallClock : public IntConstantDescriptor {
  public :
    LastRainfallClock();
};


// ==============================================

class LastSevenDaysRainfall : public FloatConstantDescriptor {
  public :
    LastSevenDaysRainfall();
};


// ==============================================

class LastTillageOperationClock : public IntConstantDescriptor {
  public :
    LastTillageOperationClock();
};


// ==============================================

class LastWeatherPrintClock : public IntConstantDescriptor {
  public :
    LastWeatherPrintClock();
};


// ==============================================

class Latitude : public FloatConstantDescriptor {
  public :
    Latitude();
};


// ==============================================

class LeafAreaIndexRate : public FloatConstantDescriptor {
  public :
    LeafAreaIndexRate();
};


// ==============================================

class LeafLifeSpanMin : public IntConstantDescriptor {
  public :
    LeafLifeSpanMin();
};


// ==============================================

class Longitude : public FloatConstantDescriptor {
  public :
    Longitude();
};


// ==============================================

class MaxReplicationNumberInDryPeriod : public IntConstantDescriptor {
  public :
    MaxReplicationNumberInDryPeriod();
};


// ==============================================

class MeanPriorityDegree : public FloatConstantDescriptor {
  public :
    MeanPriorityDegree();
};


// ==============================================

class MembershipMode : public IntConstantDescriptor {
  public :
    MembershipMode();
};


// ==============================================

class MinPercentageToBeginOperation : public FloatConstantDescriptor {
  public :
    MinPercentageToBeginOperation();
};


// ==============================================

class NeedForNextFavourableDays : public IntConstantDescriptor {
  public :
    NeedForNextFavourableDays();
};


// ==============================================

class NumberOfTractors : public IntConstantDescriptor {
  public :
    NumberOfTractors();
};


// ==============================================

class NumberOfWorkers : public IntConstantDescriptor {
  public :
    NumberOfWorkers();
};


// ==============================================

class OffWorkCalendarAttribute : public EntityConstantDescriptor {
  public :
    OffWorkCalendarAttribute();
};


// ==============================================

class OperatedPlotsAttribute : public EntityTabConstantDescriptor {
  public :
    OperatedPlotsAttribute();
};


// ==============================================

class OperationPriorityOptionSetAttribute : public EntityConstantDescriptor {
  public :
    OperationPriorityOptionSetAttribute();
};


// ==============================================

class OperationRecordingAttribute : public EntityConstantDescriptor {
  public :
    OperationRecordingAttribute();
};


// ==============================================

class OptActualDownyMildewRiskThreshold : public FloatConstantDescriptor {
  public :
    OptActualDownyMildewRiskThreshold();
};


// ==============================================

class OptAutumnTillageCP : public IntConstantDescriptor {
  public :
    OptAutumnTillageCP();
};


// ==============================================

class OptAutumnTillageOP : public IntConstantDescriptor {
  public :
    OptAutumnTillageOP();
};


// ==============================================

class OptChemicalWeedingOP : public IntConstantDescriptor {
  public :
    OptChemicalWeedingOP();
};


// ==============================================

class OptCropRowAlleyWidthRatio : public FloatConstantDescriptor {
  public :
    OptCropRowAlleyWidthRatio();
};


// ==============================================

class OptDebranchingModality : public IntConstantDescriptor {
  public :
    OptDebranchingModality();
};


// ==============================================

class OptDownyMildewAtLeastClosing : public IntConstantDescriptor {
  public :
    OptDownyMildewAtLeastClosing();
};


// ==============================================

class OptDownyMildewManagement : public IntConstantDescriptor {
  public :
    OptDownyMildewManagement();
};


// ==============================================

class OptDownyMildewUnderPressureClosing : public IntConstantDescriptor {
  public :
    OptDownyMildewUnderPressureClosing();
};


// ==============================================

class OptExtraPhytoTreatmentsOP : public IntConstantDescriptor {
  public :
    OptExtraPhytoTreatmentsOP();
};


// ==============================================

class OptFertilizationOP : public IntConstantDescriptor {
  public :
    OptFertilizationOP();
};


// ==============================================

class OptFertilizationSeason : public IntConstantDescriptor {
  public :
    OptFertilizationSeason();
};


// ==============================================

class OptFirstSpringTillageOP : public IntConstantDescriptor {
  public :
    OptFirstSpringTillageOP();
};


// ==============================================

class OptGrassStripAlleyWidthRatio : public FloatConstantDescriptor {
  public :
    OptGrassStripAlleyWidthRatio();
};


// ==============================================

class OptInitSpringTillageOP : public IntConstantDescriptor {
  public :
    OptInitSpringTillageOP();
};


// ==============================================

class OptPastDownyMildewPressureThreshold : public FloatConstantDescriptor {
  public :
    OptPastDownyMildewPressureThreshold();
};


// ==============================================

class OptPhytoTreatmentCadence : public IntConstantDescriptor {
  public :
    OptPhytoTreatmentCadence();
};


// ==============================================

class OptPhytoTreatmentRainAnticipation : public IntConstantDescriptor {
  public :
    OptPhytoTreatmentRainAnticipation();
};


// ==============================================

class OptPlantationOP : public IntConstantDescriptor {
  public :
    OptPlantationOP();
};


// ==============================================

class OptPowderyMildewClosing : public IntConstantDescriptor {
  public :
    OptPowderyMildewClosing();
};


// ==============================================

class OptPowderyMildewManagement : public IntConstantDescriptor {
  public :
    OptPowderyMildewManagement();
};


// ==============================================

class OptPrePruningModality : public IntConstantDescriptor {
  public :
    OptPrePruningModality();
};


// ==============================================

class OptPruningMinBegDate : public IntConstantDescriptor {
  public :
    OptPruningMinBegDate();
};


// ==============================================

class OptPruningOP : public IntConstantDescriptor {
  public :
    OptPruningOP();
};


// ==============================================

class OptRegularPhytoTreatmentsOP : public IntConstantDescriptor {
  public :
    OptRegularPhytoTreatmentsOP();
};


// ==============================================

class OptRidingOrientedInterRowProportion : public FloatConstantDescriptor {
  public :
    OptRidingOrientedInterRowProportion();
};


// ==============================================

class OptShootThinningsOP : public IntConstantDescriptor {
  public :
    OptShootThinningsOP();
};


// ==============================================

class OptSprayNumberAtBeginning : public IntConstantDescriptor {
  public :
    OptSprayNumberAtBeginning();
};


// ==============================================

class OptSprayPathAtBeginning : public FloatConstantDescriptor {
  public :
    OptSprayPathAtBeginning();
};


// ==============================================

class OptSprayPathRegular : public FloatConstantDescriptor {
  public :
    OptSprayPathRegular();
};


// ==============================================

class OptSprayPathSinceFlowering : public FloatConstantDescriptor {
  public :
    OptSprayPathSinceFlowering();
};


// ==============================================

class OptSprayerTypeAtBeginning : public IntConstantDescriptor {
  public :
    OptSprayerTypeAtBeginning();
};


// ==============================================

class OptSprayerTypeRegular : public IntConstantDescriptor {
  public :
    OptSprayerTypeRegular();
};


// ==============================================

class OptSpringChemicalWeedingOP : public IntConstantDescriptor {
  public :
    OptSpringChemicalWeedingOP();
};


// ==============================================

class OptSpringFertMaxBegDate : public IntConstantDescriptor {
  public :
    OptSpringFertMaxBegDate();
};


// ==============================================

class OptSpringFertMinBegDate : public IntConstantDescriptor {
  public :
    OptSpringFertMinBegDate();
};


// ==============================================

class OptSpringTillagesIterationCP : public IntConstantDescriptor {
  public :
    OptSpringTillagesIterationCP();
};


// ==============================================

class OptSpringTillagesOP : public IntConstantDescriptor {
  public :
    OptSpringTillagesOP();
};


// ==============================================

class OptSpringTillagesOPScope : public IntConstantDescriptor {
  public :
    OptSpringTillagesOPScope();
};


// ==============================================

class PathNameAttribute : public StringConstantDescriptor {
  public :
    PathNameAttribute();
};


// ==============================================

class PestInfoMemoryAttribute : public EntityConstantDescriptor {
  public :
    PestInfoMemoryAttribute();
};


// ==============================================

class PesticideSubtype : public StringConstantDescriptor {
  public :
    PesticideSubtype();
};


// ==============================================

class PesticideType : public StringConstantDescriptor {
  public :
    PesticideType();
};


// ==============================================

class PhytoManagement : public StringConstantDescriptor {
  public :
    PhytoManagement();
};


// ==============================================

class PhytoTreatmentList : public StringTabConstantDescriptor {
  public :
    PhytoTreatmentList();
};


// ==============================================

class PlaceName : public StringConstantDescriptor {
  public :
    PlaceName();
};


// ==============================================

class PlantAttribute : public EntityConstantDescriptor {
  public :
    PlantAttribute();
};


// ==============================================

class PlantSpacing : public IntConstantDescriptor {
  public :
    PlantSpacing();
};


// ==============================================

class PlotPattern : public EntityConstantDescriptor {
  public :
    PlotPattern();
};


// ==============================================

class PlotPatternOptionSetAttribute : public EntityConstantDescriptor {
  public :
    PlotPatternOptionSetAttribute();
};


// ==============================================

class PlotProfile : public DescValueSpecTabConstantDescriptor {
  public :
    PlotProfile();
};


// ==============================================

class PlotProfileOperator : public IntConstantDescriptor {
  public :
    PlotProfileOperator();
};


// ==============================================

class PowderyMildewFlagShoot : public IntConstantDescriptor {
  public :
    PowderyMildewFlagShoot();
};


// ==============================================

class PowderyMildewLevel : public IntConstantDescriptor {
  public :
    PowderyMildewLevel();
};


// ==============================================

class PowderyMildewManagementAttribute : public IntConstantDescriptor {
  public :
    PowderyMildewManagementAttribute();
};


// ==============================================

class PowderyMildewToClose : public IntConstantDescriptor {
  public :
    PowderyMildewToClose();
};


// ==============================================

class PreviousReplicationRefDate : public IntConstantDescriptor {
  public :
    PreviousReplicationRefDate();
};


// ==============================================

class PruningMode : public StringConstantDescriptor {
  public :
    PruningMode();
};


// ==============================================

class PruningsManagement : public StringConstantDescriptor {
  public :
    PruningsManagement();
};


// ==============================================

class RecordedActivityClassName : public StringConstantDescriptor {
  public :
    RecordedActivityClassName();
};


// ==============================================

class RecordedChantierClassName : public StringConstantDescriptor {
  public :
    RecordedChantierClassName();
};


// ==============================================

class RecordedDay : public IntConstantDescriptor {
  public :
    RecordedDay();
};


// ==============================================

class RecordedInDayDuration : public IntConstantDescriptor {
  public :
    RecordedInDayDuration();
};


// ==============================================

class RecordedJulianDay : public IntConstantDescriptor {
  public :
    RecordedJulianDay();
};


// ==============================================

class RecordedMonth : public IntConstantDescriptor {
  public :
    RecordedMonth();
};


// ==============================================

class RecordedOperationClassName : public StringConstantDescriptor {
  public :
    RecordedOperationClassName();
};


// ==============================================

class RecordedPerformerList : public EntityTabConstantDescriptor {
  public :
    RecordedPerformerList();
};


// ==============================================

class RecordedPhytoProductList : public StringTabConstantDescriptor {
  public :
    RecordedPhytoProductList();
};


// ==============================================

class RecordedPlotName : public StringConstantDescriptor {
  public :
    RecordedPlotName();
};


// ==============================================

class RecordedResourceList : public EntityTabConstantDescriptor {
  public :
    RecordedResourceList();
};


// ==============================================

class RecordedYear : public IntConstantDescriptor {
  public :
    RecordedYear();
};


// ==============================================

class RegularPhytoTreatmentIndex : public IntConstantDescriptor {
  public :
    RegularPhytoTreatmentIndex();
};


// ==============================================

class RelativeArea : public FloatConstantDescriptor {
  public :
    RelativeArea();
};


// ==============================================

class RidingOrientedInterRowProportion : public FloatConstantDescriptor {
  public :
    RidingOrientedInterRowProportion();
};


// ==============================================

class RowManagement : public IntConstantDescriptor {
  public :
    RowManagement();
};


// ==============================================

class SeasonalEmploymentPlanAttribute : public EntityConstantDescriptor {
  public :
    SeasonalEmploymentPlanAttribute();
};


// ==============================================

class ShootIntensity : public IntConstantDescriptor {
  public :
    ShootIntensity();
};


// ==============================================

class ShootThinningsManagement : public StringConstantDescriptor {
  public :
    ShootThinningsManagement();
};


// ==============================================

class SkippedPlotsAttribute : public EntityTabConstantDescriptor {
  public :
    SkippedPlotsAttribute();
};


// ==============================================

class SoilHumidityVectorFromMhydas : public FloatTabConstantDescriptor {
  public :
    SoilHumidityVectorFromMhydas();
};


// ==============================================

class SoilManagementGroupName : public StringConstantDescriptor {
  public :
    SoilManagementGroupName();
};


// ==============================================

class SoilManagementGroupSetName : public StringConstantDescriptor {
  public :
    SoilManagementGroupSetName();
};


// ==============================================

class SoilManagementModality : public IntConstantDescriptor {
  public :
    SoilManagementModality();
};


// ==============================================

class SoilManagementOption : public IntConstantDescriptor {
  public :
    SoilManagementOption();
};


// ==============================================

class SoilType : public StringConstantDescriptor {
  public :
    SoilType();
};


// ==============================================

class SpringChemicalWeedingsManagement : public StringConstantDescriptor {
  public :
    SpringChemicalWeedingsManagement();
};


// ==============================================

class SpringTillagesManagement : public StringConstantDescriptor {
  public :
    SpringTillagesManagement();
};


// ==============================================

class StageName : public StringConstantDescriptor {
  public :
    StageName();
};


// ==============================================

class StageTab : public EntityTabConstantDescriptor {
  public :
    StageTab();
};


// ==============================================

class StandardValuePriorityTab : public IntTabConstantDescriptor {
  public :
    StandardValuePriorityTab();
};


// ==============================================

class Stoniness : public StringConstantDescriptor {
  public :
    Stoniness();
};


// ==============================================

class TerminatedPlotsAttribute : public EntityTabConstantDescriptor {
  public :
    TerminatedPlotsAttribute();
};


// ==============================================

class ThermalTimeFromBbkToAchieve : public FloatConstantDescriptor {
  public :
    ThermalTimeFromBbkToAchieve();
};


// ==============================================

class ThermalTimeToAchieve : public FloatConstantDescriptor {
  public :
    ThermalTimeToAchieve();
};


// ==============================================

class TimetableAttribute : public EntityConstantDescriptor {
  public :
    TimetableAttribute();
};


// ==============================================

class ToolClassName : public StringConstantDescriptor {
  public :
    ToolClassName();
};


// ==============================================

class TrellisMode : public StringConstantDescriptor {
  public :
    TrellisMode();
};


// ==============================================

class Village : public StringConstantDescriptor {
  public :
    Village();
};


// ==============================================

class VineyardAttribute : public EntityConstantDescriptor {
  public :
    VineyardAttribute();
};


// ==============================================

class WeatherStationAttribute : public EntityConstantDescriptor {
  public :
    WeatherStationAttribute();
};


// ==============================================

class WeekDayNumber : public IntConstantDescriptor {
  public :
    WeekDayNumber();
};


// ==============================================

class Width : public IntConstantDescriptor {
  public :
    Width();
};


// ==============================================

class WinterBeginningClock : public IntConstantDescriptor {
  public :
    WinterBeginningClock();
};


// ==============================================

class WinterBeginningClockForInitst : public IntConstantDescriptor {
  public :
    WinterBeginningClockForInitst();
};


// ==============================================

class WinterTillagesManagement : public StringConstantDescriptor {
  public :
    WinterTillagesManagement();
};


// ==============================================

class WorkBeginningHour : public IntConstantDescriptor {
  public :
    WorkBeginningHour();
};


// ==============================================

class WorkDayAfternoonBegHour : public FloatConstantDescriptor {
  public :
    WorkDayAfternoonBegHour();
};


// ==============================================

class WorkDayAfternoonEndHour : public FloatConstantDescriptor {
  public :
    WorkDayAfternoonEndHour();
};


// ==============================================

class WorkDayAfternoonExtendedEndHour : public FloatConstantDescriptor {
  public :
    WorkDayAfternoonExtendedEndHour();
};


// ==============================================

class WorkDayMorningBegHour : public FloatConstantDescriptor {
  public :
    WorkDayMorningBegHour();
};


// ==============================================

class WorkDayMorningEndHour : public FloatConstantDescriptor {
  public :
    WorkDayMorningEndHour();
};


// ==============================================

class WorkDayMorningExtendedEndHour : public FloatConstantDescriptor {
  public :
    WorkDayMorningExtendedEndHour();
};


// ==============================================

class WorkOrganizationOptionSetAttribute : public EntityConstantDescriptor {
  public :
    WorkOrganizationOptionSetAttribute();
};


// ==============================================

class WorkingTimeDailyUpperBound : public IntConstantDescriptor {
  public :
    WorkingTimeDailyUpperBound();
};


// ==============================================

class WorkingTimeWeeklyUpperBound : public IntConstantDescriptor {
  public :
    WorkingTimeWeeklyUpperBound();
};


// ==============================================

class WorkingTimeYearlyUpperBound : public IntConstantDescriptor {
  public :
    WorkingTimeYearlyUpperBound();
};


// ==============================================

class YearOfPlantation : public IntConstantDescriptor {
  public :
    YearOfPlantation();
};

#endif  // _User_CONSTANTDESCRIPTOR_HH
