// ==============================================
// Fichier : UserEntity.h
// Type    : source C++
// 
// Description : déclaration des classes des 'Entity'.
// ==============================================
  
#ifndef _User_ENTITY_HH
#define _User_ENTITY_HH
  
#include "UserTypes.h"
  
// ==============================================

class AgroClimaticSystem : public Entity
{
  public :
    AgroClimaticSystem();
};

// ==============================================

class AllocationPriorityOptionSet : public Entity
{
  public :
    AllocationPriorityOptionSet();
};

// ==============================================

class AllocationPriorityOptionSubset : public Entity
{
  public :
    AllocationPriorityOptionSubset();
};

// ==============================================

class AnnualEmploymentPlan : public Entity
{
  public :
    AnnualEmploymentPlan();
};

// ==============================================

class DecisionOptionSet : public Entity
{
  public :
    DecisionOptionSet();
};

// ==============================================

class DistributedActivitySetMemoryItem : public Entity
{
  public :
    DistributedActivitySetMemoryItem();
};

// ==============================================

class GrapeVariety : public Entity
{
  public :
    GrapeVariety();
};

// ==============================================

class GrassType : public Entity
{
  public :
    GrassType();
};

// ==============================================

class IsoAgeingEntity : public Entity
{
  public :
    IsoAgeingEntity();
};

// ==============================================

class LastOperationsMemory : public Entity
{
  public :
    LastOperationsMemory();
};

// ==============================================

class LastOperationsMemoryItem : public Entity
{
  public :
    LastOperationsMemoryItem();
};

// ==============================================

class LastPesticideApplicationsMemoryItem : public LastOperationsMemoryItem
{
  public :
    LastPesticideApplicationsMemoryItem();
};

// ==============================================

class LastTillageOperationsMemoryItem : public LastOperationsMemoryItem
{
  public :
    LastTillageOperationsMemoryItem();
};

// ==============================================

class ManagerAnnualEmploymentPlan : public AnnualEmploymentPlan
{
  public :
    ManagerAnnualEmploymentPlan();
};

// ==============================================

class OffWorkCalendar : public Entity
{
  public :
    OffWorkCalendar();
};

// ==============================================

class OffWorkSinglePeriod : public Entity
{
  public :
    OffWorkSinglePeriod();
};

// ==============================================

class OperationPriorityOptionSet : public Entity
{
  public :
    OperationPriorityOptionSet();
};

// ==============================================

class OperationPriorityOptionSubset : public Entity
{
  public :
    OperationPriorityOptionSubset();
};

// ==============================================

class OperationRecordingItem : public Entity
{
  public :
    OperationRecordingItem();
};

// ==============================================

class OperationRecordingStructure : public Entity
{
  public :
    OperationRecordingStructure();
};

// ==============================================

class PestInfoMemory : public Entity
{
  public :
    PestInfoMemory();
};

// ==============================================

class PestInfoMemoryItem : public Entity
{
  public :
    PestInfoMemoryItem();
};

// ==============================================

class PhenoStage : public Entity
{
  public :
    PhenoStage();
};

// ==============================================

class PlantAge : public Entity
{
  public :
    PlantAge();
};

// ==============================================

class Plot : public Entity
{
  public :
    Plot();
  public :
    Plot(char* name);
};

// ==============================================

class PlotInternalPatternOptionSet : public Entity
{
  public :
    PlotInternalPatternOptionSet();
};

// ==============================================

class PlotInternalPatternOptionSubset : public Entity
{
  public :
    PlotInternalPatternOptionSubset();
};

// ==============================================

class RetiredWorkerAnnualEmploymentPlan : public AnnualEmploymentPlan
{
  public :
    RetiredWorkerAnnualEmploymentPlan();
};

// ==============================================

class Row : public Entity
{
  public :
    Row();
};

// ==============================================

class SeasonalEmploymentPlan : public Entity
{
  public :
    SeasonalEmploymentPlan();
};

// ==============================================

class SeptemberOctoberEmploymentPlan : public SeasonalEmploymentPlan
{
  public :
    SeptemberOctoberEmploymentPlan();
};

// ==============================================

class SeptemberOctoberNormalHoursEmploymentPlan : public SeptemberOctoberEmploymentPlan
{
  public :
    SeptemberOctoberNormalHoursEmploymentPlan();
};

// ==============================================

class SeptemberOctoberReducedHoursEmploymentPlan : public SeptemberOctoberEmploymentPlan
{
  public :
    SeptemberOctoberReducedHoursEmploymentPlan();
};

// ==============================================

class SoilManagementGroup : public Entity
{
  public :
    SoilManagementGroup();
};

// ==============================================

class SoilManagementGroupSet : public Entity
{
  public :
    SoilManagementGroupSet();
};

// ==============================================

class SoilReservoir : public Entity
{
  public :
    SoilReservoir();
};

// ==============================================

class SoilSurface : public Entity
{
  public :
    SoilSurface();
};

// ==============================================

class SpecialWorkerAnnualEmploymentPlan : public AnnualEmploymentPlan
{
  public :
    SpecialWorkerAnnualEmploymentPlan();
};

// ==============================================

class StandardWorkerAnnualEmploymentPlan : public AnnualEmploymentPlan
{
  public :
    StandardWorkerAnnualEmploymentPlan();
};

// ==============================================

class VarietyGroup : public Entity
{
  public :
    VarietyGroup();
};

// ==============================================

class VarietyGroupSet : public Entity
{
  public :
    VarietyGroupSet();
};

// ==============================================

class VegetalCompartment : public Entity
{
  public :
    VegetalCompartment();
};

// ==============================================

class Vegetation : public Entity
{
  public :
    Vegetation();
};

// ==============================================

class Vineyard : public Entity
{
  public :
    Vineyard();
};

// ==============================================

class VineyardSet : public Entity
{
  public :
    VineyardSet();
};

// ==============================================

class WeatherStation : public Entity
{
  public :
    WeatherStation();
};

// ==============================================

class WeatherStationSet : public Entity
{
  public :
    WeatherStationSet();
};

// ==============================================

class WorkOrganizationOptionSet : public Entity
{
  public :
    WorkOrganizationOptionSet();
};

// ==============================================

class WorkOrganizationOptionSubset : public Entity
{
  public :
    WorkOrganizationOptionSubset();
};

// ==============================================

class AprilEmploymentPlan : public SeasonalEmploymentPlan
{
  public :
    AprilEmploymentPlan();
};

// ==============================================

class AprilNormalHoursEmploymentPlan : public AprilEmploymentPlan
{
  public :
    AprilNormalHoursEmploymentPlan();
};

// ==============================================

class AprilReducedHoursEmploymentPlan : public AprilEmploymentPlan
{
  public :
    AprilReducedHoursEmploymentPlan();
};

// ==============================================

class CropRow : public Row
{
  public :
    CropRow();
};

// ==============================================

class FebruaryMarchEmploymentPlan : public SeasonalEmploymentPlan
{
  public :
    FebruaryMarchEmploymentPlan();
};

// ==============================================

class FebruaryMarchNormalHoursEmploymentPlan : public FebruaryMarchEmploymentPlan
{
  public :
    FebruaryMarchNormalHoursEmploymentPlan();
};

// ==============================================

class FebruaryMarchReducedHoursEmploymentPlan : public FebruaryMarchEmploymentPlan
{
  public :
    FebruaryMarchReducedHoursEmploymentPlan();
};

// ==============================================

class Grapevine : public Vegetation
{
  public :
    Grapevine();
};

// ==============================================

class GrapevineAge : public PlantAge
{
  public :
    GrapevineAge();
};

// ==============================================

class Grass : public Vegetation
{
  public :
    Grass();
};

// ==============================================

class GrassAge : public PlantAge
{
  public :
    GrassAge();
};

// ==============================================

class InterRow : public Row
{
  public :
    InterRow();
};

// ==============================================

class MayAugustEmploymentPlan : public SeasonalEmploymentPlan
{
  public :
    MayAugustEmploymentPlan();
};

// ==============================================

class MayAugustExtendedHoursEmploymentPlan : public MayAugustEmploymentPlan
{
  public :
    MayAugustExtendedHoursEmploymentPlan();
};

// ==============================================

class MayAugustNormalHoursEmploymentPlan : public MayAugustEmploymentPlan
{
  public :
    MayAugustNormalHoursEmploymentPlan();
};

// ==============================================

class MayAugustReducedHoursEmploymentPlan : public MayAugustEmploymentPlan
{
  public :
    MayAugustReducedHoursEmploymentPlan();
};

// ==============================================

class NovemberJanuaryEmploymentPlan : public SeasonalEmploymentPlan
{
  public :
    NovemberJanuaryEmploymentPlan();
};

// ==============================================

class NovemberJanuaryNormalHoursEmploymentPlan : public NovemberJanuaryEmploymentPlan
{
  public :
    NovemberJanuaryNormalHoursEmploymentPlan();
};

// ==============================================

class NovemberJanuaryReducedHoursEmploymentPlan : public NovemberJanuaryEmploymentPlan
{
  public :
    NovemberJanuaryReducedHoursEmploymentPlan();
};

#endif  // _User_ENTITY_HH
