// ==============================================
// Fichier : UserFile.h
// Type    : source C++
// 
// Description : déclaration des classes de fichiers sequentiels.
// ==============================================
  
#ifndef _User_FILE_HH
#define _User_FILE_HH
  
#include "UserTypes.h"
  
  
// ==============================================
// Fichier séquentiel : 'HourlyWeatherFile'
// ==============================================

class HourlyWeatherFile : public BufferizedDataFile {
  public :
      HourlyWeatherFile();
};

int hourlyWeatherFile_ScanNextEnrgt(BufferizedDataFile*, char*);

int hourlyWeatherFile_SetMemoryScope(UserFileId fileId);
int hourlyWeatherFile_SetPredictionScope(UserFileId fileId);

enum HourlyWeatherFile_Fields {
  FLD_DATE,
  FLD_HOUR,
  FLD_RAINFALL
};


// ==============================================
// Fichier séquentiel : 'PestInfoFile'
// ==============================================

class PestInfoFile : public FactualDataFile {
  public :
      PestInfoFile();
};

int pestInfoFile_ReadNextEnrgt(FactualDataFile*);
int pestInfoFile_GetRecordClockValue(FactualDataFile*);

enum PestInfoFile_Fields {
  FLD_DMY,
  FLD_FLAGSHOOT,
  FLD_LEVEL_PM,
  FLD_PRIM_INFECT_DM,
  FLD_LEVEL_DM,
  FLD_RISK_DM
};


// ==============================================
// Fichier séquentiel : 'PhenoStageFile'
// ==============================================

class PhenoStageFile : public FactualDataFile {
  public :
      PhenoStageFile();
};

int phenoStageFile_ReadNextEnrgt(FactualDataFile*);
int phenoStageFile_GetRecordClockValue(FactualDataFile*);

enum PhenoStageFile_Fields {
  FLD_CODE_STADE,
  FLD_JMA,
  FLD_VARIETE
};


#endif  // _User_FILE_HH
