// ==============================================
// Fichier : UserFunction.h
// Type    : source C++
// 
// Description : Fonctions 'développeur'.
// ==============================================

#ifndef _User_FUNCTION_HH
#define _User_FUNCTION_HH

#include <string.h>
#include <stdlib.h>
#include "UserTypes.h"

// ------------------------------
// Fonctions 'developpeur'
// ------------------------------

bool App_AreAllPlotsDone(Activity* pChantier, UserDescriptorId descId);

void App_AssignIsoAgeingEntityToPlots (Entity* pVineyardSet);

void App_AssignTurnedOffActivitiesOnPlots (Entity* pVineyardSet);

void App_Body_mySortActivitySetsInARB (EntityMethod* pM);

void App_Body_pushMAXSpecToBackInARBActivitySet (EntityMethod* pM);

void App_ControlPlanSettings (char fileName[]);

void App_DeallocateMiscellaneousDynamicEntities ();

void App_DeallocatePrimitiveActivities (Activity* pChantier);

void App_DepthBioPhysicalSettings (char fileName[]);

float App_DistanceToWeatherStation (Entity* pTarget, float x, float y);

char* App_EnumToChar (int value);

int App_EnumToInt (char* token);

void App_Exception (int excep, int clock, Entity* pE);

bool App_FloatEQ (float left, float right);

bool App_FloatGT (float left, float right);

bool App_FloatLT (float left, float right);

bool App_FloatNEQ (float left, float right);

int App_GetAllocationExclusivity(Entity* pARB, char* nomClasse);

int App_GetAllocationPriority(Entity* pVineyard, char* nomClasse, UserDescriptorId descId, int numPhase);

float App_GetAlreadyChosenActivitiesDuration (pEntityTab* pInCoursePlots, Entity* pChantier, char* optionSerPar, char* manualMotorizedValue, float passedRowFrequency, float manualNominalSpeed, float motorizedNominalSpeed);

int App_GetDistributedActivitySetType (Entity* pObj);

float App_GetExpectedDuration (Entity* pPlot, bool isPlotMotorizable, UserClassId otClassId, char* optionSerPar, char* manualMotorizedValue, float passedRowFrequency, float manualNominalSpeed, float motorizedNominalSpeed);

float App_GetFloatDecisionOption (Entity* pVineyard, UserDescriptorId descId);

float App_GetFloatPestInfo (Vineyard* pEA, UserDescriptorId descId);

int App_GetIntDecisionOption (Entity* pVineyard, UserDescriptorId descId);

float App_GetIntPestHistory (Vineyard* pEA, UserDescriptorId descId);

int App_GetIntPestInfo (Vineyard* pEA, UserDescriptorId descId);

pEntityTab* App_GetIsoAgeingEntityList (Entity* pEA, Entity* pVariety, Entity* pWS);

int App_GetOperationPriority (Entity* pVineyard, char* nomClasse, UserDescriptorId descId, int numPhase);

int App_GetPhaseIndex (Activity* pAct);

int App_GetResourceNumberForDistributedActivitySet(Entity* pVineyard, Entity* pChantier);

int App_GetResourceNumberFromDistributedActivitySetClassId(Entity* pVineyard, UserClassId chantierClassId);

char* App_GetStringDecisionOption (Entity* pVineyard, UserDescriptorId descId);

char* App_GetStringWorkOrganizationOption (Entity* pVineyard, int phaseIndex, UserDescriptorId descId);

VarietyGroupSet* App_GetVarietyGroupSet (int powderyMildewManagement);

Vineyard* App_GetVineyard (Activity* pInst);

bool App_HasThisGuidingVariety (Entity* pEA, Entity* pVariety);

void App_InstantiateWorkers (char* nomEA, Entity* pPool, char* subPool, char* shortName, char* className);

bool App_IsStageReached (WeatherStation* pWS_arg, char* nomVariety_arg, char* nomStade_arg);

bool App_IsStageReachedForEarlyGuidingVariety (Vineyard* pEA, char* nomStade_arg);

bool App_IsStageReachedForLateGuidingVariety (Vineyard* pEA, char* nomStade_arg);

int App_JulianDayToClockFromBegSim (int julianDay);

void App_MakeGanttChartCommandFiles ();

void App_ParseMainArguments (int argc, char* argv[]);

void App_ResourceSettings (char fileName[]);

pIntTab* App_SummarizePerformerPool (pEntityTab* perfList);

pIntTab* App_SummarizeToolSet (pEntityTab* rscList);

int App_WeatherFileDateToClock (char* dateArg, char* hourArg);

Date* App_WeatherFileDateToDate (char* dateArg, char* hourArg);

BasicEntity* Body_BestActivitySetSelector_FirstOnOperationPriority (EntityMethod* pM);

BasicEntity* Body_BestActivitySetSelector_OnlyOnOperationPriority (EntityMethod* pM);

BasicEntity* Body_BestActivitySetSelector_Standard (EntityMethod* pM);

bool Body_CP_AntiMildewTreatments (EntityMethod* pM);

bool Body_CP_AutumnTillages (EntityMethod* pM);

bool Body_CP_ChemicalWeedings (EntityMethod* pM);

bool Body_CP_Clippings (EntityMethod* pM);

bool Body_CP_Debranchings (EntityMethod* pM);

bool Body_CP_ExtraPhytoTreatments (EntityMethod* pM);

bool Body_CP_Fertilizations_Phase3 (EntityMethod* pM);

bool Body_CP_InitSpringTillages_Phase3 (EntityMethod* pM);

bool Body_CP_Phase1 (EntityMethod* pM);

bool Body_CP_Phase3 (EntityMethod* pM);

bool Body_CP_Plantations (EntityMethod* pM);

bool Body_CP_Prunings_Phase2 (EntityMethod* pM);

bool Body_CP_Prunings_Phase3 (EntityMethod* pM);

bool Body_CP_RegularPhytoTreatments (EntityMethod* pM);

bool Body_CP_ShootThinnings_Phase2 (EntityMethod* pM);

bool Body_CP_ShootThinnings_Phase3 (EntityMethod* pM);

bool Body_CP_SpringChemicalWeedings (EntityMethod* pM);

bool Body_CP_SpringTillages (EntityMethod* pM);

bool Body_CP_Trellisings (EntityMethod* pM);

bool Body_CP_WinterTillages_OnDate (EntityMethod* pM);

bool Body_CP_alwaysTrue (EntityMethod* pM);

bool Body_MBS_Fertilizations_Phase1 (EntityMethod* pM);

bool Body_MBS_Fertilizations_Phase3 (EntityMethod* pM);

bool Body_MBS_OptionalPhase2 (EntityMethod* pM) ;

bool Body_MBS_Plantations (EntityMethod* pM);

bool Body_MBS_WinterTillages (EntityMethod* pM);

bool Body_MIOS_AutumnTillages (EntityMethod* pM);

bool Body_MIOS_ChemicalWeedings (EntityMethod* pM);

bool Body_MIOS_Clippings (EntityMethod* pM);

bool Body_MIOS_ConcurrentAntiMildewTreatments (EntityMethod* pM);

bool Body_MIOS_ConcurrentExtraPhytoTreatments (EntityMethod* pM);

bool Body_MIOS_ConcurrentRegularPhytoTreatments (EntityMethod* pM);

bool Body_MIOS_Debranchings (EntityMethod* pM);

bool Body_MIOS_Fertilizations (EntityMethod* pM);

bool Body_MIOS_InitSpringTillages (EntityMethod* pM);

bool Body_MIOS_Plantations (EntityMethod* pM);

bool Body_MIOS_Prunings (EntityMethod* pM);

bool Body_MIOS_SerialAntiMildewTreatments (EntityMethod* pM);

bool Body_MIOS_SerialExtraPhytoTreatments (EntityMethod* pM);

bool Body_MIOS_SerialManualRegularPhytoTreatments (EntityMethod* pM);

bool Body_MIOS_SerialMotorizedRegularPhytoTreatments (EntityMethod* pM);

bool Body_MIOS_ShootThinnings (EntityMethod* pM);

bool Body_MIOS_SpringChemicalWeedings (EntityMethod* pM);

bool Body_MIOS_SpringTillages (EntityMethod* pM);

bool Body_MIOS_Trellisings (EntityMethod* pM);

bool Body_MIOS_WinterTillages (EntityMethod* pM);

bool Body_OP_AutumnTillages (EntityMethod* pM);

bool Body_OP_ChemicalWeedings (EntityMethod* pM);

bool Body_OP_Clippings (EntityMethod* pM);

bool Body_OP_Debranchings (EntityMethod* pM);

bool Body_OP_Fertilizations_OnChain (EntityMethod* pM);

bool Body_OP_Fertilizations_OnDate (EntityMethod* pM);

bool Body_OP_InitSpringTillages (EntityMethod* pM);

bool Body_OP_OptionalPhase2 (EntityMethod* pM);

bool Body_OP_Phase3 (EntityMethod* pM);

bool Body_OP_PhytoTreatments (EntityMethod* pM);

bool Body_OP_Plantations_OnDate (EntityMethod* pM);

bool Body_OP_Prunings_OnDate (EntityMethod* pM);

bool Body_OP_ShootThinnings_OnSurface (EntityMethod* pM);

bool Body_OP_SpringChemicalWeedings (EntityMethod* pM);

bool Body_OP_SpringTillages (EntityMethod* pM);

bool Body_OP_Trellisings (EntityMethod* pM);

bool Body_OP_WinterTillages_OnDate (EntityMethod* pM);

bool Common_PhytoTreatment_OnDate_OpeningPredicate (Entity* pChantier);

bool Common_PhytoTreatment_Primary_OpeningPredicate (Entity* pChantier);

bool Common_PhytoTreatment_WeatherOriented_OpeningPredicate (Entity* pChantier);

void FinalizeOpenSimulation (char* dirFile) ;

void InitOpenSimulation(char* paramFile, char* simFile, char* osFile, char* structFile) ;

bool OpeningCondition_AutumnTillages (Entity* pChantier);

bool OpeningCondition_ChemicalWeedings (Entity* pChantier);

bool OpeningCondition_Clippings (Entity* pChantier);

bool OpeningCondition_Debranchings (Entity* pChantier);

bool OpeningCondition_Fertilizations_OnChain (Entity* pChantier);

bool OpeningCondition_Fertilizations_OnDate (Entity* pChantier);

bool OpeningCondition_InitSpringTillages (Entity* pChantier);

bool OpeningCondition_Plantations_OnDate (Entity* pChantier);

bool OpeningCondition_Prunings_OnDate (Entity* pObj);

bool OpeningCondition_ShootThinnings_OnSurface (Entity* pChantier);

bool OpeningCondition_SpringChemicalWeedings (Entity* pChantier);

bool OpeningCondition_SpringTillages (Entity* pChantier, int replicationNumber, int prevTillageClock);

bool OpeningCondition_SpringTillages_OnWeed (Entity* pChantier);

bool OpeningCondition_Trellisings (Entity* pChantier);

bool OpeningCondition_WinterTillages_OnDate (Entity* pChantier);

int ReturnManagerWakeUpHour ();

int main_Auto (int argc, char* argv[]);

int main_Mhydas (int argc, char* argv[]);

int main_core(int argc, char* argv[], int numSim) ;

void InitSimulation();
 
int App_EnumToInt(char*);
 
void App_InstallMetaClasses();
void App_AssignInstantiators();
void App_DefineMonitors();
 
void App_MakeClassIdToCharTab();
void App_MakeDescIdToCharTab();
 
Entity* App_NewEntityFromString(char*);
Entity* App_NewEntityFromId(UserClassId);
Process* App_NewProcessFromString(char*);
Event* App_NewEventFromString(char*);
EntitySpec* App_NewEntitySpecFromString(char*);
DescValueSpec* App_NewDescValueSpecFromString(char*);
SerialDataFile* App_NewSerialDataFileFromString(char*);
SerialDataFile* App_NewSerialDataFileFromId(UserFileId);
UserFileId App_SerialDataFileIdFromString(char*);
 
// pour compatibilite 5.0
SerialDataFile* App_NewSequentialDataFileFromString(char*);
SerialDataFile* App_NewSequentialDataFileFromId(UserFileId);
UserFileId App_SequentialDataFileIdFromString(char*);
 
 
#endif  // _User_FUNCTION_HH

