// ==============================================
// Fichier : UserOperation.h
// Type    : source C++
// 
// Description : déclaration des classes des 'Operation'.
// ==============================================
  
#ifndef _User_OPERATION_HH
#define _User_OPERATION_HH
  
#include "UserTypes.h"
  
// ==============================================

class MyFloatAreaOperation : public FloatQuantityGranulatedOperation
{
  public :
    MyFloatAreaOperation();
};

// ==============================================

class ManualOperation : public MyFloatAreaOperation
{
  public :
    ManualOperation();
};

// ==============================================

class MotorizedOperation : public MyFloatAreaOperation
{
  public :
    MotorizedOperation();
};

// ==============================================

class MotorizedSprayingOperation : public MotorizedOperation
{
  public :
    MotorizedSprayingOperation();
};

// ==============================================

class PlantationOperation : public ManualOperation
{
  public :
    PlantationOperation();
};

// ==============================================

class PruningOperation : public ManualOperation
{
  public :
    PruningOperation();
};

// ==============================================

class ShootThinningOperation : public MotorizedOperation
{
  public :
    ShootThinningOperation();
};

// ==============================================

class TillageOperation : public MotorizedOperation
{
  public :
    TillageOperation();
};

// ==============================================

class TrellisingOperation : public ManualOperation
{
  public :
    TrellisingOperation();
};

// ==============================================

class VerticalRailOperatedSpraying : public MotorizedSprayingOperation
{
  public :
    VerticalRailOperatedSpraying();
};

// ==============================================

class AirAssistedSpraying : public MotorizedSprayingOperation
{
  public :
    AirAssistedSpraying();
};

// ==============================================

class BackSprayingOperation : public ManualOperation
{
  public :
    BackSprayingOperation();
};

// ==============================================

class ChemicalDebrancherOperatedSpraying : public MotorizedSprayingOperation
{
  public :
    ChemicalDebrancherOperatedSpraying();
};

// ==============================================

class ClippingOperation : public MotorizedOperation
{
  public :
    ClippingOperation();
};

// ==============================================

class FertilizationOperation : public MotorizedOperation
{
  public :
    FertilizationOperation();
};

// ==============================================

class GrinderOperatedShootThinning : public ShootThinningOperation
{
  public :
    GrinderOperatedShootThinning();
};

// ==============================================

class HandHeldGunOperatedSpraying : public MotorizedSprayingOperation
{
  public :
    HandHeldGunOperatedSpraying();
};

// ==============================================

class HorizontalRailOperatedSpraying : public MotorizedSprayingOperation
{
  public :
    HorizontalRailOperatedSpraying();
};

// ==============================================

class ManualDebranchingOperation : public ManualOperation
{
  public :
    ManualDebranchingOperation();
};

// ==============================================

class RotaryOperatedShootThinning : public ShootThinningOperation
{
  public :
    RotaryOperatedShootThinning();
};

// ==============================================

class RotaryOperatedTillage : public TillageOperation
{
  public :
    RotaryOperatedTillage();
};

// ==============================================

class SpringTineOperatedTillage : public TillageOperation
{
  public :
    SpringTineOperatedTillage();
};

#endif  // _User_OPERATION_HH
