// ==============================================
// Fichier : UserResource.h
// Type    : source C++
// 
// Description : déclaration des classes des 'Resource'.
// ==============================================
  
#ifndef _User_RESOURCE_HH
#define _User_RESOURCE_HH
  
#include "UserTypes.h"
  
// ==============================================

class AirAssistedSprayingResourceSet : public HomogeneousAggregatedDiscreteStateReusableResource
{
  public :
    AirAssistedSprayingResourceSet();
};

// ==============================================

class ChemicalDebrancherSprayingResourceSet : public HomogeneousAggregatedDiscreteStateReusableResource
{
  public :
    ChemicalDebrancherSprayingResourceSet();
};

// ==============================================

class ClippingResourceSet : public HomogeneousAggregatedDiscreteStateReusableResource
{
  public :
    ClippingResourceSet();
};

// ==============================================

class FarmEquipment : public SingleTool
{
  public :
    FarmEquipment();
};

// ==============================================

class FarmWorker : public SingleWorker
{
  public :
    FarmWorker();
};

// ==============================================

class FarmWorkerAvailabilityTimetable : public RecurrentAvailabilityTimetable
{
  public :
    FarmWorkerAvailabilityTimetable();
};

// ==============================================

class FertilizationResourceSet : public HomogeneousAggregatedDiscreteStateReusableResource
{
  public :
    FertilizationResourceSet();
};

// ==============================================

class Grinder : public FarmEquipment
{
  public :
    Grinder();
};

// ==============================================

class GrinderShootThinningResourceSet : public HomogeneousAggregatedDiscreteStateReusableResource
{
  public :
    GrinderShootThinningResourceSet();
};

// ==============================================

class HandHeldGunSprayingResourceSet : public HomogeneousAggregatedDiscreteStateReusableResource
{
  public :
    HandHeldGunSprayingResourceSet();
};

// ==============================================

class HorizontalRailSprayingResourceSet : public HomogeneousAggregatedDiscreteStateReusableResource
{
  public :
    HorizontalRailSprayingResourceSet();
};

// ==============================================

class LowCumulativeRainSuffered : public StateAvailabilityConstraint
{
  public :
    LowCumulativeRainSuffered();
};

// ==============================================

class NonPermanentFarmWorker : public FarmWorker
{
  public :
    NonPermanentFarmWorker();
};

// ==============================================

class NonPermanentManualFarmWorker : public NonPermanentFarmWorker
{
  public :
    NonPermanentManualFarmWorker();
};

// ==============================================

class NonPermanentTractorDriver : public NonPermanentFarmWorker
{
  public :
    NonPermanentTractorDriver();
};

// ==============================================

class PermanentFarmWorker : public FarmWorker
{
  public :
    PermanentFarmWorker();
};

// ==============================================

class PermanentFarmWorkerFiveDayTimetable : public FarmWorkerAvailabilityTimetable
{
  public :
    PermanentFarmWorkerFiveDayTimetable();
};

// ==============================================

class PermanentFarmWorkerSevenDayTimetable : public FarmWorkerAvailabilityTimetable
{
  public :
    PermanentFarmWorkerSevenDayTimetable();
};

// ==============================================

class PermanentFarmWorkerSixDayTimetable : public FarmWorkerAvailabilityTimetable
{
  public :
    PermanentFarmWorkerSixDayTimetable();
};

// ==============================================

class PermanentManualFarmWorker : public PermanentFarmWorker
{
  public :
    PermanentManualFarmWorker();
};

// ==============================================

class PermanentMultiTaskManualWorker : public PermanentManualFarmWorker
{
  public :
    PermanentMultiTaskManualWorker();
};

// ==============================================

class PermanentMultiTaskWorker : public PermanentFarmWorker
{
  public :
    PermanentMultiTaskWorker();
};

// ==============================================

class PermanentPreferentialTractorDriver : public PermanentMultiTaskWorker
{
  public :
    PermanentPreferentialTractorDriver();
};

// ==============================================

class PermanentPruner : public PermanentManualFarmWorker
{
  public :
    PermanentPruner();
};

// ==============================================

class PermanentTillageOrientedTractorDriver : public PermanentMultiTaskWorker
{
  public :
    PermanentTillageOrientedTractorDriver();
};

// ==============================================

class PermanentTractorDriver : public PermanentFarmWorker
{
  public :
    PermanentTractorDriver();
};

// ==============================================

class PermanentVegetationGrower : public PermanentManualFarmWorker
{
  public :
    PermanentVegetationGrower();
};

// ==============================================

class PruningMachine : public FarmEquipment
{
  public :
    PruningMachine();
};

// ==============================================

class Sprayer : public FarmEquipment
{
  public :
    Sprayer();
};

// ==============================================

class Spreader : public FarmEquipment
{
  public :
    Spreader();
};

// ==============================================

class Tank : public FarmEquipment
{
  public :
    Tank();
};

// ==============================================

class TillageResourceSet : public HomogeneousAggregatedDiscreteStateReusableResource
{
  public :
    TillageResourceSet();
};

// ==============================================

class TillageTool : public FarmEquipment
{
  public :
    TillageTool();
};

// ==============================================

class Tractor : public FarmEquipment
{
  public :
    Tractor();
};

// ==============================================

class TrellisingMachine : public FarmEquipment
{
  public :
    TrellisingMachine();
};

// ==============================================

class VerticalRailSprayer : public Sprayer
{
  public :
    VerticalRailSprayer();
};

// ==============================================

class VerticalRailSprayingResourceSet : public HomogeneousAggregatedDiscreteStateReusableResource
{
  public :
    VerticalRailSprayingResourceSet();
};

// ==============================================

class WeekDayPart : public AvailabilityTimeSlot
{
  public :
    WeekDayPart();
};

// ==============================================

class AirAssistedSprayer : public Sprayer
{
  public :
    AirAssistedSprayer();
};

// ==============================================

class BackSprayer : public Sprayer
{
  public :
    BackSprayer();
};

// ==============================================

class Clipper : public FarmEquipment
{
  public :
    Clipper();
};

// ==============================================

class CollectorPane : public FarmEquipment
{
  public :
    CollectorPane();
};

// ==============================================

class DebranchingSprayer : public Sprayer
{
  public :
    DebranchingSprayer();
};

// ==============================================

class HandHeldSprayGun : public Sprayer
{
  public :
    HandHeldSprayGun();
};

// ==============================================

class HorizontalRailSprayer : public Sprayer
{
  public :
    HorizontalRailSprayer();
};

// ==============================================

class PermanentAllTaskTractorDriver : public PermanentMultiTaskWorker
{
  public :
    PermanentAllTaskTractorDriver();
};

// ==============================================

class PermanentTillageTractorDriver : public PermanentTractorDriver
{
  public :
    PermanentTillageTractorDriver();
};

// ==============================================

class RotaryCultivator : public TillageTool
{
  public :
    RotaryCultivator();
};

// ==============================================

class RotaryTillageResourceSet : public TillageResourceSet
{
  public :
    RotaryTillageResourceSet();
};

// ==============================================

class SpringTineCultivator : public TillageTool
{
  public :
    SpringTineCultivator();
};

// ==============================================

class SpringTineTillageResourceSet : public TillageResourceSet
{
  public :
    SpringTineTillageResourceSet();
};

// ==============================================

class WeekDayAfternoon : public WeekDayPart
{
  public :
    WeekDayAfternoon();
};

// ==============================================

class WeekDayMorning : public WeekDayPart
{
  public :
    WeekDayMorning();
};

#endif  // _User_RESOURCE_HH
