// ==============================================
// Fichier : UserCondition.cc
// Type    : source C++
// 
// Description : constructeurs des classes des 'Condition'.
// ==============================================
  
#include "UserCondition.h"
  
AtLeastOnePlot::AtLeastOnePlot() {
// =========================================================
// Une classe de Entity : 'AtLeastOnePlot'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(AT_LEAST_ONE_PLOT);
  //SetParentClassId(OCCURRENCE_DOMAIN); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(ENTITY_ID_ATTRIBUTE, PLOT);
  SetIntConstValue(ACCEPTABILITY_THRESHOLD, 0);
  SetIntConstValue(BINARY_OPERATOR_ID, C_GT);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

EquipmentMultiLocalization::EquipmentMultiLocalization() {
// =========================================================
// Une classe de Entity : 'EquipmentMultiLocalization'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(EQUIPMENT_MULTI_LOCALIZATION);
  //SetParentClassId(RESOURCE_SHARING_VIOLATION_CONDITION); // pour memoire (*)
  AddInstanceToClass();
  BasicEntity* pBE;
  pBE = new EquipmentUbiquityCondition();
  SetEntityConstValue(OCCURRENCE_CROSS_DOMAIN_ATTRIBUTE, pBE);
  SetIntVarValue(CONSTRAINED_ENTITY_CLASS_ID, FARM_EQUIPMENT);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

EquipmentUbiquityCondition::EquipmentUbiquityCondition() {
// =========================================================
// Une classe de Entity : 'EquipmentUbiquityCondition'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(EQUIPMENT_UBIQUITY_CONDITION);
  //SetParentClassId(OCCURRENCE_CROSS_DOMAIN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  Entity* pOD = new MoreThanOnePlot();
  AddElement(pOD);
};

FarmWorkerMultiLocalization::FarmWorkerMultiLocalization() {
// =========================================================
// Une classe de Entity : 'FarmWorkerMultiLocalization'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FARM_WORKER_MULTI_LOCALIZATION);
  //SetParentClassId(RESOURCE_SHARING_VIOLATION_CONDITION); // pour memoire (*)
  AddInstanceToClass();
  BasicEntity* pBE;
  pBE = new FarmWorkerUbiquityCondition();
  SetEntityConstValue(OCCURRENCE_CROSS_DOMAIN_ATTRIBUTE, pBE);
  SetIntVarValue(CONSTRAINED_ENTITY_CLASS_ID, FARM_WORKER);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

FarmWorkerMultiOccupation::FarmWorkerMultiOccupation() {
// =========================================================
// Une classe de Entity : 'FarmWorkerMultiOccupation'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FARM_WORKER_MULTI_OCCUPATION);
  //SetParentClassId(RESOURCE_SHARING_VIOLATION_CONDITION); // pour memoire (*)
  AddInstanceToClass();
  BasicEntity* pBE;
  pBE = new FarmWorkerMultiOccupied();
  SetEntityConstValue(OCCURRENCE_CROSS_DOMAIN_ATTRIBUTE, pBE);
  SetIntVarValue(CONSTRAINED_ENTITY_CLASS_ID, FARM_WORKER);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

FarmWorkerMultiOccupied::FarmWorkerMultiOccupied() {
// =========================================================
// Une classe de Entity : 'FarmWorkerMultiOccupied'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FARM_WORKER_MULTI_OCCUPIED);
  //SetParentClassId(OCCURRENCE_CROSS_DOMAIN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  Entity* pOD = new MoreThanOneTask();
  AddElement(pOD);
};

FarmWorkerUbiquityCondition::FarmWorkerUbiquityCondition() {
// =========================================================
// Une classe de Entity : 'FarmWorkerUbiquityCondition'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FARM_WORKER_UBIQUITY_CONDITION);
  //SetParentClassId(OCCURRENCE_CROSS_DOMAIN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  Entity* pOD = new MoreThanOnePlot();
  AddElement(pOD);
};

MoreThanOnePlot::MoreThanOnePlot() {
// =========================================================
// Une classe de Entity : 'MoreThanOnePlot'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MORE_THAN_ONE_PLOT);
  //SetParentClassId(OCCURRENCE_DOMAIN); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(ENTITY_ID_ATTRIBUTE, PLOT);
  SetIntConstValue(ACCEPTABILITY_THRESHOLD, 1);
  SetIntConstValue(BINARY_OPERATOR_ID, C_GT);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

MoreThanOneTask::MoreThanOneTask() {
// =========================================================
// Une classe de Entity : 'MoreThanOneTask'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MORE_THAN_ONE_TASK);
  //SetParentClassId(OCCURRENCE_DOMAIN); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(ENTITY_ID_ATTRIBUTE, OPERATION);
  SetIntConstValue(ACCEPTABILITY_THRESHOLD, 1);
  SetIntConstValue(BINARY_OPERATOR_ID, C_GT);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

NeutralInconsistencyCondition::NeutralInconsistencyCondition() {
// =========================================================
// Une classe de Entity : 'NeutralInconsistencyCondition'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(NEUTRAL_INCONSISTENCY_CONDITION);
  //SetParentClassId(OCCURRENCE_CROSS_DOMAIN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
// 
// OccurrenceCrossDomain utilise par l'AIC '...'
// Cette condition est toujours vraie. Ainsi c'est la HoldingCondition qui 
// decidera de la satisfaction de l'AIC
//
  Entity* pOD = new AtLeastOnePlot();
  AddElement(pOD);
};

bool onlyPhytoTreatmentsAtEarlyMorning_holdingCondition_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// M�thode d'une InconstencyCondition : OnlyPhytoTreatmentsAtEarlyMorning
// Le corps examine l'�tat du syst�me et doit renvoyer vrai si et seulement si
// l'�tat justifie que la contrainte soit appliqu�e � l'activit� ou �
// la ressource qui est la valeur de l'argument REFERENCEENTITY_ARGUMENT.
// L'argument CANDIDATEENTITYTABVALUE_ARGUMENT est un ensemble de ressources
// candidates � l'allocation.
// L'argument CANDIDATEENTITYVALUE_ARGUMENT est l'allocation de ressources
// candidates (structure de type V).
//---------------------------------------------------------------------------
// renvoie VRAI (inconsistance) si :
// - l'activite n'est pas un traitement phyto  (cond 1)
// ET
// - un ouvrier est un ATTDriver ou un PPTDriver  (cond 2)
// ET
// - on est avant l'heure standard d'embauche matinale  (cond 3)
//---------------------------------------------------------------------------
  Entity* pAIC = pM->DescribedEntity();
  bool result = FALSE;
  
  Entity* pAct = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
//printf("\n'%s'::onlyPhytoTreatmentsAtEarlyMorning_HC", pAct->InstanceName(), result);
  Entity* pV_alloc = pM->GetEntityArgValue(CANDIDATEENTITYVALUE_ARGUMENT);
  //
  // cond 1 : operation non phyto
  //
  bool cond_typeAct = ! pAct->IsInstanceOf(PHYTO_TREATMENT_ACTIVITY);
  if(cond_typeAct) {
	//
	// cond 2 : un ouvrier est un ATTDriver ou un PPTDriver
	//
	bool cond_perf = FALSE;
	Entity* allocPerfSet = pV_alloc->GetComponent(ALLOCATED_PERFORMER_SET);
	pEntityTab perfList = allocPerfSet->GetElementTab();
//perfList.display_names();
	int nbPerf = perfList.size();
	for(int i=0;i<nbPerf-1;i++) {
	  Entity* pPerf = (Entity*)perfList[i];
	  if(pPerf->IsInstanceOf(PERMANENT_ALL_TASK_TRACTOR_DRIVER)
		 ||
		 pPerf->IsInstanceOf(PERMANENT_PREFERENTIAL_TRACTOR_DRIVER)) {
		cond_perf = TRUE;
		break;
	  }
	}
	if(cond_typeAct) {
	  //
	  // cond 3 : n est avant l'heure standard d'embauche matinale
	  //
	  float standardBegHour = gRealParam_normalPlan_mayAugustMorningBegHour_;
	  int now = pCurrentSim->Clock();
	  tm* pTm = ClockValueToTm(now);
	  int hour = pTm->tm_hour;
	  delete pTm;
	  if((float)hour < standardBegHour)
		result = TRUE;
	}
  }
  
//printf("\n'%s'::onlyPhytoTreatmentsAtEarlyMorning_HC returns %d", pAct->InstanceName(), result);
  return result;
};

OnlyPhytoTreatmentsAtEarlyMorning::OnlyPhytoTreatmentsAtEarlyMorning() {
// =========================================================
// Une classe de Entity : 'OnlyPhytoTreatmentsAtEarlyMorning'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ONLY_PHYTO_TREATMENTS_AT_EARLY_MORNING);
  //SetParentClassId(ACTIVITY_INCONSISTENCY_CONDITION); // pour memoire (*)
  AddInstanceToClass();
  BasicEntity* pBE;
  pBE = new NeutralInconsistencyCondition();
  SetEntityConstValue(OCCURRENCE_CROSS_DOMAIN_ATTRIBUTE, pBE);
  SetIntVarValue(CONSTRAINED_ENTITY_CLASS_ID, VINEYARD_ACTIVITY);
  AssignBody(HOLDING_CONDITION, onlyPhytoTreatmentsAtEarlyMorning_holdingCondition_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

bool plotWithSeveralOperations_holdingCondition_Body(EntityMethod* pM) {
//----------------------------------------------------------------------
// Methode d'une InconstencyCondition ou ActivitiesResourcesInconsistentCommitment.
// Le corps examine l'etat du systeme et doit renvoyer vrai si et seulement si
// l'etat justifie que la contrainte soit appliquee a l'activite ou a
// la ressource qui est la valeur de l'argument REFERENCEENTITY_ARGUMENT.
// L'argument CANDIDATEENTITYTABVALUE_ARGUMENT est un ensemble de ressources
// candidates a l'allocation.
// L'argument CANDIDATEENTITYVALUE_ARGUMENT est l'alloc. de ress. candidates.
//----------------------------------------------------------------------
  Entity* pE = pM->DescribedEntity();
  bool result = FALSE;
//printf("\nplotWithSeveralOperations_HC pE : '%s'", pE->InstanceName());
  Entity* pISA = (Entity*)pM->GetEntityArgValue(CANDIDATEENTITYVALUE_ARGUMENT);
  // jeu (A B)
  //      A : <(p1),    ot1, w1> 
  //      B : <(p2 p1), ot2, w2> 
  //  - structure U : ((ot1                    (PLOT p1)    (PERF w1)   )
  //                   (ot2                    (PLOT p1 p2) (PERF w2)   )
  //                   (p1 (PRUN ot1) (CHW ot2)(PLOT p2)    (PERF w1 w2))
  //                   (p2            (CHW ot2)(PLOT p1)    (PERF w2)   )
  //                   (w1 (PRUN ot1)          (PLOT p1)                )
  //                   (w2 (CHW ot2)           (PLOT p1 p2)             )
  //                  )
//((InstructionSetAllocation*)pISA)->SpecialDisplay();
  //
  // parcours des lignes de la struture U (pISA)
  //
  int nbUsageItems = pISA->GetNumberOfElements();
  for(int i=0;i<nbUsageItems;i++) {
	Entity* pUsageItem = pISA->GetElement(i);
	//
	// on ne regarde que les lignes ne portant pas sur une operation
	// donc : (p1 ...)(p2 ...)(w1 ...) et (w2 ...)
	//
	if(pUsageItem->IsDirectInstanceOf(RESOURCE_USAGE_ITEM)) {
	  Entity* pRscUsed = pUsageItem->GetEntityConstValue(RESOURCE_USED);
	  //
	  // on ne regarde que les lignes portant sur un 'operatedObject'
	  // donc : (p1 ...) puis (p2 ...)
	  //
      if(pRscUsed->IsInstanceOf(OPERATED_OBJECT)) {
		Entity* pObj = pRscUsed->GetEntityConstValue(RESOURCE_ENTITY);
		//
		// on ne regarde que les lignes dont 'operatedObject' est une PLOT
		// peut-etre (p1 ...) et (p2 ...)
		//
		if(pObj->IsInstanceOf(PLOT)) {
		  // (p1 ...)
		  // puis
		  // (p2 ...)
		  pEntityTab* pCoengOtTab = new pEntityTab();
		  // pCoengOtTab --> ()
		  // ((PRUN ot1) (CHW ot2) (PERF w1))
		  int nbCoengItems = pUsageItem->GetNumberOfElements();  // = 3
		  for(int j=0;j<nbCoengItems;j++) {
			Entity* pCoengItem = pUsageItem->GetElement(j);
			// e.g. (PRUN ot1)         puis CHW ot2)
			UserClassId pCoengObjId = pCoengItem->GetIntVarValue(RESOURCE_ID);
			// PRUN                    puis CHW
			if(IsDescendantOf(pCoengObjId, OPERATION)) {
			  pEntityTab* pRscTab 
				= pCoengItem->GetEntityTabConstValue(RESOURCE_LIST);
			  pCoengOtTab->push_back_ifnew(* pRscTab);
			  // pCoengOtTab --> (ot1) puis --> (ot1 ot2)
			}
		  }
		  int nbCoengOt = pCoengOtTab->size();   // = 2
		  delete  pCoengOtTab;
		  if(nbCoengOt > 1) {
			result = TRUE;
			break;
		  }
		}
	  }
	}
	if(result == TRUE)
	  break;
  }
//printf("\nplotWithSeveralOperations_HC returns %d", result);
  return result;
};

PlotWithSeveralOperations::PlotWithSeveralOperations() {
// =========================================================
// Une classe de Entity : 'PlotWithSeveralOperations'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PLOT_WITH_SEVERAL_OPERATIONS);
  //SetParentClassId(ACTIVITIES_RESOURCES_INCONSISTENT_COMMITMENT); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(HOLDING_CONDITION, plotWithSeveralOperations_holdingCondition_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

bool tooLateInWorkDayForActivityBeginning_holdingCondition_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// M�thode d'une InconstencyCondition : TooLateInWorkDayForActivityBeginning
// Le corps examine l'�tat du syst�me et doit renvoyer vrai si et seulement si
// l'�tat justifie que la contrainte soit appliqu�e � l'activit�
// qui est la valeur de l'argument REFERENCEENTITY_ARGUMENT.le de ressources
// candidates � l'allocation.
// L'argument CANDIDATEENTITYVALUE_ARGUMENT est l'allocation de ressources 
// candidates (structure de type V).
//---------------------------------------------------------------------------
// L'AIC TooLateInWorkDayForActivityBeginning contraint toutes les activites
// primitives. Elle specifie qu'une activite est inconsistante si :
// - son predicat HoldingCondition (celui-ci) renvoie vrai
// - ET elle porte sur au moins une parcelle (toujours vrai)
//
// Ce pr�dicat porte donc toute la specification. Il renvoie vrai ssi :
// - la proc�dure d'allocation est compl�te, cad jusqu'aux objets operes, pour
//   permettre le calcul de la duree prevue de l'activite (il suffit de tester
//   si le nombre d'objets dans le composant AllocatedOperatedObjectSet est 
//   positif, puisqu'il y a toujours une parcelle specifiee, par construction)
// - l'operation n'est pas encore commencee
// - la duree de l'activite permet d'en realiser une proportion suffisante
//   avant la fin de la demi-journee de travail
//---------------------------------------------------------------------------
  Entity* pAIC = pM->DescribedEntity();
  bool result = FALSE;
  
  Entity* pAct = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pV_alloc = pM->GetEntityArgValue(CANDIDATEENTITYVALUE_ARGUMENT);

  Entity* allocOOSet = pV_alloc->GetComponent(ALLOCATED_OPERATED_OBJECT_SET);
  int nbOO = allocOOSet->GetNumberOfElements();

  if(nbOO > 0) {
	Entity* allocOtSet = pV_alloc->GetComponent(ALLOCATED_OPERATION_SET);
	Entity* allocOt = allocOtSet->GetElement(0); // par construction
	float achDegree = allocOt->GetFloatVarValue(ACHIEVEMENT_DEGREE);
	if(achDegree > gFloatingPointEqualityTolerance) {
	  // sortie du for, result reste FALSE
	}
	else {
	  Entity* allocPerfSet = pV_alloc->GetComponent(ALLOCATED_PERFORMER_SET);
	  pEntityTab perfList = allocPerfSet->GetElementTab();
	  int nbPerf = perfList.size();

//printf("\ntooLateInWorkDayForActivityBeginning_HC nbOO = %d nbPerf = %d OT en %x", nbOO, nbPerf, allocOt);

	  pAct->SetEntityArgValue(OPERATION_NOMINAL_DURATION,
							  CANDIDATEENTITYVALUE_ARGUMENT, pV_alloc);
	  float duration = pAct->ExecFloatMethod(OPERATION_NOMINAL_DURATION); 
//printf("\n\tduration = %f UTS", duration);
	  
	  int now = pCurrentSim->Clock();
	  tm* pTm_now = ClockValueToTm(now);
	  
	  //
	  // temps restant pour le performer a qui il en reste le moins
	  //
	  float now_hour = (float)pTm_now->tm_hour;
	  delete pTm_now;
//printf("\n\tnow_hour = %f", now_hour);
	  float infTimeLeft = D_FLOATMAX;
	  for(int j=0;j<nbPerf;j++) {
		Entity* pPerf_k = (Entity*)perfList.get_element(j);
		Entity* pEmploymentPlan = 
		  pPerf_k->GetEntityConstValue(ANNUAL_EMPLOYMENT_PLAN_ATTRIBUTE);
		int seasonIndex = 
		  pEmploymentPlan->ExecIntMethod(UPDATE_SEASON_CURRENT_INDEX);
		Entity* pSeasonalPlan = pEmploymentPlan->GetElement(seasonIndex);
		float normalMorningEnd = 
		  pSeasonalPlan->GetFloatConstValue(WORK_DAY_MORNING_END_HOUR);
		float normalAfternoonBeg = 
		  pSeasonalPlan->GetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR);
		float normalAfternoonEnd = 
		  pSeasonalPlan->GetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR);
		float timeLeftForPerf_k;
		if(now_hour >= normalAfternoonBeg) {
		  timeLeftForPerf_k = normalAfternoonEnd - now_hour;
		}
		else {
		  timeLeftForPerf_k = normalMorningEnd - now_hour
			+ (normalAfternoonEnd - normalAfternoonBeg);
		}
		if(timeLeftForPerf_k < infTimeLeft) {
		  infTimeLeft = timeLeftForPerf_k;
		}
	  }
//printf("\n\tinfTimeLeft = %f", infTimeLeft);
	  //
	  // Test : 'temps restant /duree totale' assez grand
	  // 130519 : si l'opération est tres longue, cette condition peut faire
	  // qu'elle ne soit jamais demaree. Donc on ne l'applique que si on est
	  // deja assez pres de la fin de la journee
	  if(infTimeLeft < 4) {   // + JPR 130519
		float critere = (infTimeLeft*3600)         
		  /
		  ClockIntervalToTimeInterval((int)duration);  
//printf("\n\tcritere = %f", critere);
		
		float seuil = pAct->GetFloatConstValue(MIN_PERCENTAGE_TO_BEGIN_OPERATION);
		if(critere < seuil) {
		  result = TRUE;       // situation d'inconsistance
		}
	  }
	}
  }
//printf("\n'%s'::tooLateInWorkDayForActivityBeginning_HC returns %d", pAct->InstanceName(), result);
  return result;
};

TooLateInWorkDayForActivityBeginning::TooLateInWorkDayForActivityBeginning() {
// =========================================================
// Une classe de Entity : 'TooLateInWorkDayForActivityBeginning'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(TOO_LATE_IN_WORK_DAY_FOR_ACTIVITY_BEGINNING);
  //SetParentClassId(ACTIVITY_INCONSISTENCY_CONDITION); // pour memoire (*)
  AddInstanceToClass();
  BasicEntity* pBE;
  pBE = new NeutralInconsistencyCondition();
  SetEntityConstValue(OCCURRENCE_CROSS_DOMAIN_ATTRIBUTE, pBE);
  SetIntVarValue(CONSTRAINED_ENTITY_CLASS_ID, VINEYARD_ACTIVITY);
  AssignBody(HOLDING_CONDITION, tooLateInWorkDayForActivityBeginning_holdingCondition_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

