// ==============================================
// Fichier : UserEntity.cc
// Type    : source C++
// 
// Description : constructeurs des classes des 'Entity'.
// ==============================================
  
#include "UserEntity.h"
  
AgroClimaticSystem::AgroClimaticSystem() {
// =========================================================
// Une classe de Entity : 'AgroClimaticSystem'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(AGRO_CLIMATIC_SYSTEM);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  AddComponentClassId(WEATHER_STATION_SET);
  AddComponentClassId(VINEYARD_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

AllocationPriorityOptionSet::AllocationPriorityOptionSet() {
// =========================================================
// Une classe de Entity : 'AllocationPriorityOptionSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ALLOCATION_PRIORITY_OPTION_SET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(ALLOCATION_PRIORITY_OPTION_SUBSET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

AllocationPriorityOptionSubset::AllocationPriorityOptionSubset() {
// =========================================================
// Une classe de Entity : 'AllocationPriorityOptionSubset'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ALLOCATION_PRIORITY_OPTION_SUBSET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new StandardValuePriorityTab();    AddConstantDescriptor(pD);
  pD = new IsAllocationExclusive();       AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

AnnualEmploymentPlan::AnnualEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'AnnualEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ANNUAL_EMPLOYMENT_PLAN);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(SEASONAL_EMPLOYMENT_PLAN);
  Descriptor* pD;
  pD = new FarmWorkerAttribute();         AddConstantDescriptor(pD);
  pD = new OffWorkCalendarAttribute();    AddConstantDescriptor(pD);
  Method* pM;
  pM = new UpdateSeasonCurrentIndex();    AddMethod (pM);
  pM = new AttachFarmWorkerToTimetables();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  // Un descripteur par heritage : CurrentElementIndex pointe sur
  // l'element courant (SeasonalEmploymentPlan)
  // Justification -9 dans UpdateSeasonCurrentIndex
  SetIntVarValue(CURRENT_ELEMENT_INDEX, -9);
};

DecisionOptionSet::DecisionOptionSet() {
// =========================================================
// Une classe de Entity : 'DecisionOptionSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(DECISION_OPTION_SET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new OptFertilizationSeason();      AddConstantDescriptor(pD);
  pD = new OptSpringFertMinBegDate();     AddConstantDescriptor(pD);
  pD = new OptSpringFertMaxBegDate();     AddConstantDescriptor(pD);
  pD = new OptPruningMinBegDate();        AddConstantDescriptor(pD);
  pD = new OptSprayerTypeRegular();       AddConstantDescriptor(pD);
  pD = new OptSprayerTypeAtBeginning();   AddConstantDescriptor(pD);
  pD = new OptSprayNumberAtBeginning();   AddConstantDescriptor(pD);
  pD = new OptSprayPathAtBeginning();     AddConstantDescriptor(pD);
  pD = new OptSprayPathRegular();         AddConstantDescriptor(pD);
  pD = new OptSprayPathSinceFlowering();  AddConstantDescriptor(pD);
  pD = new OptFertilizationOP();          AddConstantDescriptor(pD);
  pD = new OptPruningOP();                AddConstantDescriptor(pD);
  pD = new OptRegularPhytoTreatmentsOP(); AddConstantDescriptor(pD);
  pD = new GuidingEarlyVarietyAttribute();AddConstantDescriptor(pD);
  pD = new GuidingLateVarietyAttribute(); AddConstantDescriptor(pD);
  pD = new OptDownyMildewManagement();    AddConstantDescriptor(pD);
  pD = new OptPowderyMildewManagement();  AddConstantDescriptor(pD);
  pD = new OptPhytoTreatmentCadence();    AddConstantDescriptor(pD);
  pD = new OptPhytoTreatmentRainAnticipation();AddConstantDescriptor(pD);
  pD = new OptExtraPhytoTreatmentsOP();   AddConstantDescriptor(pD);
  pD = new OptPowderyMildewClosing();     AddConstantDescriptor(pD);
  pD = new OptPastDownyMildewPressureThreshold();AddConstantDescriptor(pD);
  pD = new OptActualDownyMildewRiskThreshold();AddConstantDescriptor(pD);
  pD = new OptDownyMildewAtLeastClosing();AddConstantDescriptor(pD);
  pD = new OptDownyMildewUnderPressureClosing();AddConstantDescriptor(pD);
  pD = new OptAutumnTillageCP();          AddConstantDescriptor(pD);
  pD = new OptSpringTillagesOP();         AddConstantDescriptor(pD);
  pD = new OptFirstSpringTillageOP();     AddConstantDescriptor(pD);
  pD = new OptSpringTillagesOPScope();    AddConstantDescriptor(pD);
  pD = new OptSpringTillagesIterationCP();AddConstantDescriptor(pD);
  pD = new OptAutumnTillageOP();          AddConstantDescriptor(pD);
  pD = new OptShootThinningsOP();         AddConstantDescriptor(pD);
  pD = new OptInitSpringTillageOP();      AddConstantDescriptor(pD);
  pD = new OptChemicalWeedingOP();        AddConstantDescriptor(pD);
  pD = new OptPlantationOP();             AddConstantDescriptor(pD);
  pD = new OptDebranchingModality();      AddConstantDescriptor(pD);
  pD = new OptPrePruningModality();       AddConstantDescriptor(pD);
  pD = new OptSpringChemicalWeedingOP();  AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

DistributedActivitySetMemoryItem::DistributedActivitySetMemoryItem() {
// =========================================================
// Une classe de Entity : 'DistributedActivitySetMemoryItem'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(DISTRIBUTED_ACTIVITY_SET_MEMORY_ITEM);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new ActivityNameAttribute();       AddConstantDescriptor(pD);
  pD = new ActivityAttribute();           AddConstantDescriptor(pD);
  pD = new BegDate();                     AddVariableDescriptor(pD);
  pD = new EndDate();                     AddVariableDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

GrapeVariety::GrapeVariety() {
// =========================================================
// Une classe de Entity : 'GrapeVariety'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GRAPE_VARIETY);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new IsEarly();                     AddConstantDescriptor(pD);
  pD = new ShootIntensity();              AddConstantDescriptor(pD);
  ((IntConstantDescriptor*)pD)->SetValue(0);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

GrassType::GrassType() {
// =========================================================
// Une classe de Entity : 'GrassType'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GRASS_TYPE);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new LeafAreaIndexRate();           AddConstantDescriptor(pD);
  pD = new LeafLifeSpanMin();             AddConstantDescriptor(pD);
  pD = new LaiForMowing();                AddConstantDescriptor(pD);
  pD = new LeafAreaIndexResidual();       AddVariableDescriptor(pD);
  pD = new LaiForSenescence();            AddVariableDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

IsoAgeingEntity::IsoAgeingEntity() {
// =========================================================
// Une classe de Entity : 'IsoAgeingEntity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ISO_AGEING_ENTITY);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new WeatherStationAttribute();     AddConstantDescriptor(pD);
  pD = new GrapeVarietyAttribute();       AddConstantDescriptor(pD);
  pD = new AgeAttribute();                AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Entity* pAge = new GrapevineAge();
  pAge->SetEntityConstValue(ISO_AGEING_ENTITY_ATTRIBUTE, this);
  pAge->SetIntVarValue(CURRENT_STAGE_INDEX, 0);
  SetEntityConstValue(AGE_ATTRIBUTE, pAge);
};

LastOperationsMemory::LastOperationsMemory() {
// =========================================================
// Une classe de Entity : 'LastOperationsMemory'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(LAST_OPERATIONS_MEMORY);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(LAST_OPERATIONS_MEMORY_ITEM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

LastOperationsMemoryItem::LastOperationsMemoryItem() {
// =========================================================
// Une classe de Entity : 'LastOperationsMemoryItem'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(LAST_OPERATIONS_MEMORY_ITEM);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new ToolClassName();               AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  pD = new DateISOAttribute();            AddConstantDescriptor(pD);
  // ligne ci-dessus scratcher apres valuation de InstantAttribute au lieu
  // de DateISOAttribute dans le moniteur sur AchievementDegree
};

LastPesticideApplicationsMemoryItem::LastPesticideApplicationsMemoryItem() {
// =========================================================
// Une classe de Entity : 'LastPesticideApplicationsMemoryItem'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(LAST_PESTICIDE_APPLICATIONS_MEMORY_ITEM);
  //SetParentClassId(LAST_OPERATIONS_MEMORY_ITEM); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new PesticideType();               AddConstantDescriptor(pD);
  pD = new PesticideSubtype();            AddConstantDescriptor(pD);
  pD = new CommercialFormulation();       AddConstantDescriptor(pD);
  pD = new CommercialFormulationDose();   AddConstantDescriptor(pD);
  pD = new ActuallyOperatedAreaPercentage();AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

LastTillageOperationsMemoryItem::LastTillageOperationsMemoryItem() {
// =========================================================
// Une classe de Entity : 'LastTillageOperationsMemoryItem'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(LAST_TILLAGE_OPERATIONS_MEMORY_ITEM);
  //SetParentClassId(LAST_OPERATIONS_MEMORY_ITEM); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ManagerAnnualEmploymentPlan::ManagerAnnualEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'ManagerAnnualEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MANAGER_ANNUAL_EMPLOYMENT_PLAN);
  //SetParentClassId(ANNUAL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Entity* pPlan;
  Entity* pRATT;
  //--------------------------------------------------
  pPlan = new SeptemberOctoberNormalHoursEmploymentPlan();
  pPlan->SetIntConstValue(WORKING_TIME_WEEKLY_UPPER_BOUND, gIntParam_managerWorkingTime_week_);
  pRATT = new PermanentFarmWorkerSixDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new NovemberJanuaryNormalHoursEmploymentPlan();
  pPlan->SetIntConstValue(WORKING_TIME_WEEKLY_UPPER_BOUND, gIntParam_managerWorkingTime_week_); 
  pRATT = new PermanentFarmWorkerSixDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new FebruaryMarchNormalHoursEmploymentPlan();
  pPlan->SetIntConstValue(WORKING_TIME_WEEKLY_UPPER_BOUND, gIntParam_managerWorkingTime_week_); 
  pRATT = new PermanentFarmWorkerSixDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new AprilNormalHoursEmploymentPlan();
  pPlan->SetIntConstValue(WORKING_TIME_WEEKLY_UPPER_BOUND, gIntParam_managerWorkingTime_week_); 
  pRATT = new PermanentFarmWorkerSixDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  //pPlan = new MayAugustNormalHoursEmploymentPlan();
  pPlan = new MayAugustExtendedHoursEmploymentPlan(); // JPR 121220
  pPlan->SetIntConstValue(WORKING_TIME_WEEKLY_UPPER_BOUND, gIntParam_managerWorkingTime_week_); 
  pRATT = new PermanentFarmWorkerSixDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
};

OffWorkCalendar::OffWorkCalendar() {
// =========================================================
// Une classe de Entity : 'OffWorkCalendar'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(OFF_WORK_CALENDAR);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(OFF_WORK_SINGLE_PERIOD);
  Method* pM;
  pM = new UpdateOffPeriodCurrentIndex(); AddMethod (pM);
  pM = new IsClockValueInCalendar();      AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  // Un descripteur par heritage : CurrentElementIndex pointe sur
  // l'element courant (OffWorkSinglePeriod)
  // Justification -9 dans  updateOffPeriodCurrentIndex_Body
  SetIntVarValue(CURRENT_ELEMENT_INDEX, -9);
};

OffWorkSinglePeriod::OffWorkSinglePeriod() {
// =========================================================
// Une classe de Entity : 'OffWorkSinglePeriod'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(OFF_WORK_SINGLE_PERIOD);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new BeginningCalendarDate();       AddConstantDescriptor(pD);
  pD = new EndCalendarDate();             AddConstantDescriptor(pD);
  Method* pM;
  pM = new IsClockValueInPeriod();        AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

OperationPriorityOptionSet::OperationPriorityOptionSet() {
// =========================================================
// Une classe de Entity : 'OperationPriorityOptionSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(OPERATION_PRIORITY_OPTION_SET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(OPERATION_PRIORITY_OPTION_SUBSET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

OperationPriorityOptionSubset::OperationPriorityOptionSubset() {
// =========================================================
// Une classe de Entity : 'OperationPriorityOptionSubset'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(OPERATION_PRIORITY_OPTION_SUBSET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new StandardValuePriorityTab();    AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

OperationRecordingItem::OperationRecordingItem() {
// =========================================================
// Une classe de Entity : 'OperationRecordingItem'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(OPERATION_RECORDING_ITEM);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new RecordedYear();                AddConstantDescriptor(pD);
  pD = new RecordedMonth();               AddConstantDescriptor(pD);
  pD = new RecordedDay();                 AddConstantDescriptor(pD);
  pD = new RecordedJulianDay();           AddConstantDescriptor(pD);
  pD = new RecordedPlotName();            AddConstantDescriptor(pD);
  pD = new RecordedActivityClassName();   AddConstantDescriptor(pD);
  pD = new RecordedChantierClassName();   AddConstantDescriptor(pD);
  pD = new RecordedOperationClassName();  AddConstantDescriptor(pD);
  pD = new RecordedInDayDuration();       AddConstantDescriptor(pD);
  pD = new RecordedResourceList();        AddConstantDescriptor(pD);
  pD = new RecordedPerformerList();       AddConstantDescriptor(pD);
  pD = new RecordedPhytoProductList();    AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

OperationRecordingStructure::OperationRecordingStructure() {
// =========================================================
// Une classe de Entity : 'OperationRecordingStructure'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(OPERATION_RECORDING_STRUCTURE);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(OPERATION_RECORDING_ITEM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PestInfoMemory::PestInfoMemory() {
// =========================================================
// Une classe de Entity : 'PestInfoMemory'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PEST_INFO_MEMORY);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(PEST_INFO_MEMORY_ITEM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PestInfoMemoryItem::PestInfoMemoryItem() {
// =========================================================
// Une classe de Entity : 'PestInfoMemoryItem'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PEST_INFO_MEMORY_ITEM);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new InstantAttribute();            AddConstantDescriptor(pD);
  pD = new PowderyMildewFlagShoot();      AddConstantDescriptor(pD);
  pD = new PowderyMildewLevel();          AddConstantDescriptor(pD);
  pD = new DownyMildewPrimaryInfection(); AddConstantDescriptor(pD);
  pD = new DownyMildewLevel();            AddConstantDescriptor(pD);
  pD = new DownyMildewRiskLevel();        AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PhenoStage::PhenoStage() {
// =========================================================
// Une classe de Entity : 'PhenoStage'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PHENO_STAGE);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new ThermalTimeToAchieve();        AddConstantDescriptor(pD);
  pD = new StageName();                   AddConstantDescriptor(pD);
  pD = new JulianTimeToAchieve();         AddConstantDescriptor(pD);
  pD = new DayOfAchievement();            AddConstantDescriptor(pD);
  pD = new DayWhenAchieved();             AddVariableDescriptor(pD);
  pD = new ThermalTimeWhenAchieved();     AddVariableDescriptor(pD);
  pD = new YearWhenAchieved();            AddVariableDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PlantAge::PlantAge() {
// =========================================================
// Une classe de Entity : 'PlantAge'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PLANT_AGE);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new StageTab();                    AddConstantDescriptor(pD);
  pD = new IsoAgeingEntityAttribute();    AddConstantDescriptor(pD);
  pD = new DaysNumber();                  AddVariableDescriptor(pD);
  pD = new CurrentStageIndex();           AddVariableDescriptor(pD);
  pD = new ThermalTimeFromSowing();       AddVariableDescriptor(pD);
  Method* pM;
  pM = new SetDayWhenStageAchieved();     AddMethod (pM);
  pM = new GetDayWhenStageAchieved();     AddMethod (pM);
  pM = new GetActualThermalTimeFromEmergence();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Plot::Plot() {
// =========================================================
// Une classe de Entity : 'Plot'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PLOT);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  AddComponentClassId(VEGETAL_COMPARTMENT);
  AddComponentClassId(SOIL_RESERVOIR);
  Descriptor* pD;
  pD = new WeatherStationAttribute();     AddConstantDescriptor(pD);
  pD = new Latitude();                    AddConstantDescriptor(pD);
  pD = new Longitude();                   AddConstantDescriptor(pD);
  pD = new Village();                     AddConstantDescriptor(pD);
  pD = new Area();                        AddConstantDescriptor(pD);
  pD = new AlleyWidth();                  AddConstantDescriptor(pD);
  pD = new PlantSpacing();                AddConstantDescriptor(pD);
  pD = new YearOfPlantation();            AddConstantDescriptor(pD);
  pD = new LandUse();                     AddConstantDescriptor(pD);
  pD = new PlaceName();                   AddConstantDescriptor(pD);
  pD = new SoilType();                    AddConstantDescriptor(pD);
  pD = new SoilManagementGroupName();     AddConstantDescriptor(pD);
  pD = new Stoniness();                   AddConstantDescriptor(pD);
  pD = new PruningMode();                 AddConstantDescriptor(pD);
  pD = new TrellisMode();                 AddConstantDescriptor(pD);
  pD = new GrapeVarietyAttribute();       AddConstantDescriptor(pD);
  pD = new RowManagement();               AddConstantDescriptor(pD);
  pD = new CropRowAlleyWidthRatio();      AddConstantDescriptor(pD);
  pD = new GrassStripAlleyWidthRatio();   AddConstantDescriptor(pD);
  pD = new RidingOrientedInterRowProportion();AddConstantDescriptor(pD);
  pD = new LastTillageOperationClock();   AddConstantDescriptor(pD);
  pD = new CumulativeRainfallFromMhydasInteraction();AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromLastTillage();AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromEarlyWinter();AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromEarlyWinterForInitst();AddVariableDescriptor(pD);
  pD = new PercentAntiMildewTreated();    AddVariableDescriptor(pD);
  pD = new PercentAutumnTilled();         AddVariableDescriptor(pD);
  pD = new PercentClipped();              AddVariableDescriptor(pD);
  pD = new PercentDebranched();           AddVariableDescriptor(pD);
  pD = new PercentExtraPhytoTreated();    AddVariableDescriptor(pD);
  pD = new PercentFertilized();           AddVariableDescriptor(pD);
  pD = new PercentInitSpringTilled();     AddVariableDescriptor(pD);
  pD = new PercentPlanted();              AddVariableDescriptor(pD);
  pD = new PercentPruned();               AddVariableDescriptor(pD);
  pD = new PercentRegularPhytoTreated();  AddVariableDescriptor(pD);
  pD = new PercentShootThinned();         AddVariableDescriptor(pD);
  pD = new PercentSpringTilled();         AddVariableDescriptor(pD);
  pD = new PercentSpringWeeded();         AddVariableDescriptor(pD);
  pD = new PercentTrellised();            AddVariableDescriptor(pD);
  pD = new PercentWeeded();               AddVariableDescriptor(pD);
  pD = new PercentWinterTilled();         AddVariableDescriptor(pD);
  Method* pM;
  pM = new IsMotorizationPossible();      AddMethod (pM);
  pM = new AssignRelativeAreaToRows();    AddMethod (pM);
  pM = new ReturnPassedRowsFrequency();   AddMethod (pM);
  pM = new SetRowSoilManagement();        AddMethod (pM);
  pM = new ReturnSoilManagementGroupOnProfile();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Plot::Plot(char* name) {
// =========================================================
// Une classe de Entity : 'Plot'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PLOT);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  AddComponentClassId(VEGETAL_COMPARTMENT);
  AddComponentClassId(SOIL_RESERVOIR);
  Descriptor* pD;
  pD = new WeatherStationAttribute();     AddConstantDescriptor(pD);
  pD = new Latitude();                    AddConstantDescriptor(pD);
  pD = new Longitude();                   AddConstantDescriptor(pD);
  pD = new Village();                     AddConstantDescriptor(pD);
  pD = new Area();                        AddConstantDescriptor(pD);
  pD = new AlleyWidth();                  AddConstantDescriptor(pD);
  pD = new PlantSpacing();                AddConstantDescriptor(pD);
  pD = new YearOfPlantation();            AddConstantDescriptor(pD);
  pD = new LandUse();                     AddConstantDescriptor(pD);
  pD = new PlaceName();                   AddConstantDescriptor(pD);
  pD = new SoilType();                    AddConstantDescriptor(pD);
  pD = new SoilManagementGroupName();     AddConstantDescriptor(pD);
  pD = new Stoniness();                   AddConstantDescriptor(pD);
  pD = new PruningMode();                 AddConstantDescriptor(pD);
  pD = new TrellisMode();                 AddConstantDescriptor(pD);
  pD = new GrapeVarietyAttribute();       AddConstantDescriptor(pD);
  pD = new RowManagement();               AddConstantDescriptor(pD);
  pD = new CropRowAlleyWidthRatio();      AddConstantDescriptor(pD);
  pD = new GrassStripAlleyWidthRatio();   AddConstantDescriptor(pD);
  pD = new RidingOrientedInterRowProportion();AddConstantDescriptor(pD);
  pD = new LastTillageOperationClock();   AddConstantDescriptor(pD);
  pD = new CumulativeRainfallFromMhydasInteraction();AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromLastTillage();AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromEarlyWinter();AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromEarlyWinterForInitst();AddVariableDescriptor(pD);
  pD = new PercentAntiMildewTreated();    AddVariableDescriptor(pD);
  pD = new PercentAutumnTilled();         AddVariableDescriptor(pD);
  pD = new PercentClipped();              AddVariableDescriptor(pD);
  pD = new PercentDebranched();           AddVariableDescriptor(pD);
  pD = new PercentExtraPhytoTreated();    AddVariableDescriptor(pD);
  pD = new PercentFertilized();           AddVariableDescriptor(pD);
  pD = new PercentInitSpringTilled();     AddVariableDescriptor(pD);
  pD = new PercentPlanted();              AddVariableDescriptor(pD);
  pD = new PercentPruned();               AddVariableDescriptor(pD);
  pD = new PercentRegularPhytoTreated();  AddVariableDescriptor(pD);
  pD = new PercentShootThinned();         AddVariableDescriptor(pD);
  pD = new PercentSpringTilled();         AddVariableDescriptor(pD);
  pD = new PercentSpringWeeded();         AddVariableDescriptor(pD);
  pD = new PercentTrellised();            AddVariableDescriptor(pD);
  pD = new PercentWeeded();               AddVariableDescriptor(pD);
  pD = new PercentWinterTilled();         AddVariableDescriptor(pD);
  Method* pM;
  pM = new IsMotorizationPossible();      AddMethod (pM);
  pM = new AssignRelativeAreaToRows();    AddMethod (pM);
  pM = new ReturnPassedRowsFrequency();   AddMethod (pM);
  pM = new SetRowSoilManagement();        AddMethod (pM);
  pM = new ReturnSoilManagementGroupOnProfile();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetInstanceName(name);

  // pour tri sur motorisable : non motorisable (chantiet AntiMildiou)
  pD = new AnonymousIntAttribute();       AddVariableDescriptor(pD);

  Entity* pVegetal = new VegetalCompartment();
  AddComponent(pVegetal);
  for(int i=0;i<4;i++) {
	Entity* pRow_i = pVegetal->GetElement(i);
	char rowName[100] = "\0";;
	sprintf(rowName, "%s_%d", name, i+1);
	pRow_i->SetInstanceName(rowName);
  }

  Entity* pReservoir = new SoilReservoir();
  AddComponent(pReservoir);
};

PlotInternalPatternOptionSet::PlotInternalPatternOptionSet() {
// =========================================================
// Une classe de Entity : 'PlotInternalPatternOptionSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PLOT_INTERNAL_PATTERN_OPTION_SET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(PLOT_INTERNAL_PATTERN_OPTION_SUBSET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PlotInternalPatternOptionSubset::PlotInternalPatternOptionSubset() {
// =========================================================
// Une classe de Entity : 'PlotInternalPatternOptionSubset'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PLOT_INTERNAL_PATTERN_OPTION_SUBSET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new OptCropRowAlleyWidthRatio();   AddConstantDescriptor(pD);
  pD = new OptGrassStripAlleyWidthRatio();AddConstantDescriptor(pD);
  pD = new OptRidingOrientedInterRowProportion();AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

RetiredWorkerAnnualEmploymentPlan::RetiredWorkerAnnualEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'RetiredWorkerAnnualEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(RETIRED_WORKER_ANNUAL_EMPLOYMENT_PLAN);
  //SetParentClassId(ANNUAL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Entity* pPlan;
  Entity* pRATT;
  //--------------------------------------------------
  pPlan = new SeptemberOctoberReducedHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new NovemberJanuaryReducedHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new FebruaryMarchReducedHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new AprilReducedHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new MayAugustReducedHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
};

Row::Row() {
// =========================================================
// Une classe de Entity : 'Row'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ROW);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new RelativeArea();                AddConstantDescriptor(pD);
  pD = new SoilManagementModality();      AddConstantDescriptor(pD);
  pD = new LastOperationsMemoryAttribute();AddConstantDescriptor(pD);
  pD = new SoilHumidityVectorFromMhydas();AddConstantDescriptor(pD);
  pD = new GrassCoverVectorFromMhydas();  AddConstantDescriptor(pD);
  Method* pM;
  pM = new SumUpGrassCoverVector();       AddMethod (pM);
  pM = new SumUpSoilHumidityVector();     AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetEntityConstValue(LAST_OPERATIONS_MEMORY_ATTRIBUTE, 
					  new LastOperationsMemory());
};

SeasonalEmploymentPlan::SeasonalEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'SeasonalEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SEASONAL_EMPLOYMENT_PLAN);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new WorkDayMorningBegHour();       AddConstantDescriptor(pD);
  pD = new WorkDayMorningEndHour();       AddConstantDescriptor(pD);
  pD = new WorkDayMorningExtendedEndHour();AddConstantDescriptor(pD);
  pD = new WorkDayAfternoonBegHour();     AddConstantDescriptor(pD);
  pD = new WorkDayAfternoonEndHour();     AddConstantDescriptor(pD);
  pD = new WorkDayAfternoonExtendedEndHour();AddConstantDescriptor(pD);
  pD = new TimetableAttribute();          AddConstantDescriptor(pD);
  pD = new WorkingTimeWeeklyUpperBound(); AddConstantDescriptor(pD);
  pD = new CurrentSlotToBeExtended();     AddConstantDescriptor(pD);
  Method* pM;
  pM = new TimetableOpeningPredicate();   AddMethod (pM);
  pM = new TimetableClosingPredicate();   AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  // contraintes standard sur les heures de travail
  SetIntConstValue(WORKING_TIME_WEEKLY_UPPER_BOUND, gIntParam_standardWorkingTime_week_);
};

bool septemberOctoberEmploymentPlan_timetableOpeningPredicate_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// specifie l'ouverture d'un SeasonalEmploymentPlan
//---------------------------------------------------------------------------
// renvoie 'vrai' ssi la date courante est apres le 01/09 de la m�me annee
//---------------------------------------------------------------------------
  Entity* pSeasonalPlan = pM->DescribedEntity();
  bool result = FALSE;
  //
  // l'instant courant
  //
  int now = pCurrentSim->Clock();
  tm* pTm_now = ClockValueToTm(now);
  int mday = pTm_now->tm_mday;
  int mon = pTm_now->tm_mon;
  //
  // la date a atteindre pour entrer dans la periode
  //
  // de MAI a DEC : le 01/09 de la meme annee
  // de JAN a AVR : le 01/09 de l'annee precedente
  //
  if(mon < 4)
	pTm_now->tm_year = pTm_now->tm_year - 1;
  pTm_now->tm_mon = 8; // septembre
  pTm_now->tm_mday = 1;

  mktime(pTm_now);
  int seuil = StructTmToClockValue(pTm_now);
  //
  // test
  //
  if(now >= seuil)
	result = TRUE;

//printf("\nseptemberOctoberEmploymentPlan_OP with %d %s vs. %d %s %d returns %d", mday, MonthToChar(mon+1), pTm_now->tm_mday, MonthToChar(pTm_now->tm_mon+1), pTm_now->tm_year+1900, result);
  delete pTm_now;

  return result;
};

SeptemberOctoberEmploymentPlan::SeptemberOctoberEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'SeptemberOctoberEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SEPTEMBER_OCTOBER_EMPLOYMENT_PLAN);
  //SetParentClassId(SEASONAL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(TIMETABLE_OPENING_PREDICATE, septemberOctoberEmploymentPlan_timetableOpeningPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SeptemberOctoberNormalHoursEmploymentPlan::SeptemberOctoberNormalHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'SeptemberOctoberNormalHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SEPTEMBER_OCTOBER_NORMAL_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(SEPTEMBER_OCTOBER_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR,
					 gRealParam_normalPlan_septemberOctoberMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_normalPlan_septemberOctoberMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_normalPlan_septemberOctoberMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_normalPlan_septemberOctoberAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_normalPlan_septemberOctoberAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_normalPlan_septemberOctoberAfternoonExtendedEndHour_);
};

SeptemberOctoberReducedHoursEmploymentPlan::SeptemberOctoberReducedHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'SeptemberOctoberReducedHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SEPTEMBER_OCTOBER_REDUCED_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(SEPTEMBER_OCTOBER_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR,
					 gRealParam_reducedPlan_septemberOctoberMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_reducedPlan_septemberOctoberMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_reducedPlan_septemberOctoberMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_reducedPlan_septemberOctoberAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_reducedPlan_septemberOctoberAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_reducedPlan_septemberOctoberAfternoonExtendedEndHour_);
};

SoilManagementGroup::SoilManagementGroup() {
// =========================================================
// Une classe de Entity : 'SoilManagementGroup'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SOIL_MANAGEMENT_GROUP);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new PlotProfile();                 AddConstantDescriptor(pD);
  pD = new PlotProfileOperator();         AddConstantDescriptor(pD);
  pD = new PlotPattern();                 AddConstantDescriptor(pD);
  pD = new RowManagement();               AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SoilManagementGroupSet::SoilManagementGroupSet() {
// =========================================================
// Une classe de Entity : 'SoilManagementGroupSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SOIL_MANAGEMENT_GROUP_SET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(SOIL_MANAGEMENT_GROUP);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SoilReservoir::SoilReservoir() {
// =========================================================
// Une classe de Entity : 'SoilReservoir'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SOIL_RESERVOIR);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SoilSurface::SoilSurface() {
// =========================================================
// Une classe de Entity : 'SoilSurface'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SOIL_SURFACE);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SpecialWorkerAnnualEmploymentPlan::SpecialWorkerAnnualEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'SpecialWorkerAnnualEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SPECIAL_WORKER_ANNUAL_EMPLOYMENT_PLAN);
  //SetParentClassId(ANNUAL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Entity* pPlan;
  Entity* pRATT;
  //--------------------------------------------------
  pPlan = new SeptemberOctoberNormalHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new NovemberJanuaryNormalHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new FebruaryMarchNormalHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new AprilNormalHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new MayAugustExtendedHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerSevenDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
};

StandardWorkerAnnualEmploymentPlan::StandardWorkerAnnualEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'StandardWorkerAnnualEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(STANDARD_WORKER_ANNUAL_EMPLOYMENT_PLAN);
  //SetParentClassId(ANNUAL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Entity* pPlan;
  Entity* pRATT;
  //--------------------------------------------------
  pPlan = new SeptemberOctoberNormalHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new NovemberJanuaryNormalHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new FebruaryMarchNormalHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new AprilNormalHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
  pPlan = new MayAugustNormalHoursEmploymentPlan();
  pRATT = new PermanentFarmWorkerFiveDayTimetable();
  pPlan->SetEntityConstValue(TIMETABLE_ATTRIBUTE, pRATT);
  pRATT->SetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE, pPlan);
  AddElement(pPlan);
  //--------------------------------------------------
};

VarietyGroup::VarietyGroup() {
// =========================================================
// Une classe de Entity : 'VarietyGroup'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VARIETY_GROUP);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(GRAPE_VARIETY);
  Descriptor* pD;
  pD = new MembershipMode();              AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

VarietyGroupSet::VarietyGroupSet() {
// =========================================================
// Une classe de Entity : 'VarietyGroupSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VARIETY_GROUP_SET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(VARIETY_GROUP);
  Method* pM;
  pM = new GetRankedWaveList();           AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

VegetalCompartment::VegetalCompartment() {
// =========================================================
// Une classe de Entity : 'VegetalCompartment'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VEGETAL_COMPARTMENT);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(ROW);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  Entity* pRow;

  // inter-rang avec fonction de passage
  pRow = new InterRow();
  AddElement(pRow);
  // inter-rang toujours nu (labour ou chimie)
  pRow = new InterRow();
  AddElement(pRow);
  // rang
  pRow = new CropRow();
  AddElement(pRow);
  // rang
  pRow = new CropRow();
  AddElement(pRow);
};

Vegetation::Vegetation() {
// =========================================================
// Une classe de Entity : 'Vegetation'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VEGETATION);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Vineyard::Vineyard() {
// =========================================================
// Une classe de Entity : 'Vineyard'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VINEYARD);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(PLOT);
  Descriptor* pD;
  pD = new ControlPlanClassNameAttribute();AddConstantDescriptor(pD);
  pD = new ControlPlanAttribute();        AddConstantDescriptor(pD);
  pD = new HasEarlyVariety();             AddConstantDescriptor(pD);
  pD = new HasLateVariety();              AddConstantDescriptor(pD);
  pD = new GrapeVarietyListAttribute();   AddConstantDescriptor(pD);
  pD = new IsoAgeingEntitySetAttribute(); AddConstantDescriptor(pD);
  pD = new AreaWithGrapevine();           AddConstantDescriptor(pD);
  pD = new NumberOfTractors();            AddConstantDescriptor(pD);
  pD = new NumberOfWorkers();             AddConstantDescriptor(pD);
  pD = new AreaWithTilledGrapevine();     AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

VineyardSet::VineyardSet() {
// =========================================================
// Une classe de Entity : 'VineyardSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VINEYARD_SET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(VINEYARD);
  Descriptor* pD;
  pD = new PestInfoMemoryAttribute();     AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  Entity* pMemory = new PestInfoMemory();
  this->SetEntityConstValue(PEST_INFO_MEMORY_ATTRIBUTE, pMemory);
};

WeatherStation::WeatherStation() {
// =========================================================
// Une classe de Entity : 'WeatherStation'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(WEATHER_STATION);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new InstantAttribute();            AddConstantDescriptor(pD);
  pD = new Latitude();                    AddConstantDescriptor(pD);
  pD = new Longitude();                   AddConstantDescriptor(pD);
  pD = new PathNameAttribute();           AddConstantDescriptor(pD);
  pD = new DailyRainfallForecastFromCurrentDay();AddConstantDescriptor(pD);
  pD = new WinterBeginningClock();        AddConstantDescriptor(pD);
  pD = new WinterBeginningClockForInitst();AddConstantDescriptor(pD);
  pD = new Rainfall();                    AddVariableDescriptor(pD);
  pD = new Temperature();                 AddVariableDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatTabConstValue(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
						new pFloatTab(10));

  // pour tri sur pluie decroissante (OpeningCondition_SpringTillages)
  pD = new AnonymousFloatAttribute();     AddVariableDescriptor(pD);
};

WeatherStationSet::WeatherStationSet() {
// =========================================================
// Une classe de Entity : 'WeatherStationSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(WEATHER_STATION_SET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(WEATHER_STATION);
  Descriptor* pD;
  pD = new LastWeatherPrintClock();       AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

WorkOrganizationOptionSet::WorkOrganizationOptionSet() {
// =========================================================
// Une classe de Entity : 'WorkOrganizationOptionSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(WORK_ORGANIZATION_OPTION_SET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  ElementClassId(WORK_ORGANIZATION_OPTION_SUBSET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

WorkOrganizationOptionSubset::WorkOrganizationOptionSubset() {
// =========================================================
// Une classe de Entity : 'WorkOrganizationOptionSubset'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(WORK_ORGANIZATION_OPTION_SUBSET);
  //SetParentClassId(BD_ENTITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new ChemicalWeedingsManagement();  AddConstantDescriptor(pD);
  pD = new AutumnTillagesManagement();    AddConstantDescriptor(pD);
  pD = new PhytoManagement();             AddConstantDescriptor(pD);
  pD = new FertilizationsManagement();    AddConstantDescriptor(pD);
  pD = new ShootThinningsManagement();    AddConstantDescriptor(pD);
  pD = new WinterTillagesManagement();    AddConstantDescriptor(pD);
  pD = new InitSpringTillagesManagement();AddConstantDescriptor(pD);
  pD = new SpringTillagesManagement();    AddConstantDescriptor(pD);
  pD = new SpringChemicalWeedingsManagement();AddConstantDescriptor(pD);
  pD = new DebranchingsManagement();      AddConstantDescriptor(pD);
  pD = new ClippingsManagement();         AddConstantDescriptor(pD);
  pD = new PruningsManagement();          AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

bool aprilEmploymentPlan_timetableOpeningPredicate_Body(EntityMethod* pM) {
//-------------------------------------------------------------------------
// specifie l'ouverture d'un SeasonalEmploymentPlan
//-------------------------------------------------------------------------
// renvoie 'vrai' ssi la date courante est
// . apres le passage heure Hiver -> heure Ete de la m�me annee
//---------------------------------------------------------------------------
  Entity* pSeasonalPlan = pM->DescribedEntity();
  bool result = FALSE;
  //
  // l'instant courant
  //
  int now = pCurrentSim->Clock();
  tm* pTm_now = ClockValueToTm(now);
  int mday = pTm_now->tm_mday;
  int mon = pTm_now->tm_mon;
  //
  // la date a depasser pour entrer dans la periode
  // le passage Hiver -> Ete de la meme annee
  //
  // recherche du jour de passage heure Hiver -> heure Ete
  //
  pTm_now->tm_mon = 2; // mars
  for(int m=24;m<=31;m++) {
	pTm_now->tm_mday = m;
	mktime(pTm_now);
	int isdst_m = pTm_now->tm_isdst;
	if(isdst_m == 1) {
	  break;
	}
  }
//printf("\naprilEmploymentPlan_OP with %d %s hiver->ete le %d %s %d", mday, MonthToChar(mon+1), pTm_now->tm_mday, MonthToChar(pTm_now->tm_mon+1), pTm_now->tm_year+1900);
  int seuil = StructTmToClockValue(pTm_now);
  //
  // test
  //
  if(now >= seuil)
	result = TRUE;

//printf("\naprilEmploymentPlan_OP with %d %s vs. %d %s %d returns %d", mday, MonthToChar(mon+1), pTm_now->tm_mday, MonthToChar(pTm_now->tm_mon+1), pTm_now->tm_year+1900, result);
  delete pTm_now;

  return result;
};

AprilEmploymentPlan::AprilEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'AprilEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(APRIL_EMPLOYMENT_PLAN);
  //SetParentClassId(SEASONAL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(TIMETABLE_OPENING_PREDICATE, aprilEmploymentPlan_timetableOpeningPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

AprilNormalHoursEmploymentPlan::AprilNormalHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'AprilNormalHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(APRIL_NORMAL_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(APRIL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR, 
					 gRealParam_normalPlan_aprilMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_normalPlan_aprilMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_normalPlan_aprilMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_normalPlan_aprilAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_normalPlan_aprilAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_normalPlan_aprilAfternoonExtendedEndHour_);
};

AprilReducedHoursEmploymentPlan::AprilReducedHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'AprilReducedHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(APRIL_REDUCED_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(APRIL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR,
					 gRealParam_reducedPlan_aprilMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_reducedPlan_aprilMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_reducedPlan_aprilMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_reducedPlan_aprilAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_reducedPlan_aprilAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_reducedPlan_aprilAfternoonExtendedEndHour_);
};

CropRow::CropRow() {
// =========================================================
// Une classe de Entity : 'CropRow'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CROP_ROW);
  //SetParentClassId(ROW); // pour memoire (*)
  AddInstanceToClass();
  AddComponentClassId(GRAPEVINE);
  AddComponentClassId(SOIL_SURFACE);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  Entity* pGrapevine = new Grapevine();
  AddComponent(pGrapevine);
  Entity* pSoilSurface = new SoilSurface();
  AddComponent(pSoilSurface);
};

bool februaryMarchEmploymentPlan_timetableOpeningPredicate_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// specifie l'ouverture d'un SeasonalEmploymentPlan
//---------------------------------------------------------------------------
// renvoie 'vrai' ssi la date courante est apres le 01/02 de la m�me annee
//---------------------------------------------------------------------------
  Entity* pSeasonalPlan = pM->DescribedEntity();
  bool result = FALSE;
  //
  // l'instant courant
  //
  int now = pCurrentSim->Clock();
  tm* pTm_now = ClockValueToTm(now);
  int mday = pTm_now->tm_mday;
  int mon = pTm_now->tm_mon;
  //
  // la date a atteindre pour entrer dans la periode
  //
  // de SEP a DEC : le 01/02 de l'annee suivante
  // en JAN � AOU : le 01/02 de la meme annee
  //
  if(mon > 7)
	pTm_now->tm_year = pTm_now->tm_year + 1;
  pTm_now->tm_mon = 1; // fevrier
  pTm_now->tm_mday = 1;

  mktime(pTm_now);
  int seuil = StructTmToClockValue(pTm_now);
  //
  // test
  //
  if(now >= seuil)
	result = TRUE;

//printf("\nfebruaryMarchEmploymentPlan_OP with %d %s vs. %d %s %d returns %d", mday, MonthToChar(mon+1), pTm_now->tm_mday, MonthToChar(pTm_now->tm_mon+1), pTm_now->tm_year+1900, result);
  delete pTm_now;

  return result;
};

FebruaryMarchEmploymentPlan::FebruaryMarchEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'FebruaryMarchEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FEBRUARY_MARCH_EMPLOYMENT_PLAN);
  //SetParentClassId(SEASONAL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(TIMETABLE_OPENING_PREDICATE, februaryMarchEmploymentPlan_timetableOpeningPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

FebruaryMarchNormalHoursEmploymentPlan::FebruaryMarchNormalHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'FebruaryMarchNormalHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FEBRUARY_MARCH_NORMAL_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(FEBRUARY_MARCH_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR,
					 gRealParam_normalPlan_februaryMarchMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_normalPlan_februaryMarchMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_normalPlan_februaryMarchMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_normalPlan_februaryMarchAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_normalPlan_februaryMarchAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_normalPlan_februaryMarchAfternoonExtendedEndHour_);
};

FebruaryMarchReducedHoursEmploymentPlan::FebruaryMarchReducedHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'FebruaryMarchReducedHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FEBRUARY_MARCH_REDUCED_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(FEBRUARY_MARCH_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR,
					 gRealParam_reducedPlan_februaryMarchMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_reducedPlan_februaryMarchMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_reducedPlan_februaryMarchMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_reducedPlan_februaryMarchAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_reducedPlan_februaryMarchAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_reducedPlan_februaryMarchAfternoonExtendedEndHour_);
};

Grapevine::Grapevine() {
// =========================================================
// Une classe de Entity : 'Grapevine'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GRAPEVINE);
  //SetParentClassId(VEGETATION); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new IsoAgeingEntityAttribute();    AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

GrapevineAge::GrapevineAge() {
// =========================================================
// Une classe de Entity : 'GrapevineAge'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GRAPEVINE_AGE);
  //SetParentClassId(PLANT_AGE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  pEntityTab* pStadeTab = GetEntityTabConstValue(STAGE_TAB);

  for (int k=0;k<48;k++) {
	//
	// Systeme Eichhorn et Lorentz a 47 stades 
	// de 'Bourgeon d'hiver' a 'debut chute des feuilles'.
	// On ne decrit que les stades utiles a la decision Dhivine.
	// Le stade 0 est reserve pour le stade 'dormance'.
	PhenoStage* pStade = new PhenoStage();
	pStadeTab->push_back(pStade);
  }
  ((Entity*)(pStadeTab->get_element(6)))->SetStringConstValue(STAGE_NAME, "budBreak");
  ((Entity*)(pStadeTab->get_element(7)))->SetStringConstValue(STAGE_NAME, "firstLeafUnfolded");
  ((Entity*)(pStadeTab->get_element(9)))->SetStringConstValue(STAGE_NAME, "twoToThreeLeavesUnfolded");
  ((Entity*)(pStadeTab->get_element(12)))->SetStringConstValue(STAGE_NAME, "fiveToSixLeavesUnfolded");
  ((Entity*)(pStadeTab->get_element(15)))->SetStringConstValue(STAGE_NAME, "inflorescenceElongating");
  ((Entity*)(pStadeTab->get_element(17)))->SetStringConstValue(STAGE_NAME, "inflorescenceFullyDeveloped");
  ((Entity*)(pStadeTab->get_element(19)))->SetStringConstValue(STAGE_NAME, "beginningOfFlowering");
  ((Entity*)(pStadeTab->get_element(21)))->SetStringConstValue(STAGE_NAME, "earlyFlowering");
  ((Entity*)(pStadeTab->get_element(23)))->SetStringConstValue(STAGE_NAME, "fullFlowering");
  ((Entity*)(pStadeTab->get_element(25)))->SetStringConstValue(STAGE_NAME, "lateFlowering");
  ((Entity*)(pStadeTab->get_element(27)))->SetStringConstValue(STAGE_NAME, "fruitSet");
  ((Entity*)(pStadeTab->get_element(29)))->SetStringConstValue(STAGE_NAME, "berriesSmall");
  ((Entity*)(pStadeTab->get_element(31)))->SetStringConstValue(STAGE_NAME, "berriesPeaSized");
  ((Entity*)(pStadeTab->get_element(33)))->SetStringConstValue(STAGE_NAME, "beginningOfBerryTouch");
  ((Entity*)(pStadeTab->get_element(35)))->SetStringConstValue(STAGE_NAME, "beginningOfBerryRipening");
  ((Entity*)(pStadeTab->get_element(37)))->SetStringConstValue(STAGE_NAME, "endOfBerryRipening");
};

Grass::Grass() {
// =========================================================
// Une classe de Entity : 'Grass'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GRASS);
  //SetParentClassId(VEGETATION); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new GrassTypeAttribute();          AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

GrassAge::GrassAge() {
// =========================================================
// Une classe de Entity : 'GrassAge'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GRASS_AGE);
  //SetParentClassId(PLANT_AGE); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new ThermalTimeFromEmergence();    AddVariableDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  pEntityTab* pStadeTab = GetEntityTabConstValue(STAGE_TAB);

  PhenoStage* pStade = new PhenoStage();
  pStade->SetStringConstValue(STAGE_NAME, "germination");
  pStadeTab->push_back(pStade);

  pStade = new PhenoStage();
  pStade->SetStringConstValue(STAGE_NAME, "croissance");
  pStade->SetFloatConstValue(THERMAL_TIME_TO_ACHIEVE, 
			     GetRealParameterValue("grassDeveloppement", 
						   "fromSowingToEmergence"));
  pStadeTab->push_back(pStade);

  pStade = new PhenoStage();
  pStade->SetStringConstValue(STAGE_NAME, "destruction");
  pStadeTab->push_back(pStade);
};

InterRow::InterRow() {
// =========================================================
// Une classe de Entity : 'InterRow'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(INTER_ROW);
  //SetParentClassId(ROW); // pour memoire (*)
  AddInstanceToClass();
  AddComponentClassId(GRASS);
  AddComponentClassId(SOIL_SURFACE);
  AddComponentClassId(SOIL_RESERVOIR);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

bool mayAugustEmploymentPlan_timetableOpeningPredicate_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// specifie l'ouverture d'un SeasonalEmploymentPlan
//---------------------------------------------------------------------------
// renvoie 'vrai' ssi la date courante est apres le 01/05 de la m�me annee
//---------------------------------------------------------------------------
  Entity* pSeasonalPlan = pM->DescribedEntity();
  bool result = FALSE;
  //
  // l'instant courant
  //
  int now = pCurrentSim->Clock();
  tm* pTm_now = ClockValueToTm(now);
  int mday = pTm_now->tm_mday;
  int mon = pTm_now->tm_mon;
  //
  // la date a atteindre pour entrer dans la periode
  //
  // de SEP a DEC : le 01/05 de l'annee suivante
  // en JAN � AOU : le 01/05 de la meme annee
  //
  if(mon > 7)
	pTm_now->tm_year = pTm_now->tm_year + 1;
  //
  pTm_now->tm_mon = 4; // may
  pTm_now->tm_mday = 1;

  mktime(pTm_now);
  int seuil = StructTmToClockValue(pTm_now);
  //
  // test
  //
  if(now >= seuil)
	result = TRUE;

//printf("\nmayAugustEmploymentPlan_OP with %d %s vs. %d %s %d returns %d", mday, MonthToChar(mon+1), pTm_now->tm_mday, MonthToChar(pTm_now->tm_mon+1), pTm_now->tm_year+1900, result);
  delete pTm_now;

  return result;
};

MayAugustEmploymentPlan::MayAugustEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'MayAugustEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MAY_AUGUST_EMPLOYMENT_PLAN);
  //SetParentClassId(SEASONAL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(TIMETABLE_OPENING_PREDICATE, mayAugustEmploymentPlan_timetableOpeningPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

MayAugustExtendedHoursEmploymentPlan::MayAugustExtendedHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'MayAugustExtendedHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MAY_AUGUST_EXTENDED_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(MAY_AUGUST_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR,
					 gRealParam_extendedPlan_mayAugustMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_extendedPlan_mayAugustMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_extendedPlan_mayAugustMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_extendedPlan_mayAugustAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_extendedPlan_mayAugustAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_extendedPlan_mayAugustAfternoonExtendedEndHour_);
};

MayAugustNormalHoursEmploymentPlan::MayAugustNormalHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'MayAugustNormalHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MAY_AUGUST_NORMAL_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(MAY_AUGUST_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR,
					 gRealParam_normalPlan_mayAugustMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_normalPlan_mayAugustMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_normalPlan_mayAugustMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_normalPlan_mayAugustAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_normalPlan_mayAugustAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_normalPlan_mayAugustAfternoonExtendedEndHour_);
};

MayAugustReducedHoursEmploymentPlan::MayAugustReducedHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'MayAugustReducedHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MAY_AUGUST_REDUCED_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(MAY_AUGUST_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR,
					 gRealParam_reducedPlan_mayAugustMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_reducedPlan_mayAugustMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_reducedPlan_mayAugustMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_reducedPlan_mayAugustAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_reducedPlan_mayAugustAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_reducedPlan_mayAugustAfternoonExtendedEndHour_);
};

bool novemberJanuaryEmploymentPlan_timetableOpeningPredicate_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// specifie l'ouverture d'un SeasonalEmploymentPlan
//---------------------------------------------------------------------------
// renvoie 'vrai' ssi la date courante est
// . apres le passage heure Ete -> heure Hiver de la m�me annee
//   si mois <= 7 e.g. : 15 NOV
//   OU
// . apres le passage heure Ete -> heure Hiver de l'annee precedente
//   e.g. : 15 JAN
//---------------------------------------------------------------------------
  Entity* pSeasonalPlan = pM->DescribedEntity();
  bool result = FALSE;
  //
  // l'instant courant
  //
  int now = pCurrentSim->Clock();
  tm* pTm_now = ClockValueToTm(now);
  int mon  = pTm_now->tm_mon;
  int mday = pTm_now->tm_mday;
  //
  // la date a depasser pour entrer dans la periode :
  //
  // de JAN a AOU : le passage Ete -> Hiver de l'annee precedente
  // de SEP a DEC : le passage Ete -> Hiver de la meme annee
  //
  // recherche du jour de passage heure Ete -> heure Hiver
  //
  if(mon < 8)
	pTm_now->tm_year = pTm_now->tm_year - 1;
  pTm_now->tm_mon = 9; // octobre
  for(int m=23;m<=31;m++) {
	pTm_now->tm_mday = m;
	mktime(pTm_now);
	int isdst_m = pTm_now->tm_isdst;
	if(isdst_m == 0) {
	  break;
	}
  }
//printf("\nnovemberJanuaryEmploymentPlan_OP with %d %s ete->hiver le %d %s %d", mday, MonthToChar(mon+1), pTm_now->tm_mday, MonthToChar(pTm_now->tm_mon+1), pTm_now->tm_year+1900);
  int seuil = StructTmToClockValue(pTm_now);
  //
  // test
  //
  if(now >= seuil)
	result = TRUE;

//printf("\nnovemberJanuaryEmploymentPlan_OP with %d %s vs. %d %s %d returns %d", mday, MonthToChar(mon+1), pTm_now->tm_mday, MonthToChar(pTm_now->tm_mon+1), pTm_now->tm_year+1900, result);
  delete pTm_now;

  return result;
};

NovemberJanuaryEmploymentPlan::NovemberJanuaryEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'NovemberJanuaryEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(NOVEMBER_JANUARY_EMPLOYMENT_PLAN);
  //SetParentClassId(SEASONAL_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(TIMETABLE_OPENING_PREDICATE, novemberJanuaryEmploymentPlan_timetableOpeningPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

NovemberJanuaryNormalHoursEmploymentPlan::NovemberJanuaryNormalHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'NovemberJanuaryNormalHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(NOVEMBER_JANUARY_NORMAL_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(NOVEMBER_JANUARY_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR,
					 gRealParam_normalPlan_novemberJanuaryMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_normalPlan_novemberJanuaryMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_normalPlan_novemberJanuaryMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_normalPlan_novemberJanuaryAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_normalPlan_novemberJanuaryAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_normalPlan_novemberJanuaryAfternoonExtendedEndHour_);
};

NovemberJanuaryReducedHoursEmploymentPlan::NovemberJanuaryReducedHoursEmploymentPlan() {
// =========================================================
// Une classe de Entity : 'NovemberJanuaryReducedHoursEmploymentPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(NOVEMBER_JANUARY_REDUCED_HOURS_EMPLOYMENT_PLAN);
  //SetParentClassId(NOVEMBER_JANUARY_EMPLOYMENT_PLAN); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR,
					 gRealParam_reducedPlan_novemberJanuaryMorningBegHour_);
  SetFloatConstValue(WORK_DAY_MORNING_END_HOUR,
					 gRealParam_reducedPlan_novemberJanuaryMorningEndHour_);
  SetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR,
					 gRealParam_reducedPlan_novemberJanuaryMorningExtendedEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR,
					 gRealParam_reducedPlan_novemberJanuaryAfternoonBegHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR,
					 gRealParam_reducedPlan_novemberJanuaryAfternoonEndHour_);
  SetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR,
					 gRealParam_reducedPlan_novemberJanuaryAfternoonExtendedEndHour_);
};

