// ==============================================
// Fichier : UserEntitySpec.cc  
// Type    : source C++
// 
// Description : constructeurs des classes des 'EntitySpec'.
// ==============================================
  
#include "UserEntitySpec.h"
  
// ==============================================
// Une classe d'EntitySpec : 'AirAssistedSprayingResourceEntitySpec'.
// ==============================================

AirAssistedSprayingResourceEntitySpec::AirAssistedSprayingResourceEntitySpec() : EntitySpec(AIR_ASSISTED_SPRAYING_RESOURCE_SET) {
	ClassName("airAssistedSprayingResourceEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(INSTANTIATE);
	IntQuantity(-9);
	AssignEntityListInstantiator(airAssistedSprayingResourceEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'ChemicalDebrancherSprayingResourceEntitySpec'.
// ==============================================

ChemicalDebrancherSprayingResourceEntitySpec::ChemicalDebrancherSprayingResourceEntitySpec() : EntitySpec(CHEMICAL_DEBRANCHER_SPRAYING_RESOURCE_SET) {
	ClassName("chemicalDebrancherSprayingResourceEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(INSTANTIATE);
	IntQuantity(-9);
	AssignEntityListInstantiator(chemicalDebrancherSprayingResourceEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'ChemicalWeedingExecutorEntitySpec'.
// ==============================================

ChemicalWeedingExecutorEntitySpec::ChemicalWeedingExecutorEntitySpec() : EntitySpec(PERMANENT_FARM_WORKER) {
	ClassName("chemicalWeedingExecutorEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(RETURN_INSTANCES);
	IntQuantity(-9);
	AssignEntityListInstantiator(chemicalWeedingExecutorEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'ClippingResourceEntitySpec'.
// ==============================================

ClippingResourceEntitySpec::ClippingResourceEntitySpec() : EntitySpec(CLIPPING_RESOURCE_SET) {
	ClassName("clippingResourceEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(INSTANTIATE);
	IntQuantity(-9);
	AssignEntityListInstantiator(clippingResourceEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'FertilizationResourceEntitySpec'.
// ==============================================

FertilizationResourceEntitySpec::FertilizationResourceEntitySpec() : EntitySpec(FERTILIZATION_RESOURCE_SET) {
	ClassName("fertilizationResourceEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(INSTANTIATE);
	IntQuantity(-9);
	AssignEntityListInstantiator(fertilizationResourceEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'GreenWorkExecutorEntitySpec'.
// ==============================================

GreenWorkExecutorEntitySpec::GreenWorkExecutorEntitySpec() : EntitySpec(FARM_WORKER) {
	ClassName("greenWorkExecutorEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(RETURN_INSTANCES);
	IntQuantity(-9);
	AssignEntityListInstantiator(greenWorkExecutorEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'GrinderShootThinningResourceEntitySpec'.
// ==============================================

GrinderShootThinningResourceEntitySpec::GrinderShootThinningResourceEntitySpec() : EntitySpec(GRINDER_SHOOT_THINNING_RESOURCE_SET) {
	ClassName("grinderShootThinningResourceEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(INSTANTIATE);
	IntQuantity(-9);
	AssignEntityListInstantiator(grinderShootThinningResourceEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'HandHeldGunSprayingResourceEntitySpec'.
// ==============================================

HandHeldGunSprayingResourceEntitySpec::HandHeldGunSprayingResourceEntitySpec() : EntitySpec(HAND_HELD_GUN_SPRAYING_RESOURCE_SET) {
	ClassName("handHeldGunSprayingResourceEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(INSTANTIATE);
	IntQuantity(-9);
	AssignEntityListInstantiator(handHeldGunSprayingResourceEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'HorizontalRailSprayingResourceEntitySpec'.
// ==============================================

HorizontalRailSprayingResourceEntitySpec::HorizontalRailSprayingResourceEntitySpec() : EntitySpec(HORIZONTAL_RAIL_SPRAYING_RESOURCE_SET) {
	ClassName("horizontalRailSprayingResourceEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(INSTANTIATE);
	IntQuantity(-9);
	AssignEntityListInstantiator(horizontalRailSprayingResourceEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'ManualWorkerEntitySpec'.
// ==============================================

ManualWorkerEntitySpec::ManualWorkerEntitySpec() : EntitySpec(FARM_WORKER) {
	ClassName("manualWorkerEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(RETURN_INSTANCES);
	IntQuantity(-9);
	AssignEntityListInstantiator(manualWorkerEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'PruningExecutorEntitySpec'.
// ==============================================

PruningExecutorEntitySpec::PruningExecutorEntitySpec() : EntitySpec(FARM_WORKER) {
	ClassName("pruningExecutorEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(RETURN_INSTANCES);
	IntQuantity(-9);
	AssignEntityListInstantiator(pruningExecutorEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'RotaryTillageResourceEntitySpec'.
// ==============================================

RotaryTillageResourceEntitySpec::RotaryTillageResourceEntitySpec() : EntitySpec(ROTARY_TILLAGE_RESOURCE_SET) {
	ClassName("rotaryTillageResourceEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(INSTANTIATE);
	IntQuantity(-9);
	AssignEntityListInstantiator(rotaryTillageResourceEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'SpringTineTillageResourceEntitySpec'.
// ==============================================

SpringTineTillageResourceEntitySpec::SpringTineTillageResourceEntitySpec() : EntitySpec(SPRING_TINE_TILLAGE_RESOURCE_SET) {
	ClassName("springTineTillageResourceEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(INSTANTIATE);
	IntQuantity(-9);
	AssignEntityListInstantiator(springTineTillageResourceEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'TillageTractorDriverEntitySpec'.
// ==============================================

TillageTractorDriverEntitySpec::TillageTractorDriverEntitySpec() : EntitySpec(PERMANENT_FARM_WORKER) {
	ClassName("tillageTractorDriverEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(RETURN_INSTANCES);
	IntQuantity(-9);
	AssignEntityListInstantiator(tillageTractorDriverEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'TractorDriverEntitySpec'.
// ==============================================

TractorDriverEntitySpec::TractorDriverEntitySpec() : EntitySpec(PERMANENT_MULTI_TASK_WORKER) {
	ClassName("tractorDriverEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(RETURN_INSTANCES);
	IntQuantity(-9);
	AssignEntityListInstantiator(tractorDriverEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Une classe d'EntitySpec : 'VerticalRailSprayingResourceEntitySpec'.
// ==============================================

VerticalRailSprayingResourceEntitySpec::VerticalRailSprayingResourceEntitySpec() : EntitySpec(VERTICAL_RAIL_SPRAYING_RESOURCE_SET) {
	ClassName("verticalRailSprayingResourceEntitySpec");
	SetQuantificatorId(ALLENT);
	SetMode(INSTANTIATE);
	IntQuantity(-9);
	AssignEntityListInstantiator(verticalRailSprayingResourceEntitySpec_entityListInstantiator_Body);
};


// ==============================================
// Corps des méthodes prédéfinies
// ==============================================

pEntityTab* airAssistedSprayingResourceEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pOt = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  if(ooList->size() < 1) {
	printf("\n!!! Pas de parcelle trouv�e dans airAssistedSprayingResourceEntitySpec_ELI operation : '%s'", pOt->InstanceName());
	exit(0);
  }
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nairAssistedSprayingResourceEntitySpec_ELI pPlot  : '%s'\n", pPlot->InstanceName());

  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT); 
  // AIR_ASSISTED_SPRAYING_RESOURCE_SET
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);

  Entity* pVineyard = pPlot->GetSuperSet();
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  //Entity* pWorkerPool = pRscPool->GetElement(0); // cf. App_ResourceSettings
  Entity* pEquipmentPool = pRscPool->GetElement(1);
  pEntityTab tmp;
   //------------------------------------------------------------
  pEntityTab* tractorTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TRACTOR);
  tractorTab->push_back(tmp);
  int nbTractor = tractorTab->size();
//printf("\nairAssistedSprayingResourceEntitySpec_ELI tractorTab : ");tractorTab->display_names();
  //------------------------------------------------------------
  pEntityTab* tractedTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(AIR_ASSISTED_SPRAYER);
  tractedTab->push_back(tmp);
  int nbTracted = tractedTab->size();
//printf("\nairAssistedSprayingResourceEntitySpec_ELI tractedTab : ");tractedTab->display_names();
  //------------------------------------------------------------
  for(int j= 0;j<nbTractor;j++) {
	Entity* pTractor = (Entity*)tractorTab->get_element(j);
	/*
	  if(pTractor->IsInstanceOf(UNE_SS_CLASSE)
	  &&
	  pPlot-GetIntConstValue(ALLEY_WIDTH) < 180)
	  continue;
	*/
	for(int k= 0;k<nbTracted;k++) {
	  Entity* pTracted = (Entity*)tractedTab->get_element(k);
		Entity* pAggrRsc = new AirAssistedSprayingResourceSet();
		pAggrRsc->AddElement(pTractor);
		pAggrRsc->AddElement(pTracted);
		//pAggrRsc->AddElement(pDriver);
		pAggrRsc->SetIntConstValue(IS_PERMANENT, FALSE);  // + JPR 110225
//printf("\nairAssistedSprayingResourceEntitySpec_ELI new {'%s' '%s' }", pTractor->InstanceName(), pTracted->InstanceName()); 
		result->push_back(pAggrRsc);	 
	}
  }
  delete  tractorTab;
  delete  tractedTab;
  return result;
};
  
pEntityTab* chemicalDebrancherSprayingResourceEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pOt = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  if(ooList->size() < 1) {
	printf("\n!!! Pas de parcelle trouv�e dans chemicalDebrancherSprayingResourceEntitySpec_ELI operation : '%s'", pOt->InstanceName());
	exit(0);
  }
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nchemicalDebrancherSprayingResourceEntitySpec_ELI pPlot  : '%s'\n", pPlot->InstanceName());

  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT); 
  // CHEMICAL_DEBRANCHER_SPRAYING_RESOURCE_SET
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);

  Entity* pVineyard = pPlot->GetSuperSet();
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  //Entity* pWorkerPool = pRscPool->GetElement(0); // cf. App_ResourceSettings
  Entity* pEquipmentPool = pRscPool->GetElement(1);
  pEntityTab tmp;
  //------------------------------------------------------------
  pEntityTab* tractorTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TRACTOR);
  tractorTab->push_back(tmp);
  int nbTractor = tractorTab->size();
//printf("\nchemicalDebrancherSprayingResourceEntitySpec_ELI tractorTab : ");tractorTab->display_names();
  //------------------------------------------------------------
  pEntityTab* tractedTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(DEBRANCHING_SPRAYER);
  tractedTab->push_back(tmp);
  int nbTracted = tractedTab->size();
//printf("\nchemicalDebrancherSprayingResourceEntitySpec_ELI tractedTab : ");tractedTab->display_names();
  //------------------------------------------------------------
  for(int j= 0;j<nbTractor;j++) {
	Entity* pTractor = (Entity*)tractorTab->get_element(j);
	/*
	  if(pTractor->IsInstanceOf(UNE_SS_CLASSE)
	  &&
	  pPlot-GetIntConstValue(ALLEY_WIDTH) < 180)
	  continue;
	*/
	for(int k= 0;k<nbTracted;k++) {
	  Entity* pTracted = (Entity*)tractedTab->get_element(k);
		Entity* pAggrRsc = new ChemicalDebrancherSprayingResourceSet();
		pAggrRsc->AddElement(pTractor);
		pAggrRsc->AddElement(pTracted);
		pAggrRsc->SetIntConstValue(IS_PERMANENT, FALSE);  // + JPR 110225
//printf("\nchemicalDebrancherSprayingResourceEntitySpec_ELI new {'%s' '%s'}", pTractor->InstanceName(), pTracted->InstanceName()); 
		result->push_back(pAggrRsc);
	}
  }
  delete  tractorTab;
  delete  tractedTab;
  
  return result;
};
  
pEntityTab* chemicalWeedingExecutorEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pVineyard = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT);
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);
  //
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  Entity* pWorkerPool = pRscPool->GetElement(0); // convention App_ResourceSettings
  pEntityTab tmp;  
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_MULTI_TASK_MANUAL_WORKER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_TILLAGE_ORIENTED_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_ALL_TASK_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_PREFERENTIAL_TRACTOR_DRIVER);
  result->push_back(tmp);

//printf("\nchemicalWeedingExecutorEntitySpec_ELI result : ");result->display_names();

  return result;
};
  
pEntityTab* clippingResourceEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pOt = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  if(ooList->size() < 1) {
	printf("\n!!! Pas de parcelle trouvee dans clippingResourceEntitySpec_ELI operation : '%s'", pOt->InstanceName());
	exit(0);
  }
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nclippingResourceEntitySpec_ELI pPlot  : '%s'\n", pPlot->InstanceName());

  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT); 
  // CLIPPING_RESOURCE_SET
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);

  Entity* pVineyard = pPlot->GetSuperSet();
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  //Entity* pWorkerPool = pRscPool->GetElement(0); // cf. App_ResourceSettings
  Entity* pEquipmentPool = pRscPool->GetElement(1);
  pEntityTab tmp;
  //------------------------------------------------------------
  pEntityTab* tractorTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TRACTOR);
  tractorTab->push_back(tmp);
  int nbTractor = tractorTab->size();
//printf("\nclippingResourceEntitySpec_ELI tractorTab : ");tractorTab->display_names();
  //------------------------------------------------------------
  pEntityTab* tractedTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(CLIPPER);
  tractedTab->push_back(tmp);
  int nbTracted = tractedTab->size();
//printf("\nclippingResourceEntitySpec_ELI tractedTab : ");tractedTab->display_names();
  //------------------------------------------------------------
  for(int j= 0;j<nbTractor;j++) {
	Entity* pTractor = (Entity*)tractorTab->get_element(j);
	/*
	  if(pTractor->IsInstanceOf(UNE_SS_CLASSE)
	  &&
	  pPlot-GetIntConstValue(ALLEY_WIDTH) < 180)
	  continue;
	*/
	for(int k= 0;k<nbTracted;k++) {
	  Entity* pTracted = (Entity*)tractedTab->get_element(k);
		Entity* pAggrRsc = new FertilizationResourceSet();
		pAggrRsc->AddElement(pTractor);
		pAggrRsc->AddElement(pTracted);
		pAggrRsc->SetIntConstValue(IS_PERMANENT, FALSE);  // + JPR 110225
//printf("\nclippingResourceEntitySpec_ELI new {'%s' '%s'}", pTractor->InstanceName(), pTracted->InstanceName()); 
		result->push_back(pAggrRsc);
	}
  }
  delete  tractorTab;
  delete  tractedTab;
  
  return result;
};
  
pEntityTab* fertilizationResourceEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pOt = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  if(ooList->size() < 1) {
	printf("\n!!! Pas de parcelle trouv�e dans fertilizationResourceEntitySpec_ELI operation : '%s'", pOt->InstanceName());
	exit(0);
  }
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nfertilizationResourceEntitySpec_ELI pPlot  : '%s'\n", pPlot->InstanceName());

  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT); 
  // FERTILIZATION_RESOURCE_SET
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);

  Entity* pVineyard = pPlot->GetSuperSet();
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  //Entity* pWorkerPool = pRscPool->GetElement(0); // cf. App_ResourceSettings
  Entity* pEquipmentPool = pRscPool->GetElement(1);
  pEntityTab tmp;
  //------------------------------------------------------------
  pEntityTab* tractorTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TRACTOR);
  tractorTab->push_back(tmp);
  int nbTractor = tractorTab->size();
//printf("\nfertilizationResourceEntitySpec_ELI tractorTab : ");tractorTab->display_names();
  //------------------------------------------------------------
  pEntityTab* tractedTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(SPREADER);
  tractedTab->push_back(tmp);
  int nbTracted = tractedTab->size();
//printf("\nfertilizationResourceEntitySpec_ELI tractedTab : ");tractedTab->display_names();
  //------------------------------------------------------------
  for(int j= 0;j<nbTractor;j++) {
	Entity* pTractor = (Entity*)tractorTab->get_element(j);
	/*
	  if(pTractor->IsInstanceOf(UNE_SS_CLASSE)
	  &&
	  pPlot-GetIntConstValue(ALLEY_WIDTH) < 180)
	  continue;
	*/
	for(int k= 0;k<nbTracted;k++) {
	  Entity* pTracted = (Entity*)tractedTab->get_element(k);
		Entity* pAggrRsc = new FertilizationResourceSet();
		pAggrRsc->AddElement(pTractor);
		pAggrRsc->AddElement(pTracted);
		pAggrRsc->SetIntConstValue(IS_PERMANENT, FALSE);  // + JPR 110225
//printf("\nfertilizationResourceEntitySpec_ELI new {'%s' '%s'}", pTractor->InstanceName(), pTracted->InstanceName()); 
		result->push_back(pAggrRsc);
	}
  }
  delete  tractorTab;
  delete  tractedTab;

  return result;
};
  
pEntityTab* greenWorkExecutorEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pVineyard = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT);
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);
  //
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  Entity* pWorkerPool = pRscPool->GetElement(0); // convention App_ResourceSettings
  pEntityTab tmp;  

  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_VEGETATION_GROWER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(NON_PERMANENT_MANUAL_FARM_WORKER);
  result->push_back(tmp);

  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_MULTI_TASK_MANUAL_WORKER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_TILLAGE_ORIENTED_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_ALL_TASK_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_PREFERENTIAL_TRACTOR_DRIVER);
  result->push_back(tmp);

//printf("\ngreenWorkExecutorEntitySpec_ELI result : ");result->display_names();

  return result;
};
  
pEntityTab* grinderShootThinningResourceEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pOt = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  if(ooList->size() < 1) {
	printf("\n!!! Pas de parcelle trouv�e dans grinderShootThinningResourceEntitySpec_ELI operation : '%s'", pOt->InstanceName());
	exit(0);
  }
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\ngrinderShootThinningResourceEntitySpec_ELI pPlot  : '%s'\n", pPlot->InstanceName());

  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT); 
  // GRINDER_SHOOT_THINNING_RESOURCE_SET
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);

  Entity* pVineyard = pPlot->GetSuperSet();
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  //Entity* pWorkerPool = pRscPool->GetElement(0); // cf. App_ResourceSettings
  Entity* pEquipmentPool = pRscPool->GetElement(1);
  pEntityTab tmp;
  //------------------------------------------------------------
  pEntityTab* tractorTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TRACTOR);
  tractorTab->push_back(tmp);
  int nbTractor = tractorTab->size();
//printf("\ngrinderShootThinningResourceEntitySpec_ELI tractorTab : ");tractorTab->display_names();
  //------------------------------------------------------------
  pEntityTab* tractedTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(GRINDER);
  tractedTab->push_back(tmp);
  int nbTracted = tractedTab->size();
//printf("\ngrinderShootThinningResourceEntitySpec_ELI tractedTab : ");tractedTab->display_names();
  //------------------------------------------------------------
  for(int j= 0;j<nbTractor;j++) {
	Entity* pTractor = (Entity*)tractorTab->get_element(j);
	/*
	  if(pTractor->IsInstanceOf(UNE_SS_CLASSE)
	  &&
	  pPlot-GetIntConstValue(ALLEY_WIDTH) < 180)
	  continue;
	*/
	for(int k= 0;k<nbTracted;k++) {
	  Entity* pTracted = (Entity*)tractedTab->get_element(k);
		Entity* pAggrRsc = new GrinderShootThinningResourceSet();
		pAggrRsc->AddElement(pTractor);
		pAggrRsc->AddElement(pTracted);
		pAggrRsc->SetIntConstValue(IS_PERMANENT, FALSE);  // + JPR 110225
//printf("\ngrinderShootThinningResourceEntitySpec_ELI new {'%s' '%s'}", pTractor->InstanceName(), pTracted->InstanceName()); 
		result->push_back(pAggrRsc);
	}
  }
  delete  tractorTab;
  delete  tractedTab;
  return result;
};
  
pEntityTab* handHeldGunSprayingResourceEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pOt = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  if(ooList->size() < 1) {
	printf("\n!!! Pas de parcelle trouvee dans handHeldGunSprayingResourceEntitySpec_ELI operation : '%s'", pOt->InstanceName());
	exit(0);
  }
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nhandHeldGunSprayingResourceEntitySpec_ELI pPlot  : '%s'\n", pPlot->InstanceName());

  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT); 
  // HAND_HELD_GUN_SPRAYING_RESOURCE_SET
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);

  Entity* pVineyard = pPlot->GetSuperSet();
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  //Entity* pWorkerPool = pRscPool->GetElement(0); // cf. App_ResourceSettings
  Entity* pEquipmentPool = pRscPool->GetElement(1);
  pEntityTab tmp;
  //------------------------------------------------------------
  pEntityTab* tractorTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TRACTOR);
  tractorTab->push_back(tmp);
  int nbTractor = tractorTab->size();
//printf("\nhandHeldGunSprayingResourceEntitySpec_ELI tractorTab : ");tractorTab->display_names();
  //------------------------------------------------------------
  pEntityTab* tankTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TANK);
  tankTab->push_back(tmp);
  int nbTank = tankTab->size();
//printf("\nhandHeldGunSprayingResourceEntitySpec_ELI tractedTab : ");tankTab->display_names();
  //------------------------------------------------------------
  pEntityTab* sprayerTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(HAND_HELD_SPRAY_GUN);
  sprayerTab->push_back(tmp);
  int nbSprayer = sprayerTab->size();
//printf("\nhandHeldGunSprayingResourceEntitySpec_ELI tractedTab : ");sprayerTab->display_names();
  //------------------------------------------------------------
  for(int j= 0;j<nbTractor;j++) {
	Entity* pTractor = (Entity*)tractorTab->get_element(j);
	/*
	  if(pTractor->IsInstanceOf(UNE_SS_CLASSE)
	  &&
	  pPlot-GetIntConstValue(ALLEY_WIDTH) < 180)
	  continue;
	*/
	for(int k= 0;k<nbTank;k++) {
	  Entity* pTank = (Entity*)tankTab->get_element(k);
	  for(int k= 0;k<nbSprayer;k++) {
	    Entity* pSprayer = (Entity*)sprayerTab->get_element(k);
		  Entity* pAggrRsc = new HandHeldGunSprayingResourceSet();
		  pAggrRsc->AddElement(pTractor);
		  pAggrRsc->AddElement(pTank);
		  pAggrRsc->AddElement(pSprayer);
		  pAggrRsc->SetIntConstValue(IS_PERMANENT, FALSE);  // + JPR 110225
//printf("\nhandHeldGunSprayingResourceEntitySpec_ELI new {'%s' '%s' '%s'}", pTractor->InstanceName(), pTank->InstanceName(), pSprayer->InstanceName()); 
		result->push_back(pAggrRsc);
	}
      }
  }
  delete  tractorTab;
  delete  tankTab;
  delete  sprayerTab;

  return result;
};
  
pEntityTab* horizontalRailSprayingResourceEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pOt = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  if(ooList->size() < 1) {
	printf("\n!!! Pas de parcelle trouvee dans horizontalRailSprayingResourceEntitySpec_ELI operation : '%s'", pOt->InstanceName());
	exit(0);
  }
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nhorizontalRailSprayingResourceEntitySpec_ELI pPlot  : '%s'\n", pPlot->InstanceName());

  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT); 
  // HORIZONTAL_RAIL_SPRAYING_RESOURCE_SET
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);

  Entity* pVineyard = pPlot->GetSuperSet();
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  //Entity* pWorkerPool = pRscPool->GetElement(0); // cf. App_ResourceSettings
  Entity* pEquipmentPool = pRscPool->GetElement(1);
  pEntityTab tmp;
  //------------------------------------------------------------
  pEntityTab* tractorTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TRACTOR);
  tractorTab->push_back(tmp);
  int nbTractor = tractorTab->size();
//printf("\nhorizontalRailSprayingResourceEntitySpec_ELI tractorTab : ");tractorTab->display_names();
  //------------------------------------------------------------
  pEntityTab* tankTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TANK);
  tankTab->push_back(tmp);
  int nbTank = tankTab->size();
//printf("\nhorizontalRailSprayingResourceEntitySpec_ELI tractedTab : ");tankTab->display_names();
  //------------------------------------------------------------
  pEntityTab* sprayerTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(HORIZONTAL_RAIL_SPRAYER);
  sprayerTab->push_back(tmp);
  int nbSprayer = sprayerTab->size();
//printf("\nhorizontalRailSprayingResourceEntitySpec_ELI tractedTab : ");sprayerTab->display_names();
  //------------------------------------------------------------
  for(int j= 0;j<nbTractor;j++) {
	Entity* pTractor = (Entity*)tractorTab->get_element(j);
	/*
	  if(pTractor->IsInstanceOf(UNE_SS_CLASSE)
	  &&
	  pPlot-GetIntConstValue(ALLEY_WIDTH) < 180)
	  continue;
	*/
	for(int k= 0;k<nbTank;k++) {
	  Entity* pTank = (Entity*)tankTab->get_element(k);
	  for(int k= 0;k<nbSprayer;k++) {
	    Entity* pSprayer = (Entity*)sprayerTab->get_element(k);
		  Entity* pAggrRsc = new HorizontalRailSprayingResourceSet();
		  pAggrRsc->AddElement(pTractor);
		  pAggrRsc->AddElement(pTank);
		  pAggrRsc->AddElement(pSprayer);
		  pAggrRsc->SetIntConstValue(IS_PERMANENT, FALSE);  // + JPR 110225
//printf("\nhorizontalRailSprayingResourceEntitySpec_ELI new {'%s' '%s' '%s'}", pTractor->InstanceName(), pTank->InstanceName(), pSprayer->InstanceName()); 
		result->push_back(pAggrRsc);
	}
      }
  }
  delete  tractorTab;
  delete  tankTab;
  delete  sprayerTab;

  return result;
};
  
pEntityTab* manualWorkerEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pVineyard = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT);
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);
  //
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  Entity* pWorkerPool = pRscPool->GetElement(0); // convention App_ResourceSettings
  pEntityTab tmp;  

  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_MULTI_TASK_MANUAL_WORKER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_TILLAGE_ORIENTED_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_ALL_TASK_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_PREFERENTIAL_TRACTOR_DRIVER);
  result->push_back(tmp);

//printf("\nmanualWorkerEntitySpec_ELI result : ");result->display_names();

  return result;
};
  
pEntityTab* pruningExecutorEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pVineyard = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT);
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);
  //
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  Entity* pWorkerPool = pRscPool->GetElement(0); // convention App_ResourceSettings
  pEntityTab tmp;  

  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_PRUNER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(NON_PERMANENT_MANUAL_FARM_WORKER);
  result->push_back(tmp);

  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_MULTI_TASK_MANUAL_WORKER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_TILLAGE_ORIENTED_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_ALL_TASK_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_PREFERENTIAL_TRACTOR_DRIVER);
  result->push_back(tmp);

//printf("\npruningExecutorEntitySpec_ELI result : ");result->display_names();

  return result;
};
  
pEntityTab* rotaryTillageResourceEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pOt = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  if(ooList->size() < 1) {
	printf("\n!!! Pas de parcelle trouv�e dans rotaryTillageResourceEntitySpec_ELI operation : '%s'", pOt->InstanceName());
	exit(0);
  }
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nrotaryTillageResourceEntitySpec_ELI pPlot  : '%s'\n", pPlot->InstanceName());

  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT); 
  // ROTARY_TILLAGE_RESOURCE_SET
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);

  Entity* pVineyard = pPlot->GetSuperSet();
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  //Entity* pWorkerPool = pRscPool->GetElement(0); // cf. App_ResourceSettings
  Entity* pEquipmentPool = pRscPool->GetElement(1);
  pEntityTab tmp;
  //------------------------------------------------------------
  pEntityTab* tractorTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TRACTOR);
  tractorTab->push_back(tmp);
  int nbTractor = tractorTab->size();
//printf("\nrotaryTillageResourceEntitySpec_ELI tractorTab : ");tractorTab->display_names();
  //------------------------------------------------------------
  pEntityTab* tractedTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(ROTARY_CULTIVATOR);
  tractedTab->push_back(tmp);
  int nbTracted = tractedTab->size();
//printf("\nrotaryTillageResourceEntitySpec_ELI tractedTab : ");tractedTab->display_names();
  //------------------------------------------------------------
  for(int j= 0;j<nbTractor;j++) {
	Entity* pTractor = (Entity*)tractorTab->get_element(j);
	/*
	  if(pTractor->IsInstanceOf(UNE_SS_CLASSE)
	  &&
	  pPlot-GetIntConstValue(ALLEY_WIDTH) < 180)
	  continue;
	*/
	for(int k= 0;k<nbTracted;k++) {
	  Entity* pTracted = (Entity*)tractedTab->get_element(k);
		Entity* pAggrRsc = new RotaryTillageResourceSet();
		pAggrRsc->AddElement(pTractor);
		pAggrRsc->AddElement(pTracted);
		pAggrRsc->SetIntConstValue(IS_PERMANENT, FALSE);  // + JPR 110225
//printf("\nrotaryTillageResourceEntitySpec_ELI new {'%s' '%s'}", pTractor->InstanceName(), pTracted->InstanceName()); 
		result->push_back(pAggrRsc);
	}
  }
  delete  tractorTab;
  delete  tractedTab;

  return result;
};
  
pEntityTab* springTineTillageResourceEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pOt = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  if(ooList->size() < 1) {
	printf("\n!!! Pas de parcelle trouv�e dans springTineTillageResourceEntitySpec_ELI operation : '%s'", pOt->InstanceName());
	exit(0);
  }
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nspringTineTillageResourceEntitySpec_ELI pPlot  : '%s'\n", pPlot->InstanceName());

  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT); 
  // SPRING_TINE_TILLAGE_RESOURCE_SET
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);

  Entity* pVineyard = pPlot->GetSuperSet();
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  //Entity* pWorkerPool = pRscPool->GetElement(0); // cf. App_ResourceSettings
  Entity* pEquipmentPool = pRscPool->GetElement(1);
  pEntityTab tmp;
  //------------------------------------------------------------
  pEntityTab* tractorTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TRACTOR);
  tractorTab->push_back(tmp);
  int nbTractor = tractorTab->size();
//printf("\nspringTineTillageResourceEntitySpec_ELI tractorTab : ");tractorTab->display_names();
  //------------------------------------------------------------
  pEntityTab* tractedTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(SPRING_TINE_CULTIVATOR);
  tractedTab->push_back(tmp);
  int nbTracted = tractedTab->size();
//printf("\nspringTineTillageResourceEntitySpec_ELI tractedTab : ");tractedTab->display_names();
  //------------------------------------------------------------
  for(int j= 0;j<nbTractor;j++) {
	Entity* pTractor = (Entity*)tractorTab->get_element(j);
	/*
	  if(pTractor->IsInstanceOf(UNE_SS_CLASSE)
	  &&
	  pPlot-GetIntConstValue(ALLEY_WIDTH) < 180)
	  continue;
	*/
	for(int k= 0;k<nbTracted;k++) {
	  Entity* pTracted = (Entity*)tractedTab->get_element(k);
		Entity* pAggrRsc = new SpringTineTillageResourceSet();
		pAggrRsc->AddElement(pTractor);
		pAggrRsc->AddElement(pTracted);
		pAggrRsc->SetIntConstValue(IS_PERMANENT, FALSE);  // + JPR 110225
//printf("\nrotaryTillageResourceEntitySpec_ELI new {'%s' '%s'}", pTractor->InstanceName(), pTracted->InstanceName()); 
		result->push_back(pAggrRsc);
	}
  }
  delete  tractorTab;
  delete  tractedTab;
  return result;
};
  
pEntityTab* tillageTractorDriverEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pVineyard = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT);
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);
  //
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  Entity* pWorkerPool = pRscPool->GetElement(0); // convention App_ResourceSettings
  pEntityTab tmp;
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_TILLAGE_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_TILLAGE_ORIENTED_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_PREFERENTIAL_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_ALL_TASK_TRACTOR_DRIVER);
  result->push_back(tmp);

//printf("\ntillageTractorDriverEntitySpec_ELI result : ");result->display_names();


  return result;
};
  
pEntityTab* tractorDriverEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pVineyard = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT);
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);
  //
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  Entity* pWorkerPool = pRscPool->GetElement(0); // convention App_ResourceSettings
  pEntityTab tmp;
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_ALL_TASK_TRACTOR_DRIVER);
  result->push_back(tmp);
  tmp = pWorkerPool->GetDepthElementTab(PERMANENT_PREFERENTIAL_TRACTOR_DRIVER);
  result->push_back(tmp);

//printf("\ntractorDriverEntitySpec_ELI result : ");result->display_names();

  return result;
};
  
pEntityTab* verticalRailSprayingResourceEntitySpec_entityListInstantiator_Body(EntitySpecMethod* pM)
//---------------------------------------------
// Construit une liste d'entites correspondant a la specification.
//---------------------------------------------
{
  EntitySpec* pES = pM->DescribedEntitySpec();
  pEntityTab* result = pES->GetExpansion();
  result->erase();
  Entity* pOt = pM->GetEntityArgValue(REFERENCEENTITY_ARGUMENT);
  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  if(ooList->size() < 1) {
	printf("\n!!! Pas de parcelle trouvee dans verticalRailSprayingResourceEntitySpec_ELI operation : '%s'", pOt->InstanceName());
	exit(0);
  }
  Entity* pPlot = (Entity*)ooList->get_element(0);
//printf("\nverticalRailSprayingResourceEntitySpec_ELI pPlot  : '%s'\n", pPlot->InstanceName());

  //UserClassId classId = pM->GetIntArgValue(CLASSID_ARGUMENT); 
  // VERTICAL_RAIL_SPRAYING_RESOURCE_SET
  //int size = pM->GetIntArgValue(LISTSIZE_ARGUMENT);

  Entity* pVineyard = pPlot->GetSuperSet();
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pRscPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  //Entity* pWorkerPool = pRscPool->GetElement(0); // cf. App_ResourceSettings
  Entity* pEquipmentPool = pRscPool->GetElement(1);
  pEntityTab tmp;
  //------------------------------------------------------------
  pEntityTab* tractorTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TRACTOR);
  tractorTab->push_back(tmp);
  int nbTractor = tractorTab->size();
//printf("\nverticalRailSprayingResourceEntitySpec_ELI tractorTab : ");tractorTab->display_names();
  //------------------------------------------------------------
  pEntityTab* tankTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(TANK);
  tankTab->push_back(tmp);
  int nbTank = tankTab->size();
//printf("\nverticalRailSprayingResourceEntitySpec_ELI tractedTab : ");tankTab->display_names();
  //------------------------------------------------------------
  pEntityTab* sprayerTab = new pEntityTab();
  tmp = pEquipmentPool->GetDepthElementTab(VERTICAL_RAIL_SPRAYER);
  sprayerTab->push_back(tmp);
  int nbSprayer = sprayerTab->size();
//printf("\nverticalRailSprayingResourceEntitySpec_ELI tractedTab : ");sprayerTab->display_names();
  //------------------------------------------------------------
  for(int j= 0;j<nbTractor;j++) {
	Entity* pTractor = (Entity*)tractorTab->get_element(j);
	/*
	  if(pTractor->IsInstanceOf(UNE_SS_CLASSE)
	  &&
	  pPlot-GetIntConstValue(ALLEY_WIDTH) < 180)
	  continue;
	*/
	for(int k= 0;k<nbTank;k++) {
	  Entity* pTank = (Entity*)tankTab->get_element(k);
	  for(int k= 0;k<nbSprayer;k++) {
	    Entity* pSprayer = (Entity*)sprayerTab->get_element(k);
		  Entity* pAggrRsc = new VerticalRailSprayingResourceSet();
		  pAggrRsc->AddElement(pTractor);
		  pAggrRsc->AddElement(pTank);
		  pAggrRsc->AddElement(pSprayer);
		  pAggrRsc->SetIntConstValue(IS_PERMANENT, FALSE);  // + JPR 110225
//printf("\nverticalRailSprayingResourceEntitySpec_ELI new {'%s' '%s' '%s'}", pTractor->InstanceName(), pTank->InstanceName(), pSprayer->InstanceName()); 
		result->push_back(pAggrRsc);
	}
      }
  }
  delete  tractorTab;
  delete  tankTab;
  delete  sprayerTab;

  return result;
};
  
