// ==============================================
// Fichier : UserResource.cc
// Type    : source C++
// 
// Description : constructeurs des classes des 'Resource'.
// ==============================================
  
#include "UserResource.h"
  
AirAssistedSprayingResourceSet::AirAssistedSprayingResourceSet() {
// =========================================================
// Une classe de Entity : 'AirAssistedSprayingResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(AIR_ASSISTED_SPRAYING_RESOURCE_SET);
  //SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ChemicalDebrancherSprayingResourceSet::ChemicalDebrancherSprayingResourceSet() {
// =========================================================
// Une classe de Entity : 'ChemicalDebrancherSprayingResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CHEMICAL_DEBRANCHER_SPRAYING_RESOURCE_SET);
  //SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ClippingResourceSet::ClippingResourceSet() {
// =========================================================
// Une classe de Entity : 'ClippingResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CLIPPING_RESOURCE_SET);
  //SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

FarmEquipment::FarmEquipment() {
// =========================================================
// Une classe de Entity : 'FarmEquipment'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FARM_EQUIPMENT);
  //SetParentClassId(SINGLE_TOOL); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new Width();                       AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

FarmWorker::FarmWorker() {
// =========================================================
// Une classe de Entity : 'FarmWorker'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FARM_WORKER);
  //SetParentClassId(SINGLE_WORKER); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new IsManager();                   AddConstantDescriptor(pD);
  pD = new AnnualEmploymentPlanAttribute();AddConstantDescriptor(pD);
  pD = new WorkingTimeYearlyUpperBound(); AddConstantDescriptor(pD);
  pD = new WorkingTimeDailyUpperBound();  AddConstantDescriptor(pD);
  pD = new WorkBeginningHour();           AddConstantDescriptor(pD);
  pD = new LastRainfallClock();           AddConstantDescriptor(pD);
  pD = new WorkingTimeYearlyLeft();       AddVariableDescriptor(pD);
  pD = new WorkingTimeDailyLeft();        AddVariableDescriptor(pD);
  pD = new WorkingTimeWeeklyLeft();       AddVariableDescriptor(pD);
  pD = new CumulativeRainfallFromWorkBeginning();AddVariableDescriptor(pD);
   TemporaryMonitor->AttachToDescriptor(this, WORKING_TIME_WEEKLY_LEFT);
   TemporaryMonitor->AttachToDescriptor(this, WORKING_TIME_DAILY_LEFT);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  // un descripteur par heritage : AvailabilityTimetableAttribute
  // qui pointe sur une instance de AvailabilityTimetable 
  // (affecte dans updateSeasonCurrentIndexProcess_execProcess_Body)

  // contraintes standard sur les heures de travail
  SetIntConstValue(WORKING_TIME_DAILY_UPPER_BOUND, gIntParam_standardWorkingTime_day_);
  SetIntConstValue(WORKING_TIME_YEARLY_UPPER_BOUND, gIntParam_standardWorkingTime_year_);

  // contrainte de disponibilite relative au cumul de pluie recue
  // depuis le debut de la journee de travail
  Entity* pCtr = new LowCumulativeRainSuffered();
  AddEntityValueElement(STATE_AVAILABILITY_ATTRIBUTE, pCtr);
};

FarmWorkerAvailabilityTimetable::FarmWorkerAvailabilityTimetable() {
// =========================================================
// Une classe de Entity : 'FarmWorkerAvailabilityTimetable'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FARM_WORKER_AVAILABILITY_TIMETABLE);
  //SetParentClassId(RECURRENT_AVAILABILITY_TIMETABLE); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new SeasonalEmploymentPlanAttribute();AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

FertilizationResourceSet::FertilizationResourceSet() {
// =========================================================
// Une classe de Entity : 'FertilizationResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FERTILIZATION_RESOURCE_SET);
  //SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Grinder::Grinder() {
// =========================================================
// Une classe de Entity : 'Grinder'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GRINDER);
  //SetParentClassId(FARM_EQUIPMENT); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

GrinderShootThinningResourceSet::GrinderShootThinningResourceSet() {
// =========================================================
// Une classe de Entity : 'GrinderShootThinningResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GRINDER_SHOOT_THINNING_RESOURCE_SET);
  //SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

HandHeldGunSprayingResourceSet::HandHeldGunSprayingResourceSet() {
// =========================================================
// Une classe de Entity : 'HandHeldGunSprayingResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(HAND_HELD_GUN_SPRAYING_RESOURCE_SET);
  //SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

HorizontalRailSprayingResourceSet::HorizontalRailSprayingResourceSet() {
// =========================================================
// Une classe de Entity : 'HorizontalRailSprayingResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(HORIZONTAL_RAIL_SPRAYING_RESOURCE_SET);
  //SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

bool lowCumulativeRainSuffered_stateRelatedPredicate_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// Doit renvoyer vrai si la contrainte est satisfaite.
// Celle-ci porte sur l'etat de la ressource a laquelle la contrainte est attachee.
// La ressource est la valeur de l'argument CANDIDATEENTITY_ARGUMENT.
//---------------------------------------------------------------------------
// Rsc attachee : FarmWorker (pMO)
// Cette contrainte est testee lors de chaque determination par le moteur
// de la disponibilite de la ressource. 
// Si ce predicat renvoie FALSE, la ressource est declaree indisponible.
//---------------------------------------------------------------------------
  //Entity* pMO = pM->GetEntityArgValue(CANDIDATEENTITY_ARGUMENT);
  Entity* pCtr = pM->DescribedEntity(); // JPR 120207 <- nouveau DIESE 5.8
  Entity* pMO = pCtr->GetEntityConstValue(DESCRIBED_RESOURCE);

  bool result = TRUE;

  bool critere1 = TRUE;
  // VRAI, sauf dans la situation d'indisponibilite :
  // - pMO a subi plus de X mm de pluie depuis le debut de la journee
  //   ET . on est le matin
  //      OU
  //      . on est l'apres-midi et la derniere pluie date de moins de 4 heures
  float cumulativeRainSuffered = 
	pMO->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_WORK_BEGINNING);
  float threshold = gRealParam_arretMainDOeuvre_seuilCumulPluieJour_;
//printf("\n'%s' lowCumulativeRainSuffered_SRP %f >? %f", pMO->InstanceName(), cumulativeRainSuffered, threshold);
  if(cumulativeRainSuffered > threshold ) {
	Entity* pEmploymentPlan = 
	  pMO->GetEntityConstValue(ANNUAL_EMPLOYMENT_PLAN_ATTRIBUTE);
	int currentIndex = 
	  pEmploymentPlan->GetIntVarValue(CURRENT_ELEMENT_INDEX);
	  Entity* pSeasonalPlan = pEmploymentPlan->GetElement(currentIndex);
	Entity* pRATT = pSeasonalPlan->GetEntityConstValue(TIMETABLE_ATTRIBUTE);
	currentIndex = pRATT->GetIntVarValue(CURRENT_ELEMENT_INDEX);
	Entity* pSlot = pRATT->GetElement(currentIndex);
//printf("\n'%s' lowCumulativeRainSuffered_SRP pSlot : '%s'", pMO->InstanceName(), pSlot->InstanceName());
	if(pSlot->IsInstanceOf(WEEK_DAY_MORNING)) {
	  critere1 = FALSE;
	}
	else {
	  int lastRainClock = pMO->GetIntConstValue(LAST_RAINFALL_CLOCK);
	  if((pCurrentSim->Clock() - lastRainClock) < 4)  // 4 heures
		critere1 = FALSE;	  
	}
  }
  bool critere2 = TRUE;
  if(critere1) {
	//
	// critere2 : si pluie > seuil dans les 6h precedentes
	// alors la ressource est declaree indisponible
	// ---------------------------------------------
	// Recuperation des stations meteo pour cette EA
	//
	pEntityTab* pWSList = GetEntityList(WEATHER_STATION);
	int nbWS = pWSList->size();
	for(int i=0;i<nbWS;i++) {
	  Entity* pWS_i = (Entity*)pWSList->get_nth(i);
	  char* pathName_i = pWS_i->GetStringConstValue(PATH_NAME_ATTRIBUTE);
	  float value_i =  // pluie des 6h precedentes, hormis l'heure en cours
		SumUpMemoryFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 6);
//printf("\n\t%s pluie[-1 -6] = %f", pWS_i->InstanceName(), value_i);
	  if(value_i > threshold) {
//printf("\n'%s' lowCumulativeRainSuffered_SRP critere2 FALSE", pMO->InstanceName());
		critere2 = FALSE;
	  }
	}
  }
  result = critere1 && critere2;

//printf("\n'%s' lowCumulativeRainSuffered_SRP returns %d", pMO->InstanceName(), result);
  return result;
};

LowCumulativeRainSuffered::LowCumulativeRainSuffered() {
// =========================================================
// Une classe de Entity : 'LowCumulativeRainSuffered'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(LOW_CUMULATIVE_RAIN_SUFFERED);
  //SetParentClassId(STATE_AVAILABILITY_CONSTRAINT); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(STATE_RELATED_PREDICATE, lowCumulativeRainSuffered_stateRelatedPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

NonPermanentFarmWorker::NonPermanentFarmWorker() {
// =========================================================
// Une classe de Entity : 'NonPermanentFarmWorker'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(NON_PERMANENT_FARM_WORKER);
  //SetParentClassId(FARM_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

NonPermanentManualFarmWorker::NonPermanentManualFarmWorker() {
// =========================================================
// Une classe de Entity : 'NonPermanentManualFarmWorker'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(NON_PERMANENT_MANUAL_FARM_WORKER);
  //SetParentClassId(NON_PERMANENT_FARM_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

NonPermanentTractorDriver::NonPermanentTractorDriver() {
// =========================================================
// Une classe de Entity : 'NonPermanentTractorDriver'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(NON_PERMANENT_TRACTOR_DRIVER);
  //SetParentClassId(NON_PERMANENT_FARM_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PermanentFarmWorker::PermanentFarmWorker() {
// =========================================================
// Une classe de Entity : 'PermanentFarmWorker'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_FARM_WORKER);
  //SetParentClassId(FARM_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  //printf("\nconstruction du PermanentFarmWorker '%s'", InstanceName());

  // 2 lignes ci-dessous transportees dans App_ResourceSettings
  // pour particulariser les programmes de travail
  //
  //Entity* pE = new PermanentFarmWorkerFiveDayTimetable();
  //((RecurrentAvailabilityTimetable*)pE)->AttachToResource(this);
};

PermanentFarmWorkerFiveDayTimetable::PermanentFarmWorkerFiveDayTimetable() {
// =========================================================
// Une classe de Entity : 'PermanentFarmWorkerFiveDayTimetable'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_FARM_WORKER_FIVE_DAY_TIMETABLE);
  //SetParentClassId(FARM_WORKER_AVAILABILITY_TIMETABLE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  Entity* pE;
  //
  // 5 jours de semaine
  //
  for(int k=1;k<6;k++) {
	pE = new WeekDayMorning();
	pE->SetIntConstValue(WEEK_DAY_NUMBER, k);  // LUN, ..., VEN
	AddElement(pE);
	pE = new WeekDayAfternoon();
	pE->SetIntConstValue(WEEK_DAY_NUMBER, k);
	AddElement(pE);
  }

//printf("creation '%s'", InstanceName());
};

PermanentFarmWorkerSevenDayTimetable::PermanentFarmWorkerSevenDayTimetable() {
// =========================================================
// Une classe de Entity : 'PermanentFarmWorkerSevenDayTimetable'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_FARM_WORKER_SEVEN_DAY_TIMETABLE);
  //SetParentClassId(FARM_WORKER_AVAILABILITY_TIMETABLE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  Entity* pE;
  //
  // 1 dimanche
  //
  pE = new WeekDayMorning();
  pE->SetIntConstValue(WEEK_DAY_NUMBER, 0);  // DIM
  AddElement(pE);
  pE = new WeekDayAfternoon();
  pE->SetIntConstValue(WEEK_DAY_NUMBER, 0);
  AddElement(pE);
  //
  // 5 jours de semaine
  //
  for(int k=1;k<6;k++) {
	pE = new WeekDayMorning();
	pE->SetIntConstValue(WEEK_DAY_NUMBER, k);  // LUN, ..., VEN
	AddElement(pE);
	pE = new WeekDayAfternoon();
	pE->SetIntConstValue(WEEK_DAY_NUMBER, k);
	AddElement(pE);
  }
  //
  // 1 samedi
  //
  pE = new WeekDayMorning();
  pE->SetIntConstValue(WEEK_DAY_NUMBER, 6);  // SAM
  AddElement(pE);
  pE = new WeekDayAfternoon();
  pE->SetIntConstValue(WEEK_DAY_NUMBER, 6);
  AddElement(pE);

//printf("creation '%s'", InstanceName());
};

PermanentFarmWorkerSixDayTimetable::PermanentFarmWorkerSixDayTimetable() {
// =========================================================
// Une classe de Entity : 'PermanentFarmWorkerSixDayTimetable'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_FARM_WORKER_SIX_DAY_TIMETABLE);
  //SetParentClassId(FARM_WORKER_AVAILABILITY_TIMETABLE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  Entity* pE;
  //
  // 5 jours de semaine
  //
  for(int k=1;k<6;k++) {
	pE = new WeekDayMorning();
	pE->SetIntConstValue(WEEK_DAY_NUMBER, k);  // LUN, ..., VEN
	AddElement(pE);
	pE = new WeekDayAfternoon();
	pE->SetIntConstValue(WEEK_DAY_NUMBER, k);
	AddElement(pE);
  }
  //
  // 1 samedi
  //
  pE = new WeekDayMorning();
  pE->SetIntConstValue(WEEK_DAY_NUMBER, 6);  // SAM
  AddElement(pE);
  pE = new WeekDayAfternoon();
  pE->SetIntConstValue(WEEK_DAY_NUMBER, 6);
  AddElement(pE);

//printf("creation '%s'", InstanceName());
};

PermanentManualFarmWorker::PermanentManualFarmWorker() {
// =========================================================
// Une classe de Entity : 'PermanentManualFarmWorker'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_MANUAL_FARM_WORKER);
  //SetParentClassId(PERMANENT_FARM_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PermanentMultiTaskManualWorker::PermanentMultiTaskManualWorker() {
// =========================================================
// Une classe de Entity : 'PermanentMultiTaskManualWorker'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_MULTI_TASK_MANUAL_WORKER);
  //SetParentClassId(PERMANENT_MANUAL_FARM_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PermanentMultiTaskWorker::PermanentMultiTaskWorker() {
// =========================================================
// Une classe de Entity : 'PermanentMultiTaskWorker'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_MULTI_TASK_WORKER);
  //SetParentClassId(PERMANENT_FARM_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PermanentPreferentialTractorDriver::PermanentPreferentialTractorDriver() {
// =========================================================
// Une classe de Entity : 'PermanentPreferentialTractorDriver'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_PREFERENTIAL_TRACTOR_DRIVER);
  //SetParentClassId(PERMANENT_MULTI_TASK_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PermanentPruner::PermanentPruner() {
// =========================================================
// Une classe de Entity : 'PermanentPruner'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_PRUNER);
  //SetParentClassId(PERMANENT_MANUAL_FARM_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PermanentTillageOrientedTractorDriver::PermanentTillageOrientedTractorDriver() {
// =========================================================
// Une classe de Entity : 'PermanentTillageOrientedTractorDriver'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_TILLAGE_ORIENTED_TRACTOR_DRIVER);
  //SetParentClassId(PERMANENT_MULTI_TASK_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PermanentTractorDriver::PermanentTractorDriver() {
// =========================================================
// Une classe de Entity : 'PermanentTractorDriver'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_TRACTOR_DRIVER);
  //SetParentClassId(PERMANENT_FARM_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PermanentVegetationGrower::PermanentVegetationGrower() {
// =========================================================
// Une classe de Entity : 'PermanentVegetationGrower'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_VEGETATION_GROWER);
  //SetParentClassId(PERMANENT_MANUAL_FARM_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PruningMachine::PruningMachine() {
// =========================================================
// Une classe de Entity : 'PruningMachine'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PRUNING_MACHINE);
  //SetParentClassId(FARM_EQUIPMENT); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Sprayer::Sprayer() {
// =========================================================
// Une classe de Entity : 'Sprayer'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SPRAYER);
  //SetParentClassId(FARM_EQUIPMENT); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Spreader::Spreader() {
// =========================================================
// Une classe de Entity : 'Spreader'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SPREADER);
  //SetParentClassId(FARM_EQUIPMENT); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Tank::Tank() {
// =========================================================
// Une classe de Entity : 'Tank'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(TANK);
  //SetParentClassId(FARM_EQUIPMENT); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

TillageResourceSet::TillageResourceSet() {
// =========================================================
// Une classe de Entity : 'TillageResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(TILLAGE_RESOURCE_SET);
  //SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  
};

TillageTool::TillageTool() {
// =========================================================
// Une classe de Entity : 'TillageTool'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(TILLAGE_TOOL);
  //SetParentClassId(FARM_EQUIPMENT); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Tractor::Tractor() {
// =========================================================
// Une classe de Entity : 'Tractor'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(TRACTOR);
  //SetParentClassId(FARM_EQUIPMENT); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

TrellisingMachine::TrellisingMachine() {
// =========================================================
// Une classe de Entity : 'TrellisingMachine'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(TRELLISING_MACHINE);
  //SetParentClassId(FARM_EQUIPMENT); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

VerticalRailSprayer::VerticalRailSprayer() {
// =========================================================
// Une classe de Entity : 'VerticalRailSprayer'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VERTICAL_RAIL_SPRAYER);
  //SetParentClassId(SPRAYER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

VerticalRailSprayingResourceSet::VerticalRailSprayingResourceSet() {
// =========================================================
// Une classe de Entity : 'VerticalRailSprayingResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VERTICAL_RAIL_SPRAYING_RESOURCE_SET);
  //SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

WeekDayPart::WeekDayPart() {
// =========================================================
// Une classe de Entity : 'WeekDayPart'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(WEEK_DAY_PART);
  //SetParentClassId(AVAILABILITY_TIME_SLOT); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new WeekDayNumber();               AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

AirAssistedSprayer::AirAssistedSprayer() {
// =========================================================
// Une classe de Entity : 'AirAssistedSprayer'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(AIR_ASSISTED_SPRAYER);
  //SetParentClassId(SPRAYER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

BackSprayer::BackSprayer() {
// =========================================================
// Une classe de Entity : 'BackSprayer'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(BACK_SPRAYER);
  //SetParentClassId(SPRAYER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Clipper::Clipper() {
// =========================================================
// Une classe de Entity : 'Clipper'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CLIPPER);
  //SetParentClassId(FARM_EQUIPMENT); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

CollectorPane::CollectorPane() {
// =========================================================
// Une classe de Entity : 'CollectorPane'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(COLLECTOR_PANE);
  //SetParentClassId(FARM_EQUIPMENT); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

DebranchingSprayer::DebranchingSprayer() {
// =========================================================
// Une classe de Entity : 'DebranchingSprayer'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(DEBRANCHING_SPRAYER);
  //SetParentClassId(SPRAYER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

HandHeldSprayGun::HandHeldSprayGun() {
// =========================================================
// Une classe de Entity : 'HandHeldSprayGun'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(HAND_HELD_SPRAY_GUN);
  //SetParentClassId(SPRAYER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

HorizontalRailSprayer::HorizontalRailSprayer() {
// =========================================================
// Une classe de Entity : 'HorizontalRailSprayer'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(HORIZONTAL_RAIL_SPRAYER);
  //SetParentClassId(SPRAYER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PermanentAllTaskTractorDriver::PermanentAllTaskTractorDriver() {
// =========================================================
// Une classe de Entity : 'PermanentAllTaskTractorDriver'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_ALL_TASK_TRACTOR_DRIVER);
  //SetParentClassId(PERMANENT_MULTI_TASK_WORKER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PermanentTillageTractorDriver::PermanentTillageTractorDriver() {
// =========================================================
// Une classe de Entity : 'PermanentTillageTractorDriver'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PERMANENT_TILLAGE_TRACTOR_DRIVER);
  //SetParentClassId(PERMANENT_TRACTOR_DRIVER); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

RotaryCultivator::RotaryCultivator() {
// =========================================================
// Une classe de Entity : 'RotaryCultivator'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ROTARY_CULTIVATOR);
  //SetParentClassId(TILLAGE_TOOL); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

RotaryTillageResourceSet::RotaryTillageResourceSet() {
// =========================================================
// Une classe de Entity : 'RotaryTillageResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ROTARY_TILLAGE_RESOURCE_SET);
  //SetParentClassId(TILLAGE_RESOURCE_SET); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

};

SpringTineCultivator::SpringTineCultivator() {
// =========================================================
// Une classe de Entity : 'SpringTineCultivator'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SPRING_TINE_CULTIVATOR);
  //SetParentClassId(TILLAGE_TOOL); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SpringTineTillageResourceSet::SpringTineTillageResourceSet() {
// =========================================================
// Une classe de Entity : 'SpringTineTillageResourceSet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SPRING_TINE_TILLAGE_RESOURCE_SET);
  //SetParentClassId(TILLAGE_RESOURCE_SET); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

};

int weekDayAfternoon_setThisTimeSlotBegValue_Body(EntityMethod* pM) {
//-------------------------------------------------------------------
// (commentaire �ventuel)
//-------------------------------------------------------------------
  AvailabilityTimeSlot* pTimeSlot 
	= (AvailabilityTimeSlot*)(pM->DescribedEntity());
  int result;

  int now = pCurrentSim->Clock();
  //
  // recuperation date de fin du TimeSlot WeekDayMorning
  //
  Entity* pTimetable = pTimeSlot->GetSuperSet();
  int timeSlotIndex = pTimetable->GetElementPosition(pTimeSlot);
  Entity* pPrevTimeSlot = pTimetable->GetElement(timeSlotIndex-1);
  int prevTimeSlotEndDate = pPrevTimeSlot->GetIntVarValue(END_DATE);
  tm* pTm = ClockValueToTm(prevTimeSlotEndDate);
  //
  // par convention CDIESE, 
  // la date de fin est la premiere posterieure au TimeSlot
  //
  Entity* pSeasonalPlan = 
	pTimetable->GetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE);
  //
  // determination si l'instant courant est dans un jour ferie ou de conge
  //
  Entity* pAnnualPlan = pSeasonalPlan->GetSuperSet();
  Entity* pCalendar = pAnnualPlan->GetEntityConstValue(OFF_WORK_CALENDAR_ATTRIBUTE);
  pCalendar->SetIntArgValue(IS_CLOCK_VALUE_IN_CALENDAR, CLOCK_ARGUMENT, now);
  bool isOff = pCalendar->ExecPredicate(IS_CLOCK_VALUE_IN_CALENDAR);
  float begHour;
  if(isOff) {
	//
	// jour ferie ou de conge -> l'intervalle de dispo est reduit a rien
	// -> date de debut = date de fin
	//
	begHour = pSeasonalPlan->GetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR);
	pTm->tm_hour = (int)floor(begHour);
  }
  else  {
	begHour = pSeasonalPlan->GetFloatConstValue(WORK_DAY_AFTERNOON_BEG_HOUR);
	pTm->tm_hour = (int)ceil(begHour);
  } 
  pTm->tm_isdst = -1;// 120704
  mktime(pTm);
  int thisTimeSlotBegDate = StructTmToClockValue(pTm);
  delete pTm;
  if(thisTimeSlotBegDate < 0)
    result = now;
  else
    result = thisTimeSlotBegDate;
		
//printf("\n'%s'_setThisTimeSlotBegValue returns %d", pTimeSlot->InstanceName(), result);
  return result;
};

int weekDayAfternoon_setThisTimeSlotEndValue_Body(EntityMethod* pM) {
//-------------------------------------------------------------------
// (commentaire �ventuel)
//-------------------------------------------------------------------
  AvailabilityTimeSlot* pTimeSlot 
	= (AvailabilityTimeSlot*)(pM->DescribedEntity());
  int result = -9;

  int now = pCurrentSim->Clock();
  //
  // recuperation date de debut de ce TimeSlot
  //
  int thisTimeSlotBegDate = pTimeSlot->GetIntVarValue(BEG_DATE);	
//printf("\nentree '%s'_set..EndValue this..BegDate = %d", pTimeSlot->InstanceName(), thisTimeSlotBegDate);

  if(thisTimeSlotBegDate >= 0) {
	tm* pTm = ClockValueToTm(thisTimeSlotBegDate);
	//
	// par convention CDIESE, 
	// la date de fin est la premiere posterieure au TimeSlot
	//
	Entity* pTimetable = pTimeSlot->GetSuperSet();
	Entity* pSeasonalPlan = 
	  pTimetable->GetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE);
	int toBeExtended = 
	  pSeasonalPlan->GetIntConstValue(CURRENT_SLOT_TO_BE_EXTENDED);
	float endHour;
	if(toBeExtended)
	  endHour = 
		pSeasonalPlan->GetFloatConstValue(WORK_DAY_AFTERNOON_EXTENDED_END_HOUR);
	else
	  endHour = 
		pSeasonalPlan->GetFloatConstValue(WORK_DAY_AFTERNOON_END_HOUR);
	pTm->tm_hour = (int)floor(endHour);
	pTm->tm_isdst = -1;// 120704
	mktime(pTm);
	int thisTimeSlotEndDate = StructTmToClockValue(pTm);
	delete pTm;
	if(thisTimeSlotEndDate < 0)
	  result = now;
	else
	  result = thisTimeSlotEndDate;
  }
		
//printf("\n'%s'_setThisTimeSlotEndValue returns %d", pTimeSlot->InstanceName(), result);
  return result;
};

WeekDayAfternoon::WeekDayAfternoon() {
// =========================================================
// Une classe de Entity : 'WeekDayAfternoon'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(WEEK_DAY_AFTERNOON);
  //SetParentClassId(WEEK_DAY_PART); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(SET_THIS_TIME_SLOT_BEG_VALUE, weekDayAfternoon_setThisTimeSlotBegValue_Body);
  AssignBody(SET_THIS_TIME_SLOT_END_VALUE, weekDayAfternoon_setThisTimeSlotEndValue_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

int weekDayMorning_setThisTimeSlotBegValue_Body(EntityMethod* pM) {
//-----------------------------------------------------------------
// (commentaire �ventuel)
//-----------------------------------------------------------------
  AvailabilityTimeSlot* pTimeSlot = (AvailabilityTimeSlot*)(pM->DescribedEntity());
  int result;

  int now = pCurrentSim->Clock();
  //
  // recuperation TimeSlot precedent
  //
  Entity* pTimetable = pTimeSlot->GetSuperSet();
  pEntityTab pElemTab = pTimetable->GetElementTab();
  int nbSlots = pElemTab.size();
  int thisSlotIndex = GetPosition(pElemTab, pTimeSlot);
  int prevSlotIndex = thisSlotIndex-1;
  if(thisSlotIndex == 0)
	prevSlotIndex = nbSlots-1;
  Entity* prevTimeSlot = (Entity*)pElemTab[prevSlotIndex];
  //
  // recuperation date de fin du TimeSlot precedent
  //
  int prevTimeSlotEndDate = prevTimeSlot->GetIntVarValue(END_DATE);
  tm* pTm;
  if(prevTimeSlotEndDate < 0) {
	//
	// JPR 121210 : dans le cas d'un début de simulation un jour non travaillé (e.g. samedi)
	// le prevTimeSlotEndDate est -9. Dans ce cas, lors du UpdateSituation du prochain jour
	// travaillé (e.g. lundi), le slot précédent ne doit pas être l'après-midi du vendredi,
	// mais l'après-midi de la veille. On crée donc un pTm marqué de la veille (avec le -24)
	// puis on établiera l'heure avec le switch général.
	//
	int unInstantDeLaVeille = now-24;
	if(unInstantDeLaVeille < 0) unInstantDeLaVeille = 0;
    pTm = ClockValueToTm(unInstantDeLaVeille);
  }
  else {
    pTm = ClockValueToTm(prevTimeSlotEndDate);
  }
  //
  // recuperation du jour dans la semaine et forcage du jour
  // modif JPR 121210 :
  //  cette écupération est identique dans les 2 cas if ... else ci-dessus
  int wday = pTm->tm_wday;
//printf("\nwday = %d", wday);
  int delay = -9; 
  switch (nbSlots) {
  case 10 : {       // semaine de 5 jours
	switch (wday) {
	case VEN : { delay = 3; break; }
	case SAM : { delay = 2; break; }
	default  : { delay = 1; break; }
	}
	break;
  }
  case 12 : {       // semaine de 6 jours
	switch (wday) {
	case SAM : { delay = 2; break; }
	default  : { delay = 1; break; }
	} 
	break;
  }
  case 14 : {       // semaine de 7 jours
	delay = 1;
	break;
  }
  }
  pTm->tm_mday = pTm->tm_mday + delay;

  //
  // forcage de l'heure (descripteur du SeasonalPlan)
  //
  Entity* pSeasonalPlan = 
	pTimetable->GetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE);;
  //
  // determination si l'instant courant est dans un jour ferie ou de conge
  //
  Entity* pAnnualPlan = pSeasonalPlan->GetSuperSet();
  Entity* pCalendar = pAnnualPlan->GetEntityConstValue(OFF_WORK_CALENDAR_ATTRIBUTE);
  pCalendar->SetIntArgValue(IS_CLOCK_VALUE_IN_CALENDAR, CLOCK_ARGUMENT, now);
  bool isOff = pCalendar->ExecPredicate(IS_CLOCK_VALUE_IN_CALENDAR);
  float begHour;
  if(isOff) {
	//
	// jour ferie ou de conge -> l'intervalle de dispo est reduit a rien
	// -> date de debut = date de fin
	//
	begHour = pSeasonalPlan->GetFloatConstValue(WORK_DAY_MORNING_END_HOUR);
	pTm->tm_hour = (int)floor(begHour);
  }
  else  {
	begHour = pSeasonalPlan->GetFloatConstValue(WORK_DAY_MORNING_BEG_HOUR);
	pTm->tm_hour = (int)ceil(begHour);
  }
  pTm->tm_isdst = -1;// 120704
  mktime(pTm);
  int thisTimeSlotBegDate = StructTmToClockValue(pTm);
  delete pTm;
  if(thisTimeSlotBegDate < 0)
    result = now;
  else
    result = thisTimeSlotBegDate;
	
//printf("\nweekDayMorning_setThisTimeSlotBegValue returns %d", result);
  return result;
};

int weekDayMorning_setThisTimeSlotEndValue_Body(EntityMethod* pM) {
//-----------------------------------------------------------------
// (commentaire �ventuel)
//-----------------------------------------------------------------
  AvailabilityTimeSlot* pTimeSlot 
	= (AvailabilityTimeSlot*)(pM->DescribedEntity());
  int result = -9;

  int now = pCurrentSim->Clock();
  //
  // recuperation date de debut de ce TimeSlot
  //
  int thisTimeSlotBegDate = pTimeSlot->GetIntVarValue(BEG_DATE);	
//printf("\nentree '%s'_set..EndValue this..BegDate = %d", pTimeSlot->InstanceName(), thisTimeSlotBegDate);

  if(thisTimeSlotBegDate >= 0) {
	tm* pTm = ClockValueToTm(thisTimeSlotBegDate);
	//
	// par convention CDIESE, 
	// la date de fin est la premiere posterieure au TimeSlot
	//
	Entity* pTimetable = pTimeSlot->GetSuperSet();
	Entity* pSeasonalPlan = 
	  pTimetable->GetEntityConstValue(SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE);
	int toBeExtended = 
	  pSeasonalPlan->GetIntConstValue(CURRENT_SLOT_TO_BE_EXTENDED);
	float endHour;
	if(toBeExtended)
	  endHour = 
		pSeasonalPlan->GetFloatConstValue(WORK_DAY_MORNING_EXTENDED_END_HOUR);
	else
	  endHour = 
		pSeasonalPlan->GetFloatConstValue(WORK_DAY_MORNING_END_HOUR);
	pTm->tm_hour = (int)floor(endHour);
	pTm->tm_isdst = -1;// 120704
	mktime(pTm);
	int thisTimeSlotEndDate = StructTmToClockValue(pTm);
	delete pTm;
	if(thisTimeSlotEndDate < 0)
	  result = now;
	else
	  result = thisTimeSlotEndDate;
  }
		
//printf("\n'%s'_setThisTimeSlotEndValue returns %d", pTimeSlot->InstanceName(), result);
  return result;
};

WeekDayMorning::WeekDayMorning() {
// =========================================================
// Une classe de Entity : 'WeekDayMorning'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(WEEK_DAY_MORNING);
  //SetParentClassId(WEEK_DAY_PART); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(SET_THIS_TIME_SLOT_BEG_VALUE, weekDayMorning_setThisTimeSlotBegValue_Body);
  AssignBody(SET_THIS_TIME_SLOT_END_VALUE, weekDayMorning_setThisTimeSlotEndValue_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

