// ==============================================
// Fichier : UserSpecification.cc
// Type    : source C++
// 
// Description : constructeurs des classes des 'Specification'.
// ==============================================
  
#include "UserSpecification.h"
  
AirAssistedSprayingOperationResourceSpec::AirAssistedSprayingOperationResourceSpec() {
// =========================================================
// Une classe de Entity : 'AirAssistedSprayingOperationResourceSpec'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(AIR_ASSISTED_SPRAYING_OPERATION_RESOURCE_SPEC);
  //SetParentClassId(OPERATION_RESOURCE_SPECIFICATION); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  SetIntConstValue(SELECTOR_FCT_ARG, 1);
  SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, AIR_ASSISTED_SPRAYING_RESOURCE_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  EntitySpec* pES = new AirAssistedSprayingResourceEntitySpec();
  SetEntitySpecConstValue(RESOURCE_ENTITY_SPEC_ATTRIBUTE, pES);
};

ChemicalDebrancherSprayingOperationResourceSpec::ChemicalDebrancherSprayingOperationResourceSpec() {
// =========================================================
// Une classe de Entity : 'ChemicalDebrancherSprayingOperationResourceSpec'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CHEMICAL_DEBRANCHER_SPRAYING_OPERATION_RESOURCE_SPEC);
  //SetParentClassId(OPERATION_RESOURCE_SPECIFICATION); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  SetIntConstValue(SELECTOR_FCT_ARG, 1);
  SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, CHEMICAL_DEBRANCHER_SPRAYING_RESOURCE_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  EntitySpec* pES = new ChemicalDebrancherSprayingResourceEntitySpec();
  SetEntitySpecConstValue(RESOURCE_ENTITY_SPEC_ATTRIBUTE, pES);
};

ClippingOperationResourceSpec::ClippingOperationResourceSpec() {
// =========================================================
// Une classe de Entity : 'ClippingOperationResourceSpec'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CLIPPING_OPERATION_RESOURCE_SPEC);
  //SetParentClassId(OPERATION_RESOURCE_SPECIFICATION); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  SetIntConstValue(SELECTOR_FCT_ARG, 1);
  SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, CLIPPING_RESOURCE_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  EntitySpec* pES = new ClippingResourceEntitySpec();
  SetEntitySpecConstValue(RESOURCE_ENTITY_SPEC_ATTRIBUTE, pES);
};

FertilizationOperationResourceSpec::FertilizationOperationResourceSpec() {
// =========================================================
// Une classe de Entity : 'FertilizationOperationResourceSpec'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FERTILIZATION_OPERATION_RESOURCE_SPEC);
  //SetParentClassId(OPERATION_RESOURCE_SPECIFICATION); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  SetIntConstValue(SELECTOR_FCT_ARG, 1);
  SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FERTILIZATION_RESOURCE_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  EntitySpec* pES = new FertilizationResourceEntitySpec();
  SetEntitySpecConstValue(RESOURCE_ENTITY_SPEC_ATTRIBUTE, pES);
};

GrinderShootThinningOperationResourceSpec::GrinderShootThinningOperationResourceSpec() {
// =========================================================
// Une classe de Entity : 'GrinderShootThinningOperationResourceSpec'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GRINDER_SHOOT_THINNING_OPERATION_RESOURCE_SPEC);
  //SetParentClassId(OPERATION_RESOURCE_SPECIFICATION); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  SetIntConstValue(SELECTOR_FCT_ARG, 1);
  SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, GRINDER_SHOOT_THINNING_RESOURCE_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  EntitySpec* pES = new GrinderShootThinningResourceEntitySpec();
  SetEntitySpecConstValue(RESOURCE_ENTITY_SPEC_ATTRIBUTE, pES);
};

HandHeldGunSprayingOperationResourceSpec::HandHeldGunSprayingOperationResourceSpec() {
// =========================================================
// Une classe de Entity : 'HandHeldGunSprayingOperationResourceSpec'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(HAND_HELD_GUN_SPRAYING_OPERATION_RESOURCE_SPEC);
  //SetParentClassId(OPERATION_RESOURCE_SPECIFICATION); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  SetIntConstValue(SELECTOR_FCT_ARG, 1);
  SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, HAND_HELD_GUN_SPRAYING_RESOURCE_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  EntitySpec* pES = new HandHeldGunSprayingResourceEntitySpec();
  SetEntitySpecConstValue(RESOURCE_ENTITY_SPEC_ATTRIBUTE, pES);
};

HorizontalRailSprayingOperationResourceSpec::HorizontalRailSprayingOperationResourceSpec() {
// =========================================================
// Une classe de Entity : 'HorizontalRailSprayingOperationResourceSpec'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(HORIZONTAL_RAIL_SPRAYING_OPERATION_RESOURCE_SPEC);
  //SetParentClassId(OPERATION_RESOURCE_SPECIFICATION); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  SetIntConstValue(SELECTOR_FCT_ARG, 1);
  SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, HORIZONTAL_RAIL_SPRAYING_RESOURCE_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  EntitySpec* pES = new HorizontalRailSprayingResourceEntitySpec();
  SetEntitySpecConstValue(RESOURCE_ENTITY_SPEC_ATTRIBUTE, pES);
};

RotaryTillageOperationResourceSpec::RotaryTillageOperationResourceSpec() {
// =========================================================
// Une classe de Entity : 'RotaryTillageOperationResourceSpec'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ROTARY_TILLAGE_OPERATION_RESOURCE_SPEC);
  //SetParentClassId(OPERATION_RESOURCE_SPECIFICATION); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  SetIntConstValue(SELECTOR_FCT_ARG, 1);
  SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, ROTARY_TILLAGE_RESOURCE_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  EntitySpec* pES = new RotaryTillageResourceEntitySpec();
  SetEntitySpecConstValue(RESOURCE_ENTITY_SPEC_ATTRIBUTE, pES);
};

SpringTineTillageOperationResourceSpec::SpringTineTillageOperationResourceSpec() {
// =========================================================
// Une classe de Entity : 'SpringTineTillageOperationResourceSpec'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SPRING_TINE_TILLAGE_OPERATION_RESOURCE_SPEC);
  //SetParentClassId(OPERATION_RESOURCE_SPECIFICATION); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  SetIntConstValue(SELECTOR_FCT_ARG, 1);
  SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, SPRING_TINE_TILLAGE_RESOURCE_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  EntitySpec* pES = new SpringTineTillageResourceEntitySpec();
  SetEntitySpecConstValue(RESOURCE_ENTITY_SPEC_ATTRIBUTE, pES);
};

VerticalRailSprayingOperationResourceSpec::VerticalRailSprayingOperationResourceSpec() {
// =========================================================
// Une classe de Entity : 'VerticalRailSprayingOperationResourceSpec'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VERTICAL_RAIL_SPRAYING_OPERATION_RESOURCE_SPEC);
  //SetParentClassId(OPERATION_RESOURCE_SPECIFICATION); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  SetIntConstValue(SELECTOR_FCT_ARG, 1);
  SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, VERTICAL_RAIL_SPRAYING_RESOURCE_SET);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  EntitySpec* pES = new VerticalRailSprayingResourceEntitySpec();
  SetEntitySpecConstValue(RESOURCE_ENTITY_SPEC_ATTRIBUTE, pES);
};

