// ==============================================
// Fichier : UserVariableDescriptor.cc  
// Type    : source C++
// 
// Description : constructeurs des classes des 'VariableDescriptor'.
// ==============================================
  
#include "UserVariableDescriptor.h"
  

// ==============================================
// Une classe de Descriptor : 'CumulativeRainfallFromEarlyWinter'    (de sous-classe : 'FLOAT').
// ==============================================

CumulativeRainfallFromEarlyWinter::CumulativeRainfallFromEarlyWinter() {
	ClassName   ("cumulativeRainfallFromEarlyWinter");
	ClassComment   ("descripteur de Plot ; cumul depuis date parametree");
	ClassUnity   ("mm");
	ClassSymbol (CUMULATIVE_RAINFALL_FROM_EARLY_WINTER);
	SetDefaultValue(0.0);
	SetToDefaultValue(0.0);
};



// ==============================================
// Une classe de Descriptor : 'CumulativeRainfallFromEarlyWinterForInitst'    (de sous-classe : 'FLOAT').
// ==============================================

CumulativeRainfallFromEarlyWinterForInitst::CumulativeRainfallFromEarlyWinterForInitst() {
	ClassName   ("cumulativeRainfallFromEarlyWinterForInitst");
	ClassComment   ("descripteur de Plot ; cumul depuis date parametree");
	ClassUnity   ("mm");
	ClassSymbol (CUMULATIVE_RAINFALL_FROM_EARLY_WINTER_FOR_INITST);
	SetDefaultValue(0.0);
	SetToDefaultValue(0.0);
};



// ==============================================
// Une classe de Descriptor : 'CumulativeRainfallFromLastTillage'    (de sous-classe : 'FLOAT').
// ==============================================

CumulativeRainfallFromLastTillage::CumulativeRainfallFromLastTillage() {
	ClassName   ("cumulativeRainfallFromLastTillage");
	ClassComment   ("descripteur de Plot ; RAZ qd percentAchieved d'un Tillage passe a 1");
	ClassUnity   ("mm");
	ClassSymbol (CUMULATIVE_RAINFALL_FROM_LAST_TILLAGE);
	SetDefaultValue(0.0);
	SetToDefaultValue(0.0);
};



// ==============================================
// Une classe de Descriptor : 'CumulativeRainfallFromMhydasInteraction'    (de sous-classe : 'FLOAT').
// ==============================================

CumulativeRainfallFromMhydasInteraction::CumulativeRainfallFromMhydasInteraction() {
	ClassName   ("cumulativeRainfallFromMhydasInteraction");
	ClassComment   ("cumul de pluie depuis la derniere prise d'info Mhydas");
	ClassUnity   ("mm");
	ClassSymbol (CUMULATIVE_RAINFALL_FROM_MHYDAS_INTERACTION);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'CumulativeRainfallFromWorkBeginning'    (de sous-classe : 'FLOAT').
// ==============================================

CumulativeRainfallFromWorkBeginning::CumulativeRainfallFromWorkBeginning() {
	ClassName   ("cumulativeRainfallFromWorkBeginning");
	ClassComment   ("cumul de pluie depuis le premier travail dans le jour courant");
	ClassUnity   ("mm");
	ClassSymbol (CUMULATIVE_RAINFALL_FROM_WORK_BEGINNING);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'CurrentStageIndex'    (de sous-classe : 'INT').
// ==============================================

CurrentStageIndex::CurrentStageIndex() {
	ClassName   ("currentStageIndex");
	ClassComment   ("indice du stade courant dans le tableau des stades");
	ClassSymbol (CURRENT_STAGE_INDEX);
	SetDefaultValue(-9);
	SetToDefaultValue(-9);
};



// ==============================================
// Une classe de Descriptor : 'DayWhenAchieved'    (de sous-classe : 'INT').
// ==============================================

DayWhenAchieved::DayWhenAchieved() {
	ClassName   ("dayWhenAchieved");
	ClassComment   ("numero julien du jour auquel le stade est completement realise");
	ClassSymbol (DAY_WHEN_ACHIEVED);
	SetDefaultValue(-1);
};



// ==============================================
// Une classe de Descriptor : 'DaysNumber'    (de sous-classe : 'INT').
// ==============================================

DaysNumber::DaysNumber() {
	ClassName   ("daysNumber");
	ClassComment   ("age en nombre de jours julien");
	ClassSymbol (DAYS_NUMBER);
};



// ==============================================
// Une classe de Descriptor : 'DistributedActivitySetMemory'    (de sous-classe : 'ENTITY_TAB').
// ==============================================

DistributedActivitySetMemory::DistributedActivitySetMemory() {
	ClassName   ("distributedActivitySetMemory");
	ClassComment   ("container des DistributedActivitySetMemoryItem's des ARB's");
	ClassSymbol (DISTRIBUTED_ACTIVITY_SET_MEMORY);
};



// ==============================================
// Une classe de Descriptor : 'LaiForSenescence'    (de sous-classe : 'FLOAT').
// ==============================================

LaiForSenescence::LaiForSenescence() {
	ClassName   ("laiForSenescence");
	ClassComment   ("lai a partir duquel on calcule la senescence");
	ClassSymbol (LAI_FOR_SENESCENCE);
	SetDefaultValue(0.3);
	SetToDefaultValue(0.3);
};



// ==============================================
// Une classe de Descriptor : 'LeafAreaIndexResidual'    (de sous-classe : 'FLOAT').
// ==============================================

LeafAreaIndexResidual::LeafAreaIndexResidual() {
	ClassName   ("leafAreaIndexResidual");
	ClassComment   ("LAI apres tonte ou au depart");
	ClassSymbol (LEAF_AREA_INDEX_RESIDUAL);
	SetDefaultValue(0.3);
	SetToDefaultValue(0.3);
};



// ==============================================
// Une classe de Descriptor : 'NominalFloatQuantitySpeed'    (de sous-classe : 'FLOAT').
// ==============================================

NominalFloatQuantitySpeed::NominalFloatQuantitySpeed() {
	ClassName   ("nominalFloatQuantitySpeed");
	ClassComment   ("vitesse de reference (nominale) des operations motorisees");
	ClassUnity   ("km par heure");
	ClassSymbol (NOMINAL_FLOAT_QUANTITY_SPEED);
	SetDefaultValue(-9.);
	SetToDefaultValue(-9.);
};



// ==============================================
// Une classe de Descriptor : 'NominalIntQuantitySpeed'    (de sous-classe : 'INT').
// ==============================================

NominalIntQuantitySpeed::NominalIntQuantitySpeed() {
	ClassName   ("nominalIntQuantitySpeed");
	ClassComment   ("vitesse de reference (nominale) des operations manuelles");
	ClassUnity   ("nb souches par heure");
	ClassSymbol (NOMINAL_INT_QUANTITY_SPEED);
	SetDefaultValue(-9);
	SetToDefaultValue(-9);
};



// ==============================================
// Une classe de Descriptor : 'OperatedVineyardSubArea'    (de sous-classe : 'FLOAT').
// ==============================================

OperatedVineyardSubArea::OperatedVineyardSubArea() {
	ClassName   ("operatedVineyardSubArea");
	ClassComment   ("partie de la superficie de l'exploitation opérée pour le chantier décrit");
	ClassUnity   ("ha");
	ClassSymbol (OPERATED_VINEYARD_SUB_AREA);
};



// ==============================================
// Une classe de Descriptor : 'PercentAntiMildewTreated'    (de sous-classe : 'FLOAT').
// ==============================================

PercentAntiMildewTreated::PercentAntiMildewTreated() {
	ClassName   ("percentAntiMildewTreated");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_ANTI_MILDEW_TREATED);
};



// ==============================================
// Une classe de Descriptor : 'PercentAutumnTilled'    (de sous-classe : 'FLOAT').
// ==============================================

PercentAutumnTilled::PercentAutumnTilled() {
	ClassName   ("percentAutumnTilled");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_AUTUMN_TILLED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentClipped'    (de sous-classe : 'FLOAT').
// ==============================================

PercentClipped::PercentClipped() {
	ClassName   ("percentClipped");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_CLIPPED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentDebranched'    (de sous-classe : 'FLOAT').
// ==============================================

PercentDebranched::PercentDebranched() {
	ClassName   ("percentDebranched");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_DEBRANCHED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentExtraPhytoTreated'    (de sous-classe : 'FLOAT').
// ==============================================

PercentExtraPhytoTreated::PercentExtraPhytoTreated() {
	ClassName   ("percentExtraPhytoTreated");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_EXTRA_PHYTO_TREATED);
};



// ==============================================
// Une classe de Descriptor : 'PercentFertilized'    (de sous-classe : 'FLOAT').
// ==============================================

PercentFertilized::PercentFertilized() {
	ClassName   ("percentFertilized");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_FERTILIZED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentInitSpringTilled'    (de sous-classe : 'FLOAT').
// ==============================================

PercentInitSpringTilled::PercentInitSpringTilled() {
	ClassName   ("percentInitSpringTilled");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_INIT_SPRING_TILLED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentPlanted'    (de sous-classe : 'FLOAT').
// ==============================================

PercentPlanted::PercentPlanted() {
	ClassName   ("percentPlanted");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_PLANTED);
	SetDefaultValue(-1.);
	SetToDefaultValue(-1.);
};



// ==============================================
// Une classe de Descriptor : 'PercentPruned'    (de sous-classe : 'FLOAT').
// ==============================================

PercentPruned::PercentPruned() {
	ClassName   ("percentPruned");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_PRUNED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentRegularPhytoTreated'    (de sous-classe : 'FLOAT').
// ==============================================

PercentRegularPhytoTreated::PercentRegularPhytoTreated() {
	ClassName   ("percentRegularPhytoTreated");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_REGULAR_PHYTO_TREATED);
};



// ==============================================
// Une classe de Descriptor : 'PercentShootThinned'    (de sous-classe : 'FLOAT').
// ==============================================

PercentShootThinned::PercentShootThinned() {
	ClassName   ("percentShootThinned");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_SHOOT_THINNED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentSpringTilled'    (de sous-classe : 'FLOAT').
// ==============================================

PercentSpringTilled::PercentSpringTilled() {
	ClassName   ("percentSpringTilled");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_SPRING_TILLED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentSpringWeeded'    (de sous-classe : 'FLOAT').
// ==============================================

PercentSpringWeeded::PercentSpringWeeded() {
	ClassName   ("percentSpringWeeded");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_SPRING_WEEDED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentTrellised'    (de sous-classe : 'FLOAT').
// ==============================================

PercentTrellised::PercentTrellised() {
	ClassName   ("percentTrellised");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_TRELLISED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentWeeded'    (de sous-classe : 'FLOAT').
// ==============================================

PercentWeeded::PercentWeeded() {
	ClassName   ("percentWeeded");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_WEEDED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'PercentWinterTilled'    (de sous-classe : 'FLOAT').
// ==============================================

PercentWinterTilled::PercentWinterTilled() {
	ClassName   ("percentWinterTilled");
	ClassComment   ("-1. si sans objet ou dans [0. 1.]");
	ClassSymbol (PERCENT_WINTER_TILLED);
	SetDefaultValue(0.);
	SetToDefaultValue(0.);
};



// ==============================================
// Une classe de Descriptor : 'Rainfall'    (de sous-classe : 'FLOAT').
// ==============================================

Rainfall::Rainfall() {
	ClassName   ("rainfall");
	ClassComment   ("quantite de precipitation tombee dans le pas du processus de lecture meteo");
	ClassUnity   ("mm");
	ClassSymbol (RAINFALL);
};



// ==============================================
// Une classe de Descriptor : 'ReplicationInDryPeriodCounter'    (de sous-classe : 'INT').
// ==============================================

ReplicationInDryPeriodCounter::ReplicationInDryPeriodCounter() {
	ClassName   ("replicationInDryPeriodCounter");
	ClassComment   ("descripteur de SpringTillageIteration");
	ClassSymbol (REPLICATION_IN_DRY_PERIOD_COUNTER);
	SetDefaultValue(0);
	SetToDefaultValue(0);
};



// ==============================================
// Une classe de Descriptor : 'Temperature'    (de sous-classe : 'FLOAT').
// ==============================================

Temperature::Temperature() {
	ClassName   ("temperature");
	ClassComment   ("temperature moyenne de l'air pendant le pas du processus de lecture meteo");
	ClassSymbol (TEMPERATURE);
};



// ==============================================
// Une classe de Descriptor : 'ThermalTimeFromBbk'    (de sous-classe : 'FLOAT').
// ==============================================

ThermalTimeFromBbk::ThermalTimeFromBbk() {
	ClassName   ("thermalTimeFromBbk");
	ClassSymbol (THERMAL_TIME_FROM_BBK);
};



// ==============================================
// Une classe de Descriptor : 'ThermalTimeFromEmergence'    (de sous-classe : 'FLOAT').
// ==============================================

ThermalTimeFromEmergence::ThermalTimeFromEmergence() {
	ClassName   ("thermalTimeFromEmergence");
	ClassComment   ("age en degres.jour depuis la levee");
	ClassUnity   ("degres.jour");
	ClassSymbol (THERMAL_TIME_FROM_EMERGENCE);
};



// ==============================================
// Une classe de Descriptor : 'ThermalTimeFromSowing'    (de sous-classe : 'FLOAT').
// ==============================================

ThermalTimeFromSowing::ThermalTimeFromSowing() {
	ClassName   ("thermalTimeFromSowing");
	ClassComment   ("age en degres.jour depuis le semis");
	ClassUnity   ("�C");
	ClassSymbol (THERMAL_TIME_FROM_SOWING);
};



// ==============================================
// Une classe de Descriptor : 'ThermalTimeWhenAchieved'    (de sous-classe : 'FLOAT').
// ==============================================

ThermalTimeWhenAchieved::ThermalTimeWhenAchieved() {
	ClassName   ("thermalTimeWhenAchieved");
	ClassComment   ("degres.jour accumules depuis le semis quand le stade est atteint");
	ClassUnity   ("�C");
	ClassSymbol (THERMAL_TIME_WHEN_ACHIEVED);
};



// ==============================================
// Une classe de Descriptor : 'WorkingTimeDailyLeft'    (de sous-classe : 'INT').
// ==============================================

WorkingTimeDailyLeft::WorkingTimeDailyLeft() {
	ClassName   ("workingTimeDailyLeft");
	ClassComment   ("nb d'heures de travail restant pour le jour en cours");
	ClassSymbol (WORKING_TIME_DAILY_LEFT);
	SetDefaultValue(-9);
	SetToDefaultValue(-9);
};



// ==============================================
// Une classe de Descriptor : 'WorkingTimeWeeklyLeft'    (de sous-classe : 'INT').
// ==============================================

WorkingTimeWeeklyLeft::WorkingTimeWeeklyLeft() {
	ClassName   ("workingTimeWeeklyLeft");
	ClassComment   ("nb d'heures de travail restant pour la semaine en cours");
	ClassSymbol (WORKING_TIME_WEEKLY_LEFT);
	SetDefaultValue(-9);
	SetToDefaultValue(-9);
};



// ==============================================
// Une classe de Descriptor : 'WorkingTimeYearlyLeft'    (de sous-classe : 'INT').
// ==============================================

WorkingTimeYearlyLeft::WorkingTimeYearlyLeft() {
	ClassName   ("workingTimeYearlyLeft");
	ClassComment   ("nb d'heures de travail restant pour l'annee en cours");
	ClassSymbol (WORKING_TIME_YEARLY_LEFT);
	SetDefaultValue(-9);
	SetToDefaultValue(-9);
};



// ==============================================
// Une classe de Descriptor : 'YearWhenAchieved'    (de sous-classe : 'INT').
// ==============================================

YearWhenAchieved::YearWhenAchieved() {
	ClassName   ("yearWhenAchieved");
	ClassComment   ("millesime auquel le stade est completement realise");
	ClassSymbol (YEAR_WHEN_ACHIEVED);
};


