// ==============================================
// Fichier : UserActivity.cc
// Type    : source C++
// 
// Description : constructeurs des classes des 'Activity'.
// ==============================================
  
#include "UserActivity.h"
  
ConcurrentDistributedActivitySet::ConcurrentDistributedActivitySet() {
// =========================================================
// Une classe de Entity : 'ConcurrentDistributedActivitySet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
  //SetParentClassId(ACTIVITY_CONJUNCTION); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new TerminatedPlotsAttribute();    AddConstantDescriptor(pD);
  pD = new SkippedPlotsAttribute();       AddConstantDescriptor(pD);
  pD = new NeedForNextFavourableDays();   AddConstantDescriptor(pD);
  pD = new ActualRealizationBegDate();    AddConstantDescriptor(pD);
  pD = new ActualRealizationEndDate();    AddConstantDescriptor(pD);
  pD = new ActivityNominalDate();         AddConstantDescriptor(pD);
  pD = new AllocationPriorityDegree();    AddConstantDescriptor(pD);
  pD = new OperatedVineyardSubArea();     AddVariableDescriptor(pD);
   DistributedActivitySetEndDateMonitor->AttachToDescriptor(this, END_DATE);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentExtraPhytoTreatments::ConcurrentExtraPhytoTreatments() {
// =========================================================
// Une classe de Entity : 'ConcurrentExtraPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_EXTRA_PHYTO_TREATMENTS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new RegularPhytoTreatmentIndex();  AddConstantDescriptor(pD);
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentExtraPhytoTreatments::ConcurrentExtraPhytoTreatments(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'ConcurrentExtraPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_EXTRA_PHYTO_TREATMENTS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new RegularPhytoTreatmentIndex();  AddConstantDescriptor(pD);
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  AssignBody(OPENING_PREDICATE, Body_OP_PhytoTreatments);
  AssignBody(CLOSING_PREDICATE, Body_CP_ExtraPhytoTreatments);
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_ConcurrentExtraPhytoTreatments);
};

ConcurrentFertilizations::ConcurrentFertilizations() {
// =========================================================
// Une classe de Entity : 'ConcurrentFertilizations'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_FERTILIZATIONS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToFertilize();   AddMethod (pM);
  pM = new AddNewSituatedFertilizations();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentFertilizations::ConcurrentFertilizations(Vineyard* pEA, int season, int numPhase) {
// =========================================================
// Une classe de Entity : 'ConcurrentFertilizations'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_FERTILIZATIONS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToFertilize();   AddMethod (pM);
  pM = new AddNewSituatedFertilizations();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Fertilizations);

  //
  // predicat d'ouverture du chantier
  //
  int minBegDate;
  if(season == 1) {   // AUTUMN
	minBegDate = pCurrentSim->Clock();
	AssignBody(OPENING_PREDICATE, Body_OP_Fertilizations_OnDate);
  }
  else {              // not AUTUMN
	int jDay = App_GetIntDecisionOption(pEA, 
										OPT_SPRING_FERT_MIN_BEG_DATE);
	minBegDate = App_JulianDayToClockFromBegSim(jDay);
	jDay =  App_GetIntDecisionOption(pEA, 
									 OPT_SPRING_FERT_MAX_BEG_DATE);
	int maxBegDate = App_JulianDayToClockFromBegSim(jDay);
	SetIntVarValue(MAX_BEG_DATE, maxBegDate);
	
	int option = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_O_P);
	if((option == END_THIN)
	   ||
	   (option == END_THIN_CW))
	  AssignBody(OPENING_PREDICATE, Body_OP_Fertilizations_OnChain);
	else if((option == EARLY_FEB)
			||
			(option == EARLY_MAR))
	  AssignBody(OPENING_PREDICATE, Body_OP_Fertilizations_OnDate);
	else {
	  printf("\nDans construction '%s', option invalide hors automne : %d\n", InstanceName(), option);
	  exit(0);
	}
	  
  }
  SetIntVarValue(MIN_BEG_DATE, minBegDate);

  //
  // predicat de fermeture             du chantier
  //          d'ouverture au plus tard du chantier
  //
  switch (numPhase) {
  case 1 : {
	AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_Fertilizations_Phase1);
	AssignBody(CLOSING_PREDICATE, Body_CP_Phase1);
	break;
  }
  case 3 : {
	AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_Fertilizations_Phase3); 
	AssignBody(CLOSING_PREDICATE, Body_CP_Fertilizations_Phase3); 
	break;
  }
  default : {
	printf("\n!!! Construction d'un '%s' avec un numero de phase illegal : %d\n", InstanceName(), numPhase);
	exit(0);
  }
  }
};

ConcurrentInitSpringTillages::ConcurrentInitSpringTillages() {
// =========================================================
// Une classe de Entity : 'ConcurrentInitSpringTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_INIT_SPRING_TILLAGES);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToInitSpringTill();AddMethod (pM);
  pM = new AddNewSituatedInitSpringTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentInitSpringTillages::ConcurrentInitSpringTillages(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'ConcurrentInitSpringTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_INIT_SPRING_TILLAGES);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToInitSpringTill();AddMethod (pM);
  pM = new AddNewSituatedInitSpringTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_InitSpringTillages); 

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_InitSpringTillages); 

  AssignBody(CLOSING_PREDICATE, Body_CP_InitSpringTillages_Phase3);
};

ConcurrentPrunings::ConcurrentPrunings() {
// =========================================================
// Une classe de Entity : 'ConcurrentPrunings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_PRUNINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToPrune();       AddMethod (pM);
  pM = new AddNewSituatedPrunings();      AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentPrunings::ConcurrentPrunings(Vineyard* pEA, int numPhase) {
// =========================================================
// Une classe de Entity : 'ConcurrentPrunings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_PRUNINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToPrune();       AddMethod (pM);
  pM = new AddNewSituatedPrunings();      AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
 
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Prunings);
  //
  // date au plus tot pour l'ouverture du chantier ...
  //
  int jDay = App_GetIntDecisionOption(pEA, OPT_PRUNING_MIN_BEG_DATE);
  int minBegDate = App_JulianDayToClockFromBegSim(jDay);
  SetIntVarValue(MIN_BEG_DATE, minBegDate);
  //
  // ... complementee par le predicat d'ouverture
  //
  AssignBody(OPENING_PREDICATE, Body_OP_Prunings_OnDate);
  //
  // predicat de fermeture
  //
  switch (numPhase) {
  case 2 : { 
	AssignBody(CLOSING_PREDICATE, Body_CP_Prunings_Phase2);
	break;
  }
  case 3 : { 
	AssignBody(CLOSING_PREDICATE, Body_CP_Prunings_Phase3);
	break;
  }
  default : {
	printf("\n!!! Construction d'un '%s' avec un numero de phase illegal : %d\n", InstanceName(), numPhase);
	exit(0);
  }
  }
};

ConcurrentRegularPhytoTreatments::ConcurrentRegularPhytoTreatments() {
// =========================================================
// Une classe de Entity : 'ConcurrentRegularPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_REGULAR_PHYTO_TREATMENTS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new AntiMildewScheduled();         AddConstantDescriptor(pD);
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
  pM = new SetScheduledAntiMildew();      AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentRegularPhytoTreatments::ConcurrentRegularPhytoTreatments(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'ConcurrentRegularPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_REGULAR_PHYTO_TREATMENTS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new AntiMildewScheduled();         AddConstantDescriptor(pD);
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
  pM = new SetScheduledAntiMildew();      AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  AssignBody(OPENING_PREDICATE, Body_OP_PhytoTreatments);
  AssignBody(CLOSING_PREDICATE, Body_CP_RegularPhytoTreatments);
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_ConcurrentRegularPhytoTreatments);
};

ConcurrentShootThinnings::ConcurrentShootThinnings() {
// =========================================================
// Une classe de Entity : 'ConcurrentShootThinnings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_SHOOT_THINNINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new AddNewSituatedShootThinnings();AddMethod (pM);
  pM = new SelectNewPlotsToShootThin();   AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentShootThinnings::ConcurrentShootThinnings(Vineyard* pVineyard, int numPhase) {
// =========================================================
// Une classe de Entity : 'ConcurrentShootThinnings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_SHOOT_THINNINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new AddNewSituatedShootThinnings();AddMethod (pM);
  pM = new SelectNewPlotsToShootThin();   AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_ShootThinnings);

  AssignBody(OPENING_PREDICATE, Body_OP_ShootThinnings_OnSurface);
  //
  // predicat de fermeture
  //
  switch (numPhase) {
  case 2 : { 
	AssignBody(CLOSING_PREDICATE, Body_CP_ShootThinnings_Phase2);
	break;
  }
  case 3 : { 
	AssignBody(CLOSING_PREDICATE, Body_CP_ShootThinnings_Phase3);
	break;
  }
  default : {
	printf("\n!!! Construction d'un '%s' avec un numero de phase illegal : %d\n", InstanceName(), numPhase);
	exit(0);
  }
  }
};

ConcurrentSpringChemicalWeedings::ConcurrentSpringChemicalWeedings() {
// =========================================================
// Une classe de Entity : 'ConcurrentSpringChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_SPRING_CHEMICAL_WEEDINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToSpringWeed();  AddMethod (pM);
  pM = new AddNewSituatedSpringChemicalWeedings();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentSpringChemicalWeedings::ConcurrentSpringChemicalWeedings(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'ConcurrentSpringChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_SPRING_CHEMICAL_WEEDINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToSpringWeed();  AddMethod (pM);
  pM = new AddNewSituatedSpringChemicalWeedings();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_SpringChemicalWeedings);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_SpringChemicalWeedings);

  AssignBody(CLOSING_PREDICATE, Body_CP_SpringChemicalWeedings);
};

ConcurrentSpringTillages::ConcurrentSpringTillages() {
// =========================================================
// Une classe de Entity : 'ConcurrentSpringTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_SPRING_TILLAGES);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new FirstSpringTillageDate();      AddConstantDescriptor(pD);
  Method* pM;
  pM = new SelectNewPlotsToSpringTill();  AddMethod (pM);
  pM = new AddNewSituatedSpringTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentSpringTillages::ConcurrentSpringTillages(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'ConcurrentSpringTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_SPRING_TILLAGES);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new FirstSpringTillageDate();      AddConstantDescriptor(pD);
  Method* pM;
  pM = new SelectNewPlotsToSpringTill();  AddMethod (pM);
  pM = new AddNewSituatedSpringTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_SpringTillages);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_SpringTillages);

  AssignBody(CLOSING_PREDICATE, Body_CP_SpringTillages);
};

ConcurrentTrellisings::ConcurrentTrellisings() {
// =========================================================
// Une classe de Entity : 'ConcurrentTrellisings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_TRELLISINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToTrellis();     AddMethod (pM);
  pM = new AddNewSituatedTrellisings();   AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_Trellisings);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Trellisings);

  AssignBody(CLOSING_PREDICATE, Body_CP_Trellisings);
};

ConcurrentWinterTillages::ConcurrentWinterTillages() {
// =========================================================
// Une classe de Entity : 'ConcurrentWinterTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_WINTER_TILLAGES);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToWinterTill();  AddMethod (pM);
  pM = new AddNewSituatedWinterTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentWinterTillages::ConcurrentWinterTillages(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'ConcurrentWinterTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_WINTER_TILLAGES);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToWinterTill();  AddMethod (pM);
  pM = new AddNewSituatedWinterTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_WinterTillages_OnDate);

  AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_WinterTillages);

  AssignBody(CLOSING_PREDICATE, Body_CP_WinterTillages_OnDate);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_WinterTillages);
};

DistributedActivitySetIteration::DistributedActivitySetIteration() {
// =========================================================
// Une classe de Entity : 'DistributedActivitySetIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(DISTRIBUTED_ACTIVITY_SET_ITERATION);
  //SetParentClassId(ACTIVITY_ITERATION); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

void extraPhytoTreatmentsIteration_updateReactivatedSon_Body(EntityMethod* pM)
//---------------------------------------------------------------------------
// Si les conditions d'une nouvelle mise en oeuvre de l'activit� it�r�e
// sont satisfaites, ce sera fait avec les propri�t�s qui lui sont donn�es
// dans cette fonction.
//---------------------------------------------------------------------------
{
  Entity* pIteration = pM->DescribedEntity();
  Activity* pIterated = (Activity*)pIteration->GetElement();
  Activity* pChantier = pIterated;
  Vineyard* pEA = App_GetVineyard((Activity*)pIteration);
//printf("\nt=%d DEB '%s'::URS", pCurrentSim->Clock(), pIteration->InstanceName());
  //
  // RAZ des Percent_.._Treated sur les parcelles a labourer;
  //
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED);
	//
	// . par codage du predicat de fermeture du chantier, on ne ferme pas
	// un traitement si le AchievementDegree d'une activite est entre 0. et 1.
	// . les parcelles non en carignan sont à -1 (App_DepthBioPhysicalSettings)
	//
	int isDone =    App_FloatEQ(percentDone, (float)1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(isDone) {
	  pPlot_k->SetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED, (float)0.);
	}
  }

  if(pIterated->IsInstanceOf(ACTIVITY_OPTIONAL))
	pChantier = (Activity*)pIterated->GetElement();
  // + JPR 130223 : effacement de la valeur 'ceSoir' donnee dans 
  //                Common_PhytoTreatment_OnDate_OpeningPredicate
  pChantier->SetIntVarValue(MAX_BEG_DATE, D_INTMAX);
  //
  // gestion des desallocations : on desalloue les activites
  // issues du dernier selectNewPlots de l'iteration precedente...
  //
  //int nbAct = pChantier->GetNumberOfElements();  // modif JPR 120612
  int nbAct = pChantier->GetNumberOfOperands();  // + modif GetOperand
  for(int i=nbAct-1;i>=0;i--) {
	PrimitiveActivity* pAct = (PrimitiveActivity*)pChantier->GetOperand(i);
	//
	// voir note dans regularPhytoTreatmentsIteration_URS
	//
	int now = pCurrentSim->Clock();
	int endDate = pAct->GetIntVarValue(END_DATE);
//printf("\n'%s'::URS '%s'::end_date=%d", pIteration->InstanceName(), pAct->InstanceName(), endDate);
	if(endDate != now)
	  pAct->DeleteInDepth();
	else { // - 120603 dans regularPhytoTreatmentsIteration_URS
	  pChantier->RemoveElement(pAct);
	}      // - 120603
  }
};

bool extraPhytoTreatmentsIteration_openingPredicate_Body(EntityMethod* pM) {
//--------------------------------------------------------------------------
// Doit renvoyer vrai pour que l'activit� puisse �tre ouverte.
//--------------------------------------------------------------------------
  Entity* pIterate = pM->DescribedEntity();
  Vineyard* pEA = App_GetVineyard((Activity*)pIterate);
  bool result = FALSE;
  //
  // TRUE si  :
  // - il y a du 'carignan' dans l'EA
  // - l'iteration 'regular' a d�j� eu au moins une realisation
  // (la condition 'il y a des drapeaux OU la pression maladie est suffisante'
  //  est placee sur l'openingPredicate du chantier)
  //
  pEntityTab pPlotTab = pEA->GetElementTab();
  int nbElems = pPlotTab.size();
  bool hasCarignan = FALSE;
  for(int i=0;i<nbElems;i++) {
	Entity* pPlot = (Entity*)pPlotTab.get_element(i);
	Entity* pVariety = pPlot->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
	if(! strcmp(pVariety->InstanceName(), "carignan")) {
	  hasCarignan = TRUE;
	  break;
	}
  }
  
  if(hasCarignan) {
	Entity* pComposedProgram = pIterate->GetSuperSet();
	Entity* pRegularIteration = (Entity*)pComposedProgram->GetElement(0);
	int nbRepl = pRegularIteration->GetIntVarValue(REPLICATION_COUNTER);
	
	if(nbRepl > 0)
	  result = TRUE;
  }

//printf("\n'%s'::extraPhytoTreatmentsIteration_OP returns %d", pIterate->InstanceName(), result);
  return result;
};

bool extraPhytoTreatmentsIteration_closingPredicate_Body(EntityMethod* pM) {
//--------------------------------------------------------------------------
// Doit renvoyer vrai pour que l'activit� puisse �tre ferm�e.
//--------------------------------------------------------------------------
  Entity* pIterate = pM->DescribedEntity();
  Vineyard* pEA = App_GetVineyard((Activity*)pIterate);
  //
  // On ferme si le cepage guide tardif (typiquement carignan)
  // a atteint le stade 33 ('debut fermeture grappe')
  //
  bool result = TRUE;
  
  char* guidingLateVarietyName = 
	App_GetStringDecisionOption (pEA, GUIDING_LATE_VARIETY_ATTRIBUTE);
  pEntityTab* pIsoAgeingEntities = 
	App_GetIsoAgeingEntityList (pEA, 
								GetNamedEntity("grapeVariety", 
											   guidingLateVarietyName),
								NULL);
  int nbIsoAgeingEntities = pIsoAgeingEntities->size();
  if(nbIsoAgeingEntities == 0) {
	printf("\n!!! Pour l'EA '%s', on n'a pas d�clar� de c�page guide tardif.\n", pEA->InstanceName());
	exit(0);
  }
  for(int i=0;i<nbIsoAgeingEntities;i++) {
	Entity* pIsoAgeingEntity = (Entity*)pIsoAgeingEntities->get_element(i);
	Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
	int currentStage = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
	
	if(currentStage < 33) {
	  result = FALSE;
	  break;
	}
  }
  delete pIsoAgeingEntities;

//printf("\n'%s'::extraPhytoTreatmentsIteration_CP returns %d", pIterate->InstanceName(), result);
  return result;
};

ExtraPhytoTreatmentsIteration::ExtraPhytoTreatmentsIteration() {
// =========================================================
// Une classe de Entity : 'ExtraPhytoTreatmentsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(EXTRA_PHYTO_TREATMENTS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(UPDATE_REACTIVATED_SON, extraPhytoTreatmentsIteration_updateReactivatedSon_Body);
  AssignBody(OPENING_PREDICATE, extraPhytoTreatmentsIteration_openingPredicate_Body);
  AssignBody(CLOSING_PREDICATE, extraPhytoTreatmentsIteration_closingPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ExtraPhytoTreatmentsIteration::ExtraPhytoTreatmentsIteration(Vineyard* pEA, char* optionSerPar) {
// =========================================================
// Une classe de Entity : 'ExtraPhytoTreatmentsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(EXTRA_PHYTO_TREATMENTS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
  AssignBody(UPDATE_REACTIVATED_SON, extraPhytoTreatmentsIteration_updateReactivatedSon_Body);
  AssignBody(OPENING_PREDICATE, extraPhytoTreatmentsIteration_openingPredicate_Body);
  AssignBody(CLOSING_PREDICATE, extraPhytoTreatmentsIteration_closingPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetIntVarValue(MAX_NUMBER_OF_REPLICATIONS, 2, FALSE);  // not monitored

  Activity* pAct;
  // --------------------------------------------------
  if(! strcmp(optionSerPar, "PAR"))
	pAct = new ConcurrentExtraPhytoTreatments(pEA);
  else
	pAct = new SerialExtraPhytoTreatments(pEA);
  // --------------------------------------------------

  pAct->SetIntConstValue(NEED_FOR_NEXT_FAVOURABLE_DAYS, 1);
  //
  // Une fois ouvert, le chantier doit etre commence dans les 3 jours,
  // ou bien etre abandonne, sans que ca soit un echec
  // Le delai de 3 jours est specifie dans Body_OP_PhytoTreatments :
  // si ouverture autorises, valuation de MAX_BEG_DATE a +3j
  //
  Activity* pOpt = new ActivityOptional();
  pOpt->AddElement(pAct);

  AddElement(pOpt);
};

PhytoTreatmentComposedProgram::PhytoTreatmentComposedProgram() {
// =========================================================
// Une classe de Entity : 'PhytoTreatmentComposedProgram'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PHYTO_TREATMENT_COMPOSED_PROGRAM);
  //SetParentClassId(ACTIVITY_CONJUNCTION); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new AntiMildewTreatmentJustDone(); AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PhytoTreatmentComposedProgram::PhytoTreatmentComposedProgram(Vineyard* pEA, char* optionSerPar) {
// =========================================================
// Une classe de Entity : 'PhytoTreatmentComposedProgram'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PHYTO_TREATMENT_COMPOSED_PROGRAM);
  //SetParentClassId(ACTIVITY_CONJUNCTION); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new AntiMildewTreatmentJustDone(); AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Activity* pAct;
  // --------------------------------------------------
  //
  // le traitement repetitif, anti oidium  [+ anti mildiou selon strategie Rx]
  //
  pAct = new RegularPhytoTreatmentsIteration(pEA, optionSerPar);
  AddElement(pAct);
  // --------------------------------------------------
  //
  // un ou deux traitements anti oidium complementaires si besoin
  //
  pAct = new ExtraPhytoTreatmentsIteration(pEA, optionSerPar);
  AddElement(pAct);
  // --------------------------------------------------
  //
  // un traitement specifique anti mildiou si necessaire
  //
  Entity* pChantier;
  if(! strcmp(optionSerPar, "PAR"))
	pChantier = new ConcurrentAntiMildewTreatments(pEA);
  else
	pChantier = new SerialAntiMildewTreatments(pEA);
  pAct = new ActivityOptional();
  pAct->AddElement(pChantier);
  AddElement(pAct);
  // --------------------------------------------------
};


void regularPhytoTreatmentsIteration_updateReactivatedSon_Body(EntityMethod* pM)
//---------------------------------------------------------------------------
// Si les conditions d'une nouvelle mise en oeuvre de l'activité itérée
// sont satisfaites, ce sera fait avec les propriétés qui lui sont données
// dans cette fonction.
//---------------------------------------------------------------------------
{
  Entity* pIteration = pM->DescribedEntity();
  Entity* pSon = pIteration->GetElement();
  Vineyard* pEA = App_GetVineyard((Activity*)pIteration);
//printf("\nt=%d DEB '%s'::URS", pCurrentSim->Clock(), pIteration->InstanceName());
  //
  // RAZ des Percent..Treated sur les parcelles a traiter;
  //
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k); 
	// ci-dessous modif JPR 130225 : RAZ sans condition 'isDone'
	pPlot_k->SetFloatVarValue(PERCENT_REGULAR_PHYTO_TREATED, (float)0.);
	//pPlot_k->SetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED, (float)0.);  // +/- JPR 130225
	//pPlot_k->SetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED, (float)0.);  // +/- JPR 130225
  }

  int cadence = App_GetIntDecisionOption(pEA, 
										 OPT_PHYTO_TREATMENT_CADENCE);
  // convention :
  // . -X pour la cadence "X jours minimum"       (e.g. 14 jours minimum)
  // .  X pour la cadence "X jours nominalement"  (e.g. 12 ou 14)

  int prevBegClock =  pSon->GetIntVarValue(BEG_DATE);
//printf("\nDEB '%s'::URS '%s'::prevBegClock = %d (now=%d)\n", pIteration->InstanceName(), pSon->InstanceName(), prevBegClock, pCurrentSim->Clock());
//((Activity*)pSon)->DisplaySituation();
  
  //
  // "X jours nominalement : on ouvre deux jours avant la date nominale de traitement
  // "X jours minimum" : on ouvre a la date nominale de traitement
  //
  int delay;
  int nextBegClock, minBegDate;
  if(cadence > 0) { 
	if(cadence < 15) {
	  delay = (cadence / 2) - 1;
	}
	else {
	  delay = 11 - 1;
	}
  }
  else { 
	delay = 11 - 1;
  } 
  nextBegClock = prevBegClock + (delay+1)*24;
  tm* pTm = ClockValueToTm(nextBegClock);
  //
  // determination heure du UpdateReactivatedSon
  //
  pTm->tm_hour = ReturnManagerWakeUpHour();
  mktime(pTm);
  minBegDate = StructTmToClockValue(pTm);
//printf("\n'%s'::URS '%s'::nextBegClock = %d", pIteration->InstanceName(), pSon->InstanceName(), minBegDate);
  delete pTm;
  pSon->SetIntVarValue(MIN_BEG_DATE, minBegDate);

  pEntityTab* pListeChantiers = new pEntityTab();
  if(pSon->IsInstanceOf(VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN)) {
	pListeChantiers->push_back(pSon->GetElementTab());
  }
  else {  // pSon est un chantier
	pListeChantiers->push_back(pSon);
  }
  //
  // gestion des desallocations : on desalloue les activites
  // issues du dernier selectNewPlots de l'iteration precedente...
  // (on ne desalloue pas ici les operations, parce que les activites
  // primitives iterees, par conception, toutes fermees ; les operations
  // ont donc ete terminees et le moteur les a alors desallouees)
  //
  int nbChantiers = pListeChantiers->size();
  for(int k=0;k<nbChantiers;k++) {
	Activity* pChantier = (Activity*)pListeChantiers->get_element(k);
//pChantier->DisplaySituation();
	//int nbAct = pChantier->GetNumberOfElements();  // modif JPR 120612
	int nbAct = pChantier->GetNumberOfOperands();  // + modif GetOperand
	for(int i=nbAct-1;i>=0;i--) {
	  PrimitiveActivity* pAct = (PrimitiveActivity*)pChantier->GetOperand(i);
	  //
	  // ... sauf la derniere activite fermee, parce que c'est pendant sa
	  // fermeture (et celle du chantier) qu'est invoque le present URS ;
	  // --> ne pas terminer la fermeture sur un objet desalloue !
	  // (sa desallocation sera faite dans le DeallocatePrimitiveActivityTab
	  // en fin de main)
	  //
	  int now = pCurrentSim->Clock();
	  int endDate = pAct->GetIntVarValue(END_DATE);
//printf("\n'%s'::URS '%s'::endDate=%d now=%d", pIteration->InstanceName(), pAct->InstanceName(), endDate, now);
	  if(endDate != now) {
		pAct->DeleteInDepth();
//printf("\nif ");pChantier->DisplaySituation();
	  }
	  //else { // - 120603
		pChantier->RemoveElement(pAct);
//printf("\nelse ");pChantier->DisplaySituation();
	  //}      // - 120603
	}
//pChantier->DisplaySituation();
  }
  delete pListeChantiers;
//((Activity*)pSon)->DisplaySituation();
//printf("\n'FIN %s'::URS '%s'\n", pIteration->InstanceName(), pSon->InstanceName());
};

bool regularPhytoTreatmentsIteration_openingPredicate_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// Doit renvoyer vrai pour que l'activit� puisse �tre ouverte.
//---------------------------------------------------------------------------
  Entity* pIterate = pM->DescribedEntity();
  Entity* pEA = App_GetVineyard((Activity*)pIterate);
//printf("\nentree '%s'_OP", pIterate->InstanceName());

  bool result = FALSE;
  
  int option = App_GetIntDecisionOption(pEA, OPT_REGULAR_PHYTO_TREATMENTS_O_P);
  //
  // etablissement de la liste des cepages de la 1ere vague
  //
  Entity* pConduite = 
	pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  int powderyMildewMngt = 
	pConduite->GetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE);
  
  Entity* pVarGroupSet = App_GetVarietyGroupSet(powderyMildewMngt);
  
  pVarGroupSet->SetEntityArgValue(GET_RANKED_WAVE_LIST, VINEYARD_ARGUMENT, pEA);
  pVarGroupSet->SetIntArgValue(GET_RANKED_WAVE_LIST, STAGE_INDEX_ARGUMENT, 0);
  pEntityTab* firstWaveList = pVarGroupSet->ExecEntityTabMethod(GET_RANKED_WAVE_LIST);

  pEntityTab* localVarietyList = pEA->GetEntityTabConstValue(GRAPE_VARIETY_LIST_ATTRIBUTE);
  
  int nbElem = firstWaveList->size();
  for(int i=nbElem-1;i>=0;i--) {
	BasicEntity* pVariety = firstWaveList->get_element(i);
	if(GetPosition(*localVarietyList, pVariety) < 0) {
	  firstWaveList->remove(i);
	}
  }
  //
  // etablissement presence early et/ou late dans les cepages de la 1ere vague
  //
  bool areEarly = FALSE;
  bool areLate = FALSE;
  nbElem = firstWaveList->size();
  int k=-1;
  while((! areEarly || ! areLate)
		&&
		(k < nbElem-1)) {
	Entity* pVar = (Entity*)firstWaveList->get_element(++k);
	if(pVar->GetIntConstValue(IS_EARLY))
	  areEarly = TRUE;
	else
	  areLate = TRUE;
  }  
  delete firstWaveList;
//printf("\n'%s'_OP areEarly =%d areLate = %d", pIterate->InstanceName(), areEarly, areLate);
  if(! areEarly && ! areLate) {
	printf("!!! '%s'_OP ni early ni late !!!\n", pIterate->InstanceName());
	exit(0);
  }
  //
  // recherche des varietes-guides early et late pour cette EA
  //
  char* guidingEarlyVarietyName = 
	App_GetStringDecisionOption (pEA, GUIDING_EARLY_VARIETY_ATTRIBUTE);
  Entity* guidingEarlyVariety = GetNamedEntity("grapeVariety", guidingEarlyVarietyName);
  char* guidingLateVarietyName = 
	App_GetStringDecisionOption (pEA, GUIDING_LATE_VARIETY_ATTRIBUTE);
  Entity* guidingLateVariety = GetNamedEntity("grapeVariety", guidingLateVarietyName); 
  //
  // etablissement liste des IsoAgeingEntity relatives aux varietes-guides
  //
  pEntityTab* pEarlyIsoAgeingAttributeList = 
	App_GetIsoAgeingEntityList(pEA, guidingEarlyVariety, NULL);	  
  int nbElemEarly = pEarlyIsoAgeingAttributeList->size();
  pEntityTab* pLateIsoAgeingAttributeList = 
	App_GetIsoAgeingEntityList(pEA, guidingLateVariety, NULL);
  int nbElemLate = pLateIsoAgeingAttributeList->size();
  //
  //
  //
  bool allOKForEarly = TRUE;
  bool allOKForLate = TRUE;
  switch(option)  {
  case 1 : { // D1
	if(! areEarly) {
	  printf("!!! '%s'_OP pas de early et cas 'D1' !!!\n", pIterate->InstanceName());
	  exit(0);
	}
	for(int i=0;i<nbElemEarly;i++)  {
	  Entity* pIsoAgeingEntity = 
		(Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
	  Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
	  int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
	  if(codeStade < 6) { //budBreak
		allOKForEarly = FALSE;
		break;
	  }
	}
	break;
  }
  case 2 : { // D2
	if(areEarly) {
	  for(int i=0;i<nbElemEarly;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 9) { //3-4 feuilles
		  allOKForEarly = FALSE;
		  break;
		}
	  }
	}
	if(areLate) {
	  for(int i=0;i<nbElemLate;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pLateIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 6) { //budBreak
		  allOKForLate = FALSE;
		  break;
		}
	  }
	}
	break;
  }
  case 3 : { // D3
	if(areEarly) {
	  for(int i=0;i<nbElemEarly;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 11) { //4-5 feuilles
		  allOKForEarly = FALSE;
		  break;
		}
	  }
	}
	if(areLate) {
	  for(int i=0;i<nbElemLate;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pLateIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 9) { //2-3 feuilles
		  allOKForLate = FALSE;
		  break;
		}
	  }
	}
	break;
  }
  case 4 : { // D4
	if(areEarly) {
	  for(int i=0;i<nbElemEarly;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 12) { //5-6 feuilles
		  allOKForEarly= FALSE;
		  break;
		}
	  }
	}
	if(areLate) {
	  for(int i=0;i<nbElemLate;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pLateIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 10) { //3-4 feuilles
		  allOKForLate = FALSE;
		  break;
		}
	  }
	}
	break;
  }
  case 5 : { // D5
	if(areEarly) {
	  for(int i=0;i<nbElemEarly;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 15) { //boutons floraux agglomeres
		  allOKForEarly = FALSE;
		  break;
		}
	  }
	}
	if(areLate) {
	  for(int i=0;i<nbElemLate;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pLateIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade < 12) { //5-6 feuilles
		  allOKForLate = FALSE;
		  break;
		}
	  }
	}
	break;
  }
  case 6 : { // D6
	if(! areLate) {
	  printf("!!! '%s'_OP pas de late et cas 'D6' !!!\n", pIterate->InstanceName());
	  exit(0);
	}
	for(int i=0;i<nbElemLate;i++)  {
	  Entity* pIsoAgeingEntity = 
		(Entity*)pLateIsoAgeingAttributeList->get_element(i);
	  Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
	  int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
	  if(codeStade < 12) { //5-6 feuilles
		allOKForLate = FALSE;
		break;
	  }
	}
	break;
  }
  default : {
	printf("\n'%s'_OP passage inattendu par 'default'\n", pIterate->InstanceName());
	exit(0);
  }
  }	

  result = allOKForEarly && allOKForLate;
	 
  delete pEarlyIsoAgeingAttributeList;		 
  delete pLateIsoAgeingAttributeList;

//printf("\n'%s'_OP returns %d", pIterate->InstanceName(), result);
  return result;
};

bool regularPhytoTreatmentsIteration_closingPredicate_Body(EntityMethod* pM) {
//---------------------------------------------------------------------------
// Doit renvoyer vrai pour que l'activit� puisse �tre ferm�e.
//---------------------------------------------------------------------------
  Entity* pIteration = pM->DescribedEntity();
  bool result = FALSE;
//printf("\nentree '%s'_closingPredicate_Body", pIteration->InstanceName());

  //
  // condition prealable : chantier termine (= ttes parcelles faites)
  // =====================================================
  Entity* pChantier = pIteration->GetElement(0);
  int situation = pChantier->GetIntVarValue(SITUATION);
  if(situation != WAITING) {
//printf("\nt = %d '%s'_CP renvoie %d (chantier ouvert)", pCurrentSim->Clock(), pIteration->InstanceName(), result);
	return FALSE;
  }
  //
  // critere d'arret : le risque est devenu faible
  // =========================================
  //
  //  OIDIUM
  //
  bool powderyMildewToClose = 
	pIteration->ExecPredicate(ANTI_POWDERY_MILDEW_CLOSING_PREDICATE);

  pIteration->SetIntConstValue(POWDERY_MILDEW_TO_CLOSE, powderyMildewToClose);
//if(powderyMildewToClose) printf("\n\t  !! POWDERY_MILDEW_TO_CLOSE !!");
  //
  // MILDIOU (modif JPR 140117)
  //
  bool downyMildewToClose = FALSE;
  bool downyMildewToClose_atLeast = 
	pIteration->ExecPredicate(ANTI_DOWNY_MILDEW_AT_LEAST_CLOSING_PREDICATE);
//printf("\nANTI_DOWNY_MILDEW_AT_LEAST_CLOSING_PREDICATE -> %d", downyMildewToClose_atLeast);

  if(downyMildewToClose_atLeast) {
	int pressureAlreadyObserved = pIteration->GetIntConstValue(DOWNY_MILDEW_PRESSURE);
	// valeur init = -9
	// 0 ssi pressureAlreadyObserved <= 0 ET ! pressureExists(t-1)
	// 1 ssi pressureExists(t-1)
//printf("\n\tpressureAlreadyObserved = %d", pressureAlreadyObserved);
	if(pressureAlreadyObserved <= 0) { // pas encore fait  // JPR 120306 : < -> <=
	  bool pressureExists = FALSE;
	  // 
	  // evaluation du niveau de pression present
	  //
	  Vineyard* pEA = App_GetVineyard((Activity*)pChantier);
	  int downyMildewLevel = App_GetIntPestInfo(pEA, DOWNY_MILDEW_LEVEL);
	  int threshold1 = gIntParam_virtualManager_actualDownyMildewLevelThreshold_;
//printf("\n\tdownyMildewLevel = %d threshold1 = %d", downyMildewLevel, threshold1);
	  if(downyMildewLevel > threshold1) {
		float downyMildewRiskLevel = App_GetFloatPestInfo(pEA, DOWNY_MILDEW_RISK_LEVEL);
		float threshold2 = App_GetFloatDecisionOption(pEA, 
													  OPT_ACTUAL_DOWNY_MILDEW_RISK_THRESHOLD);
//printf("\n\tdownyMildewRiskLevel = %12.10f threshold2 = %12.10f", downyMildewRiskLevel, threshold2);
		if(downyMildewRiskLevel > threshold2)
		  pressureExists = TRUE;
	  }
//printf("\n\t--> pressureExists / downyMildewRiskLevel = %d", pressureExists);
	  if(! pressureExists) {
		// 
		// evaluation du niveau d'attaque passe (moyenne/j)
		//
		float pastPressureLevel = App_GetIntPestHistory (pEA, DOWNY_MILDEW_LEVEL);
		// 
		// capture du seuil accepte sur niveau de pression passe
		//
		float threshold3 = App_GetFloatDecisionOption(pEA, 
													 OPT_PAST_DOWNY_MILDEW_PRESSURE_THRESHOLD);
//printf("\n\tpastPressureLevel = %12.10f threshold3 = %12.10f", pastPressureLevel, threshold3);
		if(pastPressureLevel > threshold3) {
		  pressureExists = TRUE;
		}
	  }
	  // 
	  // Memorisation au profit du prochain examen
	  //
//printf("\n\t--> pressureExists final = %d", pressureExists);
// JPR140117 : reste a coder le "dans les 30 jours qui suivent cet arrêt" de l'expression 
// "chantiers mildiou susceptibles de reprendre si la pression devient forte dans les 30 jours 
// qui suivent cet arrêt [= date ou AtLeastClosingPredicate devient vraie]"
// AB 140120 : "Inutile de le coder. c'est mieux sans cette restriction."
	  pIteration->SetIntConstValue(DOWNY_MILDEW_PRESSURE, pressureExists);
	} // fin case (pressureAlreadyObserved < 0)

	downyMildewToClose = 
	  pIteration->ExecPredicate(ANTI_DOWNY_MILDEW_UNDER_PRESSURE_CLOSING_PREDICATE);
//printf("\nANTI_DOWNY_MILDEW_UNDER_PRESSURE_CLOSING_PREDICATE -> %d", downyMildewToClose);
  } // fin case 'downyMildewToClose_atLeast vrai'

  pIteration->SetIntConstValue(DOWNY_MILDEW_TO_CLOSE, downyMildewToClose);
//if(downyMildewToClose) printf("\n\t  !! DOWNY_MILDEW_TO_CLOSE !!");
  //
  // test sur les 2 maladies
  //
  if(powderyMildewToClose
	 &&
	 downyMildewToClose) {
	result = TRUE;
  }

//printf("\nt = %d '%s'_CP renvoie %d", pCurrentSim->Clock(), pIteration->InstanceName(), result);
  return result;
};

RegularPhytoTreatmentsIteration::RegularPhytoTreatmentsIteration() {
// =========================================================
// Une classe de Entity : 'RegularPhytoTreatmentsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(REGULAR_PHYTO_TREATMENTS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new DownyMildewPressure();         AddConstantDescriptor(pD);
  pD = new DownyMildewToClose();          AddConstantDescriptor(pD);
  pD = new PowderyMildewToClose();        AddConstantDescriptor(pD);
  Method* pM;
  pM = new AntiPowderyMildewClosingPredicate();AddMethod (pM);
  pM = new AntiDownyMildewAtLeastClosingPredicate();AddMethod (pM);
  pM = new AntiDownyMildewUnderPressureClosingPredicate();AddMethod (pM);
  AssignBody(UPDATE_REACTIVATED_SON, regularPhytoTreatmentsIteration_updateReactivatedSon_Body);
  AssignBody(OPENING_PREDICATE, regularPhytoTreatmentsIteration_openingPredicate_Body);
  AssignBody(CLOSING_PREDICATE, regularPhytoTreatmentsIteration_closingPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

RegularPhytoTreatmentsIteration::RegularPhytoTreatmentsIteration(Vineyard* pEA, char* optionSerPar) {
// =========================================================
// Une classe de Entity : 'RegularPhytoTreatmentsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(REGULAR_PHYTO_TREATMENTS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new DownyMildewPressure();         AddConstantDescriptor(pD);
  pD = new DownyMildewToClose();          AddConstantDescriptor(pD);
  pD = new PowderyMildewToClose();        AddConstantDescriptor(pD);
  Method* pM;
  pM = new AntiPowderyMildewClosingPredicate();AddMethod (pM);
  pM = new AntiDownyMildewAtLeastClosingPredicate();AddMethod (pM);
  pM = new AntiDownyMildewUnderPressureClosingPredicate();AddMethod (pM);
  AssignBody(UPDATE_REACTIVATED_SON, regularPhytoTreatmentsIteration_updateReactivatedSon_Body);
  AssignBody(OPENING_PREDICATE, regularPhytoTreatmentsIteration_openingPredicate_Body);
  AssignBody(CLOSING_PREDICATE, regularPhytoTreatmentsIteration_closingPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Activity* pAct;
  // --------------------------------------------------
  if(! strcmp(optionSerPar, "PAR")) {
	pAct = new ConcurrentRegularPhytoTreatments(pEA);
  }
  else {
	//
	pAct = new VineyardIteratedConjunctiveSubplan();
	Activity* pManualSeq = new SerialManualRegularPhytoTreatments(pEA);
	pAct->AddElement(pManualSeq);
	Activity* pMotorSeq = new SerialMotorizedRegularPhytoTreatments(pEA);
	pAct->AddElement(pMotorSeq);
  }
  // --------------------------------------------------
  AddElement(pAct);
};

SerialClippingsIteration::SerialClippingsIteration() {
// =========================================================
// Une classe de Entity : 'SerialClippingsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_CLIPPINGS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialClippingsIteration::SerialClippingsIteration(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'SerialClippingsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_CLIPPINGS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Activity* pAct;
  // --------------------------------------------------
  pAct = new SerialClippings(pEA);
  AddElement(pAct);
  // --------------------------------------------------
};

SerialDistributedActivitySet::SerialDistributedActivitySet() {
// =========================================================
// Une classe de Entity : 'SerialDistributedActivitySet'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_DISTRIBUTED_ACTIVITY_SET);
  //SetParentClassId(ACTIVITY_MEETING_ANY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new TerminatedPlotsAttribute();    AddConstantDescriptor(pD);
  pD = new SkippedPlotsAttribute();       AddConstantDescriptor(pD);
  pD = new NeedForNextFavourableDays();   AddConstantDescriptor(pD);
  pD = new ActualRealizationBegDate();    AddConstantDescriptor(pD);
  pD = new ActualRealizationEndDate();    AddConstantDescriptor(pD);
  pD = new ActivityNominalDate();         AddConstantDescriptor(pD);
  pD = new AllocationPriorityDegree();    AddConstantDescriptor(pD);
  pD = new OperatedVineyardSubArea();     AddVariableDescriptor(pD);
   DistributedActivitySetEndDateMonitor->AttachToDescriptor(this, END_DATE);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialExtraPhytoTreatments::SerialExtraPhytoTreatments() {
// =========================================================
// Une classe de Entity : 'SerialExtraPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_EXTRA_PHYTO_TREATMENTS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new RegularPhytoTreatmentIndex();  AddConstantDescriptor(pD);
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialExtraPhytoTreatments::SerialExtraPhytoTreatments(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'SerialExtraPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_EXTRA_PHYTO_TREATMENTS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new RegularPhytoTreatmentIndex();  AddConstantDescriptor(pD);
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  AssignBody(OPENING_PREDICATE, Body_OP_PhytoTreatments);
  AssignBody(CLOSING_PREDICATE, Body_CP_ExtraPhytoTreatments);
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_SerialExtraPhytoTreatments);
};

SerialFertilizations::SerialFertilizations() {
// =========================================================
// Une classe de Entity : 'SerialFertilizations'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_FERTILIZATIONS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToFertilize();   AddMethod (pM);
  pM = new AddNewSituatedFertilizations();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialFertilizations::SerialFertilizations(Vineyard* pEA, int season, int numPhase) {
// =========================================================
// Une classe de Entity : 'SerialFertilizations'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_FERTILIZATIONS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToFertilize();   AddMethod (pM);
  pM = new AddNewSituatedFertilizations();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Fertilizations);

  //
  //  predicat d'ouverture du chantier
  //
  int minBegDate;
  if(season == 1) {   // AUTUMN
	minBegDate = pCurrentSim->Clock();
	AssignBody(OPENING_PREDICATE, Body_OP_Fertilizations_OnDate);
  }
  else {              // not AUTUMN
	int jDay = App_GetIntDecisionOption(pEA, 
										OPT_SPRING_FERT_MIN_BEG_DATE);
	minBegDate = App_JulianDayToClockFromBegSim(jDay);
	jDay =  App_GetIntDecisionOption(pEA, 
									 OPT_SPRING_FERT_MAX_BEG_DATE);
	int maxBegDate = App_JulianDayToClockFromBegSim(jDay);
	SetIntVarValue(MAX_BEG_DATE, maxBegDate);
	
	int option = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_O_P);
	if((option == END_THIN)
	   ||
	   (option == END_THIN_CW))
	  AssignBody(OPENING_PREDICATE, Body_OP_Fertilizations_OnChain);
	else if((option == EARLY_FEB)
			||
			(option == EARLY_MAR))
	  AssignBody(OPENING_PREDICATE, Body_OP_Fertilizations_OnDate);
	else {
	  printf("\nDans construction '%s', option invalide hors automne : %d\n", InstanceName(), option);
	  exit(0);
	}
	  
  }
  SetIntVarValue(MIN_BEG_DATE, minBegDate);

  //
  // predicat de fermeture du chantier
  //
  switch (numPhase) {
  case 1 : {
	AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_Fertilizations_Phase1);
	AssignBody(CLOSING_PREDICATE, Body_CP_Phase1);
	break;
  }
  case 3 : {
	AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_Fertilizations_Phase3); 
	AssignBody(CLOSING_PREDICATE, Body_CP_Fertilizations_Phase3);
	break;
  }
  default : {
	printf("\n!!! Construction d'un '%s' avec un numero de phase illegal : %d\n", InstanceName(), numPhase);
	exit(0);
  }
  }
};

SerialInitSpringTillages::SerialInitSpringTillages() {
// =========================================================
// Une classe de Entity : 'SerialInitSpringTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_INIT_SPRING_TILLAGES);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToInitSpringTill();AddMethod (pM);
  pM = new AddNewSituatedInitSpringTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialInitSpringTillages::SerialInitSpringTillages(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialInitSpringTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_INIT_SPRING_TILLAGES);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToInitSpringTill();AddMethod (pM);
  pM = new AddNewSituatedInitSpringTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_InitSpringTillages); 

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_InitSpringTillages); 

  AssignBody(CLOSING_PREDICATE, Body_CP_InitSpringTillages_Phase3);
};

SerialPlantations::SerialPlantations() {
// =========================================================
// Une classe de Entity : 'SerialPlantations'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_PLANTATIONS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToPlant();       AddMethod (pM);
  pM = new AddNewSituatedPlantations();   AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialPlantations::SerialPlantations(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialPlantations'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_PLANTATIONS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToPlant();       AddMethod (pM);
  pM = new AddNewSituatedPlantations();   AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_Plantations_OnDate);

  AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_Plantations);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Plantations);

  AssignBody(CLOSING_PREDICATE, Body_CP_Plantations);
};

SerialPrunings::SerialPrunings() {
// =========================================================
// Une classe de Entity : 'SerialPrunings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_PRUNINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToPrune();       AddMethod (pM);
  pM = new AddNewSituatedPrunings();      AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialPrunings::SerialPrunings(Vineyard* pEA, int numPhase) {
// =========================================================
// Une classe de Entity : 'SerialPrunings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_PRUNINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToPrune();       AddMethod (pM);
  pM = new AddNewSituatedPrunings();      AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
 
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Prunings);

  //
  // date au plus tot pour l'ouverture du chantier ...
  //
  int jDay = App_GetIntDecisionOption(pEA, OPT_PRUNING_MIN_BEG_DATE);
  int minBegDate = App_JulianDayToClockFromBegSim(jDay);
  SetIntVarValue(MIN_BEG_DATE, minBegDate);
  //
  // ... complementee par le predicat d'ouverture
  //
  AssignBody(OPENING_PREDICATE, Body_OP_Prunings_OnDate);
  //
  // predicat de fermeture
  //
  switch (numPhase) {
  case 2 : { 
	AssignBody(CLOSING_PREDICATE, Body_CP_Prunings_Phase2);
	break;
  }
  case 3 : { 
	AssignBody(CLOSING_PREDICATE, Body_CP_Prunings_Phase3);
	break;
  }
  default : {
	printf("\n!!! Construction d'un '%s' avec un numero de phase illegal : %d\n", InstanceName(), numPhase);
	exit(0);
  }
  }
};

SerialRegularPhytoTreatments::SerialRegularPhytoTreatments() {
// =========================================================
// Une classe de Entity : 'SerialRegularPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_REGULAR_PHYTO_TREATMENTS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new AntiMildewScheduled();         AddConstantDescriptor(pD);
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
  pM = new SetScheduledAntiMildew();      AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialRegularPhytoTreatments::SerialRegularPhytoTreatments(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'SerialRegularPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_REGULAR_PHYTO_TREATMENTS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new AntiMildewScheduled();         AddConstantDescriptor(pD);
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
  pM = new SetScheduledAntiMildew();      AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_PhytoTreatments);
  AssignBody(CLOSING_PREDICATE, Body_CP_RegularPhytoTreatments);
};

SerialShootThinnings::SerialShootThinnings() {
// =========================================================
// Une classe de Entity : 'SerialShootThinnings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_SHOOT_THINNINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToShootThin();   AddMethod (pM);
  pM = new AddNewSituatedShootThinnings();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialShootThinnings::SerialShootThinnings(Vineyard* pVineyard, int numPhase) {
// =========================================================
// Une classe de Entity : 'SerialShootThinnings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_SHOOT_THINNINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToShootThin();   AddMethod (pM);
  pM = new AddNewSituatedShootThinnings();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_ShootThinnings);

  AssignBody(OPENING_PREDICATE, Body_OP_ShootThinnings_OnSurface);
  //
  // predicat de fermeture
  //
  switch (numPhase) {
  case 2 : { 
	AssignBody(CLOSING_PREDICATE, Body_CP_ShootThinnings_Phase2);
	break;
  }
  case 3 : { 
	AssignBody(CLOSING_PREDICATE, Body_CP_ShootThinnings_Phase3);
	break;
  }
  default : {
	printf("\n!!! Construction d'un '%s' avec un numero de phase illegal : %d\n", InstanceName(), numPhase);
	exit(0);
  }
  }
};

SerialSpringChemicalWeedings::SerialSpringChemicalWeedings() {
// =========================================================
// Une classe de Entity : 'SerialSpringChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_SPRING_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToSpringWeed();  AddMethod (pM);
  pM = new AddNewSituatedSpringChemicalWeedings();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialSpringChemicalWeedings::SerialSpringChemicalWeedings(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialSpringChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_SPRING_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToSpringWeed();  AddMethod (pM);
  pM = new AddNewSituatedSpringChemicalWeedings();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_SpringChemicalWeedings);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_SpringChemicalWeedings);

  AssignBody(CLOSING_PREDICATE, Body_CP_SpringChemicalWeedings);
};

SerialSpringTillages::SerialSpringTillages() {
// =========================================================
// Une classe de Entity : 'SerialSpringTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_SPRING_TILLAGES);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new FirstSpringTillageDate();      AddConstantDescriptor(pD);
  Method* pM;
  pM = new SelectNewPlotsToSpringTill();  AddMethod (pM);
  pM = new AddNewSituatedSpringTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialSpringTillages::SerialSpringTillages(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialSpringTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_SPRING_TILLAGES);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new FirstSpringTillageDate();      AddConstantDescriptor(pD);
  Method* pM;
  pM = new SelectNewPlotsToSpringTill();  AddMethod (pM);
  pM = new AddNewSituatedSpringTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_SpringTillages);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_SpringTillages);

  AssignBody(CLOSING_PREDICATE, Body_CP_SpringTillages);
};

SerialTrellisings::SerialTrellisings() {
// =========================================================
// Une classe de Entity : 'SerialTrellisings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_TRELLISINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToTrellis();     AddMethod (pM);
  pM = new AddNewSituatedTrellisings();   AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialTrellisings::SerialTrellisings(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialTrellisings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_TRELLISINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToTrellis();     AddMethod (pM);
  pM = new AddNewSituatedTrellisings();   AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_Trellisings);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Trellisings);

  AssignBody(CLOSING_PREDICATE, Body_CP_Trellisings);
};

SerialTrellisingsIteration::SerialTrellisingsIteration() {
// =========================================================
// Une classe de Entity : 'SerialTrellisingsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_TRELLISINGS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialTrellisingsIteration::SerialTrellisingsIteration(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'SerialTrellisingsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_TRELLISINGS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Activity* pAct;
  // --------------------------------------------------
  pAct = new SerialTrellisings(pEA);
  AddElement(pAct);
  // --------------------------------------------------
};

SerialWinterTillages::SerialWinterTillages() {
// =========================================================
// Une classe de Entity : 'SerialWinterTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_WINTER_TILLAGES);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToWinterTill();  AddMethod (pM);
  pM = new AddNewSituatedWinterTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialWinterTillages::SerialWinterTillages(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialWinterTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_WINTER_TILLAGES);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToWinterTill();  AddMethod (pM);
  pM = new AddNewSituatedWinterTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_WinterTillages_OnDate);

  AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_WinterTillages);

  AssignBody(CLOSING_PREDICATE, Body_CP_WinterTillages_OnDate);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_WinterTillages);
};

void springTillagesIteration_updateReactivatedSon_Body(EntityMethod* pM)
//------------------------------------------------------------------------
// Si les conditions d'une nouvelle mise en oeuvre de l'activit� it�r�e
// sont satisfaites, ce sera fait avec les propri�t�s qui lui sont donn�es
// dans cette fonction.
//------------------------------------------------------------------------
{
  Entity* pIterate = pM->DescribedEntity();
//printf("\nt=%d DEB '%s'::URS", pCurrentSim->Clock(), pIterate->InstanceName());
  //
  // RAZ des PencentSpringTilled sur les parcelles a labourer;
  //
  Entity* pEA = App_GetVineyard((Activity*)pIterate);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_SPRING_TILLED);
	//
	// par codage du predicat de fermeture du chantier, on ne ferme pas
	// un labour si le AchievementDegree d'une activite est entre 0. et 1.
	//
	int isDone =    App_FloatEQ(percentDone, (float)1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(isDone) {
	  pPlot_k->SetFloatVarValue(PERCENT_SPRING_TILLED, (float)0.);
	}
  }
  Activity* pChantier = (Activity*)pIterate->GetElement();  // 120619
  /* obsolète 120823
  // RAZ de la date du debut de la premiere operation du chantier
  // (utilisation dans le predicat de fermeture du chantier)   // plus vrai
  //
  pChantier->SetIntConstValue(FIRST_SPRING_TILLAGE_DATE, (float)-9.);
  */
  //
  // gestion des desallocations : on desalloue les activites
  // issues du dernier selectNewPlots de l'iteration precedente...
  //
  int nbAct = pChantier->GetNumberOfOperands();  // 120619
//printf("\nnbAct = %d", nbAct);
  for(int i=nbAct-1;i>=0;i--) {
	PrimitiveActivity* pAct = (PrimitiveActivity*)pChantier->GetOperand(i);  // 120619
	//
	// voir note dans regularPhytoTreatmentsIteration_URS
	//
	int now = pCurrentSim->Clock();
	int endDate = pAct->GetIntVarValue(END_DATE);
//printf("\n'%s'::URS '%s'::end_date=%d", pIteration->InstanceName(), pAct->InstanceName(), endDate);
	if(endDate != now)
	  pAct->DeleteInDepth();
	else
	  //pChantier->RemoveElement(i);
	  pChantier->RemoveOperand(pAct);  // modif bug 120824
  }
};

bool springTillagesIteration_openingPredicate_Body(EntityMethod* pM) {
//--------------------------------------------------------------------
// Doit renvoyer vrai pour que l'activit� puisse �tre ouverte.
//--------------------------------------------------------------------
  Entity* pIterate = pM->DescribedEntity();
  Entity* pEA = App_GetVineyard((Activity*)pIterate);
  bool result = FALSE;

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year +1;
  delete pTm;

  int clockOuverture; 

  int option = App_GetIntDecisionOption(pEA, OPT_FIRST_SPRING_TILLAGE_O_P);
  switch (option) {
  case INIT_SPRING_TILLAGE : {
	Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	Boolean error = FALSE;
	int option2 = App_GetIntDecisionOption(pEA, OPT_INIT_SPRING_TILLAGE_O_P);
	if(option2 == NONE)
	  error = TRUE;
	else {
	  pEntityTab pActTab = pConduite->GetDepthElementTab(ACTIVITY);
	  if(GetPosition(pActTab, CONCURRENT_INIT_SPRING_TILLAGES) < 0
		 &&
		 GetPosition(pActTab, SERIAL_INIT_SPRING_TILLAGES) < 0) {
		error = TRUE;
	  }
	}
	if(error) {
	  printf("\n!!! Option INIT_SPRING_TILLAGE interdite pour l'ouverture de '%s' :\n!!! pas de [Concurrent Serial]InitSpringTillages dans la conduite '%s'.\n", pIterate->InstanceName(), pConduite->InstanceName());
	  exit(0);
	}
	//result = TRUE;
	result = Body_CP_InitSpringTillages_Phase3(pM);
	break;
  }
  case EARLY_MAR : {
	clockOuverture = DateToClockValue(1, 3, year);  // 1er mars
	if(now >= clockOuverture)
	  result = TRUE;
	break;
  }
  case MID_MAR : {
	clockOuverture = DateToClockValue(15, 3, year);  // 15 juilletmars
	if(now >= clockOuverture)
	  result = TRUE;
	break;
  }
  case EARLY_APR : {
	clockOuverture = DateToClockValue(1, 4, year);  // 1er avril
	if(now >= clockOuverture)
	  result = TRUE;
	break;
  }
  case MID_APR : {
	clockOuverture = DateToClockValue(15, 4, year);  // 15 juilletavril
	if(now >= clockOuverture)
	  result = TRUE;
	break;
  }
  case WINTER_RAIN_BASED : {  // + JPR 130309
	result = TRUE;
	break;
  }
  default : {
	printf("\n'%s'_OP option d'ouverture inconnue : %d", pIterate->InstanceName(), option);
	exit(0);
  } 
  } 

//printf("\n'%s'_OP returns %d", pIterate->InstanceName(), result);
  return result;
};

bool springTillagesIteration_closingPredicate_Body(EntityMethod* pM) {
  //--------------------------------------------------------------------
  // Doit renvoyer vrai pour que l'activit� puisse �tre ferm�e.
  //--------------------------------------------------------------------
  Entity* pIterate = pM->DescribedEntity();
  Vineyard* pEA = App_GetVineyard((Activity*)pIterate);
  bool result = FALSE;

  Entity* pPhase = pIterate->GetSuperSet();
  Entity* pConduite = pPhase->GetSuperSet();
  int indexPhase = pConduite->GetElementPosition(pPhase);
 
  int option = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_ITERATION_C_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)    // sept, oct, etc.
	year = year + 1;
  delete pTm;

  int clockFermeture;
  switch (option) {
  case EARLY_JUN : {
	clockFermeture = DateToClockValue(1, 6, year);  // 1er juin
	break;
  }
  case EARLY_JUL : {
	clockFermeture = DateToClockValue(1, 7, year);  // 1er juillet
	break;
  }
  case MID_JUL : {
	clockFermeture = DateToClockValue(15, 7, year);  // 15 juillet
	break;
  }
  case TEN_AUG : {
	clockFermeture = DateToClockValue(10, 8, year);  // 10 aout
	break;
  }
  default : {
	printf("\n'%s'_CP option de fermeture inconnue : %d", pIterate->InstanceName(), option);
	exit(0);

  } 
  } 
//printf("\n'%s'_CP now = %d clockFermeture %d", pIterate->InstanceName(), now, clockFermeture);
  if((now >= clockFermeture)
	 ||   // + JPR 130425 (5.6)
	 (pIterate->GetIntVarValue(REPLICATION_IN_DRY_PERIOD_COUNTER)
	  >=
	  pIterate->GetIntConstValue(MAX_REPLICATION_NUMBER_IN_DRY_PERIOD)))
	result = TRUE;

//printf("\t --> returns %d", result);
  return result;
};

SpringTillagesIteration::SpringTillagesIteration() {
// =========================================================
// Une classe de Entity : 'SpringTillagesIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SPRING_TILLAGES_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new PreviousReplicationRefDate();  AddConstantDescriptor(pD);
  pD = new MaxReplicationNumberInDryPeriod();AddConstantDescriptor(pD);
  pD = new ReplicationInDryPeriodCounter();AddVariableDescriptor(pD);
  AssignBody(UPDATE_REACTIVATED_SON, springTillagesIteration_updateReactivatedSon_Body);
  AssignBody(OPENING_PREDICATE, springTillagesIteration_openingPredicate_Body);
  AssignBody(CLOSING_PREDICATE, springTillagesIteration_closingPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SpringTillagesIteration::SpringTillagesIteration(Vineyard* pEA, char* optionSerPar) {
// =========================================================
// Une classe de Entity : 'SpringTillagesIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SPRING_TILLAGES_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new PreviousReplicationRefDate();  AddConstantDescriptor(pD);
  pD = new MaxReplicationNumberInDryPeriod();AddConstantDescriptor(pD);
  pD = new ReplicationInDryPeriodCounter();AddVariableDescriptor(pD);
  AssignBody(UPDATE_REACTIVATED_SON, springTillagesIteration_updateReactivatedSon_Body);
  AssignBody(OPENING_PREDICATE, springTillagesIteration_openingPredicate_Body);
  AssignBody(CLOSING_PREDICATE, springTillagesIteration_closingPredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  Activity* pAct;
  // --------------------------------------------------

  if(! strcmp(optionSerPar, "PAR"))
	pAct = new ConcurrentSpringTillages(pEA);
  else
	pAct = new SerialSpringTillages(pEA);
  AddElement(pAct);
  // --------------------------------------------------
  // + JPR 130425 (5.6)
  int n = gIntParam_virtualManager_springTillagesMaxNumberOfReplicationsInDryPeriod_;
  SetIntConstValue(MAX_REPLICATION_NUMBER_IN_DRY_PERIOD, n);
  // --------------------------------------------------
};

void vineyardActivity_setUserOperationName_Body(EntityMethod* pM) {
//-----------------------------------------------------------------
// M�thode invoqu�e lors de l'initialisation du processus d'avanc�e de l'op�ration,
// de l'activit�, donc une fois que celle-ci a �t� compl�tement allou�e.
//-----------------------------------------------------------------
  Entity* pInst = pM->DescribedEntity();

  Entity* pOOspec = pInst->GetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE);
  pEntityTab* ooList = pOOspec->GetEntityTabVarValue(PRE_EXPANDED_LIST);
  Entity* pPlot = (Entity*)ooList->get_element(0);

  Entity* pOt = pInst->GetEntityVarValue(ALLOCATED_OPERATION);

  char tmp[100];
  sprintf(tmp, "%s_%s", pOt->ClassName(), pPlot->InstanceName());
  pOt->SetInstanceName(tmp);

};

bool vineyardActivity_maxBegStatePredicate_Body(EntityMethod* pM) {
//-----------------------------------------------------------------
// L'�volution de l'�tat du syst�me �tant vue comme une horloge qui tourne,
// doit retourner vrai si l'instant indiqu� par cette sorte d'horloge
// est post�rieur � la fin de la fen�tre d'ouverture de l'activit�.
//-----------------------------------------------------------------
  Entity* pE = pM->DescribedEntity();

  bool result = gEveningFlag;

  return result;
};

VineyardActivity::VineyardActivity() {
// =========================================================
// Une classe de Entity : 'VineyardActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VINEYARD_ACTIVITY);
  //SetParentClassId(PRIMITIVE_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new MinPercentageToBeginOperation();AddConstantDescriptor(pD);
  pD = new MeanPriorityDegree();          AddConstantDescriptor(pD);
  Method* pM;
  pM = new OperationNominalDuration();    AddMethod (pM);
  AssignBody(SET_USER_OPERATION_NAME, vineyardActivity_setUserOperationName_Body);
  AssignBody(MAX_BEG_STATE_PREDICATE, vineyardActivity_maxBegStatePredicate_Body);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  
  //
  // Valeur par d�faut du 'pourcentage mini pouvant �tre realise avant l'arret
  // de travail' pour pouvoir debuter une operation.
  // Cette valeur est surchargee pour chaque activite manuelle.
  //
  float x = gRealParam_vineyardActivity_standardMinPercentageToBeginOperation_;
  SetFloatConstValue(MIN_PERCENTAGE_TO_BEGIN_OPERATION, x);
			  
};

VineyardControlSequence::VineyardControlSequence() {
// =========================================================
// Une classe de Entity : 'VineyardControlSequence'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VINEYARD_CONTROL_SEQUENCE);
  //SetParentClassId(ACTIVITY_BEFORE); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new VineyardAttribute();           AddConstantDescriptor(pD);
  pD = new FlagMildew();                  AddConstantDescriptor(pD);
  pD = new DownyMildewManagementAttribute();AddConstantDescriptor(pD);
  pD = new PowderyMildewManagementAttribute();AddConstantDescriptor(pD);
  Method* pM;
  pM = new SetFlagMildew();               AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

VineyardIteratedConjunctiveSubplan::VineyardIteratedConjunctiveSubplan() {
// =========================================================
// Une classe de Entity : 'VineyardIteratedConjunctiveSubplan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN);
  //SetParentClassId(ACTIVITY_CONJUNCTION); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

VineyardPhaseConjunctivePlan::VineyardPhaseConjunctivePlan() {
// =========================================================
// Une classe de Entity : 'VineyardPhaseConjunctivePlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VINEYARD_PHASE_CONJUNCTIVE_PLAN);
  //SetParentClassId(ACTIVITY_CONJUNCTION); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

VineyardPhaseOptionalPlan::VineyardPhaseOptionalPlan() {
// =========================================================
// Une classe de Entity : 'VineyardPhaseOptionalPlan'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(VINEYARD_PHASE_OPTIONAL_PLAN);
  //SetParentClassId(ACTIVITY_OPTIONAL); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ChemicalWeedingActivity::ChemicalWeedingActivity() {
// =========================================================
// Une classe de Entity : 'ChemicalWeedingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CHEMICAL_WEEDING_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new CommercialFormulationList();   AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ClippingActivity::ClippingActivity() {
// =========================================================
// Une classe de Entity : 'ClippingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CLIPPING_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, CLIPPING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ClippingActivity::ClippingActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'ClippingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CLIPPING_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, CLIPPING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr ClippingActivity pEA : '%s'", pEA->InstanceName());

  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new TractorDriverEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ARG, 1);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);

  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

ConcurrentAntiMildewTreatments::ConcurrentAntiMildewTreatments() {
// =========================================================
// Une classe de Entity : 'ConcurrentAntiMildewTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_ANTI_MILDEW_TREATMENTS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentAntiMildewTreatments::ConcurrentAntiMildewTreatments(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'ConcurrentAntiMildewTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_ANTI_MILDEW_TREATMENTS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  AssignBody(OPENING_PREDICATE, Body_OP_PhytoTreatments);
  AssignBody(CLOSING_PREDICATE, Body_CP_AntiMildewTreatments);
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_ConcurrentAntiMildewTreatments);
};

ConcurrentAutumnTillages::ConcurrentAutumnTillages() {
// =========================================================
// Une classe de Entity : 'ConcurrentAutumnTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_AUTUMN_TILLAGES);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToAutumnTill();  AddMethod (pM);
  pM = new AddNewSituatedAutumnTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentAutumnTillages::ConcurrentAutumnTillages(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'ConcurrentAutumnTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_AUTUMN_TILLAGES);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToAutumnTill();  AddMethod (pM);
  pM = new AddNewSituatedAutumnTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_AutumnTillages);
  AssignBody(CLOSING_PREDICATE, Body_CP_AutumnTillages);
  AssignBody(OPENING_PREDICATE, Body_OP_AutumnTillages);
};

ConcurrentChemicalWeedings::ConcurrentChemicalWeedings() {
// =========================================================
// Une classe de Entity : 'ConcurrentChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_CHEMICAL_WEEDINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToWeed();        AddMethod (pM);
  pM = new AddNewSituatedChemicalWeedings();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentChemicalWeedings::ConcurrentChemicalWeedings(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'ConcurrentChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_CHEMICAL_WEEDINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToWeed();        AddMethod (pM);
  pM = new AddNewSituatedChemicalWeedings();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_ChemicalWeedings); 

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_ChemicalWeedings); 

  AssignBody(CLOSING_PREDICATE, Body_CP_ChemicalWeedings);
};

ConcurrentClippings::ConcurrentClippings() {
// =========================================================
// Une classe de Entity : 'ConcurrentClippings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_CLIPPINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToClip();        AddMethod (pM);
  pM = new AddNewSituatedClippings();     AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentClippings::ConcurrentClippings(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'ConcurrentClippings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_CLIPPINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToClip();        AddMethod (pM);
  pM = new AddNewSituatedClippings();     AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_Clippings);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Clippings);

  AssignBody(CLOSING_PREDICATE, Body_CP_Clippings);
};

ConcurrentClippingsIteration::ConcurrentClippingsIteration() {
// =========================================================
// Une classe de Entity : 'ConcurrentClippingsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_CLIPPINGS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentClippingsIteration::ConcurrentClippingsIteration(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'ConcurrentClippingsIteration'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_CLIPPINGS_ITERATION);
  //SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  Activity* pAct;
  // --------------------------------------------------
  pAct = new ConcurrentClippings(pEA);
  AddElement(pAct);
  // --------------------------------------------------
};

ConcurrentDebranchings::ConcurrentDebranchings() {
// =========================================================
// Une classe de Entity : 'ConcurrentDebranchings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_DEBRANCHINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToDebranch();    AddMethod (pM);
  pM = new AddNewSituatedDebranchings();  AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ConcurrentDebranchings::ConcurrentDebranchings(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'ConcurrentDebranchings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONCURRENT_DEBRANCHINGS);
  //SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToDebranch();    AddMethod (pM);
  pM = new AddNewSituatedDebranchings();  AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_Debranchings);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Debranchings);

  AssignBody(CLOSING_PREDICATE, Body_CP_Debranchings);
};

Conduite1::Conduite1() {
// =========================================================
// Une classe de Entity : 'Conduite1'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE1);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Conduite1::Conduite1(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'Conduite1'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE1);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetEntityConstValue(VINEYARD_ATTRIBUTE, pEA);

  SetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_POWDERY_MILDEW_MANAGEMENT));
  SetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_DOWNY_MILDEW_MANAGEMENT));

  int fertSeason = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_SEASON);
//printf("\nconstruction '%s' avec fertSeason %d\n", InstanceName(), fertSeason);
  Activity* pAct;
  // ==================================================
  // phase 1 
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase1 = new VineyardPhaseConjunctivePlan();  
  //--------------------------------------------------  
  char* optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 0, AUTUMN_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentAutumnTillages(pEA);
  else
    pAct = new SerialAutumnTillages(pEA);
  pAct->AssignBody(MAX_BEG_STATE_PREDICATE, Body_CP_Phase1);
  Entity* pOpt = new ActivityOptional();
  pOpt->AddElement(pAct);
  pPhase1->AddElement(pOpt);
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 0, FERTILIZATIONS_MANAGEMENT);  
  if((fertSeason == 1) || (fertSeason == 3)) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	else
	  pAct = new SerialFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	pOpt->AddElement(pAct);
	pPhase1->AddElement(pOpt);
  }  
  //--------------------------------------------------
  this->AddElement(pPhase1);
  pPhase1->AssignBody(CLOSING_PREDICATE, Body_CP_Phase1);
  // ==================================================
  // phase 2
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase2 = new VineyardPhaseConjunctivePlan();  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, AUTUMN_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentAutumnTillages(pEA);
  else
    pAct = new SerialAutumnTillages(pEA);
  pAct->AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_OptionalPhase2);
  pOpt = new ActivityOptional();
  pOpt->AddElement(pAct);
  pPhase2->AddElement(pOpt);   
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 2);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 2);
  pAct->AssignBody(MAX_BEG_STATE_PREDICATE, Body_CP_Phase1);   
  pPhase2->AddElement(pAct);
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 2);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 2);  
  //--------------------------------------------------
  pPhase2->AddElement(pAct);  
  Entity* pOptPhase2 = new VineyardPhaseOptionalPlan();
  pOptPhase2->AddElement(pPhase2);
  pPhase2->AssignBody(OPENING_PREDICATE,
							  Body_OP_OptionalPhase2);
  pPhase2->AssignBody(MAX_BEG_STATE_PREDICATE,
							  Body_MBS_OptionalPhase2);
  pPhase2->AssignBody(CLOSING_PREDICATE,
							  Body_CP_alwaysTrue);

  this->AddElement(pOptPhase2);
  // ==================================================
  // phase 3
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase3 = new VineyardPhaseConjunctivePlan();
    
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 3);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 3);

  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CHEMICAL_WEEDINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }
  else {
    pAct = new SerialMotorizedChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 3);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 3);
 
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, INIT_SPRING_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentInitSpringTillages(pEA);
  else
    pAct = new SerialInitSpringTillages(pEA);

  pPhase3->AddElement(pAct);    
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, FERTILIZATIONS_MANAGEMENT);   
  if(fertSeason >= 2) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	else
	  pAct = new SerialFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	
	pOpt->AddElement(pAct);
	pPhase3->AddElement(pOpt);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SPRING_TILLAGES_MANAGEMENT);
  pAct = new SpringTillagesIteration(pEA, optionSerPar);
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PHYTO_MANAGEMENT);
  pAct = new PhytoTreatmentComposedProgram(pEA, optionSerPar);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, DEBRANCHINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }
  else {
    pAct = new SerialMotorizedDebranchings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }  
  //--------------------------------------------------
  // NO SPRING_CHEMICAL_WEEDINGS
  // PercentSpringWeeded initialise a -1 par construction
  //--------------------------------------------------
  pAct = new SerialTrellisings(pEA);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CLIPPINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentClippings(pEA);
  else
    pAct = new SerialClippings(pEA);

  pPhase3->AddElement(pAct);    
  //--------------------------------------------------
  pOpt = new ActivityOptional();
  pAct = new SerialPlantations(pEA);
  
  pOpt->AddElement(pAct);
  pPhase3->AddElement(pOpt);    
  //--------------------------------------------------
  
  this->AddElement(pPhase3);

  this->AddElement(pPhase3);
  pPhase3->AssignBody(OPENING_PREDICATE, Body_OP_Phase3);
  pPhase3->AssignBody(CLOSING_PREDICATE, Body_CP_Phase3);

};

Conduite2::Conduite2() {
// =========================================================
// Une classe de Entity : 'Conduite2'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE2);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Conduite2::Conduite2(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'Conduite2'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE2);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetEntityConstValue(VINEYARD_ATTRIBUTE, pEA);

  SetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_POWDERY_MILDEW_MANAGEMENT));
  SetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_DOWNY_MILDEW_MANAGEMENT));

  int fertSeason = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_SEASON);
//printf("\nconstruction '%s' avec fertSeason %d\n", InstanceName(), fertSeason);
  Activity* pAct;
  // ==================================================
  // phase 1 
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase1 = new VineyardPhaseConjunctivePlan();  
  //-------------------------------------------------- 
  // NO AUTUMN_TILLAGES

  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	pPlot_k->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
  }  
  //--------------------------------------------------
  char* optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 0, FERTILIZATIONS_MANAGEMENT);  
  if((fertSeason == 1) || (fertSeason == 3)) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	else
	  pAct = new SerialFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	pOpt->AddElement(pAct);
	pPhase1->AddElement(pOpt);
  }  
  //--------------------------------------------------
  this->AddElement(pPhase1);
  pPhase1->AssignBody(CLOSING_PREDICATE, Body_CP_Phase1);
  // ==================================================
  // phase 2
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase2 = new VineyardPhaseConjunctivePlan();  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, AUTUMN_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentAutumnTillages(pEA);
  else
    pAct = new SerialAutumnTillages(pEA);
  pAct->AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_OptionalPhase2);
  Entity* pOpt = new ActivityOptional();
  pOpt->AddElement(pAct);
  pPhase2->AddElement(pOpt);   
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 2);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 2);

  pPhase2->AddElement(pAct);    
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 2);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 2);  
  //--------------------------------------------------
  pPhase2->AddElement(pAct);  
  Entity* pOptPhase2 = new VineyardPhaseOptionalPlan();
  pOptPhase2->AddElement(pPhase2);
  pPhase2->AssignBody(OPENING_PREDICATE,
							  Body_OP_OptionalPhase2);
  pPhase2->AssignBody(MAX_BEG_STATE_PREDICATE,
							  Body_MBS_OptionalPhase2);
  pPhase2->AssignBody(CLOSING_PREDICATE,
							  Body_CP_alwaysTrue);

  this->AddElement(pOptPhase2);
  // ==================================================
  // phase 3
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase3 = new VineyardPhaseConjunctivePlan();
    
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 3);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 3);

  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CHEMICAL_WEEDINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }
  else {
    pAct = new SerialMotorizedChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 3);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 3);
 
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  // NO INIT_SPRING_TILLAGES

  //int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	pPlot_k->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
  }  
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, FERTILIZATIONS_MANAGEMENT);   
  if(fertSeason >= 2) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	else
	  pAct = new SerialFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	
	pOpt->AddElement(pAct);
	pPhase3->AddElement(pOpt);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SPRING_TILLAGES_MANAGEMENT);
  pAct = new SpringTillagesIteration(pEA, optionSerPar);
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PHYTO_MANAGEMENT);
  pAct = new PhytoTreatmentComposedProgram(pEA, optionSerPar);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, DEBRANCHINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }
  else {
    pAct = new SerialMotorizedDebranchings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SPRING_CHEMICAL_WEEDINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentSpringChemicalWeedings(pEA);
    pPhase3->AddElement(pAct); 
  }
  else {
    pAct = new SerialMotorizedSpringChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualSpringChemicalWeedings(pEA);
    pPhase3->AddElement(pAct); 
  }  
  //--------------------------------------------------
  pAct = new SerialTrellisings(pEA);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CLIPPINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentClippings(pEA);
  else
    pAct = new SerialClippings(pEA);

  pPhase3->AddElement(pAct);    
  //--------------------------------------------------
  pOpt = new ActivityOptional();
  pAct = new SerialPlantations(pEA);
  
  pOpt->AddElement(pAct);
  pPhase3->AddElement(pOpt);    
  //--------------------------------------------------

  this->AddElement(pPhase3);
  pPhase3->AssignBody(OPENING_PREDICATE, Body_OP_Phase3);
  pPhase3->AssignBody(CLOSING_PREDICATE, Body_CP_Phase3);

};

Conduite3::Conduite3() {
// =========================================================
// Une classe de Entity : 'Conduite3'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE3);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Conduite3::Conduite3(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'Conduite3'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE3);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetEntityConstValue(VINEYARD_ATTRIBUTE, pEA);

  SetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_POWDERY_MILDEW_MANAGEMENT));
  SetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_DOWNY_MILDEW_MANAGEMENT));

  int fertSeason = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_SEASON);
//printf("\nconstruction '%s' avec fertSeason %d\n", InstanceName(), fertSeason);
  Activity* pAct;
  // ==================================================
  // phase 1 
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase1 = new VineyardPhaseConjunctivePlan();  
  //-------------------------------------------------- 
  // NO AUTUMN_TILLAGES

  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	pPlot_k->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
  }  
  //--------------------------------------------------
  char* optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 0, FERTILIZATIONS_MANAGEMENT);  
  if((fertSeason == 1) || (fertSeason == 3)) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	else
	  pAct = new SerialFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	pOpt->AddElement(pAct);
	pPhase1->AddElement(pOpt);
  }  
  //--------------------------------------------------
  this->AddElement(pPhase1);
  pPhase1->AssignBody(CLOSING_PREDICATE, Body_CP_Phase1);
  // ==================================================
  // phase 2
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase2 = new VineyardPhaseConjunctivePlan();  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, AUTUMN_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentAutumnTillages(pEA);
  else
    pAct = new SerialAutumnTillages(pEA);
  pAct->AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_OptionalPhase2);
  Entity* pOpt = new ActivityOptional();
  pOpt->AddElement(pAct);
  pPhase2->AddElement(pOpt);    
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 2);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 2);

  pPhase2->AddElement(pAct);    
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 2);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 2);  
  //--------------------------------------------------
  pPhase2->AddElement(pAct);  
  Entity* pOptPhase2 = new VineyardPhaseOptionalPlan();
  pOptPhase2->AddElement(pPhase2);
  pPhase2->AssignBody(OPENING_PREDICATE,
							  Body_OP_OptionalPhase2);
  pPhase2->AssignBody(MAX_BEG_STATE_PREDICATE,
							  Body_MBS_OptionalPhase2);
  pPhase2->AssignBody(CLOSING_PREDICATE,
							  Body_CP_alwaysTrue);

  this->AddElement(pOptPhase2);
  // ==================================================
  // phase 3
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase3 = new VineyardPhaseConjunctivePlan();
    
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 3);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 3);

  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CHEMICAL_WEEDINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }
  else {
    pAct = new SerialMotorizedChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 3);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 3);
 
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  // NO INIT_SPRING_TILLAGES

  //int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	pPlot_k->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
  }  
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, FERTILIZATIONS_MANAGEMENT);   
  if(fertSeason >= 2) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	else
	  pAct = new SerialFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	
	pOpt->AddElement(pAct);
	pPhase3->AddElement(pOpt);
  }  
  //--------------------------------------------------
  // NO SPRING_TILLAGES   

  //int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	pPlot_k->SetFloatVarValue(PERCENT_SPRING_TILLED, (float)-1.);
  }  
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PHYTO_MANAGEMENT);
  pAct = new PhytoTreatmentComposedProgram(pEA, optionSerPar);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, DEBRANCHINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }
  else {
    pAct = new SerialMotorizedDebranchings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }  
  //--------------------------------------------------
  // NO SPRING_CHEMICAL_WEEDINGS
  // PercentSpringWeeded initialise a -1 par construction
  //--------------------------------------------------
  pAct = new SerialTrellisings(pEA);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CLIPPINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentClippings(pEA);
  else
    pAct = new SerialClippings(pEA);

  pPhase3->AddElement(pAct);    
  //--------------------------------------------------
  pOpt = new ActivityOptional();
  pAct = new SerialPlantations(pEA);
  
  pOpt->AddElement(pAct);
  pPhase3->AddElement(pOpt);    
  //--------------------------------------------------

  this->AddElement(pPhase3);
  pPhase3->AssignBody(OPENING_PREDICATE, Body_OP_Phase3);
  pPhase3->AssignBody(CLOSING_PREDICATE, Body_CP_Phase3);

};

Conduite4::Conduite4() {
// =========================================================
// Une classe de Entity : 'Conduite4'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE4);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Conduite4::Conduite4(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'Conduite4'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE4);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetEntityConstValue(VINEYARD_ATTRIBUTE, pEA);

  SetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_POWDERY_MILDEW_MANAGEMENT));
  SetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_DOWNY_MILDEW_MANAGEMENT));

  int fertSeason = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_SEASON);
//printf("\nconstruction '%s' avec fertSeason %d\n", InstanceName(), fertSeason);
  Activity* pAct;
  // ==================================================
  // phase 1 
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase1 = new VineyardPhaseConjunctivePlan();  
  //--------------------------------------------------  
  // NO AUTUMN_TILLAGES

  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	pPlot_k->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
  }  
  //--------------------------------------------------
  char* optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 0, FERTILIZATIONS_MANAGEMENT);  
  if((fertSeason == 1) || (fertSeason == 3)) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	else
	  pAct = new SerialFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	pOpt->AddElement(pAct);
	pPhase1->AddElement(pOpt);
  }  
  //--------------------------------------------------
  this->AddElement(pPhase1);
  pPhase1->AssignBody(CLOSING_PREDICATE, Body_CP_Phase1);
  // ==================================================
  // phase 2
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase2 = new VineyardPhaseConjunctivePlan();  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, AUTUMN_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentAutumnTillages(pEA);
  else
    pAct = new SerialAutumnTillages(pEA);
  pAct->AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_OptionalPhase2);
  Entity* pOpt = new ActivityOptional();
  pOpt->AddElement(pAct);
  pPhase2->AddElement(pOpt);    
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 2);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 2);

  pPhase2->AddElement(pAct);    
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 2);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 2);  
  //--------------------------------------------------
  pPhase2->AddElement(pAct);  
  Entity* pOptPhase2 = new VineyardPhaseOptionalPlan();
  pOptPhase2->AddElement(pPhase2);
  pPhase2->AssignBody(OPENING_PREDICATE,
							  Body_OP_OptionalPhase2);
  pPhase2->AssignBody(MAX_BEG_STATE_PREDICATE,
							  Body_MBS_OptionalPhase2);
  pPhase2->AssignBody(CLOSING_PREDICATE,
							  Body_CP_alwaysTrue);

  this->AddElement(pOptPhase2);
  // ==================================================
  // phase 3
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase3 = new VineyardPhaseConjunctivePlan();
    
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 3);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 3);

  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CHEMICAL_WEEDINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }
  else {
    pAct = new SerialMotorizedChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 3);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 3);
 
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, INIT_SPRING_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentInitSpringTillages(pEA);
  else
    pAct = new SerialInitSpringTillages(pEA);

  pPhase3->AddElement(pAct);    
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, FERTILIZATIONS_MANAGEMENT);   
  if(fertSeason >= 2) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	else
	  pAct = new SerialFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	
	pOpt->AddElement(pAct);
	pPhase3->AddElement(pOpt);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SPRING_TILLAGES_MANAGEMENT);
  pAct = new SpringTillagesIteration(pEA, optionSerPar);
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PHYTO_MANAGEMENT);
  pAct = new PhytoTreatmentComposedProgram(pEA, optionSerPar);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, DEBRANCHINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }
  else {
    pAct = new SerialMotorizedDebranchings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }  
  //--------------------------------------------------
  // NO SPRING_CHEMICAL_WEEDINGS
  // PercentSpringWeeded initialise a -1 par construction
  //--------------------------------------------------
  pAct = new SerialTrellisings(pEA);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CLIPPINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentClippings(pEA);
  else
    pAct = new SerialClippings(pEA);

  pPhase3->AddElement(pAct);    
  //--------------------------------------------------
  pOpt = new ActivityOptional();
  pAct = new SerialPlantations(pEA);
  
  pOpt->AddElement(pAct);
  pPhase3->AddElement(pOpt);    
  //--------------------------------------------------
  
  this->AddElement(pPhase3);

  this->AddElement(pPhase3);
  pPhase3->AssignBody(OPENING_PREDICATE, Body_OP_Phase3);
  pPhase3->AssignBody(CLOSING_PREDICATE, Body_CP_Phase3);

};

Conduite5::Conduite5() {
// =========================================================
// Une classe de Entity : 'Conduite5'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE5);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

Conduite5::Conduite5(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'Conduite5'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(CONDUITE5);
  //SetParentClassId(VINEYARD_CONTROL_SEQUENCE); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  SetEntityConstValue(VINEYARD_ATTRIBUTE, pEA);

  SetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_POWDERY_MILDEW_MANAGEMENT));
  SetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE, 
				   App_GetIntDecisionOption(pEA, 
											OPT_DOWNY_MILDEW_MANAGEMENT));

  int fertSeason = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_SEASON);
//printf("\nconstruction '%s' avec fertSeason %d\n", InstanceName(), fertSeason);
  Activity* pAct;
  // ==================================================
  // phase 1 
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase1 = new VineyardPhaseConjunctivePlan();  
  //--------------------------------------------------  
  char* optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 0, AUTUMN_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentAutumnTillages(pEA);
  else
    pAct = new SerialAutumnTillages(pEA);
  pAct->AssignBody(MAX_BEG_STATE_PREDICATE, Body_CP_Phase1);
  Entity* pOpt = new ActivityOptional();
  pOpt->AddElement(pAct);
  pPhase1->AddElement(pOpt);    
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 0, FERTILIZATIONS_MANAGEMENT);  
  if((fertSeason == 1) || (fertSeason == 3)) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	else
	  pAct = new SerialFertilizations(pEA, 1, 1); // 1 = AUTUMN ; phase 1
	pOpt->AddElement(pAct);
	pPhase1->AddElement(pOpt);
  }  
  //--------------------------------------------------
  this->AddElement(pPhase1);
  pPhase1->AssignBody(CLOSING_PREDICATE, Body_CP_Phase1);
  // ==================================================
  // phase 2
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase2 = new VineyardPhaseConjunctivePlan();  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, AUTUMN_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentAutumnTillages(pEA);
  else
    pAct = new SerialAutumnTillages(pEA);
  pAct->AssignBody(MAX_BEG_STATE_PREDICATE, Body_MBS_OptionalPhase2);
  pOpt = new ActivityOptional();
  pOpt->AddElement(pAct);
  pPhase2->AddElement(pOpt);   
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 2);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 2);

  pPhase2->AddElement(pAct);    
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 1, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 2);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 2);  
  //--------------------------------------------------
  pPhase2->AddElement(pAct);  
  Entity* pOptPhase2 = new VineyardPhaseOptionalPlan();
  pOptPhase2->AddElement(pPhase2);
  pPhase2->AssignBody(OPENING_PREDICATE,
							  Body_OP_OptionalPhase2);
  pPhase2->AssignBody(MAX_BEG_STATE_PREDICATE,
							  Body_MBS_OptionalPhase2);
  pPhase2->AssignBody(CLOSING_PREDICATE,
							  Body_CP_alwaysTrue);

  this->AddElement(pOptPhase2);
  // ==================================================
  // phase 3
  // ==================================================
  VineyardPhaseConjunctivePlan* pPhase3 = new VineyardPhaseConjunctivePlan();
    
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PRUNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentPrunings(pEA, 3);  // numPhase
  else
    pAct = new SerialPrunings(pEA, 3);

  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CHEMICAL_WEEDINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }
  else {
    pAct = new SerialMotorizedChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SHOOT_THINNINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentShootThinnings(pEA, 3);  // numPhase
  else
    pAct = new SerialShootThinnings(pEA, 3);
 
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, INIT_SPRING_TILLAGES_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentInitSpringTillages(pEA);
  else
    pAct = new SerialInitSpringTillages(pEA);

  pPhase3->AddElement(pAct);    
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, FERTILIZATIONS_MANAGEMENT);   
  if(fertSeason >= 2) {
	Entity* pOpt = new ActivityOptional();
	if(! strcmp(optionSerPar, "PAR"))
	  pAct = new ConcurrentFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	else
	  pAct = new SerialFertilizations(pEA, 2, 3); // 2 = SPRING ; phase 3
	
	pOpt->AddElement(pAct);
	pPhase3->AddElement(pOpt);
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SPRING_TILLAGES_MANAGEMENT);
  pAct = new SpringTillagesIteration(pEA, optionSerPar);
  pPhase3->AddElement(pAct);   
  //-------------------------------------------------- 
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, PHYTO_MANAGEMENT);
  pAct = new PhytoTreatmentComposedProgram(pEA, optionSerPar);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------

  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, DEBRANCHINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }
  else {
    pAct = new SerialMotorizedDebranchings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualDebranchings(pEA);
    pPhase3->AddElement(pAct); 
  }  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, SPRING_CHEMICAL_WEEDINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR")) {
    pAct = new ConcurrentSpringChemicalWeedings(pEA);
    pPhase3->AddElement(pAct); 
  }
  else {
    pAct = new SerialMotorizedSpringChemicalWeedings(pEA);
    pPhase3->AddElement(pAct);
    pAct = new SerialManualSpringChemicalWeedings(pEA);
    pPhase3->AddElement(pAct); 
  }  
  //--------------------------------------------------
  pAct = new SerialTrellisings(pEA);
  pPhase3->AddElement(pAct);  
  //--------------------------------------------------
  optionSerPar = 
	App_GetStringWorkOrganizationOption(pEA, 2, CLIPPINGS_MANAGEMENT);
  if(! strcmp(optionSerPar, "PAR"))
    pAct = new ConcurrentClippings(pEA);
  else
    pAct = new SerialClippings(pEA);

  pPhase3->AddElement(pAct);    
  //--------------------------------------------------
  pOpt = new ActivityOptional();
  pAct = new SerialPlantations(pEA);
  
  pOpt->AddElement(pAct);
  pPhase3->AddElement(pOpt);    
  //--------------------------------------------------

  this->AddElement(pPhase3);
  pPhase3->AssignBody(OPENING_PREDICATE, Body_OP_Phase3);
  pPhase3->AssignBody(CLOSING_PREDICATE, Body_CP_Phase3);

};

DebranchingActivity::DebranchingActivity() {
// =========================================================
// Une classe de Entity : 'DebranchingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(DEBRANCHING_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

FertilizationActivity::FertilizationActivity() {
// =========================================================
// Une classe de Entity : 'FertilizationActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FERTILIZATION_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, FERTILIZATION_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

FertilizationActivity::FertilizationActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'FertilizationActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FERTILIZATION_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, FERTILIZATION_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***


//printf("\nconstr FertilizationActivity pEA : '%s'", pEA->InstanceName());
  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new TractorDriverEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ARG, 1);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

ManualChemicalDebranchingActivity::ManualChemicalDebranchingActivity() {
// =========================================================
// Une classe de Entity : 'ManualChemicalDebranchingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MANUAL_CHEMICAL_DEBRANCHING_ACTIVITY);
  //SetParentClassId(DEBRANCHING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new CommercialFormulationList();   AddConstantDescriptor(pD);
  SetIntVarValue(OPERATION_CLASS_ID, BACK_SPRAYING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ManualChemicalDebranchingActivity::ManualChemicalDebranchingActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'ManualChemicalDebranchingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MANUAL_CHEMICAL_DEBRANCHING_ACTIVITY);
  //SetParentClassId(DEBRANCHING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new CommercialFormulationList();   AddConstantDescriptor(pD);
  SetIntVarValue(OPERATION_CLASS_ID, BACK_SPRAYING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr ManualChemicalDebranchingActivity pEA : '%s'", pEA->InstanceName());

  SetFloatConstValue(MIN_PERCENTAGE_TO_BEGIN_OPERATION, (float)0.);

  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new ManualWorkerEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  //pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, DISJ); // 121211 (5.1)
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ARG, 1);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  //pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

ManualChemicalWeedingActivity::ManualChemicalWeedingActivity() {
// =========================================================
// Une classe de Entity : 'ManualChemicalWeedingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MANUAL_CHEMICAL_WEEDING_ACTIVITY);
  //SetParentClassId(CHEMICAL_WEEDING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, BACK_SPRAYING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ManualChemicalWeedingActivity::ManualChemicalWeedingActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'ManualChemicalWeedingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MANUAL_CHEMICAL_WEEDING_ACTIVITY);
  //SetParentClassId(CHEMICAL_WEEDING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, BACK_SPRAYING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr ManualChemicalWeedingActivity pEA : '%s'", pEA->InstanceName());

  SetFloatConstValue(MIN_PERCENTAGE_TO_BEGIN_OPERATION, (float)0.);

  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new ManualWorkerEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  //pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, DISJ); // 121211 (5.1)
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ARG, 1);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  //pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

ManualMechanicalDebranchingActivity::ManualMechanicalDebranchingActivity() {
// =========================================================
// Une classe de Entity : 'ManualMechanicalDebranchingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MANUAL_MECHANICAL_DEBRANCHING_ACTIVITY);
  //SetParentClassId(DEBRANCHING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, MANUAL_DEBRANCHING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ManualMechanicalDebranchingActivity::ManualMechanicalDebranchingActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'ManualMechanicalDebranchingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MANUAL_MECHANICAL_DEBRANCHING_ACTIVITY);
  //SetParentClassId(DEBRANCHING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, MANUAL_DEBRANCHING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr ManualMechanicalDebranchingActivity pEA : '%s'", pEA->InstanceName());

  SetFloatConstValue(MIN_PERCENTAGE_TO_BEGIN_OPERATION, (float)0.);

  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new GreenWorkExecutorEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, MAX);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  //pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

MotorizedChemicalDebranchingActivity::MotorizedChemicalDebranchingActivity() {
// =========================================================
// Une classe de Entity : 'MotorizedChemicalDebranchingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MOTORIZED_CHEMICAL_DEBRANCHING_ACTIVITY);
  //SetParentClassId(DEBRANCHING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new CommercialFormulationList();   AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

MotorizedChemicalDebranchingActivity::MotorizedChemicalDebranchingActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'MotorizedChemicalDebranchingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MOTORIZED_CHEMICAL_DEBRANCHING_ACTIVITY);
  //SetParentClassId(DEBRANCHING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new CommercialFormulationList();   AddConstantDescriptor(pD);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  
  //
  // Ersatz local d'un futur ReturnOperationClassId
  //
  pEntityTab* tmp = GetEntityList(DEBRANCHING_SPRAYER);
  if(tmp->size() > 0)
	SetIntVarValue(OPERATION_CLASS_ID, CHEMICAL_DEBRANCHER_OPERATED_SPRAYING);
  else
	SetIntVarValue(OPERATION_CLASS_ID, HAND_HELD_GUN_OPERATED_SPRAYING);


//printf("\nconstr MotorizedChemicalDebranchingActivity pEA : '%s'", pEA->InstanceName());
  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new TractorDriverEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ARG, 1);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

MotorizedChemicalWeedingActivity::MotorizedChemicalWeedingActivity() {
// =========================================================
// Une classe de Entity : 'MotorizedChemicalWeedingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MOTORIZED_CHEMICAL_WEEDING_ACTIVITY);
  //SetParentClassId(CHEMICAL_WEEDING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

MotorizedChemicalWeedingActivity::MotorizedChemicalWeedingActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'MotorizedChemicalWeedingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MOTORIZED_CHEMICAL_WEEDING_ACTIVITY);
  //SetParentClassId(CHEMICAL_WEEDING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***


//printf("\nconstr MotorizedChemicalWeedingActivity pEA : '%s'", pEA->InstanceName());
  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new TractorDriverEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ARG, 1);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

PhytoTreatmentActivity::PhytoTreatmentActivity() {
// =========================================================
// Une classe de Entity : 'PhytoTreatmentActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PHYTO_TREATMENT_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  Descriptor* pD;
  pD = new PhytoTreatmentList();          AddConstantDescriptor(pD);
  pD = new CommercialFormulationList();   AddConstantDescriptor(pD);
  pD = new CommercialFormulationDose();   AddConstantDescriptor(pD);
  Method* pM;
  pM = new ReturnPhytoTreatmentOperationSubclass();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PlantationActivity::PlantationActivity() {
// =========================================================
// Une classe de Entity : 'PlantationActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PLANTATION_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, PLANTATION_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PlantationActivity::PlantationActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'PlantationActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PLANTATION_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, PLANTATION_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr PlantationActivity pEA : '%s'", pEA->InstanceName());

  SetFloatConstValue(MIN_PERCENTAGE_TO_BEGIN_OPERATION, (float)0.);

  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new ManualWorkerEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, MAX);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  //pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

PruningActivity::PruningActivity() {
// =========================================================
// Une classe de Entity : 'PruningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PRUNING_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, 50);
  SetIntVarValue(OPERATION_CLASS_ID, PRUNING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

PruningActivity::PruningActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'PruningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(PRUNING_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, 50);
  SetIntVarValue(OPERATION_CLASS_ID, PRUNING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr PruningActivity pEA : '%s'", pEA->InstanceName());

  SetFloatConstValue(MIN_PERCENTAGE_TO_BEGIN_OPERATION, (float)0.);

  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new PruningExecutorEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, MAX);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  //pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

RoyatPruningActivity::RoyatPruningActivity() {
// =========================================================
// Une classe de Entity : 'RoyatPruningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ROYAT_PRUNING_ACTIVITY);
  //SetParentClassId(PRUNING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

RoyatPruningActivity::RoyatPruningActivity(Vineyard* pEA)
: PruningActivity(pEA) {
// =========================================================
// Une classe de Entity : 'RoyatPruningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(ROYAT_PRUNING_ACTIVITY);
  //SetParentClassId(PRUNING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialAntiMildewTreatments::SerialAntiMildewTreatments() {
// =========================================================
// Une classe de Entity : 'SerialAntiMildewTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_ANTI_MILDEW_TREATMENTS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialAntiMildewTreatments::SerialAntiMildewTreatments(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'SerialAntiMildewTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_ANTI_MILDEW_TREATMENTS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new AddNewSituatedPhytoTreatments();AddMethod (pM);
  pM = new SelectNewPlotsToPhytoProtect();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  AssignBody(OPENING_PREDICATE, Body_OP_PhytoTreatments);
  AssignBody(CLOSING_PREDICATE, Body_CP_AntiMildewTreatments);
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_SerialAntiMildewTreatments);
};

SerialAutumnTillages::SerialAutumnTillages() {
// =========================================================
// Une classe de Entity : 'SerialAutumnTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_AUTUMN_TILLAGES);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToAutumnTill();  AddMethod (pM);
  pM = new AddNewSituatedAutumnTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialAutumnTillages::SerialAutumnTillages(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'SerialAutumnTillages'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_AUTUMN_TILLAGES);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToAutumnTill();  AddMethod (pM);
  pM = new AddNewSituatedAutumnTillages();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_AutumnTillages);
  AssignBody(CLOSING_PREDICATE, Body_CP_AutumnTillages);
  AssignBody(OPENING_PREDICATE, Body_OP_AutumnTillages);
};

SerialChemicalWeedings::SerialChemicalWeedings() {
// =========================================================
// Une classe de Entity : 'SerialChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToWeed();        AddMethod (pM);
  pM = new AddNewSituatedChemicalWeedings();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialChemicalWeedings::SerialChemicalWeedings(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToWeed();        AddMethod (pM);
  pM = new AddNewSituatedChemicalWeedings();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_ChemicalWeedings); 

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_ChemicalWeedings); 

  AssignBody(CLOSING_PREDICATE, Body_CP_ChemicalWeedings);
};

SerialClippings::SerialClippings() {
// =========================================================
// Une classe de Entity : 'SerialClippings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_CLIPPINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToClip();        AddMethod (pM);
  pM = new AddNewSituatedClippings();     AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialClippings::SerialClippings(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialClippings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_CLIPPINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToClip();        AddMethod (pM);
  pM = new AddNewSituatedClippings();     AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_Clippings);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Clippings);

  AssignBody(CLOSING_PREDICATE, Body_CP_Clippings);
};

SerialDebranchings::SerialDebranchings() {
// =========================================================
// Une classe de Entity : 'SerialDebranchings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_DEBRANCHINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToDebranch();    AddMethod (pM);
  pM = new AddNewSituatedDebranchings();  AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialDebranchings::SerialDebranchings(Vineyard* pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialDebranchings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_DEBRANCHINGS);
  //SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET); // pour memoire (*)
  AddInstanceToClass();
  Method* pM;
  pM = new SelectNewPlotsToDebranch();    AddMethod (pM);
  pM = new AddNewSituatedDebranchings();  AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

  AssignBody(OPENING_PREDICATE, Body_OP_Debranchings);

  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_Debranchings);

  AssignBody(CLOSING_PREDICATE, Body_CP_Debranchings);
};

SerialManualChemicalWeedings::SerialManualChemicalWeedings() {
// =========================================================
// Une classe de Entity : 'SerialManualChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MANUAL_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_CHEMICAL_WEEDINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialManualChemicalWeedings::SerialManualChemicalWeedings(Vineyard* pVineyard) : SerialChemicalWeedings(pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialManualChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MANUAL_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_CHEMICAL_WEEDINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialManualDebranchings::SerialManualDebranchings() {
// =========================================================
// Une classe de Entity : 'SerialManualDebranchings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MANUAL_DEBRANCHINGS);
  //SetParentClassId(SERIAL_DEBRANCHINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialManualDebranchings::SerialManualDebranchings(Vineyard* pVineyard)
: SerialDebranchings(pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialManualDebranchings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MANUAL_DEBRANCHINGS);
  //SetParentClassId(SERIAL_DEBRANCHINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialManualRegularPhytoTreatments::SerialManualRegularPhytoTreatments() {
// =========================================================
// Une classe de Entity : 'SerialManualRegularPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS);
  //SetParentClassId(SERIAL_REGULAR_PHYTO_TREATMENTS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialManualRegularPhytoTreatments::SerialManualRegularPhytoTreatments(Vineyard* pVineyard)
: SerialRegularPhytoTreatments(pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialManualRegularPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS);
  //SetParentClassId(SERIAL_REGULAR_PHYTO_TREATMENTS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_SerialManualRegularPhytoTreatments);
};

SerialManualSpringChemicalWeedings::SerialManualSpringChemicalWeedings() {
// =========================================================
// Une classe de Entity : 'SerialManualSpringChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_SPRING_CHEMICAL_WEEDINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialManualSpringChemicalWeedings::SerialManualSpringChemicalWeedings(Vineyard* pVineyard)
: SerialSpringChemicalWeedings(pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialManualSpringChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_SPRING_CHEMICAL_WEEDINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialMotorizedChemicalWeedings::SerialMotorizedChemicalWeedings() {
// =========================================================
// Une classe de Entity : 'SerialMotorizedChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MOTORIZED_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_CHEMICAL_WEEDINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialMotorizedChemicalWeedings::SerialMotorizedChemicalWeedings(Vineyard* pVineyard)
: SerialChemicalWeedings(pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialMotorizedChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MOTORIZED_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_CHEMICAL_WEEDINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialMotorizedDebranchings::SerialMotorizedDebranchings() {
// =========================================================
// Une classe de Entity : 'SerialMotorizedDebranchings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MOTORIZED_DEBRANCHINGS);
  //SetParentClassId(SERIAL_DEBRANCHINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialMotorizedDebranchings::SerialMotorizedDebranchings(Vineyard* pVineyard)
: SerialDebranchings(pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialMotorizedDebranchings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MOTORIZED_DEBRANCHINGS);
  //SetParentClassId(SERIAL_DEBRANCHINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialMotorizedRegularPhytoTreatments::SerialMotorizedRegularPhytoTreatments() {
// =========================================================
// Une classe de Entity : 'SerialMotorizedRegularPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS);
  //SetParentClassId(SERIAL_REGULAR_PHYTO_TREATMENTS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialMotorizedRegularPhytoTreatments::SerialMotorizedRegularPhytoTreatments(Vineyard* pVineyard)
: SerialRegularPhytoTreatments(pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialMotorizedRegularPhytoTreatments'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS);
  //SetParentClassId(SERIAL_REGULAR_PHYTO_TREATMENTS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
  AssignBody(MODIFY_IN_OPEN_SITUATION, Body_MIOS_SerialMotorizedRegularPhytoTreatments);
};

SerialMotorizedSpringChemicalWeedings::SerialMotorizedSpringChemicalWeedings() {
// =========================================================
// Une classe de Entity : 'SerialMotorizedSpringChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MOTORIZED_SPRING_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_SPRING_CHEMICAL_WEEDINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SerialMotorizedSpringChemicalWeedings::SerialMotorizedSpringChemicalWeedings(Vineyard* pVineyard)
: SerialSpringChemicalWeedings(pVineyard) {
// =========================================================
// Une classe de Entity : 'SerialMotorizedSpringChemicalWeedings'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SERIAL_MOTORIZED_SPRING_CHEMICAL_WEEDINGS);
  //SetParentClassId(SERIAL_SPRING_CHEMICAL_WEEDINGS); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ShootThinningActivity::ShootThinningActivity() {
// =========================================================
// Une classe de Entity : 'ShootThinningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SHOOT_THINNING_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, SHOOT_THINNING_OPERATION);
  Method* pM;
  pM = new ReturnShootThinningOperationSubclass();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ShootThinningActivity::ShootThinningActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'ShootThinningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SHOOT_THINNING_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, SHOOT_THINNING_OPERATION);
  Method* pM;
  pM = new ReturnShootThinningOperationSubclass();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr ShootThinningActivity pEA : '%s'", pEA->InstanceName());
  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new TractorDriverEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ARG, 1);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

TillageActivity::TillageActivity() {
// =========================================================
// Une classe de Entity : 'TillageActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(TILLAGE_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, TILLAGE_OPERATION);
  Method* pM;
  pM = new ReturnTillageOperationSubclass();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

TillageActivity::TillageActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'TillageActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(TILLAGE_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, TILLAGE_OPERATION);
  Method* pM;
  pM = new ReturnTillageOperationSubclass();AddMethod (pM);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr TillageActivity pEA : '%s'", pEA->InstanceName());
  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new TillageTractorDriverEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ARG, 1);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

TrellisingActivity::TrellisingActivity() {
// =========================================================
// Une classe de Entity : 'TrellisingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(TRELLISING_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, TRELLISING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

TrellisingActivity::TrellisingActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'TrellisingActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(TRELLISING_ACTIVITY);
  //SetParentClassId(VINEYARD_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, TRELLISING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr TrellisingActivity pEA : '%s'", pEA->InstanceName());

  SetFloatConstValue(MIN_PERCENTAGE_TO_BEGIN_OPERATION, (float)0.);

  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new GreenWorkExecutorEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, MAX);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  //pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

WinterTillageActivity::WinterTillageActivity() {
// =========================================================
// Une classe de Entity : 'WinterTillageActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(WINTER_TILLAGE_ACTIVITY);
  //SetParentClassId(TILLAGE_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

WinterTillageActivity::WinterTillageActivity(Vineyard* pEA) 
: TillageActivity(pEA) {
// =========================================================
// Une classe de Entity : 'WinterTillageActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(WINTER_TILLAGE_ACTIVITY);
  //SetParentClassId(TILLAGE_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

AutumnTillageActivity::AutumnTillageActivity() {
// =========================================================
// Une classe de Entity : 'AutumnTillageActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(AUTUMN_TILLAGE_ACTIVITY);
  //SetParentClassId(TILLAGE_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

AutumnTillageActivity::AutumnTillageActivity(Vineyard* pEA) 
: TillageActivity(pEA) {
// =========================================================
// Une classe de Entity : 'AutumnTillageActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(AUTUMN_TILLAGE_ACTIVITY);
  //SetParentClassId(TILLAGE_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

FormationPruningActivity::FormationPruningActivity() {
// =========================================================
// Une classe de Entity : 'FormationPruningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FORMATION_PRUNING_ACTIVITY);
  //SetParentClassId(PRUNING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

FormationPruningActivity::FormationPruningActivity(Vineyard* pEA)
: PruningActivity(pEA) {
// =========================================================
// Une classe de Entity : 'FormationPruningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(FORMATION_PRUNING_ACTIVITY);
  //SetParentClassId(PRUNING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

GobeletPruningActivity::GobeletPruningActivity() {
// =========================================================
// Une classe de Entity : 'GobeletPruningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GOBELET_PRUNING_ACTIVITY);
  //SetParentClassId(PRUNING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

GobeletPruningActivity::GobeletPruningActivity(Vineyard* pEA)
: PruningActivity(pEA) {
// =========================================================
// Une classe de Entity : 'GobeletPruningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GOBELET_PRUNING_ACTIVITY);
  //SetParentClassId(PRUNING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

GuyotPruningActivity::GuyotPruningActivity() {
// =========================================================
// Une classe de Entity : 'GuyotPruningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GUYOT_PRUNING_ACTIVITY);
  //SetParentClassId(PRUNING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

GuyotPruningActivity::GuyotPruningActivity(Vineyard* pEA)
: PruningActivity(pEA) {
// =========================================================
// Une classe de Entity : 'GuyotPruningActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(GUYOT_PRUNING_ACTIVITY);
  //SetParentClassId(PRUNING_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

InitSpringTillageActivity::InitSpringTillageActivity() {
// =========================================================
// Une classe de Entity : 'InitSpringTillageActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(INIT_SPRING_TILLAGE_ACTIVITY);
  //SetParentClassId(TILLAGE_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

InitSpringTillageActivity::InitSpringTillageActivity(Vineyard* pEA) 
: TillageActivity(pEA) {
// =========================================================
// Une classe de Entity : 'InitSpringTillageActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(INIT_SPRING_TILLAGE_ACTIVITY);
  //SetParentClassId(TILLAGE_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ManualPhytoTreatmentActivity::ManualPhytoTreatmentActivity() {
// =========================================================
// Une classe de Entity : 'ManualPhytoTreatmentActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MANUAL_PHYTO_TREATMENT_ACTIVITY);
  //SetParentClassId(PHYTO_TREATMENT_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, BACK_SPRAYING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

ManualPhytoTreatmentActivity::ManualPhytoTreatmentActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'ManualPhytoTreatmentActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MANUAL_PHYTO_TREATMENT_ACTIVITY);
  //SetParentClassId(PHYTO_TREATMENT_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
  SetIntVarValue(OPERATION_CLASS_ID, BACK_SPRAYING_OPERATION);
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr ManualPhytoTreatmentActivity pEA : '%s'", pEA->InstanceName());

  SetFloatConstValue(MIN_PERCENTAGE_TO_BEGIN_OPERATION, (float)0.);

  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new ManualWorkerEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  //pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, DISJ); // 121211 (5.1)
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ARG, 1);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  //pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

MotorizedPhytoTreatmentActivity::MotorizedPhytoTreatmentActivity() {
// =========================================================
// Une classe de Entity : 'MotorizedPhytoTreatmentActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MOTORIZED_PHYTO_TREATMENT_ACTIVITY);
  //SetParentClassId(PHYTO_TREATMENT_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

MotorizedPhytoTreatmentActivity::MotorizedPhytoTreatmentActivity(Vineyard* pEA) {
// =========================================================
// Une classe de Entity : 'MotorizedPhytoTreatmentActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(MOTORIZED_PHYTO_TREATMENT_ACTIVITY);
  //SetParentClassId(PHYTO_TREATMENT_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***

//printf("\nconstr MotorizedPhytoTreatmentActivity pEA : '%s'", pEA->InstanceName());
  PerformerSpecification* pPerfSpec = new PerformerSpecification();
  //-------------------------------------------------------
  EntitySpec* pES = new TractorDriverEntitySpec();
  //-------------------------------------------------------
  pES->ReferentEntity(pEA);
  pPerfSpec->SetEntitySpecConstValue(PERFORMER_ENTITY_SPEC_ATTRIBUTE, pES);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ID, ANYONE);
  pPerfSpec->SetIntConstValue(SELECTOR_FCT_ARG, 1);
  pPerfSpec->SetIntVarValue(ENTITY_SPEC_REFERENCE_CLASS_ID, FARM_WORKER);
  pPerfSpec->SetIntConstValue(CONTINUATION_MODE, SAME_PREVIOUS_ENTITIES);
  
  SetEntityVarValue(PERFORMER_SPEC_ATTRIBUTE, pPerfSpec);
};

SpringTillageActivity::SpringTillageActivity() {
// =========================================================
// Une classe de Entity : 'SpringTillageActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SPRING_TILLAGE_ACTIVITY);
  //SetParentClassId(TILLAGE_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

SpringTillageActivity::SpringTillageActivity(Vineyard* pEA) 
: TillageActivity(pEA) {
// =========================================================
// Une classe de Entity : 'SpringTillageActivity'
// Ne pas modifier les lignes au-dessus du code spécifique.
// (*) la parente est declaree dans App_InstallMetaClasses()
// =========================================================
  SetMetaClass(SPRING_TILLAGE_ACTIVITY);
  //SetParentClassId(TILLAGE_ACTIVITY); // pour memoire (*)
  AddInstanceToClass();
// *** DEBUT DU CODE SPECIFIQUE. NE RIEN MODIFIER CI-DESSUS ***
};

