// ==============================================
// Fichier : UserEntityMethod.cc  
// Type    : source C++
// 
// Description : constructeurs des classes des 'EntityMethod'.
// ==============================================
  
#include "UserEntityMethod.h"
  

// ==============================================
// Sous-classe de Method : 'AddNewSituatedAutumnTillages' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedAutumnTillages::AddNewSituatedAutumnTillages() {
	ClassSymbol(ADD_NEW_SITUATED_AUTUMN_TILLAGES);
	ClassName("addNewSituatedAutumnTillages");
	ClassShortComment("ajoute au chantier de labour d'automne des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedAutumnTillages_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedChemicalWeedings' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedChemicalWeedings::AddNewSituatedChemicalWeedings() {
	ClassSymbol(ADD_NEW_SITUATED_CHEMICAL_WEEDINGS);
	ClassName("addNewSituatedChemicalWeedings");
	ClassShortComment("ajoute au chantier de desherbage des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedChemicalWeedings_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedClippings' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedClippings::AddNewSituatedClippings() {
	ClassSymbol(ADD_NEW_SITUATED_CLIPPINGS);
	ClassName("addNewSituatedClippings");
	ClassShortComment("ajoute au chantier d'ecimage des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedClippings_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedDebranchings' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedDebranchings::AddNewSituatedDebranchings() {
	ClassSymbol(ADD_NEW_SITUATED_DEBRANCHINGS);
	ClassName("addNewSituatedDebranchings");
	ClassShortComment("ajoute au chantier d'épamprage des activites sur de nouvelles parcelles");
	AddArg(new ManualMotorizedArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedDebranchings_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedFertilizations' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedFertilizations::AddNewSituatedFertilizations() {
	ClassSymbol(ADD_NEW_SITUATED_FERTILIZATIONS);
	ClassName("addNewSituatedFertilizations");
	ClassShortComment("ajoute au chantier de fertilisation des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedFertilizations_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedInitSpringTillages' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedInitSpringTillages::AddNewSituatedInitSpringTillages() {
	ClassSymbol(ADD_NEW_SITUATED_INIT_SPRING_TILLAGES);
	ClassName("addNewSituatedInitSpringTillages");
	ClassShortComment("ajoute au chantier de labour de reprise des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedInitSpringTillages_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedPhytoTreatments' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedPhytoTreatments::AddNewSituatedPhytoTreatments() {
	ClassSymbol(ADD_NEW_SITUATED_PHYTO_TREATMENTS);
	ClassName("addNewSituatedPhytoTreatments");
	ClassShortComment("ajoute au chantier de traitement phyto. des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedPhytoTreatments_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedPlantations' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedPlantations::AddNewSituatedPlantations() {
	ClassSymbol(ADD_NEW_SITUATED_PLANTATIONS);
	ClassName("addNewSituatedPlantations");
	ClassShortComment("ajoute au chantier de plantation des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedPlantations_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedPrunings' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedPrunings::AddNewSituatedPrunings() {
	ClassSymbol(ADD_NEW_SITUATED_PRUNINGS);
	ClassName("addNewSituatedPrunings");
	ClassShortComment("ajoute au chantier de taille des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedPrunings_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedShootThinnings' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedShootThinnings::AddNewSituatedShootThinnings() {
	ClassSymbol(ADD_NEW_SITUATED_SHOOT_THINNINGS);
	ClassName("addNewSituatedShootThinnings");
	ClassShortComment("ajoute au chantier de broyage des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedShootThinnings_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedSpringChemicalWeedings' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedSpringChemicalWeedings::AddNewSituatedSpringChemicalWeedings() {
	ClassSymbol(ADD_NEW_SITUATED_SPRING_CHEMICAL_WEEDINGS);
	ClassName("addNewSituatedSpringChemicalWeedings");
	ClassShortComment("ajoute au chantier de desherbage de printemps des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedSpringChemicalWeedings_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedSpringTillages' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedSpringTillages::AddNewSituatedSpringTillages() {
	ClassSymbol(ADD_NEW_SITUATED_SPRING_TILLAGES);
	ClassName("addNewSituatedSpringTillages");
	ClassShortComment("ajoute au chantier de labour de printemps des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedSpringTillages_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedTrellisings' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedTrellisings::AddNewSituatedTrellisings() {
	ClassSymbol(ADD_NEW_SITUATED_TRELLISINGS);
	ClassName("addNewSituatedTrellisings");
	ClassShortComment("ajoute au chantier de relevage des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedTrellisings_Body);
};


// ==============================================
// Sous-classe de Method : 'AddNewSituatedWinterTillages' (type : 'BOOLEAN').
// ==============================================

AddNewSituatedWinterTillages::AddNewSituatedWinterTillages() {
	ClassSymbol(ADD_NEW_SITUATED_WINTER_TILLAGES);
	ClassName("addNewSituatedWinterTillages");
	ClassShortComment("ajoute au chantier de labour d'hiver des activites sur de nouvelles parcelles");
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(addNewSituatedWinterTillages_Body);
};


// ==============================================
// Sous-classe de Method : 'AntiDownyMildewAtLeastClosingPredicate' (type : 'BOOLEAN').
// ==============================================

AntiDownyMildewAtLeastClosingPredicate::AntiDownyMildewAtLeastClosingPredicate() {
	ClassSymbol(ANTI_DOWNY_MILDEW_AT_LEAST_CLOSING_PREDICATE);
	ClassName("antiDownyMildewAtLeastClosingPredicate");
	ClassShortComment("renvoie vrai ssi il y a lieu d'arreter la serie de traitement anti-mildiou en absence de pression");
	AssignBody(antiDownyMildewAtLeastClosingPredicate_Body);
};


// ==============================================
// Sous-classe de Method : 'AntiDownyMildewUnderPressureClosingPredicate' (type : 'BOOLEAN').
// ==============================================

AntiDownyMildewUnderPressureClosingPredicate::AntiDownyMildewUnderPressureClosingPredicate() {
	ClassSymbol(ANTI_DOWNY_MILDEW_UNDER_PRESSURE_CLOSING_PREDICATE);
	ClassName("antiDownyMildewUnderPressureClosingPredicate");
	ClassShortComment("renvoie vrai ssi il y a lieu d'arreter la serie de traitement anti-mildiou en presence de pression");
	AssignBody(antiDownyMildewUnderPressureClosingPredicate_Body);
};


// ==============================================
// Sous-classe de Method : 'AntiPowderyMildewClosingPredicate' (type : 'BOOLEAN').
// ==============================================

AntiPowderyMildewClosingPredicate::AntiPowderyMildewClosingPredicate() {
	ClassSymbol(ANTI_POWDERY_MILDEW_CLOSING_PREDICATE);
	ClassName("antiPowderyMildewClosingPredicate");
	ClassShortComment("renvoie vrai ssi il y a lieu d'arreter la serie de traitement anti-oidium");
	AssignBody(antiPowderyMildewClosingPredicate_Body);
};


// ==============================================
// Sous-classe de Method : 'AssignRelativeAreaToRows' (type : 'VOID').
// ==============================================

AssignRelativeAreaToRows::AssignRelativeAreaToRows() {
	ClassSymbol(ASSIGN_RELATIVE_AREA_TO_ROWS);
	ClassName("assignRelativeAreaToRows");
	ClassShortComment("repartit la surface de la parcelle entre les quatre types de rangees");
	AssignBody(assignRelativeAreaToRows_Body);
};


// ==============================================
// Sous-classe de Method : 'AttachFarmWorkerToTimetables' (type : 'VOID').
// ==============================================

AttachFarmWorkerToTimetables::AttachFarmWorkerToTimetables() {
	ClassSymbol(ATTACH_FARM_WORKER_TO_TIMETABLES);
	ClassName("attachFarmWorkerToTimetables");
	ClassShortComment("attachement reciproque entre l'ouvrier et les Timetable des periodes de l'AnnualPlan");
	AddArg(new FarmWorkerArgument());
	AssignBody(attachFarmWorkerToTimetables_Body);
};


// ==============================================
// Sous-classe de Method : 'DumpOperationRecords' (type : 'VOID').
// ==============================================

DumpOperationRecords::DumpOperationRecords() {
	ClassSymbol(DUMP_OPERATION_RECORDS);
	ClassName("dumpOperationRecords");
	ClassShortComment("ecrit sur un fichier externe le contenu de la memoire des operations du manager");
	AssignBody(dumpOperationRecords_Body);
};


// ==============================================
// Sous-classe de Method : 'GetActualThermalTimeFromEmergence' (type : 'FLOAT').
// ==============================================

GetActualThermalTimeFromEmergence::GetActualThermalTimeFromEmergence() {
	ClassSymbol(GET_ACTUAL_THERMAL_TIME_FROM_EMERGENCE);
	ClassName("getActualThermalTimeFromEmergence");
	ClassShortComment("Renvoie la somme de degres.jour reelle depuie la levee");
	AssignBody(getActualThermalTimeFromEmergence_Body);
};


// ==============================================
// Sous-classe de Method : 'GetDayWhenStageAchieved' (type : 'INT').
// ==============================================

GetDayWhenStageAchieved::GetDayWhenStageAchieved() {
	ClassSymbol(GET_DAY_WHEN_STAGE_ACHIEVED);
	ClassName("getDayWhenStageAchieved");
	ClassShortComment("renvoie le nb de jours depuis le semis, a la fin d'un stade donne");
	AddArg(new StageIndexArgument());
	AssignBody(getDayWhenStageAchieved_Body);
};


// ==============================================
// Sous-classe de Method : 'GetFirstWaveList' (type : 'ENTITY_TAB').
// ==============================================

GetFirstWaveList::GetFirstWaveList() {
	ClassSymbol(GET_FIRST_WAVE_LIST);
	ClassName("getFirstWaveList");
	ClassShortComment("renvoie la liste des varietes prioritaires pour les traitements phyto");
	AddArg(new VineyardArgument());
	AssignBody(getFirstWaveList_Body);
};


// ==============================================
// Sous-classe de Method : 'GetRankedWaveList' (type : 'ENTITY_TAB').
// ==============================================

GetRankedWaveList::GetRankedWaveList() {
	ClassSymbol(GET_RANKED_WAVE_LIST);
	ClassName("getRankedWaveList");
	ClassShortComment("renvoie la liste des varietes a traiter phyto, en fct d'un rang de priorite en arg.");
	AddArg(new VineyardArgument());
	AddArg(new StageIndexArgument());
	AssignBody(getRankedWaveList_Body);
};


// ==============================================
// Sous-classe de Method : 'IsClockValueInCalendar' (type : 'BOOLEAN').
// ==============================================

IsClockValueInCalendar::IsClockValueInCalendar() {
	ClassSymbol(IS_CLOCK_VALUE_IN_CALENDAR);
	ClassName("isClockValueInCalendar");
	ClassShortComment("renvoie 'vrai' ssi la valeur d'horloge en argument est dans le OffWorkCalendar");
	AddArg(new ClockArgument());
	AssignBody(isClockValueInCalendar_Body);
};


// ==============================================
// Sous-classe de Method : 'IsClockValueInPeriod' (type : 'BOOLEAN').
// ==============================================

IsClockValueInPeriod::IsClockValueInPeriod() {
	ClassSymbol(IS_CLOCK_VALUE_IN_PERIOD);
	ClassName("isClockValueInPeriod");
	ClassShortComment("renvoie 'vrai' ssi la valeur d'horloge en argument est dans la WorkSinglePeriod");
	AddArg(new ClockArgument());
	AssignBody(isClockValueInPeriod_Body);
};


// ==============================================
// Sous-classe de Method : 'IsMotorizationPossible' (type : 'BOOLEAN').
// ==============================================

IsMotorizationPossible::IsMotorizationPossible() {
	ClassSymbol(IS_MOTORIZATION_POSSIBLE);
	ClassName("isMotorizationPossible");
	ClassShortComment("renvoie TRUE ssi les ressources de l'EA sont OK pour l'OT en argument");
	AddArg(new OperationClassArgument());
	AssignBody(isMotorizationPossible_Body);
};


// ==============================================
// Sous-classe de Method : 'OperationNominalDuration' (type : 'FLOAT').
// ==============================================

OperationNominalDuration::OperationNominalDuration() {
	ClassSymbol(OPERATION_NOMINAL_DURATION);
	ClassName("operationNominalDuration");
	ClassShortComment("returns the previsionnal duration of the operation of a primitive activity");
	AddArg(new CandidateEntityValueArgument());
	AssignBody(operationNominalDuration_Body);
};


// ==============================================
// Sous-classe de Method : 'ReturnEffectiveTemperature' (type : 'FLOAT').
// ==============================================

ReturnEffectiveTemperature::ReturnEffectiveTemperature() {
	ClassSymbol(RETURN_EFFECTIVE_TEMPERATURE);
	ClassName("returnEffectiveTemperature");
	ClassShortComment("donne la temp en prenant le zero de vegetation de la plante consideree");
	AssignBody(returnEffectiveTemperature_Body);
};


// ==============================================
// Sous-classe de Method : 'ReturnPassedRowsFrequency' (type : 'FLOAT').
// ==============================================

ReturnPassedRowsFrequency::ReturnPassedRowsFrequency() {
	ClassSymbol(RETURN_PASSED_ROWS_FREQUENCY);
	ClassName("returnPassedRowsFrequency");
	ClassShortComment("Renvoie la fr�quence de passage dans les inter-rangs en fonction de l'operation");
	AddArg(new OperationArgument());
	AssignBody(returnPassedRowsFrequency_Body);
};


// ==============================================
// Sous-classe de Method : 'ReturnPhytoTreatmentOperationSubclass' (type : 'INT').
// ==============================================

ReturnPhytoTreatmentOperationSubclass::ReturnPhytoTreatmentOperationSubclass() {
	ClassSymbol(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS);
	ClassName("returnPhytoTreatmentOperationSubclass");
	ClassShortComment("renvoie une classe d'ot de traitement adaptee au materiel, parcelle, strategie");
	AddArg(new PlotArgument());
	AddArg(new DistributedActivitySetArgument());
	AddArg(new SprayerTypeRegularOptionArgument());
	AddArg(new SprayerTypeAtBeginningOptionArgument());
	AddArg(new SprayNumberAtBeginningOptionArgument());
	AssignBody(returnPhytoTreatmentOperationSubclass_Body);
};


// ==============================================
// Sous-classe de Method : 'ReturnShootThinningOperationSubclass' (type : 'INT').
// ==============================================

ReturnShootThinningOperationSubclass::ReturnShootThinningOperationSubclass() {
	ClassSymbol(RETURN_SHOOT_THINNING_OPERATION_SUBCLASS);
	ClassName("returnShootThinningOperationSubclass");
	ClassShortComment("renvoie une classe d'ot de broyage adaptee au materiel, parcelle, strategie");
	AddArg(new PlotArgument());
	AssignBody(returnShootThinningOperationSubclass_Body);
};


// ==============================================
// Sous-classe de Method : 'ReturnSoilManagementGroupOnProfile' (type : 'P_ENTITY').
// ==============================================

ReturnSoilManagementGroupOnProfile::ReturnSoilManagementGroupOnProfile() {
	ClassSymbol(RETURN_SOIL_MANAGEMENT_GROUP_ON_PROFILE);
	ClassName("returnSoilManagementGroupOnProfile");
	ClassShortComment("renvoie le groupe de gestion en fonction des proprietes de la parcelle");
	AddArg(new ManagementGroupSetArgument());
	AssignBody(returnSoilManagementGroupOnProfile_Body);
};


// ==============================================
// Sous-classe de Method : 'ReturnTillageOperationSubclass' (type : 'INT').
// ==============================================

ReturnTillageOperationSubclass::ReturnTillageOperationSubclass() {
	ClassSymbol(RETURN_TILLAGE_OPERATION_SUBCLASS);
	ClassName("returnTillageOperationSubclass");
	ClassShortComment("renvoie une classe d'ot de labour adaptee au materiel, parcelle, strategie");
	AddArg(new PlotArgument());
	AddArg(new SeasonArgument());
	AssignBody(returnTillageOperationSubclass_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToAutumnTill' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToAutumnTill::SelectNewPlotsToAutumnTill() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_AUTUMN_TILL);
	ClassName("selectNewPlotsToAutumnTill");
	ClassShortComment("renvoie un tableau de parcelles a labourer dans le chantier d'automne");
	AddArg(new VineyardArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(selectNewPlotsToAutumnTill_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToClip' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToClip::SelectNewPlotsToClip() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_CLIP);
	ClassName("selectNewPlotsToClip");
	ClassShortComment("renvoie un tableau de parcelles a ecimer");
	AddArg(new VineyardArgument());
	AddArg(new ClockArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AddArg(new SerialParallelArgument());
	AssignBody(selectNewPlotsToClip_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToDebranch' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToDebranch::SelectNewPlotsToDebranch() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_DEBRANCH);
	ClassName("selectNewPlotsToDebranch");
	ClassShortComment("renvoie un tableau de parcelles a epamprer");
	AddArg(new VineyardArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new ManualMotorizedArgument());
	AssignBody(selectNewPlotsToDebranch_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToFertilize' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToFertilize::SelectNewPlotsToFertilize() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_FERTILIZE);
	ClassName("selectNewPlotsToFertilize");
	ClassShortComment("renvoie un tableau de parcelles a fertiliser");
	AddArg(new VineyardArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(selectNewPlotsToFertilize_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToInitSpringTill' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToInitSpringTill::SelectNewPlotsToInitSpringTill() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL);
	ClassName("selectNewPlotsToInitSpringTill");
	ClassShortComment("renvoie un tableau de parcelles a labourer dans le chantier de reprise");
	AddArg(new VineyardArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(selectNewPlotsToInitSpringTill_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToPhytoProtect' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToPhytoProtect::SelectNewPlotsToPhytoProtect() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT);
	ClassName("selectNewPlotsToPhytoProtect");
	ClassShortComment("renvoie un tableau de parcelles a traiter");
	AddArg(new VineyardArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new ManualMotorizedArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(selectNewPlotsToPhytoProtect_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToPlant' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToPlant::SelectNewPlotsToPlant() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_PLANT);
	ClassName("selectNewPlotsToPlant");
	ClassShortComment("renvoie un tableau de parcelles a planter");
	AddArg(new VineyardArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(selectNewPlotsToPlant_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToPrune' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToPrune::SelectNewPlotsToPrune() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_PRUNE);
	ClassName("selectNewPlotsToPrune");
	ClassShortComment("renvoie un tableau de parcelles a tailler");
	AddArg(new VineyardArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AddArg(new SerialParallelArgument());
	AssignBody(selectNewPlotsToPrune_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToShootThin' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToShootThin::SelectNewPlotsToShootThin() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_SHOOT_THIN);
	ClassName("selectNewPlotsToShootThin");
	ClassShortComment("renvoie un tableau de parcelles a broyer");
	AddArg(new VineyardArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(selectNewPlotsToShootThin_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToSpringTill' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToSpringTill::SelectNewPlotsToSpringTill() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_SPRING_TILL);
	ClassName("selectNewPlotsToSpringTill");
	ClassShortComment("renvoie un tableau de parcelles a labourer dans le chantier de printemps");
	AddArg(new VineyardArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(selectNewPlotsToSpringTill_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToSpringWeed' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToSpringWeed::SelectNewPlotsToSpringWeed() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_SPRING_WEED);
	ClassName("selectNewPlotsToSpringWeed");
	ClassShortComment("renvoie un tableau de parcelles a desherber au printemps");
	AddArg(new VineyardArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new ManualMotorizedArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(selectNewPlotsToSpringWeed_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToTrellis' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToTrellis::SelectNewPlotsToTrellis() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_TRELLIS);
	ClassName("selectNewPlotsToTrellis");
	ClassShortComment("renvoie un tableau de parcelles a relever");
	AddArg(new VineyardArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AddArg(new SerialParallelArgument());
	AssignBody(selectNewPlotsToTrellis_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToWeed' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToWeed::SelectNewPlotsToWeed() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_WEED);
	ClassName("selectNewPlotsToWeed");
	ClassShortComment("renvoie un tableau de parcelles a desherber");
	AddArg(new VineyardArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new ManualMotorizedArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(selectNewPlotsToWeed_Body);
};


// ==============================================
// Sous-classe de Method : 'SelectNewPlotsToWinterTill' (type : 'ENTITY_TAB').
// ==============================================

SelectNewPlotsToWinterTill::SelectNewPlotsToWinterTill() {
	ClassSymbol(SELECT_NEW_PLOTS_TO_WINTER_TILL);
	ClassName("selectNewPlotsToWinterTill");
	ClassShortComment("renvoie un tableau de parcelles a labourer dans le chantier d'hiver");
	AddArg(new VineyardArgument());
	AddArg(new SerialParallelArgument());
	AddArg(new TerminatedPlotsArgument());
	AddArg(new InCoursePlotsArgument());
	AssignBody(selectNewPlotsToWinterTill_Body);
};


// ==============================================
// Sous-classe de Method : 'SetDayWhenStageAchieved' (type : 'VOID').
// ==============================================

SetDayWhenStageAchieved::SetDayWhenStageAchieved() {
	ClassSymbol(SET_DAY_WHEN_STAGE_ACHIEVED);
	ClassName("setDayWhenStageAchieved");
	ClassShortComment("dote le stade du jour de son achevement, passe en argument");
	AddArg(new DayWhenAchievedArgument());
	AssignBody(setDayWhenStageAchieved_Body);
};


// ==============================================
// Sous-classe de Method : 'SetFlagMildew' (type : 'INT').
// ==============================================

SetFlagMildew::SetFlagMildew() {
	ClassSymbol(SET_FLAG_MILDEW);
	ClassName("setFlagMildew");
	ClassShortComment("etablit le descripteur FlagMildew de la conduite (mildewWarningProcess)");
	AssignBody(setFlagMildew_Body);
};


// ==============================================
// Sous-classe de Method : 'SetRowSoilManagement' (type : 'VOID').
// ==============================================

SetRowSoilManagement::SetRowSoilManagement() {
	ClassSymbol(SET_ROW_SOIL_MANAGEMENT);
	ClassName("setRowSoilManagement");
	ClassShortComment("etablit le mode de gestion de chaque rangee de la parcelle");
	AssignBody(setRowSoilManagement_Body);
};


// ==============================================
// Sous-classe de Method : 'SetScheduledAntiMildew' (type : 'VOID').
// ==============================================

SetScheduledAntiMildew::SetScheduledAntiMildew() {
	ClassSymbol(SET_SCHEDULED_ANTI_MILDEW);
	ClassName("setScheduledAntiMildew");
	ClassShortComment("pour un chantier ouvert, etablit s'il est programme avec un anti-mildiou");
	AddArg(new VineyardArgument());
	AssignBody(setScheduledAntiMildew_Body);
};


// ==============================================
// Sous-classe de Method : 'SumUpGrassCoverVector' (type : 'FLOAT').
// ==============================================

SumUpGrassCoverVector::SumUpGrassCoverVector() {
	ClassSymbol(SUM_UP_GRASS_COVER_VECTOR);
	ClassName("sumUpGrassCoverVector");
	ClassShortComment("renvoie un scalaire a partir du vecteur des couvertures sur les unit. hydro.");
	AssignBody(sumUpGrassCoverVector_Body);
};


// ==============================================
// Sous-classe de Method : 'SumUpSoilHumidityVector' (type : 'FLOAT').
// ==============================================

SumUpSoilHumidityVector::SumUpSoilHumidityVector() {
	ClassSymbol(SUM_UP_SOIL_HUMIDITY_VECTOR);
	ClassName("sumUpSoilHumidityVector");
	ClassShortComment("renvoie un scalaire a partir du vecteur des humidites sur les unit. hydro.");
	AssignBody(sumUpSoilHumidityVector_Body);
};


// ==============================================
// Sous-classe de Method : 'TimetableClosingPredicate' (type : 'BOOLEAN').
// ==============================================

TimetableClosingPredicate::TimetableClosingPredicate() {
	ClassSymbol(TIMETABLE_CLOSING_PREDICATE);
	ClassName("timetableClosingPredicate");
	ClassShortComment("specifie la fermeture d'un SeasonalEmploymentPlan");
	AssignBody(timetableClosingPredicate_Body);
};


// ==============================================
// Sous-classe de Method : 'TimetableOpeningPredicate' (type : 'BOOLEAN').
// ==============================================

TimetableOpeningPredicate::TimetableOpeningPredicate() {
	ClassSymbol(TIMETABLE_OPENING_PREDICATE);
	ClassName("timetableOpeningPredicate");
	ClassShortComment("specifie l'ouverture d'un SeasonalEmploymentPlan");
	AssignBody(timetableOpeningPredicate_Body);
};


// ==============================================
// Sous-classe de Method : 'UpdateOffPeriodCurrentIndex' (type : 'INT').
// ==============================================

UpdateOffPeriodCurrentIndex::UpdateOffPeriodCurrentIndex() {
	ClassSymbol(UPDATE_OFF_PERIOD_CURRENT_INDEX);
	ClassName("updateOffPeriodCurrentIndex");
	ClassShortComment("modifie l'index pointant sur la periode en cours dans un OffWorkCalendar");
	AssignBody(updateOffPeriodCurrentIndex_Body);
};


// ==============================================
// Sous-classe de Method : 'UpdateSeasonCurrentIndex' (type : 'INT').
// ==============================================

UpdateSeasonCurrentIndex::UpdateSeasonCurrentIndex() {
	ClassSymbol(UPDATE_SEASON_CURRENT_INDEX);
	ClassName("updateSeasonCurrentIndex");
	ClassShortComment("modifie l'index pointant sur la saison en cours dans un AnnualEmploymentPlan");
	AssignBody(updateSeasonCurrentIndex_Body);
};

// Corps des méthodes non prédéfinies

bool addNewSituatedAutumnTillages_Body(EntityMethod* pM)
//------------------------------------------------------
// ajoute au chantier de labour d'automne des activites sur de nouvelles parcelles
//------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\n\tpChantier : '%s'", pChantier->InstanceName());
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> arguments de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // + JPR 130520 :
  // suppression de toute activité programmee par un addNew.. precedent
  // mais non demarree (donc ni terminee ni en cours), pour que cet
  // addNew.., s'il sélectionne la meme parcelle, ne cree pas une
  // deuxième (puis n-ième) activité portant sur la meme parcelle.
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedAutumnTillages : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Vineyard* pVineyard = (Vineyard*)App_GetVineyard((Activity*)pChantier);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());
  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
//printf("\n\tpConduite : '%s'", pConduite->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des labours
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a labourer
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_AUTUMN_TILL, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_AUTUMN_TILL, 
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_AUTUMN_TILL, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_AUTUMN_TILL, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pEntityTab* plotsToAutumnTillTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_AUTUMN_TILL);
  //  ----------------------------------------------------------
//printf("\n\tplotsToAutumnTillTab : "); plotsToAutumnTillTab->display_names(); 
  int nbPlots = plotsToAutumnTillTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  int numPhase = App_GetPhaseIndex((Activity*)pPhasicPlan) + 1;
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToAutumnTillTab->get_element(i);
    Activity* pAct;
	//
	// creation d'une activite de labour d'automne
	//
	pAct = new AutumnTillageActivity(pVineyard);
	//
	// priorites d'allocation differenciees selon la periode
	//
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);

	//
	// coder choix ss-classe d'operation en fonction de la largeur IR
	//
	pAct->SetEntityArgValue(RETURN_TILLAGE_OPERATION_SUBCLASS,
							PLOT_ARGUMENT, pPlot);
	pAct->SetIntArgValue(RETURN_TILLAGE_OPERATION_SUBCLASS,
						 SEASON_ARGUMENT, AUTUMN);
	int otClasId = pAct->ExecIntMethod(RETURN_TILLAGE_OPERATION_SUBCLASS);
	pAct->SetIntVarValue(OPERATION_CLASS_ID, otClasId);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedAutumnTillages sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToAutumnTillTab;
//printf("\naddNewSituatedAutumnTillages_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedChemicalWeedings_Body(EntityMethod* pM)
//--------------------------------------------------------
// ajoute au chantier de desherbage des activites sur de nouvelles parcelles
//--------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\naddNewSituatedChemicalWeedings_Body sur '%s'", pChantier->InstanceName());
  //-------------------------------------------------
  // les parcelles en cours d'operation
  // -> argument de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN,
                                                                                         TRUE);
  if(pPhasicPlan == NULL) {
        printf("\naddNewSituatedChemicalWeedings : pas de plan de phase trouve !\n");
        exit(0);   
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
        (Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des desherbages
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
        optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);

  char* manualMotorizedValue;
  if(! strcmp(optionSerPar, "PAR"))
	 manualMotorizedValue = "";
  else {
	if(pChantier->IsInstanceOf(SERIAL_MANUAL_CHEMICAL_WEEDINGS))
	  manualMotorizedValue = "MANUAL";
	else
	  manualMotorizedValue = "MOTORIZED";
  }
//printf("\n\tmanualMotorizedValue = '%s'", manualMotorizedValue);
       
  //-------------------------------------------------
  // determination des nouvelles parcelles a desherber
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------
  
  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_WEED, VINEYARD_ARGUMENT,
							   pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_WEED, 
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_WEED, 
								  IN_COURSE_PLOTS_ARGUMENT,  
								  pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_WEED,
							   SERIAL_PARALLEL_ARGUMENT,
							   optionSerPar);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_WEED,
							   MANUAL_MOTORIZED_ARGUMENT,
							   manualMotorizedValue);
  pEntityTab* plotsToWeedTab
        = pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_WEED);
  //  ----------------------------------------------------------
//printf("\n\tplotsToWeedTab : "); plotsToWeedTab->display_names();
  int nbPlots = plotsToWeedTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  bool actInstantiated;
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToWeedTab->get_element(i);
    Activity* pAct;
	actInstantiated = FALSE;
	//
	// creation d'une activite de desherbage
	//
	/* version ecrite par NP+JPR

	if(! strcmp(optionSerPar, "SER")) {
	  if(! strcmp(manualMotorizedValue, "MOTORIZED")) { 
		pAct = new MotorizedChemicalWeedingActivity(pVineyard);
		UserClassId otClassId = HORIZONTAL_RAIL_OPERATED_SPRAYING;  // provisoire
        
		pAct->SetIntVarValue(OPERATION_CLASS_ID, otClassId);
		actInstantiated = TRUE;
	  }
	  else {  
		pAct = new ManualChemicalWeedingActivity(pVineyard);
		// otClassId = ? a faire ?
		actInstantiated = TRUE;
	  }
	}
	else {
	  // choix manuel/motorise en fonction de plusieurs criteres
	  // mais provisoirement un seul critere : parcelle motorisable ou pas
	  //
	  pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							OPERATION_CLASS_ARGUMENT,
							MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable = pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable = %d", isPlotMotorizable);
	  if(isPlotMotorizable) { 
		pAct = new MotorizedChemicalWeedingActivity(pVineyard);
		UserClassId otClassId = HORIZONTAL_RAIL_OPERATED_SPRAYING;  // provisoire
        
		pAct->SetIntVarValue(OPERATION_CLASS_ID, otClassId);
		actInstantiated = TRUE;
	  }
	  else {
		pAct = new ManualChemicalWeedingActivity(pVineyard);
		// otClassId = ? a faire ?
		actInstantiated = TRUE;
	  }
	}
	*/
	// version JPR 110210 :
	//
	pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
						  OPERATION_CLASS_ARGUMENT,
						  MOTORIZED_SPRAYING_OPERATION);
	bool isPlotMotorizable = pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	// Y compris en SER (pour faire comme dans SpringCW) :
	// choix manuel/motorise en fonction de plusieurs criteres
	// mais provisoirement un seul critere : parcelle motorisable ou pas
	//
	if(isPlotMotorizable) { 
	  pAct = new MotorizedChemicalWeedingActivity(pVineyard);
	  UserClassId otClassId = HORIZONTAL_RAIL_OPERATED_SPRAYING;  // provisoire
	  
	  pAct->SetIntVarValue(OPERATION_CLASS_ID, otClassId);
	  actInstantiated = TRUE;
	}
	else {
	  pAct = new ManualChemicalWeedingActivity(pVineyard);
	  // otClassId = ? a faire ?
	  actInstantiated = TRUE;
	}
	if(actInstantiated) {  // securite utile ?
	  //
	  // priorite d'allocation
	  //
	  int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	  int allocPriority = 
		App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								  STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	  pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	  pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	  //
	  // designation de pPlot comme objet opere par pAct
	  //
	  Entity* pOOSpec = new OperatedObjectSpecification();
	  pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	  pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	  pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans '%s' sur '%s' pPlot : '%s'", pAct->InstanceName(), pVineyard->InstanceName(), pPlot->InstanceName());
	  //
	  // ajout de ce ChemicalWeeding au chantier
	  //      
	  if(! strcmp(optionSerPar, "PAR")){
		pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
		pChantier->AddOperand(pAct);
	  }
	  else {
		((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	  } 
	}
  }
  delete plotsToWeedTab;
//printf("\nsortie addNewSituatedChemicalWeedings_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
}; 

bool addNewSituatedClippings_Body(EntityMethod* pM)
//-------------------------------------------------
// ajoute au chantier d'ecimage des activites sur de nouvelles parcelles
//-------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> arguments de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedClippings : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des ecimages
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a ecimer
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_CLIP, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_CLIP,  
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_CLIP, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots); 
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_CLIP, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pEntityTab* plotsToClipTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_CLIP);
  //  ----------------------------------------------------------
//printf("\n\tplotsToClipTab : "); plotsToClipTab->display_names(); 
  int nbPlots = plotsToClipTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToClipTab->get_element(i);
    Activity* pAct;
	//
	// creation d'une activite d'ecimage
	//
	pAct = new ClippingActivity(pVineyard);
	//
	// priorite d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedClippings sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce Clipping au chantier this
	//	
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToClipTab;
//printf("\naddNewSituatedClippings_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedDebranchings_Body(EntityMethod* pM)
//----------------------------------------------------
// ajoute au chantier d'épamprage des activites sur de nouvelles parcelles
//----------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\naddNewSituatedDebranchings_Body sur '%s'", pChantier->InstanceName());
  //-------------------------------------------------
  // les parcelles en cours d'operation
  // -> argument de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedDebranchings : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des epamprages
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);

  char* manualMotorizedValue;
  if(! strcmp(optionSerPar, "PAR"))
	 manualMotorizedValue = "";
  else {
	if(pChantier->IsInstanceOf(SERIAL_MANUAL_DEBRANCHINGS))
	  manualMotorizedValue = "MANUAL";
	else
	  manualMotorizedValue = "MOTORIZED";
  }
//printf("\n\tmanualMotorizedValue = '%s'", manualMotorizedValue);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a desherber
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_DEBRANCH, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_DEBRANCH,  
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_DEBRANCH,  
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_DEBRANCH, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_DEBRANCH, 
								 MANUAL_MOTORIZED_ARGUMENT,
								 manualMotorizedValue);
  pEntityTab* plotsToDebranchTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_DEBRANCH);
  //  ----------------------------------------------------------
//printf("\n\tplotsToDebranchTab : "); plotsToDebranchTab->display_names(); 
  int nbPlots = plotsToDebranchTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToDebranchTab->get_element(i);
	pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
						  OPERATION_CLASS_ARGUMENT,
						  MOTORIZED_SPRAYING_OPERATION);
	bool isPlotMotorizable =
	  pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable/MOTORIZED_SPRAYING = %d", isPlotMotorizable);
    Activity* pAct;
	//
	// creation d'une activite d'epamprage
	//
	//
	int modality = 
	  App_GetIntDecisionOption(pVineyard, OPT_DEBRANCHING_MODALITY);
	bool isPureChem = (modality == PART_CHEM) || (modality == WHOLE_CHEM);
	bool isPureMeca = (modality == PART_MECA) || (modality == WHOLE_MECA);
	bool isMixed = (modality == PART_MECA_CHEM) || (modality == WHOLE_MECA_CHEM);
	Entity* pVariety = 
	  pPlot->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
	int shootIntensity = pVariety->GetIntConstValue(SHOOT_INTENSITY);

	if(! strcmp(optionSerPar, "SER")) {
	  if(! strcmp(manualMotorizedValue, "MOTORIZED")) {  
		pAct = new MotorizedChemicalDebranchingActivity(pVineyard);
		// l'activite MotorizedMecanicalDebranchingActivity n'est pas encore
		// introduite dans la base
	  }
	  else {                         // "MANUAL"
		if(isPureChem) { 
		  pAct = new ManualChemicalDebranchingActivity(pVineyard);
		}
		else if(isPureMeca) { 
		  pAct = new ManualMechanicalDebranchingActivity(pVineyard);
		}
		else if(isMixed) {
		  if(shootIntensity < 2) {
			pAct = new ManualMechanicalDebranchingActivity(pVineyard);
		  }
		  else { 
			pAct = new ManualChemicalDebranchingActivity(pVineyard);
		  }
		}		
	  }
	}
	else {                          // "PAR"
	  if(isPureChem) {
		if(isPlotMotorizable)
		  pAct = new MotorizedChemicalDebranchingActivity(pVineyard);
		else
		  pAct = new ManualChemicalDebranchingActivity(pVineyard);
	  }
	  else if(isPureMeca) { 
		pAct = new ManualMechanicalDebranchingActivity(pVineyard);
	  }
	  else if(isMixed) {
		if(isPlotMotorizable && (shootIntensity == 2))
		  pAct = new MotorizedChemicalDebranchingActivity(pVineyard);
		else { 
		  if(isPlotMotorizable)// shootIntensity < 2
			pAct = new ManualMechanicalDebranchingActivity(pVineyard);
		  else                 // shootIntensity == 2
			pAct = new ManualChemicalDebranchingActivity(pVineyard);
		}
	  }		
	}
	//
	// priorite d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewDebranchings sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce Debranching au chantier
	//	
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToDebranchTab;
//printf("\naddNewSituatedDebranchings_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedFertilizations_Body(EntityMethod* pM)
//------------------------------------------------------
// ajoute au chantier de fertilisation des activites sur de nouvelles parcelles
//------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> arguments de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedFertilizations : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des fertilisations
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a fertiliser
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_FERTILIZE, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_FERTILIZE,  
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_FERTILIZE, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_FERTILIZE, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pEntityTab* plotsToFertilizeTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_FERTILIZE);
  //  ----------------------------------------------------------
//printf("\n\tplotsToFertilizeTab : "); plotsToFertilizeTab->display_names(); 
  int nbPlots = plotsToFertilizeTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToFertilizeTab->get_element(i);
    Activity* pAct;
	//
	// creation d'une activite de fertilisation
	//
	pAct = new FertilizationActivity(pVineyard);
	//
	// priorites d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedFertilizations sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce Fertilization au chantier this
	//	
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToFertilizeTab;
//printf("\naddNewSituatedFertilizations_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedInitSpringTillages_Body(EntityMethod* pM)
//----------------------------------------------------------
// ajoute au chantier de labour de reprise des activites sur de nouvelles parcelles
//----------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> argument de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedInitSpringTillages : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des labours
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a labourer
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL,  
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pEntityTab* plotsToInitSpringTillTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL);
  //  ----------------------------------------------------------
//printf("\n\tplotsToInitSpringTillTab : "); plotsToInitSpringTillTab->display_names(); printf("\n");
//pChantier->DisplaySituation();
  int nbPlots = plotsToInitSpringTillTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToInitSpringTillTab->get_element(i);
    Activity* pAct;
	//
	// creation d'une activite de labour de reprise
	//
	pAct = new InitSpringTillageActivity(pVineyard);
	//
	// priorites d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// coder choix ss-classe d'operation en fonction de la largeur IR
	//
	pAct->SetEntityArgValue(RETURN_TILLAGE_OPERATION_SUBCLASS,
							PLOT_ARGUMENT, pPlot);
	pAct->SetIntArgValue(RETURN_TILLAGE_OPERATION_SUBCLASS,
						 SEASON_ARGUMENT, INITSPRING);
	int otClasId = pAct->ExecIntMethod(RETURN_TILLAGE_OPERATION_SUBCLASS);
	pAct->SetIntVarValue(OPERATION_CLASS_ID, otClasId);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedInitSpringTillages sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce InitSpringTillage au chantier this
	//
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToInitSpringTillTab;
//printf("\naddNewSituatedInitSpringTillages_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedPhytoTreatments_Body(EntityMethod* pM)
//-------------------------------------------------------
// ajoute au chantier de traitement phyto. des activites sur de nouvelles parcelles
//-------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\naddNewSituatedPhytoTreatments_Body sur '%s'", pChantier->InstanceName());
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> arguments de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedPhytoTreatments : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des traitements
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);

  char* manualMotorizedValue;
  if(! strcmp(optionSerPar, "PAR"))
	 manualMotorizedValue = "";
  else { // modif 120516 4.6
	if(pChantier->IsInstanceOf(SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS))
	  manualMotorizedValue = "MANUAL";
	else if(pChantier->IsInstanceOf(SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS))
	  manualMotorizedValue = "MOTORIZED";
	else
	  manualMotorizedValue = ""; 
  }
//printf("\n\tmanualMotorizedValue = '%s'", manualMotorizedValue);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a traiter
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT, 
							   VINEYARD_ARGUMENT, 
							   pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT, 
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots); 
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT, 
							   SERIAL_PARALLEL_ARGUMENT,
							   optionSerPar);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT, 
							   MANUAL_MOTORIZED_ARGUMENT,
							   manualMotorizedValue);
  pEntityTab* plotsToProtectTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_PHYTO_PROTECT);
  //  ----------------------------------------------------------
//printf("\n\tplotsToProtectTab : "); plotsToProtectTab->display_names(); 
  int nbPlots = plotsToProtectTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  Boolean headingActInSerialActivitySet = FALSE;
  if(! strcmp(optionSerPar, "SER")
	 &&
	 pChantier->GetNumberOfElements() == 0)
	headingActInSerialActivitySet = TRUE;
  
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToProtectTab->get_element(i);
    Activity* pAct;
	pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
						  OPERATION_CLASS_ARGUMENT,
						  MOTORIZED_SPRAYING_OPERATION);
	bool isPlotMotorizable = pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable = %d", isPlotMotorizable);
	//
	// creation d'une activite de traitement phyto.
	//
	if(! strcmp(optionSerPar, "SER")) { // modif 120516 4.6
	  if(! strcmp(manualMotorizedValue, "MOTORIZED")) {  
		pAct = new MotorizedPhytoTreatmentActivity(pVineyard);
		//pas de 'UserClassId otClassId = xx;" ?
	  }
	  else if(! strcmp(manualMotorizedValue, "MANUAL")) {
		pAct = new ManualPhytoTreatmentActivity(pVineyard);
		//pas de 'UserClassId otClassId = xx;" ?
	  }
	  else {        // manualMotorizedValue : ""
		if(isPlotMotorizable) { 
		  pAct = new MotorizedPhytoTreatmentActivity(pVineyard);
		}
		else {
		  pAct = new ManualPhytoTreatmentActivity(pVineyard);
		}
	  }
	}
	else {
	  // choix manuel/motorise en fonction de plusieurs criteres
	  // mais provisoirement un seul critere : parcelle motorisable ou pas
	  //
	  if(isPlotMotorizable) { 
		pAct = new MotorizedPhytoTreatmentActivity(pVineyard);
	  }
	  else {
		pAct = new ManualPhytoTreatmentActivity(pVineyard);
	  }
	}
	//
	// priorites d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// etablir la liste des produits de traitement
	//
	int typeChantier = App_GetDistributedActivitySetType(pChantier);
	Entity* pComposedProgram = 
	  (Entity*)pChantier->GetFirstContainer(PHYTO_TREATMENT_COMPOSED_PROGRAM,
											TRUE);
	TableauString* list = new Tableau<char*>;
	if(typeChantier == ANTI_MILDIOU) {
	  list->push_back(strdup("anti-mildiou"));
	  pComposedProgram->SetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE,
										 TRUE);
	}
	else if(typeChantier == EXTRA_PHYTO) {
	  list->push_back(strdup("anti-oidium"));
	}
	else {               // REGULAR
	  Entity* pSuperSet = pChantier->GetSuperSet();
	  Entity* pIteration = pSuperSet;
	  if(pSuperSet->IsInstanceOf(VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN)) {
		//
		// cas SERIAL  : iterate(conj(chantierManual, chantierMotorized))
		//         (voir constructeur de RegularPhytoTreatmentsIteration)
		//
		pIteration = pSuperSet->GetSuperSet();
	  }
	  bool powderyMildewToClose 
		= pIteration->GetIntConstValue(POWDERY_MILDEW_TO_CLOSE);
	  if(! powderyMildewToClose)
		list->push_back(strdup("anti-oidium"));


	  int flagMildew = pConduite->GetIntConstValue(FLAG_MILDEW);
	  int antiMildiouScheduled = 
		pChantier->GetIntConstValue(ANTI_MILDEW_SCHEDULED);
	  if((flagMildew == TRUE) || (antiMildiouScheduled == TRUE)) {
		bool downyMildewToClose = pIteration->GetIntConstValue(DOWNY_MILDEW_TO_CLOSE);
		if(! downyMildewToClose) {
		  list->push_back(strdup("anti-mildiou"));
		  pComposedProgram->SetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE,
										   TRUE);
		}
	  }
	  else {
		pComposedProgram->SetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE,
										   FALSE);
	  }
	}
//printf("\n'%s'::PHYTO_TREATMENT_LIST : ", pAct->InstanceName());list->display();
	pAct->SetStringTabConstValue(PHYTO_TREATMENT_LIST, list);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\nt=%d sur pPlot : '%s' : '%s'", pCurrentSim->Clock(), pPlot->InstanceName(), pAct->InstanceName());
	//
	// ajout de ce PhytoTreatment au chantier
	// (seulement si un produit a été désigné)
	//	
	if(list->size() > 0) {
	  //
	  // choix ss-classe d'operation en fonction de ...
	  // (besoin d'avoir attache l'activite au chantier : fait ci-dessus)
	  //
	  // remonté avant l'ajout au chantier (JPR 130129) parce que :
	  // voir dans READ_ME_versions le passage à 5.3
	  //
	  pAct->SetEntityArgValue(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS,
							  PLOT_ARGUMENT, pPlot);
	  pAct->SetEntityArgValue(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS,
							  DISTRIBUTED_ACTIVITY_SET_ARGUMENT, pChantier);
	  pAct->SetIntArgValue(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS,
						   SPRAYER_TYPE_REGULAR_OPTION_ARGUMENT, 
						   App_GetIntDecisionOption (pVineyard, 
													 OPT_SPRAYER_TYPE_REGULAR));
	  pAct->SetIntArgValue(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS,
						   SPRAYER_TYPE_AT_BEGINNING_OPTION_ARGUMENT, 
						   App_GetIntDecisionOption (pVineyard, 
													 OPT_SPRAYER_TYPE_AT_BEGINNING));
	  pAct->SetIntArgValue(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS,
						   SPRAY_NUMBER_AT_BEGINNING_OPTION_ARGUMENT, 
						   App_GetIntDecisionOption (pVineyard, 
													 OPT_SPRAY_NUMBER_AT_BEGINNING));
	  int otClasId = pAct->ExecIntMethod(RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS);
	  pAct->SetIntVarValue(OPERATION_CLASS_ID, otClasId);

	  if(! strcmp(optionSerPar, "PAR")){
		pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
		pChantier->AddOperand(pAct);
	  }
	  else {
		((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	  }
	}
  }
//printf("\n==>");pChantier->DisplaySituation();printf("\n");
  delete plotsToProtectTab;
//printf("\naddNewSituatedPhytoTreatments_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedPlantations_Body(EntityMethod* pM)
//---------------------------------------------------
// ajoute au chantier de plantation des activites sur de nouvelles parcelles
//---------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedPlantations : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());
  //-------------------------------------------------
  // determination des nouvelles parcelles a tailler
  //-------------------------------------------------
  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_PLANT, VINEYARD_ARGUMENT, 
							   pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_PLANT,  
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_PLANT, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_PLANT, 
							   SERIAL_PARALLEL_ARGUMENT,
							   "SER");
  pEntityTab* plotsToPlantTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_PLANT);
  //  ----------------------------------------------------
//printf("\n\tplotsToPlantTab : "); plotsToPlantTab->display_names();
  int nbPlots = plotsToPlantTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToPlantTab->get_element(i);
	Activity* pAct;
	//
	// creation d'une activite de plantation
	//
	pAct = new PlantationActivity(pVineyard);
	//
	// priorites d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedPlantations sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de cette Plantation a la conjonction this
	//		
	((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
  }
  delete plotsToPlantTab;
//printf("\naddNewSituatedPlantations_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedPrunings_Body(EntityMethod* pM)
//------------------------------------------------
// ajoute au chantier de taille des activites sur de nouvelles parcelles
//------------------------------------------------
{
  bool result = FALSE;

  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedprunings : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Vineyard* pVineyard = (Vineyard*)App_GetVineyard((Activity*)pChantier);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());
  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
//printf("\n\tpConduite : '%s'", pConduite->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des tailles
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a tailler
  //-------------------------------------------------
  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_PRUNE, VINEYARD_ARGUMENT, 
							   pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_PRUNE,  
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_PRUNE, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots); 
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_PRUNE, // + JPT 130121
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pEntityTab* plotsToPruneTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_PRUNE);
  //  ----------------------------------------------------
//printf("\n\tplotsToPruneTab : "); plotsToPruneTab->display_names();
  int nbPlots = plotsToPruneTab->size();
	 
  // --------------------------------------------------
  // ajout a la conjonction d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  int numPhase = App_GetPhaseIndex((Activity*)pPhasicPlan) + 1;
  
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToPruneTab->get_element(i);
	
	char* typeTaille = pPlot->GetStringConstValue(PRUNING_MODE);
	//
	// ... on instancie une activite primitive de taille
	//
	Activity* pAct;
	if(! strcmp(typeTaille, "R")) {
	  //
	  // ... on instancie une activite primitive de taille / Royat
	  //
	  pAct = new RoyatPruningActivity(pVineyard);
	}
	else if(! strcmp(typeTaille, "G")){
	  //
	  // ... on instancie une activite primitive de taille / Guyot
	  //
	  pAct = new GuyotPruningActivity(pVineyard);
	}
	else if(! strcmp(typeTaille, "GOB")){
	  //
	  // ... on instancie une activite primitive de taille / Gobelet
	  //
	  pAct = new GobeletPruningActivity(pVineyard);
	}
	else {
	  int yearOfPlantation = pPlot->GetIntConstValue(YEAR_OF_PLANTATION);
	  // si plante en 2006 et qu'on est a l'automne 2006 alors age = 1
	  int now = pCurrentSim->Clock();
	  int age = ClockValueToDate(now).year - yearOfPlantation + 1;
	  if(age < 3) {
		pAct = new FormationPruningActivity(pVineyard);
	  }
	  else {
		//
		// ... on instancie une activite primitive de taille / Guyot
		//
		if(gMyTraceWarnings) printf("\n!!! sur '%s', taille Guyot par defaut", pPlot->InstanceName());
		pAct = new GuyotPruningActivity(pVineyard);
	  }
	}
	//
	// priorites d'allocation
	//
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedPrunings sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce Pruning a la conjonction this
	//	
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToPruneTab;
//printf("\naddNewSituatedPrunings_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedShootThinnings_Body(EntityMethod* pM)
//------------------------------------------------------
// ajoute au chantier de broyage des activites sur de nouvelles parcelles
//------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> argument de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedShootThinnings : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Vineyard* pVineyard = (Vineyard*)App_GetVineyard((Activity*)pChantier);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());
  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
//printf("\n\tpConduite : '%s'", pConduite->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des broyages
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a broyer
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_SHOOT_THIN, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_SHOOT_THIN,  
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_SHOOT_THIN,  
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_SHOOT_THIN, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pEntityTab* plotsToShootThinTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_SHOOT_THIN);
  //  ----------------------------------------------------------
//printf("\n\tplotsToShootThinTab : "); plotsToShootThinTab->display_names(); 
  int nbPlots = plotsToShootThinTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  int numPhase = App_GetPhaseIndex((Activity*)pPhasicPlan) + 1;
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToShootThinTab->get_element(i);
    Activity* pAct;
	//
	// creation d'une activite de broyage
	//
	pAct = new ShootThinningActivity(pVineyard);
	//
	// priorites d'allocation
	//
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// coder choix ss-classe d'operation en fonction de la largeur IR
	//
	pAct->SetEntityArgValue(RETURN_SHOOT_THINNING_OPERATION_SUBCLASS,
							PLOT_ARGUMENT, pPlot);
	int otClasId = pAct->ExecIntMethod(RETURN_SHOOT_THINNING_OPERATION_SUBCLASS);
	pAct->SetIntVarValue(OPERATION_CLASS_ID, otClasId);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedShootThinnings '%s' sur '%s' pPlot : '%s'", pAct->InstanceName(), pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce ShootThinning au chantier this
	//	
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  /* essai 120615
  pEntityTab pTmpTab = pChantier->GetDepthElementTab(ACTIVITY_MEETING_ANY);
  Activity* pLastAny = (Activity*)pTmpTab.get_nth(pTmpTab.size()-1);
  if(nbPlots == 0) {
	printf("\npnbPlots == %d --> LastAny : '%s'  <- WAITING", nbPlots, pLastAny->InstanceName());
	pLastAny->SetIntVarValue(SITUATION, WAITING);
	pLastAny->GetElement(0)->SetIntVarValue(SITUATION, WAITING);
  }
  else  {
	printf("\npnbPlots == %d --> LastAny : '%s'  <- WAITING", nbPlots, pLastAny->InstanceName());
	pLastAny->SetIntVarValue(SITUATION, SLEEPING);
	pLastAny->GetElement(0)->SetIntVarValue(SITUATION, SLEEPING);
  }
  */
  delete plotsToShootThinTab;
  //pChantier->DisplaySituation();
//printf("\naddNewSituatedShootThinnings_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedSpringChemicalWeedings_Body(EntityMethod* pM)
//--------------------------------------------------------------
// ajoute au chantier de desherbage de printemps des activites sur de nouvelles parcelles
//--------------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\naddNewSituatedSpringChemicalWeedings_Body sur '%s'", pChantier->InstanceName());
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> arguments de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN,
                                                                                         TRUE);
  if(pPhasicPlan == NULL) {
        printf("\naddNewSituatedSpringChemicalWeedings : pas de plan de phase trouve !\n");
        exit(0);   
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
        (Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des desherbages de printemps
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
        optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);

  char* manualMotorizedValue;
  if(! strcmp(optionSerPar, "PAR"))
	 manualMotorizedValue = "";
  else {
	if(pChantier->IsInstanceOf(SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS))
	  manualMotorizedValue = "MANUAL";
	else
	  manualMotorizedValue = "MOTORIZED";
  }
//printf("\n\tmanualMotorizedValue = '%s'", manualMotorizedValue);
       
  //-------------------------------------------------
  // determination des nouvelles parcelles a desherber au printemps
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_SPRING_WEED, 
							   VINEYARD_ARGUMENT, pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_SPRING_WEED, 
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_SPRING_WEED, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_SPRING_WEED,
							   SERIAL_PARALLEL_ARGUMENT,
							   optionSerPar);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_SPRING_WEED,
							   MANUAL_MOTORIZED_ARGUMENT,
							   manualMotorizedValue);
  
  pEntityTab* plotsToSpringWeedTab
        = pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_SPRING_WEED);
  //  ----------------------------------------------------------
//printf("\n\tplotsToSpringWeedTab : "); plotsToSpringWeedTab->display_names();
  int nbPlots = plotsToSpringWeedTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  Boolean headingActInSerialActivitySet = FALSE;
  if(! strcmp(optionSerPar, "SER")
	 &&
	 pChantier->GetNumberOfElements() == 0)
	headingActInSerialActivitySet = TRUE;
  
  bool actInstantiated;
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToSpringWeedTab->get_element(i);
    Activity* pAct;
	actInstantiated = FALSE;
	//
	// creation d'une activite de desherbage
	//
	/* version ecrite par NP+JPR

	if(! strcmp(optionSerPar, "SER")) {
	  if(! strcmp(manualMotorizedValue, "MOTORIZED")) { 
		pAct = new MotorizedChemicalWeedingActivity(pVineyard);
		UserClassId otClassId = HORIZONTAL_RAIL_OPERATED_SPRAYING;  // provisoire
        
		pAct->SetIntVarValue(OPERATION_CLASS_ID, otClassId);
		actInstantiated = TRUE;
	  }
	  else {  
		pAct = new ManualChemicalWeedingActivity(pVineyard);
		// otClassId = ? a faire ?
		actInstantiated = TRUE;
	  }
	}
	else {
	  // choix manuel/motorise en fonction de plusieurs criteres
	  // mais provisoirement un seul critere : parcelle motorisable ou pas
	  //
	  pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							OPERATION_CLASS_ARGUMENT,
							MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable = pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable = %d", isPlotMotorizable);
	  if(isPlotMotorizable) { 
		pAct = new MotorizedChemicalWeedingActivity(pVineyard);
		UserClassId otClassId = HORIZONTAL_RAIL_OPERATED_SPRAYING;  // provisoire
        
		pAct->SetIntVarValue(OPERATION_CLASS_ID, otClassId);
		actInstantiated = TRUE;
	  }
	  else {
		pAct = new ManualChemicalWeedingActivity(pVineyard);
		// otClassId = ? a faire ?
		actInstantiated = TRUE;
	  } 
	}
	*/
	// version JPR 110210 :
	//
	// Y compris en SER :
	// choix manuel/motorise en fonction de plusieurs criteres
	// mais provisoirement un seul critere : parcelle motorisable ou pas
	// <- la version remplacee cree deux SpringCW sur la meme parcelle :
	// . un qd cette meth est appelee sur le chantier SerialManual
	// . un qd cette meth est appelee sur le chantier SerialMotorized
	// (sur MG16_16 -la derniere-, et pas les autres !)
	//
	pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
						  OPERATION_CLASS_ARGUMENT,
						  MOTORIZED_SPRAYING_OPERATION);
	bool isPlotMotorizable = pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable = %d", isPlotMotorizable);
	if(isPlotMotorizable) { 
	  pAct = new MotorizedChemicalWeedingActivity(pVineyard);
	  UserClassId otClassId = HORIZONTAL_RAIL_OPERATED_SPRAYING;  // provisoire
	  
	  pAct->SetIntVarValue(OPERATION_CLASS_ID, otClassId);
	  actInstantiated = TRUE;
	}
	else {
	  pAct = new ManualChemicalWeedingActivity(pVineyard);
	  // otClassId = ? a faire ?
	  actInstantiated = TRUE;
	}

	if(actInstantiated) {  // securite utile ?
	  //
	  // priorite d'allocation
	  //
	  int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	  int allocPriority = 
		App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								  STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	  pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	  pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	  //
	  // designation de pPlot comme objet opere par pAct
	  //
	  Entity* pOOSpec = new OperatedObjectSpecification();
	  pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	  pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	  pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans '%s' sur '%s' pPlot : '%s'", pAct->InstanceName(), pVineyard->InstanceName(), pPlot->InstanceName());
	  //
	  // ajout de ce ChemicalWeeding au chantier
	  //  
	  if(! strcmp(optionSerPar, "PAR")){
		pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
		pChantier->AddOperand(pAct);
	  }
	  else {
		((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	  }     
	}
  }
  delete plotsToSpringWeedTab;
//printf("\naddNewSituatedSpringChemicalWeedings_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedSpringTillages_Body(EntityMethod* pM)
//------------------------------------------------------
// ajoute au chantier de labour de printemps des activites sur de nouvelles parcelles
//------------------------------------------------------
{
  bool result = FALSE;
  // on renvoie toujours FALSE pour que le ValidateClosed appelé dans UpdateSituation
  // soit forcé de tester le ClosingPredicate du chantier. En effet, 
  // - si le MIOS renvoie TRUE, le desc. DynamicAcivityTocontinue est mis à 1,
  // et ValidateClosed renvoie FALSE sans regarder le ClosingPredicate 
  // - si le MIOS renvoie FALSE, le desc. DynamicAcivityTocontinue est mis à 0,
  // et ValidateClosed regarde le ClosingPredicate pour décider le TurnToClosed

  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> argument de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedSpringTillages : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des labours
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a labourer
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_SPRING_TILL, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_SPRING_TILL, 
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_SPRING_TILL, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_SPRING_TILL, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pEntityTab* plotsToSpringTillTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_SPRING_TILL);
  //  ----------------------------------------------------------
//printf("\n\tplotsToSpringTillTab : "); plotsToSpringTillTab->display_names(); 
  int nbPlots = plotsToSpringTillTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToSpringTillTab->get_element(i);
    Activity* pAct;
	//
	// creation d'une activite de labour de printemps
	//
	pAct = new SpringTillageActivity(pVineyard);
	//
	// priorites d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// coder choix ss-classe d'operation en fonction de la largeur IR
	//
	pAct->SetEntityArgValue(RETURN_TILLAGE_OPERATION_SUBCLASS,
							PLOT_ARGUMENT, pPlot);
	pAct->SetIntArgValue(RETURN_TILLAGE_OPERATION_SUBCLASS,
						 SEASON_ARGUMENT, SPRING);
	int otClasId = pAct->ExecIntMethod(RETURN_TILLAGE_OPERATION_SUBCLASS);
	pAct->SetIntVarValue(OPERATION_CLASS_ID, otClasId);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedSpringTillages sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce SpringTillage au chantier this
	//	
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToSpringTillTab;
//printf("\naddNewSituatedSpringTillages_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedTrellisings_Body(EntityMethod* pM)
//---------------------------------------------------
// ajoute au chantier de relevage des activites sur de nouvelles parcelles
//---------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> arguments de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedtrellisings : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des relevages (+ JPR 120602)
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);

  //-------------------------------------------------
  // determination des nouvelles parcelles a relever
  //-------------------------------------------------
  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_TRELLIS, VINEYARD_ARGUMENT, 
							   pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_TRELLIS,  
								 TERMINATED_PLOTS_ARGUMENT, 
								 pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_TRELLIS, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_TRELLIS,
							  SERIAL_PARALLEL_ARGUMENT,
							   optionSerPar); // + JPR 130110
  pEntityTab* plotsToTrellisTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_TRELLIS);
  //  ----------------------------------------------------
//printf("\n\tplotsToTrellisTab : "); plotsToTrellisTab->display_names();
  int nbPlots = plotsToTrellisTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToTrellisTab->get_element(i);
	Activity* pAct;
	//
	// creation d'une activite de relevage
	//
	pAct = new TrellisingActivity(pVineyard);
	//
	// priorites d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedTrellisings sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce Trellising au chantier
	//	
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToTrellisTab;
//printf("\naddNewSituatedTrellisings_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool addNewSituatedWinterTillages_Body(EntityMethod* pM)
//------------------------------------------------------
// ajoute au chantier de labour d'hiver des activites sur de nouvelles parcelles
//------------------------------------------------------
{
  bool result = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
  //-------------------------------------------------
  // les parcelles en cours d'operation et terminees
  // -> argument de SelectPlotsToX
  //-------------------------------------------------
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);

  // ------------------------------------------------
  // suppression de toute activité programmee mais non demarree
  // (voir commentaire dans addNewSituatedAutumnTillages)
  // ------------------------------------------------
  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case WAITING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
	  break;
	}
	}
  }

  //-------------------------------------------------
  // recuperation du Vineyard
  //-------------------------------------------------
  BasicEntity* pPhasicPlan;
  pPhasicPlan = pChantier->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
											 TRUE);
  if(pPhasicPlan == NULL) {
	printf("\naddNewSituatedWinterTillages : pas de plan de phase trouve !\n");
	exit(0);    
  }
  Entity* pConduite = pPhasicPlan->GetSuperSet();
  Vineyard* pVineyard =
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\n\tpVineyard : '%s'", pVineyard->InstanceName());

  //-------------------------------------------------
  // recuperation organisation des labours
  //-------------------------------------------------
  char* optionSerPar = "SER";
  if(pChantier->IsInstanceOf(ACTIVITY_CONJUNCTION))
	optionSerPar = "PAR";
//printf("\n\toptionSerPar = '%s'", optionSerPar);
	
  //-------------------------------------------------
  // determination des nouvelles parcelles a labourer
  // en fonction de l'option SER(ial) / PAR(allel))
  //-------------------------------------------------

  pChantier->SetEntityArgValue(SELECT_NEW_PLOTS_TO_WINTER_TILL, VINEYARD_ARGUMENT, 
							  pVineyard);
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_WINTER_TILL, 
								 TERMINATED_PLOTS_ARGUMENT,
								 pTerminatedPlots);  
  pChantier->SetEntityTabArgValue(SELECT_NEW_PLOTS_TO_WINTER_TILL, 
								 IN_COURSE_PLOTS_ARGUMENT, 
								 pInCoursePlots);
  pChantier->SetStringArgValue(SELECT_NEW_PLOTS_TO_WINTER_TILL, 
							  SERIAL_PARALLEL_ARGUMENT,
							  optionSerPar);
  pEntityTab* plotsToWinterTillTab
	= pChantier->ExecEntityTabMethod(SELECT_NEW_PLOTS_TO_WINTER_TILL);
  //  ----------------------------------------------------------
//printf("\n\tplotsToWinterTillTab : "); plotsToWinterTillTab->display_names(); 
  int nbPlots = plotsToWinterTillTab->size();

  // --------------------------------------------------
  // ajout au chantier d'activites sur ce lot :
  // - il y a une activite pour chaque parcelle ajoutee
  // - l'ordre des activites respecte celui des parcelles,
  //   pour la cas ou celui-ci serait intentionnel
  // --------------------------------------------------
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot = (Entity*)plotsToWinterTillTab->get_element(i);
    Activity* pAct;
	//
	// creation d'une activite de labour d'hiver
	//
	pAct = new WinterTillageActivity(pVineyard);
	//
	// priorites d'allocation
	//
	int numPhase = pConduite->GetElementPosition(pPhasicPlan) + 1;
	int allocPriority = 
	  App_GetAllocationPriority(pVineyard, pAct->ClassName(), 
								STANDARD_VALUE_PRIORITY_TAB, numPhase); 
	pAct->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority); 
	pChantier->SetIntConstValue(ALLOCATION_PRIORITY_DEGREE, allocPriority);
	//
	// coder choix ss-classe d'operation en fonction de la largeur IR
	//
	pAct->SetEntityArgValue(RETURN_TILLAGE_OPERATION_SUBCLASS,
							PLOT_ARGUMENT, pPlot);
	pAct->SetIntArgValue(RETURN_TILLAGE_OPERATION_SUBCLASS,
						 SEASON_ARGUMENT, WINTER);
	int otClasId = pAct->ExecIntMethod(RETURN_TILLAGE_OPERATION_SUBCLASS);
	pAct->SetIntVarValue(OPERATION_CLASS_ID, otClasId);
	//
	// designation de pPlot comme objet opere par pAct
	//
	Entity* pOOSpec = new OperatedObjectSpecification();
	pOOSpec->AddEntityValueElement(PRE_EXPANDED_LIST, pPlot);
	pOOSpec->SetIntConstValue(SELECTOR_FCT_ID, ALL);
	pAct->SetEntityVarValue(OPERATED_OBJECT_SPEC_ATTRIBUTE, pOOSpec);
//printf("\ndans addNewSituatedWinterTillages sur '%s' pPlot : '%s'", pVineyard->InstanceName(), pPlot->InstanceName());
	//
	// ajout de ce WinterTillage au chantier this
	//		
	if(! strcmp(optionSerPar, "PAR")){
	  pAct->SetIntVarValue(SITUATION, WAITING, FALSE);
	  pChantier->AddOperand(pAct);
	}
	else {
	  ((ActivityMeetingAny*)pChantier)->AddOperand(pAct);
	}
  }
  delete plotsToWinterTillTab;
//printf("\naddNewSituatedWinterTillages_Body sur '%s' returns %d", pChantier->InstanceName(), result);
  return result;
};

bool antiDownyMildewAtLeastClosingPredicate_Body(EntityMethod* pM)
//----------------------------------------------------------------
// renvoie vrai ssi il y a lieu d'arreter la serie de traitement anti-mildiou en absence de pression
//----------------------------------------------------------------
// Selon une option propre au manager, la condition premiere necessaire
// pour arreter les traitements anti-mildiou est :
// SOIT - un stade pheno est atteint pour la Late Variety
// SOIT - le risque mildiou est faible
// SOIT - les traitements anti-oidium sont arretes
//
{
  Entity* pIteration = pM->DescribedEntity();
  Vineyard* pEA = (Vineyard*)App_GetVineyard((Activity*)pIteration);

  bool result = FALSE;

  int option = App_GetIntDecisionOption(pEA, OPT_DOWNY_MILDEW_AT_LEAST_CLOSING);

  switch (option) {
	//
	// les 'case' stade
	//
  case 0 : {             // FRUIT_SET 
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "fruitSet");
	break;
  }
  case 1 : {             // PEA_SIZED  
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "berriesPeaSized");
	break;
  }
  case 2 : {             // BERRY-TOUCH 
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "beginningOfBerryTouch");
	break;
  }
  case 3 : {             // EARLY_RIPENING 
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "beginningOfBerryRipening");
	break;
  }
  case 4 : {             // END_RIPENING 
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "endOfBerryRipening");
	break;
  }
	//
	// le 'case' risque mildiou (ssi au moins floraison atteinte)
	//
  case 5 : {
	bool floraisonAtteinte =  
	  App_IsStageReachedForLateGuidingVariety(pEA, "lateFlowering");
	if(floraisonAtteinte) {
	  float downyMildewRiskLevel =
		App_GetFloatPestInfo(pEA, DOWNY_MILDEW_RISK_LEVEL);
	  float threshold = gRealParam_virtualManager_riskLevelForDownyMildewClosing_;
	  if((downyMildewRiskLevel >= -5)  // -infini par defaut (App_GetFloatPestInfo)
		 &&
		 (downyMildewRiskLevel < threshold)) {
		result = TRUE;
	  }
	}
	break;
  }
	//
	// le 'case' anti-oidium arrete
	//
  case 6 : {
	result = pIteration->GetIntConstValue(POWDERY_MILDEW_TO_CLOSE);
	break;
  }
  }
  return result;
};

bool antiDownyMildewUnderPressureClosingPredicate_Body(EntityMethod* pM)
//------------------------------------------------------------------
// renvoie vrai ssi il y a lieu d'arreter la serie de traitement anti-mildiou en presence de pression
//------------------------------------------------------------------
// Selon une option propre au manager, la condition premiere necessaire
// pour arreter les traitements anti-mildiou est :
// SOIT - un stade pheno est atteint pour la Late Variety
// SOIT - le risque mildiou est faible
// SOIT - les traitements anti-oidium sont arretes
//
{
  Entity* pIteration = pM->DescribedEntity();
  Vineyard* pEA = (Vineyard*)App_GetVineyard((Activity*)pIteration);

  bool result = false;

  int option = App_GetIntDecisionOption(pEA, 
										OPT_DOWNY_MILDEW_UNDER_PRESSURE_CLOSING);

  switch (option) {
	//
	// les 'case' stade
	//
  case 0 : {             // FRUIT_SET 
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "fruitSet");
	break;
  }
  case 1 : {             // PEA_SIZED  
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "berriesPeaSized");
	break;
  }
  case 2 : {             // BERRY-TOUCH 
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "beginningOfBerryTouch");
	break;
  }
  case 3 : {             // EARLY_RIPENING 
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "beginningOfBerryRipening");
	break;
  }
  case 4 : {             // END_RIPENING 
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "endOfBerryRipening");
	break;
  }
	//
	// le 'case' risque mildiou (ssi au moins floraison atteinte)
	//
  case 5 : {
	bool floraisonAtteinte =  
	  App_IsStageReachedForLateGuidingVariety(pEA, "lateFlowering");
	if(floraisonAtteinte) {
	  float downyMildewRiskLevel = 
		App_GetFloatPestInfo(pEA, DOWNY_MILDEW_RISK_LEVEL);
	  float threshold = gRealParam_virtualManager_riskLevelForDownyMildewClosing_;
	  if((downyMildewRiskLevel >= -5)  // -infini par defaut (App_GetFloatPestInfo)
		 &&
		 (downyMildewRiskLevel < threshold)) {
		result = TRUE;
	  }
	}
	break;
  }
	//
	// le 'case' anti-oidium arrete
	//
  case 6 : {
	result = pIteration->GetIntConstValue(POWDERY_MILDEW_TO_CLOSE);
	break;
  }
  }
  return result;
};

bool antiPowderyMildewClosingPredicate_Body(EntityMethod* pM)
//-----------------------------------------------------------
// renvoie vrai ssi il y a lieu d'arreter la serie de traitement anti-oidium
//-----------------------------------------------------------
{
  Entity* pIteration = pM->DescribedEntity();
//printf("\n'%s'::antiPowderyMildewClosingPredicate", pIteration->InstanceName());
  Vineyard* pEA = (Vineyard*)App_GetVineyard((Activity*)pIteration);

  bool result = false;

  int option = App_GetIntDecisionOption(pEA, OPT_POWDERY_MILDEW_CLOSING);

  switch (option) {
  case 0 : {             // BERRY-TOUCH
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "beginningOfBerryTouch");
	break;
  }
  case 1 : {             // EARLY_RIPENING
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "beginningOfBerryRipening");
	break;
  }
  case 2 : {             // END_RIPENING
	result = App_IsStageReachedForLateGuidingVariety(pEA, 
													 "endOfBerryRipening");
	break;
  }
  case 3 : {             // AUGUST
	//=================================================
	// recuperation de la date de debut du chantier Regular
	//=================================================
	//
	Entity* iteratedActivity = pIteration->GetElement(0);
	int actualRegularBegDate = D_INTMAX;
	if(iteratedActivity->IsInstanceOf(VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN)) {
	  Entity* pChantier0 = iteratedActivity->GetElement(0);
	  int actualRegularBegDate0 = 
		pChantier0->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
	  if(actualRegularBegDate0 < actualRegularBegDate)
		actualRegularBegDate = actualRegularBegDate0;
	  Entity* pChantier1 = iteratedActivity->GetElement(1);
	  int actualRegularBegDate1 = 
		pChantier1->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
	  if(actualRegularBegDate1 < actualRegularBegDate)
		actualRegularBegDate = actualRegularBegDate1;
	}
	else {
	  actualRegularBegDate = 
		iteratedActivity->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
	}
//printf("\n\tactualRegularBegDate = %d\n", actualRegularBegDate);
	tm* pTm_now = ClockValueToTm(pCurrentSim->Clock());
	int year_now = pTm_now->tm_year;
	pTm_now->tm_mon = 7; // aout
	pTm_now->tm_mday = 1;
	mktime(pTm_now);
	int clock_seuil = StructTmToClockValue(pTm_now);
	delete pTm_now;
	
	if (actualRegularBegDate >= clock_seuil)
	  result = TRUE;
	break;
  }
  }
  
//printf("\nantiPowderyMildewClosingPredicate(%s) returns %d", pIteration->InstanceName(), result);
	return result;
};

void assignRelativeAreaToRows_Body(EntityMethod* pM)
//--------------------------------------------------
// repartit la surface de la parcelle entre les quatre types de rangees
//--------------------------------------------------
{
  Entity* pPlot = pM->DescribedEntity();
  float q = 
	pPlot->GetFloatConstValue(RIDING_ORIENTED_INTER_ROW_PROPORTION);
  float p = 
	pPlot->GetFloatConstValue(GRASS_STRIP_ALLEY_WIDTH_RATIO);
  float r = 
	pPlot->GetFloatConstValue(CROP_ROW_ALLEY_WIDTH_RATIO);
  //
  // visite des (4) rangs
  //
  Entity* pVegetal = pPlot->GetComponent(VEGETAL_COMPARTMENT);

  bool isPlotWithGrass = FALSE;
  int nbRows = pVegetal->GetNumberOfElements();
  float prop = (float)0.25;
  for(int i=0;i<nbRows;i++) {
	Entity* pRow_i = pVegetal->GetElement(i);
	switch (i) {
	case 0 : {            // inter-rang stabilise
	  int modality = pRow_i->GetIntConstValue(SOIL_MANAGEMENT_MODALITY); 
	  if (modality == GRASS_COVER){
		isPlotWithGrass = TRUE;
		prop = (p*q);
	  }
	  else {
		prop = (q*(1-r));
	  }
	  break;
	}
	case 1 : {            // inter-rang travaille
	  prop = ((1-r)*(1-q));
	  break;
	}
	case 2 : {            // rang voisin d'un inter-rang stabilise
	  if (isPlotWithGrass) {
		prop = (q*(1+r-p));
	  }
	  else if(q == 1) {
		prop = r;
	  }
	  else {
		prop = (2*q*r);
	  }
	  break;
	}
	case 3 : {          // rang non voisin d'un inter-rang stabilise
	  if (q == 1) { // cas particulier: si que des inter-rangs stabilises pas de rang 3
		prop = 0;
	  }
	  else {
		prop = (r*(1-2*q));
	  }
	  break;
	}
	default : {
	  printf("\nassignRelativeAreaToRows : '%s' nombre de rangees illegal\n", pPlot->InstanceName());
	  exit(0);
	}
	}
	pRow_i->SetFloatConstValue(RELATIVE_AREA, prop);
//printf("\nassignRelativeAreaToRows : '%s'/'%s' = %3.2f\n", pRow_i->InstanceName(), pPlot->InstanceName(), prop);
  }
};

void attachFarmWorkerToTimetables_Body(EntityMethod* pM)
//-----------------------------------------------------
// attachement reciproque entre l'ouvrier et les Timetable des periodes de l'AnnualPlan
//-----------------------------------------------------
{
  Entity* pEmploymentPlan = pM->DescribedEntity();
  BasicEntity* pFarmWorker = pM->GetEntityArgValue(FARM_WORKER_ARGUMENT);

  int nbSeasons = pEmploymentPlan->GetNumberOfElements();
  for(int k=0;k<nbSeasons;k++)  {
	Entity* pSeasonalPlan = pEmploymentPlan->GetElement(k);
	Entity* pRATT = pSeasonalPlan->GetEntityConstValue(TIMETABLE_ATTRIBUTE);
	((RecurrentAvailabilityTimetable*)pRATT)->AttachToResource((SingleResource*)pFarmWorker);
  }
};

void dumpOperationRecords_Body(EntityMethod* pM)
//----------------------------------------------
// ecrit sur un fichier externe le contenu de la memoire des operations du manager
//----------------------------------------------
{
  //
  // recuperation de la memoire des operations du manager 
  // alimentee dans AchievementDegreeMonitor
  //
  Entity* pManager = pM->DescribedEntity();
  Entity* pOtRecordingStructure = 
	  pManager->GetEntityConstValue(OPERATION_RECORDING_ATTRIBUTE);
  int nbRecords = pOtRecordingStructure->GetNumberOfElements();
  //
  // parcours des enregistrements memorises
  //
  for(int k=0;k<nbRecords;k++) {
	Entity* pRecordItem_k = pOtRecordingStructure->GetElement(k);
	//
	// recuperation YMD, plot, activite, operation, duree
	// 
	int year_k = pRecordItem_k->GetIntConstValue(RECORDED_YEAR);
	int month_k = pRecordItem_k->GetIntConstValue(RECORDED_MONTH);
	int day_k = pRecordItem_k->GetIntConstValue(RECORDED_DAY);
	char* plot_k = pRecordItem_k->GetStringConstValue(RECORDED_PLOT_NAME);
	char* cha_k = pRecordItem_k->GetStringConstValue(RECORDED_CHANTIER_CLASS_NAME);  // 120516 4.6
	char* act_k = pRecordItem_k->GetStringConstValue(RECORDED_ACTIVITY_CLASS_NAME);
	char* ot_k = pRecordItem_k->GetStringConstValue(RECORDED_OPERATION_CLASS_NAME);
	int nbHours_k = pRecordItem_k->GetIntConstValue(RECORDED_IN_DAY_DURATION);
	//
	// recuperation listes de performers, ressources, produits phyto
	// 
	pEntityTab* perfList_k = 
	  pRecordItem_k->GetEntityTabConstValue(RECORDED_PERFORMER_LIST);
	pEntityTab* rscList_k = 
	  pRecordItem_k->GetEntityTabConstValue(RECORDED_RESOURCE_LIST);
	TableauString* productList_k = 
	  pRecordItem_k->GetStringTabConstValue(RECORDED_PHYTO_PRODUCT_LIST);
	//
	// calcul du jour de semaine (LUN, ...)
	// 
    tm* pTm = new tm();
	pTm->tm_year = year_k;pTm->tm_mon = month_k;pTm->tm_mday = day_k;
	mktime(pTm);
	int wday_k = pTm->tm_wday;
	delete pTm;
	//
	// ecriture des champs jour de semaine, YMD, plot, act, operation, duree
	// gFileBDD est instancie, ouvert et ferme dans la fonction main(...)
	// 
	FILE* pF = gFileBDD->GetPhysicalFile();
	fprintf(pF, "\n%s %d %d %d %s %s %s %s %d",  // 120516 4.6
			ShortWeekDayNameToCharTab[wday_k], year_k+1900, month_k+1, day_k, 
			plot_k, cha_k, act_k, ot_k, nbHours_k);
	//
	// calcul de l'effectif alloue a l'activite pour les 7 types de MO Perm
	// dans l'ordre : pATT, pPT, pTT, pTOT, pMTM, pP, pVG
	// par exemple  :   2    0    0    0     1    0    0
	//
	pIntTab* profilMO = App_SummarizePerformerPool(perfList_k);
	//
	// ecriture des 7 champs pour les types de MO
	// 
	for(int p=0;p<7; p++) fprintf(pF, " %d", profilMO->get_nth(p));
    delete profilMO;
	//
	// calcul du nb de Rsc allouees a l'operation pour les 5 types d'outils
	// dans l'ordre : TRACTOR, PULVE, TILLAGE_TOOL, GRINDER, autres
	// par exemple  :    1       1           0         0       0
	//
	pIntTab* profilTools = App_SummarizeToolSet(rscList_k);
	//
	// ecriture des 5 champs pour les types d'outils
	// 
	for(int p=0;p<5; p++) fprintf(pF, " %d", profilTools->get_nth(p));
    delete profilTools;
	//
	// calcul des 2 champs anti-oidium et anti-mildiou pour les traitements
	// par exemple  :          oidium          -
	// seulement si liste renseignee dans AchievementDegreeMonitor
	//
	if(productList_k) {  
	  TableauString* profilProd = new TableauString("-", 2);
	  int nbProds = productList_k->size();
	  for (int p = 0;p<nbProds;p++) {
		char* pProd_k_p = productList_k->get_nth(p);
		if(strstr(pProd_k_p, "oidium"))
		  profilProd->set_nth(0, "oidium");
		else if(strstr(pProd_k_p, "mildiou"))
		  profilProd->set_nth(1, "mildiou");
	  }
	  //
	  // ecriture des 2 champs pour les produits phyto
	  // 
	  for(int p=0;p<2; p++) fprintf(pF, " %s", profilProd->get_nth(p));
	  delete profilProd;
	}
  }
};

float getActualThermalTimeFromEmergence_Body(EntityMethod* pM)
//---------------------------
// Renvoie la somme de degres.jour reelle depuie la levee
//--------------------------
{
  Entity* pGrassAge = pM->DescribedEntity();
  //
  // recherche de la somme de temperatures de la veille
  //
  float oldSumTemp = pGrassAge->GetFloatVarValue(THERMAL_TIME_FROM_EMERGENCE);
//printf("\n somme de la veille = %4.2f",oldSumTemp);
  float newSumTemp = (float)0.;
  //
  // recherche du composant Grass
  //
  Entity* pGrass  = pGrassAge->GetEntityConstValue(PLANT_ATTRIBUTE);
  //Entity* pGrassType = pGrass->GetEntityConstValue(GRASS_TYPE_ATTRIBUTE);

  Entity* pRow = pGrass->GetSuperEntity();
  Entity* pVegetalCompartment= pRow->GetSuperSet();
  Entity* pPlot = pVegetalCompartment->GetSuperEntity();

  Entity* pWeather = pPlot->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
  //
  // calcul de la temperature efficace du jour
  //
  float actualTemp = pWeather->GetFloatVarValue(TEMPERATURE);
  
   FloatEntityMethod* pM2 = 
 	(FloatEntityMethod*)(pGrass->GetMethod(RETURN_EFFECTIVE_TEMPERATURE));
   pM2->SetArgValue(TEMPERATURE_ARGUMENT, actualTemp);
   float effectiveTemp = pM2->Body(pM2);

  //
  // calcul de la somme de temperature du jour courant
  //
    newSumTemp = oldSumTemp + effectiveTemp;

  /*
  // recherche de la duree de vie min des feuilles
  // si somme de temp > duree de vie; remis a 0 pr calcul de senescence
  //
  Entity* pGrassType = pGrass->GetEntityConstValue(GRASS_TYPE_ATTRIBUTE);
  int leafLifeSpan = pGrassType->GetIntConstValue(LEAF_LIFE_SPAN_MIN);
  float laiRes = pGrassType->GetFloatVarValue(LEAF_AREA_INDEX_RESIDUAL);
  float leafAreaIndex = pGrass->GetFloatValue(LEAF_AREA_INDEX);
  if((oldSumTemp > (float)leafLifeSpan)
     ||
     (leafAreaIndex == laiRes))
    //newSumTemp = effectiveActualTemp;

    newSumTemp = effectiveTemp;
    //newSumTemp = actualTemp;
	*/

//printf("\n somme  = %3.2f",actualTemp);
//printf("\n somme  = %3.2f",effectiveTemp);
//printf("\n somme  = %3.2f",effectiveActualTemp);
//printf("\n somme  = %3.2f",newSumTemp);
  pGrassAge->SetFloatVarValue(THERMAL_TIME_FROM_EMERGENCE, newSumTemp);

  return newSumTemp;

};

int getDayWhenStageAchieved_Body(EntityMethod* pM)
//-------------------------
// renvoie le nb de jours depuis le semis, a la fin d'un stade donne
//-------------------------
{
  int result = 0;
  Entity* pAge = pM->DescribedEntity();
  int i = pM->GetIntArgValue(STAGE_INDEX_ARGUMENT);
  pEntityTab* tab = pAge->GetEntityTabValue(STAGE_TAB);
  PhenoStage* stage_i = (PhenoStage*) tab->get_element(i);
  result = stage_i->GetIntValue(DAY_WHEN_ACHIEVED);

  return result;
};

pEntityTab* getFirstWaveList_Body(EntityMethod* pM)
//-------------------------------------------------
// renvoie la liste des varietes prioritaires pour les traitements phyto
//-------------------------------------------------
{
  Entity* pVarGroupSet = pM->DescribedEntity();
//printf("\ngetFirstWaveList sur pVarGroupSet '%s'", pVarGroupSet->InstanceName()); 
  Entity* pVineyard = pM->GetEntityArgValue(VINEYARD_ARGUMENT);
//printf("\ngetFirstWaveList sur '%x'", pVineyard); 

  pEntityTab* result = new pEntityTab();

  int nbVarGroups = pVarGroupSet->GetNumberOfElements();

  pEntityTab* localVarietyList = pVineyard->GetEntityTabConstValue(GRAPE_VARIETY_LIST_ATTRIBUTE);
  if(nbVarGroups == 0) {
	result->push_back(*localVarietyList);
  }
  else {
	Entity* pFirstGroup = pVarGroupSet->GetElement(0);
	pEntityTab firstVarietyTab = pFirstGroup->GetElementTab();

	int inOutMode = pFirstGroup->GetIntConstValue(MEMBERSHIP_MODE);
	if(inOutMode == IN) {
	  result->push_back(firstVarietyTab);
	}
	else {
	  int nbLocals = localVarietyList->size();
	  for(int k=0;k<nbLocals;k++) {
		BasicEntity* localVar_k = localVarietyList->get_element(k);
		if(GetPosition(firstVarietyTab, localVar_k) < 0)
		  result->push_back(localVar_k);
	  }
	}
  }
//printf("\ngetFirstWaveList sur '%s' returns :", pVineyard->InstanceName()); result->display_names();
  return result;
};

pEntityTab* getRankedWaveList_Body(EntityMethod* pM)
//--------------------------------------------------
// renvoie la liste des varietes a traiter phyto, en fct d'un rang de priorite en arg.
// localVarietyList : {a b c d e f g h}
//                   IN      NOT_IN    IN   
// pVarGroupSet : ( {a b}  {a b c d}  {g h} )   
// ==> 
// result :
// pour rank=1  : {a b}
// pour rank=2  : {a b e f}
// pour rank=3  : {a b e f g h}
// pour rank>3  : {a b c d e f g h} // et pas {a b e f c d g h}  !!
// pour rank=-9 : {a b c d e f g h}
//--------------------------------------------------
{
  Entity* pVarGroupSet = pM->DescribedEntity();
  Entity* pVineyard = pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  int stageIndex = pM->GetIntArgValue(STAGE_INDEX_ARGUMENT);
  //stageIndex = compteur d'iterations
//printf("\ngetRankedWaveList sur '%s', EA : '%s' rang=%d", pVarGroupSet->InstanceName(), pVineyard->InstanceName(), stageIndex); 
  pEntityTab* result = new pEntityTab();

  int nbVarGroups = pVarGroupSet->GetNumberOfElements();

  pEntityTab* localVarietyList = 
	pVineyard->GetEntityTabConstValue(GRAPE_VARIETY_LIST_ATTRIBUTE);
  if((nbVarGroups == 0)
	 ||
	 (stageIndex == -9)) {
	result->push_back(*localVarietyList);
  }
  else {
	if(stageIndex < nbVarGroups) {
	  for(int rank=0;rank<=stageIndex;rank++)  {
		Entity* pGroup_rk = pVarGroupSet->GetElement(rank);
		pEntityTab pVarietyTab_rk = pGroup_rk->GetElementTab();
		
		int inOutMode = pGroup_rk->GetIntConstValue(MEMBERSHIP_MODE);
		if(inOutMode == IN) {
		  result->push_back_ifnew(pVarietyTab_rk);
		}
		else {
		  int nbLocals = localVarietyList->size();
		  for(int k=0;k<nbLocals;k++) {
			BasicEntity* localVar_k = localVarietyList->get_element(k);
			if(GetPosition(pVarietyTab_rk, localVar_k) < 0)
			  result->push_back_ifnew(localVar_k);
		  }
		}
	  }
	}
	else {
	  //
	  // au dernier rang, on renvoie toutes les cepages
	  //
	  result->push_back(*localVarietyList);
	}
  }
//printf("\ngetRankedWaveList sur '%s', EA : '%s' rang=%d returns :", pVarGroupSet->InstanceName(), pVineyard->InstanceName(), stageIndex);result->display_names();
  return result;
};

bool isClockValueInCalendar_Body(EntityMethod* pM)
//------------------------------------------------
// renvoie 'vrai' ssi la valeur d'horloge en argument est dans le OffWorkCalendar
//------------------------------------------------
// - currentPeriod est la periode du calendrier qui contient l'horloge courante
//   ou bien la p�riode la plus r�cente pr�cedant l'horloge courante
//   (mise � jour dans  updateSeasonCurrentIndexProcess)
//------------------------------------------------
{
  Entity* pCalendar = pM->DescribedEntity();
  int clockArgument = pM->GetIntArgValue(CLOCK_ARGUMENT);
  bool result = FALSE;

  int nbPeriods = pCalendar->GetNumberOfElements();

  int currentPeriodIndex = pCalendar->GetIntVarValue(CURRENT_ELEMENT_INDEX);

  if(currentPeriodIndex < 0) currentPeriodIndex = 0;  // + JPR 110105

  Entity* pCurrentPeriod;
  for(int cpt=0;cpt<nbPeriods;cpt++) {

	int index_cpt = currentPeriodIndex+cpt;
	if(index_cpt > nbPeriods-1)
	  index_cpt = index_cpt - nbPeriods;
	pCurrentPeriod = pCalendar->GetElement(index_cpt);

	pCurrentPeriod->SetIntArgValue(IS_CLOCK_VALUE_IN_PERIOD,
								   CLOCK_ARGUMENT, clockArgument);
	bool isClockInCurrent 
	  = pCurrentPeriod->ExecPredicate(IS_CLOCK_VALUE_IN_PERIOD);
	if(isClockInCurrent) {
	  result = TRUE;
	  break;
	}
  }
//printf("\n'%s'::isClockValueInCalendar(%d) currentPeriod : [%s %s] returns %d", pCalendar->InstanceName(), pCurrentPeriod->GetStringConstValue(BEGINNING_CALENDAR_DATE), pCurrentPeriod->GetStringConstValue(END_CALENDAR_DATE), result)
  return result;
};

bool isClockValueInPeriod_Body(EntityMethod* pM)
//----------------------------------------
// renvoie 'vrai' ssi la valeur d'horloge en argument est dans la WorkSinglePeriod
//----------------------------------------
{
  Entity* pPeriod = pM->DescribedEntity();
  int clockArgument = pM->GetIntArgValue(CLOCK_ARGUMENT);
  bool result = FALSE;

  //
  // les dates de debut et de fin sont au format aaaa-mm-jj par convention
  //
  char* begValue = pPeriod->GetStringConstValue(BEGINNING_CALENDAR_DATE);
  char* strBeg = strdup(begValue);
  char* yStrBeg = strtok(strBeg, "-");
  char* mStrBeg = strtok(NULL, "-");
  char* dStrBeg = strtok(NULL, "-");
  int yBeg = atoi(yStrBeg);
  int mBeg = atoi(mStrBeg);
  int dBeg = atoi(dStrBeg);
  int clockBeg = DateToClockValue(dBeg, mBeg, yBeg, 0, 0, 0);
  free(strBeg);
  
  int clockEnd;
  char* endValue = pPeriod->GetStringConstValue(END_CALENDAR_DATE);
  char* strEnd = strdup(endValue);
  if(strlen(strEnd) > 0) {
	char* yEnd = strtok(strEnd, "-");
	char* mEnd = strtok(NULL, "-");
	char* dEnd = strtok(NULL, "-");
	clockEnd = DateToClockValue(atoi(dEnd), atoi(mEnd), atoi(yEnd), 23, 0, 0);
  }
  else {
	//
	// la valeur "" pour la date de fin implique une periode de un jour
	//
	clockEnd = DateToClockValue(dBeg, mBeg, yBeg, 23, 0, 0);
  }
  free(strEnd);

  if((clockArgument >= clockBeg)
	 &&
	 (clockArgument <= clockEnd))
	result = TRUE;
//printf("[%s %s]=[%d %d]::isClockValueInPeriod(%d) returns %d", begValue, endValue, clockBeg, clockEnd, clockArgument, result);
  return result;
};

bool isMotorizationPossible_Body(EntityMethod* pM)
//--------------------------
// renvoie TRUE ssi les ressources de l'EA sont OK pour l'OT en argument
//--------------------------
{
  Entity* pPlot = pM->DescribedEntity();
  int operationClassArgument = pM->GetIntArgValue(OPERATION_CLASS_ARGUMENT);
  bool result = false;
  //
  // provisoire : on ne regarde que l'ecartement
  // plus tard : regarder concordance entre materiel et ecartement, compte tenu
  //             du type d'operation en jeu. Le materiel regarde sera le pool
  //             de ressources instancie en peambule de la simulation
  //
  int alleyWidth = pPlot->GetIntConstValue(ALLEY_WIDTH);

  if(alleyWidth >= 200)
	result = true;

//printf("\nt = %d, isMotorizationPossible sur '%S' = %d", pCurrentSim->Clock(), pPlot->InstanceName(), result);
  return result;
};

float operationNominalDuration_Body(EntityMethod* pM)
//-------------------------------------------------
// returns the previsionnal duration of the operation of a primitive activity
//-------------------------------------------------
{
  float result = (float)0.;
  Entity* pV_alloc  
	= pM->GetEntityArgValue(CANDIDATEENTITYVALUE_ARGUMENT);
  Entity* ooSet = pV_alloc->GetComponent(ALLOCATED_OPERATED_OBJECT_SET);
  int nbOO = ooSet->GetNumberOfElements();
  //
  // pas d'objets operes encore alloues : duree nulle
  //
  Entity* pInst = pM->DescribedEntity();
  if(nbOO > 0) {
	Entity* otSpec = pInst->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	int now = pCurrentSim->Clock();
	if(!otSpec) {
	  //
	  // pas de specification d'operation :
	  // - si specification necessaire (cas general) : arret simulation
	  // - si specification non necessaire : on renvoie -9
	  //
	  int otSpecNotRequired  = pInst->GetIntConstValue(NO_OPERATION_SPEC);
	  if(! otSpecNotRequired)
		App_Exception(ERR_NO_OT_SPEC, now, pInst);
	  else
		result = -9;
	} 
	else {
	  Entity* pOt = otSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  UserDescriptorId qtyDescId = pOt->GetIntConstValue(QUANTITY_DESCRIPTOR_ID);
	  int opEntityId = pOt->GetIntConstValue(OPERATED_ENTITY_ID);

	  int nbInvolvedEntities = 0;
	  pEntityTab* ooList = new pEntityTab();
	  for(int k=0;k<nbOO;k++) {
		Entity* pObj_k = ooSet->GetElement(k);
		Entity* oo = pObj_k->GetEntityConstValue(RESOURCE_ENTITY);
		if(oo->IsInstanceOf(opEntityId))
		  ooList->push_back(oo);
		else
		  ooList->push_back(oo->GetDepthElementTab(opEntityId));
	  } 
//printf("\n\tooList : ");ooList->display_names();
	  int nbOO = ooList->size();
	  float totalQty = (float)0.;
	  for(int j=0;j<nbOO;j++) {
		Entity* pOO = (Entity*)ooList->get_element(j);
		totalQty += pOO->GetFloatConstValue(qtyDescId);
	  }
	  delete ooList;
	  float speed  = ((FloatQuantityGranulatedOperation*)pOt)->GetFloatQuantitySpeed();
//printf("\n\ttotalQty = %f\tspeed = %f\ttotalQty/speed = %f", totalQty, speed, totalQty / speed);
	  result = ceil(totalQty / speed);
	}
  }
//printf("\noperationNominalDuration_Body pour '%s' returns %f", pInst->InstanceName(), result);
  return result;
};

float returnEffectiveTemperature_Body(EntityMethod* pM)
//-----------------------------------------------------
// donne la temp en prenant le zero de vegetation de la plante consideree
//-----------------------------------------------------
{
  float result;
  /*
  Entity* pVegetation = pM->DescribedEntity();
  float currentTemp = pM->GetFloatArgValue(TEMPERATURE_ARGUMENT);
  float baseTemp = pVegetation->GetFloatConstValue(BASE_TEMPERATURE);
  float satTemp = pVegetation->GetFloatConstValue(SATURATION_TEMPERATURE);
  
  if(currentTemp < baseTemp) {
    result = 0;
  }
  else {
  if (currentTemp > satTemp) {
    result = satTemp;
    }
    else {
      result = currentTemp-baseTemp;
    }
  }
//printf("\n tempBase  = %3.2f", baseTemp);
//printf("\nupdateReturnEffectiveTemp from %4.1f to %4.1f", currentTemp, result);
*/
  return result;
};

float returnPassedRowsFrequency_Body(EntityMethod* pM)
//----------------------------------------------------
// Renvoie la fr�quence de passage dans les inter-rangs en fonction de l'operation
//----------------------------------------------------
{
  Entity* pPlot = pM->DescribedEntity();
  Operation* pOt = (Operation*)pM->GetEntityArgValue(OPERATION_ARGUMENT);
  UserClassId operationClassId = pOt->ClassId();
  float result = (float)0.5;     // default value

  float q_plot = 
	pPlot->GetFloatConstValue(RIDING_ORIENTED_INTER_ROW_PROPORTION);

  switch (operationClassId) {
  case CLIPPING_OPERATION :
  case CHEMICAL_DEBRANCHER_OPERATED_SPRAYING : {
	result = (float)1.0;
	break;
  }
  case FERTILIZATION_OPERATION : {
	// default value
	break;
  }
  case HAND_HELD_GUN_OPERATED_SPRAYING : 
  case HORIZONTAL_RAIL_OPERATED_SPRAYING : 
  case VERTICAL_RAIL_OPERATED_SPRAYING : {
	// default value
	break;
  }
  case GRINDER_OPERATED_SHOOT_THINNING : {
	// default value
	break;
  }
  case ROTARY_OPERATED_SHOOT_THINNING : {
	result = (float)1. - q_plot;
	break;
  }
  case AIR_ASSISTED_SPRAYING : {
	Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
	//
	// determination / position dans l'iteration de traitements
	//
	Vineyard* pEA = App_GetVineyard((Activity*)pInst);
	Entity* pIterate = (Entity*)pInst->GetFirstContainer(ACTIVITY_ITERATION,
														 FALSE);
	if(pIterate) {  // + JPR 121113
	  int iterationIndex = pIterate->GetIntVarValue(REPLICATION_COUNTER); // 0, 1, etc...
	  int indexMaxForBeginning =        // 1, 2, etc...
		App_GetIntDecisionOption(pEA, OPT_SPRAY_NUMBER_AT_BEGINNING);
	  if(iterationIndex < indexMaxForBeginning)
		result = App_GetFloatDecisionOption(pEA, OPT_SPRAY_PATH_AT_BEGINNING);
	  else {
		//
		// determination / stage vegetatif avant/apres floraison
		//
		bool isFloweringReached =
		  App_IsStageReachedForEarlyGuidingVariety(pEA,
												   "beginningOfFlowering");
		if(isFloweringReached)
		  result = App_GetFloatDecisionOption(pEA, 
											  OPT_SPRAY_PATH_SINCE_FLOWERING);
		else {
		  //
		  // cas residuel : apres 'beginnng' et avant floraison
		  //
		  result = App_GetFloatDecisionOption(pEA, OPT_SPRAY_PATH_REGULAR);
		}
	  }
	}
	else {  // chantier concurrentAntiMildewTreatments (non itéré)
	  // !!! choix arbitraire JPR 121113
	  result = App_GetFloatDecisionOption(pEA, OPT_SPRAY_PATH_REGULAR);
	}
	break;
  }
  default : {
	if(pOt->IsInstanceOf(TILLAGE_OPERATION)) {
	  Entity* pInst = pOt->GetEntityVarValue(INSTRUCTION_CONTAINER);
	  UserClassIdTab actParentIds = pInst->AncestorIds();
	  if(GetPosition(actParentIds, SPRING_TILLAGE_ACTIVITY) >= 0) {
		Entity* pPassedRow =  pPlot->GetElement(0); // par convention
		int management = pPassedRow->GetIntConstValue(SOIL_MANAGEMENT_MODALITY);
//printf("\n\tSPRING_TILLAGE_ACTIVITY pInst : '%s' management = %s", pInst->InstanceName(), App_EnumToChar(management));
		if(management == MIXED_TILLAGE_CW)
		  result = (float)1.0;
		else
		  result = (float)1. - q_plot;
	  }
	  else {
//printf("\n\tNOT SPRING_TILLAGE_ACTIVITY pInst : '%s'", pInst->InstanceName());
		result = (float)1. - q_plot;
		
	  }
	}
	else {
	  printf("\n!!! Tentative d'evaluation de la frequence de passage dans les inter-rangs\n    pour un type d'operation non pris en charge : '%s'.\n", ClassIdToCharTab[operationClassId]);
	exit(0);
	}
  }
  }
//printf("\n'%s'(q = %3.2f)::returnPassedRowsFrequency(%s) returns %3.2f", pPlot->InstanceName(), q_plot, ClassIdToCharTab[operationClassId], result);
  return result;
};

int returnPhytoTreatmentOperationSubclass_Body(EntityMethod* pM)
//-----------------------------------------------------------------
// renvoie une classe d'ot de traitement adaptee au materiel, parcelle, strategie
//-----------------------------------------------------------------
{
  Entity* pInst = pM->DescribedEntity();
  BasicEntity* plotArgument = pM->GetEntityArgValue(PLOT_ARGUMENT);
  Entity* pChantier = pM->GetEntityArgValue(DISTRIBUTED_ACTIVITY_SET_ARGUMENT); 
  // ligne ci-dessus : + JPR 130129, car l'appel de cette méthode est remontée avant 
  // l'ajout de l'activité à son chantier, dans AddNewSituatedPhTr. On ne peut donc plus
  // le trouver avec le GetSuperSet (voir plus loin)
  int sprayerTypeRegular = 
	pM->GetIntArgValue(SPRAYER_TYPE_REGULAR_OPTION_ARGUMENT);
  int sprayerTypeAtBeginning = 
	pM->GetIntArgValue(SPRAYER_TYPE_AT_BEGINNING_OPTION_ARGUMENT);
  int sprayNumberAtBeginning = 
	pM->GetIntArgValue(SPRAY_NUMBER_AT_BEGINNING_OPTION_ARGUMENT);
  int result = -9;

  //
  // !!! y compris pour operation manuelle
  //
  if(pInst->IsInstanceOf(MANUAL_PHYTO_TREATMENT_ACTIVITY)) {
	result = BACK_SPRAYING_OPERATION;
  }
  else {
	int sprayerType = -9;
	
	//Entity* pChantier = pInst->GetSuperSet(); // - JPR 130129
	int typeChantier = App_GetDistributedActivitySetType(pChantier);
	
	switch(typeChantier) {
	case EXTRA_PHYTO : {
	  sprayerType = sprayerTypeRegular;
	  break;
	}
	case ANTI_MILDIOU : {   // optional
	  sprayerType = sprayerTypeRegular;
	  break;
	}
	case REGULAR_PHYTO : {
	  //Entity* pIterate = (Entity*)pInst->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
	  Entity* pIterate = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
	  // ligne ci-dessus : modif JPR 130129 (pInst n'est pas encore ajoutée au chantier
	  // (voir commentaire plus haut)
	  int iterationIndex = pIterate->GetIntVarValue(REPLICATION_COUNTER); // 0, 1, etc...
	  
	  sprayerType = sprayerTypeRegular;
	  if(iterationIndex < sprayNumberAtBeginning) {
		sprayerType = sprayerTypeAtBeginning;
	  }
	}
	}
	  
	switch (sprayerType) {
	case HAND_HELD : {
	  result = HAND_HELD_GUN_OPERATED_SPRAYING;
	  break;
	}
	case VERTICAL : {
	  result = VERTICAL_RAIL_OPERATED_SPRAYING;
	  break;
	}
	case AIR_ASSISTED : {
	  result = AIR_ASSISTED_SPRAYING;
	  break;
	}
	case BACK_CARRIED : { // !!
	  result = BACK_SPRAYING_OPERATION;
	  printf("\n!!! '%s'::returnPhytoTreatmentOperationSubclass sprayerType non compatible avec operation motorisee : 'BACK_CARRIED'\n", pInst->InstanceName());
	  break;
	}
	default : {
	  printf("\n!!! '%s'::returnPhytoTreatmentOperationSubclass sprayerType non gere : '%s'\n", pInst->InstanceName(), App_EnumToChar(sprayerType));
	  exit(0);
	}
	}  // fin switch sprayerType
  }

//printf("\n'%s'::returnPhytoTreatmentOperationSubclass returns '%s'", pInst->InstanceName(), ClassIdToCharTab[result]);
  return result;
};




int returnShootThinningOperationSubclass_Body(EntityMethod* pM)
//-------------------------------------------------------------
// renvoie une classe d'ot de broyage adaptee au materiel, parcelle, strategie
//-------------------------------------------------------------
{
 Entity* pActivity = pM->DescribedEntity();
  Entity* pPlot = pM->GetEntityArgValue(PLOT_ARGUMENT);
  // pPlot donne acces a la strategie, 
  // donc aux options en lien avec le present choix

  int result; // = [ROTARY GRINDER]_OPERATED_SHOOT_THINNING; 

  //if(AlleyWidth < 180) { ...}

  result = GRINDER_OPERATED_SHOOT_THINNING;  // pour test

  return result;
};

BasicEntity* returnSoilManagementGroupOnProfile_Body(EntityMethod* pM)
//--------------------------------------------------------
// renvoie le groupe de gestion en fonction des proprietes de la parcelle
//--------------------------------------------------------
{
  Entity* pPlot = pM->DescribedEntity();
  BasicEntity* result = NULL;  // SoilManagementGroup

  char* soilManagementGroupSet = 
	pM->GetStringArgValue(MANAGEMENT_GROUP_SET_ARGUMENT);
  
  Entity* pSMGroupSet = GetNamedEntity(SOIL_MANAGEMENT_GROUP_SET, 
									soilManagementGroupSet);
  int nbGroups = pSMGroupSet->GetNumberOfElements();

  for (int i=0;i<nbGroups;i++) {
	//
	// la parcelle pPlot releve-t-elle du groupe de gestion i ?
	//
	Entity* pSMGroup_i = (Entity*)pSMGroupSet->GetElement(i);
	RelationalOperator op_i = (RelationalOperator)pSMGroup_i->GetIntConstValue(PLOT_PROFILE_OPERATOR);
	pDescValueSpecTab* pDVSTab_i = pSMGroup_i->GetDescValueSpecTabValue(PLOT_PROFILE);
	
	int nbDVS_i = pDVSTab_i->size();
	Boolean allDVSsatisfied_i = TRUE;
	for (int k=0;k<nbDVS_i;k++)  {
	  //
	  // le critere k du groupe i est-il satisfait pour la parcelle pPlot .
	  //
	  DescValueSpec* pDVS_i_k = pDVSTab_i->get_element(k);
	  Boolean pDVS_i_k_satisfied = pDVS_i_k->IsInDomain(pPlot);
	  if (op_i == IN) {
		if(! pDVS_i_k_satisfied) {
		  allDVSsatisfied_i = FALSE;
if(gMyTraceWarnings) printf("\npour le groupe '%s' (op IN), le critere '%s' n'est pas satisfait par '%s'", pSMGroup_i->InstanceName(), DescIdToCharTab[pDVS_i_k->GetDescId()], pPlot->InstanceName());
		  break;
		}
		else {
if(gMyTraceWarnings) printf("\npour le groupe '%s' (op IN), le critere '%s' est satisfait par '%s'", pSMGroup_i->InstanceName(), DescIdToCharTab[pDVS_i_k->GetDescId()], pPlot->InstanceName());
		}
	  }
	  else {  // NOT_IN
		if(pDVS_i_k_satisfied) {
		  allDVSsatisfied_i = FALSE;
if(gMyTraceWarnings) printf("\npour le groupe '%s' (op NOT_IN), le critere '%s' est satisfait par '%s'", pSMGroup_i->InstanceName(), DescIdToCharTab[pDVS_i_k->GetDescId()], pPlot->InstanceName());
		  break;
		}
		else {
if(gMyTraceWarnings) printf("\npour le groupe '%s' (op NOT_IN), le critere '%s' n'est pas satisfait par '%s'", pSMGroup_i->InstanceName(), DescIdToCharTab[pDVS_i_k->GetDescId()], pPlot->InstanceName());
		}
	  }
	  if(! allDVSsatisfied_i) {
		break;
	  }
	}
	if(allDVSsatisfied_i) {
	  if(gMyTraceWarnings) printf("\n\t==>le groupe '%s' (op IN) contient la parcelle '%s'", pSMGroup_i->InstanceName(), pPlot->InstanceName());
	  result = pSMGroup_i;
	  break;
	}
  }
  return result;  // SoilManagementGroup*
};

int returnTillageOperationSubclass_Body(EntityMethod* pM)
//-------------------------------------------------------
// renvoie une classe d'ot de labour adaptee au materiel, parcelle, strategie
//-------------------------------------------------------
{
  Entity* pInst = pM->DescribedEntity();
//printf("\nentree '%s'::returnTillageOperationSubclass ", pInst->InstanceName());
  Entity* pPlot = pM->GetEntityArgValue(PLOT_ARGUMENT);
  // pPlot donne acces a la strategie, 
  // donc aux options en lien avec le present choix

  int season = pM->GetIntArgValue(SEASON_ARGUMENT);

  int result; // = [ROTARY SPRING_TINE]_OPERATED_TILLAGE; 

  pEntityTab* rotTab = GetEntityList(ROTARY_CULTIVATOR);
  pEntityTab* stTab = GetEntityList(SPRING_TINE_CULTIVATOR);
//rotTab->display_names();
//stTab->display_names();

  //if(season == AUTUMN) { ...}

  result = SPRING_TINE_OPERATED_TILLAGE;  // pour test
//printf("\n'%s'::returnTillageOperationSubclass returns %s", pInst->InstanceName(), ClassIdToCharTab[result]);
  return result;
};

pEntityTab* selectNewPlotsToAutumnTill_Body(EntityMethod* pM) {
//--------------------------------------------------------
// renvoie un tableau de parcelles a labourer dans le chantier d'automne
//-------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToAutumnTill_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);

  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : sans objet
  //   cas MOT : alleyWidth * _tillageOperation_speed_ /12 / passedRowFrequency
  //
  //UserClassId otClassId = TILLAGE_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)-9; 
  float motorizedNominalSpeed = gRealParam_tillageOperation_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											"MOTORIZED",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nalreadyChosenDuration = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	//
	// les parcelles etroites sont eliminees dans SetRowSoilManagement_XX
	//
	if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
	   &&
	   (GetPosition(*pInCoursePlots, pPlot_i) < 0)
	   &&
	   App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_AUTUMN_TILLED), (float)0.)) {
	  result->push_back(pPlot_i);
	  float duration_i = App_GetExpectedDuration(pPlot_i, 
												 FALSE, // isPlotMotorizable
												 TILLAGE_OPERATION,
												 serParOption,
												 "MOTORIZED",
												 passedRowFrequency,
												 manualNominalSpeed,
												 motorizedNominalSpeed);
		alreadyChosenDuration+= duration_i;
		if(duration_i > (float)1.0) nbPlotMax--;
//printf("\tduree des en-cours = %f", alreadyChosenDuration);
	}
  }
//printf("\nt = %d selectPlotsToAutumnTill returns :", pCurrentSim->Clock());result->display_names();

  return result;
};

pEntityTab* selectNewPlotsToClip_Body(EntityMethod* pM) {
//----------------------------------------------------------
// renvoie un tableau de parcelles a ecimer
//----------------------------------------------------------
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToClip_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : sans objet
  //   cas MOT : alleyWidth * _clippingOperation_speed_ /12 / passedRowFrequency
  //
  //UserClassId otClassId = CLIPPING_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)-9; 
  float motorizedNominalSpeed = gRealParam_clippingOperation_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											"MOTORIZED",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nalreadyChosenDuration des InCourse = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail; 
  if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
//printf("\nplot '%s'", pPlot_i->InstanceName());
	//
	// on elimine les parcelles non motorisables (+ JPR 130110)
	//
	bool isPlotMotorizable = pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\n%s isPlotMotorizable = %d pcTrellised : %f ", pPlot_i->InstanceName(), isPlotMotorizable, pPlot_i->GetFloatVarValue(PERCENT_TRELLISED));
	if(isPlotMotorizable) {
	  //
	  // on elimine les parcelles non completement palissees
	  //
	  if(App_FloatNEQ(pPlot_i->GetFloatVarValue(PERCENT_TRELLISED), (float)1.)
		 &&
		 App_FloatNEQ(pPlot_i->GetFloatVarValue(PERCENT_TRELLISED), (float)-1.))
		continue;
	  
	  if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		 &&
		 (GetPosition(*pInCoursePlots, pPlot_i) < 0)
		 &&
		 App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_CLIPPED), (float)0.)) {
		result->push_back(pPlot_i);
		float duration_i = App_GetExpectedDuration(pPlot_i, 
												   TRUE,  // isPlotMotorizable
												   -9, // otClassId
												   serParOption,
												   "MOTORIZED",
												   passedRowFrequency,
												   manualNominalSpeed,
												   motorizedNominalSpeed);
		alreadyChosenDuration+= duration_i;
		if(duration_i > (float)1.0) nbPlotMax--;
//printf("\talreadyChosenDuration -> %f", alreadyChosenDuration);
	  }
	}
  }
//printf("\nt = %d selectPlotsToClip returns :", pCurrentSim->Clock());result->display_names();

  return result;
};

pEntityTab* selectNewPlotsToDebranch_Body(EntityMethod* pM) {
//---------------------------------
// renvoie un tableau de parcelles a epamprer
//-------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToDebranch_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* manualMotorized 
	= pM->GetStringArgValue(MANUAL_MOTORIZED_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : alleyWidth * plantSpacing * _manualDebranchingOperation_speed_
  //   cas MOT : alleyWidth * _chemicalDebrancherOperatedSpraying_speed_ /12 / passedRowFrequency
  //
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)gIntParam_manualDebranchingOperation_speed_; // plus faible valeur vs. "backSprayingOperation" "speed" 
  float motorizedNominalSpeed = gRealParam_chemicalDebrancherOperatedSpraying_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											manualMotorized,
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f\n", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(! strcmp(manualMotorized, "MOTORIZED")) {
	if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
	if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;
  }
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f nbPlotMax = %d\n", nbRsc, dureePlageTravail, DTotW, nbPlotMax);

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
	   &&
	   (GetPosition(*pInCoursePlots, pPlot_i) < 0)
	   &&
	   App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_DEBRANCHED), (float)0.)) {
	  
	  pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							OPERATION_CLASS_ARGUMENT,
							MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable =
		pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\n'%s' isPlotMotorizable/MOTORIZED_SPRAYING = %d", pPlot_i->InstanceName(), isPlotMotorizable);
	  //
	  // le App_AssignTurnedOffActivitiesOnPlots a mis a -1 le PERCENT_DEBRANCHED
	  // des parcelles exclues pour raison de shootIntensity.
	  //
	  int modality = 
		App_GetIntDecisionOption(pVineyard, OPT_DEBRANCHING_MODALITY);
	  bool isPureChem = (modality == PART_CHEM) || (modality == WHOLE_CHEM);
	  bool isPureMeca = (modality == PART_MECA) || (modality == WHOLE_MECA);
	  bool isMixed = (modality == PART_MECA_CHEM) || (modality == WHOLE_MECA_CHEM);

	  if(isPureChem) {
		//
		// elimination de parcelles sur le critere motorisable ou non
		// - seulement effectif dans le cas "SER" (en "PAR, c'est dans 
		//   AddNewSituated qu'on regardera le critere pour decider du
		//   type d'operation)
		// - si "MANUAL", on elimine les parcelles motorisables
		//   si "MOTORIZED, on elimine les parcelles non motorisables
		//
		if(! strcmp(serParOption, "SER")) {
		  if(! strcmp(manualMotorized, "MANUAL")) {
			if(isPlotMotorizable)
			  continue;
		  }
		  else if(! strcmp(manualMotorized, "MOTORIZED")) { 
			if(! isPlotMotorizable)
			  continue;
		  }
		}
	  }
	  else if(isPureMeca) {
		//
		// elimination de parcelles dans le cas "SER" (id. ci-dessus)
		// - si "MANUAL", on elimine rien
		//   si "MOTORIZED, on elimine toutes les parcelles
		//
		if(! strcmp(serParOption, "SER")) {
		  if(! strcmp(manualMotorized, "MOTORIZED")) { 
			continue;
		  }
		}
	  }
	  else if(isMixed) {
		Entity* pVariety = pPlot_i->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
		int shootIntensity = pVariety->GetIntConstValue(SHOOT_INTENSITY);
		if(! strcmp(manualMotorized, "MANUAL")) {
		  //
		  // elimination de parcelles avec shootIntensity=2 et motorisables
		  //
		  if(isPlotMotorizable && (shootIntensity == 2))
			continue;
		}
		else {                         // "MOTORIZED"
		  //
		  // elimination de parcelles avec shootIntensity<2 ou non motorisables
		  //
		  if((! isPlotMotorizable) || (shootIntensity < 2))
			continue;
		}		
	  }
	  result->push_back(pPlot_i);
	  float duration_i = App_GetExpectedDuration(pPlot_i, 
												 isPlotMotorizable,  
												 -9, // otClaaaId
												 serParOption,
												 manualMotorized, // "MOTORIZED",
												 passedRowFrequency,
												 manualNominalSpeed,
												 motorizedNominalSpeed);
		alreadyChosenDuration+= duration_i;
		if(! strcmp(manualMotorized, "MOTORIZED")) {
		  if(duration_i > (float)1.0) nbPlotMax--;
		}
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	}
  }  // fin boucle / parcelles

//printf("\nt = %d selectPlotsToDebranch returns :", pCurrentSim->Clock());result->display_names();
  return result;
};

pEntityTab* selectNewPlotsToFertilize_Body(EntityMethod* pM) {
//----------------------------------------------------------
// renvoie un tableau de parcelles a fertiliser
//----------------------------------------------------------
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//----------------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToFertilize_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : sans objet
  //   cas MOT : alleyWidth * _tillageOperation_speed_ /12 / passedRowFrequency
  //
  //UserClassId otClassId = FERTILIZATION_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)-9; 
  float motorizedNominalSpeed = gRealParam_fertilizationOperation_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots,  
											pChantier,
											serParOption,
											"MOTORIZED",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	bool isPlotMotorizable = pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	// !!! ci-dessus : sans spécifier OPERATION_CLASS_ARGUMENT ???
	if(isPlotMotorizable) {
	  //
	  // on elimine les parcelles taillees ET . partiellement broyees
	  //                                      . OU pas broyees mais a broyer
	  //
	  if(App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_PRUNED), (float)1.)
		 &&
		 App_FloatGT(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED), (float)-1.)
		 &&
		 App_FloatLT(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED), (float)1.))
		continue;
	  
	  if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		 &&
		 (GetPosition(*pInCoursePlots, pPlot_i) < 0)
		 &&
		 App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_FERTILIZED), (float)0.)) {
		result->push_back(pPlot_i);
		float duration_i = App_GetExpectedDuration(pPlot_i, 
												   TRUE, // isPlotMotorizable
												   -9, // otClassId
												   serParOption,
												   "MOTORIZED",
												   passedRowFrequency,
												   manualNominalSpeed,
												   motorizedNominalSpeed);
		  alreadyChosenDuration+= duration_i;
		  if(duration_i > (float)1.0) nbPlotMax--;
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	  }
	}
	else {
	  //
	  // on elimine les parcelles non motorisables
	  //
	  pPlot_i->SetFloatVarValue(PERCENT_FERTILIZED, (float)-1.);
	}
  }
//printf("\nt = %d selectPlotsToFertilize returns :", pCurrentSim->Clock());result->display_names();
  return result;
};

pEntityTab* selectNewPlotsToInitSpringTill_Body(EntityMethod* pM) {
//---------------------------------------------------------------
// renvoie un tableau de parcelles a labourer dans le chantier de reprise
//-------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToInitSpringTill_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();ay_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : sans objet
  //   cas MOT : alleyWidth * _tillageOperation_speed_ /12 / passedRowFrequency
  //
  //UserClassId otClassId = TILLAGE_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)-9; 
  float motorizedNominalSpeed = gRealParam_tillageOperation_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											"MOTORIZED",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	//
	// les parcelles etroites sont eliminees dans SetRowSoilManagement_XX
	//
	// on elimine les parcelles non completement taillees
	//         ET les parcelles (taillees) a broyer ET . partiellement broyees
	//                                                 . OU pas broyees
	//
	if(App_FloatLT(pPlot_i->GetFloatVarValue(PERCENT_PRUNED), (float)1.)
	   // on supoose que PERCENT_PRUNED n'est jamais -1.
	   ||
	   (App_FloatGT(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED), (float)-1.)
		&&
		App_FloatLT(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED), (float)1.)))
	  continue;
	
	if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
	   &&
	   (GetPosition(*pInCoursePlots, pPlot_i) < 0)
	   &&
	   App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_INIT_SPRING_TILLED), (float)0.)) {
	  result->push_back(pPlot_i);
	  float duration_i = App_GetExpectedDuration(pPlot_i,
												 FALSE, // isPlotMotorizable
												 TILLAGE_OPERATION,
												 serParOption,
												 "MOTORIZED",
												 passedRowFrequency,
												 manualNominalSpeed,
												 motorizedNominalSpeed);
	  alreadyChosenDuration+= duration_i;
	  if(duration_i > (float)1.0) nbPlotMax--;
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	}
  }
//printf("\nt = %d selectPlotsToInitSpringTill returns :", pCurrentSim->Clock());result->display_names();
  return result;
};

pEntityTab* selectNewPlotsToPhytoProtect_Body(EntityMethod* pM)
//-------------------------------------------------------------
// renvoie un tableau de parcelles a traiter
//------------------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToPhytoProtect_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard = pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  char* manualMotorized 
	= pM->GetStringArgValue(MANUAL_MOTORIZED_ARGUMENT);
//printf("\npChantier : '%s' manualMotorized = '%s'", pChantier->InstanceName(), manualMotorized);
  
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();
//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();
  //
  // on va établir une liste de parcelles possiblement traitées dans la plage 
  // de travail, où DTotW heures de travail sont disponibles.
  // cad telle que la durée totale des traitements soit égale ou sup. à DTotW
  // --> dans la boucle sur les parcelles, on s'arretera qd on aura selectionné 
  // des parcelles dont la somme des durée d'opération aura dépassé DTotW
  //
  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : alleyWidth * plantSpacing * _backSprayingOperation_speed_
  //   cas MOT : alleyWidth * _verticalRailOperatedSpraying_speed_ /12 / passedRowFrequency
  //
  //UserClassId otClassId = MOTORIZED_SPRAYING_OPERATION;
  float passedRowFrequency = (float)0.5;  // approximation
  float manualNominalSpeed = (float)gIntParam_backSprayingOperation_speed_; 
  float motorizedNominalSpeed = gRealParam_verticalRailOperatedSpraying_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier, 
											serParOption,
											manualMotorized, //"" modif JPR 130127
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(! strcmp(manualMotorized, "MOTORIZED")) {
	if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
	if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;
  }

  pEntityTab* result = new pEntityTab();

  int typeChantier = App_GetDistributedActivitySetType(pChantier);
  switch(typeChantier) {
  case EXTRA_PHYTO : {
//printf("\nEXTRA_PHYTO");
	//
	// on selectionne toutes (et seulement) les parcelles en carignan
	//
	for(int i=0;i<nbPlots;i++) {
//printf("\ni = %d alreadyChosen = %f DTotW = %f result->size()=%d", i, alreadyChosenDuration, DTotW, result->size());
	  if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	  }
	  else {
		if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		  break;
	  }

	  Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	  // JPR 130228 test 'carignan' remonté ici
	  Entity* pVariety = pPlot_i->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
	  if(! strcmp(pVariety->InstanceName(), "carignan")) {
		pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
								OPERATION_CLASS_ARGUMENT,
								MOTORIZED_SPRAYING_OPERATION);
		bool isPlotMotorizable =
		  pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\n%s isPlotMotorizable = %d", pPlot_i->InstanceName(), isPlotMotorizable);
		//
		// pour chantier "série", elimination de parcelles sur le critere motorisable
		// ou non (voir note dans 'REGULAR') // + JPR 120405
		//
		if(! strcmp(serParOption, "SER")) {
//printf("\n%s isPlotMotorizable = %d", pPlot_i->InstanceName(), isPlotMotorizable);
		  if(! strcmp(manualMotorized, "MANUAL")) {
			if(isPlotMotorizable) {
			  pPlot_i->SetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED, (float)-1.0);  // JPR 130126
			  continue;
			}
		  }
		  else if(! strcmp(manualMotorized, "MOTORIZED")) { 
			if(! isPlotMotorizable) {
			  pPlot_i->SetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED, (float)-1.0);  // JPR 130126
			  continue;
			}
		  }
		}
		if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		   &&
		   (GetPosition(*pInCoursePlots, pPlot_i) < 0)) {
		  //printf("\t carignan");
		  result->push_back(pPlot_i);
		  
		  float duration_i = App_GetExpectedDuration(pPlot_i, 
													 isPlotMotorizable, 
													 -9, // otClaaaId
													 serParOption,
													 manualMotorized,
													 passedRowFrequency,
													 manualNominalSpeed,
													 motorizedNominalSpeed);
		  alreadyChosenDuration+= duration_i;
		  if(! strcmp(manualMotorized, "MOTORIZED")) {
			if(duration_i > (float)1.0) nbPlotMax--;
		  }
		  //printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
		}
	  } // nouveau test carignan
	}
	break;
  }
  case ANTI_MILDIOU : {
	//printf("\nANTI_MILDIOU");
	//
	// préambule : (variante 130306)
	// en SER : les Motorisables d'abord, les NON Motor. ensuite
	// en PAR : les NON Motor. d'abord, les Motorisables ensuite 
	//
	for(int i=0;i<nbPlots;i++) {
	  Plot* pPlot_i = (Plot*)pPlotTab.get_element(i);
	  pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							  OPERATION_CLASS_ARGUMENT,
							  MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable =
		pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	  if(isPlotMotorizable)
		pPlot_i->SetIntVarValue(ANONYMOUS_INT_ATTRIBUTE, 0);
	  else
		pPlot_i->SetIntVarValue(ANONYMOUS_INT_ATTRIBUTE, 1);
	}
	if(! strcmp(serParOption, "SER"))
	  SortUp((pDescriptedEntityTab*)&pPlotTab, ANONYMOUS_INT_ATTRIBUTE);
	else
	  SortDown((pDescriptedEntityTab*)&pPlotTab, ANONYMOUS_INT_ATTRIBUTE);

	for(int i=0;i<nbPlots;i++) {
//printf("\ni = %d alreadyChosen = %f DTotW = %f result->size()=%d nbRsc=%d", i, alreadyChosenDuration, DTotW, result->size(), nbRsc);
	  if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	  }
	  else {
		if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		  break;
	  }

	  Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	  pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							  OPERATION_CLASS_ARGUMENT,
							  MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable =
		pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	  //
	  // pour chantier "série", elimination de parcelles sur le critere motorisable
	  // ou non (voir note dans 'REGULAR') // + JPR 120405
	  //
	  if(! strcmp(serParOption, "SER")) {
//printf("\n%s isPlotMotorizable = %d", pPlot_i->InstanceName(), isPlotMotorizable);
		if(! strcmp(manualMotorized, "MANUAL")) {
		  if(isPlotMotorizable) {
			pPlot_i->SetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED, (float)-1.0);  // JPR 130225
			continue;
		  }
		}
		else if(! strcmp(manualMotorized, "MOTORIZED")) { 
		  if(! isPlotMotorizable) {
			pPlot_i->SetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED, (float)-1.0);  // JPR 130225
			continue;
		  }
		}
	  }
	  if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		 &&
		 (GetPosition(*pInCoursePlots, pPlot_i) < 0)) {
		result->push_back(pPlot_i);
//printf("\n + %s", pPlot_i->InstanceName());printf(" isPlotMotorizable = %d", isPlotMotorizable);
		
		float duration_i = App_GetExpectedDuration(pPlot_i, 
												   isPlotMotorizable, 
												   -9, // otClassId
												   serParOption,
												   manualMotorized,
												   passedRowFrequency,
												   manualNominalSpeed,
												   motorizedNominalSpeed);
		alreadyChosenDuration+= duration_i;
		if(! strcmp(manualMotorized, "MOTORIZED")) {
		  if(duration_i > (float)1.0) nbPlotMax--;
		}
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	  }
	}
	break;
  }
  default : {                              // REGULAR
//printf("\nREGULAR");
	//
	// recuperation de la sequence de vagues de varietes
	//
	Entity* pConduite = 
	  pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	Boolean flag_mildiou = 
	  pConduite->GetIntConstValue(FLAG_MILDEW);
	int powderyMildewMngt =
	  pConduite->GetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE);
	int downyMildewMngt = 
	  pConduite->GetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE);
	Entity* pVarGroupSet = App_GetVarietyGroupSet(powderyMildewMngt);
	//
	// recuperation du numero d'ordre du chantier dans l'iteration
	//
	Entity* pIteration = 
	  (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
	pEntityTab* rankedWaveList;
	int rank =  pIteration->GetIntVarValue(REPLICATION_COUNTER);		
	pVarGroupSet->SetEntityArgValue(GET_RANKED_WAVE_LIST, VINEYARD_ARGUMENT, 
									pVineyard);
	pVarGroupSet->SetIntArgValue(GET_RANKED_WAVE_LIST, STAGE_INDEX_ARGUMENT, 
								 rank);
	Entity* pComposedProgram = pIteration->GetSuperSet();  // par construction
	Boolean antiMildiouJustDone = 
	  pComposedProgram->GetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE);
	//
	// ssi strategie R0, perturbation de la selection en f� du mildiou
	//
	if((downyMildewMngt == R0)
	   ||
	   (downyMildewMngt == RFLO)) {
	  if(flag_mildiou) {  // f(foyers primaires, ...)
		pVarGroupSet->SetIntArgValue(GET_RANKED_WAVE_LIST, 
									 STAGE_INDEX_ARGUMENT, 
									 -9);// on renvoie tout
	  }
	}
	//
	// etablissement de la liste des cepages a traiter, en f� du rang
	//
	rankedWaveList	= 
	  pVarGroupSet->ExecEntityTabMethod(GET_RANKED_WAVE_LIST);
	//
	// examen des parcelles de l'EA
	//
	for(int i=0;i<nbPlots;i++) {
	  if(! strcmp(serParOption, "SER")) {   // modif 130208
		if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		  break;
	  }
	  else {
		if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		  break;
	  }

	  Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	  if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		 &&
		 (GetPosition(*pInCoursePlots, pPlot_i) < 0)) {
		pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
								OPERATION_CLASS_ARGUMENT,
								MOTORIZED_SPRAYING_OPERATION);
		bool isPlotMotorizable =
		  pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
		//
		// elimination de parcelles sur le critere motorisable ou non
		// - seulement utile dans le cas "SER" (en "PAR, c'est dans 
		//   AddNewSituated qu'on regardera le crit�re pour d�cider du
		//   type d'operation)
		// - si "MANUAL", on elimine les parcelles motorisables
		//   si "MOTORIZED, on elimine les parcelles non motorisables
		//
		if(! strcmp(serParOption, "SER")) {
		  if(! strcmp(manualMotorized, "MANUAL")) {
			if(isPlotMotorizable)
			  continue;
		  }
		  else if(! strcmp(manualMotorized, "MOTORIZED")) { 
			if(! isPlotMotorizable)
			  continue;
		  }
		}
		// le cas des parcelles 'pas a traiter' est traite dans le switch
		//
		// la variete figure-t-elle dans la vague de celles a traiter ?
		//
		Entity* pVariety_i = 
		  pPlot_i->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
		if(GetPosition(*rankedWaveList, pVariety_i) >=0) {
		  result->push_back(pPlot_i);
//printf("\n + %s", pPlot_i->InstanceName());printf(" isPlotMotorizable = %d", isPlotMotorizable);
		  float duration_i = App_GetExpectedDuration(pPlot_i, 
													 isPlotMotorizable, 
													 -9, // otClassId
													 serParOption,
													 manualMotorized,
													 passedRowFrequency,
													 manualNominalSpeed,
													 motorizedNominalSpeed);
//printf("\tduration_i = %f", duration_i);
		  alreadyChosenDuration+= duration_i;
		  if(! strcmp(manualMotorized, "MOTORIZED")) {
			if(duration_i > (float)1.0) nbPlotMax--;
		  }
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
		}
		else {
		  pPlot_i->SetFloatVarValue(PERCENT_REGULAR_PHYTO_TREATED, (float)-1.0);  // JPR 130126
		}
	  }
	}
	delete rankedWaveList;
  }  // fin REGULAR
  } // fin switch
  
//printf("\nt = %d selectPlotsToPhytoProtect case %d returns :", pCurrentSim->Clock(), typeChantier);result->display_names();
//printf("\n");if(pCurrentSim->Clock() > 5000) {printf("\n"); exit(0);}
  return result;
};

pEntityTab* selectNewPlotsToPlant_Body(EntityMethod* pM)
//------------------------------------------------------
// renvoie un tableau de parcelles a planter
//------------------------------------------------------
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToPlant_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : alleyWidth * plantSpacing * _plantationOperation_speed_
  //   cas MOT : sans objet
  //
  //UserClassId otClassId = PLANTATION_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = gRealParam_plantationOperation_overallSpeed_; 
  float motorizedNominalSpeed = (float)-9; 
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											"MANUAL",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  // if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  // if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
	  if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}
	
	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
	   &&
	   (GetPosition(*pInCoursePlots, pPlot_i) < 0)
	   &&
	   App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_PLANTED), (float)0.)) {
	  result->push_back(pPlot_i);
	  float duration_i = App_GetExpectedDuration(pPlot_i, 
												 FALSE,  // isPlotMotorizable
												 PLANTATION_OPERATION,
												 serParOption,
												 "MANUAL",
												 passedRowFrequency,
												 manualNominalSpeed,
												 motorizedNominalSpeed);
	  alreadyChosenDuration+= duration_i;
	  // if(duration_i > (float)1.0) nbPlotMax--;
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	}
  }
//printf("\nt = %d selectPlotsToPlant returns :", pCurrentSim->Clock());result->display_names();
  return result;
};

pEntityTab* selectNewPlotsToPrune_Body(EntityMethod* pM) {
//--------------------------------------------------
// renvoie un tableau de parcelles a tailler
//-------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToPrune_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard = pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT); // + JPR 130121
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : alleyWidth * plantSpacing * _pruningOperation_speed_
  //   cas MOT : sans objet
  //
  //UserClassId otClassId = PRUNING_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)gIntParam_guyotPruning_speedNotPrePruned_;
  float motorizedNominalSpeed = (float)-9;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											"MANUAL",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree maxi des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  //if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  //if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f nbPlotMax = %d", nbRsc, dureePlageTravail, DTotW, nbPlotMax);

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
	  if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
	   &&
	   (GetPosition(*pInCoursePlots, pPlot_i) < 0)
	   &&
	   App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_PRUNED), (float)0.)) {
		result->push_back(pPlot_i);
		float duration_i = App_GetExpectedDuration(pPlot_i, 
												   FALSE,   // isPlotMotorizable
												   PRUNING_OPERATION,  
												   serParOption,
												   "MANUAL",
												   passedRowFrequency,
												   manualNominalSpeed,
												   motorizedNominalSpeed);
		  alreadyChosenDuration+= duration_i;
		  // if(duration_i > (float)1.0) nbPlotMax--;
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	}
  }
//printf("\nt = %d selectPlotsToPrune returns :", pCurrentSim->Clock());result->display_names();
  return result;
};

pEntityTab* selectNewPlotsToShootThin_Body(EntityMethod* pM) {
//--------------------------------------------------------
// renvoie un tableau de parcelles a broyer
//--------------------------------------------------  
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToShootThin_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : sans objet
  //   cas MOT : alleyWidth * _verticalRailOperatedSpraying_speed_ /12 / passedRowFrequency
  //
  //UserClassId otClassId = SHOOT_THINNING_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation  // 130104
  float manualNominalSpeed = (float)-9.; 
  float motorizedNominalSpeed = gRealParam_rotaryOperatedShootThinning_speed_; // le plus lent
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots,
											pChantier,
											serParOption,
											"MOTORIZED",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
	  if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	//
	// on elimine les parcelles non motorisables
	//
	bool isPlotMotorizable = pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\n%s isPlotMotorizable = %d", pPlot_i->InstanceName(), isPlotMotorizable);
	if(isPlotMotorizable) {
	  //
	  // on elimine les parcelles non completement taillees
	  //
	  if(App_FloatLT(pPlot_i->GetFloatVarValue(PERCENT_PRUNED), (float)1.))
		// on suppose que PERCENT_PRUNED n'est jamais -1
		continue;
	  
	  if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		 &&
		 (GetPosition(*pInCoursePlots, pPlot_i) < 0)
		 &&
		 App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED),(float)0.)){
		result->push_back(pPlot_i);
		float duration_i = App_GetExpectedDuration(pPlot_i, 
												   isPlotMotorizable, 
												   -9, // otClassId
												   serParOption,
												   "MOTORIZED",
												   passedRowFrequency,
												   manualNominalSpeed,
												   motorizedNominalSpeed);
		  alreadyChosenDuration+= duration_i;
		  if(duration_i > (float)1.0) nbPlotMax--;
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	  }
	}
	else {
	  pPlot_i->SetFloatVarValue(PERCENT_SHOOT_THINNED, (float)-1.);
	}
  }
//printf("\nt = %d selectPlotsToShootThin returns %d plots : ", pCurrentSim->Clock(), result->size());result->display_names();
  return result;
};

pEntityTab* selectNewPlotsToSpringTill_Body(EntityMethod* pM) {
//--------------------------------------------------------
// renvoie un tableau de parcelles a labourer dans le chantier de printemps
//--------------------------------------------------  
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToSpringTill_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : sans objet
  //   cas MOT : alleyWidth * _tillageOperation_speed_ /12 / passedRowFrequency
  //
  //UserClassId otClassId = TILLAGE_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)-9; 
  float motorizedNominalSpeed = gRealParam_tillageOperation_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											"MOTORIZED",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  //
  // passent d'abord les parcelles dont le dernier labour est le plus ancien
  //
//printf("\nt = %d pPlotTab :", pCurrentSim->Clock());pPlotTab.display_names();
  pDescriptedEntityTab* pDETab = EntityTabToDescriptedEntityTab(pPlotTab);
  SortUp(pDETab, LAST_TILLAGE_OPERATION_CLOCK);
//printf("\nt = %d   pDETab :", pCurrentSim->Clock());pDETab->display_names();
  int nbPlots = pDETab->size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
	  if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pDETab->get_element(i);
	//
	// les parcelles etroites sont eliminees dans SetRowSoilManagement_XX
	//
	// elimination des parcelles labourees il y a moins de 'X=param' jours
	//
	int lastTillageClock = pPlot_i->GetIntConstValue(LAST_TILLAGE_OPERATION_CLOCK);
	int now = pCurrentSim->Clock();
	int nbDaysThreshold = gIntParam_virtualManager_nbDaysThresholdForTillageOpening_;
	//
	// modif JPR 120925 : date min ramenée au debut du jour
	//
	int thisTillageMinClock = lastTillageClock + nbDaysThreshold*24;// modif JPR 120907
//printf("\nlastTillageClock = %d thisTillageMinClock = %d transforme en ", lastTillageClock, thisTillageMinClock);
	tm* tm_tmp = ClockValueToTm(thisTillageMinClock);
	tm_tmp->tm_hour = gIntParam_morningUpdateSituation_specialHour_;
	mktime(tm_tmp);
	thisTillageMinClock = (int)StructTmToClockValue(tm_tmp);
//printf(" %d", thisTillageMinClock);
	if(now >= thisTillageMinClock) {

	  if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		 &&
		 (GetPosition(*pInCoursePlots, pPlot_i) < 0)
		 &&
		 App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_SPRING_TILLED), (float)0.)) {
		result->push_back(pPlot_i);
		float duration_i = App_GetExpectedDuration(pPlot_i, 
												   FALSE, // isPlotMotorizable
												   TILLAGE_OPERATION, 
												   serParOption,
												   "MOTORIZED",
												   passedRowFrequency,
												   manualNominalSpeed,
												   motorizedNominalSpeed);
		alreadyChosenDuration+= duration_i;
		if(duration_i > (float)1.0) nbPlotMax--;
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	  }
	}
	delete tm_tmp;  // + JPR 130114 -> MLK
  }
  delete pDETab;
//printf("\nt = %d selectPlotsToSpringTill returns :", pCurrentSim->Clock());result->display_names();
  return result;
};

pEntityTab* selectNewPlotsToSpringWeed_Body(EntityMethod* pM) {
//-----------------------------------------------------------
// renvoie un tableau de parcelles a desherber au printemps
//----------------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToSpringWeed_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* manualMotorized 
	= pM->GetStringArgValue(MANUAL_MOTORIZED_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : alleyWidth * plantSpacing * backSprayingOperation_speed_
  //   cas MOT : alleyWidth * _horizontalRailOperatedSpraying_speed_ /12 / passedRowFrequency!!!!!!!!!!!!!!!!
  //
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)gIntParam_backSprayingOperation_speed_;
  float motorizedNominalSpeed = gRealParam_horizontalRailOperatedSpraying_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											manualMotorized,
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail; // + JPR 130131;
  if(! strcmp(manualMotorized, "MOTORIZED")) { 
	if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
	if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;
  }

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
	  if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
	   &&
	   (GetPosition(*pInCoursePlots, pPlot_i) < 0)
	   &&
	   App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_SPRING_WEEDED), (float)0.)) {
	  pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							  OPERATION_CLASS_ARGUMENT,
							  MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable =
		pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable = %d", isPlotMotorizable);
	  result->push_back(pPlot_i);
	  float duration_i = App_GetExpectedDuration(pPlot_i, 
												 isPlotMotorizable,
												 -9, // otClassId
												 serParOption,
												 manualMotorized,
												 passedRowFrequency,
												 manualNominalSpeed,
												 motorizedNominalSpeed);
	  alreadyChosenDuration+= duration_i;
	  if(! strcmp(manualMotorized, "MOTORIZED")) { 
		if(duration_i > (float)1.0) nbPlotMax--;
	  }
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	}
  }
//printf("\nt = %d selectPlotsToSpringWeed returns :", pCurrentSim->Clock());result->display_names();
  return result;
};

pEntityTab* selectNewPlotsToTrellis_Body(EntityMethod* pM) {
//--------------------------------------------------
// renvoie un tableau de parcelles a relever
//-------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToTrellis_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard = pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : alleyWidth * plantSpacing * _trellisingOperation_speed_
  //   cas MOT : asans objet
  //
  //UserClassId otClassId = TRELLISING_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)gIntParam_trellisingOperation_speed_;
  float motorizedNominalSpeed = (float)-9; 
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											"MANUAL",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  //if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  //if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
	  if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	//
	// on elimine les parcelles taillees en gobelet
	//
	char* modeTaille = pPlot_i->GetStringConstValue(PRUNING_MODE);
	if(modeTaille != "GOB") {
	  if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
		 &&
		 (GetPosition(*pInCoursePlots, pPlot_i) < 0)
		 &&
		 App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_TRELLISED), (float)0.)) {
		result->push_back(pPlot_i);
		float duration_i = App_GetExpectedDuration(pPlot_i, 
												   FALSE, // isPlotMotorizable
												   TRELLISING_OPERATION, 
												   serParOption,
												   "MANUAL",
												   passedRowFrequency,
												   manualNominalSpeed,
												   motorizedNominalSpeed);
		alreadyChosenDuration+= duration_i;
		//if(duration_i > (float)1.0) nbPlotMax--;
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	  }
	}
  }
//printf("\nt = %d selectPlotsToTrellis returns :", pCurrentSim->Clock());result->display_names();
  return result;
};

pEntityTab* selectNewPlotsToWeed_Body(EntityMethod* pM) {
//---------------------------------
// renvoie un tableau de parcelles a desherber
//-------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToWeed_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  char* manualMotorized
	= pM->GetStringArgValue(MANUAL_MOTORIZED_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : alleyWidth * plantSpacing * backSprayingOperation_speed_
  //   cas MOT : alleyWidth * __horizontalRailOperatedSprayingspeed_ /12 / passedRowFrequency!!!!!!!!!!!!!!!!
  //
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)gIntParam_backSprayingOperation_speed_;
  float motorizedNominalSpeed = gRealParam_horizontalRailOperatedSpraying_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											manualMotorized,
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(! strcmp(manualMotorized, "MOTORIZED")) { 
	if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
	if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;
  }

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
	  if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	//
	// on elimine les parcelles taillees ET . partiellement broyees
	//                                      . OU pas broyees mais a broyer
	//
	if(App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_PRUNED), (float)1.)
	   &&
	   App_FloatGT(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED), (float)-1.)
	   &&
	   App_FloatLT(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED), (float)1.))
	  continue;
	//
	// elimination de parcelles sur le critere motorisable ou non
	// - seulement utile dans le cas "SER" (en "PAR, c'est dans 
	//   AddNewSituated qu'on regardera le critere pour decider du
	//   type d'operation)
	// - si "MANUAL", on elimine les parcelles motorisables
	//   si "MOTORIZED, on elimine les parcelles non motorisables
	//
	pPlot_i->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							OPERATION_CLASS_ARGUMENT,
							MOTORIZED_SPRAYING_OPERATION);
	bool isPlotMotorizable =
	  pPlot_i->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
//printf("\nisPlotMotorizable = %d", isPlotMotorizable);
	if(! strcmp(serParOption, "SER")) {
	  if(! strcmp(manualMotorized, "MANUAL")) {
		if(isPlotMotorizable)
		  continue;
	  }
	  else if(! strcmp(manualMotorized, "MOTORIZED")) { 
		if(! isPlotMotorizable)
		  continue;
	  }
	}
	if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
	   &&
	   (GetPosition(*pInCoursePlots, pPlot_i) < 0)
	   &&
	   App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_WEEDED), (float)0.)) {
		result->push_back(pPlot_i);
	  float duration_i = App_GetExpectedDuration(pPlot_i, 
												 isPlotMotorizable,
												 -9, // otClassId
												 serParOption,
												 manualMotorized,
												 passedRowFrequency,
												 manualNominalSpeed,
												 motorizedNominalSpeed);
	  alreadyChosenDuration+= duration_i;
	  if(! strcmp(manualMotorized, "MOTORIZED")) { 
		if(duration_i > (float)1.0) nbPlotMax--;
	  }
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	}
  }
//printf("\nt = %d selectPlotsToWeed returns :", pCurrentSim->Clock());result->display_names();
  return result;
};

pEntityTab* selectNewPlotsToWinterTill_Body(EntityMethod* pM) {
//-----------------------------------------------------------
// renvoie un tableau de parcelles a labourer dans le chantier d'hiver
//-------------------------------------------------- 
// en excluant les parcelles terminees : TERMINATED_PLOTS_ARGUMENT
// en comptant les parcelles en cours  : IN_COURSE_PLOTS_ARGUMENT
//--------------------------------------------------
  Entity* pChantier = pM->DescribedEntity();
//printf("\nDEB selectNewPlotsToWinterTill_Body sur '%s'", pChantier->InstanceName());
  Entity* pVineyard 
	= pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  char* serParOption 
	= pM->GetStringArgValue(SERIAL_PARALLEL_ARGUMENT);
  //
  // recuperation de la liste des parcelles en cours et terminees
  //
  pEntityTab* pTerminatedPlots 
	= pM->GetEntityTabArgValue(TERMINATED_PLOTS_ARGUMENT);
  pEntityTab* pInCoursePlots 
	= pM->GetEntityTabArgValue(IN_COURSE_PLOTS_ARGUMENT);
  int nbAlreadyChosen = pInCoursePlots->size();

//printf("\nparcelles en cours  : ");pInCoursePlots->display_names();
//printf("\nparcelles terminees : ");pTerminatedPlots->display_names();

  // duree previsionnelle de traitement pour les parcelles en cours
  // vitesseOperation =
  //   cas MAN : sans objet
  //   cas MOT : alleyWidth * _tillageOperation_speed_ /12 / passedRowFrequency
  //
  //UserClassId otClassId = TILLAGE_OPERATION;
  float passedRowFrequency = (float)1.0;  // approximation
  float manualNominalSpeed = (float)-9; 
  float motorizedNominalSpeed = gRealParam_tillageOperation_speed_;
  float alreadyChosenDuration = 
	App_GetAlreadyChosenActivitiesDuration(pInCoursePlots, 
											pChantier,
											serParOption,
											"MOTORIZED",
											passedRowFrequency,
											manualNominalSpeed,
											motorizedNominalSpeed);
//printf("\nduree des en-cours = %f", alreadyChosenDuration);
  // 
  // DTotW  = duree totale de travail sur la plage de travail de duree
  // 
  int dureePlageTravail = 2;// version pour UPS intermédiaires
  int nbRsc = App_GetResourceNumberForDistributedActivitySet(pVineyard, pChantier);
  float DTotW = dureePlageTravail * nbRsc;
//printf("\nnbRsc = %d dureePlageTravail = %d -> DTotW = %f", nbRsc, dureePlageTravail, DTotW);
  int nbPlotMax = dureePlageTravail * nbRsc;
  if(! strcmp(serParOption, "SER")) nbPlotMax = dureePlageTravail;
  if(alreadyChosenDuration > (float) 0.0) nbPlotMax--;
  if(alreadyChosenDuration > (float) 1.0) nbPlotMax--;

  pEntityTab* result = new pEntityTab();
  //
  // limitation calculée sur la durée (130106)
  //
  pEntityTab pPlotTab = pVineyard->GetElementTab();
  int nbPlots = pPlotTab.size();
  for(int i=0;i<nbPlots;i++) {
	if(! strcmp(serParOption, "SER")) {   // modif 130208
	  if((alreadyChosenDuration >= DTotW) || (result->size() >= nbPlotMax))
		break;
	}
	else {
	  if((alreadyChosenDuration >= DTotW) && (result->size() >= nbPlotMax))
		break;
	}

	Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
	//
	// on elimine les parcelles taillees ET . partiellement broyees
	//                                      . OU pas broyees mais a broyer
	//
	if(App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_PRUNED), (float)1.)
	   &&
	   App_FloatGT(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED), (float)-1.)
	   &&
	   App_FloatLT(pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED), (float)1.))
	  continue;

	if((GetPosition(*pTerminatedPlots, pPlot_i) < 0)
	   &&
	   (GetPosition(*pInCoursePlots, pPlot_i) < 0)
	   &&
	   App_FloatEQ(pPlot_i->GetFloatVarValue(PERCENT_WINTER_TILLED), (float)0.)) {
		result->push_back(pPlot_i);
		float duration_i = App_GetExpectedDuration(pPlot_i, 
												   FALSE,  // isPlotMotorizable
												   TILLAGE_OPERATION, 
												   serParOption,
												   "MOTORIZED",
												   passedRowFrequency,
												   manualNominalSpeed,
												   motorizedNominalSpeed);
		alreadyChosenDuration+= duration_i;
		if(duration_i > (float)1.0) nbPlotMax--;
//printf("\talreadyChosenDuration = %f", alreadyChosenDuration);
	}
  }
  
//printf("\nt = %d selectPlotsToWinterTill returns :", pCurrentSim->Clock());result->display_names();
  return result;
};

void setDayWhenStageAchieved_Body(EntityMethod* pM)
//--------------------------
// dote le stade du jour de son achevement, passe en argument
//--------------------------
{
  Entity* pAge = pM->DescribedEntity();
  int i = pAge->GetIntValue(CURRENT_STAGE_INDEX);
  pEntityTab* tab = pAge->GetEntityTabValue(STAGE_TAB);
  Entity* stage_i = (Entity*) tab->get_element(i);
  stage_i->SetIntValue(DAY_WHEN_ACHIEVED, 
                       pM->GetIntArgValue(DAY_WHEN_ACHIEVED_ARGUMENT));
};

int setFlagMildew_Body(EntityMethod* pM)
//--------------------------------------
// etablit le descripteur FlagMildew de la conduite (mildewWarningProcess)
//--------------------------------------
{
  Entity* pConduite = pM->DescribedEntity();

  Vineyard* pVineyard = 
	(Vineyard*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);

  int now = pCurrentSim->Clock();
  if(pConduite->GetIntConstValue(FLAG_MILDEW) == 1) {
//printf("\nt = %d setFlagMildew_Body  FLAG_MILDEW", now);
	return TRUE;
  }

  Boolean result = FALSE;
  int downyMildewMngt = 
	pConduite->GetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE);
  
  switch (downyMildewMngt) {
  case R0 : {
	int foyersPrimaires = App_GetIntPestInfo(pVineyard, 
											 DOWNY_MILDEW_PRIMARY_INFECTION);
	if(foyersPrimaires == OUI) {
	  //
	  // Recuperation des stations meteo pour cette EA
	  //----------------------------------------------
	  pEntityTab* pWSList = new pEntityTab();
	  pEntityTab pPlotList = pVineyard->GetElementTab();
	  int nbPlots = pPlotList.size();
	  for(int i=0;i<nbPlots;i++) {
		Entity* pPlot_i = (Entity*)pPlotList[i];
		Entity* pWS_i = pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
		pWSList->push_back_ifnew(pWS_i);
	  }
//printf("\nstations meteo :");pWSList->display_names();
	  // parcours des stations
	  // si un pr�sente un total de pluie > S1 et pluie pas trop repartie
	  // alors result = TRUE;
	  int nbWS = pWSList->size();
	  for(int i=0;i<nbWS;i++) {
		Entity* pWS_i = (Entity*)pWSList->get_element(i);
		char* pathName_i = pWS_i->GetStringConstValue(PATH_NAME_ATTRIBUTE);
//printf("\n\tpath : '%s'", pathName_i);
		float cumulPluie_JP3;
		cumulPluie_JP3 = 
		  SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 71)
		  + pWS_i->GetFloatVarValue(RAINFALL);
		pWS_i->ClearFloatTabValues(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY);
		pWS_i->AddFloatValueElement(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
									cumulPluie_JP3);
//Date laDate = ClockValueToDate(pCurrentSim->Clock());
//printf("\n%d-%s-%d %dH ", laDate.mday, MonthToChar(laDate.month), laDate.year, laDate.hour); printf("prevision pluie JP3 '%s' : %5.1f", pWS_i->InstanceName(), cumulPluie_JP3);
	  }
	  delete pWSList;
	  
	  // etablissement indicateur pour l'ensemble des parcelles :
	  // les 2 conditions suivantes doivent �tre respect�es sur une 
	  // au moins une parcelle � traiter :
	  // condition_niv : suffisamment de pluie dans le 3 prochains jours (> seuil fixe)
	  // condition_dis : distribution +- homog�ne sur les 3 jours
	  // ==>
	  // 1 on examine tour a tour chaque parcelle p_i
	  //       on examine le couple de conditions 1 et 2
	  //       SI    C1 et C2 respectees 
	  //       ALORS respectCondition = TRUE
	  //             break
	  //-------------------------------------------------
	  float seuilPluie = gRealParam_virtualManager_rainfallThresholdForPhytoTreatment_;
	  bool respectCondition_niv = FALSE;  // pour trace
	  bool respectCondition_dis = FALSE;  // pour trace
	  for(int i=0;i<nbPlots;i++) {
		Entity* pPlot_i = (Entity*)pPlotList[i];
//printf("\n'%s' ", pPlot_i->InstanceName());
		Entity* pWS_i = pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
		pFloatTab* rainFallVector = 
		  pWS_i->GetFloatTabConstValue(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY);
		float cumulPluie_JP3 = rainFallVector->get_element(0);
		if(cumulPluie_JP3 > seuilPluie) {
		  respectCondition_niv = TRUE; // pour trace
//printf(" respectCondition_niv : %d\n", respectCondition_niv);
		  // examen distribution
		  respectCondition_dis = TRUE;
//printf("\nApp_GetFlagMildew case R0 avec foyersPrimaires : completer l'estimation de la distribution");
		}
		if(respectCondition_niv && respectCondition_dis) {
		  result = TRUE;
		  break;
		}
	  }
	}
	break;
  }
  case S : {
	// result remains FALSE
	break;
  }
  default : {
	int foyersPrimaires = App_GetIntPestInfo(pVineyard, 
											 DOWNY_MILDEW_PRIMARY_INFECTION);
	if(foyersPrimaires == OUI) {
	  result = TRUE;
	}
	else {
	  int downyMildewLevel  = App_GetIntPestInfo(pVineyard, 
												 DOWNY_MILDEW_LEVEL);
	  float downyMildewRisk = App_GetFloatPestInfo(pVineyard, 
												   DOWNY_MILDEW_RISK_LEVEL);
	  // externalisation des seuils (1401)
	  int dmlThreshold = gIntParam_virtualManager_downyMildewLevelThresholdForFlagUp_;
	  float dmrThreshold = gRealParam_virtualManager_downyMildewRiskThresholdForFlagUp_;
	  if((downyMildewLevel > dmlThreshold) && (downyMildewRisk > dmrThreshold))
		result = TRUE;
	}
	break;
  }
  }
  pConduite->SetIntConstValue(FLAG_MILDEW, result);

//printf("\n'%s'::SetFlagMildew sets and returns %d", pConduite->InstanceName(), result);
  return result;
};

void  setRowSoilManagement_Body(EntityMethod* pM)
//------------------------------------------
// etablit le mode de gestion de chaque rangee de la parcelle
//------------------------------------------
{
  Entity* pPlot = pM->DescribedEntity();
  Entity* pVegetal = pPlot->GetComponent(VEGETAL_COMPARTMENT);
  int nbRows = pVegetal->GetNumberOfElements();

  int rowManagement = pPlot->GetIntConstValue(ROW_MANAGEMENT);
  float q = pPlot->GetFloatConstValue(RIDING_ORIENTED_INTER_ROW_PROPORTION);
  float p = pPlot->GetFloatConstValue(GRASS_STRIP_ALLEY_WIDTH_RATIO);
  float r = pPlot->GetFloatConstValue(CROP_ROW_ALLEY_WIDTH_RATIO); 

  switch(rowManagement) {

  case GRASS_COVERING_TILLAGE : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, GRASS_COVER); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE); 
		pPlot->SetFloatVarValue(PERCENT_WEEDED, (float)-1.); // AB 130514
		break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);break; // à valider
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);break; // à valider
	  }	    
	  }
	}
	break; 
  }
  case GRASS_COVERING : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, GRASS_COVER); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE); break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		if((r > 0) && (q < 0.5))
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		else
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		break;
	  }	    
	  }
	}
	break; 
  }
  case CW_IN_SPACE : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE); break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		if((r > 0) && (q < 0.5))
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		else
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		break;
	  }	    
	  }
	}
	break; 
  }
  case CW_IN_TIME : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
		/* old 
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, MIXED_TILLAGE_CW); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); 
		pPlot->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
		pPlot->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
		pPlot->SetFloatVarValue(PERCENT_SPRING_TILLED, (float)-1.);
		break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		if((r > 0) && (q < 0.5))
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		else
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		break;
	  }
		*/
		// new AB 1401 : "affecter un mode d'entretien du sol
		// aux inter-rangs travaillés et non aux inter-rangs stabilisés"
      case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
        pPlot->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
        pPlot->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
        pPlot->SetFloatVarValue(PERCENT_SPRING_TILLED, (float)-1.);
        break;
      }
      case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, MIXED_TILLAGE_CW); break;
      }
      case 2 : {   // rang voisin d'inter-rang stabilise
        pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
      }
      case 3 : {   //rang non voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
        break;
      }
	  }
	}
	break; 
  }
  case TOTAL_CW : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); 
		pPlot->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
		pPlot->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
		pPlot->SetFloatVarValue(PERCENT_SPRING_TILLED, (float)-1.);
		break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		if((r > 0) && (q < 0.5))
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		else
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		break;
	  }	    
	  }
	}
	break; 
  }
  case TILLAGE : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE); break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		if((r > 0) && (q < 0.5))
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, CHEMICAL_WEEDING);
		else
		  pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE);
		break;
	  }	    
	  }
	}
	break;
  }
  case TOTAL_TILLAGE : {
	for(int j=0;j<nbRows;j++) {
	  Entity* pRow_j = pVegetal->GetElement(j);
	  switch (j) {
	  case 0 : {   // inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
	  }
	  case 1 : {   // inter-rang travaille
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, TILLAGE);
		pPlot->SetFloatVarValue(PERCENT_WEEDED, (float)-1.); // + JPR 120907
		break;
	  }
	  case 2 : {   // rang voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break;
	  }
	  case 3 : {   //rang non voisin d'inter-rang stabilise
		pRow_j->SetIntConstValue(SOIL_MANAGEMENT_MODALITY, NONE); break; // à valider
	  }	    
	  }
	}
	break; 
  }	
  }
};







































void setScheduledAntiMildew_Body(EntityMethod* pM)
//------------------------------------------------
// pour un chantier ouvert, etablit s'il est programme avec un anti-mildiou
//------------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  Vineyard* pEA = (Vineyard*)pM->GetEntityArgValue(VINEYARD_ARGUMENT);
  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  //Entity* pIterate = pChantier->GetSuperSet();
  Entity* pIterate = ((Activity*)pChantier)->IsIterated();  // modif JPR 120302
//printf("\tpIterate : '%s'", pIterate->InstanceName());

  int result = FALSE;

  int downyMildewMngt = 
	pConduite->GetIntConstValue(DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE);
  int powderyMildewMngt = 
	pConduite->GetIntConstValue(POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE);

  Entity* pARB = pConduite->GetSuperEntity();
  Entity* dec_optionSet //DecisionOptionSet
	= pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
  char* guidingEarlyVarietyName = 
	dec_optionSet->GetStringConstValue(GUIDING_EARLY_VARIETY_ATTRIBUTE);
  Entity* guidingEarlyVariety = 
	GetNamedEntity("grapeVariety", guidingEarlyVarietyName);
  char* guidingLateVarietyName = 
	  dec_optionSet->GetStringConstValue(GUIDING_LATE_VARIETY_ATTRIBUTE);
  Entity* guidingLateVariety = 
	GetNamedEntity("grapeVariety", guidingLateVarietyName); 


  switch (downyMildewMngt) {
  case S : {
	result = TRUE;
	break;
  }
  case R0 : {
	result = FALSE;  // pour clarte
	break;
  }
  case F3 : {
	int rank = pIterate->GetIntVarValue(REPLICATION_COUNTER); // 0, 1, ...
	if(rank < 3)
	  result = TRUE;
	break;
  }
  case F2 : {
	int rank = pIterate->GetIntVarValue(REPLICATION_COUNTER);
	if(rank < 2)
	  result = TRUE;
	break;
  }
  case R1 : {
	int rank = pIterate->GetIntVarValue(REPLICATION_COUNTER);
	if(powderyMildewMngt == G) {
	  if(rank < 1)
		result = TRUE;
	}
	else {
	  if(rank < 2)
		result = TRUE;
	}
	break;
  }
  case RFLO :
  case FFLO : {
	pEntityTab* pLateIsoAgeingAttributeList = 
	  App_GetIsoAgeingEntityList(pEA, guidingLateVariety, NULL);
	int nbElemLate = pLateIsoAgeingAttributeList->size();

	bool allOKForLate = TRUE;
	for(int i=0;i<nbElemLate;i++)  {
	  Entity* pIsoAgeingEntity = 
		(Entity*)pLateIsoAgeingAttributeList->get_element(i);
	  Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
	  int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
	  if(codeStade >= 26) { //fin floraison
		allOKForLate = FALSE;
		break;
	  }
	}
	if(downyMildewMngt == FFLO) {
	  if(allOKForLate)
		result = TRUE;
	}
	else {
	  //
	  // etablissement liste des IsoAgeingEntity relatives aux varietes-guides
	  // (en principe 1 seule Late et 1 seule Early, 
	  //  mais on installe une boucle pour genaralisation possible)
	  //
	  pEntityTab* pEarlyIsoAgeingAttributeList = 
		App_GetIsoAgeingEntityList(pEA, guidingEarlyVariety, NULL);	  
	  int nbElemEarly = pEarlyIsoAgeingAttributeList->size();
	  
	  bool allOKForEarly = TRUE;
	  
	  for(int i=0;i<nbElemEarly;i++)  {
		Entity* pIsoAgeingEntity = 
		  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
		Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
		int codeStade = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
		if(codeStade <= 18) {       //debut floraison
		  allOKForEarly = FALSE;
		  break;
		}
	  }
	  if(allOKForLate && allOKForEarly)
		result = TRUE;
	}
	delete pLateIsoAgeingAttributeList;
	break;
  }
  }
//printf("\n'%s'::setScheduledAntiMildew -> %d", pChantier->InstanceName(), result);
  pChantier->SetIntConstValue(ANTI_MILDEW_SCHEDULED, result);
};

float sumUpGrassCoverVector_Body(EntityMethod* pM)
//------------------------------------------------
// renvoie un scalaire a partir du vecteur des couvertures sur les unit. hydro.
// ou -9. si pas de vecteur assigne par Mhydas
//------------------------------------------------
{
  Entity* pRow = pM->DescribedEntity();
  float result = (float)0.;

  pFloatTab* mhydasVector 
	= pRow->GetFloatTabConstValue(GRASS_COVER_VECTOR_FROM_MHYDAS);

  if(! mhydasVector) {
	if(gMyTraceWarnings)
	  printf("\npour '%s', sumUpGrassCoverVector n'a pas trouve de vecteur (attendu de OpenFluid).\nValeur -9 retournee.\n", pRow->InstanceName());
	return (float)-9.;
  }

  //
  // option a valider : on renvoie la moyenne
  //
  float total = 0.;
  int nbValues = mhydasVector->size();
  for(int i=0;i<nbValues;i++) {
	total += mhydasVector->get_element(i);
  }
  result = total/(float)nbValues;
	
  if(gMyTraceWarnings)
	printf("\n!!! sumUpGrassCoverVector : corps de methode a valider. \n");
//printf("\n'%s'::sumUpGrassCoverVector renvoie %5.3f", pRow->InstanceName(), result);
  return result;
};

float sumUpSoilHumidityVector_Body(EntityMethod* pM)
//--------------------------------------------------
// renvoie un scalaire a partir du vecteur des humidites sur les unit. hydro.
//--------------------------------------------------
{
  Entity* pRow = pM->DescribedEntity();
  float result = (float)0.;

  pFloatTab* mhydasVector 
	= pRow->GetFloatTabConstValue(SOIL_HUMIDITY_VECTOR_FROM_MHYDAS);

  if(! mhydasVector) {
	if(gMyTraceWarnings)
	  printf("\npour '%s', sumUpSoilHumidityVector n'a pas trouve de vecteur (attendu de OpenFluid).\nValeur -9 retournee.\n", pRow->InstanceName());
	return (float)-9.;
  }

  /*
  // option possible : on renvoie la moyenne
  //
  float total = 0.;
  int nbValues = mhydasVector->size();
  for(int i=0;i<nbValues;i++) {
	total += mhydasVector->get_element(i);
  }
  result = total/(float)nbValues;
  */
  //
  // option prise : on renvoie le max
  //
  int nbValues = mhydasVector->size();
  for(int i=0;i<nbValues;i++) {
	float val_i = mhydasVector->get_element(i);
	if(val_i > result)
	  result = val_i;
  }
 
//printf("\n'%s'::sumUpSoilHumidityVector renvoie %5.3f", pRow->InstanceName(), result);
  return result;
};

bool timetableClosingPredicate_Body(EntityMethod* pM)
//---------------------------------------------------
// specifie la fermeture d'un SeasonalEmploymentPlan
//---------------------------------------------------
{
  Entity* pE = pM->DescribedEntity();
  bool result = false;
  // to be overloaded in subclasses
  return result;
};

bool timetableOpeningPredicate_Body(EntityMethod* pM)
//---------------------------------------------------
// specifie l'ouverture d'un SeasonalEmploymentPlan
//---------------------------------------------------
{
  Entity* pE = pM->DescribedEntity();
  bool result = false;
  // to be overloaded in subclasses
  return result;
};

int updateOffPeriodCurrentIndex_Body(EntityMethod* pM)
//-------------------------------------------------
// modifie l'index pointant sur la periode en cours dans un OffWorkCalendar
//-------------------------------------------------
{
  Entity* pCalendar = pM->DescribedEntity();
  int nbPeriods = pCalendar->GetNumberOfElements();

  int now = pCurrentSim->Clock();
  //
  // currentIndex est initialise a -9 dans le constructeur du pCalendar
  // ==> a l'initialisation de la simulation, le calendrier est parcouru
  //     depuis son debut pour trouver la periode courante
  // ==> ensuite, le calendrier est parcouru a partir de la periode courante
  //
  int currentIndex = pCalendar->GetIntVarValue(CURRENT_ELEMENT_INDEX);
//printf("\nentree updatePeriodCurrentIndex_Body sur '%s' currentIndex = %d\n", pCalendar->InstanceName(), currentIndex);
  //
  // initialisation de l'index en fonction de la date courante
  // (= date de debut de la simulation, puisque l'evenement 
  //  updateSeasonCurrentIndexEvent est lance en t=0, qui invoque la
  //  presente methode dans la methode exec de son processus)
  //
  int candidateIndex = 0;
  for(int i=0;i<nbPeriods;i++) {
	if(currentIndex < 0) {
	  candidateIndex = i;
	}
	else {
	  candidateIndex = currentIndex + 1 + i;
	  if(candidateIndex >= nbPeriods)
		break;
	}
//printf("\n\tau candidateIndex = %d", candidateIndex);
	Entity* pPeriod = pCalendar->GetElement(candidateIndex);
//printf("\tperiod '%s'\n", pPeriod->InstanceName());
	//-------------------------
	//
	// les dates de debut et de fin sont au format aaaa-mm-jj par convention
	//
	char* begValue = pPeriod->GetStringConstValue(BEGINNING_CALENDAR_DATE);
	char* strBeg = strdup(begValue);
	char* yStrBeg = strtok(strBeg, "-");
	char* mStrBeg = strtok(NULL, "-");
	char* dStrBeg = strtok(NULL, "-");
	int yBeg = atoi(yStrBeg);
	int mBeg = atoi(mStrBeg);
	int dBeg = atoi(dStrBeg);
	int clockBeg = DateToClockValue(dBeg, mBeg, yBeg, 0, 0, 0);
	free(strBeg);

	if(now < clockBeg) {
	  currentIndex = candidateIndex - 1;
	  break;
	}
  }
//printf("\n!!! updatePeriodCurrentIndex_Body sur '%s' nouvel index = %d", pCalendar->InstanceName(), currentIndex);
  pCalendar->SetIntVarValue(CURRENT_ELEMENT_INDEX, currentIndex);

  return currentIndex;
};

int updateSeasonCurrentIndex_Body(EntityMethod* pM)
//--------------------------------------------------
// modifie l'index pointant sur la saison en cours dans un AnnualEmploymentPlan
//--------------------------------------------------
{
  Entity* pEmploymentPlan = pM->DescribedEntity();
  int nbSeasons = pEmploymentPlan->GetNumberOfElements();
  //
  // currentIndex est initialise a -9 dans le constructeur du pEmploymentPlan
  // ==> a l'initialisation de la simulation, le plan est parcouru
  //     depuis son debut pour trouver la saison courante
  // ==> ensuite, le plan est parcouru a partir de la saison courante
  //
  int currentIndex = pEmploymentPlan->GetIntVarValue(CURRENT_ELEMENT_INDEX);
//printf("\nentree updateSeasonCurrentIndex_Body sur '%s' currentIndex = %d\n", pEmploymentPlan->InstanceName(), currentIndex);
  //
  // initialisation de l'index en fonction de la date courante
  // (= date de debut de la simulation, puisque l'evenement 
  //  updateSeasonCurrentIndexEvent est lance en t=0, qui invoque la
  //  presente methode dans la methode exec de son processus)
  //
  int candidateIndex = 0;
  for(int i=0;i<nbSeasons;i++) {
	if(currentIndex < 0) {
	  candidateIndex = i;
	}
	else {
	  candidateIndex = currentIndex + 1 + i;
	  if(candidateIndex >= nbSeasons)
		candidateIndex = currentIndex + 1 + i - nbSeasons;
	}
//printf("\n\tau candidateIndex = %d", candidateIndex);
	Entity* pSeasonalPlan = pEmploymentPlan->GetElement(candidateIndex);
//printf("\tseasonalPlan '%s'\n", pSeasonalPlan->InstanceName());
	//-------------------------
	Method* pOpeningMeth = 
	  pSeasonalPlan->GetMethodWithBody(TIMETABLE_OPENING_PREDICATE); 
	EntityPredicate*  pM_OP = (EntityPredicate*)pOpeningMeth;
	Method* pClosingMeth = 
	  pSeasonalPlan->GetMethodWithBody(TIMETABLE_CLOSING_PREDICATE);
	EntityPredicate*  pM_CP = (EntityPredicate*)pClosingMeth;
	//-------------------------
	if(pOpeningMeth) {  // IL Y A UN  OPENING	
	  Boolean isOpenable = pM_OP->Body(pM_OP);
	  if(isOpenable) {     // candidateIndex openable
		if(pClosingMeth) {
		  Boolean isClosable = pM_CP->Body(pM_CP);
		  if(isClosable) { // candidateIndex closable
			currentIndex = candidateIndex;
			break;
		  }
		  else {           // candidateIndex not closable
			// on va regarder la saison suivante
		  }
		}
	  }
	  else {               // candidateIndex not openable
		currentIndex = candidateIndex -1;
		if(candidateIndex == 0)
		  currentIndex = nbSeasons - 1;
		else
		  currentIndex = candidateIndex -1;
		break;
	  }
	}
	else {  // PAS DE OPENING
	  if(pClosingMeth) {
		Boolean isClosable = pM_CP->Body(pM_CP);
		if(isClosable) { // candidateIndex closable
		  currentIndex = candidateIndex;
		  break;
		}
		else {           // candidateIndex not closable
		  // on va regarder la saison suivante
		}
	  }
	  else {
		printf("\n!!! updateSeasonCurrentIndex_Body sur '%s'\n    la saison %k n'a ni Opening ni ClosingPredicate.\n", pEmploymentPlan->InstanceName(), candidateIndex);
		exit(0);
	  }
	}
  }
//printf("\n!!! updateSeasonCurrentIndex_Body sur '%s' nouvel index = %d", pEmploymentPlan->InstanceName(), currentIndex);
  pEmploymentPlan->SetIntVarValue(CURRENT_ELEMENT_INDEX, currentIndex);
  //
  // l'attachement d'une nouvelle AvailabilityTimetable (propre a la nouvelle
  // periode ouverte) a l'unite de MO qui possede cet AnnualEmploymentPlan
  // est fait dans le processus updateSeasonCurrentIndexProcess
  //
  return currentIndex;
};

