void App_ControlPlanSettings (char fileName[])
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
//printf("\nApp_ControlPlanSettings('%s')", fileName);
  FILE* pF = fopen(fileName,"r");
  /*
  Entity* pPS = pCurrentSim->SimulatedEntity();
  Entity* pCS = pPS->GetComponent(CONTROLLED_SYSTEM);
  Entity* pACS = pCS->GetEntityConstValue(ATTACHED_ENTITY);
  Entity* pVineyardSet = pACS->GetComponent(VINEYARD_SET);
  Entity* pDS = pPS->GetComponent(MANAGER);
  Entity* pStrategy = pDS->GetComponent(STRATEGY);
  */
 
  char nomEA[10], codeConduite[20], codeWOOptionSet[20], codeDecOptionSet[20], codePatternOptionSet[30], codeAlPriorityOptionSet[30], codeOpPriorityOptionSet[30], specSoilManagement[500];

  while(TRUE) {
	int i = fscanf(pF,
				   "%s %s %s %s %s %s %s %s",
				   nomEA, codeConduite, 
				   codeWOOptionSet, codeDecOptionSet, 
				   codePatternOptionSet, 
				   codeAlPriorityOptionSet, codeOpPriorityOptionSet,
				   specSoilManagement);
	if(i == EOF)
	  break;

	if(strncmp(nomEA, "//", 2)) { // + JPR 121107 : possibilité de lignes en commentaire

	  char* str_in = strtok(specSoilManagement, "=");
	  char* str_soilManagement = strtok(NULL, "=");
	  if(! str_soilManagement) {
		printf("\n!! App_ControlPlanSettings('%s') :\n!! option d'entretien du sol non reconnue (exemple autorise : rowManagement=GRASS_COVERING)\n", fileName);
		exit(0);
	  }
//printf("\n\ti = %d nomEA : '%s' '%s' '%s' '%s' '%s' '%s' '%s' '%s'", i, nomEA, codeConduite, codeWOOptionSet, codeDecOptionSet, codePatternOptionSet, codeAlPriorityOptionSet, codeOpPriorityOptionSet, str_soilManagement);

	  //
	  // recuperation de l'EA
	  //
	  Vineyard* pVineyard = (Vineyard*)GetNamedEntity(nomEA);   // pas mieux ?!
	  if(! pVineyard) {
		printf("\n!!! Exploitation '%s' non trouv�e !!!", nomEA);
		exit(0);
	  }
	  //
	  // recuperation l'ARB de l'EA : 
	  //
	  // un plan a ete attache a l'ARB dans App_DepthBioPhysicalSettings
	  // juste pour pouvoir remonter a l'ARB a partir de pEA
	  // et redescendre au pool de ressources dans App_ResourceSettings
	  //
	  //
	  Entity* pOldPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	  Entity* pARB = pOldPlan->GetSuperEntity(); 
	  pARB->AssignBody(LOCAL_CANDIDATE_ACTIVITY_SET_SORT_METHOD, 
					   //App_Body_pushMAXSpecToBackInARBActivitySet);
					   App_Body_mySortActivitySetsInARB); // modif JPR 121222
	  
	  Entity* pWOOptionSet = GetNamedEntity(codeWOOptionSet);
	  pARB->SetEntityConstValue(WORK_ORGANIZATION_OPTION_SET_ATTRIBUTE,
								pWOOptionSet);
	  Entity* pDecOptionSet = GetNamedEntity(codeDecOptionSet);
	  pARB->SetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE,
								pDecOptionSet);
	  Entity* pPatternOptionSet = GetNamedEntity(codePatternOptionSet);
	  pARB->SetEntityConstValue(PLOT_PATTERN_OPTION_SET_ATTRIBUTE,
								pPatternOptionSet);
	  Entity* pAlPriorityOptionSet = GetNamedEntity(codeAlPriorityOptionSet);
	  pARB->SetEntityConstValue(ALLOCATION_PRIORITY_OPTION_SET_ATTRIBUTE,
								pAlPriorityOptionSet);
	  Entity* pOpPriorityOptionSet = GetNamedEntity(codeOpPriorityOptionSet);
	  pARB->SetEntityConstValue(OPERATION_PRIORITY_OPTION_SET_ATTRIBUTE,
								pOpPriorityOptionSet);
	  //
	  // designation fonction de selection du meilleur jeu d'activites
	  //
	  if(TRUE) {  // provisoire !
		pARB->AssignBody(LOCAL_BEST_ACTIVITY_SET_SELECTOR,
						 //Body_BestActivitySetSelector_OnlyOnOperationPriority);
						 Body_BestActivitySetSelector_Standard);
	  }
	  else {
		// affectation autre fonction de selection
	  }
	  //
	  // instanciation du plan de conduite definitif
	  //
	  int soilManagement = App_EnumToInt(str_soilManagement);
	  pARB->SetIntConstValue(SOIL_MANAGEMENT_OPTION, soilManagement);
	  Entity* pPlan;
	  if(! strcmp(codeConduite, "conduite1")) {
		pPlan = new Conduite1(pVineyard, soilManagement);
	  }
	  else if(! strcmp(codeConduite, "conduite2")) {
		pPlan = new Conduite2(pVineyard, soilManagement);
	  }
	  else if(! strcmp(codeConduite, "conduite3")) {
		pPlan = new Conduite3(pVineyard, soilManagement);
	  }
	  else if(! strcmp(codeConduite, "conduite4")) {
		pPlan = new Conduite4(pVineyard, soilManagement);
	  }
	  else if(! strcmp(codeConduite, "conduite5")) {
		pPlan = new Conduite5(pVineyard, soilManagement);
	  }
	  else  {
		printf("\n App_ControlPlanSettings conduite inconnue\n");
		exit(0);
	  }
	  //
	  // remplacement du plan temporaire par le definitif
	  //
	  pVineyard->SetEntityConstValue(CONTROL_PLAN_ATTRIBUTE, pPlan);
	  pARB->RemoveComponent(pOldPlan);
	  DeleteEntity(pOldPlan);
	  pARB->AddComponent(pPlan);
	  //
	  // on rend le plan pret a etre interprete
	  //
	  pPlan->SetIntVarValue(READY_TO_RUN, 1);
//printf("\npPlan : %s pour '%s'\n", pPlan->InstanceName(), pVineyard->InstanceName());
//((Activity*)pPlan)->DisplaySituation(); printf("\n");
	  //
	  // pour chaque parcelle de l'EA
	  // l'etablissement de la surface relative des rangs et inter-rangs 
	  // est delegue aux fonctions SetRowSoilManagement<X>
	} // fin if("//")
  } // fin while
  fclose(pF);  
//printf("\nfin App_ControlPlanSettings('%s')", fileName);
}
