// ==============================================
// Fichier : UserFunction.cc  
// Type    : source C++
// 
// Description : Fonctions 'developpeur'.
// ==============================================

#include "UserFunction.h"

// -------------------------------
// Initialisation de la simulation
// -------------------------------
void InitSimulation() {
	if(g_BD_TraceActionMode)
	  printf("\nDEBUT UserFunction.cc/InitSimulation()");
	pCurrentSim = new Simulation();
	pCurrentSim->AssignBeforeInAgendaMethod(BeforeByDatePriority);
	AssignEnumToInt(App_EnumToInt);
 
	App_AssignInstantiators();
 
	D_InstallMetaClasses();
	C_InstallMetaClasses();
	O_InstallMetaClasses();
	App_InstallMetaClasses();
	SetHierarchy();
 
	D_DefineMonitors();
	C_DefineMonitors();
	O_DefineMonitors();
	App_DefineMonitors();
	if(g_BD_TraceActionMode)
	  printf("\nFIN   UserFunction.cc/InitSimulation()\n");
}


// -------------------------------------------
// passage symbole -> string  pour ClassId
// -------------------------------------------
void App_MakeClassIdToCharTab() {
	for(int k=gClassIdToCharTabSize;k<401;k++)
		ClassIdToCharTab.push_back("@");
	ClassIdToCharTab.push_back("AGRO_CLIMATIC_SYSTEM");
	ClassIdToCharTab.push_back("AIR_ASSISTED_SPRAYER");
	ClassIdToCharTab.push_back("AIR_ASSISTED_SPRAYING");
	ClassIdToCharTab.push_back("AIR_ASSISTED_SPRAYING_OPERATION_RESOURCE_SPEC");
	ClassIdToCharTab.push_back("AIR_ASSISTED_SPRAYING_RESOURCE_SET");
	ClassIdToCharTab.push_back("ALLOCATION_PRIORITY_OPTION_SET");
	ClassIdToCharTab.push_back("ALLOCATION_PRIORITY_OPTION_SUBSET");
	ClassIdToCharTab.push_back("ANNUAL_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("APRIL_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("APRIL_NORMAL_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("APRIL_REDUCED_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("AT_LEAST_ONE_PLOT");
	ClassIdToCharTab.push_back("AUTUMN_TILLAGE_ACTIVITY");
	ClassIdToCharTab.push_back("BACK_SPRAYER");
	ClassIdToCharTab.push_back("BACK_SPRAYING_OPERATION");
	ClassIdToCharTab.push_back("CHEMICAL_DEBRANCHER_OPERATED_SPRAYING");
	ClassIdToCharTab.push_back("CHEMICAL_DEBRANCHER_SPRAYING_OPERATION_RESOURCE_SPEC");
	ClassIdToCharTab.push_back("CHEMICAL_DEBRANCHER_SPRAYING_RESOURCE_SET");
	ClassIdToCharTab.push_back("CHEMICAL_WEEDING_ACTIVITY");
	ClassIdToCharTab.push_back("CLIPPER");
	ClassIdToCharTab.push_back("CLIPPING_ACTIVITY");
	ClassIdToCharTab.push_back("CLIPPING_OPERATION");
	ClassIdToCharTab.push_back("CLIPPING_OPERATION_RESOURCE_SPEC");
	ClassIdToCharTab.push_back("CLIPPING_RESOURCE_SET");
	ClassIdToCharTab.push_back("COLLECTOR_PANE");
	ClassIdToCharTab.push_back("CONCURRENT_ANTI_MILDEW_TREATMENTS");
	ClassIdToCharTab.push_back("CONCURRENT_AUTUMN_TILLAGES");
	ClassIdToCharTab.push_back("CONCURRENT_CHEMICAL_WEEDINGS");
	ClassIdToCharTab.push_back("CONCURRENT_CLIPPINGS");
	ClassIdToCharTab.push_back("CONCURRENT_CLIPPINGS_ITERATION");
	ClassIdToCharTab.push_back("CONCURRENT_DEBRANCHINGS");
	ClassIdToCharTab.push_back("CONCURRENT_DISTRIBUTED_ACTIVITY_SET");
	ClassIdToCharTab.push_back("CONCURRENT_EXTRA_PHYTO_TREATMENTS");
	ClassIdToCharTab.push_back("CONCURRENT_FERTILIZATIONS");
	ClassIdToCharTab.push_back("CONCURRENT_INIT_SPRING_TILLAGES");
	ClassIdToCharTab.push_back("CONCURRENT_PRUNINGS");
	ClassIdToCharTab.push_back("CONCURRENT_REGULAR_PHYTO_TREATMENTS");
	ClassIdToCharTab.push_back("CONCURRENT_SHOOT_THINNINGS");
	ClassIdToCharTab.push_back("CONCURRENT_SPRING_CHEMICAL_WEEDINGS");
	ClassIdToCharTab.push_back("CONCURRENT_SPRING_TILLAGES");
	ClassIdToCharTab.push_back("CONCURRENT_TRELLISINGS");
	ClassIdToCharTab.push_back("CONCURRENT_WINTER_TILLAGES");
	ClassIdToCharTab.push_back("CONDUITE1");
	ClassIdToCharTab.push_back("CONDUITE2");
	ClassIdToCharTab.push_back("CONDUITE3");
	ClassIdToCharTab.push_back("CONDUITE4");
	ClassIdToCharTab.push_back("CONDUITE5");
	ClassIdToCharTab.push_back("CROP_ROW");
	ClassIdToCharTab.push_back("CULTURAL_OPERATIONS_DATA_ITEM");
	ClassIdToCharTab.push_back("DEBRANCHING_ACTIVITY");
	ClassIdToCharTab.push_back("DEBRANCHING_SPRAYER");
	ClassIdToCharTab.push_back("DECISION_OPTION_SET");
	ClassIdToCharTab.push_back("DHIVINE_VALUATED_DATA_ITEM");
	ClassIdToCharTab.push_back("DISTRIBUTED_ACTIVITY_SET_ITERATION");
	ClassIdToCharTab.push_back("DISTRIBUTED_ACTIVITY_SET_MEMORY_ITEM");
	ClassIdToCharTab.push_back("EQUIPMENT_MULTI_LOCALIZATION");
	ClassIdToCharTab.push_back("EQUIPMENT_UBIQUITY_CONDITION");
	ClassIdToCharTab.push_back("EXTRA_PHYTO_TREATMENTS_ITERATION");
	ClassIdToCharTab.push_back("FARM_EQUIPMENT");
	ClassIdToCharTab.push_back("FARM_WORKER");
	ClassIdToCharTab.push_back("FARM_WORKER_AVAILABILITY_TIMETABLE");
	ClassIdToCharTab.push_back("FARM_WORKER_MULTI_LOCALIZATION");
	ClassIdToCharTab.push_back("FARM_WORKER_MULTI_OCCUPATION");
	ClassIdToCharTab.push_back("FARM_WORKER_MULTI_OCCUPIED");
	ClassIdToCharTab.push_back("FARM_WORKER_UBIQUITY_CONDITION");
	ClassIdToCharTab.push_back("FEBRUARY_MARCH_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("FEBRUARY_MARCH_NORMAL_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("FEBRUARY_MARCH_REDUCED_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("FERTILIZATION_ACTIVITY");
	ClassIdToCharTab.push_back("FERTILIZATION_OPERATION");
	ClassIdToCharTab.push_back("FERTILIZATION_OPERATION_RESOURCE_SPEC");
	ClassIdToCharTab.push_back("FERTILIZATION_RESOURCE_SET");
	ClassIdToCharTab.push_back("FORMATION_PRUNING_ACTIVITY");
	ClassIdToCharTab.push_back("GOBELET_PRUNING_ACTIVITY");
	ClassIdToCharTab.push_back("GRAPE_VARIETY");
	ClassIdToCharTab.push_back("GRAPEVINE");
	ClassIdToCharTab.push_back("GRAPEVINE_AGE");
	ClassIdToCharTab.push_back("GRASS");
	ClassIdToCharTab.push_back("GRASS_AGE");
	ClassIdToCharTab.push_back("GRASS_COVER_VECTOR_DATA_ITEM");
	ClassIdToCharTab.push_back("GRASS_TYPE");
	ClassIdToCharTab.push_back("GRINDER");
	ClassIdToCharTab.push_back("GRINDER_OPERATED_SHOOT_THINNING");
	ClassIdToCharTab.push_back("GRINDER_SHOOT_THINNING_OPERATION_RESOURCE_SPEC");
	ClassIdToCharTab.push_back("GRINDER_SHOOT_THINNING_RESOURCE_SET");
	ClassIdToCharTab.push_back("GUYOT_PRUNING_ACTIVITY");
	ClassIdToCharTab.push_back("HAND_HELD_GUN_OPERATED_SPRAYING");
	ClassIdToCharTab.push_back("HAND_HELD_GUN_SPRAYING_OPERATION_RESOURCE_SPEC");
	ClassIdToCharTab.push_back("HAND_HELD_GUN_SPRAYING_RESOURCE_SET");
	ClassIdToCharTab.push_back("HAND_HELD_SPRAY_GUN");
	ClassIdToCharTab.push_back("HORIZONTAL_RAIL_OPERATED_SPRAYING");
	ClassIdToCharTab.push_back("HORIZONTAL_RAIL_SPRAYER");
	ClassIdToCharTab.push_back("HORIZONTAL_RAIL_SPRAYING_OPERATION_RESOURCE_SPEC");
	ClassIdToCharTab.push_back("HORIZONTAL_RAIL_SPRAYING_RESOURCE_SET");
	ClassIdToCharTab.push_back("INIT_SPRING_TILLAGE_ACTIVITY");
	ClassIdToCharTab.push_back("INTER_ROW");
	ClassIdToCharTab.push_back("ISO_AGEING_ENTITY");
	ClassIdToCharTab.push_back("LAST_OPERATIONS_MEMORY");
	ClassIdToCharTab.push_back("LAST_OPERATIONS_MEMORY_ITEM");
	ClassIdToCharTab.push_back("LAST_PESTICIDE_APPLICATIONS_MEMORY_ITEM");
	ClassIdToCharTab.push_back("LAST_TILLAGE_OPERATIONS_MEMORY_ITEM");
	ClassIdToCharTab.push_back("LOW_CUMULATIVE_RAIN_SUFFERED");
	ClassIdToCharTab.push_back("MANAGER_ANNUAL_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("MANUAL_CHEMICAL_DEBRANCHING_ACTIVITY");
	ClassIdToCharTab.push_back("MANUAL_CHEMICAL_WEEDING_ACTIVITY");
	ClassIdToCharTab.push_back("MANUAL_DEBRANCHING_OPERATION");
	ClassIdToCharTab.push_back("MANUAL_MECHANICAL_DEBRANCHING_ACTIVITY");
	ClassIdToCharTab.push_back("MANUAL_OPERATION");
	ClassIdToCharTab.push_back("MANUAL_PHYTO_TREATMENT_ACTIVITY");
	ClassIdToCharTab.push_back("MAY_AUGUST_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("MAY_AUGUST_EXTENDED_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("MAY_AUGUST_NORMAL_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("MAY_AUGUST_REDUCED_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("MHYDAS_VALUATED_DATA_ITEM");
	ClassIdToCharTab.push_back("MORE_THAN_ONE_PLOT");
	ClassIdToCharTab.push_back("MORE_THAN_ONE_TASK");
	ClassIdToCharTab.push_back("MOTORIZED_CHEMICAL_DEBRANCHING_ACTIVITY");
	ClassIdToCharTab.push_back("MOTORIZED_CHEMICAL_WEEDING_ACTIVITY");
	ClassIdToCharTab.push_back("MOTORIZED_OPERATION");
	ClassIdToCharTab.push_back("MOTORIZED_PHYTO_TREATMENT_ACTIVITY");
	ClassIdToCharTab.push_back("MOTORIZED_SPRAYING_OPERATION");
	ClassIdToCharTab.push_back("MY_FLOAT_AREA_OPERATION");
	ClassIdToCharTab.push_back("NEUTRAL_INCONSISTENCY_CONDITION");
	ClassIdToCharTab.push_back("NON_PERMANENT_FARM_WORKER");
	ClassIdToCharTab.push_back("NON_PERMANENT_MANUAL_FARM_WORKER");
	ClassIdToCharTab.push_back("NON_PERMANENT_TRACTOR_DRIVER");
	ClassIdToCharTab.push_back("NOVEMBER_JANUARY_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("NOVEMBER_JANUARY_NORMAL_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("NOVEMBER_JANUARY_REDUCED_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("OFF_WORK_CALENDAR");
	ClassIdToCharTab.push_back("OFF_WORK_SINGLE_PERIOD");
	ClassIdToCharTab.push_back("ONLY_PHYTO_TREATMENTS_AT_EARLY_MORNING");
	ClassIdToCharTab.push_back("OPERATION_PRIORITY_OPTION_SET");
	ClassIdToCharTab.push_back("OPERATION_PRIORITY_OPTION_SUBSET");
	ClassIdToCharTab.push_back("OPERATION_RECORDING_ITEM");
	ClassIdToCharTab.push_back("OPERATION_RECORDING_STRUCTURE");
	ClassIdToCharTab.push_back("PERMANENT_ALL_TASK_TRACTOR_DRIVER");
	ClassIdToCharTab.push_back("PERMANENT_FARM_WORKER");
	ClassIdToCharTab.push_back("PERMANENT_FARM_WORKER_FIVE_DAY_TIMETABLE");
	ClassIdToCharTab.push_back("PERMANENT_FARM_WORKER_SEVEN_DAY_TIMETABLE");
	ClassIdToCharTab.push_back("PERMANENT_FARM_WORKER_SIX_DAY_TIMETABLE");
	ClassIdToCharTab.push_back("PERMANENT_MANUAL_FARM_WORKER");
	ClassIdToCharTab.push_back("PERMANENT_MULTI_TASK_MANUAL_WORKER");
	ClassIdToCharTab.push_back("PERMANENT_MULTI_TASK_WORKER");
	ClassIdToCharTab.push_back("PERMANENT_PREFERENTIAL_TRACTOR_DRIVER");
	ClassIdToCharTab.push_back("PERMANENT_PRUNER");
	ClassIdToCharTab.push_back("PERMANENT_TILLAGE_ORIENTED_TRACTOR_DRIVER");
	ClassIdToCharTab.push_back("PERMANENT_TILLAGE_TRACTOR_DRIVER");
	ClassIdToCharTab.push_back("PERMANENT_TRACTOR_DRIVER");
	ClassIdToCharTab.push_back("PERMANENT_VEGETATION_GROWER");
	ClassIdToCharTab.push_back("PEST_INFO_MEMORY");
	ClassIdToCharTab.push_back("PEST_INFO_MEMORY_ITEM");
	ClassIdToCharTab.push_back("PHENO_STAGE");
	ClassIdToCharTab.push_back("PHYTO_TREATMENT_ACTIVITY");
	ClassIdToCharTab.push_back("PHYTO_TREATMENT_COMPOSED_PROGRAM");
	ClassIdToCharTab.push_back("PLANT_AGE");
	ClassIdToCharTab.push_back("PLANTATION_ACTIVITY");
	ClassIdToCharTab.push_back("PLANTATION_OPERATION");
	ClassIdToCharTab.push_back("PLOT");
	ClassIdToCharTab.push_back("PLOT_INTERNAL_PATTERN_OPTION_SET");
	ClassIdToCharTab.push_back("PLOT_INTERNAL_PATTERN_OPTION_SUBSET");
	ClassIdToCharTab.push_back("PLOT_WITH_SEVERAL_OPERATIONS");
	ClassIdToCharTab.push_back("PRUNING_ACTIVITY");
	ClassIdToCharTab.push_back("PRUNING_MACHINE");
	ClassIdToCharTab.push_back("PRUNING_OPERATION");
	ClassIdToCharTab.push_back("REGULAR_PHYTO_TREATMENTS_ITERATION");
	ClassIdToCharTab.push_back("RELATIVE_AREA_DATA_ITEM");
	ClassIdToCharTab.push_back("RETIRED_WORKER_ANNUAL_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("ROTARY_CULTIVATOR");
	ClassIdToCharTab.push_back("ROTARY_OPERATED_SHOOT_THINNING");
	ClassIdToCharTab.push_back("ROTARY_OPERATED_TILLAGE");
	ClassIdToCharTab.push_back("ROTARY_TILLAGE_OPERATION_RESOURCE_SPEC");
	ClassIdToCharTab.push_back("ROTARY_TILLAGE_RESOURCE_SET");
	ClassIdToCharTab.push_back("ROW");
	ClassIdToCharTab.push_back("ROYAT_PRUNING_ACTIVITY");
	ClassIdToCharTab.push_back("SEASONAL_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("SEPTEMBER_OCTOBER_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("SEPTEMBER_OCTOBER_NORMAL_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("SEPTEMBER_OCTOBER_REDUCED_HOURS_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("SERIAL_ANTI_MILDEW_TREATMENTS");
	ClassIdToCharTab.push_back("SERIAL_AUTUMN_TILLAGES");
	ClassIdToCharTab.push_back("SERIAL_CHEMICAL_WEEDINGS");
	ClassIdToCharTab.push_back("SERIAL_CLIPPINGS");
	ClassIdToCharTab.push_back("SERIAL_CLIPPINGS_ITERATION");
	ClassIdToCharTab.push_back("SERIAL_DEBRANCHINGS");
	ClassIdToCharTab.push_back("SERIAL_DISTRIBUTED_ACTIVITY_SET");
	ClassIdToCharTab.push_back("SERIAL_EXTRA_PHYTO_TREATMENTS");
	ClassIdToCharTab.push_back("SERIAL_FERTILIZATIONS");
	ClassIdToCharTab.push_back("SERIAL_INIT_SPRING_TILLAGES");
	ClassIdToCharTab.push_back("SERIAL_MANUAL_CHEMICAL_WEEDINGS");
	ClassIdToCharTab.push_back("SERIAL_MANUAL_DEBRANCHINGS");
	ClassIdToCharTab.push_back("SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS");
	ClassIdToCharTab.push_back("SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS");
	ClassIdToCharTab.push_back("SERIAL_MOTORIZED_CHEMICAL_WEEDINGS");
	ClassIdToCharTab.push_back("SERIAL_MOTORIZED_DEBRANCHINGS");
	ClassIdToCharTab.push_back("SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS");
	ClassIdToCharTab.push_back("SERIAL_MOTORIZED_SPRING_CHEMICAL_WEEDINGS");
	ClassIdToCharTab.push_back("SERIAL_PLANTATIONS");
	ClassIdToCharTab.push_back("SERIAL_PRUNINGS");
	ClassIdToCharTab.push_back("SERIAL_REGULAR_PHYTO_TREATMENTS");
	ClassIdToCharTab.push_back("SERIAL_SHOOT_THINNINGS");
	ClassIdToCharTab.push_back("SERIAL_SPRING_CHEMICAL_WEEDINGS");
	ClassIdToCharTab.push_back("SERIAL_SPRING_TILLAGES");
	ClassIdToCharTab.push_back("SERIAL_TRELLISINGS");
	ClassIdToCharTab.push_back("SERIAL_TRELLISINGS_ITERATION");
	ClassIdToCharTab.push_back("SERIAL_WINTER_TILLAGES");
	ClassIdToCharTab.push_back("SHOOT_THINNING_ACTIVITY");
	ClassIdToCharTab.push_back("SHOOT_THINNING_OPERATION");
	ClassIdToCharTab.push_back("SOIL_HUMIDITY_VECTOR_DATA_ITEM");
	ClassIdToCharTab.push_back("SOIL_MANAGEMENT_DATA_ITEM");
	ClassIdToCharTab.push_back("SOIL_MANAGEMENT_GROUP");
	ClassIdToCharTab.push_back("SOIL_MANAGEMENT_GROUP_SET");
	ClassIdToCharTab.push_back("SOIL_RESERVOIR");
	ClassIdToCharTab.push_back("SOIL_SURFACE");
	ClassIdToCharTab.push_back("SPECIAL_WORKER_ANNUAL_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("SPRAYER");
	ClassIdToCharTab.push_back("SPREADER");
	ClassIdToCharTab.push_back("SPRING_TILLAGE_ACTIVITY");
	ClassIdToCharTab.push_back("SPRING_TILLAGES_ITERATION");
	ClassIdToCharTab.push_back("SPRING_TINE_CULTIVATOR");
	ClassIdToCharTab.push_back("SPRING_TINE_OPERATED_TILLAGE");
	ClassIdToCharTab.push_back("SPRING_TINE_TILLAGE_OPERATION_RESOURCE_SPEC");
	ClassIdToCharTab.push_back("SPRING_TINE_TILLAGE_RESOURCE_SET");
	ClassIdToCharTab.push_back("STANDARD_WORKER_ANNUAL_EMPLOYMENT_PLAN");
	ClassIdToCharTab.push_back("TANK");
	ClassIdToCharTab.push_back("TILLAGE_ACTIVITY");
	ClassIdToCharTab.push_back("TILLAGE_OPERATION");
	ClassIdToCharTab.push_back("TILLAGE_RESOURCE_SET");
	ClassIdToCharTab.push_back("TILLAGE_TOOL");
	ClassIdToCharTab.push_back("TOO_LATE_IN_WORK_DAY_FOR_ACTIVITY_BEGINNING");
	ClassIdToCharTab.push_back("TRACTOR");
	ClassIdToCharTab.push_back("TRELLISING_ACTIVITY");
	ClassIdToCharTab.push_back("TRELLISING_MACHINE");
	ClassIdToCharTab.push_back("TRELLISING_OPERATION");
	ClassIdToCharTab.push_back("VARIETY_GROUP");
	ClassIdToCharTab.push_back("VARIETY_GROUP_SET");
	ClassIdToCharTab.push_back("VEGETAL_COMPARTMENT");
	ClassIdToCharTab.push_back("VEGETATION");
	ClassIdToCharTab.push_back("VERTICAL_RAIL_OPERATED_SPRAYING");
	ClassIdToCharTab.push_back("VERTICAL_RAIL_SPRAYER");
	ClassIdToCharTab.push_back("VERTICAL_RAIL_SPRAYING_OPERATION_RESOURCE_SPEC");
	ClassIdToCharTab.push_back("VERTICAL_RAIL_SPRAYING_RESOURCE_SET");
	ClassIdToCharTab.push_back("VINE_GROWING_TERRITORY");
	ClassIdToCharTab.push_back("VINE_PRODUCING_REGION");
	ClassIdToCharTab.push_back("VINEYARD");
	ClassIdToCharTab.push_back("VINEYARD_ACTIVITIES_RESOURCES_BLOCK");
	ClassIdToCharTab.push_back("VINEYARD_ACTIVITY");
	ClassIdToCharTab.push_back("VINEYARD_CONTROL_SEQUENCE");
	ClassIdToCharTab.push_back("VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN");
	ClassIdToCharTab.push_back("VINEYARD_PHASE_CONJUNCTIVE_PLAN");
	ClassIdToCharTab.push_back("VINEYARD_PHASE_OPTIONAL_PLAN");
	ClassIdToCharTab.push_back("VINEYARD_SET");
	ClassIdToCharTab.push_back("VIRTUAL_REGION_MANAGER");
	ClassIdToCharTab.push_back("VIRTUAL_REGION_OPERATING_SYSTEM");
	ClassIdToCharTab.push_back("WEATHER_STATION");
	ClassIdToCharTab.push_back("WEATHER_STATION_SET");
	ClassIdToCharTab.push_back("WEEK_DAY_AFTERNOON");
	ClassIdToCharTab.push_back("WEEK_DAY_MORNING");
	ClassIdToCharTab.push_back("WEEK_DAY_PART");
	ClassIdToCharTab.push_back("WINTER_TILLAGE_ACTIVITY");
	ClassIdToCharTab.push_back("WORK_ORGANIZATION_OPTION_SET");
	ClassIdToCharTab.push_back("WORK_ORGANIZATION_OPTION_SUBSET");
	gClassIdToCharTabSize = ClassIdToCharTab.size();
}


// -------------------------------------------
// passage symbole -> string  pour DescId
// -------------------------------------------
void App_MakeDescIdToCharTab() {
	for(int k=gDescIdToCharTabSize;k<401;k++)
		DescIdToCharTab.push_back("@");
	DescIdToCharTab.push_back("ACTIVITY_ATTRIBUTE");
	DescIdToCharTab.push_back("ACTIVITY_NAME_ATTRIBUTE");
	DescIdToCharTab.push_back("ACTIVITY_NOMINAL_DATE");
	DescIdToCharTab.push_back("ACTUAL_REALIZATION_BEG_DATE");
	DescIdToCharTab.push_back("ACTUAL_REALIZATION_END_DATE");
	DescIdToCharTab.push_back("ACTUALLY_OPERATED_AREA_PERCENTAGE");
	DescIdToCharTab.push_back("AGE_ATTRIBUTE");
	DescIdToCharTab.push_back("ALLEY_WIDTH");
	DescIdToCharTab.push_back("ALLOCATION_PRIORITY_OPTION_SET_ATTRIBUTE");
	DescIdToCharTab.push_back("ANNUAL_EMPLOYMENT_PLAN_ATTRIBUTE");
	DescIdToCharTab.push_back("ANTI_MILDEW_SCHEDULED");
	DescIdToCharTab.push_back("ANTI_MILDEW_TREATMENT_JUST_DONE");
	DescIdToCharTab.push_back("AREA");
	DescIdToCharTab.push_back("AREA_WITH_GRAPEVINE");
	DescIdToCharTab.push_back("AREA_WITH_TILLED_GRAPEVINE");
	DescIdToCharTab.push_back("AUTUMN_TILLAGES_MANAGEMENT");
	DescIdToCharTab.push_back("BEGINNING_CALENDAR_DATE");
	DescIdToCharTab.push_back("CHEMICAL_WEEDINGS_MANAGEMENT");
	DescIdToCharTab.push_back("CLIPPINGS_MANAGEMENT");
	DescIdToCharTab.push_back("COMMERCIAL_FORMULATION");
	DescIdToCharTab.push_back("COMMERCIAL_FORMULATION_DOSE");
	DescIdToCharTab.push_back("COMMERCIAL_FORMULATION_LIST");
	DescIdToCharTab.push_back("CONTROL_PLAN_ATTRIBUTE");
	DescIdToCharTab.push_back("CONTROL_PLAN_CLASS_NAME_ATTRIBUTE");
	DescIdToCharTab.push_back("CROP_ROW_ALLEY_WIDTH_RATIO");
	DescIdToCharTab.push_back("CUMULATIVE_RAINFALL_FROM_EARLY_WINTER");
	DescIdToCharTab.push_back("CUMULATIVE_RAINFALL_FROM_EARLY_WINTER_FOR_INITST");
	DescIdToCharTab.push_back("CUMULATIVE_RAINFALL_FROM_LAST_TILLAGE");
	DescIdToCharTab.push_back("CUMULATIVE_RAINFALL_FROM_MHYDAS_INTERACTION");
	DescIdToCharTab.push_back("CUMULATIVE_RAINFALL_FROM_WORK_BEGINNING");
	DescIdToCharTab.push_back("CURRENT_SLOT_TO_BE_EXTENDED");
	DescIdToCharTab.push_back("CURRENT_STAGE_INDEX");
	DescIdToCharTab.push_back("DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY");
	DescIdToCharTab.push_back("DAY_OF_ACHIEVEMENT");
	DescIdToCharTab.push_back("DAY_WHEN_ACHIEVED");
	DescIdToCharTab.push_back("DAYS_NUMBER");
	DescIdToCharTab.push_back("DEBRANCHINGS_MANAGEMENT");
	DescIdToCharTab.push_back("DECISION_OPTION_SET_ATTRIBUTE");
	DescIdToCharTab.push_back("DISTRIBUTED_ACTIVITY_SET_MEMORY");
	DescIdToCharTab.push_back("DOWNY_MILDEW_LEVEL");
	DescIdToCharTab.push_back("DOWNY_MILDEW_MANAGEMENT_ATTRIBUTE");
	DescIdToCharTab.push_back("DOWNY_MILDEW_PRESSURE");
	DescIdToCharTab.push_back("DOWNY_MILDEW_PRIMARY_INFECTION");
	DescIdToCharTab.push_back("DOWNY_MILDEW_RISK_LEVEL");
	DescIdToCharTab.push_back("DOWNY_MILDEW_TO_CLOSE");
	DescIdToCharTab.push_back("END_CALENDAR_DATE");
	DescIdToCharTab.push_back("FARM_WORKER_ATTRIBUTE");
	DescIdToCharTab.push_back("FERTILIZATIONS_MANAGEMENT");
	DescIdToCharTab.push_back("FIRST_SPRING_TILLAGE_DATE");
	DescIdToCharTab.push_back("FLAG_MILDEW");
	DescIdToCharTab.push_back("GRAPE_VARIETY_ATTRIBUTE");
	DescIdToCharTab.push_back("GRAPE_VARIETY_LIST_ATTRIBUTE");
	DescIdToCharTab.push_back("GRASS_COVER_VECTOR_FROM_MHYDAS");
	DescIdToCharTab.push_back("GRASS_STRIP_ALLEY_WIDTH_RATIO");
	DescIdToCharTab.push_back("GRASS_TYPE_ATTRIBUTE");
	DescIdToCharTab.push_back("GUIDING_EARLY_VARIETY_ATTRIBUTE");
	DescIdToCharTab.push_back("GUIDING_LATE_VARIETY_ATTRIBUTE");
	DescIdToCharTab.push_back("GUIDING_VARIETIES_ATTRIBUTE");
	DescIdToCharTab.push_back("HAS_EARLY_VARIETY");
	DescIdToCharTab.push_back("HAS_LATE_VARIETY");
	DescIdToCharTab.push_back("IN_OUT_MODE");
	DescIdToCharTab.push_back("INIT_SPRING_TILLAGES_MANAGEMENT");
	DescIdToCharTab.push_back("IS_ALLOCATION_EXCLUSIVE");
	DescIdToCharTab.push_back("IS_EARLY");
	DescIdToCharTab.push_back("IS_MANAGER");
	DescIdToCharTab.push_back("ISO_AGEING_ENTITY_ATTRIBUTE");
	DescIdToCharTab.push_back("ISO_AGEING_ENTITY_SET_ATTRIBUTE");
	DescIdToCharTab.push_back("JULIAN_TIME_TO_ACHIEVE");
	DescIdToCharTab.push_back("LAI_FOR_MOWING");
	DescIdToCharTab.push_back("LAI_FOR_SENESCENCE");
	DescIdToCharTab.push_back("LAND_USE");
	DescIdToCharTab.push_back("LAST_OPERATIONS_MEMORY_ATTRIBUTE");
	DescIdToCharTab.push_back("LAST_RAINFALL_CLOCK");
	DescIdToCharTab.push_back("LAST_SEVEN_DAYS_RAINFALL");
	DescIdToCharTab.push_back("LAST_TILLAGE_OPERATION_CLOCK");
	DescIdToCharTab.push_back("LAST_WEATHER_PRINT_CLOCK");
	DescIdToCharTab.push_back("LATITUDE");
	DescIdToCharTab.push_back("LEAF_AREA_INDEX_RATE");
	DescIdToCharTab.push_back("LEAF_AREA_INDEX_RESIDUAL");
	DescIdToCharTab.push_back("LEAF_LIFE_SPAN_MIN");
	DescIdToCharTab.push_back("LONGITUDE");
	DescIdToCharTab.push_back("MAX_REPLICATION_NUMBER_IN_DRY_PERIOD");
	DescIdToCharTab.push_back("MEAN_PRIORITY_DEGREE");
	DescIdToCharTab.push_back("MEMBERSHIP_MODE");
	DescIdToCharTab.push_back("MIN_PERCENTAGE_TO_BEGIN_OPERATION");
	DescIdToCharTab.push_back("NEED_FOR_NEXT_FAVOURABLE_DAYS");
	DescIdToCharTab.push_back("NOMINAL_FLOAT_QUANTITY_SPEED");
	DescIdToCharTab.push_back("NOMINAL_INT_QUANTITY_SPEED");
	DescIdToCharTab.push_back("NUMBER_OF_TRACTORS");
	DescIdToCharTab.push_back("NUMBER_OF_WORKERS");
	DescIdToCharTab.push_back("OFF_WORK_CALENDAR_ATTRIBUTE");
	DescIdToCharTab.push_back("OPERATED_PLOTS_ATTRIBUTE");
	DescIdToCharTab.push_back("OPERATED_VINEYARD_SUB_AREA");
	DescIdToCharTab.push_back("OPERATION_PRIORITY_OPTION_SET_ATTRIBUTE");
	DescIdToCharTab.push_back("OPERATION_RECORDING_ATTRIBUTE");
	DescIdToCharTab.push_back("OPT_ACTUAL_DOWNY_MILDEW_RISK_THRESHOLD");
	DescIdToCharTab.push_back("OPT_AUTUMN_TILLAGE_C_P");
	DescIdToCharTab.push_back("OPT_AUTUMN_TILLAGE_O_P");
	DescIdToCharTab.push_back("OPT_CHEMICAL_WEEDING_O_P");
	DescIdToCharTab.push_back("OPT_CROP_ROW_ALLEY_WIDTH_RATIO");
	DescIdToCharTab.push_back("OPT_DEBRANCHING_MODALITY");
	DescIdToCharTab.push_back("OPT_DOWNY_MILDEW_AT_LEAST_CLOSING");
	DescIdToCharTab.push_back("OPT_DOWNY_MILDEW_MANAGEMENT");
	DescIdToCharTab.push_back("OPT_DOWNY_MILDEW_UNDER_PRESSURE_CLOSING");
	DescIdToCharTab.push_back("OPT_EXTRA_PHYTO_TREATMENTS_O_P");
	DescIdToCharTab.push_back("OPT_FERTILIZATION_O_P");
	DescIdToCharTab.push_back("OPT_FERTILIZATION_SEASON");
	DescIdToCharTab.push_back("OPT_FIRST_SPRING_TILLAGE_O_P");
	DescIdToCharTab.push_back("OPT_GRASS_STRIP_ALLEY_WIDTH_RATIO");
	DescIdToCharTab.push_back("OPT_INIT_SPRING_TILLAGE_O_P");
	DescIdToCharTab.push_back("OPT_PAST_DOWNY_MILDEW_PRESSURE_THRESHOLD");
	DescIdToCharTab.push_back("OPT_PHYTO_TREATMENT_CADENCE");
	DescIdToCharTab.push_back("OPT_PHYTO_TREATMENT_RAIN_ANTICIPATION");
	DescIdToCharTab.push_back("OPT_PLANTATION_O_P");
	DescIdToCharTab.push_back("OPT_POWDERY_MILDEW_CLOSING");
	DescIdToCharTab.push_back("OPT_POWDERY_MILDEW_MANAGEMENT");
	DescIdToCharTab.push_back("OPT_PRE_PRUNING_MODALITY");
	DescIdToCharTab.push_back("OPT_PRUNING_MIN_BEG_DATE");
	DescIdToCharTab.push_back("OPT_PRUNING_O_P");
	DescIdToCharTab.push_back("OPT_REGULAR_PHYTO_TREATMENTS_O_P");
	DescIdToCharTab.push_back("OPT_RIDING_ORIENTED_INTER_ROW_PROPORTION");
	DescIdToCharTab.push_back("OPT_SHOOT_THINNINGS_O_P");
	DescIdToCharTab.push_back("OPT_SPRAY_NUMBER_AT_BEGINNING");
	DescIdToCharTab.push_back("OPT_SPRAY_PATH_AT_BEGINNING");
	DescIdToCharTab.push_back("OPT_SPRAY_PATH_REGULAR");
	DescIdToCharTab.push_back("OPT_SPRAY_PATH_SINCE_FLOWERING");
	DescIdToCharTab.push_back("OPT_SPRAYER_TYPE_AT_BEGINNING");
	DescIdToCharTab.push_back("OPT_SPRAYER_TYPE_REGULAR");
	DescIdToCharTab.push_back("OPT_SPRING_CHEMICAL_WEEDING_O_P");
	DescIdToCharTab.push_back("OPT_SPRING_FERT_MAX_BEG_DATE");
	DescIdToCharTab.push_back("OPT_SPRING_FERT_MIN_BEG_DATE");
	DescIdToCharTab.push_back("OPT_SPRING_TILLAGES_ITERATION_C_P");
	DescIdToCharTab.push_back("OPT_SPRING_TILLAGES_O_P");
	DescIdToCharTab.push_back("OPT_SPRING_TILLAGES_O_P_SCOPE");
	DescIdToCharTab.push_back("PATH_NAME_ATTRIBUTE");
	DescIdToCharTab.push_back("PERCENT_ANTI_MILDEW_TREATED");
	DescIdToCharTab.push_back("PERCENT_AUTUMN_TILLED");
	DescIdToCharTab.push_back("PERCENT_CLIPPED");
	DescIdToCharTab.push_back("PERCENT_DEBRANCHED");
	DescIdToCharTab.push_back("PERCENT_EXTRA_PHYTO_TREATED");
	DescIdToCharTab.push_back("PERCENT_FERTILIZED");
	DescIdToCharTab.push_back("PERCENT_INIT_SPRING_TILLED");
	DescIdToCharTab.push_back("PERCENT_PLANTED");
	DescIdToCharTab.push_back("PERCENT_PRUNED");
	DescIdToCharTab.push_back("PERCENT_REGULAR_PHYTO_TREATED");
	DescIdToCharTab.push_back("PERCENT_SHOOT_THINNED");
	DescIdToCharTab.push_back("PERCENT_SPRING_TILLED");
	DescIdToCharTab.push_back("PERCENT_SPRING_WEEDED");
	DescIdToCharTab.push_back("PERCENT_TRELLISED");
	DescIdToCharTab.push_back("PERCENT_WEEDED");
	DescIdToCharTab.push_back("PERCENT_WINTER_TILLED");
	DescIdToCharTab.push_back("PEST_INFO_MEMORY_ATTRIBUTE");
	DescIdToCharTab.push_back("PESTICIDE_SUBTYPE");
	DescIdToCharTab.push_back("PESTICIDE_TYPE");
	DescIdToCharTab.push_back("PHYTO_MANAGEMENT");
	DescIdToCharTab.push_back("PHYTO_TREATMENT_LIST");
	DescIdToCharTab.push_back("PLACE_NAME");
	DescIdToCharTab.push_back("PLANT_ATTRIBUTE");
	DescIdToCharTab.push_back("PLANT_SPACING");
	DescIdToCharTab.push_back("PLOT_PATTERN");
	DescIdToCharTab.push_back("PLOT_PATTERN_OPTION_SET_ATTRIBUTE");
	DescIdToCharTab.push_back("PLOT_PROFILE");
	DescIdToCharTab.push_back("PLOT_PROFILE_OPERATOR");
	DescIdToCharTab.push_back("POWDERY_MILDEW_FLAG_SHOOT");
	DescIdToCharTab.push_back("POWDERY_MILDEW_LEVEL");
	DescIdToCharTab.push_back("POWDERY_MILDEW_MANAGEMENT_ATTRIBUTE");
	DescIdToCharTab.push_back("POWDERY_MILDEW_TO_CLOSE");
	DescIdToCharTab.push_back("PREVIOUS_REPLICATION_REF_DATE");
	DescIdToCharTab.push_back("PRUNING_MODE");
	DescIdToCharTab.push_back("PRUNINGS_MANAGEMENT");
	DescIdToCharTab.push_back("RAINFALL");
	DescIdToCharTab.push_back("RECORDED_ACTIVITY_CLASS_NAME");
	DescIdToCharTab.push_back("RECORDED_CHANTIER_CLASS_NAME");
	DescIdToCharTab.push_back("RECORDED_DAY");
	DescIdToCharTab.push_back("RECORDED_IN_DAY_DURATION");
	DescIdToCharTab.push_back("RECORDED_JULIAN_DAY");
	DescIdToCharTab.push_back("RECORDED_MONTH");
	DescIdToCharTab.push_back("RECORDED_OPERATION_CLASS_NAME");
	DescIdToCharTab.push_back("RECORDED_PERFORMER_LIST");
	DescIdToCharTab.push_back("RECORDED_PHYTO_PRODUCT_LIST");
	DescIdToCharTab.push_back("RECORDED_PLOT_NAME");
	DescIdToCharTab.push_back("RECORDED_RESOURCE_LIST");
	DescIdToCharTab.push_back("RECORDED_YEAR");
	DescIdToCharTab.push_back("REGULAR_PHYTO_TREATMENT_INDEX");
	DescIdToCharTab.push_back("RELATIVE_AREA");
	DescIdToCharTab.push_back("REPLICATION_IN_DRY_PERIOD_COUNTER");
	DescIdToCharTab.push_back("RIDING_ORIENTED_INTER_ROW_PROPORTION");
	DescIdToCharTab.push_back("ROW_MANAGEMENT");
	DescIdToCharTab.push_back("SEASONAL_EMPLOYMENT_PLAN_ATTRIBUTE");
	DescIdToCharTab.push_back("SHOOT_INTENSITY");
	DescIdToCharTab.push_back("SHOOT_THINNINGS_MANAGEMENT");
	DescIdToCharTab.push_back("SKIPPED_PLOTS_ATTRIBUTE");
	DescIdToCharTab.push_back("SOIL_HUMIDITY_VECTOR_FROM_MHYDAS");
	DescIdToCharTab.push_back("SOIL_MANAGEMENT_GROUP_NAME");
	DescIdToCharTab.push_back("SOIL_MANAGEMENT_GROUP_SET_NAME");
	DescIdToCharTab.push_back("SOIL_MANAGEMENT_MODALITY");
	DescIdToCharTab.push_back("SOIL_MANAGEMENT_OPTION");
	DescIdToCharTab.push_back("SOIL_TYPE");
	DescIdToCharTab.push_back("SPRING_CHEMICAL_WEEDINGS_MANAGEMENT");
	DescIdToCharTab.push_back("SPRING_TILLAGES_MANAGEMENT");
	DescIdToCharTab.push_back("STAGE_NAME");
	DescIdToCharTab.push_back("STAGE_TAB");
	DescIdToCharTab.push_back("STANDARD_VALUE_PRIORITY_TAB");
	DescIdToCharTab.push_back("STONINESS");
	DescIdToCharTab.push_back("TEMPERATURE");
	DescIdToCharTab.push_back("TERMINATED_PLOTS_ATTRIBUTE");
	DescIdToCharTab.push_back("THERMAL_TIME_FROM_BBK");
	DescIdToCharTab.push_back("THERMAL_TIME_FROM_BBK_TO_ACHIEVE");
	DescIdToCharTab.push_back("THERMAL_TIME_FROM_EMERGENCE");
	DescIdToCharTab.push_back("THERMAL_TIME_FROM_SOWING");
	DescIdToCharTab.push_back("THERMAL_TIME_TO_ACHIEVE");
	DescIdToCharTab.push_back("THERMAL_TIME_WHEN_ACHIEVED");
	DescIdToCharTab.push_back("TIMETABLE_ATTRIBUTE");
	DescIdToCharTab.push_back("TOOL_CLASS_NAME");
	DescIdToCharTab.push_back("TRELLIS_MODE");
	DescIdToCharTab.push_back("VILLAGE");
	DescIdToCharTab.push_back("VINEYARD_ATTRIBUTE");
	DescIdToCharTab.push_back("WEATHER_STATION_ATTRIBUTE");
	DescIdToCharTab.push_back("WEEK_DAY_NUMBER");
	DescIdToCharTab.push_back("WIDTH");
	DescIdToCharTab.push_back("WINTER_BEGINNING_CLOCK");
	DescIdToCharTab.push_back("WINTER_BEGINNING_CLOCK_FOR_INITST");
	DescIdToCharTab.push_back("WINTER_TILLAGES_MANAGEMENT");
	DescIdToCharTab.push_back("WORK_BEGINNING_HOUR");
	DescIdToCharTab.push_back("WORK_DAY_AFTERNOON_BEG_HOUR");
	DescIdToCharTab.push_back("WORK_DAY_AFTERNOON_END_HOUR");
	DescIdToCharTab.push_back("WORK_DAY_AFTERNOON_EXTENDED_END_HOUR");
	DescIdToCharTab.push_back("WORK_DAY_MORNING_BEG_HOUR");
	DescIdToCharTab.push_back("WORK_DAY_MORNING_END_HOUR");
	DescIdToCharTab.push_back("WORK_DAY_MORNING_EXTENDED_END_HOUR");
	DescIdToCharTab.push_back("WORK_ORGANIZATION_OPTION_SET_ATTRIBUTE");
	DescIdToCharTab.push_back("WORKING_TIME_DAILY_LEFT");
	DescIdToCharTab.push_back("WORKING_TIME_DAILY_UPPER_BOUND");
	DescIdToCharTab.push_back("WORKING_TIME_WEEKLY_LEFT");
	DescIdToCharTab.push_back("WORKING_TIME_WEEKLY_UPPER_BOUND");
	DescIdToCharTab.push_back("WORKING_TIME_YEARLY_LEFT");
	DescIdToCharTab.push_back("WORKING_TIME_YEARLY_UPPER_BOUND");
	DescIdToCharTab.push_back("YEAR_OF_PLANTATION");
	DescIdToCharTab.push_back("YEAR_WHEN_ACHIEVED");
	gDescIdToCharTabSize = DescIdToCharTab.size();
}


// -------------------------------------------
// passage symbole -> string  pour MethodId
// -------------------------------------------
void App_MakeMethodIdToCharTab() {
	for(int k=gMethodIdToCharTabSize;k<301;k++)
		MethodIdToCharTab.push_back("@");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_AUTUMN_TILLAGES");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_CHEMICAL_WEEDINGS");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_CLIPPINGS");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_DEBRANCHINGS");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_FERTILIZATIONS");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_INIT_SPRING_TILLAGES");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_PHYTO_TREATMENTS");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_PLANTATIONS");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_PRUNINGS");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_SHOOT_THINNINGS");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_SPRING_CHEMICAL_WEEDINGS");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_SPRING_TILLAGES");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_TRELLISINGS");
	MethodIdToCharTab.push_back("ADD_NEW_SITUATED_WINTER_TILLAGES");
	MethodIdToCharTab.push_back("ANTI_DOWNY_MILDEW_AT_LEAST_CLOSING_PREDICATE");
	MethodIdToCharTab.push_back("ANTI_DOWNY_MILDEW_UNDER_PRESSURE_CLOSING_PREDICATE");
	MethodIdToCharTab.push_back("ANTI_POWDERY_MILDEW_CLOSING_PREDICATE");
	MethodIdToCharTab.push_back("ASSIGN_RELATIVE_AREA_TO_ROWS");
	MethodIdToCharTab.push_back("ATTACH_FARM_WORKER_TO_TIMETABLES");
	MethodIdToCharTab.push_back("DUMP_OPERATION_RECORDS");
	MethodIdToCharTab.push_back("GET_ACTUAL_THERMAL_TIME_FROM_EMERGENCE");
	MethodIdToCharTab.push_back("GET_DAY_WHEN_STAGE_ACHIEVED");
	MethodIdToCharTab.push_back("GET_FIRST_WAVE_LIST");
	MethodIdToCharTab.push_back("GET_RANKED_WAVE_LIST");
	MethodIdToCharTab.push_back("IS_CLOCK_VALUE_IN_CALENDAR");
	MethodIdToCharTab.push_back("IS_CLOCK_VALUE_IN_PERIOD");
	MethodIdToCharTab.push_back("IS_MOTORIZATION_POSSIBLE");
	MethodIdToCharTab.push_back("OPERATION_NOMINAL_DURATION");
	MethodIdToCharTab.push_back("RETURN_EFFECTIVE_TEMPERATURE");
	MethodIdToCharTab.push_back("RETURN_PASSED_ROWS_FREQUENCY");
	MethodIdToCharTab.push_back("RETURN_PHYTO_TREATMENT_OPERATION_SUBCLASS");
	MethodIdToCharTab.push_back("RETURN_SHOOT_THINNING_OPERATION_SUBCLASS");
	MethodIdToCharTab.push_back("RETURN_SOIL_MANAGEMENT_GROUP_ON_PROFILE");
	MethodIdToCharTab.push_back("RETURN_TILLAGE_OPERATION_SUBCLASS");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_AUTUMN_TILL");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_CLIP");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_DEBRANCH");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_FERTILIZE");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_INIT_SPRING_TILL");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_PHYTO_PROTECT");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_PLANT");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_PRUNE");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_SHOOT_THIN");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_SPRING_TILL");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_SPRING_WEED");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_TRELLIS");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_WEED");
	MethodIdToCharTab.push_back("SELECT_NEW_PLOTS_TO_WINTER_TILL");
	MethodIdToCharTab.push_back("SET_DAY_WHEN_STAGE_ACHIEVED");
	MethodIdToCharTab.push_back("SET_FLAG_MILDEW");
	MethodIdToCharTab.push_back("SET_ROW_SOIL_MANAGEMENT");
	MethodIdToCharTab.push_back("SET_SCHEDULED_ANTI_MILDEW");
	MethodIdToCharTab.push_back("SUM_UP_GRASS_COVER_VECTOR");
	MethodIdToCharTab.push_back("SUM_UP_SOIL_HUMIDITY_VECTOR");
	MethodIdToCharTab.push_back("TIMETABLE_CLOSING_PREDICATE");
	MethodIdToCharTab.push_back("TIMETABLE_OPENING_PREDICATE");
	MethodIdToCharTab.push_back("UPDATE_OFF_PERIOD_CURRENT_INDEX");
	MethodIdToCharTab.push_back("UPDATE_SEASON_CURRENT_INDEX");
	gMethodIdToCharTabSize = MethodIdToCharTab.size();
}


// -------------------------------------------
// fonctions d'installation des classes
// -------------------------------------------
void App_InstallMetaClasses() {
	App_MakeClassIdToCharTab();
	App_MakeDescIdToCharTab();
	App_MakeMethodIdToCharTab();
	MetaClass* pMC;
	pMC = CreateMetaClass(AGRO_CLIMATIC_SYSTEM, "agroClimaticSystem");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(AIR_ASSISTED_SPRAYER, "airAssistedSprayer");
	pMC->SetParentClassId(SPRAYER);
	pMC = CreateMetaClass(AIR_ASSISTED_SPRAYING, "airAssistedSpraying");
	pMC->SetParentClassId(MOTORIZED_SPRAYING_OPERATION);
	pMC = CreateMetaClass(AIR_ASSISTED_SPRAYING_OPERATION_RESOURCE_SPEC, "airAssistedSprayingOperationResourceSpec");
	pMC->SetParentClassId(OPERATION_RESOURCE_SPECIFICATION);
	pMC = CreateMetaClass(AIR_ASSISTED_SPRAYING_RESOURCE_SET, "airAssistedSprayingResourceSet");
	pMC->SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE);
	pMC = CreateMetaClass(ALLOCATION_PRIORITY_OPTION_SET, "allocationPriorityOptionSet");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(ALLOCATION_PRIORITY_OPTION_SUBSET, "allocationPriorityOptionSubset");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(ANNUAL_EMPLOYMENT_PLAN, "annualEmploymentPlan");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(APRIL_EMPLOYMENT_PLAN, "aprilEmploymentPlan");
	pMC->SetParentClassId(SEASONAL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(APRIL_NORMAL_HOURS_EMPLOYMENT_PLAN, "aprilNormalHoursEmploymentPlan");
	pMC->SetParentClassId(APRIL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(APRIL_REDUCED_HOURS_EMPLOYMENT_PLAN, "aprilReducedHoursEmploymentPlan");
	pMC->SetParentClassId(APRIL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(AT_LEAST_ONE_PLOT, "atLeastOnePlot");
	pMC->SetParentClassId(OCCURRENCE_DOMAIN);
	pMC = CreateMetaClass(AUTUMN_TILLAGE_ACTIVITY, "autumnTillageActivity");
	pMC->SetParentClassId(TILLAGE_ACTIVITY);
	pMC = CreateMetaClass(BACK_SPRAYER, "backSprayer");
	pMC->SetParentClassId(SPRAYER);
	pMC = CreateMetaClass(BACK_SPRAYING_OPERATION, "backSprayingOperation");
	pMC->SetParentClassId(MANUAL_OPERATION);
	pMC = CreateMetaClass(CHEMICAL_DEBRANCHER_OPERATED_SPRAYING, "chemicalDebrancherOperatedSpraying");
	pMC->SetParentClassId(MOTORIZED_SPRAYING_OPERATION);
	pMC = CreateMetaClass(CHEMICAL_DEBRANCHER_SPRAYING_OPERATION_RESOURCE_SPEC, "chemicalDebrancherSprayingOperationResourceSpec");
	pMC->SetParentClassId(OPERATION_RESOURCE_SPECIFICATION);
	pMC = CreateMetaClass(CHEMICAL_DEBRANCHER_SPRAYING_RESOURCE_SET, "chemicalDebrancherSprayingResourceSet");
	pMC->SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE);
	pMC = CreateMetaClass(CHEMICAL_WEEDING_ACTIVITY, "chemicalWeedingActivity");
	pMC->SetParentClassId(VINEYARD_ACTIVITY);
	pMC = CreateMetaClass(CLIPPER, "clipper");
	pMC->SetParentClassId(FARM_EQUIPMENT);
	pMC = CreateMetaClass(CLIPPING_ACTIVITY, "clippingActivity");
	pMC->SetParentClassId(VINEYARD_ACTIVITY);
	pMC = CreateMetaClass(CLIPPING_OPERATION, "clippingOperation");
	pMC->SetParentClassId(MOTORIZED_OPERATION);
	pMC = CreateMetaClass(CLIPPING_OPERATION_RESOURCE_SPEC, "clippingOperationResourceSpec");
	pMC->SetParentClassId(OPERATION_RESOURCE_SPECIFICATION);
	pMC = CreateMetaClass(CLIPPING_RESOURCE_SET, "clippingResourceSet");
	pMC->SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE);
	pMC = CreateMetaClass(COLLECTOR_PANE, "collectorPane");
	pMC->SetParentClassId(FARM_EQUIPMENT);
	pMC = CreateMetaClass(CONCURRENT_ANTI_MILDEW_TREATMENTS, "concurrentAntiMildewTreatments");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_AUTUMN_TILLAGES, "concurrentAutumnTillages");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_CHEMICAL_WEEDINGS, "concurrentChemicalWeedings");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_CLIPPINGS, "concurrentClippings");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_CLIPPINGS_ITERATION, "concurrentClippingsIteration");
	pMC->SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION);
	pMC = CreateMetaClass(CONCURRENT_DEBRANCHINGS, "concurrentDebranchings");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_DISTRIBUTED_ACTIVITY_SET, "concurrentDistributedActivitySet");
	pMC->SetParentClassId(ACTIVITY_CONJUNCTION);
	pMC = CreateMetaClass(CONCURRENT_EXTRA_PHYTO_TREATMENTS, "concurrentExtraPhytoTreatments");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_FERTILIZATIONS, "concurrentFertilizations");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_INIT_SPRING_TILLAGES, "concurrentInitSpringTillages");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_PRUNINGS, "concurrentPrunings");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_REGULAR_PHYTO_TREATMENTS, "concurrentRegularPhytoTreatments");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_SHOOT_THINNINGS, "concurrentShootThinnings");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_SPRING_CHEMICAL_WEEDINGS, "concurrentSpringChemicalWeedings");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_SPRING_TILLAGES, "concurrentSpringTillages");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_TRELLISINGS, "concurrentTrellisings");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONCURRENT_WINTER_TILLAGES, "concurrentWinterTillages");
	pMC->SetParentClassId(CONCURRENT_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(CONDUITE1, "conduite1");
	pMC->SetParentClassId(VINEYARD_CONTROL_SEQUENCE);
	pMC = CreateMetaClass(CONDUITE2, "conduite2");
	pMC->SetParentClassId(VINEYARD_CONTROL_SEQUENCE);
	pMC = CreateMetaClass(CONDUITE3, "conduite3");
	pMC->SetParentClassId(VINEYARD_CONTROL_SEQUENCE);
	pMC = CreateMetaClass(CONDUITE4, "conduite4");
	pMC->SetParentClassId(VINEYARD_CONTROL_SEQUENCE);
	pMC = CreateMetaClass(CONDUITE5, "conduite5");
	pMC->SetParentClassId(VINEYARD_CONTROL_SEQUENCE);
	pMC = CreateMetaClass(CROP_ROW, "cropRow");
	pMC->SetParentClassId(ROW);
	pMC = CreateMetaClass(CULTURAL_OPERATIONS_DATA_ITEM, "culturalOperationsDataItem");
	pMC->SetParentClassId(DHIVINE_VALUATED_DATA_ITEM);
	pMC = CreateMetaClass(DEBRANCHING_ACTIVITY, "debranchingActivity");
	pMC->SetParentClassId(VINEYARD_ACTIVITY);
	pMC = CreateMetaClass(DEBRANCHING_SPRAYER, "debranchingSprayer");
	pMC->SetParentClassId(SPRAYER);
	pMC = CreateMetaClass(DECISION_OPTION_SET, "decisionOptionSet");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(DHIVINE_VALUATED_DATA_ITEM, "dhivineValuatedDataItem");
	pMC->SetParentClassId(INTERFACE_DATA_ITEM);
	pMC = CreateMetaClass(DISTRIBUTED_ACTIVITY_SET_ITERATION, "distributedActivitySetIteration");
	pMC->SetParentClassId(ACTIVITY_ITERATION);
	pMC = CreateMetaClass(DISTRIBUTED_ACTIVITY_SET_MEMORY_ITEM, "distributedActivitySetMemoryItem");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(EQUIPMENT_MULTI_LOCALIZATION, "equipmentMultiLocalization");
	pMC->SetParentClassId(RESOURCE_SHARING_VIOLATION_CONDITION);
	pMC = CreateMetaClass(EQUIPMENT_UBIQUITY_CONDITION, "equipmentUbiquityCondition");
	pMC->SetParentClassId(OCCURRENCE_CROSS_DOMAIN);
	pMC = CreateMetaClass(EXTRA_PHYTO_TREATMENTS_ITERATION, "extraPhytoTreatmentsIteration");
	pMC->SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION);
	pMC = CreateMetaClass(FARM_EQUIPMENT, "farmEquipment");
	pMC->SetParentClassId(SINGLE_TOOL);
	pMC = CreateMetaClass(FARM_WORKER, "farmWorker");
	pMC->SetParentClassId(SINGLE_WORKER);
	pMC = CreateMetaClass(FARM_WORKER_AVAILABILITY_TIMETABLE, "farmWorkerAvailabilityTimetable");
	pMC->SetParentClassId(RECURRENT_AVAILABILITY_TIMETABLE);
	pMC = CreateMetaClass(FARM_WORKER_MULTI_LOCALIZATION, "farmWorkerMultiLocalization");
	pMC->SetParentClassId(RESOURCE_SHARING_VIOLATION_CONDITION);
	pMC = CreateMetaClass(FARM_WORKER_MULTI_OCCUPATION, "farmWorkerMultiOccupation");
	pMC->SetParentClassId(RESOURCE_SHARING_VIOLATION_CONDITION);
	pMC = CreateMetaClass(FARM_WORKER_MULTI_OCCUPIED, "farmWorkerMultiOccupied");
	pMC->SetParentClassId(OCCURRENCE_CROSS_DOMAIN);
	pMC = CreateMetaClass(FARM_WORKER_UBIQUITY_CONDITION, "farmWorkerUbiquityCondition");
	pMC->SetParentClassId(OCCURRENCE_CROSS_DOMAIN);
	pMC = CreateMetaClass(FEBRUARY_MARCH_EMPLOYMENT_PLAN, "februaryMarchEmploymentPlan");
	pMC->SetParentClassId(SEASONAL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(FEBRUARY_MARCH_NORMAL_HOURS_EMPLOYMENT_PLAN, "februaryMarchNormalHoursEmploymentPlan");
	pMC->SetParentClassId(FEBRUARY_MARCH_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(FEBRUARY_MARCH_REDUCED_HOURS_EMPLOYMENT_PLAN, "februaryMarchReducedHoursEmploymentPlan");
	pMC->SetParentClassId(FEBRUARY_MARCH_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(FERTILIZATION_ACTIVITY, "fertilizationActivity");
	pMC->SetParentClassId(VINEYARD_ACTIVITY);
	pMC = CreateMetaClass(FERTILIZATION_OPERATION, "fertilizationOperation");
	pMC->SetParentClassId(MOTORIZED_OPERATION);
	pMC = CreateMetaClass(FERTILIZATION_OPERATION_RESOURCE_SPEC, "fertilizationOperationResourceSpec");
	pMC->SetParentClassId(OPERATION_RESOURCE_SPECIFICATION);
	pMC = CreateMetaClass(FERTILIZATION_RESOURCE_SET, "fertilizationResourceSet");
	pMC->SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE);
	pMC = CreateMetaClass(FORMATION_PRUNING_ACTIVITY, "formationPruningActivity");
	pMC->SetParentClassId(PRUNING_ACTIVITY);
	pMC = CreateMetaClass(GOBELET_PRUNING_ACTIVITY, "gobeletPruningActivity");
	pMC->SetParentClassId(PRUNING_ACTIVITY);
	pMC = CreateMetaClass(GRAPE_VARIETY, "grapeVariety");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(GRAPEVINE, "grapevine");
	pMC->SetParentClassId(VEGETATION);
	pMC = CreateMetaClass(GRAPEVINE_AGE, "grapevineAge");
	pMC->SetParentClassId(PLANT_AGE);
	pMC = CreateMetaClass(GRASS, "grass");
	pMC->SetParentClassId(VEGETATION);
	pMC = CreateMetaClass(GRASS_AGE, "grassAge");
	pMC->SetParentClassId(PLANT_AGE);
	pMC = CreateMetaClass(GRASS_COVER_VECTOR_DATA_ITEM, "grassCoverVectorDataItem");
	pMC->SetParentClassId(MHYDAS_VALUATED_DATA_ITEM);
	pMC = CreateMetaClass(GRASS_TYPE, "grassType");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(GRINDER, "grinder");
	pMC->SetParentClassId(FARM_EQUIPMENT);
	pMC = CreateMetaClass(GRINDER_OPERATED_SHOOT_THINNING, "grinderOperatedShootThinning");
	pMC->SetParentClassId(SHOOT_THINNING_OPERATION);
	pMC = CreateMetaClass(GRINDER_SHOOT_THINNING_OPERATION_RESOURCE_SPEC, "grinderShootThinningOperationResourceSpec");
	pMC->SetParentClassId(OPERATION_RESOURCE_SPECIFICATION);
	pMC = CreateMetaClass(GRINDER_SHOOT_THINNING_RESOURCE_SET, "grinderShootThinningResourceSet");
	pMC->SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE);
	pMC = CreateMetaClass(GUYOT_PRUNING_ACTIVITY, "guyotPruningActivity");
	pMC->SetParentClassId(PRUNING_ACTIVITY);
	pMC = CreateMetaClass(HAND_HELD_GUN_OPERATED_SPRAYING, "handHeldGunOperatedSpraying");
	pMC->SetParentClassId(MOTORIZED_SPRAYING_OPERATION);
	pMC = CreateMetaClass(HAND_HELD_GUN_SPRAYING_OPERATION_RESOURCE_SPEC, "handHeldGunSprayingOperationResourceSpec");
	pMC->SetParentClassId(OPERATION_RESOURCE_SPECIFICATION);
	pMC = CreateMetaClass(HAND_HELD_GUN_SPRAYING_RESOURCE_SET, "handHeldGunSprayingResourceSet");
	pMC->SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE);
	pMC = CreateMetaClass(HAND_HELD_SPRAY_GUN, "handHeldSprayGun");
	pMC->SetParentClassId(SPRAYER);
	pMC = CreateMetaClass(HORIZONTAL_RAIL_OPERATED_SPRAYING, "horizontalRailOperatedSpraying");
	pMC->SetParentClassId(MOTORIZED_SPRAYING_OPERATION);
	pMC = CreateMetaClass(HORIZONTAL_RAIL_SPRAYER, "horizontalRailSprayer");
	pMC->SetParentClassId(SPRAYER);
	pMC = CreateMetaClass(HORIZONTAL_RAIL_SPRAYING_OPERATION_RESOURCE_SPEC, "horizontalRailSprayingOperationResourceSpec");
	pMC->SetParentClassId(OPERATION_RESOURCE_SPECIFICATION);
	pMC = CreateMetaClass(HORIZONTAL_RAIL_SPRAYING_RESOURCE_SET, "horizontalRailSprayingResourceSet");
	pMC->SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE);
	pMC = CreateMetaClass(INIT_SPRING_TILLAGE_ACTIVITY, "initSpringTillageActivity");
	pMC->SetParentClassId(TILLAGE_ACTIVITY);
	pMC = CreateMetaClass(INTER_ROW, "interRow");
	pMC->SetParentClassId(ROW);
	pMC = CreateMetaClass(ISO_AGEING_ENTITY, "isoAgeingEntity");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(LAST_OPERATIONS_MEMORY, "lastOperationsMemory");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(LAST_OPERATIONS_MEMORY_ITEM, "lastOperationsMemoryItem");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(LAST_PESTICIDE_APPLICATIONS_MEMORY_ITEM, "lastPesticideApplicationsMemoryItem");
	pMC->SetParentClassId(LAST_OPERATIONS_MEMORY_ITEM);
	pMC = CreateMetaClass(LAST_TILLAGE_OPERATIONS_MEMORY_ITEM, "lastTillageOperationsMemoryItem");
	pMC->SetParentClassId(LAST_OPERATIONS_MEMORY_ITEM);
	pMC = CreateMetaClass(LOW_CUMULATIVE_RAIN_SUFFERED, "lowCumulativeRainSuffered");
	pMC->SetParentClassId(STATE_AVAILABILITY_CONSTRAINT);
	pMC = CreateMetaClass(MANAGER_ANNUAL_EMPLOYMENT_PLAN, "managerAnnualEmploymentPlan");
	pMC->SetParentClassId(ANNUAL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(MANUAL_CHEMICAL_DEBRANCHING_ACTIVITY, "manualChemicalDebranchingActivity");
	pMC->SetParentClassId(DEBRANCHING_ACTIVITY);
	pMC = CreateMetaClass(MANUAL_CHEMICAL_WEEDING_ACTIVITY, "manualChemicalWeedingActivity");
	pMC->SetParentClassId(CHEMICAL_WEEDING_ACTIVITY);
	pMC = CreateMetaClass(MANUAL_DEBRANCHING_OPERATION, "manualDebranchingOperation");
	pMC->SetParentClassId(MANUAL_OPERATION);
	pMC = CreateMetaClass(MANUAL_MECHANICAL_DEBRANCHING_ACTIVITY, "manualMechanicalDebranchingActivity");
	pMC->SetParentClassId(DEBRANCHING_ACTIVITY);
	pMC = CreateMetaClass(MANUAL_OPERATION, "manualOperation");
	pMC->SetParentClassId(MY_FLOAT_AREA_OPERATION);
	pMC = CreateMetaClass(MANUAL_PHYTO_TREATMENT_ACTIVITY, "manualPhytoTreatmentActivity");
	pMC->SetParentClassId(PHYTO_TREATMENT_ACTIVITY);
	pMC = CreateMetaClass(MAY_AUGUST_EMPLOYMENT_PLAN, "mayAugustEmploymentPlan");
	pMC->SetParentClassId(SEASONAL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(MAY_AUGUST_EXTENDED_HOURS_EMPLOYMENT_PLAN, "mayAugustExtendedHoursEmploymentPlan");
	pMC->SetParentClassId(MAY_AUGUST_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(MAY_AUGUST_NORMAL_HOURS_EMPLOYMENT_PLAN, "mayAugustNormalHoursEmploymentPlan");
	pMC->SetParentClassId(MAY_AUGUST_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(MAY_AUGUST_REDUCED_HOURS_EMPLOYMENT_PLAN, "mayAugustReducedHoursEmploymentPlan");
	pMC->SetParentClassId(MAY_AUGUST_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(MHYDAS_VALUATED_DATA_ITEM, "mhydasValuatedDataItem");
	pMC->SetParentClassId(INTERFACE_DATA_ITEM);
	pMC = CreateMetaClass(MORE_THAN_ONE_PLOT, "moreThanOnePlot");
	pMC->SetParentClassId(OCCURRENCE_DOMAIN);
	pMC = CreateMetaClass(MORE_THAN_ONE_TASK, "moreThanOneTask");
	pMC->SetParentClassId(OCCURRENCE_DOMAIN);
	pMC = CreateMetaClass(MOTORIZED_CHEMICAL_DEBRANCHING_ACTIVITY, "motorizedChemicalDebranchingActivity");
	pMC->SetParentClassId(DEBRANCHING_ACTIVITY);
	pMC = CreateMetaClass(MOTORIZED_CHEMICAL_WEEDING_ACTIVITY, "motorizedChemicalWeedingActivity");
	pMC->SetParentClassId(CHEMICAL_WEEDING_ACTIVITY);
	pMC = CreateMetaClass(MOTORIZED_OPERATION, "motorizedOperation");
	pMC->SetParentClassId(MY_FLOAT_AREA_OPERATION);
	pMC = CreateMetaClass(MOTORIZED_PHYTO_TREATMENT_ACTIVITY, "motorizedPhytoTreatmentActivity");
	pMC->SetParentClassId(PHYTO_TREATMENT_ACTIVITY);
	pMC = CreateMetaClass(MOTORIZED_SPRAYING_OPERATION, "motorizedSprayingOperation");
	pMC->SetParentClassId(MOTORIZED_OPERATION);
	pMC = CreateMetaClass(MY_FLOAT_AREA_OPERATION, "myFloatAreaOperation");
	pMC->SetParentClassId(FLOAT_QUANTITY_GRANULATED_OPERATION);
	pMC = CreateMetaClass(NEUTRAL_INCONSISTENCY_CONDITION, "neutralInconsistencyCondition");
	pMC->SetParentClassId(OCCURRENCE_CROSS_DOMAIN);
	pMC = CreateMetaClass(NON_PERMANENT_FARM_WORKER, "nonPermanentFarmWorker");
	pMC->SetParentClassId(FARM_WORKER);
	pMC = CreateMetaClass(NON_PERMANENT_MANUAL_FARM_WORKER, "nonPermanentManualFarmWorker");
	pMC->SetParentClassId(NON_PERMANENT_FARM_WORKER);
	pMC = CreateMetaClass(NON_PERMANENT_TRACTOR_DRIVER, "nonPermanentTractorDriver");
	pMC->SetParentClassId(NON_PERMANENT_FARM_WORKER);
	pMC = CreateMetaClass(NOVEMBER_JANUARY_EMPLOYMENT_PLAN, "novemberJanuaryEmploymentPlan");
	pMC->SetParentClassId(SEASONAL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(NOVEMBER_JANUARY_NORMAL_HOURS_EMPLOYMENT_PLAN, "novemberJanuaryNormalHoursEmploymentPlan");
	pMC->SetParentClassId(NOVEMBER_JANUARY_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(NOVEMBER_JANUARY_REDUCED_HOURS_EMPLOYMENT_PLAN, "novemberJanuaryReducedHoursEmploymentPlan");
	pMC->SetParentClassId(NOVEMBER_JANUARY_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(OFF_WORK_CALENDAR, "offWorkCalendar");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(OFF_WORK_SINGLE_PERIOD, "offWorkSinglePeriod");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(ONLY_PHYTO_TREATMENTS_AT_EARLY_MORNING, "onlyPhytoTreatmentsAtEarlyMorning");
	pMC->SetParentClassId(ACTIVITY_INCONSISTENCY_CONDITION);
	pMC = CreateMetaClass(OPERATION_PRIORITY_OPTION_SET, "operationPriorityOptionSet");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(OPERATION_PRIORITY_OPTION_SUBSET, "operationPriorityOptionSubset");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(OPERATION_RECORDING_ITEM, "operationRecordingItem");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(OPERATION_RECORDING_STRUCTURE, "operationRecordingStructure");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(PERMANENT_ALL_TASK_TRACTOR_DRIVER, "permanentAllTaskTractorDriver");
	pMC->SetParentClassId(PERMANENT_MULTI_TASK_WORKER);
	pMC = CreateMetaClass(PERMANENT_FARM_WORKER, "permanentFarmWorker");
	pMC->SetParentClassId(FARM_WORKER);
	pMC = CreateMetaClass(PERMANENT_FARM_WORKER_FIVE_DAY_TIMETABLE, "permanentFarmWorkerFiveDayTimetable");
	pMC->SetParentClassId(FARM_WORKER_AVAILABILITY_TIMETABLE);
	pMC = CreateMetaClass(PERMANENT_FARM_WORKER_SEVEN_DAY_TIMETABLE, "permanentFarmWorkerSevenDayTimetable");
	pMC->SetParentClassId(FARM_WORKER_AVAILABILITY_TIMETABLE);
	pMC = CreateMetaClass(PERMANENT_FARM_WORKER_SIX_DAY_TIMETABLE, "permanentFarmWorkerSixDayTimetable");
	pMC->SetParentClassId(FARM_WORKER_AVAILABILITY_TIMETABLE);
	pMC = CreateMetaClass(PERMANENT_MANUAL_FARM_WORKER, "permanentManualFarmWorker");
	pMC->SetParentClassId(PERMANENT_FARM_WORKER);
	pMC = CreateMetaClass(PERMANENT_MULTI_TASK_MANUAL_WORKER, "permanentMultiTaskManualWorker");
	pMC->SetParentClassId(PERMANENT_MANUAL_FARM_WORKER);
	pMC = CreateMetaClass(PERMANENT_MULTI_TASK_WORKER, "permanentMultiTaskWorker");
	pMC->SetParentClassId(PERMANENT_FARM_WORKER);
	pMC = CreateMetaClass(PERMANENT_PREFERENTIAL_TRACTOR_DRIVER, "permanentPreferentialTractorDriver");
	pMC->SetParentClassId(PERMANENT_MULTI_TASK_WORKER);
	pMC = CreateMetaClass(PERMANENT_PRUNER, "permanentPruner");
	pMC->SetParentClassId(PERMANENT_MANUAL_FARM_WORKER);
	pMC = CreateMetaClass(PERMANENT_TILLAGE_ORIENTED_TRACTOR_DRIVER, "permanentTillageOrientedTractorDriver");
	pMC->SetParentClassId(PERMANENT_MULTI_TASK_WORKER);
	pMC = CreateMetaClass(PERMANENT_TILLAGE_TRACTOR_DRIVER, "permanentTillageTractorDriver");
	pMC->SetParentClassId(PERMANENT_TRACTOR_DRIVER);
	pMC = CreateMetaClass(PERMANENT_TRACTOR_DRIVER, "permanentTractorDriver");
	pMC->SetParentClassId(PERMANENT_FARM_WORKER);
	pMC = CreateMetaClass(PERMANENT_VEGETATION_GROWER, "permanentVegetationGrower");
	pMC->SetParentClassId(PERMANENT_MANUAL_FARM_WORKER);
	pMC = CreateMetaClass(PEST_INFO_MEMORY, "pestInfoMemory");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(PEST_INFO_MEMORY_ITEM, "pestInfoMemoryItem");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(PHENO_STAGE, "phenoStage");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(PHYTO_TREATMENT_ACTIVITY, "phytoTreatmentActivity");
	pMC->SetParentClassId(VINEYARD_ACTIVITY);
	pMC = CreateMetaClass(PHYTO_TREATMENT_COMPOSED_PROGRAM, "phytoTreatmentComposedProgram");
	pMC->SetParentClassId(ACTIVITY_CONJUNCTION);
	pMC = CreateMetaClass(PLANT_AGE, "plantAge");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(PLANTATION_ACTIVITY, "plantationActivity");
	pMC->SetParentClassId(VINEYARD_ACTIVITY);
	pMC = CreateMetaClass(PLANTATION_OPERATION, "plantationOperation");
	pMC->SetParentClassId(MANUAL_OPERATION);
	pMC = CreateMetaClass(PLOT, "plot");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(PLOT_INTERNAL_PATTERN_OPTION_SET, "plotInternalPatternOptionSet");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(PLOT_INTERNAL_PATTERN_OPTION_SUBSET, "plotInternalPatternOptionSubset");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(PLOT_WITH_SEVERAL_OPERATIONS, "plotWithSeveralOperations");
	pMC->SetParentClassId(ACTIVITIES_RESOURCES_INCONSISTENT_COMMITMENT);
	pMC = CreateMetaClass(PRUNING_ACTIVITY, "pruningActivity");
	pMC->SetParentClassId(VINEYARD_ACTIVITY);
	pMC = CreateMetaClass(PRUNING_MACHINE, "pruningMachine");
	pMC->SetParentClassId(FARM_EQUIPMENT);
	pMC = CreateMetaClass(PRUNING_OPERATION, "pruningOperation");
	pMC->SetParentClassId(MANUAL_OPERATION);
	pMC = CreateMetaClass(REGULAR_PHYTO_TREATMENTS_ITERATION, "regularPhytoTreatmentsIteration");
	pMC->SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION);
	pMC = CreateMetaClass(RELATIVE_AREA_DATA_ITEM, "relativeAreaDataItem");
	pMC->SetParentClassId(DHIVINE_VALUATED_DATA_ITEM);
	pMC = CreateMetaClass(RETIRED_WORKER_ANNUAL_EMPLOYMENT_PLAN, "retiredWorkerAnnualEmploymentPlan");
	pMC->SetParentClassId(ANNUAL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(ROTARY_CULTIVATOR, "rotaryCultivator");
	pMC->SetParentClassId(TILLAGE_TOOL);
	pMC = CreateMetaClass(ROTARY_OPERATED_SHOOT_THINNING, "rotaryOperatedShootThinning");
	pMC->SetParentClassId(SHOOT_THINNING_OPERATION);
	pMC = CreateMetaClass(ROTARY_OPERATED_TILLAGE, "rotaryOperatedTillage");
	pMC->SetParentClassId(TILLAGE_OPERATION);
	pMC = CreateMetaClass(ROTARY_TILLAGE_OPERATION_RESOURCE_SPEC, "rotaryTillageOperationResourceSpec");
	pMC->SetParentClassId(OPERATION_RESOURCE_SPECIFICATION);
	pMC = CreateMetaClass(ROTARY_TILLAGE_RESOURCE_SET, "rotaryTillageResourceSet");
	pMC->SetParentClassId(TILLAGE_RESOURCE_SET);
	pMC = CreateMetaClass(ROW, "row");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(ROYAT_PRUNING_ACTIVITY, "royatPruningActivity");
	pMC->SetParentClassId(PRUNING_ACTIVITY);
	pMC = CreateMetaClass(SEASONAL_EMPLOYMENT_PLAN, "seasonalEmploymentPlan");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(SEPTEMBER_OCTOBER_EMPLOYMENT_PLAN, "septemberOctoberEmploymentPlan");
	pMC->SetParentClassId(SEASONAL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(SEPTEMBER_OCTOBER_NORMAL_HOURS_EMPLOYMENT_PLAN, "septemberOctoberNormalHoursEmploymentPlan");
	pMC->SetParentClassId(SEPTEMBER_OCTOBER_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(SEPTEMBER_OCTOBER_REDUCED_HOURS_EMPLOYMENT_PLAN, "septemberOctoberReducedHoursEmploymentPlan");
	pMC->SetParentClassId(SEPTEMBER_OCTOBER_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(SERIAL_ANTI_MILDEW_TREATMENTS, "serialAntiMildewTreatments");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_AUTUMN_TILLAGES, "serialAutumnTillages");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_CHEMICAL_WEEDINGS, "serialChemicalWeedings");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_CLIPPINGS, "serialClippings");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_CLIPPINGS_ITERATION, "serialClippingsIteration");
	pMC->SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION);
	pMC = CreateMetaClass(SERIAL_DEBRANCHINGS, "serialDebranchings");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_DISTRIBUTED_ACTIVITY_SET, "serialDistributedActivitySet");
	pMC->SetParentClassId(ACTIVITY_MEETING_ANY);
	pMC = CreateMetaClass(SERIAL_EXTRA_PHYTO_TREATMENTS, "serialExtraPhytoTreatments");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_FERTILIZATIONS, "serialFertilizations");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_INIT_SPRING_TILLAGES, "serialInitSpringTillages");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_MANUAL_CHEMICAL_WEEDINGS, "serialManualChemicalWeedings");
	pMC->SetParentClassId(SERIAL_CHEMICAL_WEEDINGS);
	pMC = CreateMetaClass(SERIAL_MANUAL_DEBRANCHINGS, "serialManualDebranchings");
	pMC->SetParentClassId(SERIAL_DEBRANCHINGS);
	pMC = CreateMetaClass(SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS, "serialManualRegularPhytoTreatments");
	pMC->SetParentClassId(SERIAL_REGULAR_PHYTO_TREATMENTS);
	pMC = CreateMetaClass(SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS, "serialManualSpringChemicalWeedings");
	pMC->SetParentClassId(SERIAL_SPRING_CHEMICAL_WEEDINGS);
	pMC = CreateMetaClass(SERIAL_MOTORIZED_CHEMICAL_WEEDINGS, "serialMotorizedChemicalWeedings");
	pMC->SetParentClassId(SERIAL_CHEMICAL_WEEDINGS);
	pMC = CreateMetaClass(SERIAL_MOTORIZED_DEBRANCHINGS, "serialMotorizedDebranchings");
	pMC->SetParentClassId(SERIAL_DEBRANCHINGS);
	pMC = CreateMetaClass(SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS, "serialMotorizedRegularPhytoTreatments");
	pMC->SetParentClassId(SERIAL_REGULAR_PHYTO_TREATMENTS);
	pMC = CreateMetaClass(SERIAL_MOTORIZED_SPRING_CHEMICAL_WEEDINGS, "serialMotorizedSpringChemicalWeedings");
	pMC->SetParentClassId(SERIAL_SPRING_CHEMICAL_WEEDINGS);
	pMC = CreateMetaClass(SERIAL_PLANTATIONS, "serialPlantations");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_PRUNINGS, "serialPrunings");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_REGULAR_PHYTO_TREATMENTS, "serialRegularPhytoTreatments");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_SHOOT_THINNINGS, "serialShootThinnings");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_SPRING_CHEMICAL_WEEDINGS, "serialSpringChemicalWeedings");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_SPRING_TILLAGES, "serialSpringTillages");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_TRELLISINGS, "serialTrellisings");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SERIAL_TRELLISINGS_ITERATION, "serialTrellisingsIteration");
	pMC->SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION);
	pMC = CreateMetaClass(SERIAL_WINTER_TILLAGES, "serialWinterTillages");
	pMC->SetParentClassId(SERIAL_DISTRIBUTED_ACTIVITY_SET);
	pMC = CreateMetaClass(SHOOT_THINNING_ACTIVITY, "shootThinningActivity");
	pMC->SetParentClassId(VINEYARD_ACTIVITY);
	pMC = CreateMetaClass(SHOOT_THINNING_OPERATION, "shootThinningOperation");
	pMC->SetParentClassId(MOTORIZED_OPERATION);
	pMC = CreateMetaClass(SOIL_HUMIDITY_VECTOR_DATA_ITEM, "soilHumidityVectorDataItem");
	pMC->SetParentClassId(MHYDAS_VALUATED_DATA_ITEM);
	pMC = CreateMetaClass(SOIL_MANAGEMENT_DATA_ITEM, "soilManagementDataItem");
	pMC->SetParentClassId(DHIVINE_VALUATED_DATA_ITEM);
	pMC = CreateMetaClass(SOIL_MANAGEMENT_GROUP, "soilManagementGroup");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(SOIL_MANAGEMENT_GROUP_SET, "soilManagementGroupSet");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(SOIL_RESERVOIR, "soilReservoir");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(SOIL_SURFACE, "soilSurface");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(SPECIAL_WORKER_ANNUAL_EMPLOYMENT_PLAN, "specialWorkerAnnualEmploymentPlan");
	pMC->SetParentClassId(ANNUAL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(SPRAYER, "sprayer");
	pMC->SetParentClassId(FARM_EQUIPMENT);
	pMC = CreateMetaClass(SPREADER, "spreader");
	pMC->SetParentClassId(FARM_EQUIPMENT);
	pMC = CreateMetaClass(SPRING_TILLAGE_ACTIVITY, "springTillageActivity");
	pMC->SetParentClassId(TILLAGE_ACTIVITY);
	pMC = CreateMetaClass(SPRING_TILLAGES_ITERATION, "springTillagesIteration");
	pMC->SetParentClassId(DISTRIBUTED_ACTIVITY_SET_ITERATION);
	pMC = CreateMetaClass(SPRING_TINE_CULTIVATOR, "springTineCultivator");
	pMC->SetParentClassId(TILLAGE_TOOL);
	pMC = CreateMetaClass(SPRING_TINE_OPERATED_TILLAGE, "springTineOperatedTillage");
	pMC->SetParentClassId(TILLAGE_OPERATION);
	pMC = CreateMetaClass(SPRING_TINE_TILLAGE_OPERATION_RESOURCE_SPEC, "springTineTillageOperationResourceSpec");
	pMC->SetParentClassId(OPERATION_RESOURCE_SPECIFICATION);
	pMC = CreateMetaClass(SPRING_TINE_TILLAGE_RESOURCE_SET, "springTineTillageResourceSet");
	pMC->SetParentClassId(TILLAGE_RESOURCE_SET);
	pMC = CreateMetaClass(STANDARD_WORKER_ANNUAL_EMPLOYMENT_PLAN, "standardWorkerAnnualEmploymentPlan");
	pMC->SetParentClassId(ANNUAL_EMPLOYMENT_PLAN);
	pMC = CreateMetaClass(TANK, "tank");
	pMC->SetParentClassId(FARM_EQUIPMENT);
	pMC = CreateMetaClass(TILLAGE_ACTIVITY, "tillageActivity");
	pMC->SetParentClassId(VINEYARD_ACTIVITY);
	pMC = CreateMetaClass(TILLAGE_OPERATION, "tillageOperation");
	pMC->SetParentClassId(MOTORIZED_OPERATION);
	pMC = CreateMetaClass(TILLAGE_RESOURCE_SET, "tillageResourceSet");
	pMC->SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE);
	pMC = CreateMetaClass(TILLAGE_TOOL, "tillageTool");
	pMC->SetParentClassId(FARM_EQUIPMENT);
	pMC = CreateMetaClass(TOO_LATE_IN_WORK_DAY_FOR_ACTIVITY_BEGINNING, "tooLateInWorkDayForActivityBeginning");
	pMC->SetParentClassId(ACTIVITY_INCONSISTENCY_CONDITION);
	pMC = CreateMetaClass(TRACTOR, "tractor");
	pMC->SetParentClassId(FARM_EQUIPMENT);
	pMC = CreateMetaClass(TRELLISING_ACTIVITY, "trellisingActivity");
	pMC->SetParentClassId(VINEYARD_ACTIVITY);
	pMC = CreateMetaClass(TRELLISING_MACHINE, "trellisingMachine");
	pMC->SetParentClassId(FARM_EQUIPMENT);
	pMC = CreateMetaClass(TRELLISING_OPERATION, "trellisingOperation");
	pMC->SetParentClassId(MANUAL_OPERATION);
	pMC = CreateMetaClass(VARIETY_GROUP, "varietyGroup");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(VARIETY_GROUP_SET, "varietyGroupSet");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(VEGETAL_COMPARTMENT, "vegetalCompartment");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(VEGETATION, "vegetation");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(VERTICAL_RAIL_OPERATED_SPRAYING, "verticalRailOperatedSpraying");
	pMC->SetParentClassId(MOTORIZED_SPRAYING_OPERATION);
	pMC = CreateMetaClass(VERTICAL_RAIL_SPRAYER, "verticalRailSprayer");
	pMC->SetParentClassId(SPRAYER);
	pMC = CreateMetaClass(VERTICAL_RAIL_SPRAYING_OPERATION_RESOURCE_SPEC, "verticalRailSprayingOperationResourceSpec");
	pMC->SetParentClassId(OPERATION_RESOURCE_SPECIFICATION);
	pMC = CreateMetaClass(VERTICAL_RAIL_SPRAYING_RESOURCE_SET, "verticalRailSprayingResourceSet");
	pMC->SetParentClassId(HOMOGENEOUS_AGGREGATED_DISCRETE_STATE_REUSABLE_RESOURCE);
	pMC = CreateMetaClass(VINE_GROWING_TERRITORY, "vineGrowingTerritory");
	pMC->SetParentClassId(CONTROLLED_SYSTEM);
	pMC = CreateMetaClass(VINE_PRODUCING_REGION, "vineProducingRegion");
	pMC->SetParentClassId(PRODUCTION_SYSTEM);
	pMC = CreateMetaClass(VINEYARD, "vineyard");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(VINEYARD_ACTIVITIES_RESOURCES_BLOCK, "vineyardActivitiesResourcesBlock");
	pMC->SetParentClassId(ACTIVITIES_RESOURCES_BLOCK);
	pMC = CreateMetaClass(VINEYARD_ACTIVITY, "vineyardActivity");
	pMC->SetParentClassId(PRIMITIVE_ACTIVITY);
	pMC = CreateMetaClass(VINEYARD_CONTROL_SEQUENCE, "vineyardControlSequence");
	pMC->SetParentClassId(ACTIVITY_BEFORE);
	pMC = CreateMetaClass(VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN, "vineyardIteratedConjunctiveSubplan");
	pMC->SetParentClassId(ACTIVITY_CONJUNCTION);
	pMC = CreateMetaClass(VINEYARD_PHASE_CONJUNCTIVE_PLAN, "vineyardPhaseConjunctivePlan");
	pMC->SetParentClassId(ACTIVITY_CONJUNCTION);
	pMC = CreateMetaClass(VINEYARD_PHASE_OPTIONAL_PLAN, "vineyardPhaseOptionalPlan");
	pMC->SetParentClassId(ACTIVITY_OPTIONAL);
	pMC = CreateMetaClass(VINEYARD_SET, "vineyardSet");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(VIRTUAL_REGION_MANAGER, "virtualRegionManager");
	pMC->SetParentClassId(MANAGER);
	pMC = CreateMetaClass(VIRTUAL_REGION_OPERATING_SYSTEM, "virtualRegionOperatingSystem");
	pMC->SetParentClassId(OPERATING_SYSTEM);
	pMC = CreateMetaClass(WEATHER_STATION, "weatherStation");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(WEATHER_STATION_SET, "weatherStationSet");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(WEEK_DAY_AFTERNOON, "weekDayAfternoon");
	pMC->SetParentClassId(WEEK_DAY_PART);
	pMC = CreateMetaClass(WEEK_DAY_MORNING, "weekDayMorning");
	pMC->SetParentClassId(WEEK_DAY_PART);
	pMC = CreateMetaClass(WEEK_DAY_PART, "weekDayPart");
	pMC->SetParentClassId(AVAILABILITY_TIME_SLOT);
	pMC = CreateMetaClass(WINTER_TILLAGE_ACTIVITY, "winterTillageActivity");
	pMC->SetParentClassId(TILLAGE_ACTIVITY);
	pMC = CreateMetaClass(WORK_ORGANIZATION_OPTION_SET, "workOrganizationOptionSet");
	pMC->SetParentClassId(BD_ENTITY);
	pMC = CreateMetaClass(WORK_ORGANIZATION_OPTION_SUBSET, "workOrganizationOptionSubset");
	pMC->SetParentClassId(BD_ENTITY);
}
 
 
// -------------------------------------------
// Assignation des fonctions d'instanciation
// -------------------------------------------
void App_AssignInstantiators() {
  Assign_App_NewEntityFromStringFunction(App_NewEntityFromString);
  Assign_App_NewEntityFromIdFunction(App_NewEntityFromId);
  Assign_App_NewProcessFromStringFunction(App_NewProcessFromString);
  Assign_App_NewEventFromStringFunction(App_NewEventFromString);
  Assign_App_NewEntitySpecFromStringFunction(App_NewEntitySpecFromString);
  Assign_App_NewDescValueSpecFromStringFunction(App_NewDescValueSpecFromString);
  Assign_App_NewSerialDataFileFromStringFunction(App_NewSerialDataFileFromString);
  Assign_App_NewSerialDataFileFromIdFunction(App_NewSerialDataFileFromId);
  Assign_App_SerialDataFileIdFromStringFunction(App_SerialDataFileIdFromString);
}


// -------------------------------------------
// fonction d'instanciation d'entites
// -------------------------------------------
Entity* App_NewEntityFromString(char* nom) {
	Entity* result = O_NewEntityFromString(nom);
	if(result) return result;
	if (!strcmp(nom, "agroClimaticSystem")) return new AgroClimaticSystem();
	if (!strcmp(nom, "airAssistedSprayer")) return new AirAssistedSprayer();
	if (!strcmp(nom, "airAssistedSpraying")) return new AirAssistedSpraying();
	if (!strcmp(nom, "airAssistedSprayingOperationResourceSpec")) return new AirAssistedSprayingOperationResourceSpec();
	if (!strcmp(nom, "airAssistedSprayingResourceSet")) return new AirAssistedSprayingResourceSet();
	if (!strcmp(nom, "allocationPriorityOptionSet")) return new AllocationPriorityOptionSet();
	if (!strcmp(nom, "allocationPriorityOptionSubset")) return new AllocationPriorityOptionSubset();
	if (!strcmp(nom, "annualEmploymentPlan")) return new AnnualEmploymentPlan();
	if (!strcmp(nom, "aprilEmploymentPlan")) return new AprilEmploymentPlan();
	if (!strcmp(nom, "aprilNormalHoursEmploymentPlan")) return new AprilNormalHoursEmploymentPlan();
	if (!strcmp(nom, "aprilReducedHoursEmploymentPlan")) return new AprilReducedHoursEmploymentPlan();
	if (!strcmp(nom, "atLeastOnePlot")) return new AtLeastOnePlot();
	if (!strcmp(nom, "autumnTillageActivity")) return new AutumnTillageActivity();
	if (!strcmp(nom, "backSprayer")) return new BackSprayer();
	if (!strcmp(nom, "backSprayingOperation")) return new BackSprayingOperation();
	if (!strcmp(nom, "chemicalDebrancherOperatedSpraying")) return new ChemicalDebrancherOperatedSpraying();
	if (!strcmp(nom, "chemicalDebrancherSprayingOperationResourceSpec")) return new ChemicalDebrancherSprayingOperationResourceSpec();
	if (!strcmp(nom, "chemicalDebrancherSprayingResourceSet")) return new ChemicalDebrancherSprayingResourceSet();
	if (!strcmp(nom, "chemicalWeedingActivity")) return new ChemicalWeedingActivity();
	if (!strcmp(nom, "clipper")) return new Clipper();
	if (!strcmp(nom, "clippingActivity")) return new ClippingActivity();
	if (!strcmp(nom, "clippingOperation")) return new ClippingOperation();
	if (!strcmp(nom, "clippingOperationResourceSpec")) return new ClippingOperationResourceSpec();
	if (!strcmp(nom, "clippingResourceSet")) return new ClippingResourceSet();
	if (!strcmp(nom, "collectorPane")) return new CollectorPane();
	if (!strcmp(nom, "concurrentAntiMildewTreatments")) return new ConcurrentAntiMildewTreatments();
	if (!strcmp(nom, "concurrentAutumnTillages")) return new ConcurrentAutumnTillages();
	if (!strcmp(nom, "concurrentChemicalWeedings")) return new ConcurrentChemicalWeedings();
	if (!strcmp(nom, "concurrentClippings")) return new ConcurrentClippings();
	if (!strcmp(nom, "concurrentClippingsIteration")) return new ConcurrentClippingsIteration();
	if (!strcmp(nom, "concurrentDebranchings")) return new ConcurrentDebranchings();
	if (!strcmp(nom, "concurrentDistributedActivitySet")) return new ConcurrentDistributedActivitySet();
	if (!strcmp(nom, "concurrentExtraPhytoTreatments")) return new ConcurrentExtraPhytoTreatments();
	if (!strcmp(nom, "concurrentFertilizations")) return new ConcurrentFertilizations();
	if (!strcmp(nom, "concurrentInitSpringTillages")) return new ConcurrentInitSpringTillages();
	if (!strcmp(nom, "concurrentPrunings")) return new ConcurrentPrunings();
	if (!strcmp(nom, "concurrentRegularPhytoTreatments")) return new ConcurrentRegularPhytoTreatments();
	if (!strcmp(nom, "concurrentShootThinnings")) return new ConcurrentShootThinnings();
	if (!strcmp(nom, "concurrentSpringChemicalWeedings")) return new ConcurrentSpringChemicalWeedings();
	if (!strcmp(nom, "concurrentSpringTillages")) return new ConcurrentSpringTillages();
	if (!strcmp(nom, "concurrentTrellisings")) return new ConcurrentTrellisings();
	if (!strcmp(nom, "concurrentWinterTillages")) return new ConcurrentWinterTillages();
	if (!strcmp(nom, "conduite1")) return new Conduite1();
	if (!strcmp(nom, "conduite2")) return new Conduite2();
	if (!strcmp(nom, "conduite3")) return new Conduite3();
	if (!strcmp(nom, "conduite4")) return new Conduite4();
	if (!strcmp(nom, "conduite5")) return new Conduite5();
	if (!strcmp(nom, "cropRow")) return new CropRow();
	if (!strcmp(nom, "culturalOperationsDataItem")) return new CulturalOperationsDataItem();
	if (!strcmp(nom, "debranchingActivity")) return new DebranchingActivity();
	if (!strcmp(nom, "debranchingSprayer")) return new DebranchingSprayer();
	if (!strcmp(nom, "decisionOptionSet")) return new DecisionOptionSet();
	if (!strcmp(nom, "dhivineValuatedDataItem")) return new DhivineValuatedDataItem();
	if (!strcmp(nom, "distributedActivitySetIteration")) return new DistributedActivitySetIteration();
	if (!strcmp(nom, "distributedActivitySetMemoryItem")) return new DistributedActivitySetMemoryItem();
	if (!strcmp(nom, "equipmentMultiLocalization")) return new EquipmentMultiLocalization();
	if (!strcmp(nom, "equipmentUbiquityCondition")) return new EquipmentUbiquityCondition();
	if (!strcmp(nom, "extraPhytoTreatmentsIteration")) return new ExtraPhytoTreatmentsIteration();
	if (!strcmp(nom, "farmEquipment")) return new FarmEquipment();
	if (!strcmp(nom, "farmWorker")) return new FarmWorker();
	if (!strcmp(nom, "farmWorkerAvailabilityTimetable")) return new FarmWorkerAvailabilityTimetable();
	if (!strcmp(nom, "farmWorkerMultiLocalization")) return new FarmWorkerMultiLocalization();
	if (!strcmp(nom, "farmWorkerMultiOccupation")) return new FarmWorkerMultiOccupation();
	if (!strcmp(nom, "farmWorkerMultiOccupied")) return new FarmWorkerMultiOccupied();
	if (!strcmp(nom, "farmWorkerUbiquityCondition")) return new FarmWorkerUbiquityCondition();
	if (!strcmp(nom, "februaryMarchEmploymentPlan")) return new FebruaryMarchEmploymentPlan();
	if (!strcmp(nom, "februaryMarchNormalHoursEmploymentPlan")) return new FebruaryMarchNormalHoursEmploymentPlan();
	if (!strcmp(nom, "februaryMarchReducedHoursEmploymentPlan")) return new FebruaryMarchReducedHoursEmploymentPlan();
	if (!strcmp(nom, "fertilizationActivity")) return new FertilizationActivity();
	if (!strcmp(nom, "fertilizationOperation")) return new FertilizationOperation();
	if (!strcmp(nom, "fertilizationOperationResourceSpec")) return new FertilizationOperationResourceSpec();
	if (!strcmp(nom, "fertilizationResourceSet")) return new FertilizationResourceSet();
	if (!strcmp(nom, "formationPruningActivity")) return new FormationPruningActivity();
	if (!strcmp(nom, "gobeletPruningActivity")) return new GobeletPruningActivity();
	if (!strcmp(nom, "grapeVariety")) return new GrapeVariety();
	if (!strcmp(nom, "grapevine")) return new Grapevine();
	if (!strcmp(nom, "grapevineAge")) return new GrapevineAge();
	if (!strcmp(nom, "grass")) return new Grass();
	if (!strcmp(nom, "grassAge")) return new GrassAge();
	if (!strcmp(nom, "grassCoverVectorDataItem")) return new GrassCoverVectorDataItem();
	if (!strcmp(nom, "grassType")) return new GrassType();
	if (!strcmp(nom, "grinder")) return new Grinder();
	if (!strcmp(nom, "grinderOperatedShootThinning")) return new GrinderOperatedShootThinning();
	if (!strcmp(nom, "grinderShootThinningOperationResourceSpec")) return new GrinderShootThinningOperationResourceSpec();
	if (!strcmp(nom, "grinderShootThinningResourceSet")) return new GrinderShootThinningResourceSet();
	if (!strcmp(nom, "guyotPruningActivity")) return new GuyotPruningActivity();
	if (!strcmp(nom, "handHeldGunOperatedSpraying")) return new HandHeldGunOperatedSpraying();
	if (!strcmp(nom, "handHeldGunSprayingOperationResourceSpec")) return new HandHeldGunSprayingOperationResourceSpec();
	if (!strcmp(nom, "handHeldGunSprayingResourceSet")) return new HandHeldGunSprayingResourceSet();
	if (!strcmp(nom, "handHeldSprayGun")) return new HandHeldSprayGun();
	if (!strcmp(nom, "horizontalRailOperatedSpraying")) return new HorizontalRailOperatedSpraying();
	if (!strcmp(nom, "horizontalRailSprayer")) return new HorizontalRailSprayer();
	if (!strcmp(nom, "horizontalRailSprayingOperationResourceSpec")) return new HorizontalRailSprayingOperationResourceSpec();
	if (!strcmp(nom, "horizontalRailSprayingResourceSet")) return new HorizontalRailSprayingResourceSet();
	if (!strcmp(nom, "initSpringTillageActivity")) return new InitSpringTillageActivity();
	if (!strcmp(nom, "interRow")) return new InterRow();
	if (!strcmp(nom, "isoAgeingEntity")) return new IsoAgeingEntity();
	if (!strcmp(nom, "lastOperationsMemory")) return new LastOperationsMemory();
	if (!strcmp(nom, "lastOperationsMemoryItem")) return new LastOperationsMemoryItem();
	if (!strcmp(nom, "lastPesticideApplicationsMemoryItem")) return new LastPesticideApplicationsMemoryItem();
	if (!strcmp(nom, "lastTillageOperationsMemoryItem")) return new LastTillageOperationsMemoryItem();
	if (!strcmp(nom, "lowCumulativeRainSuffered")) return new LowCumulativeRainSuffered();
	if (!strcmp(nom, "managerAnnualEmploymentPlan")) return new ManagerAnnualEmploymentPlan();
	if (!strcmp(nom, "manualChemicalDebranchingActivity")) return new ManualChemicalDebranchingActivity();
	if (!strcmp(nom, "manualChemicalWeedingActivity")) return new ManualChemicalWeedingActivity();
	if (!strcmp(nom, "manualDebranchingOperation")) return new ManualDebranchingOperation();
	if (!strcmp(nom, "manualMechanicalDebranchingActivity")) return new ManualMechanicalDebranchingActivity();
	if (!strcmp(nom, "manualOperation")) return new ManualOperation();
	if (!strcmp(nom, "manualPhytoTreatmentActivity")) return new ManualPhytoTreatmentActivity();
	if (!strcmp(nom, "mayAugustEmploymentPlan")) return new MayAugustEmploymentPlan();
	if (!strcmp(nom, "mayAugustExtendedHoursEmploymentPlan")) return new MayAugustExtendedHoursEmploymentPlan();
	if (!strcmp(nom, "mayAugustNormalHoursEmploymentPlan")) return new MayAugustNormalHoursEmploymentPlan();
	if (!strcmp(nom, "mayAugustReducedHoursEmploymentPlan")) return new MayAugustReducedHoursEmploymentPlan();
	if (!strcmp(nom, "mhydasValuatedDataItem")) return new MhydasValuatedDataItem();
	if (!strcmp(nom, "moreThanOnePlot")) return new MoreThanOnePlot();
	if (!strcmp(nom, "moreThanOneTask")) return new MoreThanOneTask();
	if (!strcmp(nom, "motorizedChemicalDebranchingActivity")) return new MotorizedChemicalDebranchingActivity();
	if (!strcmp(nom, "motorizedChemicalWeedingActivity")) return new MotorizedChemicalWeedingActivity();
	if (!strcmp(nom, "motorizedOperation")) return new MotorizedOperation();
	if (!strcmp(nom, "motorizedPhytoTreatmentActivity")) return new MotorizedPhytoTreatmentActivity();
	if (!strcmp(nom, "motorizedSprayingOperation")) return new MotorizedSprayingOperation();
	if (!strcmp(nom, "myFloatAreaOperation")) return new MyFloatAreaOperation();
	if (!strcmp(nom, "neutralInconsistencyCondition")) return new NeutralInconsistencyCondition();
	if (!strcmp(nom, "nonPermanentFarmWorker")) return new NonPermanentFarmWorker();
	if (!strcmp(nom, "nonPermanentManualFarmWorker")) return new NonPermanentManualFarmWorker();
	if (!strcmp(nom, "nonPermanentTractorDriver")) return new NonPermanentTractorDriver();
	if (!strcmp(nom, "novemberJanuaryEmploymentPlan")) return new NovemberJanuaryEmploymentPlan();
	if (!strcmp(nom, "novemberJanuaryNormalHoursEmploymentPlan")) return new NovemberJanuaryNormalHoursEmploymentPlan();
	if (!strcmp(nom, "novemberJanuaryReducedHoursEmploymentPlan")) return new NovemberJanuaryReducedHoursEmploymentPlan();
	if (!strcmp(nom, "offWorkCalendar")) return new OffWorkCalendar();
	if (!strcmp(nom, "offWorkSinglePeriod")) return new OffWorkSinglePeriod();
	if (!strcmp(nom, "onlyPhytoTreatmentsAtEarlyMorning")) return new OnlyPhytoTreatmentsAtEarlyMorning();
	if (!strcmp(nom, "operationPriorityOptionSet")) return new OperationPriorityOptionSet();
	if (!strcmp(nom, "operationPriorityOptionSubset")) return new OperationPriorityOptionSubset();
	if (!strcmp(nom, "operationRecordingItem")) return new OperationRecordingItem();
	if (!strcmp(nom, "operationRecordingStructure")) return new OperationRecordingStructure();
	if (!strcmp(nom, "permanentAllTaskTractorDriver")) return new PermanentAllTaskTractorDriver();
	if (!strcmp(nom, "permanentFarmWorker")) return new PermanentFarmWorker();
	if (!strcmp(nom, "permanentFarmWorkerFiveDayTimetable")) return new PermanentFarmWorkerFiveDayTimetable();
	if (!strcmp(nom, "permanentFarmWorkerSevenDayTimetable")) return new PermanentFarmWorkerSevenDayTimetable();
	if (!strcmp(nom, "permanentFarmWorkerSixDayTimetable")) return new PermanentFarmWorkerSixDayTimetable();
	if (!strcmp(nom, "permanentManualFarmWorker")) return new PermanentManualFarmWorker();
	if (!strcmp(nom, "permanentMultiTaskManualWorker")) return new PermanentMultiTaskManualWorker();
	if (!strcmp(nom, "permanentMultiTaskWorker")) return new PermanentMultiTaskWorker();
	if (!strcmp(nom, "permanentPreferentialTractorDriver")) return new PermanentPreferentialTractorDriver();
	if (!strcmp(nom, "permanentPruner")) return new PermanentPruner();
	if (!strcmp(nom, "permanentTillageOrientedTractorDriver")) return new PermanentTillageOrientedTractorDriver();
	if (!strcmp(nom, "permanentTillageTractorDriver")) return new PermanentTillageTractorDriver();
	if (!strcmp(nom, "permanentTractorDriver")) return new PermanentTractorDriver();
	if (!strcmp(nom, "permanentVegetationGrower")) return new PermanentVegetationGrower();
	if (!strcmp(nom, "pestInfoMemory")) return new PestInfoMemory();
	if (!strcmp(nom, "pestInfoMemoryItem")) return new PestInfoMemoryItem();
	if (!strcmp(nom, "phenoStage")) return new PhenoStage();
	if (!strcmp(nom, "phytoTreatmentActivity")) return new PhytoTreatmentActivity();
	if (!strcmp(nom, "phytoTreatmentComposedProgram")) return new PhytoTreatmentComposedProgram();
	if (!strcmp(nom, "plantAge")) return new PlantAge();
	if (!strcmp(nom, "plantationActivity")) return new PlantationActivity();
	if (!strcmp(nom, "plantationOperation")) return new PlantationOperation();
	if (!strcmp(nom, "plot")) return new Plot();
	if (!strcmp(nom, "plotInternalPatternOptionSet")) return new PlotInternalPatternOptionSet();
	if (!strcmp(nom, "plotInternalPatternOptionSubset")) return new PlotInternalPatternOptionSubset();
	if (!strcmp(nom, "plotWithSeveralOperations")) return new PlotWithSeveralOperations();
	if (!strcmp(nom, "pruningActivity")) return new PruningActivity();
	if (!strcmp(nom, "pruningMachine")) return new PruningMachine();
	if (!strcmp(nom, "pruningOperation")) return new PruningOperation();
	if (!strcmp(nom, "regularPhytoTreatmentsIteration")) return new RegularPhytoTreatmentsIteration();
	if (!strcmp(nom, "relativeAreaDataItem")) return new RelativeAreaDataItem();
	if (!strcmp(nom, "retiredWorkerAnnualEmploymentPlan")) return new RetiredWorkerAnnualEmploymentPlan();
	if (!strcmp(nom, "rotaryCultivator")) return new RotaryCultivator();
	if (!strcmp(nom, "rotaryOperatedShootThinning")) return new RotaryOperatedShootThinning();
	if (!strcmp(nom, "rotaryOperatedTillage")) return new RotaryOperatedTillage();
	if (!strcmp(nom, "rotaryTillageOperationResourceSpec")) return new RotaryTillageOperationResourceSpec();
	if (!strcmp(nom, "rotaryTillageResourceSet")) return new RotaryTillageResourceSet();
	if (!strcmp(nom, "row")) return new Row();
	if (!strcmp(nom, "royatPruningActivity")) return new RoyatPruningActivity();
	if (!strcmp(nom, "seasonalEmploymentPlan")) return new SeasonalEmploymentPlan();
	if (!strcmp(nom, "septemberOctoberEmploymentPlan")) return new SeptemberOctoberEmploymentPlan();
	if (!strcmp(nom, "septemberOctoberNormalHoursEmploymentPlan")) return new SeptemberOctoberNormalHoursEmploymentPlan();
	if (!strcmp(nom, "septemberOctoberReducedHoursEmploymentPlan")) return new SeptemberOctoberReducedHoursEmploymentPlan();
	if (!strcmp(nom, "serialAntiMildewTreatments")) return new SerialAntiMildewTreatments();
	if (!strcmp(nom, "serialAutumnTillages")) return new SerialAutumnTillages();
	if (!strcmp(nom, "serialChemicalWeedings")) return new SerialChemicalWeedings();
	if (!strcmp(nom, "serialClippings")) return new SerialClippings();
	if (!strcmp(nom, "serialClippingsIteration")) return new SerialClippingsIteration();
	if (!strcmp(nom, "serialDebranchings")) return new SerialDebranchings();
	if (!strcmp(nom, "serialDistributedActivitySet")) return new SerialDistributedActivitySet();
	if (!strcmp(nom, "serialExtraPhytoTreatments")) return new SerialExtraPhytoTreatments();
	if (!strcmp(nom, "serialFertilizations")) return new SerialFertilizations();
	if (!strcmp(nom, "serialInitSpringTillages")) return new SerialInitSpringTillages();
	if (!strcmp(nom, "serialManualChemicalWeedings")) return new SerialManualChemicalWeedings();
	if (!strcmp(nom, "serialManualDebranchings")) return new SerialManualDebranchings();
	if (!strcmp(nom, "serialManualRegularPhytoTreatments")) return new SerialManualRegularPhytoTreatments();
	if (!strcmp(nom, "serialManualSpringChemicalWeedings")) return new SerialManualSpringChemicalWeedings();
	if (!strcmp(nom, "serialMotorizedChemicalWeedings")) return new SerialMotorizedChemicalWeedings();
	if (!strcmp(nom, "serialMotorizedDebranchings")) return new SerialMotorizedDebranchings();
	if (!strcmp(nom, "serialMotorizedRegularPhytoTreatments")) return new SerialMotorizedRegularPhytoTreatments();
	if (!strcmp(nom, "serialMotorizedSpringChemicalWeedings")) return new SerialMotorizedSpringChemicalWeedings();
	if (!strcmp(nom, "serialPlantations")) return new SerialPlantations();
	if (!strcmp(nom, "serialPrunings")) return new SerialPrunings();
	if (!strcmp(nom, "serialRegularPhytoTreatments")) return new SerialRegularPhytoTreatments();
	if (!strcmp(nom, "serialShootThinnings")) return new SerialShootThinnings();
	if (!strcmp(nom, "serialSpringChemicalWeedings")) return new SerialSpringChemicalWeedings();
	if (!strcmp(nom, "serialSpringTillages")) return new SerialSpringTillages();
	if (!strcmp(nom, "serialTrellisings")) return new SerialTrellisings();
	if (!strcmp(nom, "serialTrellisingsIteration")) return new SerialTrellisingsIteration();
	if (!strcmp(nom, "serialWinterTillages")) return new SerialWinterTillages();
	if (!strcmp(nom, "shootThinningActivity")) return new ShootThinningActivity();
	if (!strcmp(nom, "shootThinningOperation")) return new ShootThinningOperation();
	if (!strcmp(nom, "soilHumidityVectorDataItem")) return new SoilHumidityVectorDataItem();
	if (!strcmp(nom, "soilManagementDataItem")) return new SoilManagementDataItem();
	if (!strcmp(nom, "soilManagementGroup")) return new SoilManagementGroup();
	if (!strcmp(nom, "soilManagementGroupSet")) return new SoilManagementGroupSet();
	if (!strcmp(nom, "soilReservoir")) return new SoilReservoir();
	if (!strcmp(nom, "soilSurface")) return new SoilSurface();
	if (!strcmp(nom, "specialWorkerAnnualEmploymentPlan")) return new SpecialWorkerAnnualEmploymentPlan();
	if (!strcmp(nom, "sprayer")) return new Sprayer();
	if (!strcmp(nom, "spreader")) return new Spreader();
	if (!strcmp(nom, "springTillageActivity")) return new SpringTillageActivity();
	if (!strcmp(nom, "springTillagesIteration")) return new SpringTillagesIteration();
	if (!strcmp(nom, "springTineCultivator")) return new SpringTineCultivator();
	if (!strcmp(nom, "springTineOperatedTillage")) return new SpringTineOperatedTillage();
	if (!strcmp(nom, "springTineTillageOperationResourceSpec")) return new SpringTineTillageOperationResourceSpec();
	if (!strcmp(nom, "springTineTillageResourceSet")) return new SpringTineTillageResourceSet();
	if (!strcmp(nom, "standardWorkerAnnualEmploymentPlan")) return new StandardWorkerAnnualEmploymentPlan();
	if (!strcmp(nom, "tank")) return new Tank();
	if (!strcmp(nom, "tillageActivity")) return new TillageActivity();
	if (!strcmp(nom, "tillageOperation")) return new TillageOperation();
	if (!strcmp(nom, "tillageResourceSet")) return new TillageResourceSet();
	if (!strcmp(nom, "tillageTool")) return new TillageTool();
	if (!strcmp(nom, "tooLateInWorkDayForActivityBeginning")) return new TooLateInWorkDayForActivityBeginning();
	if (!strcmp(nom, "tractor")) return new Tractor();
	if (!strcmp(nom, "trellisingActivity")) return new TrellisingActivity();
	if (!strcmp(nom, "trellisingMachine")) return new TrellisingMachine();
	if (!strcmp(nom, "trellisingOperation")) return new TrellisingOperation();
	if (!strcmp(nom, "varietyGroup")) return new VarietyGroup();
	if (!strcmp(nom, "varietyGroupSet")) return new VarietyGroupSet();
	if (!strcmp(nom, "vegetalCompartment")) return new VegetalCompartment();
	if (!strcmp(nom, "vegetation")) return new Vegetation();
	if (!strcmp(nom, "verticalRailOperatedSpraying")) return new VerticalRailOperatedSpraying();
	if (!strcmp(nom, "verticalRailSprayer")) return new VerticalRailSprayer();
	if (!strcmp(nom, "verticalRailSprayingOperationResourceSpec")) return new VerticalRailSprayingOperationResourceSpec();
	if (!strcmp(nom, "verticalRailSprayingResourceSet")) return new VerticalRailSprayingResourceSet();
	if (!strcmp(nom, "vineGrowingTerritory")) return new VineGrowingTerritory();
	if (!strcmp(nom, "vineProducingRegion")) return new VineProducingRegion();
	if (!strcmp(nom, "vineyard")) return new Vineyard();
	if (!strcmp(nom, "vineyardActivitiesResourcesBlock")) return new VineyardActivitiesResourcesBlock();
	if (!strcmp(nom, "vineyardActivity")) return new VineyardActivity();
	if (!strcmp(nom, "vineyardControlSequence")) return new VineyardControlSequence();
	if (!strcmp(nom, "vineyardIteratedConjunctiveSubplan")) return new VineyardIteratedConjunctiveSubplan();
	if (!strcmp(nom, "vineyardPhaseConjunctivePlan")) return new VineyardPhaseConjunctivePlan();
	if (!strcmp(nom, "vineyardPhaseOptionalPlan")) return new VineyardPhaseOptionalPlan();
	if (!strcmp(nom, "vineyardSet")) return new VineyardSet();
	if (!strcmp(nom, "virtualRegionManager")) return new VirtualRegionManager();
	if (!strcmp(nom, "virtualRegionOperatingSystem")) return new VirtualRegionOperatingSystem();
	if (!strcmp(nom, "weatherStation")) return new WeatherStation();
	if (!strcmp(nom, "weatherStationSet")) return new WeatherStationSet();
	if (!strcmp(nom, "weekDayAfternoon")) return new WeekDayAfternoon();
	if (!strcmp(nom, "weekDayMorning")) return new WeekDayMorning();
	if (!strcmp(nom, "weekDayPart")) return new WeekDayPart();
	if (!strcmp(nom, "winterTillageActivity")) return new WinterTillageActivity();
	if (!strcmp(nom, "workOrganizationOptionSet")) return new WorkOrganizationOptionSet();
	if (!strcmp(nom, "workOrganizationOptionSubset")) return new WorkOrganizationOptionSubset();
	return NULL;
}


// -------------------------------------------
// fonction d'instanciation d'entites
// -------------------------------------------
Entity* App_NewEntityFromId(UserClassId id) {
  char* className = GetClassName(id);
  return App_NewEntityFromString(className);
}


// -------------------------------------------
// fonction d'instanciation de processus
// -------------------------------------------
Process* App_NewProcessFromString(char * nom) {
	Process* result = O_NewProcessFromString(nom);
	if(result) return result;
	if (!strcmp(nom, "clearPerfAllocationAndUpdateSituation")) return new ClearPerfAllocationAndUpdateSituation();
	if (!strcmp(nom, "grapevineAgeingProcess")) return new GrapevineAgeingProcess();
	if (!strcmp(nom, "hourlyWeatherFileReading")) return new HourlyWeatherFileReading();
	if (!strcmp(nom, "initPestInfoFileReading")) return new InitPestInfoFileReading();
	if (!strcmp(nom, "initPhenoStageFileReading")) return new InitPhenoStageFileReading();
	if (!strcmp(nom, "memoryItemGarbagingProcess")) return new MemoryItemGarbagingProcess();
	if (!strcmp(nom, "mildewWarningProcess")) return new MildewWarningProcess();
	if (!strcmp(nom, "morningMhydasInteractionProcess")) return new MorningMhydasInteractionProcess();
	if (!strcmp(nom, "updateSeasonCurrentIndexProcess")) return new UpdateSeasonCurrentIndexProcess();
	return NULL;
}


// -------------------------------------------
// fonction d'instanciation d'vnements
// -------------------------------------------
Event* App_NewEventFromString(char * nom) {
	Event* result = O_NewEventFromString(nom);
	if(result) return result;
	if (!strcmp(nom, "memoryItemGarbagingEvent")) return new MemoryItemGarbagingEvent();
	if (!strcmp(nom, "mildewWarningEvent")) return new MildewWarningEvent();
	if (!strcmp(nom, "morningMhydasInteractionEvent")) return new MorningMhydasInteractionEvent();
	if (!strcmp(nom, "morningUpdateSituationEvent")) return new MorningUpdateSituationEvent();
	if (!strcmp(nom, "updateSeasonCurrentIndexEvent")) return new UpdateSeasonCurrentIndexEvent();
	return NULL;
}


// -------------------------------------------
// fonction d'instanciation de 'EntitySpec'
// -------------------------------------------
EntitySpec* App_NewEntitySpecFromString(char * nom) {
	EntitySpec* result = O_NewEntitySpecFromString(nom);
	if(result) return result;
	if (!strcmp(nom, "airAssistedSprayingResourceEntitySpec")) return new AirAssistedSprayingResourceEntitySpec();
	if (!strcmp(nom, "chemicalDebrancherSprayingResourceEntitySpec")) return new ChemicalDebrancherSprayingResourceEntitySpec();
	if (!strcmp(nom, "chemicalWeedingExecutorEntitySpec")) return new ChemicalWeedingExecutorEntitySpec();
	if (!strcmp(nom, "clippingResourceEntitySpec")) return new ClippingResourceEntitySpec();
	if (!strcmp(nom, "fertilizationResourceEntitySpec")) return new FertilizationResourceEntitySpec();
	if (!strcmp(nom, "greenWorkExecutorEntitySpec")) return new GreenWorkExecutorEntitySpec();
	if (!strcmp(nom, "grinderShootThinningResourceEntitySpec")) return new GrinderShootThinningResourceEntitySpec();
	if (!strcmp(nom, "handHeldGunSprayingResourceEntitySpec")) return new HandHeldGunSprayingResourceEntitySpec();
	if (!strcmp(nom, "horizontalRailSprayingResourceEntitySpec")) return new HorizontalRailSprayingResourceEntitySpec();
	if (!strcmp(nom, "manualWorkerEntitySpec")) return new ManualWorkerEntitySpec();
	if (!strcmp(nom, "pruningExecutorEntitySpec")) return new PruningExecutorEntitySpec();
	if (!strcmp(nom, "rotaryTillageResourceEntitySpec")) return new RotaryTillageResourceEntitySpec();
	if (!strcmp(nom, "springTineTillageResourceEntitySpec")) return new SpringTineTillageResourceEntitySpec();
	if (!strcmp(nom, "tillageTractorDriverEntitySpec")) return new TillageTractorDriverEntitySpec();
	if (!strcmp(nom, "tractorDriverEntitySpec")) return new TractorDriverEntitySpec();
	if (!strcmp(nom, "verticalRailSprayingResourceEntitySpec")) return new VerticalRailSprayingResourceEntitySpec();
	return NULL;
}


// -------------------------------------------
// fonction d'instanciation de 'DescValueSpec'
// -------------------------------------------
DescValueSpec* App_NewDescValueSpecFromString(char * nom) {
	DescValueSpec* result = O_NewDescValueSpecFromString(nom);
	if(result) return result;
	return NULL;
}


// ----------------------------------------------
// fonction d'instanciation de SerialDataFile
// ----------------------------------------------
SerialDataFile* App_NewSerialDataFileFromString(char * nom) {
	SerialDataFile* result = O_NewSerialDataFileFromString(nom);
	if(result) return result;
	if(!strcmp(nom, "HOURLY_WEATHER_FILE")) return new HourlyWeatherFile();
	if(!strcmp(nom, "PEST_INFO_FILE")) return new PestInfoFile();
	if(!strcmp(nom, "PHENO_STAGE_FILE")) return new PhenoStageFile();
	return NULL;
}
 
// pour compatibilite 5.0
SerialDataFile* App_NewSequentialDataFileFromString(char * nom) {
  return App_NewSerialDataFileFromString(nom);
}


// ----------------------------------------------
// fonction d'instanciation de SerialDataFile
// ----------------------------------------------
SerialDataFile* App_NewSerialDataFileFromId(UserFileId id) {
	SerialDataFile* result = O_NewSerialDataFileFromId(id);
	if(result) return result;
	if(id == HOURLY_WEATHER_FILE) return new HourlyWeatherFile();
	if(id == PEST_INFO_FILE) return new PestInfoFile();
	if(id == PHENO_STAGE_FILE) return new PhenoStageFile();
	return NULL;
}
 
// pour compatibilite 5.0
SerialDataFile* App_NewSequentialDataFileFromId(UserFileId id) {
  return App_NewSerialDataFileFromId(id);
}


// -------------------------------------------
// passage String -> UserFileId pour les SDF
// -------------------------------------------
UserFileId App_SerialDataFileIdFromString(char* str) {
	UserFileId result = O_SerialDataFileIdFromString(str);
	if(result > -9) return result;
	if(!strcmp(str, "HOURLY_WEATHER_FILE")) return HOURLY_WEATHER_FILE;
	if(!strcmp(str, "PEST_INFO_FILE")) return PEST_INFO_FILE;
	if(!strcmp(str, "PHENO_STAGE_FILE")) return PHENO_STAGE_FILE;
	return -9;
}
 
// pour compatibilite 5.0
UserFileId App_SequentialDataFileIdFromString(char* str) {
  return App_SerialDataFileIdFromString(str);
}


bool App_AreAllPlotsDone(Activity* pChantier, UserDescriptorId descId)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard(pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(descId);
	int isDone = App_FloatEQ(percentDone, (float)1.)
	             || 
	             App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' %s percentDone = %f isDone = %d", pPlot_k->InstanceName(), DescIdToCharTab[descId], percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  return allDone;
}

void App_AssignIsoAgeingEntityToPlots (Entity* pVineyardSet)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int nbEA = pVineyardSet->GetNumberOfElements();
  for(int i=0;i<nbEA;i++) {
	Entity* pEA_i = pVineyardSet->GetElement(i);
	Entity* pConduite = pEA_i->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	Entity* pARB = pConduite->GetSuperEntity();
	Entity* dec_optionSet //DecisionOptionSet
	  = pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
	char* guidingEarlyVariety = 
	  dec_optionSet->GetStringConstValue(GUIDING_EARLY_VARIETY_ATTRIBUTE);
	char* guidingLateVariety = 
	  dec_optionSet->GetStringConstValue(GUIDING_LATE_VARIETY_ATTRIBUTE);


	int nbPlots = pEA_i->GetNumberOfElements();
	for(int j=0;j<nbPlots;j++) {
	  Entity* pPlot_i_j = pEA_i->GetElement(j);

	  Entity* variety_i_j = 
		pPlot_i_j->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
	  Entity* ws_i_j = 
		pPlot_i_j->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);

	  char* thisVarietyName = variety_i_j->InstanceName();
	  int isEarly = ! strcmp(thisVarietyName, guidingEarlyVariety);
	  int isLate  = ! strcmp(thisVarietyName, guidingLateVariety);
	  if(isEarly || isLate) {
		//
		// recherche d'une IsoAgeingEntity deja instanciee
		//
		pEntityTab* IAE_list = GetEntityList(ISO_AGEING_ENTITY);
		int nbIAE = IAE_list->size();
		Entity* pIAE = NULL;
		for(int k=0;k<nbIAE;k++) {
		  Entity* pIAE_k = (Entity*)IAE_list->get_element(k);
		  bool sameWS = 
			(ws_i_j == pIAE_k->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE));
		  bool sameVariety = 
			(variety_i_j == pIAE_k->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE));
		  if(sameWS && sameVariety) {
			pIAE = pIAE_k;
			break;
		  }
		}
		//
		// si recherche infructueuse, alors instantiation d'une nouvelle
		//
		if(! pIAE) {
		  pIAE = new IsoAgeingEntity();
//printf("\n'%s' : instanciation de '%s'", pPlot_i_j->InstanceName(), pIAE->InstanceName());
		  pIAE->SetEntityConstValue(WEATHER_STATION_ATTRIBUTE, ws_i_j);
		  pIAE->SetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE, variety_i_j);
		}
		else {
//printf("\n'%s' : on a trouve '%s'", pPlot_i_j->InstanceName(), pIAE->InstanceName());
		}
		pEA_i->AddEntityValueElement(ISO_AGEING_ENTITY_SET_ATTRIBUTE,
									 pIAE);
		Entity* pVegetalComp = pPlot_i_j->GetComponent(VEGETAL_COMPARTMENT);
		Entity* pCropRow;
		pCropRow= pVegetalComp->GetElement(2);
		pCropRow->GetComponent(GRAPEVINE)->SetEntityConstValue(ISO_AGEING_ENTITY_ATTRIBUTE, pIAE);
		pCropRow = pVegetalComp->GetElement(3);
		pCropRow->GetComponent(GRAPEVINE)->SetEntityConstValue(ISO_AGEING_ENTITY_ATTRIBUTE, pIAE);
		
	  }
	  else {
		// pas de recherche/instantiation de IsoAgeingEntity :
		// pPlot_i_j, non porteuse d'une variete-guide, ne sera jamais
		// "interrogee" sur le stade atteint (via une  IsoAgeingEntity)
//printf("\n'%s' : variete pas guide", pPlot_i_j->InstanceName());
	  }
	}
  }
}

void App_AssignTurnedOffActivitiesOnPlots (Entity* pVineyardSet)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int nbEA = pVineyardSet->GetNumberOfElements();
  for(int i=0;i<nbEA;i++) {
	Entity* pEA_i = pVineyardSet->GetElement(i);
	Entity* pConduite = pEA_i->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	Entity* pARB = pConduite->GetSuperEntity();
	Entity* dec_optionSet //DecisionOptionSet
	  = pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);


	int nbPlots = pEA_i->GetNumberOfElements();
	for(int j=0;j<nbPlots;j++) {
	  Entity* pPlot_i_j = pEA_i->GetElement(j);
	  //
	  // a completer
	  //
	}
  }
}

void App_Body_mySortActivitySetsInARB (EntityMethod* pM)
//---------------------------------------------
// Description  :  // + JPR 121222
// Precondition : 
// Retour       :
// Comment      : version 130113 avec rduction nb Trt Phyto 
//              : complt par rgle 0 (130131)
//---------------------------------------------
{
  Entity* pARB = pM->DescribedEntity();
  Entity* pSetToSort = pM->GetEntityArgValue(ACTIVITY_SET_ARGUMENT);
  int nbSingle = pSetToSort->GetNumberOfElements();
//printf("\nDEB mySort nbSingle = %d\n", nbSingle);
//((InstructionSetConjunction*)pSetToSort)->SpecialDisplay(); printf("\n");

  //===========================================================================
  // Regle 0 : avant l'heure normale de dbut le matin, que des traitements
  //           (JPR 130131)
  //===========================================================================
  int now = pCurrentSim->Clock();
  tm* pTm  = ClockValueToTm(now);
  int hour = pTm->tm_hour;
  if(hour < gIntParam_morningUpdateSituation_normalHour_) {
	pEntityTab* tmp  = new pEntityTab();
	for (int k=nbSingle-1;k>=0;k--) {
	  SingleInstructionSet* pSingle = (SingleInstructionSet*)(pSetToSort->GetElement(k));
	  PrimitiveActivity* pInst = pSingle->GetAct();
//printf("\n\tpInst : %s\n", pInst->InstanceName());
	  UserClassIdTab idTab = pInst->AncestorIds();
	  idTab.push_back(pInst->ClassId());
	  if(GetPosition(idTab, PHYTO_TREATMENT_ACTIVITY) >= 0) {
		tmp->push_front(pSingle);
	  }
	  else nbSingle--;
		
	}
	pSetToSort->RemoveElements();
//tmp->display_names();
	pSetToSort->AddElements(*tmp);
	delete tmp;
  }
//printf("\nDEB mySort nbSingle aprs regle 0  = %d\n", nbSingle);
  delete pTm;

  //===========================================================================
  // Regle 1 : Tri des activites par force de priorite d'allocation 
  //           decroissante
  //===========================================================================
  //===========================================================================
  // Regle 2 gnrale : reduction combinatoire de l'allocation de ressources
  //          Les specifications MAX interviennent en dernier, 
  //          dans chaque inconsistentSet :
  //   (MAX_1 DISJ_1 MAX_2 ANYONE) --> (DISJ_1 ANYONE MAX_1 MAX_2)
  //===========================================================================
  //===========================================================================
  // Regle 2 spcifique : 
  //         Si le jeu comporte au moins un trellising :
  //         - si "allocation exclusive au trellising" : ([Trt Phyto] Trellisings)
  //         - sinon : jeu en entre tri  par ordre dcroissantde priorit 
  //           d'allocation
  //         Si pas de trellising : jeu en entre tri  par ordre dcroissant
  //         de priorit d'allocation.
  //===========================================================================

  // dtection prsence Trellising, Trt Phyto
  bool areTrellisings = FALSE;
  bool arePhytoTreatments = FALSE;
  pEntityTab* trellisingTab = new pEntityTab();
  pEntityTab* otherThanTrellisingTab = new pEntityTab();
  pEntityTab* allActivityTab = new pEntityTab();
  pEntityTab* phytoTreatmentTab = new pEntityTab();
  int isTrellisingExclusive = -9; // JPR 130212
  for (int k=nbSingle-1;k>=0;k--) {
    SingleInstructionSet* pSingle = (SingleInstructionSet*)(pSetToSort->GetElement(k));
	allActivityTab->push_front(pSingle);              // toutes
    PrimitiveActivity* pInst = pSingle->GetAct();
	Boolean toPull = FALSE;
	UserClassIdTab idTab = pInst->AncestorIds();
	idTab.push_back(pInst->ClassId());
	if(GetPosition(idTab, TRELLISING_ACTIVITY) >= 0) {
	  areTrellisings = TRUE;
	  trellisingTab->push_front(pSingle);             // Trellising
	  if(isTrellisingExclusive < 0)
		isTrellisingExclusive = 
		  App_GetAllocationExclusivity(pARB, "trellisingActivity");
	}
	else {
	  otherThanTrellisingTab->push_front(pSingle);    // autres que Trellising
	  if(GetPosition(idTab, PHYTO_TREATMENT_ACTIVITY) >= 0) {
		phytoTreatmentTab->push_front(pSingle);       // Trt Phyto
		arePhytoTreatments = TRUE;
	  }
	}
  }
	  
  if(arePhytoTreatments) {
	int nbTreatments = phytoTreatmentTab->size();
	Entity* pConduite = pARB->GetComponent(ACTIVITY);
	Entity* pVineyard = pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
	int maxNbTrtToKeep = App_GetResourceNumberFromDistributedActivitySetClassId(pVineyard, CONCURRENT_REGULAR_PHYTO_TREATMENTS); 
	for(int i=nbTreatments-maxNbTrtToKeep-1;i>=0;i--) {
//printf("\ni = %d maxNbTrtToKeep+i-1 = %d\n", i, maxNbTrtToKeep+i-1);
	  BasicEntity* pSingleToScratch = phytoTreatmentTab->get_element(maxNbTrtToKeep+i);
	  allActivityTab->remove_first(pSingleToScratch);
	  otherThanTrellisingTab->remove_first(pSingleToScratch);
	  //delete pSingleToScratch; //  visiter
	}
  }
//printf("\ntrellisingTab  : ");trellisingTab->display_names();
//printf("\notherThanTrellisingTab  : ");otherThanTrellisingTab->display_names();
//printf("\nphytoTreatmentTab  : ");phytoTreatmentTab->display_names();
//printf("\nallActivityTab  : ");allActivityTab->display_names();
  //
  // reconstitution de la liste des lments de pSetToSort, version 130313 (5.5)
  //
  pSetToSort->RemoveElements();
  if(areTrellisings) {
	if(isTrellisingExclusive == 1) {
	  if(arePhytoTreatments) {
		pSetToSort->AddElements(*phytoTreatmentTab);
	  }
	  pSetToSort->AddElements(*trellisingTab);
	}
	else {
	  InstructionSetConjunction* ISC_tmp = new InstructionSetConjunction();
	  ISC_tmp->AddElements(*allActivityTab);
	  // tri des autres activits que les ventuels Trellisings
	  ISC_tmp->SortByAllocPriorityThenPushMaxSpecToBack();
	  pSetToSort->AddElements(ISC_tmp->GetElementTab());	
	  delete ISC_tmp;
	}
  }
  else {  // no Trellising
	InstructionSetConjunction* ISC_tmp = new InstructionSetConjunction();
	ISC_tmp->AddElements(*allActivityTab);
	// tri de toutes les activits (sauf ventuellement qq Trt Phyto)
	ISC_tmp->SortByAllocPriorityThenPushMaxSpecToBack();
	pSetToSort->AddElements(ISC_tmp->GetElementTab());	
	delete ISC_tmp;
  }
  delete trellisingTab;
  delete otherThanTrellisingTab;
  delete phytoTreatmentTab;  // + JPR 130113
  delete allActivityTab;  // + JPR 130113
//printf("\nFIN App_Body_mySortActivitySetsInARB");
}

void App_Body_pushMAXSpecToBackInARBActivitySet (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pARB = pM->DescribedEntity();
  Entity* pSetToSort = pM->GetEntityArgValue(ACTIVITY_SET_ARGUMENT);

  //===========================================================================
  // Regle 1 : Tri des activites par force de priorite d'allocation 
  //           decroissante
  //===========================================================================

  //===========================================================================
  // Regle 2 : reduction combinatoire de l'allocation de ressources
  //           Les specifications MAX interviennent en dernier, 
  //           dans chaque inconsistentSet :
  //   (MAX_1 DISJ_1 MAX_2 ANYONE) --> (DISJ_1 ANYONE MAX_1 MAX_2)
  //===========================================================================
//printf("\npassage par App_Body_pushMAXSpecToBackInARBActivitySet pour '%s'", pARB->InstanceName());
  //
  // exploitation du service predefini dans CDIESE
  //
  ((InstructionSetConjunction*)pSetToSort)->SortByAllocPriorityThenPushMaxSpecToBack();
}

void App_ControlPlanSettings (char fileName[])
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
//printf("\nApp_ControlPlanSettings('%s')", fileName);
  FILE* pF = fopen(fileName,"r");
  /*
  Entity* pPS = pCurrentSim->SimulatedEntity();
  Entity* pCS = pPS->GetComponent(CONTROLLED_SYSTEM);
  Entity* pACS = pCS->GetEntityConstValue(ATTACHED_ENTITY);
  Entity* pVineyardSet = pACS->GetComponent(VINEYARD_SET);
  Entity* pDS = pPS->GetComponent(MANAGER);
  Entity* pStrategy = pDS->GetComponent(STRATEGY);
  */
 
  char nomEA[10], codeConduite[20], codeWOOptionSet[20], codeDecOptionSet[20], codeAlPriorityOptionSet[30], codeOpPriorityOptionSet[30], specSoilManagementGroupSet[500];

  while(TRUE) {
	int i = fscanf(pF,
				   "%s %s %s %s %s %s %s",
				   nomEA, codeConduite, 
				   codeWOOptionSet, codeDecOptionSet, 
				   codeAlPriorityOptionSet, codeOpPriorityOptionSet,
				   specSoilManagementGroupSet);
	if(i == EOF)
	  break;

	if(strncmp(nomEA, "//", 2)) { // + JPR 121107 : possibilit de lignes en commentaire

	  char* str_in = strtok(specSoilManagementGroupSet, "=");
	  char* str_soilManagementGroupSet = strtok(NULL, "=");
	  if(! str_soilManagementGroupSet) {
		printf("\n!! App_ControlPlanSettings('%s') :\n!! option d'entretien du sol non reconnue (exemple autorise : soilManagementGroups=aGroupSet)\n", fileName);
		exit(0);
	  }
//printf("\n\ti = %d nomEA : '%s' '%s' '%s' '%s' '%s' '%s' '%s'", i, nomEA, codeConduite, codeWOOptionSet, codeDecOptionSet, codeAlPriorityOptionSet, codeOpPriorityOptionSet, str_soilManagementGroupSet);

	  //
	  // recuperation de l'EA
	  //
	  Vineyard* pVineyard = (Vineyard*)GetNamedEntity(nomEA);   // pas mieux ?!
	  if(! pVineyard) {
		printf("\n!!! Exploitation '%s' non trouv e !!!", nomEA);
		exit(0);
	  }
	  //
	  // recuperation l'ARB de l'EA : 
	  //
	  // un plan a ete attache a l'ARB dans App_DepthBioPhysicalSettings
	  // juste pour pouvoir remonter a l'ARB a partir de pEA
	  // et redescendre au pool de ressources dans App_ResourceSettings
	  //
	  //
	  Entity* pOldPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	  Entity* pARB = pOldPlan->GetSuperEntity(); 
	  pARB->AssignBody(LOCAL_CANDIDATE_ACTIVITY_SET_SORT_METHOD, 
					   //App_Body_pushMAXSpecToBackInARBActivitySet);
					   App_Body_mySortActivitySetsInARB); // modif JPR 121222
	  
	  Entity* pWOOptionSet = GetNamedEntity(codeWOOptionSet);
	  pARB->SetEntityConstValue(WORK_ORGANIZATION_OPTION_SET_ATTRIBUTE,
								pWOOptionSet);
	  Entity* pDecOptionSet = GetNamedEntity(codeDecOptionSet);
	  pARB->SetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE,
								pDecOptionSet);
	  Entity* pAlPriorityOptionSet = GetNamedEntity(codeAlPriorityOptionSet);
	  pARB->SetEntityConstValue(ALLOCATION_PRIORITY_OPTION_SET_ATTRIBUTE,
								pAlPriorityOptionSet);
	  Entity* pOpPriorityOptionSet = GetNamedEntity(codeOpPriorityOptionSet);
	  pARB->SetEntityConstValue(OPERATION_PRIORITY_OPTION_SET_ATTRIBUTE,
								pOpPriorityOptionSet);
	  pARB->SetStringConstValue(SOIL_MANAGEMENT_GROUP_SET_NAME, 
								str_soilManagementGroupSet);
	  //
	  // designation fonction de selection du meilleur jeu d'activites
	  //
	  if(TRUE) {  // provisoire !
		pARB->AssignBody(LOCAL_BEST_ACTIVITY_SET_SELECTOR,
						 //Body_BestActivitySetSelector_OnlyOnOperationPriority);
						 Body_BestActivitySetSelector_Standard);
	  }
	  else {
		// affectation autre fonction de selection
	  }
	  //
	  // instanciation du plan de conduite definitif
	  //
	  Entity* pPlan;
	  if(! strcmp(codeConduite, "conduite1")) {
		pPlan = new Conduite1(pVineyard);
	  }
	  else if(! strcmp(codeConduite, "conduite2")) {
		pPlan = new Conduite2(pVineyard);
	  }
	  else if(! strcmp(codeConduite, "conduite3")) {
		pPlan = new Conduite3(pVineyard);
	  }
	  else if(! strcmp(codeConduite, "conduite4")) {
		pPlan = new Conduite4(pVineyard);
	  }
	  else if(! strcmp(codeConduite, "conduite5")) {
		pPlan = new Conduite5(pVineyard);
	  }
	  else  {
		printf("\n App_ControlPlanSettings conduite inconnue\n");
		exit(0);
	  }
	  //
	  // remplacement du plan temporaire par le definitif
	  //
	  pVineyard->SetEntityConstValue(CONTROL_PLAN_ATTRIBUTE, pPlan);
	  pARB->RemoveComponent(pOldPlan);
	  DeleteEntity(pOldPlan);
	  pARB->AddComponent(pPlan);
	  //
	  // on rend le plan pret a etre interprete
	  //
	  pPlan->SetIntVarValue(READY_TO_RUN, 1);
//printf("\npPlan : %s pour '%s'\n", pPlan->InstanceName(), pVineyard->InstanceName());
//((Activity*)pPlan)->DisplaySituation(); printf("\n");
	  //
	  // pour chaque parcelle de l'EA
	  // - on etablit le mode des gestion des rangees   (+ JPR 1312)
	  // - on etablit la surface relative des rangs et inter-rangs
	  //
	  pEntityTab pPlotTab = pVineyard->GetElementTab();
	  int nbPlots = pPlotTab.size();
	  for(int i=0;i<nbPlots;i++) {
		Entity* pPlot_i = (Entity*)pPlotTab.get_element(i);
		// exploitation ventuel groupe indique dans le fichier des parcelles
		char* grpeGestionSol = pPlot_i->GetStringConstValue(SOIL_MANAGEMENT_GROUP_NAME);
		Entity* pSMGroup = NULL;
		if(! strcmp(grpeGestionSol, "*")) {
		  // utilisation de l'indicateur en fin de ligne (soilManagementGroupSet) 
		  char* soilManagementGroupSet = 
			pARB->GetStringConstValue(SOIL_MANAGEMENT_GROUP_SET_NAME);
		  pPlot_i->SetStringArgValue(RETURN_SOIL_MANAGEMENT_GROUP_ON_PROFILE, 
									 MANAGEMENT_GROUP_SET_ARGUMENT,
									 soilManagementGroupSet);
		  pSMGroup = (Entity*)pPlot_i->ExecEntityMethod(RETURN_SOIL_MANAGEMENT_GROUP_ON_PROFILE);
		}
		else
		  pSMGroup = GetNamedEntity(SOIL_MANAGEMENT_GROUP, grpeGestionSol);
		if(! pSMGroup) {
		  printf("\n!!! Aucun groupe de gestion du sol n'a pu tre identifi pour '%s'\n", pPlot_i->InstanceName());
		  exit(0);
		}
//printf("\n '%s' est geree par les options du groupe '%s'", pPlot_i->InstanceName(), pSMGroup->InstanceName());
		int rowManagement = pSMGroup->GetIntConstValue(ROW_MANAGEMENT);
		Entity* plotPattern = pSMGroup->GetEntityConstValue(PLOT_PATTERN);
		float q = 
		  plotPattern->GetFloatConstValue(OPT_RIDING_ORIENTED_INTER_ROW_PROPORTION);
		float p = 
		  plotPattern->GetFloatConstValue(OPT_GRASS_STRIP_ALLEY_WIDTH_RATIO);
		float r = 
		  plotPattern->GetFloatConstValue(OPT_CROP_ROW_ALLEY_WIDTH_RATIO);
		pPlot_i->SetIntConstValue(ROW_MANAGEMENT, rowManagement);
		if(rowManagement != TOTAL_CW) { 
		float superficie = pPlot_i->GetFloatConstValue(AREA); 
		float x = pVineyard->GetFloatConstValue(AREA_WITH_TILLED_GRAPEVINE); 
 		pVineyard->SetFloatConstValue(AREA_WITH_TILLED_GRAPEVINE, x + superficie); 
 		} // AB 140708
		pPlot_i->SetFloatConstValue(RIDING_ORIENTED_INTER_ROW_PROPORTION, q);
		pPlot_i->SetFloatConstValue(GRASS_STRIP_ALLEY_WIDTH_RATIO, p);
		pPlot_i->SetFloatConstValue(CROP_ROW_ALLEY_WIDTH_RATIO, r);
		// 
		// etablissement du mode d'entretien du sol des rangees
		// ( installer de preference omme mthode de Plot)
		pPlot_i->ExecVoidMethod(SET_ROW_SOIL_MANAGEMENT);
		// attribution des surfaces aux rangees 
		// (transfr des SetRowSoilManagement_XX, 1312)
		pPlot_i->ExecVoidMethod(ASSIGN_RELATIVE_AREA_TO_ROWS);
	  } // fin for plot_i
	} // fin if("//")
  } // fin while
  fclose(pF);  
//printf("\nfin App_ControlPlanSettings('%s')", fileName);
}

void App_DeallocateMiscellaneousDynamicEntities ()
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pPS = pCurrentSim->SimulatedEntity();
  Entity* pCS = pPS->GetComponent(CONTROLLED_SYSTEM);
  Entity* pACS = pCS->GetEntityConstValue(ATTACHED_ENTITY);
  Entity* pVineyardSet = pACS->GetComponent(VINEYARD_SET);
  //
  // PestInfoMemoryItems
  //
  Entity* pMemory = 
	pVineyardSet->GetEntityConstValue(PEST_INFO_MEMORY_ATTRIBUTE);
  int nbItems = pMemory->GetNumberOfElements();
  for(int i=nbItems-1;i>=0;i--) {
	Entity* pItem_i = pMemory->GetElement(i);
//printf("\ndelete %s", pItem_i->InstanceName());
	delete (PestInfoMemoryItem*)pItem_i;
  }
  //
  // DistributedActivitySetMemoryItem
  //
  int nbEA = pVineyardSet->GetNumberOfElements();
  for(int i=nbEA-1;i>=0;i--) {
	Entity* pEA_i = pVineyardSet->GetElement(i);
	Entity* pConduite = pEA_i->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	Entity* pARB = pConduite->GetSuperEntity();
	pEntityTab* pItemTab = 
	  pARB->GetEntityTabValue(DISTRIBUTED_ACTIVITY_SET_MEMORY);
	int nbItems = pItemTab->size();
	for(int i=0;i<nbItems;i++) {
	  BasicEntity* pItem_i = pItemTab->get_element(i);
//printf("\ndelete %s", pItem_i->InstanceName());
	  delete (DistributedActivitySetMemoryItem*)pItem_i;
	}
  }
  //
  // Les LastOperationMemoryItem residuels de fin de simulation,
  // ceux non desalloues par le MemoryItemGarbaging du lendemain
  //
  pEntityTab* pMemoryItemTab = GetEntityList(LAST_OPERATIONS_MEMORY_ITEM);
  nbItems = pMemoryItemTab->size();
  for(int i=nbItems-1;i>=0;i--) {
	BasicEntity* pItem_i = pMemoryItemTab->get_element(i);
//printf("\ndelete %s", pItem_i->InstanceName());
	delete (LastOperationsMemoryItem*)pItem_i;
  }
}

void App_DeallocatePrimitiveActivities (Activity* pChantier)
//---------------------------------------------
// Description  : desallocation des activites primitives du chantier
// Precondition : 
// Retour       : 
// Comment      : a invoquer lors de la fermeture du chantier
//              : puisqu'il n'y aura pas de MIOS a cause de cette fermeture
//              : et que c'est ce MIOS qui desalloue les primitives presentes
//---------------------------------------------
{
//printf("\nApp_DeallocatePrimitiveActivities('%s')", pChantier->InstanceName());
  pEntityTab pInstList = pChantier->GetDepthElementTab(PRIMITIVE_ACTIVITY);
  int nbInst = pInstList.size();
  for(int k=nbInst-1;k>=0;k--) {
	PrimitiveActivity* pAct = (PrimitiveActivity*)pInstList.get_element(k);
	Entity* pOt = NULL;
	Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
//printf("\n\tpOt en %x", pOt);
	if(pOt) ((Operation*)pOt)->DeleteInDepth();
//printf("\n\t'%s'", pAct->InstanceName());
	pAct->DeleteInDepth();
  }
}

void App_DepthBioPhysicalSettings (char fileName[])
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
//printf("\nApp_DepthBioPhysicalSettings('%s')\n", fileName);
  FILE* pF = fopen(fileName,"r");

  Entity* pPS = pCurrentSim->SimulatedEntity();
  Entity* pCS = pPS->GetComponent(CONTROLLED_SYSTEM);
  Entity* pACS = pCS->GetEntityConstValue(ATTACHED_ENTITY);
  Entity* pVineyardSet = pACS->GetComponent(VINEYARD_SET);
  Entity* pWeatherStationSet = pACS->GetComponent(WEATHER_STATION_SET);
  int nbWS = pWeatherStationSet->GetNumberOfElements();
  Entity* pDS = pPS->GetComponent(MANAGER);
  Entity* pStrategy = pDS->GetComponent(STRATEGY);

  
  char nomEA[10], nomPlot[50], refCad[30], commune[30], lieudit[30], cepage[30], occSol[10], age[10], IR[10], IC[10], taille[10], palissage[10], sol[30], cailloux[10], grpeGestionSol[30];  // modif JPR 1312
  float coordX, coordY, superficie;

  char nomEA_ref[10] = "\0";

  Entity* pVineyard = NULL;
  while(TRUE) {
	int i = fscanf(pF,
				   "%s %s %s %f %f %s %s %s %s %f %s %s %s %s %s %s %s %s",
				   nomEA, nomPlot, refCad, &coordX, &coordY, commune, lieudit, cepage, occSol, &superficie, age, IR, IC, taille, palissage, sol, cailloux, grpeGestionSol);  // modif JPR 1312
	if(i == EOF)
	  break;
//printf("\n\tstr1 : '%s' '%s' '%s' '%s' %f %f '%s' '%s'\n", nomEA, nomPlot, refCad, palissage, coordX, coordY, cailloux, grpeGestionSol);  // modif JPR 1312

	if(strncmp(nomEA, "//", 2)) { // + JPR 121107 : possibilit de lignes en commentaire
	  //
	  // si changement de nom de EA, instanciation d'une nouvelle EA
	  // et ajout comme element du VineyardSet
	  //
	  if(strcmp(nomEA, nomEA_ref)) {
		pVineyard = new Vineyard();
		pVineyard->SetInstanceName(nomEA);
//printf("\ncreation du Vineyard %x '%s'", pVineyard, nomEA);
		pVineyard->ClearEntityTabValues(GRAPE_VARIETY_LIST_ATTRIBUTE);
		pVineyardSet->AddElement(pVineyard);
		pVineyard->SetFloatConstValue(AREA_WITH_GRAPEVINE, (float)0.);
		pVineyard->SetFloatConstValue(AREA_WITH_TILLED_GRAPEVINE, (float)0.);

		strcpy(nomEA_ref, nomEA);
		//
		// instanciation du plan de conduite
		//
		Entity* pPlan = new Activity();
		pVineyard->SetEntityConstValue(CONTROL_PLAN_ATTRIBUTE, pPlan);
		Entity* pARB = new VineyardActivitiesResourcesBlock();
		pARB->SetEntityConstValue(ATTACHED_ENTITY, pVineyard);
		pARB->AddComponent(pPlan);
		Entity* pARBSet = pStrategy->GetComponent(ACTIVITIES_RESOURCES_BLOCK_SET);
		pARBSet->AddElement(pARB);
	  }
	  //
	  // instanciation d'une nouvelle parcelle
	  //
	  if(pVineyard
		 &&
		 ! strcmp(occSol, "Vigne")) {
		Entity* pPlot = new Plot(nomPlot);
//printf("\n\t -> plot %x '%s'", pPlot, nomPlot);
		pPlot->SetFloatConstValue(LATITUDE, coordX);
		pPlot->SetFloatConstValue(LONGITUDE, coordY);
		pPlot->SetFloatConstValue(AREA, superficie);
		float x = pVineyard->GetFloatConstValue(AREA_WITH_GRAPEVINE);
		pVineyard->SetFloatConstValue(AREA_WITH_GRAPEVINE, x + superficie);
		// (code cadastral not used)
		
		int yearOfPlantation = atoi(age);
		pPlot->SetIntConstValue(YEAR_OF_PLANTATION, yearOfPlantation);
		// si la plantation a lieu l'annee N de debut de simulation 
		// (ou bien l'annee N ou N+1, si la simulation commence apres le 01/07)
		// la valeur par d faut (-1.) PERCENT_PLANTED passe a 0.
		Date* dateDebutSim = pCurrentSim->BeginningDate();
		tm* pTm = StructDateToTm(dateDebutSim);
		int begSimMonth = pTm->tm_mon;
		int begSimYear = pTm->tm_year+1900;
		if((yearOfPlantation == begSimYear)
		   ||
		   ((begSimMonth > 6) && (yearOfPlantation == begSimYear+1)))
		  pPlot->SetFloatVarValue(PERCENT_PLANTED, (float)0.);
		delete pTm;
		
		pPlot->SetIntConstValue(ALLEY_WIDTH, atoi(IR));
		pPlot->SetIntConstValue(PLANT_SPACING, atoi(IC));
		pPlot->SetStringConstValue(PRUNING_MODE, taille);
		if(! strcmp(taille, "GOB")) {
		  //
		  // pas de palissage pour les parcelles taillees en gobelet
		  //
		  pPlot->SetFloatVarValue(PERCENT_TRELLISED, (float)-1.);
		}
		if(strcmp(cepage, "carignan")) { // + JPR 130126
		  //
		  // pas de ExtraPhytoTreatment pour les parcelles non en carignan
		  //
		  pPlot->SetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED, (float)-1.);
		}
		pPlot->SetStringConstValue(TRELLIS_MODE, palissage);
		pPlot->SetStringConstValue(SOIL_TYPE, sol);
		pPlot->SetStringConstValue(STONINESS, cailloux);
		pPlot->SetStringConstValue(VILLAGE, commune);
		pPlot->SetStringConstValue(PLACE_NAME, lieudit);
		pPlot->SetStringConstValue(LAND_USE, occSol);
		Entity* pVariety = GetNamedEntity("grapeVariety", cepage);
		pPlot->SetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE, 
								   pVariety);
		pVineyard->AddEntityValueElement(GRAPE_VARIETY_LIST_ATTRIBUTE,
										 pVariety);
		//
		// captage eventuel du groupe de gestion du sol (1312)
		// (si '*', le groupe sera determine dans AppControlSettings
		// en connaissance de l'ensemble des groupes de gestion
		pPlot->SetStringConstValue(SOIL_MANAGEMENT_GROUP_NAME, grpeGestionSol);
		//
		// etablissement de la WeatherStation la plus proche
		//
		Entity* pNearestWS = NULL;
		float distanceToNearestWS = D_FLOATMAX;
		for(int i=0;i<nbWS;i++) {
		  Entity* pWS_i = pWeatherStationSet->GetElement(i);
		  float distance_i = App_DistanceToWeatherStation(pWS_i, coordX, coordY);
		  if(distance_i < distanceToNearestWS) {
			pNearestWS = pWS_i;
			distanceToNearestWS = distance_i;
		  }
		}
		pPlot->SetEntityConstValue(WEATHER_STATION_ATTRIBUTE, pNearestWS);
		
		pVineyard->AddElement(pPlot); 
	  }
	} // fin if("//")
  } // fin while
  fclose(pF);
//printf("\nfin App_DepthBioPhysicalSettings('%s')", fileName);
}

float App_DistanceToWeatherStation (Entity* pTarget, float x, float y)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float result = D_FLOATMAX;

  float xRef = pTarget->GetFloatConstValue(LATITUDE);
  float yRef = pTarget->GetFloatConstValue(LONGITUDE);
  
  float xDelta = x - xRef;
  float yDelta = y - yRef;
  result = pow(pow(xDelta, (float)2.) + pow(yDelta, (float)2.), (float)0.5);

//printf("App_DistanceToWeatherStation('%s' %5.2f %5.2f,%5.2f %5.2f) returns %5.2f", pTarget->InstanceName(), xRef, yRef, x, y, result);
  return result;

}

char* App_EnumToChar (int value)
//---------------------------------------------
// Description  : mapping element d'enumeration -> chaine de car.
// Precondition :
// Retour       :
//---------------------------------------------
{
  char* result;
  if(value == 160) result = "BEG_PRUN";
  else if(value == 161) result = "END_DEBR";
  else if(value == 162) result = "END_HARV";
  else if(value == 163) result = "END_PRUN_THIN";
  else if(value == 164) result = "END_THIN";
  else if(value == 165) result = "END_THIN_CW";
  else if(value == 166) result = "END_THIN_FERT";
  else if(value == 167) result = "END_THIN_CW_FERT";
  else if(value == 180) result = "PART_CHEM";
  else if(value == 181) result = "PART_MECA";
  else if(value == 182) result = "PART_MECA_CHEM";
  else if(value == 183) result = "WHOLE_CHEM";
  else if(value == 184) result = "WHOLE_MECA";
  else if(value == 185) result = "WHOLE_MECA_CHEM";
  else if(value == 0) result = "R0";
  else if(value == 1) result = "R1";
  else if(value == 2) result = "RFLO";
  else if(value == 3) result = "F2";
  else if(value == 4) result = "F3";
  else if(value == 5) result = "FFLO";
  else if(value == 6) result = "S";
  else if(value == 130) result = "EARLY_FEB";
  else if(value == 131) result = "EARLY_MAR";
  else if(value == 132) result = "EARLY_APR";
  else if(value == 133) result = "EARLY_JUN";
  else if(value == 134) result = "EARLY_JUL";
  else if(value == 135) result = "EARLY_OCT";
  else if(value == 136) result = "EARLY_NOV";
  else if(value == 137) result = "EARLY_DEC";
  else if(value == 138) result = "MID_JAN";
  else if(value == 139) result = "MID_FEB";
  else if(value == 140) result = "MID_MAR";
  else if(value == 141) result = "MID_APR";
  else if(value == 142) result = "MID_MAY";
  else if(value == 143) result = "MID_JUL";
  else if(value == 144) result = "MID_OCT";
  else if(value == 145) result = "MID_NOV";
  else if(value == 146) result = "MID_DEC";
  else if(value == 147) result = "LATE_MAR";
  else if(value == 148) result = "LATE_OCT";
  else if(value == 149) result = "LATE_NOV";
  else if(value == 150) result = "LATE_DEC";
  else if(value == 151) result = "TEN_AUG";
  else if(value == 80) result = "ERR_NO_OT_SPEC";
  else if(value == 210) result = "OPERATIONS_FILE";
  else if(value == 211) result = "ENDING_TRACE_FILE";
  else if(value == 10) result = "NON";
  else if(value == 11) result = "OUI";
  else if(value == 120) result = "AUGUST";
  else if(value == 121) result = "NOVEMBER";
  else if(value == 122) result = "DECEMBER";
  else if(value == 123) result = "NOVEMBRE";
  else if(value == 124) result = "DECEMBRE";
  else if(value == 20) result = "BEFORE";
  else if(value == 21) result = "AFTER";
  else if(value == 30) result = "ANTI_MILDIOU";
  else if(value == 31) result = "REGULAR_PHYTO";
  else if(value == 32) result = "EXTRA_PHYTO";
  else if(value == 40) result = "E1";
  else if(value == 41) result = "E2";
  else if(value == 42) result = "E3";
  else if(value == 43) result = "G";
  else if(value == 44) result = "SG1";
  else if(value == 45) result = "SG4";
  else if(value == 90) result = "NONE";
  else if(value == 91) result = "ALL_PLOTS";
  else if(value == 92) result = "ALL_BUT_GOB";
  else if(value == 93) result = "LARGE";
  else if(value == 94) result = "ROYAT";
  else if(value == 95) result = "VIGOROUS";
  else if(value == 96) result = "ROYAT_VIGOROUS";
  else if(value == 50) result = "AUTUMN";
  else if(value == 51) result = "WINTER";
  else if(value == 52) result = "INITSPRING";
  else if(value == 53) result = "SPRING";
  else if(value == 170) result = "ONE_PLOT_PRUNED";
  else if(value == 171) result = "SURF_PRUNED_3";
  else if(value == 172) result = "SURF_PRUNED_12";
  else if(value == 173) result = "SURF_PRUNED_17";
  else if(value == 174) result = "SURF_PRUNED_MAJ";
  else if(value == 60) result = "TILLAGE";
  else if(value == 61) result = "CHEMICAL_WEEDING";
  else if(value == 62) result = "GRASS_COVER";
  else if(value == 63) result = "MIXED_TILLAGE_CW";
  else if(value == 65) result = "GRASS_COVERING";
  else if(value == 66) result = "GRASS_COVERING_TILLAGE";
  else if(value == 67) result = "CW_IN_SPACE";
  else if(value == 68) result = "CW_IN_TIME";
  else if(value == 69) result = "TOTAL_CW";
  else if(value == 70) result = "TOTAL_TILLAGE";
  else if(value == 72) result = "HAND_HELD";
  else if(value == 73) result = "BACK_CARRIED";
  else if(value == 74) result = "HORIZONTAL";
  else if(value == 75) result = "VERTICAL";
  else if(value == 76) result = "AIR_ASSISTED";
  else if(value == 77) result = "DEBRANCHER";
  else if(value == 190) result = "WEED_COVER";
  else if(value == 191) result = "OPTIMIZATION";
  else if(value == 192) result = "OPPORTUNITY";
  else if(value == 193) result = "LOW_RAIN_INTENSITY";
  else if(value == 194) result = "LOW_RAIN_INTENSITY_OR_LONG_DRY_PERIOD";
  else if(value == 195) result = "MEDIUM_RAIN_INTENSITY";
  else if(value == 196) result = "MEDIUM_RAIN_INTENSITY_OR_LONG_DRY_PERIOD";
  else if(value == 197) result = "HIGH_RAIN_INTENSITY";
  else if(value == 198) result = "HIGH_RAIN_INTENSITY_OR_LONG_DRY_PERIOD";
  else if(value == 199) result = "INIT_SPRING_TILLAGE";
  else if(value == 200) result = "WINTER_RAIN_BASED";
  else if(value == 201) result = "FARM_SCOPE";
  else if(value == 202) result = "PLOT_SCOPE";
  else if(value == 203) result = "PLOT_GROUP_SCOPE";
  else result = "??";
  
  return result;
}

int App_EnumToInt (char* token)
//---------------------------------------------
// Description  : mapping element d'enumeration -> entier
// Precondition :
// Retour       :
//---------------------------------------------
{
  int result;
  int resultFromDiese = O_EnumToInt(token);
  if(resultFromDiese >= 0) {
    result = resultFromDiese;
  }
  else if(!strcmp(token, "BEG_PRUN")) result = 160;
  else if(!strcmp(token, "END_DEBR")) result = 161;
  else if(!strcmp(token, "END_HARV")) result = 162;
  else if(!strcmp(token, "END_PRUN_THIN")) result = 163;
  else if(!strcmp(token, "END_THIN")) result = 164;
  else if(!strcmp(token, "END_THIN_CW")) result = 165;
  else if(!strcmp(token, "END_THIN_FERT")) result = 166;
  else if(!strcmp(token, "END_THIN_CW_FERT")) result = 167;
  else if(!strcmp(token, "PART_CHEM")) result = 180;
  else if(!strcmp(token, "PART_MECA")) result = 181;
  else if(!strcmp(token, "PART_MECA_CHEM")) result = 182;
  else if(!strcmp(token, "WHOLE_CHEM")) result = 183;
  else if(!strcmp(token, "WHOLE_MECA")) result = 184;
  else if(!strcmp(token, "WHOLE_MECA_CHEM")) result = 185;
  else if(!strcmp(token, "R0")) result = 0;
  else if(!strcmp(token, "R1")) result = 1;
  else if(!strcmp(token, "RFLO")) result = 2;
  else if(!strcmp(token, "F2")) result = 3;
  else if(!strcmp(token, "F3")) result = 4;
  else if(!strcmp(token, "FFLO")) result = 5;
  else if(!strcmp(token, "S")) result = 6;
  else if(!strcmp(token, "EARLY_FEB")) result = 130;
  else if(!strcmp(token, "EARLY_MAR")) result = 131;
  else if(!strcmp(token, "EARLY_APR")) result = 132;
  else if(!strcmp(token, "EARLY_JUN")) result = 133;
  else if(!strcmp(token, "EARLY_JUL")) result = 134;
  else if(!strcmp(token, "EARLY_OCT")) result = 135;
  else if(!strcmp(token, "EARLY_NOV")) result = 136;
  else if(!strcmp(token, "EARLY_DEC")) result = 137;
  else if(!strcmp(token, "MID_JAN")) result = 138;
  else if(!strcmp(token, "MID_FEB")) result = 139;
  else if(!strcmp(token, "MID_MAR")) result = 140;
  else if(!strcmp(token, "MID_APR")) result = 141;
  else if(!strcmp(token, "MID_MAY")) result = 142;
  else if(!strcmp(token, "MID_JUL")) result = 143;
  else if(!strcmp(token, "MID_OCT")) result = 144;
  else if(!strcmp(token, "MID_NOV")) result = 145;
  else if(!strcmp(token, "MID_DEC")) result = 146;
  else if(!strcmp(token, "LATE_MAR")) result = 147;
  else if(!strcmp(token, "LATE_OCT")) result = 148;
  else if(!strcmp(token, "LATE_NOV")) result = 149;
  else if(!strcmp(token, "LATE_DEC")) result = 150;
  else if(!strcmp(token, "TEN_AUG")) result = 151;
  else if(!strcmp(token, "ERR_NO_OT_SPEC")) result = 80;
  else if(!strcmp(token, "OPERATIONS_FILE")) result = 210;
  else if(!strcmp(token, "ENDING_TRACE_FILE")) result = 211;
  else if(!strcmp(token, "NON")) result = 10;
  else if(!strcmp(token, "OUI")) result = 11;
  else if(!strcmp(token, "AUGUST")) result = 120;
  else if(!strcmp(token, "NOVEMBER")) result = 121;
  else if(!strcmp(token, "DECEMBER")) result = 122;
  else if(!strcmp(token, "NOVEMBRE")) result = 123;
  else if(!strcmp(token, "DECEMBRE")) result = 124;
  else if(!strcmp(token, "BEFORE")) result = 20;
  else if(!strcmp(token, "AFTER")) result = 21;
  else if(!strcmp(token, "ANTI_MILDIOU")) result = 30;
  else if(!strcmp(token, "REGULAR_PHYTO")) result = 31;
  else if(!strcmp(token, "EXTRA_PHYTO")) result = 32;
  else if(!strcmp(token, "E1")) result = 40;
  else if(!strcmp(token, "E2")) result = 41;
  else if(!strcmp(token, "E3")) result = 42;
  else if(!strcmp(token, "G")) result = 43;
  else if(!strcmp(token, "SG1")) result = 44;
  else if(!strcmp(token, "SG4")) result = 45;
  else if(!strcmp(token, "NONE")) result = 90;
  else if(!strcmp(token, "ALL_PLOTS")) result = 91;
  else if(!strcmp(token, "ALL_BUT_GOB")) result = 92;
  else if(!strcmp(token, "LARGE")) result = 93;
  else if(!strcmp(token, "ROYAT")) result = 94;
  else if(!strcmp(token, "VIGOROUS")) result = 95;
  else if(!strcmp(token, "ROYAT_VIGOROUS")) result = 96;
  else if(!strcmp(token, "AUTUMN")) result = 50;
  else if(!strcmp(token, "WINTER")) result = 51;
  else if(!strcmp(token, "INITSPRING")) result = 52;
  else if(!strcmp(token, "SPRING")) result = 53;
  else if(!strcmp(token, "ONE_PLOT_PRUNED")) result = 170;
  else if(!strcmp(token, "SURF_PRUNED_3")) result = 171;
  else if(!strcmp(token, "SURF_PRUNED_12")) result = 172;
  else if(!strcmp(token, "SURF_PRUNED_17")) result = 173;
  else if(!strcmp(token, "SURF_PRUNED_MAJ")) result = 174;
  else if(!strcmp(token, "TILLAGE")) result = 60;
  else if(!strcmp(token, "CHEMICAL_WEEDING")) result = 61;
  else if(!strcmp(token, "GRASS_COVER")) result = 62;
  else if(!strcmp(token, "MIXED_TILLAGE_CW")) result = 63;
  else if(!strcmp(token, "GRASS_COVERING")) result = 65;
  else if(!strcmp(token, "GRASS_COVERING_TILLAGE")) result = 66;
  else if(!strcmp(token, "CW_IN_SPACE")) result = 67;
  else if(!strcmp(token, "CW_IN_TIME")) result = 68;
  else if(!strcmp(token, "TOTAL_CW")) result = 69;
  else if(!strcmp(token, "TOTAL_TILLAGE")) result = 70;
  else if(!strcmp(token, "HAND_HELD")) result = 72;
  else if(!strcmp(token, "BACK_CARRIED")) result = 73;
  else if(!strcmp(token, "HORIZONTAL")) result = 74;
  else if(!strcmp(token, "VERTICAL")) result = 75;
  else if(!strcmp(token, "AIR_ASSISTED")) result = 76;
  else if(!strcmp(token, "DEBRANCHER")) result = 77;
  else if(!strcmp(token, "WEED_COVER")) result = 190;
  else if(!strcmp(token, "OPTIMIZATION")) result = 191;
  else if(!strcmp(token, "OPPORTUNITY")) result = 192;
  else if(!strcmp(token, "LOW_RAIN_INTENSITY")) result = 193;
  else if(!strcmp(token, "LOW_RAIN_INTENSITY_OR_LONG_DRY_PERIOD")) result = 194;
  else if(!strcmp(token, "MEDIUM_RAIN_INTENSITY")) result = 195;
  else if(!strcmp(token, "MEDIUM_RAIN_INTENSITY_OR_LONG_DRY_PERIOD")) result = 196;
  else if(!strcmp(token, "HIGH_RAIN_INTENSITY")) result = 197;
  else if(!strcmp(token, "HIGH_RAIN_INTENSITY_OR_LONG_DRY_PERIOD")) result = 198;
  else if(!strcmp(token, "INIT_SPRING_TILLAGE")) result = 199;
  else if(!strcmp(token, "WINTER_RAIN_BASED")) result = 200;
  else if(!strcmp(token, "FARM_SCOPE")) result = 201;
  else if(!strcmp(token, "PLOT_SCOPE")) result = 202;
  else if(!strcmp(token, "PLOT_GROUP_SCOPE")) result = 203;
  else {
    printf("\nSymbole d'numration inconnu : '%s'\n", token);
  	exit(0);
  }
  
// plus grand entier en cours : 211
  
  return result;
}

void App_Exception (int excep, int clock, Entity* pE)
//---------------------------------------------
// Nom Fonction : 'app_exception'
//---------------------------------------------
// Description  : Leve les exceptions specifiques de l'application.
//                L'argument est un symbole de l'enumeration ExceptionIds.
// Precondition : 
// Retour       : arret du programme
//---------------------------------------------
{
  switch (excep) {
    case ERR_NO_OT_SPEC : 
         printf("\nt = %d Erreur de specification pour l'activite '%s' : \nle type d'operation n'a pas ete precise !!!\n", clock, pE->InstanceName());
         break;
    default :
         printf("\nErreur :\nle programme ne peut pas continuer,\npour une raison non specifiee dans la fonction globale app_exception\n");	 
  }
  exit(0);
}

bool App_FloatEQ (float left, float right)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float delta = gFloatingPointEqualityTolerance;
  return (left < right+delta) && (left > right-delta);
}

bool App_FloatGT (float left, float right)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float delta = gFloatingPointEqualityTolerance;
  return (left > right+delta);
}

bool App_FloatLT (float left, float right)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float delta = gFloatingPointEqualityTolerance;  
  return (left < right-delta);
}

bool App_FloatNEQ (float left, float right)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float delta = gFloatingPointEqualityTolerance;
  return (left < right-delta) || (left > right+delta);
}

int App_GetAllocationExclusivity(Entity* pARB, char* nomClasse)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int result = FALSE;

  Entity* ap_optionSet //AllocationPriorityOptionSet
	= pARB->GetEntityConstValue(ALLOCATION_PRIORITY_OPTION_SET_ATTRIBUTE);
  Entity* ap_subset = (Entity*)ap_optionSet->GetNamedElement(nomClasse);

  if(! ap_subset) {
	printf("\n'%s' App_GetAllocationPriority(%s) : infos priorites non trouvees : %s\n", ap_optionSet->InstanceName(), nomClasse);
	exit(0);
  }

  result = ap_subset->GetIntConstValue(IS_ALLOCATION_EXCLUSIVE);
//printf("\nApp_GetAllocationExclusivity(%s, %s) returns %d", pARB>InstanceName(), nomClasse, result);
  return result;
}

int App_GetAllocationPriority(Entity* pVineyard, char* nomClasse, UserDescriptorId descId, int numPhase)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int result = 50;

  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pConduite->GetSuperEntity();
  Entity* ap_optionSet //AllocationPriorityOptionSet
	= pARB->GetEntityConstValue(ALLOCATION_PRIORITY_OPTION_SET_ATTRIBUTE);
  Entity* ap_subset = (Entity*)ap_optionSet->GetNamedElement(nomClasse);

  if(! ap_subset) {
	printf("\n'%s' App_GetAllocationPriority(%s) : priorites non trouvees : %s\n", ap_optionSet->InstanceName(), DescIdToCharTab[descId], nomClasse);
	exit(0);
  }

  pIntTab* ap_tab = ap_subset->GetIntTabValue(descId);
  if(numPhase < 1 ) {
	printf("\nApp_GetAllocationPriority(%s, %d) : numero de phase illegal : %d\n", nomClasse,  numPhase);
	exit(0);
  }
  result = ap_tab->get_element(numPhase-1);

  if(result < 0) {
	printf("\nApp_GetAllocationPriority(%s, %d) : priorite illegale : %d\n", nomClasse,  numPhase, result);
	exit(0);
  }
//printf("\nApp_GetAllocationPriority(%s, %s, %s, %d) returns %d", pVineyard->InstanceName(), nomClasse, DescIdToCharTab[descId], numPhase, result);
  return result;
}

float App_GetAlreadyChosenActivitiesDuration (pEntityTab* pInCoursePlots, Entity* pChantier, char* optionSerPar, char* manualMotorizedValue, float passedRowFrequency, float manualNominalSpeed, float motorizedNominalSpeed)
//---------------------------------------------
// Description  : renvoie la prvision de la dure consomme par les oprations
//              : en cours
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float result = (float)0.0;
  UserClassId chantierClassId = pChantier->ClassId();

  UserClassId otClassId = -9; // valeur par dfaut pour les chantiers SerialManual

  int nbAlreadyChosen = pInCoursePlots->size();
  for(int i=0;i<nbAlreadyChosen;i++) {
	Entity* pPlot_i = (Entity*)pInCoursePlots->get_element(i);
	float percentAchieved = (float)0.;
	switch (chantierClassId) {
	case SERIAL_PLANTATIONS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_PLANTED);
		otClassId = PLANTATION_OPERATION; break;}
	case SERIAL_FERTILIZATIONS :
	case CONCURRENT_FERTILIZATIONS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_FERTILIZED); 
		otClassId = FERTILIZATION_OPERATION; break;}
	case SERIAL_PRUNINGS :
	case CONCURRENT_PRUNINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_PRUNED); 
		otClassId = PRUNING_OPERATION; break;}
	case SERIAL_SHOOT_THINNINGS :
	case CONCURRENT_SHOOT_THINNINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_SHOOT_THINNED); 
		otClassId = SHOOT_THINNING_OPERATION; break;}
	case SERIAL_AUTUMN_TILLAGES : 
	case CONCURRENT_AUTUMN_TILLAGES : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_AUTUMN_TILLED); 
		otClassId = TILLAGE_OPERATION; break;}
	case SERIAL_WINTER_TILLAGES :
	case CONCURRENT_WINTER_TILLAGES : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_WINTER_TILLED);  
		otClassId = TILLAGE_OPERATION; break;}
	case SERIAL_INIT_SPRING_TILLAGES :
	case CONCURRENT_INIT_SPRING_TILLAGES : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_INIT_SPRING_TILLED);  
		otClassId = TILLAGE_OPERATION; break;}
	case SERIAL_SPRING_TILLAGES :
	case CONCURRENT_SPRING_TILLAGES : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_SPRING_TILLED);  
		otClassId = TILLAGE_OPERATION; break;}  

	case SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_REGULAR_PHYTO_TREATED); break;} // modif JPR 130130
	case SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS :
	case CONCURRENT_REGULAR_PHYTO_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_REGULAR_PHYTO_TREATED);    
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

	case SERIAL_EXTRA_PHYTO_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED); break;} // modif JPR 130130
	case CONCURRENT_EXTRA_PHYTO_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED);     
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

	case SERIAL_ANTI_MILDEW_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED); break;} // modif JPR 130130
	case CONCURRENT_ANTI_MILDEW_TREATMENTS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED);     
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

 	case SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_SPRING_WEEDED); break;}
	case SERIAL_MOTORIZED_SPRING_CHEMICAL_WEEDINGS :
	case CONCURRENT_SPRING_CHEMICAL_WEEDINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_SPRING_WEEDED);      
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

	case SERIAL_MANUAL_CHEMICAL_WEEDINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_WEEDED); break;}
	case SERIAL_MOTORIZED_CHEMICAL_WEEDINGS :
	case CONCURRENT_CHEMICAL_WEEDINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_WEEDED);     
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

	case SERIAL_MANUAL_DEBRANCHINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_DEBRANCHED);break;}
	case SERIAL_MOTORIZED_DEBRANCHINGS :
	case CONCURRENT_DEBRANCHINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_DEBRANCHED);       
		otClassId = MOTORIZED_SPRAYING_OPERATION; break;}

	case SERIAL_CLIPPINGS :
	case CONCURRENT_CLIPPINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_CLIPPED);  
		otClassId = CLIPPING_OPERATION; break;}
	case SERIAL_TRELLISINGS :
	case CONCURRENT_TRELLISINGS : {percentAchieved = pPlot_i->GetFloatVarValue(PERCENT_TRELLISED);  
		otClassId = TRELLISING_OPERATION;  break;}
	default : {
	}
	}
	float duration_i = App_GetExpectedDuration(pPlot_i,
											   FALSE, // isPlotMotorizable
											   otClassId,
											   optionSerPar,
											   manualMotorizedValue, 
											   passedRowFrequency,
											   manualNominalSpeed,
											   motorizedNominalSpeed)
	  * ((float)1. - percentAchieved);
	result+= duration_i;
  }
//printf("\nalreadyChosenDuration = %f", result);
  return result;
}

int App_GetDistributedActivitySetType (Entity* pObj)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 130227 : ANTI_MILDIOU, EXTRA_PHYTO, REGULAR_PHYTO ou -9
//---------------------------------------------
{
//printf("\nentree App_GetDistributedActivitySetType('%s)", pObj->InstanceName());
  int typeChantier = -9;  // modif JPR 130227
  Entity* pIterate;
  Entity* pChantier = NULL;
  if(pObj->IsInstanceOf(ACTIVITY)) {
	pChantier = pObj;
	pIterate = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, 
													FALSE);
  }
  else if(pObj->IsInstanceOf(OPERATION)) {
	Entity* pInst = pObj->GetEntityVarValue(INSTRUCTION_CONTAINER);
	pIterate = (Entity*)pInst->GetFirstContainer(ACTIVITY_ITERATION, 
											 FALSE);
  }
  else {
	printf("\n!!! App_GetDistributedActivitySetType('%s) : type d'objet non gere.\n", pObj->InstanceName());
	exit(0);
  }
//printf("\n\tpIterate : %x pChantier : %s", pIterate, pChantier->InstanceName());
				
  if(pIterate) {
	if(pIterate->IsInstanceOf(REGULAR_PHYTO_TREATMENTS_ITERATION)) {
	  typeChantier = REGULAR_PHYTO;
	}
	else if(pIterate->IsInstanceOf(EXTRA_PHYTO_TREATMENTS_ITERATION)) {
	  typeChantier = EXTRA_PHYTO;
	}
  }
  else {  // modif JPR 130227
	if(pChantier->IsInstanceOf(SERIAL_ANTI_MILDEW_TREATMENTS)
	   ||
	   pChantier->IsInstanceOf(CONCURRENT_ANTI_MILDEW_TREATMENTS))
	  typeChantier = ANTI_MILDIOU;
  }
//printf("\nApp_GetDistributedActivitySetType('%s) returns %d", pObj->InstanceName(), typeChantier);
  return typeChantier;
}

float App_GetExpectedDuration (Entity* pPlot, bool isPlotMotorizable, UserClassId otClassId, char* optionSerPar, char* manualMotorizedValue, float passedRowFrequency, float manualNominalSpeed, float motorizedNominalSpeed)
//---------------------------------------------
// Description  : renvoie la dure prvisible d'une opration donne sur une 
//              : parcelle donne 
// Precondition : 
// Retour       :       
// Comment      : modif JPR 130130 sur le cas manualMotorizedValue = ""
//---------------------------------------------
{
  float result;
  float alleyWidth =(float) pPlot->GetIntConstValue(ALLEY_WIDTH) / (float)100.;
  float vitesseOperation;

  int cas;
  //
  // La formule pour la vitesse est diffrente selon que l'opration est
  // motorise ou manuelle. mais quand le chantier est en parallle, 
  // l'indicateur manuel/motoris est vide. On choisit alors la formule
  // en fonction du caractre mororisable ou non de la parcelle.
  //
  if(! strcmp(optionSerPar, "PAR")
	 ||
	 ! strcmp(manualMotorizedValue, "")) {
	//
	// formule de la vitesse selon que la parcelle est motorisable ou pas
	//
	if(otClassId >=0) {
	  pPlot->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							OPERATION_CLASS_ARGUMENT,
							otClassId);
	  isPlotMotorizable =
		pPlot->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	}
	else {
	  // isPlotMotorizable est alors pass en paramtre
	}
	if(isPlotMotorizable) {
	  cas = 1;  // f(motorizedNominalSpeed)
	}
	else {
	  cas = 2;  // f(manualNominalSpeed)
	}
  }
  else {    // "SER" && ("MOTORIZED" ...
	if(! strcmp(manualMotorizedValue, "MOTORIZED")) {
	  cas = 1;
	}
	else {  //            ou "MANUAL")
	  cas = 2;
	}
  }
  switch(cas) {
  case 1 : {
//printf("\n\talleyWidth : %f\t passedRowFrequency : %f", alleyWidth,  passedRowFrequency);
	vitesseOperation = 
	  alleyWidth * motorizedNominalSpeed / 12 / passedRowFrequency;
	break;
  }
  case 2 : {
	float plantSpacing = pPlot->GetIntConstValue(PLANT_SPACING) / (float)100.;
//printf("\n\talleyWidth : %f\tplantSpacing : %f", alleyWidth, plantSpacing);
	vitesseOperation = 
	  alleyWidth * plantSpacing * manualNominalSpeed / (float)10000.;
	break;
  }
  }

  float area = pPlot->GetFloatConstValue(AREA);
//printf("\n\tarea : %f\tvitesseOperation : %f", area, vitesseOperation);
  result = area / vitesseOperation;
  /*
  if(otClassId > -1)
	printf("\n'%s' ser/par : '%s' isPlotMotorizable : %d ot : '%s', expectedDuration = %f", pPlot->InstanceName(), optionSerPar, isPlotMotorizable, ClassIdToCharTab[otClassId], result);
  else
	printf("\n'%s' ser/par : '%s' isPlotMotorizable : %d ot : '%s', expectedDuration = %f", pPlot->InstanceName(), optionSerPar, isPlotMotorizable, "", result);
  */
  return result;
}

float App_GetFloatDecisionOption (Entity* pVineyard, UserDescriptorId descId)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float result;

  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pConduite->GetSuperEntity();
  Entity* dec_optionSet //DecisionOptionSet
	= pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
  result = dec_optionSet->GetFloatConstValue(descId);
  
//printf("\nApp_GetFloatDecisionOption ('%s', %s) returns %f", pVineyard->InstanceName(), DescIdToCharTab[descId], result);
  return result;



}

float App_GetFloatPestInfo (Vineyard* pEA, UserDescriptorId descId)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float result = -D_FLOATMAX;
  
  Entity* pVineyardSet = (Entity*)pEA->GetSuperSet();

  BasicEntity* pPestMemory = 
	pVineyardSet->GetEntityConstValue(PEST_INFO_MEMORY_ATTRIBUTE);

  if(pPestMemory->GetNumberOfElements() > 0) {
	Entity* pPestMemoryItem = pPestMemory->GetElement(0);  // le plus recent, par construction 
	Descriptor* pCD = pPestMemoryItem->GetDescriptor(descId);
	if (pCD->ClassType() != FLOAT)
	  BadDescriptorValueType(pVineyardSet, pCD->ClassName(), "App_GetFloatPestInfo");

	result = ((FloatConstantDescriptor*)pCD)->GetFloatValue();
  }
  else {
	//printf("\nApp_GetFloatPestInfo('%s', .) : pas d'information disponible.\n", pEA->InstanceName());
	//exit(0);
  }
//printf("\nApp_GetFloatPestInfo('%s', %s) returns %d", pEA->InstanceName(), DescIdToCharTab[descId], result);
  return result;
}

int App_GetIntDecisionOption (Entity* pVineyard, UserDescriptorId descId)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int result;

  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pConduite->GetSuperEntity();
  Entity* dec_optionSet //DecisionOptionSet
	= pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
  result = dec_optionSet->GetIntConstValue(descId);
  
//printf("\nApp_GetIntDecisionOption ('%s', %s) returns %d", pVineyard->InstanceName(), DescIdToCharTab[descId], result);
  return result;
}

float App_GetIntPestHistory (Vineyard* pEA, UserDescriptorId descId)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  float result = (float)-9.;
  
  Entity* pVineyardSet = (Entity*)pEA->GetSuperSet();

  BasicEntity* pPestMemory = 
	pVineyardSet->GetEntityConstValue(PEST_INFO_MEMORY_ATTRIBUTE);

  int now = pCurrentSim->Clock();

  int nbItems = pPestMemory->GetNumberOfElements();
//printf("\n\tnbItems -> %d", nbItems);
  int total = 0;
  int prevInstant = 0;
  for(int k=0;k<nbItems;k++) {
	Entity* pPestMemoryItem_k = pPestMemory->GetElement(k);
	Descriptor* pCD = pPestMemoryItem_k->GetDescriptor(descId);
	if (pCD->ClassType() != INT)
	  BadDescriptorValueType(pVineyardSet, pCD->ClassName(), "App_GetIntPestInfo");
	int instant_k = pPestMemoryItem_k->GetIntConstValue(INSTANT_ATTRIBUTE);
	int value_k = ((IntConstantDescriptor*)pCD)->GetIntValue();
//printf("\n\tinstant_k = %d value_k = %d", instant_k, value_k);
	int ref = now;
	if(k > 0) {
	  ref = prevInstant;
	}
	int timeInterval = ClockIntervalToTimeInterval(ref - instant_k);
//printf("\n\ttimeInterval = %d", timeInterval);
	total += value_k * timeInterval;  // secondes
//printf("\n\ttotal -> %d", total);
	prevInstant = instant_k;
	//
	// arret si pestInfo trop ancienne
	//
	int memoryScope = gIntParam_virtualManager_pestMemoryScope_;  // jours
	int seuil = memoryScope * 24;  // heures
	int delta = (now - instant_k);
//printf("\n\tmemoryScope = %d delta = %d seuil = %d", memoryScope, delta, seuil);
	if(delta > seuil)
	  break;
  }
  //
  // calcul moyenne
  //
//printf("\n\t(float)total = %f now = %d prevInstant = %d", (float)total, now, prevInstant);
  result = ((float)total) / (now - prevInstant) / (float)3600;

//printf("\nApp_GetIntPestHistory('%s', %s) returns %f", pEA->InstanceName(), DescIdToCharTab[descId], result);
  return result;
}

int App_GetIntPestInfo (Vineyard* pEA, UserDescriptorId descId)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int result = -D_INTMAX;
  
  Entity* pVineyardSet = (Entity*)pEA->GetSuperSet();

  BasicEntity* pPestMemory = 
	pVineyardSet->GetEntityConstValue(PEST_INFO_MEMORY_ATTRIBUTE);

  if(pPestMemory->GetNumberOfElements() > 0) {
	Entity* pPestMemoryItem = pPestMemory->GetElement(0);  // le plus recent, par construction 
	Descriptor* pCD = pPestMemoryItem->GetDescriptor(descId);
	if (pCD->ClassType() != INT)
	  BadDescriptorValueType(pVineyardSet, pCD->ClassName(), "App_GetIntPestInfo");

	result = ((IntConstantDescriptor*)pCD)->GetIntValue();
  }
  else {
	//printf("\nApp_GetIntPestInfo('%s', .) : pas d'information disponible.\n", pEA->InstanceName());
	//exit(0);
  }
//printf("\nApp_GetIntPestInfo('%s', %s) returns %d", pEA->InstanceName(), DescIdToCharTab[descId], result);
  return result;
}

pEntityTab* App_GetIsoAgeingEntityList (Entity* pEA, Entity* pVariety, Entity* pWS)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : un tableau d'entites a desallouer par le code client
//---------------------------------------------
{
  pEntityTab* result = new pEntityTab();
  
  pEntityTab* pIsoAgeingEntityTab = 
	pEA->GetEntityTabConstValue(ISO_AGEING_ENTITY_SET_ATTRIBUTE);
  
  int nbElem = pIsoAgeingEntityTab->size();
  for(int i=0;i<nbElem;i++) {
	Entity* pIsoAgeingEntity = (Entity*)pIsoAgeingEntityTab->get_element(i);
	if((! pVariety
		||
		pIsoAgeingEntity->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE) == pVariety)
	   &&
	   (! pWS
		||
		pIsoAgeingEntity->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE) == pWS))
	  result->push_back(pIsoAgeingEntity);
  }
//printf("\nApp_GetIsoAgeingEntityList('%s','%x','%x') returns :", pEA->InstanceName(), pVariety, pWS);result->display_names();
  return result;
}

int App_GetOperationPriority (Entity* pVineyard, char* nomClasse, UserDescriptorId descId, int numPhase)
//---------------------------------------------
// Description  : 
// Precondition :  
// Precondition : nomClasse est le nom d'une classe d'activits
// Retour       : 
//---------------------------------------------
{
  int result = 50;

  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pConduite->GetSuperEntity();
  Entity* op_optionSet //OperationPriorityOptionSet
	= pARB->GetEntityConstValue(OPERATION_PRIORITY_OPTION_SET_ATTRIBUTE);
  Entity* op_subset = NULL;
  int nbElem = op_optionSet->GetNumberOfElements();
  for(int i=0;i<nbElem;i++) {
	Entity* pElem_i = (Entity* )op_optionSet->GetElement(i); // fichier
	char* optClassName = pElem_i->InstanceName();
	UserClassId optClassId =  GetClassSymbol(optClassName);
	UserClassId argClassId = GetClassSymbol(nomClasse);  // argument
	if((optClassId == argClassId)
	   ||
	   IsAncestorOf(optClassId, argClassId)) {
	  op_subset = pElem_i;
	  break;
	}
  }

  if(! op_subset) {
	printf("\n'%s' App_GetOperationPriority(%s) : priorites non trouvees : %s\n", op_optionSet->InstanceName(), DescIdToCharTab[descId], nomClasse);
	exit(0);
  }

  pIntTab* op_tab = op_subset->GetIntTabValue(descId);
  if(numPhase < 1 ) {
	printf("\nApp_GetOperationPriority(%s, %d) : numero de phase illegal : %d\n", nomClasse,  numPhase);
	exit(0);
  }
  result = op_tab->get_element(numPhase-1);

  if(result < 0) {
	printf("\nApp_GetOperationPriority(%s, %d) : priorite illegale : %d\n", nomClasse,  numPhase, result);
	exit(0);
  }
//printf("\nApp_GetOperationPriority(%s, %s, %s, %d) returns %d", pVineyard->InstanceName(), nomClasse, DescIdToCharTab[descId], numPhase, result);
  return result;
}

int App_GetPhaseIndex (Activity* pAct)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int result = -9;
//printf("\nApp_GetPhaseIndex('%s')", pAct->InstanceName());
  Vineyard* pVineyard = (Vineyard*)App_GetVineyard((Activity*)pAct);
  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);

  pEntityTab phaseTab = pConduite->GetElementTab();
//printf("\n\tphaseTab : ");phaseTab.display_names();
  pEntityTab candidateTab = pAct->GetContainerTab(ACTIVITY);
  candidateTab.push_back(pAct);
//printf("\n\tcandidateTab : ");candidateTab.display_names();
  int nbCandidate = candidateTab.size();
  for(int i=nbCandidate-1;i>=0;i--) {
	BasicEntity* pCandidate_i = candidateTab[i];
	result = GetPosition(phaseTab, pCandidate_i);
	if(result >= 0) {
	  break;
	};
  }
//printf("\treturns %d", result);
  return result;
}

int App_GetResourceNumberForDistributedActivitySet(Entity* pVineyard, Entity* pChantier)
//---------------------------------------------
// Description  : renvoie le nombre de ressources disponibles (MO, tracteurs)
//                pour estimer le nombre d'activits qu'il convient d'allouer
//                en dbut de plage de travail
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  UserClassId chantierClassId = pChantier->ClassId();
  int result = App_GetResourceNumberFromDistributedActivitySetClassId(pVineyard, chantierClassId);
  return result;
}

int App_GetResourceNumberFromDistributedActivitySetClassId(Entity* pVineyard, UserClassId chantierClassId)
//---------------------------------------------
// Description  : renvoie ...
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int result;
  EntitySpec* pES = NULL;
  int isMotorized;;
  pEntityTab* pWorkerList = new pEntityTab();
  pEntityTab* tmp;

  switch (chantierClassId) {
	// toutes activits MANUELLES
  case SERIAL_PLANTATIONS : {
	pES = new ManualWorkerEntitySpec(); 
	pES->ReferentEntity(pVineyard);
	pES->Expand();	// + JPR 130121
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 0; 
	break;
  }
  case SERIAL_PRUNINGS :
  case CONCURRENT_PRUNINGS : {
	pES = new PruningExecutorEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();	// + JPR 130121
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 0; 
	break;
  }
  case SERIAL_TRELLISINGS :
  case CONCURRENT_TRELLISINGS : {
	pES = new GreenWorkExecutorEntitySpec(); 
	pES->ReferentEntity(pVineyard);
	pES->Expand();	// + JPR 130121
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 0; 
	break;
  }

	// toutes activits MOTORISEES
  case SERIAL_FERTILIZATIONS :
  case CONCURRENT_FERTILIZATIONS :
  case SERIAL_SHOOT_THINNINGS :
  case CONCURRENT_SHOOT_THINNINGS :
  case SERIAL_CLIPPINGS :
  case CONCURRENT_CLIPPINGS :
  case SERIAL_AUTUMN_TILLAGES : 
  case CONCURRENT_AUTUMN_TILLAGES :
  case SERIAL_WINTER_TILLAGES :
  case CONCURRENT_WINTER_TILLAGES :
  case SERIAL_INIT_SPRING_TILLAGES :
  case CONCURRENT_INIT_SPRING_TILLAGES :
  case SERIAL_SPRING_TILLAGES :
  case CONCURRENT_SPRING_TILLAGES :
  case SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS :
  case SERIAL_MOTORIZED_SPRING_CHEMICAL_WEEDINGS :
  case SERIAL_MOTORIZED_CHEMICAL_WEEDINGS :
  case SERIAL_MOTORIZED_DEBRANCHINGS : {
	pES = new TractorDriverEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 1;
	break;
  } 

	// activits MIXTES MANUELLES (chimique ou mcanique) + MOTORISEES
  case CONCURRENT_DEBRANCHINGS : {
	pES = new TractorDriverEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	pES = new ManualWorkerEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	pES = new GreenWorkExecutorEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = -1;
	break;
  } 

	// activits MIXTES MANUELLES + MOTORISEES
  case CONCURRENT_REGULAR_PHYTO_TREATMENTS :
  case CONCURRENT_EXTRA_PHYTO_TREATMENTS :
  case CONCURRENT_ANTI_MILDEW_TREATMENTS :
  case CONCURRENT_SPRING_CHEMICAL_WEEDINGS :
  case CONCURRENT_CHEMICAL_WEEDINGS :
  case SERIAL_EXTRA_PHYTO_TREATMENTS :
  case SERIAL_ANTI_MILDEW_TREATMENTS : { 
	pES = new TractorDriverEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	pES = new ManualWorkerEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = -1;
	break;
  }

	// toutes activits MANUELLES
  case SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS :
  case SERIAL_MANUAL_SPRING_CHEMICAL_WEEDINGS :
  case SERIAL_MANUAL_CHEMICAL_WEEDINGS : {
	pES = new ManualWorkerEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 0;
	break;
  }

	// toutes activits MANUELLES (chimique ou mcanique)
  case SERIAL_MANUAL_DEBRANCHINGS : {
	pES = new ManualWorkerEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	pES = new GreenWorkExecutorEntitySpec();
	pES->ReferentEntity(pVineyard);
	pES->Expand();
	tmp = pES->GetExpansion();
	pWorkerList->push_back_ifnew(*tmp);
	isMotorized = 0;
	break;
  }
  default : {
	printf("\nApp_GetResourceNumberForDistributedActivitySet ne sait pas grer le chantier de classe '%ds'\n", ClassIdToCharTab[chantierClassId]);
	exit(0);
  }
  }
  //
  // quantit de ressources dispo pour le travail en parallle
  // pour le calcul des heures de travail disponibles DTotW
  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pPlan->GetSuperEntity();
  Entity* pMultiPool = pARB->GetComponent(RESOURCE_POOL_CONJUNCTION);
  
  // nb workers
  int nbWorkers = pWorkerList->size();
  int nbAvailableWorkers = 0;
  for(int i=0;i<nbWorkers;i++) {
	Entity* pMO_i = (Entity*)pWorkerList->get_element(i);
	if(pMO_i->GetIntVarValue(AVAILABILITY_STATUS))
	  nbAvailableWorkers++;
  }
  delete pWorkerList;
  
  // nb tractors
  Entity* pEquipmentPool = pMultiPool->GetElement(1); // par convention
  int nbTractors = pEquipmentPool->GetDepthElementTab(TRACTOR).size();

  switch(isMotorized) {
  case 0 : {  // chantiers manuels
	result = nbAvailableWorkers;
	break;
  }
  case 1 :  {  // chantiers motoriss
	result = nbTractors;
	if(nbAvailableWorkers < result)
	  result = nbAvailableWorkers;
	break;
  }
  case -1 : {  // chantiers mixtes
	result = nbAvailableWorkers;
	break;
  }
  }
  
//printf("\nnbAvailableWorkers = %d nbTractors = %d isMotorized = %d -> nbRsc = %d\n", nbAvailableWorkers, nbTractors, isMotorized, result);
};

char* App_GetStringDecisionOption (Entity* pVineyard, UserDescriptorId descId)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  char* result;

  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pConduite->GetSuperEntity();
  Entity* dec_optionSet //DecisionOptionSet
	= pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
  result = dec_optionSet->GetStringConstValue(descId);
  
//printf("\nApp_GetIntDecisionOption ('%s', %s) returns '%s'", pVineyard->InstanceName(), DescIdToCharTab[descId], result);
  return result;
}

char* App_GetStringWorkOrganizationOption (Entity* pVineyard, int phaseIndex, UserDescriptorId descId)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  char* result;

  Entity* pConduite = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pConduite->GetSuperEntity();
  Entity* wo_optionSet //WorkOrganizationOptionSet
	= pARB->GetEntityConstValue(WORK_ORGANIZATION_OPTION_SET_ATTRIBUTE);
  Entity* wo_optionSubset = wo_optionSet->GetElement(phaseIndex);

  result = 
	wo_optionSubset->GetStringConstValue(descId);
  
//printf("\nApp_GetStringWorkOrganizationOption ('%s', phase=%d, %s) returns %d", pVineyard->InstanceName(), phaseIndex, DescIdToCharTab[descId], result);

  return result;
}

VarietyGroupSet* App_GetVarietyGroupSet (int powderyMildewManagement)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* result;
  switch (powderyMildewManagement) {
  case E1 : {
	result = GetNamedEntity("varietyGroupSet", "varGroupSetE1");
	break;
  }
  case E2 : {
	result = GetNamedEntity("varietyGroupSet", "varGroupSetE2");
	break;
  }
  case E3 : {
	result = GetNamedEntity("varietyGroupSet", "varGroupSetE3");
	break;
  }
  case G : {
	result = GetNamedEntity("varietyGroupSet", "varGroupSetG");
	break;
  }
  case SG1 : {
	result = GetNamedEntity("varietyGroupSet", "varGroupSetSG1");
	break;
  }
  case SG4 : {
	result = GetNamedEntity("varietyGroupSet", "varGroupSetSG4");
	break;
  }
	
  } // fin switch

//printf("\nApp_GetVarietyGroupSet(%d) returns '%s'", powderyMildewManagement, result->InstanceName());
  return (VarietyGroupSet*)result;
}

Vineyard* App_GetVineyard (Activity* pInst)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : l'exploitation dont le plan de gestion contient pInst
//---------------------------------------------
{
  Vineyard* result;

  Activity* pPlan = pInst->RootActivity();
  result = (Vineyard*)pPlan->GetEntityConstValue(VINEYARD_ATTRIBUTE);   // provisoire

//printf("\nApp_GetVineyard('%s') returns '%s'", pInst->InstanceName(), result->InstanceName());

  return result;
  //
  // un codage adhoc ne serait-il pas plus efficace :
  // remont e de l'arbre jusqu'  trouver une Activity qui a un descripteur
  // VINEYARD_ATTRIBUTE, et alors renvoyer la valeur de celui-ci.
  //
}

bool App_HasThisGuidingVariety (Entity* pEA, Entity* pVariety)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  pEntityTab* pIsoAgeingEntityTab = 
	pEA->GetEntityTabConstValue(ISO_AGEING_ENTITY_SET_ATTRIBUTE);
  
  int nbElem = pIsoAgeingEntityTab->size();
  for(int i=0;i<nbElem;i++) {
	Entity* pIsoAgeingEntity = (Entity*)pIsoAgeingEntityTab->get_element(i);
	if(pIsoAgeingEntity == pVariety) {
	  result = TRUE;
	  break;
	}
  }
//printf("\nApp_HasThisGuidingVariety('%s','%x') returns %d", pEA->InstanceName(), pVariety, result);;
  return result;
};

void App_InstantiateWorkers (char* nomEA, Entity* pPool, char* subPool, char* shortName, char* className)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
//printf("\nApp_InstantiateWorkers subPool : '%s'", subPool);
  char str[50] = "";
  Boolean isChiefIdentified = FALSE;
  Entity* pE = NULL;
  Entity* pEmploymentPlan = NULL;
  Entity* pOffWorkCalendar = NULL;
  RecurrentAvailabilityTimetable* pProg = NULL;
  char* pfx, * sfx;
  int nbChar;
  if(strcmp(subPool, "0")) {
	Entity* pEA = GetNamedEntity(VINEYARD, nomEA);
	pfx = strtok(subPool, "_");
	sfx = strtok(NULL, "_");
	nbChar = strlen(pfx);
	isChiefIdentified = FALSE;
	for(int k=0;k<nbChar;k++) {
//printf("\n\t '%c'", pfx[k]);
	  //
	  // Pour chaque lettre, on cree une unite de MO pE
	  //
	  pE = App_NewEntityFromString(className);
	  if(pE) {
//printf("\tpE : '%s'", pE->InstanceName());
		//
		// - reconnaissance du manager
		//
		if(! isChiefIdentified
		   &&
		   sfx) {
		  pE->SetIntConstValue(IS_MANAGER, 1);
		  isChiefIdentified = TRUE;
		  pEmploymentPlan = new ManagerAnnualEmploymentPlan();
		  pOffWorkCalendar = 
			GetNamedEntity("offWorkCalendar", "calendrier_manager_1");
		  pE->SetIntConstValue(WORKING_TIME_DAILY_UPPER_BOUND, gIntParam_managerWorkingTime_day_);
//printf("\t(manager)");
		}
		else {
		  if(! strcmp(className, "permanentAllTaskTractorDriver")
			 ||
			 ! strcmp(className, "permanentPreferentialTractorDriver")) {
			pEmploymentPlan = new SpecialWorkerAnnualEmploymentPlan();
			pOffWorkCalendar = 
			  GetNamedEntity("offWorkCalendar", "calendrier_phyto_1");
		  }
		  else {
			if(pfx[k] == 'F') {
			  //
			  // - creation d'un AnnualEmploymentPlan et attachement a pE
			  //
			  pEmploymentPlan = new StandardWorkerAnnualEmploymentPlan();
			}
			else if(pfx[k] == 'P') {
			  pEmploymentPlan = new StandardWorkerAnnualEmploymentPlan(); // ??
			}
			else if(pfx[k] == 'R') {
			  pEmploymentPlan = new StandardWorkerAnnualEmploymentPlan(); // ??
			}
			else {
			  printf("\nApp_InstantiateWorkers '%s' : ni F ni P ni R", className);
			  exit(0);
			}
			pOffWorkCalendar = 
			  GetNamedEntity("offWorkCalendar", "calendrier_standard_1");
		  }
		}
		// incrmentation nombre d'units de MO
		int currentNbWorkers = pEA->GetIntConstValue(NUMBER_OF_WORKERS);
		pEA->SetIntConstValue(NUMBER_OF_WORKERS, currentNbWorkers+1);
//printf("\nnbWorkers -> %d", pEA->GetIntConstValue(NUMBER_OF_WORKERS));
		//
		// - attachement reciproque AnnualEmploymentPlan <-> FarmWorker
		//
		pE->SetEntityConstValue(ANNUAL_EMPLOYMENT_PLAN_ATTRIBUTE,
								pEmploymentPlan);
		pEmploymentPlan->SetEntityConstValue(FARM_WORKER_ATTRIBUTE, pE);
		//
		// - attachement de la Timetable des SeasonalPlan's <-> FarmWorker
		//
		pEmploymentPlan->SetEntityArgValue(ATTACH_FARM_WORKER_TO_TIMETABLES,
										   FARM_WORKER_ARGUMENT, pE);
		pEmploymentPlan->ExecVoidMethod(ATTACH_FARM_WORKER_TO_TIMETABLES);
		//
		// - attachement d'un calendrier de jours feries et de conges
		//
		pEmploymentPlan->SetEntityConstValue(OFF_WORK_CALENDAR_ATTRIBUTE, 
											 pOffWorkCalendar);
		//
		// - nommage et ajout au pool de ressources de l'ARB
		//
		sprintf(str, "%s_%s_%c_%d", 
				nomEA, shortName, pfx[k], pE->InstanceNumber());
//printf("\ninstanciation de '%s'", str);
		pE->SetInstanceName(str);
		pPool->AddElement(pE);
	  }
	}
  }
}

bool App_IsStageReached (WeatherStation* pWS_arg, char* nomVariety_arg, char* nomStade_arg)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 'vrai' ssi le stade est pleinement atteint sur la variete
//              : et la station meteo
//---------------------------------------------
{
  bool result = FALSE;
  pEntityTab* isoAgeingEntityTab = GetEntityList(ISO_AGEING_ENTITY);
  int nbElem = isoAgeingEntityTab->size();
  bool isoEntityFound = FALSE;
  for(int k=0;k<nbElem;k++) {
	Entity* pIsoAgeingEntity = (Entity*)isoAgeingEntityTab->get_element(k);
	Entity* pVariety 
	  = pIsoAgeingEntity->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
	Entity* pWS 
	  = pIsoAgeingEntity->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
	if(! strcmp(pVariety->InstanceName(), nomVariety_arg)
	   &&
	   (pWS == pWS_arg)) {
	  isoEntityFound = FALSE;
	  Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
	  int currentIndex = pAge->GetIntVarValue(CURRENT_STAGE_INDEX); 
	  pEntityTab* pStadeTab = pAge->GetEntityTabConstValue(STAGE_TAB);
	  int nbStages = pStadeTab->size();
	  for(int i=0;i<nbStages;i++) {
		Entity* pStage_i = (Entity*)pStadeTab->get_element(i);
		char* nomStade_i = pStage_i->GetStringConstValue(STAGE_NAME);
		if(! strcmp(nomStade_i, nomStade_arg)) {
		  if(i <= currentIndex) {
			result = TRUE;
			break;
		  }
		}
	  }
	}
	if(isoEntityFound)
	  break;
  }
//printf("\nApp_IsStageReached('%s','%s','%s') returns %d", pWS_arg, nomVariety_arg, nomStade_arg, result); 
}

bool App_IsStageReachedForEarlyGuidingVariety (Vineyard* pEA, char* nomStade_arg)
//---------------------------------------------
// Description  : Renvoie 'vrai' si le stade 'nomStade_arg' est atteint pour
//                la variete designee comme guide 'precoce' dans le fichier 
//                des options de conduite.
//                Cette variete n'est pas necessairement cataloguee 'precoce'
//                auquel cas, c'est la plus precoce des 'tardives' de l'EA.
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pConduite->GetSuperEntity();
  Entity* dec_optionSet //DecisionOptionSet
	= pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
  char* guidingEarlyVarietyName = 
	dec_optionSet->GetStringConstValue(GUIDING_EARLY_VARIETY_ATTRIBUTE);
  Entity* guidingEarlyVariety = 
	GetNamedEntity("grapeVariety", guidingEarlyVarietyName); 

  bool result = TRUE;

  pEntityTab* pEarlyIsoAgeingAttributeList = 
	App_GetIsoAgeingEntityList(pEA, guidingEarlyVariety, NULL);
  int nbElemEarly = pEarlyIsoAgeingAttributeList->size();
  
  for(int i=0;i<nbElemEarly;i++)  {
	Entity* pIsoAgeingEntity = 
	  (Entity*)pEarlyIsoAgeingAttributeList->get_element(i);
	Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE); 
	pEntityTab* pStadeTab = pAge->GetEntityTabConstValue(STAGE_TAB);
	int currentIndex = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
	int nbStages = pStadeTab->size();
	for(int i=0;i<nbStages;i++) {
	  Entity* pStage_i = (Entity*)pStadeTab->get_element(i);
	  char* nomStade_i = pStage_i->GetStringConstValue(STAGE_NAME);
	  if(! strcmp(nomStade_i, nomStade_arg)) {
		if(i > currentIndex) {
		  result = FALSE;
		}
		break;
	  }
	}
	if(! result)
	  break;
  }
  delete pEarlyIsoAgeingAttributeList;

//printf(" App_IsStageReachedForEarlyGuidingVariety(%s, %s) returns %d", pEA->InstanceName(), nomStade_arg);
  return result;
}

bool App_IsStageReachedForLateGuidingVariety (Vineyard* pEA, char* nomStade_arg)
//---------------------------------------------
// Description  : Renvoie 'vrai' si le stade 'nomStade_arg' est atteint pour
//                la variete designee comme guide 'tardive' dans le fichier 
//                des options de conduite.
//                Cette variete n'est pas necessairement cataloguee 'tardive'
//                auquel cas, c'est la plus tardive des 'precoces' de l'EA.
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
  Entity* pARB = pConduite->GetSuperEntity();
  Entity* dec_optionSet //DecisionOptionSet
	= pARB->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
  char* guidingLateVarietyName = 
	dec_optionSet->GetStringConstValue(GUIDING_LATE_VARIETY_ATTRIBUTE);
  Entity* guidingLateVariety = 
	GetNamedEntity("grapeVariety", guidingLateVarietyName); 

  bool result = TRUE;

  pEntityTab* pLateIsoAgeingAttributeList = 
	App_GetIsoAgeingEntityList(pEA, guidingLateVariety, NULL);
  int nbElemLate = pLateIsoAgeingAttributeList->size();
  
  for(int i=0;i<nbElemLate;i++)  {
	Entity* pIsoAgeingEntity = 
	  (Entity*)pLateIsoAgeingAttributeList->get_element(i);
	Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE); 
	pEntityTab* pStadeTab = pAge->GetEntityTabConstValue(STAGE_TAB);
	int currentIndex = pAge->GetIntVarValue(CURRENT_STAGE_INDEX);
	int nbStages = pStadeTab->size();
	for(int i=0;i<nbStages;i++) {
	  Entity* pStage_i = (Entity*)pStadeTab->get_element(i);
	  char* nomStade_i = pStage_i->GetStringConstValue(STAGE_NAME);
	  if(! strcmp(nomStade_i, nomStade_arg)) {
		if(i > currentIndex) {
		  result = FALSE;
		}
		break;
	  }
	}
	if(! result)
	  break;
  }
  delete pLateIsoAgeingAttributeList;

//printf(" App_IsStageReachedForLateGuidingVariety(%s, %s) returns %d", pEA->InstanceName(), nomStade_arg);
  return result;
}

int App_JulianDayToClockFromBegSim (int julianDay)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int result = 0;

  Date* begSimDate = pCurrentSim->BeginningDate();
  tm* pTm = StructDateToTm(begSimDate);
  int begSimJDay = pTm->tm_yday;
  delete pTm;

  if(julianDay >= begSimJDay) {
	result = (julianDay - begSimJDay) * 24; // UNITE_TPS HOUR
  }
  else {
	result = (julianDay + 365 - begSimJDay) * 24;
  }

//printf("\nApp_JulianDayToClockFromBegSim(%d) returns %d", julianDay, result);
  return result;
}

void App_MakeGanttChartCommandFiles ()
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  pEntityTab* arbTab = GetEntityList(ACTIVITIES_RESOURCES_BLOCK);
  int nbARB = arbTab->size();
//printf("\nnbARB = %d\n", nbARB); arbTab->display_names();
  for(int k=0;k<nbARB;k++) {
	Entity* pARB_k = (Entity*)arbTab->get_element(k);
	Entity* pConduite = (Entity*)pARB_k->GetComponent(ACTIVITY);
	Entity* pEA = (Entity*)pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
//printf("\nexploitation '%s'", pEA->InstanceName()); 
	//
	// generation du nom du fichier de sortie : ofile_k
	//
	char ofile_k[100];
	char suffixe[100];
	char simpleName[50] = "\0";
	if(gMyGanttFileSpec
	   &&
	   ! strcmp(gMyGanttFileSuffix, "")) {
	  sprintf(simpleName, "%s", gMyGanttFileName);
	}
	else {
	  Entity* pE;
	  char *opt1, *opt2, *opt3, *opt5, *opt6;
	  //char *opt4;  // modif JPR 1312 et lignes plus bas associes
	  opt1 = strdup(pConduite->ClassName());
	  char* opt_c = strtok(opt1, "conduite");
	  pE = pARB_k->GetEntityConstValue(WORK_ORGANIZATION_OPTION_SET_ATTRIBUTE);
	  opt2 = strdup(pE->InstanceName());
	  char* opt_wo = strtok(opt2, "wo_optionSet");
	  pE = pARB_k->GetEntityConstValue(DECISION_OPTION_SET_ATTRIBUTE);
	  opt3 = strdup(pE->InstanceName());
	  char* opt_dec = strtok(opt3, "dec_optionSet");
	  //pE = pARB_k->GetEntityConstValue(PLOT_PATTERN_OPTION_SET_ATTRIBUTE);
	  //opt4 = strdup(pE->InstanceName());
	  //char* opt_pp = strtok(opt4, "plotPattern_optionSet");
	  pE = pARB_k->GetEntityConstValue(ALLOCATION_PRIORITY_OPTION_SET_ATTRIBUTE);
	  opt5 = strdup(pE->InstanceName());
	  char* opt_ap = strtok(opt5, "ap_optionSet");
	  pE = pARB_k->GetEntityConstValue(OPERATION_PRIORITY_OPTION_SET_ATTRIBUTE);
	  opt6 = strdup(pE->InstanceName());
	  char* opt_op = strtok(opt6, "op_optionSet");
	  
	  //int sm = pARB_k->GetIntConstValue(SOIL_MANAGEMENT_OPTION);  // JPR 1312 : desc. supprim
	  //char* opt = App_EnumToChar(sm);
	  char opt_sm[20] = "\0";
	  //char* tmp2 = strdup(opt);
	  //char* mot = strtok(tmp2, "_");
	  //while(mot) {
		//strcat(opt_sm, mot);
		//mot = strtok(NULL, "_");
	  //}
	  //free(tmp2);
	  if(! strcmp(gMyGanttFileSuffix, ""))
		//sprintf(simpleName, "%s_c%s_wo%s_dec%s_pp%s_ap%s_op%s_%s", pEA->InstanceName(), opt_c, opt_wo, opt_dec, opt_pp, opt_ap, opt_op, opt_sm);
		sprintf(simpleName, "%s_c%s_wo%s_dec%s_ap%s_op%s_%s", pEA->InstanceName(), opt_c, opt_wo, opt_dec, opt_ap, opt_op, opt_sm);
	  else
		//sprintf(simpleName, "%s_c%s_wo%s_dec%s_pp%s_ap%s_op%s_%s_%s", pEA->InstanceName(), opt_c, opt_wo, opt_dec, opt_pp, opt_ap, opt_op, opt_sm, gMyGanttFileSuffix);
		sprintf(simpleName, "%s_c%s_wo%s_dec%s_ap%s_op%s_%s_%s", pEA->InstanceName(), opt_c, opt_wo, opt_dec, opt_ap, opt_op, opt_sm, gMyGanttFileSuffix);
	  free(opt1);free(opt2);free(opt3);free(opt5);free(opt6);
	  //free(opt4);
//printf("\ncreation fichier '%s'\n", ofile_k); 
	}
	sprintf(ofile_k, "%s%s", pCurrentSim->GetOutDir(), simpleName);
	//
	// generation liste des dates structurant la grille
	//
	char vgridpos[200] = "\0";
	char vgridlab[100] = "\0";
	int endClock = pCurrentSim->EndClock();
	Date* begDate = pCurrentSim->BeginningDate();
	int clock = -1;
	char pos[20] = "\0";
	char lab[20] = "\0";
	int annee = begDate->year;
	int mois = begDate->month -1;
	int Xmin = D_INTMAX;
	int Xmax = -D_INTMAX;
	while(clock < endClock) {
	  mois = mois + 1;
	  if(mois == 13) {
		mois = 1;
		annee = annee + 1;
	  }
	  clock = DateToClockValue(1, mois, annee);
	  //sprintf(pos, "\"%d/%d/01 0h\",", annee, mois);
	  sprintf(pos, "%d,", clock);
	  strcat(vgridpos, pos);
	  //sprintf(lab, "\"%s\",", MonthToChar(mois));
	  sprintf(lab, "\"%s\",", MonthToChar(mois));
	  strcat(vgridlab, lab);
	  if(clock < Xmin) Xmin = clock;
	  if(clock > Xmax) Xmax = clock;

	}
	mois = mois + 1;
	if(mois == 13) {
	  mois = 1;
	  annee = annee + 1;
	}
	//sprintf(pos, "\"%d/%d/01 0h\"\0", annee, mois);
	sprintf(pos, "%d", clock);
	strcat(vgridpos, pos);
	//sprintf(lab, "\"%s\"", MonthToChar(mois));
	sprintf(lab, "\"01-%s\"", MonthToChar(mois));
	strcat(vgridlab, lab);
//printf("\nvgridpos : %s\n", vgridpos);
//printf("\nvgridlab : %s\n", vgridlab);
	//
	// ecriture preambule ofile_k : format et grille
	//
	FILE* pF = fopen (ofile_k, "w");
	//fprintf(pF, "%s\n", "# format des dates pour la grille");
	//fprintf(pF, "%s\n", "Ymd.format<-\"%Y/%m/%d %H\"");
	fprintf(pF, "%s\n", "# liste des dates structurant la grille");
	//char* begpos = "vgridpos<-as.POSIXct(strptime(c(";
	char* begpos = "vgridpos<-c(";
	//char* endpos = "),format=Ymd.format))";
	char* endpos = ")";
	fprintf(pF, "%s%s%s\n", begpos, vgridpos, endpos);
	fprintf(pF, "%s\n", "# legende de la grille");
	char* beglab = "vgridlab<-c(";
	char* endlab = ")";
	fprintf(pF, "%s%s%s\n", beglab, vgridlab, endlab);
	//
	// ecriture des donnees
	//
	fprintf(pF, "%s\n", "# les fenetres des chantiers");
	char* begdata = "data<-list(";
	char labels[2000] = "labels=c(\0";
	char starts[500] = "starts=c(\0";
	char ends[500] = "ends=c(\0";
	char* enddata = ")";
	//
	// pour les couleurs pour les chantiers :
	char colors[100]  = "\0";
	  
	pEntityTab* pMemoryTab_k = 
	  pARB_k->GetEntityTabVarValue(DISTRIBUTED_ACTIVITY_SET_MEMORY);
	int nbItems_k =  pMemoryTab_k->size();
	//int minBeg = D_INTMAX;
	//int maxEnd = -D_INTMAX;
	for(int i=0;i<nbItems_k;i++) {
	  Entity* pItem_k_i = (Entity*)pMemoryTab_k->get_element(i);
	  //char* nomChantier = pItem_k_i->GetStringConstValue(ACTIVITY_NAME_ATTRIBUTE);
	  Entity* pChantier = pItem_k_i->GetEntityConstValue(ACTIVITY_ATTRIBUTE);
	  char* nomChantier = pChantier->ClassName();
	  int begClock = pItem_k_i->GetIntVarValue(BEG_DATE);
	  //if(begClock < minBeg) minBeg = begClock;
	  int endClock = pItem_k_i->GetIntVarValue(END_DATE);
	  //if(endClock > maxEnd) maxEnd = endClock;
	  char chantier[50] = "\0";
	  char start[10] = "\0";
	  char end[10] = "\0";
	  char color[10] = "\0";
	  // couleur du chantier
	  int priority = pChantier->GetIntConstValue(ALLOCATION_PRIORITY_DEGREE);
	  if(i==nbItems_k-1) {
		sprintf(chantier, "\"%s\"", nomChantier);
		sprintf(start, "%d", begClock);
		sprintf(end, "%d", endClock);
		sprintf(color, "%d", priority);
	  }
	  else {
		sprintf(chantier, "\"%s\",", nomChantier);
		sprintf(start, "%d,", begClock);
		sprintf(end, "%d,", endClock);
		sprintf(color, "%d,", priority);
	  }
	  strcat(labels, chantier);
	  strcat(starts, start);
	  strcat(ends, end);
	  strcat(colors, color);
//printf("\n'%s' %d %d", nomChantier, begClock, endClock);
	}
	fprintf(pF, "%s\n\t%s),\n\t%s),\n\t%s)%s\n", begdata, labels, starts, ends, enddata);
	//
	// ecriture de le commande de graphique
	//
	fprintf(pF, "%s\n", "# la commande");
	char* begcom = "gantt.chart(data,";
	char argpos[30]  = "\0";
	//sprintf(argpos, "vgridpos=%d:%d", minBeg, maxEnd);
	sprintf(argpos, "vgridpos=vgridpos");
	char arglab[30]  = "\0"; 
	//sprintf(arglab, "vgridlab=%d:%d", minBeg, maxEnd);
	sprintf(arglab, "vgridlab=vgridlab");
	char argmain[50]  = "\0";  
	sprintf(argmain, "main=\"%s\"", simpleName);
	char arglim[50]  = "\0";  
	sprintf(arglim, "xlim=c(%d:%d)", Xmin, Xmax);
	char argcolor[120]  = "\0";
	sprintf(argcolor, "taskcolors=c(%s)", colors);
	char* endcom = ")";
	fprintf(pF, "%s\n\t%s,\n\t%s,\n\t%s,\n\t%s,\n\t%s\n%s\n", begcom, argpos, arglab, arglim, argmain, argcolor, endcom);
	fprintf(pF, "%s\n", "");
	fclose (pF);
//printf("\n");
  }
}

void App_ParseMainArguments (int argc, char* argv[])
//---------------------------------------------
// Description  : interpretation of main function arguments
// Precondition :
// Retour       :
//---------------------------------------------
{
  Boolean arg_ok = O_ParseMainArguments(argc, argv, TRUE);  // PrintCommaneLine

  if ((argc < 6) || !strcmp(argv[1], "-h")) {
    printf("\n        [-w (application warnings)] \n");
    printf("        [-o (all activities full trace)] \n");
    printf("        [-O <nomFichier> (all activities ending trace)] \n");    // + JPR 130325
    printf("        [-O <nomFichier> <string1> ... <stringn> (string-named activities ending trace)] \n");
    printf("        [-f <nomFichier BDD> (dans OUT_DIR)] \n");
    printf("        [-gf <fichier de commandes Gantt> (dans OUT_DIR)] \n");
    printf("        [-gs <suffixe du fichier de commandes Gantt> (dans OUT_DIR)] \n");
	exit(0);
  }
  if(arg_ok)  {
	for (int i=6;i<argc;i++) {
//printf("\ni = %d argc = %d argv : '%s'", i, argc, argv[i]);
	  if (!strcmp(argv[i], "-w"))
		gMyTraceWarnings  = TRUE;
	  else if (!strcmp(argv[i], "-o"))
		gMyTraceOperations  = TRUE;
	  else if (!strcmp(argv[i], "-O")) {    // + JPR 130325
		gMyEndingTraceFileName = argv[i+1];
		if((i+2 >= argc) || strstr(argv[i+2], "-")) {
		  gMyEndingTraceAllOperations  = TRUE;
		  i++;
		}
		else {
		  if(gMyEndingTraceSomeOperations == FALSE) {
			gMyEndingTraceSomeOperations = TRUE;
			gMyEndingTraceStringTab = new char[200];
			gMyEndingTraceStringTab[0] = '\0';
		  }
		  strcat(gMyEndingTraceStringTab, argv[i+2]);
		  strcat(gMyEndingTraceStringTab, "_");
		  i = i+2;
		}
	  }
	  else if (!strcmp(argv[i], "-f")) {
		gMyRecordOperations  = TRUE;
		gMyRecordFileName = argv[i+1];
		i++;
	  }
	  else if (!strcmp(argv[i], "-gf")) {  // ajout JPR 130313 (5.5)
		gMyGanttFileSpec  = TRUE;
		gMyGanttFileName = argv[i+1];
		i++;
	  }
	  else if (!strcmp(argv[i], "-gs")) {
		gMyGanttFileSpec  = TRUE;
		gMyGanttFileSuffix = argv[i+1];
		i++;
	  }
      else if(! strstr(argv[i], "-")    // + JPR 130325
			  &&
			  ! strstr(argv[i], ".exp"))  {    // + JPR 130524
		// pour que le token soit ajoute a la liste des classes d'OT,
		// il faut que ca ne soit pas le nom du fichier de plan d'expe
        strcat(gMyEndingTraceStringTab, argv[i]);
        strcat(gMyEndingTraceStringTab, "_");
      }
	}
//printf("\ngMyEndingTraceStringTab : '%s'\n", gMyEndingTraceStringTab);
  }
  //printf("\n"); exit(0);
}

void App_ResourceSettings (char fileName[])
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
//printf("\nApp_ResourceSettings('%s')", fileName);
  FILE* pF = fopen(fileName,"r");
  /*
  Entity* pPS = pCurrentSim->SimulatedEntity();
  Entity* pCS = pPS->GetComponent(CONTROLLED_SYSTEM);
  Entity* pACS = pCS->GetEntityConstValue(ATTACHED_ENTITY);
  Entity* pVineyardSet = pACS->GetComponent(VINEYARD_SET);
  Entity* pDS = pPS->GetComponent(MANAGER);
  Entity* pStrategy = pDS->GetComponent(STRATEGY);
  */
 
  char nomEA[10], codeMO_Perm[20], codeMO_Temp[20], codeTracteur[20], codePulve[60], codeTS[20], codeBroyage[20], codeAutres[40];

  while(TRUE) {
	int i = fscanf(pF,
				   "%s %s %s %s %s %s %s %s",
				   nomEA, codeMO_Perm, codeMO_Temp, codeTracteur, codePulve, codeTS, codeBroyage, codeAutres);
//printf("\n\ti = %d nomEA: '%s' '%s'", i, nomEA, codeAutres);
	if(i == EOF)
	  break;

	if(strncmp(nomEA, "//", 2)) { // + JPR 121107 : possibilit de lignes en commentaire
	  //
	  // recuperation de l'EA
	  //
	  Entity* pVineyard = GetNamedEntity(nomEA);   // pas mieux ?!
	  if(! pVineyard) {
		printf("\n!!! Exploitation '%s' non trouv e !!!", nomEA);
		exit(0);
	  }
	  //
	  // recuperation l'ARB de l'EA
	  //
	  Entity* pPlan = pVineyard->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	  Entity* pARB = pPlan->GetSuperEntity();
	  //
	  // creation du pool de ressources et ajout a l'ARB
	  //
	  Entity* pMultiPool = new MultipleResourcePool();
	  Entity* pWorkerPool = new SimpleResourcePool();
	  Entity* pEquipmentPool = new SimpleResourcePool();
	  pMultiPool->AddElement(pWorkerPool);
	  pMultiPool->AddElement(pEquipmentPool);
	  pARB->AddComponent(pMultiPool);
	  // ------------------------------
	  // instanciation du personnel permanent
	  // ------------------------------
//printf("\n codeMO_Perm : '%s'", codeMO_Perm);
	  char* x1 = strtok(codeMO_Perm, ".");
	  char* x2 = strtok(NULL, ".");
	  char* x3 = strtok(NULL, ".");
	  char* x4 = strtok(NULL, ".");
	  char* x5 = strtok(NULL, ".");
	  char* x6 = strtok(NULL, ".");
	  char* x7 = strtok(NULL, ".");
//printf(" -> %s %s %s %s %s %s %s", x1, x2, x3, x4, x5, x6, x7);
	  
	  App_InstantiateWorkers(nomEA, pWorkerPool, 
							 x1, "pATT", "permanentAllTaskTractorDriver");
	  App_InstantiateWorkers(nomEA, pWorkerPool, 
							 x2, "pPT", "permanentPreferentialTractorDriver");
	  App_InstantiateWorkers(nomEA, pWorkerPool, 
							 x3, "pTT", "permanentTillageTractorDriver");
	  App_InstantiateWorkers(nomEA, pWorkerPool, 
							 x4, "pTOT", "permanentTillageOrientedTractorDriver");
	  App_InstantiateWorkers(nomEA, pWorkerPool, 
							 x5, "pMTM", "permanentMultiTaskManualWorker");
	  App_InstantiateWorkers(nomEA, pWorkerPool, 
							 x6, "pP", "permanentPruner");
	  App_InstantiateWorkers(nomEA, pWorkerPool, 
							 x7, "pVG", "permanentVegetationGrower");
	  // ------------------------------
	  // instanciation du materiel
	  // ------------------------------
	  //
	  // tracteur
	  //
	  Entity* pE;
	  char* str, * substr;
	  int nbItems, width=0;
	  int nbTractors = 0;
//printf("\tcodeTracteur : '%s'\n", codeTracteur);
	  str = strtok(codeTracteur, ".");
	  substr = strpbrk(str, "_");
	  if(substr) width = atoi(&substr[1]);
	  nbItems = atoi(str);
	  nbTractors = nbTractors + nbItems;
	  for(int i=0;i<nbItems;i++) {
		pE = new Tractor();
		pEquipmentPool->AddElement(pE);
		pE->SetIntConstValue(WIDTH, width);
//printf("\t\tconstruction '%s' ('%s') width = %d\n", pE->InstanceName(), &str[1], width);
		// incrmentation nombre d'units de MO
	  }
	  str = strtok(NULL, ".");
	  substr = strpbrk(str, "_");
	  if(substr) width = atoi(&substr[1]);
	  nbItems = atoi(str);
	  nbTractors = nbTractors + nbItems;
	  for(int i=0;i<nbItems;i++) {
		pE = new Tractor();
		pEquipmentPool->AddElement(pE);
		pE->SetIntConstValue(WIDTH, width);
//printf("\t\tconstruction '%s' ('%s') width = %d\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  substr = strpbrk(str, "_");
	  if(substr) width = atoi(&substr[1]);
	  nbItems = atoi(str);
	  nbTractors = nbTractors + nbItems;
	  for(int i=0;i<nbItems;i++) {
		pE = new Tractor();
		pEquipmentPool->AddElement(pE);
		pE->SetIntConstValue(WIDTH, width);
//printf("\t\tconstruction '%s' ('%s') width = %d\n", pE->InstanceName(), &str[1], width);
	  }
	  // incrmentation nombre d'units de MO
	  int currentNbTractors = pVineyard->GetIntConstValue(NUMBER_OF_TRACTORS);
	  pVineyard->SetIntConstValue(NUMBER_OF_TRACTORS, currentNbTractors+nbTractors);
//printf("\nnbTractors -> %d", pVineyard->GetIntConstValue(NUMBER_OF_TRACTORS));
	  //
	  // outils de pulvrisations
	  //
//printf("\n\tcodePulve : '%s'\n", codePulve);
	  str = strtok(codePulve, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new AirAssistedSprayer();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new DebranchingSprayer();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new BackSprayer();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new Tank();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new HorizontalRailSprayer();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new VerticalRailSprayer();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new HandHeldSprayGun();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new CollectorPane();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  //
	  // outils travail du sol
	  //
//printf("\n\tcodeTS : '%s'\n", codeTS);
	  str = strtok(codeTS, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new SpringTineCultivator();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new RotaryCultivator();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new RotaryCultivator();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  //
	  // outils broyage
	  //
//printf("\n\tcodeBroyage : '%s'\n", codeBroyage);
	  str = strtok(codeBroyage, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new Grinder();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new Grinder();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new Grinder();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  //
	  // outils autres
	  //
//printf("\n\tcodeAutres : '%s'\n", codeAutres);
	  str = strtok(codeAutres, ".");
	  //substr = strpbrk(str, "_");                  coder
	  //if(substr) property = atoi(&substr[1]);
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new Spreader();
		pEquipmentPool->AddElement(pE);
		//pE->SetStringConstValue(PROPERTY, property);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  //substr = strpbrk(str, "_");                  coder
	  //if(substr) property = atoi(&substr[1]);
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new Clipper();
		pEquipmentPool->AddElement(pE);
		//pE->SetStringConstValue(PROPERTY, property);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new PruningMachine();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	  str = strtok(NULL, ".");
	  nbItems = atoi(str);
	  for(int i=0;i<nbItems;i++) {
		pE = new TrellisingMachine();
		pEquipmentPool->AddElement(pE);
//printf("\t\tconstruction '%s' ('%s')\n", pE->InstanceName(), &str[1], width);
	  }
	} // fin if '//
  } // fin while
  fclose (pF);
//printf("\nfin App_ResourceSettings('%s')", fileName);
}

pIntTab* App_SummarizePerformerPool (pEntityTab* perfList)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  pIntTab* profilMO = new pIntTab(0, 7);
  int nbPerfs = perfList->size();
  for (int p = 0;p<nbPerfs;p++) {
	char* pPrefName_k_p = perfList->get_nth(p)->InstanceName();
	if(strstr(pPrefName_k_p, "pATT"))
	  profilMO->set_nth(0, profilMO->get_nth(0) + 1);
	else if(strstr(pPrefName_k_p, "pPT"))
	  profilMO->set_nth(1, profilMO->get_nth(1) + 1);
	else if(strstr(pPrefName_k_p, "pTT"))
	  profilMO->set_nth(2, profilMO->get_nth(2) + 1);
	else if(strstr(pPrefName_k_p, "pTOT"))
	  profilMO->set_nth(3, profilMO->get_nth(3) + 1);
	else if(strstr(pPrefName_k_p, "pMTM"))
	  profilMO->set_nth(4, profilMO->get_nth(4) + 1);
	else if(strstr(pPrefName_k_p, "pP"))
	  profilMO->set_nth(5, profilMO->get_nth(5) + 1);
	else if(strstr(pPrefName_k_p, "pVG"))
	  profilMO->set_nth(6, profilMO->get_nth(6) + 1);
  }
//printf("\nApp_SummarizePerformerPool(");perfList->display_names();printf(") renvoie ");profilMO->display();
  return profilMO;
}

pIntTab* App_SummarizeToolSet (pEntityTab* rscList)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  pIntTab* profilTools = new pIntTab(0, 5);
  int nbRscs = rscList->size();
  for (int p = 0;p<nbRscs;p++) {
	BasicEntity* pRsc_k_p = rscList->get_nth(p);
	UserClassIdTab ancestorTab = pRsc_k_p->AncestorIds();
	ancestorTab.push_front(pRsc_k_p->ClassId()); 
	if(GetPosition(ancestorTab, TRACTOR) >= 0)
	  profilTools->set_nth(0, profilTools->get_nth(0) + 1);
	else if((GetPosition(ancestorTab, SPRAYER) >= 0)
			||
			(GetPosition(ancestorTab, TANK) >= 0)
			||
			(GetPosition(ancestorTab, COLLECTOR_PANE) >= 0))
	  profilTools->set_nth(1, profilTools->get_nth(1) + 1);
	else if(GetPosition(ancestorTab, TILLAGE_TOOL) >= 0)
	  profilTools->set_nth(2, profilTools->get_nth(2) + 1);
	else if(GetPosition(ancestorTab, GRINDER) >= 0)
	  profilTools->set_nth(3, profilTools->get_nth(3) + 1);
	else profilTools->set_nth(4, profilTools->get_nth(4) + 1);
  }
//printf("\nApp_SummarizeToolSe(");rscList->display_names();printf(") renvoie ");profilTools->display();
  return profilTools;
}

int App_WeatherFileDateToClock (char* dateArg, char* hourArg)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int result;
//printf("\nApp_WeatherFileDateToClock('%s', '%s')", dateArg, hourArg);

  char* date = new char[15];
  strcpy(date, dateArg);
  char* str_d;
  str_d = strtok(date, "-");
  int year = atoi(str_d);
  str_d = strtok(NULL, "-");
  int month = atoi(str_d);
  str_d = strtok(NULL, "-");
  int mday = atoi(str_d);

  char* hour = new char[15];
  strcpy(hour, hourArg);
  char* str_h;
  str_h = strtok(hour, ":");
  int H = atoi(str_h);
  str_h = strtok(NULL, ":");
  int M = atoi(str_h);
  str_h = strtok(NULL, ":");
  int S = atoi(str_h);
//printf(" -> %d-%d-%d %d:%d:%d", year, month, mday, H, M, S);

  tm* pTm = new tm();
  pTm->tm_year = year-1900;
  pTm->tm_mon = month-1;
  pTm->tm_mday = mday;
  pTm->tm_hour = H;
  pTm->tm_min = M;
  pTm->tm_sec = S;
  mktime(pTm);
  
  result = StructTmToClockValue(pTm);
//printf(" -> clock = %d\n", result);;

  delete[] date;
  delete[] hour;
  delete pTm;
  
  return result;
}

Date* App_WeatherFileDateToDate (char* dateArg, char* hourArg)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Date* result = new Date();
//printf("\nApp_WeatherFileDateToDat('%s', '%s')", dateArg, hourArg);

  char* date = new char[15];
  strcpy(date, dateArg);
  char* str_d;
  str_d = strtok(date, "-");
  int year = atoi(str_d);
  str_d = strtok(NULL, "-");
  int month = atoi(str_d);
  str_d = strtok(NULL, "-");
  int mday = atoi(str_d);

  char* hour = new char[15];
  strcpy(hour, hourArg);
  char* str_h;
  str_h = strtok(hour, ":");
  int H = atoi(str_h);
  str_h = strtok(NULL, ":");
  int M = atoi(str_h);
  str_h = strtok(NULL, ":");
  int S = atoi(str_h);
//printf(" -> %d-%d-%d %d:%d:%d\n", year, month, mday, H, M, S);
  
  result->year = year;
  result->month = month;
  result->mday = mday;
  result->hour = H;
  result->minute = M;
  result->second = S;

  delete[] date;
  delete[] hour;

  return result;
}

BasicEntity* Body_BestActivitySetSelector_FirstOnOperationPriority (EntityMethod* pM)
//---------------------------------------------
// Choisit (et eventuellement modifie) le meilleur jeu d'activites
// parmi des jeux vehicules par l'argument ACTIVITY_SETS_ARGUMENT.
//
// CRITERE 1 : on selectionne le premier venu parmi jes jeux qui
// possede l'activite (l'operation, en fait) de plus forte priorite
//
// ((A1   B   C)  (A2   B   D))
//   30   40  70   30   40  60               <- priorite
// -> on choisit le jeu (A1 B C)
//
// CRITERE 2 :   ... 
//---------------------------------------------
{
  Entity* pARB = pM->DescribedEntity();
  Entity* pSetDisj = pM->GetEntityArgValue(ACTIVITY_SETS_ARGUMENT);

  BasicEntity* result = NULL;

  pEntityTab setTab = pSetDisj->GetElementTab();
  int nbSets = setTab.size();

  // ...

  if(! result)
	result = setTab.get_element(0);

  return result;
}

BasicEntity* Body_BestActivitySetSelector_OnlyOnOperationPriority (EntityMethod* pM)
//---------------------------------------------
// Choisit (et eventuellement modifie) le meilleur jeu d'activites
// parmi des jeux vehicules par l'argument ACTIVITY_SETS_ARGUMENT.
//
// CRITERE 1 : on selectionne le premier venu parmi jes jeux qui
// possede l'activite (l'operation, en fait) de plus forte priorite
//
// ((A1   B   C)  (A2   B   D))
//   25   40  70   30   40  60               <- priorite
// -> on choisit le jeu (A1 B C) parce que 25 < 30
//---------------------------------------------
{
  Entity* pARB = pM->DescribedEntity();
  Entity* pDisjunctionToSort = pM->GetEntityArgValue(ACTIVITY_SETS_ARGUMENT);
  int nbSets = pDisjunctionToSort->GetNumberOfElements();

  BasicEntity* result = NULL;

  //===========================================================================
  // Regle de preference : classement des jeux par ordre croissant de 
  //                       la priorite moyenne des activites du jeu
  //===========================================================================

  Tableau<DescriptedEntity*>* pElemTabCopy = new Tableau<DescriptedEntity*>();
  for(int i=0;i<nbSets;i++) {
	Entity* pSet_i = pDisjunctionToSort->GetElement(i);
	pElemTabCopy->push_back(pSet_i);
	int nbSingle_i = pSet_i->GetNumberOfElements();
	float strongestPriority_i = D_FLOATMAX;
	for(int j=0;j<nbSingle_i;j++) {
	  Entity* pSingle_i_j = pSet_i->GetElement(j);
	  Entity* pInst_i_j = 
		pSingle_i_j->GetEntityConstValue(PRIMITIVE_ACTIVITY_ATTRIBUTE);
	  int priority_i_j = 
		pInst_i_j->GetIntConstValue(ALLOCATION_PRIORITY_DEGREE);
	  if(priority_i_j < strongestPriority_i)
		strongestPriority_i = priority_i_j;
	}
	float priority_i = strongestPriority_i;
//printf("\n\tset[%d] strongest priority = %f", i, priority_i);
	pSet_i->SetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE, priority_i);
  }
  SortUp(pElemTabCopy, ANONYMOUS_FLOAT_ATTRIBUTE);
  pDisjunctionToSort->RemoveElements();
  pDisjunctionToSort->AddElements(*((Tableau<BasicEntity*>*)pElemTabCopy));
  delete pElemTabCopy;

  //===========================================================================
  // Choix final : arbitrairement le premier jeu parmi les survivants
  //===========================================================================

  if(pDisjunctionToSort->GetNumberOfElements() > 0) { 
	result = pDisjunctionToSort->GetElement(0);
  }
  else {
	//result reste NULL
  }

  return result;
}

BasicEntity* Body_BestActivitySetSelector_Standard (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : le meilleur jeu d'activite
//              : ou NULL si tous les jeux sont elimines (convention cdiese)
// Comment      : version 130218 (5.4)
//---------------------------------------------
{
  Entity* pARB = pM->DescribedEntity();
  Entity* pDisjunctionToSort = pM->GetEntityArgValue(ACTIVITY_SETS_ARGUMENT);
  int nbSets = pDisjunctionToSort->GetNumberOfElements();

  BasicEntity* result = NULL;

  //===========================================================================
  // Regle de preference 0 : (+ JPR 130226) limination des jeux Ja tels que :
  // Il existe un jeu Jb o un perf_i est allou  l'activit valeur de son 
  //                                             PrimitiveActivityAttribute
  // alors que perf_i est allou dans Ja  une autre activit.
  // Rgle restreinte heuristiquement aux jeux d'une seule activit.
  //===========================================================================
  int nbSetsToRemove = 0;
  pEntityTab* setsToRemove = new pEntityTab();
  pEntityDTab* assocList = new Tableau<pEntityTab*>();
  //
  // parcours des InstructionSet pour construire le double tableau :
  //   assocList_0      assocList_1   assocList_2
  // ((p0 A p1 A p2 B)  (p1 C p2 B)   (p3 D p4 E))
  //       set_0            set_1        set_2
  //
//printf("\nnbSets = %d", nbSets);
  for(int i=0;i<nbSets;i++) {
	Entity* pSet_i = pDisjunctionToSort->GetElement(i);
//((InstructionSetConjunction*)pSet_i)->SpecialDisplay();
	pEntityTab* assocList_i = new pEntityTab();
	assocList->push_back(assocList_i);
	int nbSingle_i = pSet_i->GetNumberOfElements();
	//
	// parcours des single's de InstructionSet i
	//
	for(int k_i=0;k_i<nbSingle_i;k_i++) {
	  SingleInstructionSet* pSingle_k_i = 
		(SingleInstructionSet*)pSet_i->GetElement(k_i);
	  Entity* pInst_k_i = pSingle_k_i->GetAct();
//printf("\n\t\tBody_BestActivitySetSelector_Standard pInst_[%d][%d] : '%s' (%x)", i, k_i, pInst_k_i->InstanceName(), pInst_k_i);
	  
	  Entity* pV_alloc_k_i = pSingle_k_i->GetEntityConstValue(ALLOCATION_ATTRIBUTE);
//printf("\n\tpV_alloc_k_i en %x", pV_alloc_k_i);
	  pEntityTab* perfList_k_i = ((InstructionAllocation*)pV_alloc_k_i)->ExtractPerfSet();
//printf("\n");perfList_k_i->display_names();printf(" = ");perfList_k_i->display();printf("\n");
	  int nbPerf_k_i = perfList_k_i->size();
	  //
	  // parcours des performers allous au single's de InstructionSet i
	  //
	  for(int n_k_i=0;n_k_i<nbPerf_k_i;n_k_i++) {
		Entity* pPerf_n_k_i = (Entity*)perfList_k_i->get_nth(n_k_i);
		int pushed = assocList_i->push_back_ifnew(pPerf_n_k_i);
		if(pushed) assocList_i->push_back(pInst_k_i);
	  }
	  delete perfList_k_i; // + JPR 130325
	}
  }  
  //
  // parcours des couples de listes (perf act)_i (perf act)_j  j != i
  // ((p0 A p1 A p2 B)  (p1 C p2 B)   (p3 D p4 E))
  //
  for(int i=0;i<nbSets;i++) {     // (p0 A p1 A p2 B)
	pEntityTab* assocList_i = assocList->get_nth(i);
//printf("\n\ni = %d assocList_[%d] : ", i, i);assocList_i->display_names();
	int nbElem_i = assocList_i->size();

	for(int j=i+1;j<nbSets;j++) {   // (p1 C p2 B)
	  if(j == i) continue;

	  int nbSingle_i = pDisjunctionToSort->GetElement(i)->GetNumberOfElements();
	  int nbSingle_j = pDisjunctionToSort->GetElement(j)->GetNumberOfElements();
	  if((nbSingle_i != 1) || (nbSingle_i != 1)) continue;

	  pEntityTab* assocList_j = assocList->get_nth(j);
//printf("\nj = %d assocList_[%d] : ", j, j);assocList_j->display_names();

	  int nbElem_j = assocList_j->size();
	  for(int ki=0;ki<nbElem_i;ki=ki+2) {
		Entity* pPerf_ki = (Entity*)assocList_i->get_nth(ki);                            // p0 p1 p2
		int position_ki_in_j = GetPosition(*assocList_j, pPerf_ki);                      // -9  0  1
//printf("\n%x : position_ki_in_j = %d\n", pPerf_ki, position_ki_in_j);
		if(position_ki_in_j >= 0) {
		  BasicEntity* candidateActivity_ki = assocList_i->get_nth(ki+1);                //     A  B
		  BasicEntity* candidateActivity_kj = assocList_j->get_nth(position_ki_in_j+1);  //     C  B
		  BasicEntity* currentAllocation_ki = 
			pPerf_ki->GetEntityConstValue(PRIMITIVE_ACTIVITY_ATTRIBUTE);                 //     A  B
//if(currentAllocation_ki)printf("\ncurrentAllocation_[%d] = '%s' (%x)", ki, currentAllocation_ki->InstanceName(), currentAllocation_ki);
//else printf("\ncurrentAllocation_[%d] = %x", ki, currentAllocation_ki);
		  if((candidateActivity_ki == currentAllocation_ki)
			 &&
			 (candidateActivity_kj != currentAllocation_ki)) {
			BasicEntity* setToRemove = pDisjunctionToSort->GetElement(j);            // pSet
//printf("\n\t==> elimination 1 de pSet_[%d] : %x", j, setToRemove);
			setsToRemove->push_back_ifnew(setToRemove);
		  }
		  else if((candidateActivity_kj == currentAllocation_ki)
				  &&
				  (candidateActivity_ki != currentAllocation_ki)) {
			BasicEntity* setToRemove = pDisjunctionToSort->GetElement(i);
//printf("\n\t==> elimination 2 de pSet_[%d] : %x", i, setToRemove);
			setsToRemove->push_back_ifnew(setToRemove);
		  }
		}
	  }
	}
  }
  nbSetsToRemove = setsToRemove->size();
  for(int k=0;k<nbSetsToRemove;k++) {
	BasicEntity* pSet_k = setsToRemove->get_nth(k);
	pDisjunctionToSort->RemoveElement(pSet_k, FALSE);
  }
  for(int i=0;i<nbSets;i++) {
	delete assocList->get_nth(i);
  }
  delete assocList;
  nbSets = pDisjunctionToSort->GetNumberOfElements();

//printf("\napres regle 0 / continuite d'activite");
//((InstructionSetConjunction*)pDisjunctionToSort)->SpecialDisplay();

  //===========================================================================
  // Regle de preference 1 : classement des jeux par ordre croissant de 
  //                         la priorite max sur les activites du jeu
  //===========================================================================

  Entity* pConduite =  (Entity*)pARB->GetComponent(ACTIVITY);
  Entity* pEA = pConduite->GetEntityConstValue(VINEYARD_ATTRIBUTE);
  Tableau<DescriptedEntity*>* pElemTabCopy = new Tableau<DescriptedEntity*>();
  for(int i=0;i<nbSets;i++) {
	Entity* pSet_i = pDisjunctionToSort->GetElement(i);
//((InstructionSetConjunction*)pSet_i)->SpecialDisplay();
	pElemTabCopy->push_back(pSet_i);
	int nbSingle_i = pSet_i->GetNumberOfElements();
	float maxPriority_i = D_FLOATMAX;
	float totalPriority_i = (float)0.;
	for(int j=0;j<nbSingle_i;j++) {
	  Entity* pSingle_i_j = pSet_i->GetElement(j);
	  Entity* pInst_i_j = 
		pSingle_i_j->GetEntityConstValue(PRIMITIVE_ACTIVITY_ATTRIBUTE);
	  // modif JPR 120907 : exploitation de la priorite des operations
	  // int priority_i_j = pInst_i_j->GetIntConstValue(ALLOCATION_PRIORITY_DEGREE);
	  int priority_i_j = 1;
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pInst_i_j->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) { 
		char* nomClasse = pInst_i_j->ClassName();
		BasicEntity* pPhasicPlan = pInst_i_j->GetFirstContainer(VINEYARD_PHASE_CONJUNCTIVE_PLAN, 
																TRUE);
		int numPhase = App_GetPhaseIndex((Activity*)pPhasicPlan) + 1;
		if(pPhasicPlan == NULL) {
		  printf("\nBody_BestActivitySetSelector_Standard : pas de plan de phase trouve !\n");
		  exit(0);    
		}
		priority_i_j = App_GetOperationPriority (pEA, nomClasse, STANDARD_VALUE_PRIORITY_TAB, numPhase);
//printf("\n\tpOt en %x\tpriority = %d", pOt, priority_i_j);
	  }

	  if(priority_i_j < maxPriority_i) maxPriority_i = priority_i_j;
	  totalPriority_i += priority_i_j;
	}
	pSet_i->SetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE, maxPriority_i);
	double meanPriority_i = totalPriority_i / nbSingle_i;
	pSet_i->SetDoubleVarValue(ANONYMOUS_DOUBLE_ATTRIBUTE, meanPriority_i);
//printf("\n\tset[%d] %x priority max = %f mean = %f", i, pSet_i, maxPriority_i, meanPriority_i);
  }
  SortUp(pElemTabCopy, ANONYMOUS_FLOAT_ATTRIBUTE);
  pDisjunctionToSort->RemoveElements();
  pDisjunctionToSort->AddElements(*((Tableau<BasicEntity*>*)pElemTabCopy));
//printf("\n1 ");pDisjunctionToSort->DisplayElementTab();
  delete pElemTabCopy;

  //===========================================================================
  // Regle de preference 2 : parmi les ex-aequo au premier rang
  //                         classement des jeux par ordre dcroissant de 
  //                         mobilisation d'units de MO (JPR 121018)
  //===========================================================================

  pElemTabCopy = new Tableau<DescriptedEntity*>();
  int maxNbPerf = 0;
  float priority_ref;
  for(int i=0;i<nbSets;i++) {
	Entity* pSet_i = pDisjunctionToSort->GetElement(i);
	float priority_i = pSet_i->GetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE);
	if(i==0) {
	  priority_ref = priority_i;
	}
	if(priority_ref < priority_i) {  // modif bug 130208
	  pSet_i->SetIntVarValue(ANONYMOUS_INT_ATTRIBUTE, -D_INTMAX);
	}
	else {
//printf("\nex aequo n %d %x\n", i, pSet_i);
	  InstructionSetAllocation* tmp = (InstructionSetAllocation*)pSet_i->GetEntityConstValue(SET_ALLOCATION_ATTRIBUTE);
	  InstructionAllocation* pV_alloc_i = tmp->ExtractVAlloc();
	  pEntityTab* perfList_i = pV_alloc_i->ExtractPerfSet();
//printf("\nex aequo n %d %x perf : ", i, pSet_i);perfList_i->display_names();
	  int nbPerf_i = perfList_i->size();
	  delete perfList_i; // + JPR 130114 <- MLK
	  pV_alloc_i->DeleteInDepth(); // + JPR 130114 <- MLK // modif JPR 130124
	  pSet_i->SetIntVarValue(ANONYMOUS_INT_ATTRIBUTE, nbPerf_i);
	}
	pElemTabCopy->push_back(pSet_i);
  }
  SortDown(pElemTabCopy, ANONYMOUS_INT_ATTRIBUTE);
  pDisjunctionToSort->RemoveElements();
  pDisjunctionToSort->AddElements(*((Tableau<BasicEntity*>*)pElemTabCopy));
//printf("\n2 ");pDisjunctionToSort->DisplayElementTab();
  delete pElemTabCopy;
  
  //===========================================================================
  // Regle de preference 3 : parmi les ex-aequo au premier rang
  //                         classement des jeux par ordre dcroissant de 
  //                         priorit moyenne (JPR 130214)
  //===========================================================================

  pElemTabCopy = new Tableau<DescriptedEntity*>();
  int nbPerf_ref;
  float maxPriority_ref;
  bool areTrellisings = FALSE;
  bool arePhytoTreatments = FALSE;
  int isTrellisingExclusive = -9;
  for(int i=0;i<nbSets;i++) {
	Entity* pSet_i = pDisjunctionToSort->GetElement(i);
	int nbSingle_i = pSet_i->GetNumberOfElements();
	// dtection prsence Trellising et Trt Phyto
	if(! areTrellisings || ! arePhytoTreatments) {
	  for (int k=nbSingle_i-1;k>=0;k--) {
		SingleInstructionSet* pSingle_i_k = (SingleInstructionSet*)(pSet_i->GetElement(k));
		PrimitiveActivity* pInst_i_k = pSingle_i_k->GetAct();
		UserClassIdTab idTab = pInst_i_k->AncestorIds();
		idTab.push_back(pInst_i_k->ClassId());
		if(GetPosition(idTab, TRELLISING_ACTIVITY) >= 0) {
		  areTrellisings = TRUE;
		  if(isTrellisingExclusive < 0)
			isTrellisingExclusive = 
			  App_GetAllocationExclusivity(pARB, "trellisingActivity");
		}
		else if(GetPosition(idTab, PHYTO_TREATMENT_ACTIVITY) >= 0) {
		  arePhytoTreatments = TRUE;
		}
	  }
	}
	float maxPriority_i = pSet_i->GetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE);
	int nbPerf_i = pSet_i->GetIntVarValue(ANONYMOUS_INT_ATTRIBUTE);
	if(i==0) {
	  maxPriority_ref = maxPriority_i;
	  nbPerf_ref = nbPerf_i;
	}
	if((maxPriority_ref < maxPriority_i)
	   ||
	   (nbPerf_ref > nbPerf_i)) { 
	  pSet_i->SetDoubleVarValue(ANONYMOUS_DOUBLE_ATTRIBUTE, D_DOUBLEMAX);
	}
	else {
//printf("\nex aequo n %d %x meanPriority : %f", i, pSet_i, pSet_i->GetDoubleVarValue(ANONYMOUS_DOUBLE_ATTRIBUTE));
	}
	pElemTabCopy->push_back(pSet_i);
  }
  // application conditionnelle de ce critre de slection
  if(arePhytoTreatments
	 ||
	 ! areTrellisings
	 ||
	 (isTrellisingExclusive == 1))
	SortUp(pElemTabCopy, ANONYMOUS_DOUBLE_ATTRIBUTE);
  pDisjunctionToSort->RemoveElements();
  pDisjunctionToSort->AddElements(*((Tableau<BasicEntity*>*)pElemTabCopy));
//printf("\n3 ");pDisjunctionToSort->DisplayElementTab();
  delete pElemTabCopy;

  //===========================================================================
  // Choix final : arbitrairement le premier jeu parmi les survivants
  //===========================================================================

  if(pDisjunctionToSort->GetNumberOfElements() > 0) { 
	result = pDisjunctionToSort->GetElement(0);
  }
  else {
	//result reste NULL
  }
  // ajout corollaire JPR 130226
  // (l'application ne doit pas modifier les lments de la disjonction en 
  // entre ; on rajoute donc les lments limins par la Rgle 0)
  for(int k=0;k<nbSetsToRemove;k++) {
	BasicEntity* pSet_k = setsToRemove->get_nth(k);
	pDisjunctionToSort->AddElement(pSet_k);
  }
  delete setsToRemove;
  
  return result;
}

bool Body_CP_AntiMildewTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si plus de parcelles a traiter
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_ANTI_MILDEW_TREATED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

//printf("\n'%s'::Body_CP_AntiMildewTreatments returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_AutumnTillages (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a labourer l'ont ete (condition 1)
//                  OU
//                - une date max a ete atteinte (condition 2)
//                  . soit une date calendaire :          // si
//                              NOV, DEC ou               //   phase
//                              la taille doit commencer  //         2
//                  . soit la taille doit commencer immediatement // si phase 1
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  int now = pCurrentSim->Clock();
  //
  // condition 1
  //
  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_AUTUMN_TILLED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	//
	// condition 2
	//
	bool debutTaille = OpeningCondition_Prunings_OnDate(pChantier);
	Vineyard* pEA = App_GetVineyard((Activity*)pChantier);
	if(debutTaille) {
	  int optionFermeture = App_GetIntDecisionOption(pEA,
													 OPT_AUTUMN_TILLAGE_C_P);
	  if(optionFermeture == BEG_PRUN)
		result = TRUE;
	  else {
		Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
		Entity* pPhase1 = pConduite->GetElement(0);
		int dateFermeturePhase1 = pPhase1->GetIntVarValue(END_DATE);
		int dateMax;
		tm* pTm = ClockValueToTm(now);
		int year = pTm->tm_year + 1900;
		delete pTm;
		if(dateFermeturePhase1 < now) {
		  if(optionFermeture == NOVEMBER) {
			dateMax = DateToClockValue(30, 11, year);
		  }
		  else {             // DECEMBER
			dateMax = DateToClockValue(31, 12, year);
		  }		  
		}
		if(now > dateMax)
		  result = TRUE;
	  }
	}
	else {
	  result = FALSE;
	}
  }
//printf("\n'%s'::Body_CP_AutumnTillages returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_ChemicalWeedings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si plus de parcelles a desherber
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_WEEDED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

//printf("\n'%s'::Body_CP_ChemicalWeedings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_Clippings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a "clipper" l'ont ete (condition 1)
//                  OU
//                - on a atteint le 20/08 (condition 2)
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_CLIPPED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	// 
	// renvoyer TRUE ssi on a atteint le 20/08
	// 
	int now = pCurrentSim->Clock();
	tm* pTm = ClockValueToTm(now);
	int month = pTm->tm_mon;
	int year = pTm->tm_year + 1900;
	if(month > 7)    // sept, oct, etc.
	  year = year + 1;
	delete pTm;
	
	int clockOuverture = DateToClockValue(20, 8, year);
	if(now >= clockOuverture)
	  result = TRUE;
  }

//printf("\n'%s'::Body_CP_Clippings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_Debranchings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a pamprer l'ont ete (condition 1)
//                  OU
//                - on a atteint le 15/06 (condition 2)
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_DEBRANCHED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

  if(! result) {
	// 
	// renvoyer TRUE ssi on a atteint le 15/06
	// 
	int now = pCurrentSim->Clock();
	tm* pTm = ClockValueToTm(now);
	int month = pTm->tm_mon;
	int year = pTm->tm_year + 1900;
	if(month > 7)    //  sept, etc.
	  year = year + 1;
	delete pTm;
	
	int clockOuverture = DateToClockValue(15, 6, year);
	if(now >= clockOuverture)
	  result = TRUE;
  }

//printf("\n'%s'::Body_CP_Debranchings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_ExtraPhytoTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_EXTRA_PHYTO_TREATED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

//printf("\n'%s'::Body_CP_ExtraPhytoTreatments returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_Fertilizations_Phase3 (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si plus de parcelles a fertiliser
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_FERTILIZED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

//printf("\n'%s'::Body_CP_Fertilizations_Phase3 returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_InitSpringTillages_Phase3 (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si 
//                - plus de parcelles a labourer
//                  OU
//                - une date max a ete atteinte (condition 2)
//                
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_INIT_SPRING_TILLED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	int now = pCurrentSim->Clock();
	tm* pTm = ClockValueToTm(now);
	int month = pTm->tm_mon;
	int year = pTm->tm_year + 1900;
	if(month > 7)       // sept, etc.
	  year = year +1;
	delete pTm;
	int clockOuverture; 

	int option = App_GetIntDecisionOption(pEA, OPT_FIRST_SPRING_TILLAGE_O_P);
	switch (option) {
	case INIT_SPRING_TILLAGE : {
	  result = FALSE;
	  break;
	}
	case EARLY_MAR : {
	  clockOuverture = DateToClockValue(1, 3, year);  // 1er mars
	  if(now >= clockOuverture)
		result = TRUE;
	  break;
	}
	case MID_MAR : {
	  clockOuverture = DateToClockValue(15, 3, year);  // 15 mars
	  if(now >= clockOuverture)
		result = TRUE;
	  break;
	}
	case EARLY_APR : {
	  clockOuverture = DateToClockValue(1, 4, year);  // 1er avril
	  if(now >= clockOuverture)
		result = TRUE;
	  break;
	}
	case MID_APR : {
	  clockOuverture = DateToClockValue(15, 4, year);  // 15 avril
	  if(now >= clockOuverture)
		result = TRUE;
	  break;
	}
	default : {
	  printf("\n'%s'_CP option inconnue : %d", pChantier->InstanceName(), option);
	  exit(0);
	  
	} 
	}
  }

//printf("\n'%s'::Body_CP_InitSpringTillages_Phase3 returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_Phase1 (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pPhase = pM->DescribedEntity();

  bool result = OpeningCondition_Prunings_OnDate(pPhase);

  if(result) {
	//
	// desallocation des dernieres activites primitives creees,
	// celles qui ne seront pas desallouees par les prochains MIOS
	// des chantiers de cette phase,
	// puisqu'il n'y aura pas de MIOS a cause de la presente fermeture
	//
	//DeallocatePrimitiveActivityTab();
	//
	// Pour epargner des activit s eventuellement crees par ailleurs,
	// ciblage explicite sur les activit s de la phase 1
	//
	App_DeallocatePrimitiveActivities((Activity*)pPhase);
  }

//printf("\n'%s'::Body_CP_Phase1 returns %d", pPhase->InstanceName(), result);
  return result;
}

bool Body_CP_Phase3 (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : TRUE ssi on a atteint le 31 aout
//---------------------------------------------
{
  Entity* pPhase = pM->DescribedEntity();

  bool result = FALSE;
  // 
  // renvoyer TRUE ssi on a atteint le 31/08
  // 
  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)    // sept, oct, etc.
	year = year + 1;
  delete pTm;

  int clockOuverture = DateToClockValue(31, 8, year);
  if(now >= clockOuverture)
	result = TRUE;

//printf("\nBody_CP_Phase3('%s') returns %d", pPhase->InstanceName(), result);
  return result;
}

bool Body_CP_Plantations (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si plus de parcelles a planter
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_PLANTED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

//printf("\n'%s'::Body_CP_Plantations returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_Prunings_Phase2 (EntityMethod* pM)
//---------------------------------------------
// Description  :  
// Precondition : 
// Retour       : renvoie 'vrai' si
//                   - (cond 1) plus de parcelles a tailler
//                     OU
//                   - (cond 2) chantier AutumnTillage closed
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  //int now = pCurrentSim->Clock();
  //
  // condition 1
  //

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_PRUNED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	//
	// condition 2
	//
	Entity* pAutumnTillages = NULL;
	Entity* pConjunction = pChantier->GetSuperSet();
	pEntityTab pElemTab = pConjunction->GetDepthElementTab(ACTIVITY);
	int nbElem = pElemTab.size();
	for(int k=0;k<nbElem;k++) {
	  Entity* pElem_k = (Entity*)pElemTab.get_element(k);
	  if(pElem_k->IsInstanceOf(CONCURRENT_AUTUMN_TILLAGES)
		 ||
		 pElem_k->IsInstanceOf(SERIAL_AUTUMN_TILLAGES)) {
		pAutumnTillages = pElem_k;
		break;
	  }
	}
	if(pAutumnTillages) {
	  int situation = pAutumnTillages->GetIntVarValue(SITUATION);
//printf("\n'%s'::Body_CP_Prunings_Phase2 situation de '%s': %d", pChantier->InstanceName(), pAutumnTillages->InstanceName(), situation);
	  result = (situation == CLOSED);
	}
	else {
	  printf("\n'%s'::Body_CP_Prunings_Phase2 : pas de chantier AutumTillage trouve !\n", pChantier->InstanceName());
	  exit(0);
	}
  }

//printf("\n'%s'::Body_CP_Prunings_Phase2 returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_Prunings_Phase3 (EntityMethod* pM)
//---------------------------------------------
// Description  :  
// Precondition : 
// Retour       : renvoie 'vrai' si
//                   - (cond unique) plus de parcelles a tailler
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_PRUNED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

//printf("\n'%s'::Body_CP_Prunings_Phase3 returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_RegularPhytoTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si plus de parcelles a traiter 
// Comment      : cr en 5.3 +  MODIF JPR 130127 (manuel/motorized)
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  bool isSerialManual = pChantier->IsInstanceOf(SERIAL_MANUAL_REGULAR_PHYTO_TREATMENTS);
  bool isSerialMotorized = pChantier->IsInstanceOf(SERIAL_MOTORIZED_REGULAR_PHYTO_TREATMENTS);

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_REGULAR_PHYTO_TREATED);
	int isDone = TRUE;
	if(isSerialManual || isSerialMotorized) {
	  pPlot_k->SetIntArgValue(IS_MOTORIZATION_POSSIBLE,
							  OPERATION_CLASS_ARGUMENT,
							  MOTORIZED_SPRAYING_OPERATION);
	  bool isPlotMotorizable =
		pPlot_k->ExecPredicate(IS_MOTORIZATION_POSSIBLE);
	  if(isSerialManual) {
		if( ! isPlotMotorizable) {
		  isDone = App_FloatEQ(percentDone, (float)1.)
		    	|| App_FloatEQ(percentDone, (float)-1.); // + JPR 130220
//printf("\n'%s' %d percentDone = %f isDone = %d", pPlot_k->InstanceName(), isPlotMotorizable, percentDone, isDone);
		}
	  }
	  else  if(isPlotMotorizable) {
		isDone = App_FloatEQ(percentDone, (float)1.)
		      || App_FloatEQ(percentDone, (float)-1.); // + JPR 130220
//printf("\n'%s' %d percentDone = %f isDone = %d", pPlot_k->InstanceName(), isPlotMotorizable, percentDone, isDone);
	  }
	}
	else { // Concurrent
	isDone =    App_FloatEQ(percentDone, (float)1.)
	         || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	}
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

//printf("\n'%s'::Body_CP_RegularPhytoTreatments returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_ShootThinnings_Phase2 (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a broyer l'ont ete (condition 1)
//                  OU
//                - le chantier de labours d'automne est ferm (condition 2) 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  //int now = pCurrentSim->Clock();
  //
  // condition 1
  //
  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_SHOOT_THINNED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	//
	// condition 2
	//
	Entity* pAutumnTillages = NULL;
	Entity* pConjunction = pChantier->GetSuperSet();
	pEntityTab pElemTab = pConjunction->GetDepthElementTab(ACTIVITY);
	int nbElem = pElemTab.size();
	for(int k=0;k<nbElem;k++) {
	  Entity* pElem_k = (Entity*)pElemTab.get_element(k);
	  if(pElem_k->IsInstanceOf(CONCURRENT_AUTUMN_TILLAGES)
		 ||
		 pElem_k->IsInstanceOf(SERIAL_AUTUMN_TILLAGES)) {
		pAutumnTillages = pElem_k;
		break;
	  }
	}
	if(pAutumnTillages) {
	  int situation = pAutumnTillages->GetIntVarValue(SITUATION);
//printf("\n'%s'::Body_CP_ShootThinnings_Phase2 situation de '%s': %d", pChantier->InstanceName(), pAutumnTillages->InstanceName(), situation);
	  result = (situation == CLOSED);
	}
	else {
	  printf("\n'%s'::Body_CP_ShootThinnings_Phase2 : pas de chantier AutumTillage trouve !\n", pChantier->InstanceName());
	  exit(0);
	}
  }

//printf("\n'%s'::Body_CP_ShootThinnings_Phase2 returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_ShootThinnings_Phase3 (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                   - (cond unique) plus de parcelles a broyer
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_SHOOT_THINNED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

//printf("\n'%s'::Body_CP_ShootThinnings_Phase3 returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_SpringChemicalWeedings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a desherber l'ont ete (condition 1)
//                  OU
//                - on a atteint le 14/07 (condition 2)
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_DEBRANCHED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	// 
	// renvoyer TRUE ssi on a atteint le 14/07
	// 
	int now = pCurrentSim->Clock();
	tm* pTm = ClockValueToTm(now);
	int month = pTm->tm_mon;
	int year = pTm->tm_year + 1900;
	if(month > 7)    //  sept, etc.
	  year = year + 1;
	delete pTm;
	
	int clockOuverture = DateToClockValue(14, 7, year);
	if(now >= clockOuverture)
	  result = TRUE;
  }

//printf("\n'%s'::Body_CP_SpringChemicalWeedings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_SpringTillages (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a labourer l'ont ete (condition 1)
//                  OU (modif JPR 120730)
//                - mme si toutes les parcelles ne sont pas faites, on ferme
//                  le chantier si le suivant demande  tre ouvert
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
//((Activity*)pChantier)->DisplaySituation();
//printf("\nDEB '%s'::Body_CP_SpringTillages", pChantier->InstanceName());
  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_SPRING_TILLED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	// ci-dessous modif JPR 120730 Dhivine_4.9
	Entity* pIterate = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION,
													FALSE);
	int currentReplicationNumber 
	  = pIterate->GetIntVarValue(REPLICATION_COUNTER);
	int targettedReplicationNumber = currentReplicationNumber + 1; 
	int prevTillageClock = 
	  pIterate->GetIntConstValue(PREVIOUS_REPLICATION_REF_DATE);
	result = OpeningCondition_SpringTillages(pChantier,
												targettedReplicationNumber,
												prevTillageClock);
  }

//printf("\n'%s'::Body_CP_SpringTillages returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_Trellisings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a "clipper" l'ont ete (condition 1)
//                  OU // abandonn 110210
//                - on a atteint le 15/07 (condition 2) (
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_TRELLISED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;

  /* 
  // remarque NK 110210 : "pour trellisings, on peut enlever la cond. sur la
  // date, elle n'est pas tres utile et ca risque de bloquer le clippings."
  if(! result) {
	// renvoyer TRUE ssi on a atteint le 15/07
	// 
	int now = pCurrentSim->Clock();
	tm* pTm = ClockValueToTm(now);
	int month = pTm->tm_mon;
	int year = pTm->tm_year + 1900;
	if(month > 7)    //  sept, etc.
	  year = year + 1;
	delete pTm;
	
	int clockOuverture = DateToClockValue(15, 7, year);
	if(now >= clockOuverture)
	  result = TRUE;
  }
  */

//printf("\n'%s'::Body_CP_Trellisings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_WinterTillages_OnDate (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : renvoie 'vrai' si
//                - toutes les parcelles a labourer l'ont ete (condition 1)
//                  OU
//                - on a atteint le 01/03 (condition 2)
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = FALSE;

  bool allDone = TRUE;
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentDone = pPlot_k->GetFloatVarValue(PERCENT_DEBRANCHED);
	int isDone =    App_FloatEQ(percentDone, (float)1.)
	             || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	if(! isDone) {
	  allDone = FALSE;
	  break;
	}
  }
  if(allDone)
	result = TRUE;
  else {
	int now = pCurrentSim->Clock();
	tm* pTm = ClockValueToTm(now);
	int month = pTm->tm_mon;
	int year = pTm->tm_year + 1900;
	if(month > 7)    //  sept, etc.
	  year = year +1;
	delete pTm;
	
	int clockOuverture = DateToClockValue(1, 3, year);
	if(now >= clockOuverture)
	  result = TRUE;
  }

//printf("\n'%s'::Body_CP_WinterTillages_OnDate returns %d\n", pChantier->InstanceName(), result);
  return result;
}

bool Body_CP_alwaysTrue (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  return TRUE;


}

bool Body_MBS_Fertilizations_Phase1 (EntityMethod* pM)
//---------------------------------------------
// L'evolution de l'etat du systeme etant vue comme une horloge qui tourne,
// doit retourner vrai si l'instant indique par cette sorte d'horloge
// est posterieur a la fin de la fenetre d'ouverture de l'activite.
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  // 
  // renvoyer TRUE s'il faut commencer a tailler
  //
  bool result = OpeningCondition_Prunings_OnDate(pChantier);

//printf("\n'%s'::Body_MBS_Fertilizations_Phase1 returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_MBS_Fertilizations_Phase3 (EntityMethod* pM)
//---------------------------------------------
// L'evolution de l'etat du systeme etant vue comme une horloge qui tourne,
// doit retourner vrai si l'instant indique par cette sorte d'horloge
// est posterieur a la fin de la fenetre d'ouverture de l'activite.
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;
  // 
  // renvoyer TRUE ssi on a atteint le 31/05
  // 
  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year + 1;
  delete pTm;

  int clockOuverture = DateToClockValue(31, 5, year);
  if(now >= clockOuverture)
	result = TRUE;

//printf("\n'%s'::Body_MBS_Fertilizations_Phase3 returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_MBS_OptionalPhase2 (EntityMethod* pM) {
//-------------------------------------------------------------------------
// L'evolution de l'etat du systeme etant vue comme une horloge qui tourne,
// doit retourner vrai si l'instant indique par cette sorte d'horloge
// est posterieur a la fin de la fenetre d'ouverture de l'activite.
//-------------------------------------------------------------------------
  Entity* pPhase = pM->DescribedEntity();
  bool result = FALSE;
  // 
  // renvoyer TRUE si la phase n'a pas ete ouverte immediatement apres
  // la date a laquelle il faut commencer a tailler, cad la date
  // de fermeture de la phase 1
  //
  Entity* pSuperSet = pPhase->GetSuperSet();
  Entity* pConduite;
  if(pSuperSet->IsInstanceOf(ACTIVITY_OPTIONAL)) // cas normal
	pConduite = pSuperSet->GetSuperSet();
  else                                           // cas exceptionnel
	pConduite = pPhase->GetSuperSet();
//printf("\nBody_MBS_OptionalPhase2 pConduite : '%s'", pConduite->InstanceName());
  Entity* pPreviousPhase = pConduite->GetElement(0);    // phase 1
  int minBegDate = pPreviousPhase->GetIntVarValue(END_DATE);

  int maxBegDate = minBegDate + 1;
  
  if(pCurrentSim->Clock() > maxBegDate)
	result = TRUE;
//printf("\n'%s'::MBS_OptionalPhase2_Body returns %d", pPhase->InstanceName(), result);
  return result;
}

bool Body_MBS_Plantations (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Activity* pChantier = (Activity*)pM->DescribedEntity();
  bool result = FALSE;
  // 
  // renvoyer TRUE si le chantier n'a pas ete ouvert immediatement apres
  // la date a laquelle il faut commencer a planter
  // (cad s'il n'y a aucune parcelle a planter)
  //
  if(pChantier->GetIntVarValue(SITUATION) == OPEN) { // + JPR 120907
	int nbElem = pChantier->GetNumberOfOperands();
	if(nbElem == 0)
	  result = TRUE;
  }

//printf("\n'%s'::Body_MBS_Plantations returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_MBS_WinterTillages (EntityMethod* pM)
//---------------------------------------------
// L'evolution de l'etat du systeme etant vue comme une horloge qui tourne,
// doit retourner vrai si l'instant indique par cette sorte d'horloge
// est posterieur a la fin de la fenetre d'ouverture de l'activite.
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  bool result = FALSE;
  // 
  // renvoyer TRUE ssi on a atteint le 15/02
  // 
  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year + 1;
  delete pTm;

  int clockOuverture = DateToClockValue(15, 2, year);
  if(now >= clockOuverture)
	result = TRUE;

//printf("\n'%s'::Body_MBS_WinterTillages returns %d", pChantier->InstanceName(), result);
  return result;



}

bool Body_MIOS_AutumnTillages (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_AutumnTillages", pChantier->InstanceName());
//((Activity*)pChantier)->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::Body_MIOS_AutumnTillages : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'Body_MIOS_AutumnTillages : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_AUTUMN_TILLAGES,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_AUTUMN_TILLAGES,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_AUTUMN_TILLAGES);
  //           ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;

//printf("\n'%s'::Body_MIOS_AutumnTillages returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_ChemicalWeedings (EntityMethod* pM)
//---------------------------------------------------------------------------
// Si l'activit  non primitive est ouverte ou en cours et que cette m thode
// a  t  dot e d'un corps, alors la m thode de mise   jour de la situation
// invoque cette m thode avant de s'appliquer r cursivement   ses  l ments.
//---------------------------------------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity(); 
//printf("\nentree '%s'::Body_MIOS_ChemicalWeedings", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::Body_MIOS_ChemicalWeedings : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'Body_MIOS_ChemicalWeedings : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_CHEMICAL_WEEDINGS, 
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots);
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_CHEMICAL_WEEDINGS, 
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_CHEMICAL_WEEDINGS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_ChemicalWeedings returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
};

bool Body_MIOS_Clippings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_Clippings", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_CLIPPINGS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_CLIPPINGS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_CLIPPINGS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_Clippings returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_ConcurrentAntiMildewTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_ConcurrentAntiMildewTreatments", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_PHYTO_TREATMENTS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_ConcurrentAntiMildewTreatments returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_ConcurrentExtraPhytoTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_ConcurrentExtraPhytoTreatments", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_PHYTO_TREATMENTS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_ConcurrentExtraPhytoTreatments returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_ConcurrentRegularPhytoTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_ConcurrentRegularPhytoTreatments", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_PHYTO_TREATMENTS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_ConcurrentRegularPhytoTreatments returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_Debranchings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_DEBRANCHINGS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_DEBRANCHINGS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_DEBRANCHINGS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_Debranchings returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_Fertilizations (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_Fertilizations", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::Body_MIOS_Fertilizations : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! '%s'::Body_MIOS_Fertilizations : la fille '%s' n'est pas primitive\n", pChantier->InstanceName(), pAct->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_FERTILIZATIONS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_FERTILIZATIONS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_FERTILIZATIONS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_Fertilizations returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_InitSpringTillages (EntityMethod* pM)
//--------------------------------------------------------------------------
// Si l'activit  non primitive est ouverte ou en cours et que cette m thode
// a  t  dot e d'un corps, alors la m thode de mise   jour de la situation
// invoque cette m thode avant de s'appliquer r cursivement   ses  l ments.
//--------------------------------------------------------------------------
{
  bool toContinue = FALSE;  
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::modifyInOpenSituation", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
//printf("\n\tnbSons = %d\n", nbSons);
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'\n", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! serialInitSpringTillages_modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! serialInitSpringTillages_modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_INIT_SPRING_TILLAGES,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots);  
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_INIT_SPRING_TILLAGES,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_INIT_SPRING_TILLAGES);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_InitSpringTillages returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
};

bool Body_MIOS_Plantations (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE; 
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_Plantations", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::Body_MIOS_Plantations : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! '%s'::Body_MIOS_Plantations : la fille '%s' n'est pas primitive\n", pChantier->InstanceName(), pAct->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PLANTATIONS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PLANTATIONS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_PLANTATIONS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_Plantations returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_Prunings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE; 
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_Prunings", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();  // 120607
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
//printf("\n\tpAct[%d] : '%s'", k, pAct->InstanceName());
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
//printf("\n !!!!! %x::DeleteInDepth()", pAct);
//pChantier->DisplaySituation();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PRUNINGS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PRUNINGS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_PRUNINGS);  // 120618
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_Prunings returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_SerialAntiMildewTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_SerialAntiMildewTreatments", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_PHYTO_TREATMENTS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_SerialAntiMildewTreatments returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;



}

bool Body_MIOS_SerialExtraPhytoTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_SerialExtraPhytoTreatments", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_PHYTO_TREATMENTS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_SerialExtraPhytoTreatments returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_SerialManualRegularPhytoTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_SerialManualRegularPhytoTreatments", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_PHYTO_TREATMENTS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_SerialManualRegularPhytoTreatments returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_SerialMotorizedRegularPhytoTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE;
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_SerialMotorizedRegularPhytoTreatments", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_PHYTO_TREATMENTS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_SerialMotorizedRegularPhytoTreatments returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_ShootThinnings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE; 
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_ShootThinnings", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SHOOT_THINNINGS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SHOOT_THINNINGS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_SHOOT_THINNINGS);  // 120618
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_ShootThinnings returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();printf("\n");
  return toContinue;
}

bool Body_MIOS_SpringChemicalWeedings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE; 
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_SpringChemicalWeedings", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SPRING_CHEMICAL_WEEDINGS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SPRING_CHEMICAL_WEEDINGS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_SPRING_CHEMICAL_WEEDINGS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_SpringChemicalWeedings returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_SpringTillages (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE; 
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_SpringTillages", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SPRING_TILLAGES,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SPRING_TILLAGES,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_SPRING_TILLAGES);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_SpringTillages returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_Trellisings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE; 
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::Body_MIOS : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'Body_MIOS : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_TRELLISINGS,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_TRELLISINGS,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_TRELLISINGS);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_Trellisings returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_MIOS_WinterTillages (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool toContinue = FALSE; 
  Activity* pChantier = (Activity*)pM->DescribedEntity();
//printf("\nentree '%s'::Body_MIOS_WinterTillages", pChantier->InstanceName());
//pChantier->DisplaySituation();

  pEntityTab* pTmpTab
	= pChantier->GetEntityTabValue(TERMINATED_PLOTS_ATTRIBUTE);
  pEntityTab* pTerminatedPlots = new pEntityTab(*pTmpTab);
  pEntityTab* pInCoursePlots = new pEntityTab();

  int nbSons = pChantier->GetNumberOfOperands();
  for(int k=nbSons-1;k>=0;k--) {
	Entity* pAct = pChantier->GetOperand(k);
	int situation = pAct->GetIntVarValue(SITUATION);
	switch (situation) {
	case CLOSED : {
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case WAITING :
	case SLEEPING :
	case OPEN : {
	  Entity* pOt = NULL;
	  Entity* pOtSpec= pAct->GetEntityVarValue(OPERATION_SPEC_ATTRIBUTE);
	  if(pOtSpec) pOt = pOtSpec->GetEntityVarValue(SPECIFIED_OPERATION);
	  if(pOt) ((Operation*)pOt)->DeleteInDepth();
	  ((PrimitiveActivity*)pAct)->DeleteInDepth();
	  break;
	}
	case IN_COURSE : {
	  // --------------------------------------------------------
	  // recuperation de la parcelle operee
	  // --------------------------------------------------------
	  Entity* pPlot = NULL;
	  int type = pAct->GetIntConstValue(TYPE_ATTRIBUTE);
	  if(type == PRIMITIVE_ACTIVITY) {
		Operation* pOt = (Operation*)pAct->GetEntityVarValue(ALLOCATED_OPERATION);
		Entity* pCurrentOO = pOt->GetEntityConstValue(CURRENT_OPERATED_OBJECT);
		if(pCurrentOO) {
		  pPlot = pCurrentOO->GetEntityConstValue(RESOURCE_ENTITY);
		  pInCoursePlots->push_back(pPlot);
		}
		else {
		  printf("\n!!! '%s'::modifyInOpenSituation : la parcelle operee n'a pas pu etre designee\n    pour l'operation '%s'\n", pChantier->InstanceName(), pOt->InstanceName());
		  exit(0);
		}
	  }
	  else {
		printf("\n!!! 'modifyInOpenSituation : la fille '%s' de la conjunction '%s' n'est pas primitive\n", pAct->InstanceName(), pChantier->InstanceName());
	  }
	  break;
	}
	}
  }
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_WINTER_TILLAGES,
								  TERMINATED_PLOTS_ARGUMENT, 
								  pTerminatedPlots); 
  pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_WINTER_TILLAGES,  
								  IN_COURSE_PLOTS_ARGUMENT, 
								  pInCoursePlots);
  toContinue = pChantier->ExecPredicate(ADD_NEW_SITUATED_WINTER_TILLAGES);
  //          ---------------------------------------------

  delete pInCoursePlots;
  delete pTerminatedPlots;
//printf("\n'%s'::Body_MIOS_WinterTillages returns %d", pChantier->InstanceName(), toContinue);
//pChantier->DisplaySituation();
  return toContinue;
}

bool Body_OP_AutumnTillages (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_AutumnTillages(pChantier);

  if(result) {
	  
	//=================================================
	// creation du premier lot de parcelles a labourer
	// en fonction de l'option SER(ial) / PAR(allel)
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_AUTUMN_TILLAGES,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots);
  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_AUTUMN_TILLAGES,
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
  	pChantier->ExecPredicate(ADD_NEW_SITUATED_AUTUMN_TILLAGES);
  	//     ---------------------------------------------

	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_AutumnTillages returns %d\n", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_ChemicalWeedings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_ChemicalWeedings(pChantier);

  if(result) {
	  
	//=================================================
	// creation du premier lot de parcelles a desherber
	// en fonction de l'option SER(ial) / PAR(allel)
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_CHEMICAL_WEEDINGS,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots);
  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_CHEMICAL_WEEDINGS,
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
  	pChantier->ExecPredicate(ADD_NEW_SITUATED_CHEMICAL_WEEDINGS);
  	//     ---------------------------------------------

	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_ChemicalWeedings returns %d\n", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_Clippings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_Clippings(pChantier);

  if(result) {

	//=================================================
	// creation du premier lot de parcelles a epamprer
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_CLIPPINGS,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots); 
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_CLIPPINGS,  
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	pChantier->ExecPredicate(ADD_NEW_SITUATED_CLIPPINGS);
	//          ---------------------------------------------
	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_Clippings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_Debranchings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_Debranchings(pChantier);

  if(result) {
	/*
	// patch JPR 110209 
	// qd des parcelles OPEN ne sont pas commenc es immediatement,
	// la plot operee n'est ni dans terminatedPlots ni dans inCoursePlots
	// --> plot est (re)mise dans la liste des parcelels selectionnees
	// --> une activite primitive est (re)creee pour elle
	//
	// ==> on enleve du chantier les activites OPEN (== not IN_COURSE)
	// (normalement fait dans MIOS !
    //
	int nbSons = pChantier->GetNumberOfOperands();
	for(int k=nbSons-1;k>=0;k--) {
	  Entity* pAct = pChantier->GetOperand(k);
	  Boolean inCourseFound = FALSE;
	  int situation = pAct->GetIntVarValue(SITUATION);
	  if(situation == OPEN) {
		pChantier->RemoveOperand(k);
	  }
	}
	*/

	//=================================================
	// creation du premier lot de parcelles a epamprer
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_DEBRANCHINGS,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots); 
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_DEBRANCHINGS,  
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	pChantier->ExecPredicate(ADD_NEW_SITUATED_DEBRANCHINGS);
	//          ---------------------------------------------
	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_Debranchings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_Fertilizations_OnChain (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_Fertilizations_OnChain(pChantier);

  if(result) {

	//=================================================
	// creation du premier lot de parcelles a fertiliser
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_FERTILIZATIONS,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots); 
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_FERTILIZATIONS,  
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	pChantier->ExecPredicate(ADD_NEW_SITUATED_FERTILIZATIONS);
	//          ---------------------------------------------
	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_Fertilizations_OnChain returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_Fertilizations_OnDate (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_Fertilizations_OnDate(pChantier);

  if(result) {

	//=================================================
	// creation du premier lot de parcelles a fertiliser
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_FERTILIZATIONS,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots); 
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_FERTILIZATIONS,  
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	pChantier->ExecPredicate(ADD_NEW_SITUATED_FERTILIZATIONS);
	//          ---------------------------------------------
	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_Fertilizations_OnDate returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_InitSpringTillages (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_InitSpringTillages(pChantier);

  if(result) {
	  
	//=================================================
	// creation du premier lot de parcelles a labourer
	// en fonction de l'option SER(ial) / PAR(allel)
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_INIT_SPRING_TILLAGES,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots);
  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_INIT_SPRING_TILLAGES,
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
  	pChantier->ExecPredicate(ADD_NEW_SITUATED_INIT_SPRING_TILLAGES);
  	//     ---------------------------------------------

	delete pTerminatedPlots;
	delete pInCoursePlots;
  }
  if(result) {
	pChantier->SetFloatVarValue(OPERATED_VINEYARD_SUB_AREA, (float)0.);
  }

//printf("\n'%s'::Body_OP_InitSpringTillages returns %d\n", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_OptionalPhase2 (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
// Il y a un Body_CP_Phase1 qui autorise de fermer la phase 1 si 
// OpeningCondition_Prunings est vrai. D s lors, l'ouverture de la phase 2
// ne depend que de la presence d'une parcelle encore a labourer.
//---------------------------------------------
{
  Entity* pPhase = pM->DescribedEntity();

  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pPhase);
  
  Entity* pPlot_j = NULL;
  int nbPlots = pEA->GetNumberOfElements();
  for(int j=0;j<nbPlots;j++) {
	pPlot_j = pEA->GetElement(j);
	float percentTilled = pPlot_j->GetFloatVarValue(PERCENT_AUTUMN_TILLED);
	if(App_FloatEQ(percentTilled, (float)0.)) {
	  result = TRUE;
	  break;
	}
  }
//printf("\n'%s' Body_OP_OptionalPhase2 returns %d", pPhase->InstanceName(), result);if((result) && pPlot_j) printf(" because '%s' not tilled", pPlot_j->InstanceName());
  return result;
}

bool Body_OP_Phase3 (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : TRUE ssi le chantier d'AutumnTillage est ferme (celui de
//              : la phase 1 ou celui de la phase 2, si on y est entre)
//---------------------------------------------
{
  Entity* pPhase = pM->DescribedEntity();
//printf("\nDEB '%s'Body_OP_Phase3", pPhase->InstanceName());
  Entity* pEA = App_GetVineyard((Activity*)pPhase);
  int nbPlots = pEA->GetNumberOfElements();
  //
  // si une parcelle est en cours de labour d'automne, on n'ouvre pas
  //
  bool result = TRUE;
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);
	float percentAutumnTilled = 
	  pPlot_k->GetFloatVarValue(PERCENT_AUTUMN_TILLED);
//printf("\n'%s'_OP_Phase3) %s percentAutumnTilled = %f", pPhase->InstanceName(), pPlot_k->InstanceName(), percentAutumnTilled);
	int isATInCourse = App_FloatGT(percentAutumnTilled, (float)-1.)
	                   && 
                       App_FloatLT(percentAutumnTilled, (float)1.);
	if(isATInCourse) {
	  result = FALSE;
	  break;
	}
  }
//printf("\n'%s'Body_OP_Phase3 returns %d", pPhase->InstanceName(), result);
  return result;
}

bool Body_OP_PhytoTreatments (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
//printf("\nt = %d entree Body_OP_PhytoTreatments pChantier : '%s'", pCurrentSim->Clock(), pChantier->InstanceName());
  Vineyard* pEA = App_GetVineyard((Activity*)pChantier);

  int typeChantier = App_GetDistributedActivitySetType(pChantier);

  //
  // cascade de tests partiels d'ouverture
  // -------------------------------------
  bool result = FALSE;
  bool result_primary = TRUE;
  if(typeChantier != REGULAR_PHYTO) {
	result_primary =            // EXTRA ou ANTI_MILDEW seulement
	  Common_PhytoTreatment_Primary_OpeningPredicate(pChantier);
  }
  if(result_primary) {
	bool result_onDate = 
	  Common_PhytoTreatment_OnDate_OpeningPredicate(pChantier);
	
	if(result_onDate) {
	  //
	  // etabissement date souhaitable (= nominale) de l'intervention
	  // ------------------------------------------------------------
	  int minBegDate = pChantier->GetIntVarValue(MIN_BEG_DATE);
	  int cadence = App_GetIntDecisionOption(pEA, 
										 OPT_PHYTO_TREATMENT_CADENCE);
//printf("\n\ttypeChantier = %d", typeChantier);
//printf("\n\tcadence = %d", cadence);
//printf("\n\tminBegDate = %d", minBegDate);
	  int nominalDate = (float)0.;
	  if((typeChantier == ANTI_MILDIOU)
		 ||
		 (typeChantier == EXTRA_PHYTO)) {
		nominalDate = minBegDate;
	  }
	  else {           // REGULAR_PHYTO
		Entity* pIterate = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
		int iterationIndex = pIterate->GetIntVarValue(REPLICATION_COUNTER);
//printf("\n\titerationIndex = %d", iterationIndex);
		if(iterationIndex == 0)
		  nominalDate = minBegDate;
		else {
		  if(cadence > 0) {                  // par convention "X jours nominalement"
			if(cadence < 15)
			  nominalDate = minBegDate + (cadence / 2)*24 ; // cad last minBegdate + cadence
			else
			  nominalDate = minBegDate + (cadence - 11)*24 ; // 
		  }
		  else {                             // par convention "X jours minimum"
			nominalDate = minBegDate + (-cadence - 8)-24 ; // 
			// parce que le URS a etabli la minBegDate comme la date minimale   laquelle
			// on peut avancer un Regular, compte tenu de l'opportunite d'un AM
		  }
		}
	  }
	  pChantier->SetIntConstValue(ACTIVITY_NOMINAL_DATE, nominalDate);
//printf("\n\tnominalDate = %d", nominalDate);

	  result = 
		Common_PhytoTreatment_WeatherOriented_OpeningPredicate(pChantier);
	}
  }
  if(result) {
	  
	if(typeChantier == REGULAR_PHYTO) {
	  //
	  // etablit AntiMildewScheduled pour AddNewSituatedPhytoTreatment
	  //
	  pChantier->SetEntityArgValue(SET_SCHEDULED_ANTI_MILDEW, 
								   VINEYARD_ARGUMENT, pEA);
	  pChantier->ExecVoidMethod(SET_SCHEDULED_ANTI_MILDEW);
	}
	else if(typeChantier == EXTRA_PHYTO) {  // + JPR 130223
	  Entity* pMother = pChantier->GetSuperSet();
	  Entity* pComposedPrgm = 
		(Entity*)pMother->GetFirstContainer(PHYTO_TREATMENT_COMPOSED_PROGRAM, 
											TRUE);
	  Entity* regularIteration = pComposedPrgm->GetElement(0); // par convention
	  int regularIterationIndex = regularIteration->GetIntVarValue(REPLICATION_COUNTER);
	  pChantier->SetIntConstValue(REGULAR_PHYTO_TREATMENT_INDEX, regularIterationIndex);
	}
	  
	//pChantier->RemoveElements(); // fait dans URS de l'it ration du chantier
	
	//=================================================
	// creation des activites relatives a chaque parcelle
	//=================================================
	
	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide
	
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots);
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PHYTO_TREATMENTS,
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	
	pChantier->ExecPredicate(ADD_NEW_SITUATED_PHYTO_TREATMENTS);
	//     ---------------------------------------------
	
	delete pTerminatedPlots;
	delete pInCoursePlots;

	pChantier->SetIntConstValue(ACTUAL_REALIZATION_BEG_DATE, -9);
  }
//printf("\nt = %d Body_OP_PhytoTreatments pChantier : '%s' returns %d", pCurrentSim->Clock(), pChantier->InstanceName(), result);
  return result;
};

bool Body_OP_Plantations_OnDate (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_Plantations_OnDate(pChantier);

  if(result) {

	//=================================================
	// creation du premier lot de parcelles a planter
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PLANTATIONS,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots); 
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PLANTATIONS,  
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	pChantier->ExecPredicate(ADD_NEW_SITUATED_PLANTATIONS);
	//          ---------------------------------------------
	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_Plantations_OnDate returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_Prunings_OnDate (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = TRUE;
  //
  // Quand ce chantier est en phase 2 ou 3 d'une conduite (cas normal),
  // on ferme la phase 1 si OpeningCondition_Prunings_OnDate
  // renvoie 'vrai'.
  // En consequence, l'appel de la ligne ci-dessous renvoie n cessairement
  // 'vrai'. On l'inhibe donc (avec initialisation de result a TRUE).
  //
  //result = OpeningCondition_Prunings_OnDate(pChantier);
	

  if(result == TRUE) {
	
	//=================================================
	// creation du premier lot de parcelles a tailler
	//=================================================
	
	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PRUNINGS, 
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots); 
  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_PRUNINGS,
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
  	pChantier->ExecPredicate(ADD_NEW_SITUATED_PRUNINGS);
  	//  ---------------------------------------------

	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\nBody_OP_Prunings_onDate_Body('%s') returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_ShootThinnings_OnSurface (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_ShootThinnings_OnSurface(pChantier);

  if(result == TRUE) {
	
	//=================================================
	// creation du premier lot de parcelles a broyer
	//=================================================
	
	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SHOOT_THINNINGS, 
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots);
  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SHOOT_THINNINGS, 
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	pChantier->ExecPredicate(ADD_NEW_SITUATED_SHOOT_THINNINGS);
  	//  ---------------------------------------------

	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_ShootThinnings_OnSurface returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_SpringChemicalWeedings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_SpringChemicalWeedings(pChantier);

  if(result) {

	//=================================================
	// creation du premier lot de parcelles a desherber au printemps
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SPRING_CHEMICAL_WEEDINGS,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots); 
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SPRING_CHEMICAL_WEEDINGS,  
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	pChantier->ExecPredicate(ADD_NEW_SITUATED_SPRING_CHEMICAL_WEEDINGS);
	//          ---------------------------------------------
	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_SpringChemicalWeedings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_SpringTillages (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();
  // ci-dessous + JPR 120730 Dhivine_4.9
  Entity* pIterate = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION,
												   FALSE);
  int replicationNumber = pIterate->GetIntVarValue(REPLICATION_COUNTER);
  int prevTillageClock = 
	pIterate->GetIntConstValue(PREVIOUS_REPLICATION_REF_DATE);
  // ci-dessous modif JPR 120730 Dhivine_4.9
  bool result = OpeningCondition_SpringTillages(pChantier,
												replicationNumber,
												prevTillageClock);

  if(result) {
	  
	//=================================================
	// creation du premier lot de parcelles a labourer
	// en fonction de l'option SER(ial) / PAR(allel)
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SPRING_TILLAGES,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots);
  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_SPRING_TILLAGES,
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	pChantier->ExecPredicate(ADD_NEW_SITUATED_SPRING_TILLAGES);
  	//     ---------------------------------------------

	delete pTerminatedPlots;
	delete pInCoursePlots;
  }
  if(result) {
	pChantier->SetFloatVarValue(OPERATED_VINEYARD_SUB_AREA, (float)0.);
	// ci-dessous transport 120823 a partir de OpeningCondition_ST
	pIterate->SetIntConstValue(PREVIOUS_REPLICATION_REF_DATE, -9);
//printf("\n\t'%s'\t REF_DATE  = -9", pIterate->InstanceName());

	pChantier->SetIntConstValue(ACTUAL_REALIZATION_BEG_DATE, -9); // + JPR 130324
  }

//printf("\n'%s'::Body_OP_SpringTillages returns %d\n", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_Trellisings (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_Trellisings(pChantier);

  if(result) {

	//=================================================
	// creation du premier lot de parcelles a relever
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_TRELLISINGS,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots); 
	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_TRELLISINGS,  
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
	pChantier->ExecPredicate(ADD_NEW_SITUATED_TRELLISINGS);
	//          ---------------------------------------------
	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_Trellisings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Body_OP_WinterTillages_OnDate (EntityMethod* pM)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pChantier = pM->DescribedEntity();

  bool result = OpeningCondition_WinterTillages_OnDate(pChantier);

  if(result) {
	  
	//=================================================
	// creation du premier lot de parcelles a labourer
	// en fonction de l'option SER(ial) / PAR(allel)
	//=================================================

	pChantier->ClearEntityTabValues(TERMINATED_PLOTS_ATTRIBUTE);

	pEntityTab* pTerminatedPlots = new pEntityTab(); // vide
	pEntityTab* pInCoursePlots = new pEntityTab(); // vide

  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_WINTER_TILLAGES,
									TERMINATED_PLOTS_ARGUMENT, 
									pTerminatedPlots);
  	pChantier->SetEntityTabArgValue(ADD_NEW_SITUATED_WINTER_TILLAGES,
									IN_COURSE_PLOTS_ARGUMENT, 
									pInCoursePlots);
  	pChantier->ExecPredicate(ADD_NEW_SITUATED_WINTER_TILLAGES);
  	//     ---------------------------------------------

	delete pTerminatedPlots;
	delete pInCoursePlots;
  }

//printf("\n'%s'::Body_OP_WinterTillages_OnDate returns %d\n", pChantier->InstanceName(), result);
  return result;
}

bool Common_PhytoTreatment_OnDate_OpeningPredicate (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Vineyard* pEA = App_GetVineyard((Activity*)pChantier);
  int now = pCurrentSim->Clock();
//printf("\nt = %d entree Common_PhytoTreatment_OnDate_OP chantier : '%s'", now, pChantier->InstanceName());

  tm* pTm = ClockValueToTm(now);

  int now_hour = pTm->tm_hour; // + JPR 130224 pour restriction ouverture a la 'wakeUpHour' pour Regular

  int wday = pTm->tm_wday;// modif JPR 121214 (5.1)
  // si Dimanche ou Samedi, on se donnera jusqu' lundi soir
  // au lieu du soir mme
  if(wday == 0) pTm->tm_mday =  pTm->tm_mday + 1;  // modif JPR 130114
  else if(wday == 6) pTm->tm_mday =  pTm->tm_mday + 2;  // modif JPR 130114
  pTm->tm_hour = 23;
  mktime(pTm);
  int ceSoir = StructTmToClockValue(pTm);
  delete pTm; 

  bool result = FALSE;
  //=================================================
  // etablissement de la date de debut du chantier Regular
  // pour cette iteration
  //=================================================
  Entity* pMother = pChantier->GetSuperSet();
  Entity* pComposedPrgm = 
	(Entity*)pMother->GetFirstContainer(PHYTO_TREATMENT_COMPOSED_PROGRAM, 
										TRUE);
  Entity* regularIteration = pComposedPrgm->GetElement(0); // par convention
  int regularIterationIndex = regularIteration->GetIntVarValue(REPLICATION_COUNTER);
  Entity* iteratedActivity = regularIteration->GetElement(0);
  int actualRegularBegDate = D_INTMAX;
  if(iteratedActivity->IsInstanceOf(VINEYARD_ITERATED_CONJUNCTIVE_SUBPLAN)) {
	//
	// cas SERIAL  : iterate(conj(chantierManual, chantierMotorized))
	//         (voir constructeur de RegularPhytoTreatmentsIteration)
	//
	Entity* pChantier0 = iteratedActivity->GetElement(0);
	int actualRegularBegDate0 =
	  pChantier0->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
	if((actualRegularBegDate0 > -9)  // correction JPR 130228
	   &&
	   (actualRegularBegDate0 < actualRegularBegDate))
	  actualRegularBegDate = actualRegularBegDate0;
	Entity* pChantier1 = iteratedActivity->GetElement(1);
	int actualRegularBegDate1 = 
	  pChantier1->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
	if((actualRegularBegDate1 > -9)  // correction JPR 130228
	   &&
	   (actualRegularBegDate1 < actualRegularBegDate))
	  actualRegularBegDate = actualRegularBegDate1;
  }
  else {
	//
	// cas CONCURRENT : iterate(chantierManual)      ou bien  
	//                  iterate(chantierMotorized))
	//
	actualRegularBegDate = 
	  iteratedActivity->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
  }
//printf("\n\tactualRegularBegDate = %d\n", actualRegularBegDate);

  //=================================================
  // calcul fenetre pour extra-oidium et/ou anti-mildiou
  // sert aussi comme minBegDate du prochain Regular
  //=================================================
  int cadence = App_GetIntDecisionOption(pEA, 
										 OPT_PHYTO_TREATMENT_CADENCE);
  int delay;
  if(cadence > 0) {
	if(cadence < 15) {
	  delay = (cadence / 2) - 1;
	}
	else {
	  delay = 11 - 1;
	}
  }
  else {    // cadence 'au moins X jours'
	delay = 11 - 1;
  }
//printf("\n\tnow=%d actualRegularBegDate=%d delay=%d", now, actualRegularBegDate, delay*24);

  int typeChantier = App_GetDistributedActivitySetType(pChantier);
  if(typeChantier == ANTI_MILDIOU) {
	//=================================================
	// test de l'ouverture sur position p.r   debut chantier 'regular'
	// + imposition d'un delai court (3j) pour commencer les operations
	//=================================================
	if(now < actualRegularBegDate + (delay+1)*24) {
	  result = TRUE;
	  pChantier->SetIntVarValue(MIN_BEG_DATE, now);
	  pChantier->SetIntVarValue(MAX_BEG_DATE, ceSoir);
//((Activity*)pChantier)->PrintDates();
	}
  }
  else if(typeChantier == EXTRA_PHYTO) {
	//=================================================
	// test de l'ouverture .....
	// 
	//=================================================
	int wakeUpHour = gIntParam_morningUpdateSituation_normalHour_;
	if(now_hour == wakeUpHour) { // + JPR 130226
	  int thisRegularIterationIndex =
		pChantier->GetIntConstValue(REGULAR_PHYTO_TREATMENT_INDEX);
	  //  + JPR 130223 : pour qu'un nouveau chantier 'Extra' puisse etre ouvert
	  // il faut qu'un nouveau chantier 'Regular' l'ait ete. La valeur initiale 
	  // de RegularPhytoTreatmentIndex est -9 : on peut donc ouvrir un chantier
	  // 'Extra' apres le premier 'regular'. Une fois realise (ou pas) cet
	  //  'Extra', son RegularPhytoTreatmentIndex passe a 0, et il faut attendre
	  //  un nouveau 'Regular' (index=1) pour que le test ci-dessous soit vrai.
	  if(regularIterationIndex > thisRegularIterationIndex) {
		int actualExtraBegDate =
		  pChantier->GetIntConstValue(ACTUAL_REALIZATION_BEG_DATE);
//printf("\n\tactualExtraBegDate=%d", actualExtraBegDate);
		// modif JPR 121001 : date min ramene au debut du jour
		//                    date max ramene au debut du jour suivant
		if((actualExtraBegDate < 0)
		   ||
		   (actualExtraBegDate < actualRegularBegDate)) {
		  
		  int thisTreatmentMinClock = actualRegularBegDate + delay*24;
//printf("\nthisTreatmentMinClock = %d transforme en ", thisTreatmentMinClock);
		  tm* tm_tmp = ClockValueToTm(thisTreatmentMinClock);
		  tm_tmp->tm_hour = gIntParam_morningUpdateSituation_specialHour_;
		  mktime(tm_tmp);
		  thisTreatmentMinClock = (int)StructTmToClockValue(tm_tmp);
//printf(" %d", thisTreatmentMinClock);

		  int thisTreatmentMaxClock = actualRegularBegDate + (delay+3)*24;
		  delete tm_tmp; // + JPR 130124
//printf("\nthisTreatmentMaxClock = %d transforme en ", thisTreatmentMaxClock);
		  tm_tmp = ClockValueToTm(thisTreatmentMaxClock);
		  tm_tmp->tm_mday = tm_tmp->tm_mday +1;
		  tm_tmp->tm_hour = gIntParam_morningUpdateSituation_specialHour_;
		  mktime(tm_tmp);
		  thisTreatmentMaxClock = (int)StructTmToClockValue(tm_tmp);
		  delete tm_tmp; // + JPR 130124
//printf(" %d", thisTreatmentMaxClock);

		  if((now >= thisTreatmentMinClock)
			 &&
			 (now < thisTreatmentMaxClock)) {
			result = TRUE;
			pChantier->SetIntVarValue(MIN_BEG_DATE, now);
			pChantier->SetIntVarValue(MAX_BEG_DATE, ceSoir);
		  }
		}
	  }
	// fin modif JPR 121001
	}
  }
  else {             // REGULAR
	int wakeUpHour = ReturnManagerWakeUpHour();
	if(now_hour == wakeUpHour) { // + JPR 130224
	  int antiMildewJustDone = 
		pComposedPrgm->GetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE);
	  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);
	  Boolean flag_mildew = pConduite->GetIntConstValue(FLAG_MILDEW);
	  if((antiMildewJustDone ==0) && flag_mildew)
		result = TRUE;
	  else {
		Entity* pRegularIteration 
		  = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
		int iterationIndex = pRegularIteration->GetIntVarValue(REPLICATION_COUNTER);
		if(iterationIndex == 0)
		  result = TRUE;
		else  {
		  if((cadence > 0)
			 &&
			 (now >= actualRegularBegDate + (cadence - 2)*24))
			result = TRUE;
		  else if((cadence < 0)
				  &&
				  (now >= actualRegularBegDate - cadence*24))
			result = TRUE;
		}
	  }
	}
  }
//((Activity*)pChantier)->PrintDates();

//printf("\nt = %d Common_PhytoTreatment_OnDate_OP chantier : '%s' returns %d", now, pChantier->InstanceName(), result);
  return result;
}

bool Common_PhytoTreatment_Primary_OpeningPredicate (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Vineyard* pEA = App_GetVineyard((Activity*)pChantier);
  int now = pCurrentSim->Clock(); 
//printf("\nt = %d entree Common_PhytoTreatment_Primary_OP chantier : '%s'", now, pChantier->InstanceName());
  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);

  bool result = FALSE;

  //
  // Body_OP_PhytoTreatments n'invoque pas la presente fonction
  // dans le cas REGULAR_PHYTO
  //
  int typeChantier = App_GetDistributedActivitySetType(pChantier);

  switch(typeChantier) {
  case EXTRA_PHYTO : {
    int pressionMin = App_GetIntDecisionOption(pEA, 
											   OPT_EXTRA_PHYTO_TREATMENTS_O_P);
	
	int powderyMildewLevel = App_GetIntPestInfo(pEA, POWDERY_MILDEW_LEVEL);
	int powderyMildewFlagShoot = App_GetIntPestInfo(pEA, POWDERY_MILDEW_FLAG_SHOOT);
	
	if((powderyMildewFlagShoot == OUI)
	   ||
	   (powderyMildewLevel >= pressionMin))
	  result = TRUE;
	break;
  }
  case ANTI_MILDIOU : {   // optional
	Entity* pComposedProgram = 
	  (Entity*)pChantier->GetFirstContainer(PHYTO_TREATMENT_COMPOSED_PROGRAM,
											TRUE);
	//
	// il faut que l'iteration 'regular' a d j  eu au moins une realisation
	//
	Entity* pRegularIteration = (Entity*)pComposedProgram->GetElement(0);
	int nbRepl = pRegularIteration->GetIntVarValue(REPLICATION_COUNTER);
	
	if(nbRepl > 0) {
	  Boolean flag_mildew = pConduite->GetIntConstValue(FLAG_MILDEW);
	  int antiMildiouJustDone = 
		pComposedProgram->GetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE);
	  if(flag_mildew
		 &&
		 (antiMildiouJustDone  == 0))
		result = TRUE;
	}
	break;
  }
  case REGULAR_PHYTO : {
	printf("\nCommon_PhytoTreatment_Primary_OP pChantier : '%s'\n !!! passage inattendu dans le case REGULAR_PHYTO.\n", pChantier->InstanceName());
	exit(0);
  }
  }

//printf("\nCommon_PhytoTreatment_Primary_OP pChantier : '%s' returns %d", pChantier->InstanceName(), result);
  return result;
}

bool Common_PhytoTreatment_WeatherOriented_OpeningPredicate (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Vineyard* pEA = App_GetVineyard((Activity*)pChantier);
  int now = pCurrentSim->Clock(); 
//printf("\nt = %d entree Common_PhytoTreatment_WeatherOriented_OP chantier : '%s'", now, pChantier->InstanceName());
  Entity* pConduite = pEA->GetEntityConstValue(CONTROL_PLAN_ATTRIBUTE);

  bool result = FALSE;

  int nbRequested = pChantier->GetIntConstValue(NEED_FOR_NEXT_FAVOURABLE_DAYS);

  int typeChantier = App_GetDistributedActivitySetType(pChantier);
//printf("\n\ttypeChantier = %d", typeChantier);
//printf("\n\tnbRequested = %d", nbRequested);
  //
  // recuperation date nominale de l'intervention (cf. OP_PhytoTreatments_Body)
  // ------------------------------------------------------------
  int nominalDate = pChantier->GetIntConstValue(ACTIVITY_NOMINAL_DATE);
  //
  // etabissement nb jours d'anticipation (cad avant la date nominale)
  //-------------------------------------------------------------
  
  tm* pTm_now = ClockValueToTm(now);
  int jd_now = pTm_now->tm_yday;
  delete pTm_now;
  tm* pTm_nominal = ClockValueToTm(nominalDate);
  int jd_nominal = pTm_nominal->tm_yday;
  delete pTm_nominal;
  int deltaJulianDays = jd_nominal - jd_now; 
//printf("\n\tdeltaJulianDays = %d", deltaJulianDays);

  //
  // etabissement attitude vis-a-vis d'une prevision de pluie
  //-------------------------------------------------------------
  bool avantPluie;  
  // TRUE  : attitude = "si pluie pr vue, alors je traite avant"
  // FALSE : attitude = "si pluie pr vue, je parie qu'elle sera de courte duree,
  //                     donc je prends le risque d'attendre la fin de la pluie"
  //
  if(deltaJulianDays >= 2) {    // AVANT-VEILLE ou avant
                                // on passe avant ou apres la pluie prevue
	// captage option par d faut du manager
	avantPluie = App_GetIntDecisionOption(pEA, 
										  OPT_PHYTO_TREATMENT_RAIN_ANTICIPATION);
	// si pression maladie elevee, on passe avant
	if(avantPluie == FALSE) {
	  int powderyMildewLevel = App_GetIntPestInfo(pEA, POWDERY_MILDEW_LEVEL); 
	  int downyMildewLevel   = App_GetIntPestInfo(pEA, DOWNY_MILDEW_LEVEL);
	  if((powderyMildewLevel > 1)  
		 ||
		 (downyMildewLevel > 1)) {  // forte pression maladie
		avantPluie = TRUE;
	  }
	  if(avantPluie == FALSE) {
		Entity* pComposedProgram = 
		  (Entity*)pChantier->GetFirstContainer(PHYTO_TREATMENT_COMPOSED_PROGRAM,
												TRUE);
		int flagMildew = pConduite->GetIntConstValue(FLAG_MILDEW);
		int protection =
		  pComposedProgram->GetIntConstValue(ANTI_MILDEW_TREATMENT_JUST_DONE);
		if(flagMildew                // risque mildiou avere 
		   && 
		   (protection == 0)) {     //  ET vigne non encore protegee
		  avantPluie = TRUE;
		}
	  }
	}
  }
  else
	avantPluie = TRUE;         // la VEILLE, on passe avant la pluie prevue
  
  //
  // Recuperation des stations meteo pour cette EA
  //----------------------------------------------
  float totalArea = (float)0.;     // pour etablissement indicateurs (plus loin)
  pEntityTab* pWSList = new pEntityTab();
  pEntityTab pPlotList = pEA->GetElementTab();
  int nbPlots = pPlotList.size();
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot_i = (Entity*)pPlotList[i];
	float area_i = pPlot_i->GetFloatConstValue(AREA);
	totalArea += area_i;
	Entity* pWS_i = pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
	pWSList->push_back_ifnew(pWS_i);
  }
//printf("\nstations meteo :");pWSList->display_names();

  // etablissement previsions pluie pour ces stations
  //-------------------------------------------------
  int nbWS = pWSList->size();
  for(int i=0;i<nbWS;i++) {
	Entity* pWS_i = (Entity*)pWSList->get_element(i);
	char* pathName_i = pWS_i->GetStringConstValue(PATH_NAME_ATTRIBUTE);
//printf("\n\tpath : '%s'", pathName_i);
	
	//
	// dans la section ci-dessous, bornes des plages de pr visions   valider !!!
	// De plus, il faut avoir des plages differentes pour le mildiou :
	// --> voir plus bas
	//
	float cumulPluie_J;
	float cumulPluie_JP1;
	float cumulPluie_JP2;
	if(nbRequested == 1) {
	  cumulPluie_J = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 12)
		+ pWS_i->GetFloatVarValue(RAINFALL);
	  
	  cumulPluie_JP1 = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 24, 47);
	  
	  cumulPluie_JP2 = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 48, 61);
	}
	else {
	  cumulPluie_J = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 23)
		+ pWS_i->GetFloatVarValue(RAINFALL);
	  
	  cumulPluie_JP1 = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 24, 38);
	  
	  cumulPluie_JP2 = 
		SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 39, 61);
	}
	float cumulPluie_JP3;   // pour mildiou
	cumulPluie_JP3 = 
	  SumUpPredictionFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 71)
	  + pWS_i->GetFloatVarValue(RAINFALL);
	
	pWS_i->ClearFloatTabValues(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY);
	pWS_i->AddFloatValueElement(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
								cumulPluie_J);
	pWS_i->AddFloatValueElement(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
								cumulPluie_JP1);
	pWS_i->AddFloatValueElement(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
								cumulPluie_JP2);
	pWS_i->AddFloatValueElement(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY, 
								cumulPluie_JP3);
	Date laDate = ClockValueToDate(now);
//printf("\n%d-%s-%d %dH ", laDate.mday, MonthToChar(laDate.month), laDate.year, laDate.hour); printf("prevision pluie J JP1 JP2 '%s' : %5.1f %5.1f %5.1f", pWS_i->InstanceName(), cumulPluie_J, cumulPluie_JP1, cumulPluie_JP2);
//printf("\n%d-%s-%d %dH ", laDate.mday, MonthToChar(laDate.month), laDate.year, laDate.hour); printf("prevision pluie JP3 '%s' : %5.1f", pWS_i->InstanceName(), cumulPluie_JP3);
  }
  delete pWSList;

  // etablissement indicateurs pour l'ensemble des parcelles : selon la
  // situation (position/date nominale, duree periode correcte requise, ..)
  // une ou l'autre des 4 conditions suivantes doit  tre respect e sur une 
  // proportion suffisante de la surface a traiter:
  // condition 1 : meteo ok aujourd'hui
  // condition 2 : meteo ok aujourd'hui et demain
  // condition 3 : meteo ok aujourd'hui et demain, et pas ok apr s-demain
  // condition 4old : meteo ok aujourd'hui, et pas ok demain ni apr s-demain
  // condition 4new : meteo ok aujourd'hui, et pas ok demain et ok apr s-demain
  // condition 5 (anti-mildiou) : lire dans setFlagMildew_Body, case R0
  //                              applicable ici dans tous les cas
  //
  // 'meteo ok' := somme des pluies horaires < seuil fixe
  //
  // ==>
  // 1 on examine tour a tour chaque parcelle p_i
  //   1.1 on examine tour   tour chaque condition C_j
  //       SI    C_j respectee 
  //       ALORS proportionRespectCondition_i += p_i.surface/surfaceTotale
  // 2 selon la situation, on utilise proportionRespectCondition_[1 2 3 ou 4]
  //   pour renvoyer TRUE ou FALSE
  //-------------------------------------------------
  float seuilPluie = gRealParam_virtualManager_rainfallThresholdForPhytoTreatment_;
  float proportionRespectCondition_1 = (float)0.;
  float proportionRespectCondition_2 = (float)0.;
  float proportionRespectCondition_3 = (float)0.;
  float proportionRespectCondition_4 = (float)0.;
  //bool respectCondition_i_1 = FALSE;  // pour trace
  //bool respectCondition_i_2 = FALSE;  //     "
  //bool respectCondition_i_3 = FALSE;  //     "
  //bool respectCondition_i_4 = FALSE;  //     "
  //bool respectCondition_i_5 = FALSE;  //     "

  bool antiMildewNeeded = FALSE;
  for(int i=0;i<nbPlots;i++) {
	Entity* pPlot_i = (Entity*)pPlotList[i];
	float area_i = pPlot_i->GetFloatConstValue(AREA);
	float proportionSurface_i = area_i/totalArea;
//printf("\n'%s'\tprop surf.=%3.2f ", pPlot_i->InstanceName(), proportionSurface_i);
	Entity* pWS_i = pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
	pFloatTab* rainFallVector = 
	  pWS_i->GetFloatTabConstValue(DAILY_RAINFALL_FORECAST_FROM_CURRENT_DAY);

	if(typeChantier == ANTI_MILDIOU) {
	  //
	  // evaluation du besoin de traiter
	  //
	  bool respectCondition_niv = FALSE;  // pour trace
	  bool respectCondition_dis = FALSE;  // pour trace
	  float cumulPluie_JP3 = rainFallVector->get_element(3);
	  if(cumulPluie_JP3 > seuilPluie) {
		respectCondition_niv = TRUE; // pour trace
//printf(" respectCondition_niv : %d\n", respectCondition_niv);
		// examen distribution
		respectCondition_dis = TRUE;
//printf("\nApp_GetFlagMildew case R0 avec foyersPrimaires : completer l'estimation de la distribution");
	  }
	  if(respectCondition_niv && respectCondition_dis) {
		antiMildewNeeded = TRUE;
	  }
	}
	if((typeChantier != ANTI_MILDIOU)
	   ||
	   (antiMildewNeeded == TRUE)) {
	  float cumulPluie_J = rainFallVector->get_element(0);
	  if(cumulPluie_J < seuilPluie) {
		//respectCondition_i_1 = TRUE;// pour trace
		proportionRespectCondition_1 += proportionSurface_i;
		float cumulPluie_JP1 = rainFallVector->get_element(1);
		if(cumulPluie_JP1 < seuilPluie) {
		  //respectCondition_i_2 = TRUE;// pour trace
		  proportionRespectCondition_2 += proportionSurface_i;
		  float cumulPluie_JP2 = rainFallVector->get_element(2);
		  if(cumulPluie_JP2 >= seuilPluie) {
			//respectCondition_i_3 = TRUE;// pour trace
			proportionRespectCondition_3 += proportionSurface_i;
		  }
		}
		else {
		  float cumulPluie_JP2 = rainFallVector->get_element(2);
		  //if(cumulPluie_JP2 >= seuilPluie) {     // old
		  if(cumulPluie_JP2 < seuilPluie) {      // new
			//respectCondition_i_4 = TRUE;// pour trace
			proportionRespectCondition_4 += proportionSurface_i;
		  }
		}
	  }
	};
//printf("%d %d %d %d", respectCondition_i_1, respectCondition_i_2, respectCondition_i_3, respectCondition_i_4);
  }

  float seuilRespect = gRealParam_virtualManager_satisfactionThresholdForPhytoTreatment_;
  bool respectCondition_1 = (proportionRespectCondition_1 >= seuilRespect);
  bool respectCondition_2 = (proportionRespectCondition_2 >= seuilRespect);
  bool respectCondition_3 = (proportionRespectCondition_3 >= seuilRespect);
  bool respectCondition_4 = (proportionRespectCondition_4 >= seuilRespect);
//printf("\nproportion respect : %3.2f %3.2f %3.2f %3.2f", proportionRespectCondition_1, proportionRespectCondition_2, proportionRespectCondition_3, proportionRespectCondition_4);
//printf("\n           respect : %d    %d    %d    %d", respectCondition_1, respectCondition_2, respectCondition_3, respectCondition_4);

  //
  // evaluation finale de la condition d'ouverture
  //----------------------------------------------

  if((typeChantier == ANTI_MILDIOU)
	 &&
	 (antiMildewNeeded == FALSE)) {
	result = FALSE;
  }
  else {
	if(deltaJulianDays >= 1) {       // on est avant la date nominale
	  if(  (nbRequested == 2)              // il faut 2 jours OK ...
		   &&
		   avantPluie) {
		if(respectCondition_3) {           // ... et on les a, mais il pleut apres
		  result = TRUE;
		}
	  }
	  else
		if((nbRequested == 1)              // il faut 1 jour OK ...
		   &&
		   avantPluie
		   && 
		   respectCondition_4) {           // ... et on l'a, mais il pleut apres
		  result = TRUE;
		}
	}
	else {                         // on est   la date nominale ou bien apres
	  if(  (nbRequested == 2)              // il faut 2 jours OK ...
		   &&
		   avantPluie
		   && 
		   respectCondition_2) {           // ... et on les a
		result = TRUE;
	  }
	  else
		if((nbRequested == 1)              // il faut 1 jour OK ...
		   &&
		   avantPluie
		   && 
		   respectCondition_1) {           // ... et on l'a
		  result = TRUE;
	  }
	}
  }
  if((nbRequested == 2) && result)
	pChantier->SetIntConstValue(NEED_FOR_NEXT_FAVOURABLE_DAYS, 1);

//printf("\nCommon_PhytoTreatment_WeatherOriented_OP pChantier : '%s' returns %d", pChantier->InstanceName(), result);
  return result;
}

// --------------------------------------------
// Finalisation de la simulation non autonome
// --------------------------------------------
void FinalizeOpenSimulation (char* dirFile) {

  // ---------------------------------------------
  // Affichage somme des durees des episodes de simulation 
  // ---------------------------------------------
  //PrintChrono();
  //printf("\nduree totale des RunOpenSimulation : '%s'\n", gTimeString);
  //CloseChrono(); // RAZ et fermeture chronometre RunOpenSimulation

  //InitChrono();  // re-ouverture du chronometre pour FinalizeOpenSimulation

  // ---------------------------------------------
  // Lecture des directives finales de simulation
  // (celles qui succ dent   la directive RUN dans
  // un simulateur autonome)
  // ---------------------------------------------
  C_ParseDirectiveFile(dirFile);
  //
  // Preparation R gantt charts
  // 
  App_MakeGanttChartCommandFiles();

  //
  // Desallocation des activites et des operations ...
  // - non commencees (*) ou entamees en l'instant de fin de simulation,
  //   donc non desallouees par un MIOS pour celles qui sont dans un chantier
  // - tq un chantier se termine avec elles, donc non desallouees par le MIOS
  //
  DeallocatePrimitiveActivityTab();
  DeallocateOperationTab();
  //
  // Desallocation des entites creees par l'application (et non par le moteur)
  // en cours de simulation et connues pour ne pas etre desallouees avant.
  //
  App_DeallocateMiscellaneousDynamicEntities();
  //
  // Desallocation generale :
  // - donc a ne pas programmer dans *.dir
  // - appel aux fonctions specialisees (au lieu de C_DeleteAll)
  // pour pouvoir y inserer un MemoryReport sans argument
  // (cad non conditionne a l'option de trace -V)
  //
  DeleteEntitySpecs();
  C_DeleteEntityInstances();
  DeleteMonitors();
  DeleteParameters();
  C_DeleteFileInstances();
  DeleteOutputSpecs();
  delete pCurrentSim;
  //O_MemoryReport();
  DeleteEntityClasses();

  //PauseChrono();
  //PrintChrono();
  //printf("\nduree FinalizeOpenSimulation : '%s'\n", gTimeString);
  //CloseChrono(); // RAZ et fermeture chronometre FinalizeOpenSimulation
}

// --------------------------------------------
// Initialisation de la simulation non autonome
// --------------------------------------------
void InitOpenSimulation(char* paramFile, char* simFile, char* osFile, char* structFile) {
  //InitChrono();
  //StartChrono()
  if(gTraceActionMode)
	printf("\nDEBUT UserFunction.cc/InitOpenSimulation()");

  // ---------------------------------------------
  // Plus grande tolerance pour l'egalite a 1 du degre de progression
  // des operations : -> 0.999 considere egal a 1
  // --------------------------------------------- 
  gFloatingPointEqualityTolerance = (float)0.001;
  //
  // Instantiation de la simulation DIESE
  //
  pCurrentSim = new OpenSimulation();
  pCurrentSim->AssignBeforeInAgendaMethod(BeforeByDatePriority);
  AssignEnumToInt(App_EnumToInt);
  //
  // Installation standard de la hierarchie des classes
  //
  App_AssignInstantiators();

  D_InstallMetaClasses();
  C_InstallMetaClasses();
  O_InstallMetaClasses();
  App_InstallMetaClasses();
  SetHierarchy();
  //
  // Installation des moniteurs
  //
  D_DefineMonitors();
  C_DefineMonitors();
  O_DefineMonitors();
  App_DefineMonitors();

  // -----------------------------------------------------------------------
  // Debut du code modifiable par le developpeur. Ne rien modifier ci-dessus
  // -----------------------------------------------------------------------

  // ---------------------------------------------
  // Lecture des parametres generaux du systeme
  // ---------------------------------------------
  ParseParameterFile(paramFile);
  //
  // Transformation des parametres du systeme en variables globales
  //
  Assign_InitParameterGlobalVariablesFunction(InitParameterGlobalVariables);
  pInitParameterGlobalVariables();
	
  // ---------------------------------------------
  // Lecture des parametres de la simulation
  // ---------------------------------------------
  ParseSimulationFile(simFile);

  // ---------------------------------------------
  // Instanciation superficielle du systeme de production
  // ---------------------------------------------
  Entity* pPS = new VineProducingRegion();
	
  Entity* pDS = new VirtualRegionManager();
					  
  Entity* pStrategy = new Strategy();
  Entity* pARBSet = new ActivitiesResourcesBlockSet();
  pStrategy->AddComponent(pARBSet);
  pDS->AddComponent(pStrategy);
  pPS->AddComponent(pDS);
  Entity* pOS = new VirtualRegionOperatingSystem();
  pPS->AddComponent(pOS);
  Entity* pCS = new VineGrowingTerritory();
  pPS->AddComponent(pCS);
  // ---------------------------------------------
  // Instanciation superficielle du systeme biophysique ...
  // ---------------------------------------------
  Entity* pBPS = new AgroClimaticSystem();
	
  Entity* pAgroSet = new VineyardSet();
  pBPS->AddComponent(pAgroSet);
  Entity* pClimSet = new WeatherStationSet();
  pBPS->AddComponent(pClimSet);
  // ... et attachement au ControlledSystem
  pCS->SetEntityConstValue(ATTACHED_ENTITY, pBPS);

  // ---------------------------------------------
  // Attachement des contraintes sur les ressources a l'OS
  // ---------------------------------------------
  Entity* pRSVC;
  pRSVC= new EquipmentMultiLocalization();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pRSVC);
  pRSVC = new FarmWorkerMultiLocalization();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pRSVC);
  pRSVC = new FarmWorkerMultiOccupation();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pRSVC);
  
  Entity* pARIC = new PlotWithSeveralOperations();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pARIC);
  
  Entity* pAIC;
  pAIC = new TooLateInWorkDayForActivityBeginning();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pAIC);
  
  pAIC = new OnlyPhytoTreatmentsAtEarlyMorning();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pAIC);

  // ---------------------------------------------
  // Designation du systeme de production comme entite simulee
  // ---------------------------------------------
  pCurrentSim->SimulatedEntity(pPS);

  // ---------------------------------------------
  // exploitation des parametres de memoire et de prediction
  // ---------------------------------------------
  int memoryScope = gIntParam_virtualManager_memoryScope_;
  pDS->SetIntVarValue(MEMORY_SCOPE, memoryScope);
  int predictionScope = gIntParam_virtualManager_predictionScope_;
  pDS->SetIntVarValue(PREDICTION_SCOPE, predictionScope);
	
  // ---------------------------------------------
  // Lecture des autres fichiers-argument de la commande
  // ---------------------------------------------
  ParseOutputSpecFile(osFile);
  ParseStructureFile(structFile);

  // ---------------------------------------------
  // Construction profonde du systeme biophysique
  // ---------------------------------------------
  char* inDir = pCurrentSim->GetInDir();
  char* vineyardFile = gStringParam_install_vineyardFile_;
  char str[200] = {'\0'};
  strcat(str, inDir);
  strcat(str, vineyardFile);
  sprintf(str, "%s%s", inDir, vineyardFile);
  App_DepthBioPhysicalSettings(str);

  // ---------------------------------------------
  // Construction profonde du systeme operant
  // ---------------------------------------------
  char* rscFile = gStringParam_install_resourceFile_;
  char str2[200] = {'\0'};
  strcat(str2, inDir);
  strcat(str2, rscFile);
  sprintf(str2, "%s%s", inDir, rscFile);
  App_ResourceSettings(str2);

  // ---------------------------------------------
  // Construction profonde du systeme de d cision
  // ---------------------------------------------
  char* planFile = gStringParam_install_planFile_;
  char str3[200] = {'\0'};
  strcat(str3, inDir);
  strcat(str3, rscFile);
  sprintf(str3, "%s%s", inDir, planFile);
  App_ControlPlanSettings(str3);

  // ---------------------------------------------
  // Etablissement des IsoAgeingEntity attachees aux parcelles,
  // une fois connues les varietes par parcelle (App_DepthBioPhysical.)
  // et les varietes-guides par conduite (App_ControlPlan.)
  // ---------------------------------------------
  App_AssignIsoAgeingEntityToPlots(pAgroSet);

  // ---------------------------------------------
  // Etablissement des operations exclues des SelectPlotsToX
  // ---------------------------------------------
  App_AssignTurnedOffActivitiesOnPlots(pAgroSet);	

  // -----------------------------------------------------------------------
  // Fin du code modifiable par le developpeur. Ne rien modifier ci-dessous
  // -----------------------------------------------------------------------

  if(gTraceActionMode)
	printf("\nFIN   UserFunction.cc/InitOpenSimulation()\n");
  //PauseChrono();
  //PrintChrono();
  //printf("\nduree InitOpenSimulation : '%s'\n", gTimeString);
  //CloseChrono(); // RAZ et fermeture chronometre InitOpenSimulation

  //InitChrono();  // re-ouverture du chronometre pour RunOpenSimulation
  // - les StartChrono/PauseChrono sont dans le code Openfluid
  //   . un StartChrono() juste avant l'appel   RunOpenSimulationToDate
  //                   et juste avant l'appel   RunOpenSimulation
  //   . un PauseChrono() juste apres l'appel   RunOpenSimulationToDate
  //                   et juste apres l'appel   RunOpenSimulation
  // - le CloseChrono est dans FinalizeOpenSimulation

}

bool OpeningCondition_AutumnTillages (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_AUTUMN_TILLAGE_O_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int year = pTm->tm_year + 1900;
  delete pTm;
  switch (option)  {
	
  case END_HARV : {
	/*
	Date* dateOuverture = GetDateParameterValue("Roujan", "finVendanges");
	int mday = dateOuverture->mday;
	int month = dateOuverture->month;
	int clockOuverture = DateToClockValue(mday, month, year);
	*/
	int clockOuverture = DateToClockValue(01, 10, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case MID_OCT : {
	int clockOuverture = DateToClockValue(20, 10, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case NONE : {
	int nbPlots = pEA->GetNumberOfElements();
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  pPlot_k->SetFloatVarValue(PERCENT_AUTUMN_TILLED, (float)-1.);
	}
	break;
  }
  default : {
	printf("\n'%s'::OpeningCondition_AutumnTillages_OnDate option inconnue : %d", pChantier->InstanceName(), option);
  }
	
  }
//printf("\n'%s'::OpeningCondition_AutumnTillages returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_ChemicalWeedings (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_CHEMICAL_WEEDING_O_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year + 1;
  delete pTm;

  switch (option)  {

  case MID_JAN : {
	int clockOuverture = DateToClockValue(15, 1, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case MID_FEB : {
	int clockOuverture = DateToClockValue(15, 2, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case EARLY_MAR : {
	int clockOuverture = DateToClockValue(1, 3, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case MID_MAR : {
	int clockOuverture = DateToClockValue(15, 3, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case END_PRUN_THIN : {
	//
	// on simule ici un Before(And(Prunings, Thinnings), ChemicalWeedings)
	// qu'on ne peut pas installer tel quel dans le plan, parce que lie
	// seulement a la presente option END_PRUN_THIN et pas a MID_JAN, etc.
	// 
	Entity* pThinnings = NULL;
	Entity* pPrunings = NULL;
	result = TRUE;

	int clockOuverture = DateToClockValue(25, 2, year);
	if(now < clockOuverture) {
	  result = FALSE;
	  break;
	}
	
	BasicEntity* pPhaseConjunctivePlan = pChantier->GetSuperSet();
	pEntityTab pElemTab = pPhaseConjunctivePlan->GetElementTab();
	int nbElem = pElemTab.size();
	for(int k=0;k<nbElem;k++) {
	  Entity* pElem_k = (Entity*)pElemTab.get_element(k);
	  if(pElem_k->IsInstanceOf(CONCURRENT_PRUNINGS)
		 ||
		 pElem_k->IsInstanceOf(SERIAL_PRUNINGS)) {
		pPrunings = pElem_k;
		if(pPrunings->GetIntVarValue(SITUATION) != CLOSED) {
		  result = FALSE;
		  break;
		}
	  }
	  if(pElem_k->IsInstanceOf(CONCURRENT_SHOOT_THINNINGS)
		 ||
		 pElem_k->IsInstanceOf(SERIAL_SHOOT_THINNINGS)) {
		pThinnings = pElem_k;
		if(pThinnings->GetIntVarValue(SITUATION) != CLOSED) {
		  result = FALSE;
		  break;
		}
	  }
	  if(pPrunings && pThinnings)
		break;
	}
	break;
  };
  }
//printf("\n'%s'::OpeningCondition_ChemicalWeedings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_Clippings (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : TRUE ssi on a atteint le 20 mai
//---------------------------------------------
{
  bool result = FALSE;
  // 
  // renvoyer TRUE ssi on a atteint le 20/05
  // 
  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year + 1;
  delete pTm;

  int clockOuverture = DateToClockValue(20, 5, year);
  if(now >= clockOuverture)
	result = TRUE;

//printf("\n'%s'::OpeningCondition_Clippings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_Debranchings (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : TRUE ssi on a atteint le 20 avril
//---------------------------------------------
{
  bool result = FALSE;
  // 
  // renvoyer TRUE ssi on a atteint le 20/04
  // 
  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)    //sept, etc.
	year = year + 1;
  delete pTm;

  int clockOuverture = DateToClockValue(20, 4, year);
  if(now >= clockOuverture)
	result = TRUE;

//printf("\n'%s'::OpeningCondition_Debranchings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_Fertilizations_OnChain (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_O_P);

  //int now = pCurrentSim->Clock();

  pEntityTab tmp = pChantier->GetContainerTab(VINEYARD_PHASE_CONJUNCTIVE_PLAN);
  BasicEntity* pPhaseConjunctivePlan = tmp.get_element(0);
  pEntityTab pElemTab = pPhaseConjunctivePlan->GetElementTab();
  int nbElem = pElemTab.size();

  Entity* pThinnings;
  for(int k=0;k<nbElem;k++) {
	Entity* pElem_k = (Entity*)pElemTab.get_element(k);
	if(pElem_k->IsInstanceOf(CONCURRENT_SHOOT_THINNINGS)
	   ||
	   pElem_k->IsInstanceOf(SERIAL_SHOOT_THINNINGS)) {
	  pThinnings = pElem_k;
	  break;
	}
  }
  switch (option)  {
	
  case END_THIN : {
	if(pThinnings->GetIntVarValue(SITUATION) == CLOSED)
	  result = TRUE;
	break;
  };
	
  case END_THIN_CW : {
	if(pThinnings->GetIntVarValue(SITUATION, CLOSED)) {

	  Entity* pChemWeedings;
	  for(int k=0;k<nbElem;k++) {
		Entity* pElem_k = (Entity*)pElemTab.get_element(k);
		if(pElem_k->IsInstanceOf(CONCURRENT_CHEMICAL_WEEDINGS)
		   ||
		   pElem_k->IsInstanceOf(SERIAL_CHEMICAL_WEEDINGS)) {
		  pChemWeedings = pElem_k;
		  break;
		}
	  }
	  if(pChemWeedings->GetIntVarValue(SITUATION) == CLOSED)
		result = TRUE;
	}
	break;
  };
  }

//printf("\n'%s'::OpeningCondition_Fertilizations_OnChain returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_Fertilizations_OnDate (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_FERTILIZATION_O_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  delete pTm;
  switch (option)  {
	
  case END_HARV : {
	/*
	Date* dateOuverture = GetDateParameterValue("Roujan", "finVendanges");
	int mday = dateOuverture->mday;
	int month = dateOuverture->month;
	int clockOuverture = DateToClockValue(mday, month, year);
	*/
	int clockOuverture = DateToClockValue(01, 10, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case MID_OCT : {
	int clockOuverture = DateToClockValue(20, 10, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case EARLY_FEB : {
	if(month > 7)    // sept, oct, etc.
	  year = year + 1;
	int clockOuverture = DateToClockValue(01, 02, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case EARLY_MAR : {
	if(month > 7)    // sept, oct, etc.
	  year = year + 1;
	int clockOuverture = DateToClockValue(01, 03, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
	
  }
//printf("\n'%s'::OpeningCondition_Fertilizations_OnDate returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_InitSpringTillages (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int nbPlots = pEA->GetNumberOfElements();

  int option = App_GetIntDecisionOption(pEA, OPT_INIT_SPRING_TILLAGE_O_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;	
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year + 1;
  delete pTm;
  switch (option)  {
	
  case MID_JAN : {
	int clockOuverture = DateToClockValue(15, 1, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case EARLY_FEB : {
	int clockOuverture = DateToClockValue(1, 2, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case MID_FEB : {
	int clockOuverture = DateToClockValue(15, 2, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case END_THIN_FERT : {
	result = TRUE;
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float percentThin = pPlot_k->GetFloatVarValue(PERCENT_SHOOT_THINNED);
	  float percentFert = pPlot_k->GetFloatVarValue(PERCENT_FERTILIZED);
	  int isNotThinned =    App_FloatGT(percentThin, (float)-1.)
		              && App_FloatLT(percentThin, (float)1.);
	  int isNotFertilized = App_FloatGT(percentFert, (float)-1.)
		              && App_FloatLT(percentFert, (float)1.);
	  if((isNotThinned) || (isNotFertilized)) {
		result = FALSE;
		break;
	  }
	}
	break;
  }
  case END_THIN_CW : {
	result = TRUE;
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float percentThin = pPlot_k->GetFloatVarValue(PERCENT_SHOOT_THINNED);
	  float percentWeed = pPlot_k->GetFloatVarValue(PERCENT_WEEDED);
	  int isNotThinned =    App_FloatGT(percentThin, (float)-1.)
		              && App_FloatLT(percentThin, (float)1.);
	  int isNotWeeded =     App_FloatGT(percentWeed, (float)-1.)
		              && App_FloatLT(percentWeed, (float)1.);
//printf("\n\t%s percentThin = %f isNotThinned = %d", pPlot_k->InstanceName(), percentThin, isNotThinned);
//printf("\n\t%s percentWeed = %f isNotWeeded = %d", pPlot_k->InstanceName(), percentWeed, isNotWeeded);
	  if((isNotThinned) || (isNotWeeded)) {
		result = FALSE;
		break;
	  }
	}
	break;
  };
  case END_THIN_CW_FERT : {
	result = TRUE;
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float percentThin = pPlot_k->GetFloatVarValue(PERCENT_SHOOT_THINNED);
	  float percentWeed = pPlot_k->GetFloatVarValue(PERCENT_WEEDED);
	  float percentFert = pPlot_k->GetFloatVarValue(PERCENT_FERTILIZED);
	  int isNotThinned = App_FloatGT(percentThin, (float)-1.)
		              && App_FloatLT(percentThin, (float)1.);
	  int isNotWeeded =  App_FloatGT(percentWeed, (float)-1.)
		              && App_FloatLT(percentWeed, (float)1.);
	  int isNotFertilized = App_FloatGT(percentFert, (float)-1.)
		              && App_FloatLT(percentFert, (float)1.);
	  if((isNotThinned) || (isNotWeeded) || (isNotFertilized)) {
		result = FALSE;
		break;
	  }
	}
	break;
  }
  case NONE : {
	int nbPlots = pEA->GetNumberOfElements();
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  pPlot_k->SetFloatVarValue(PERCENT_INIT_SPRING_TILLED, (float)-1.);
	}
	break;
  }
  case WINTER_RAIN_BASED : {  // + JPR 130425 (5.6)
	pEntityTab pPlotList = pEA->GetElementTab();
	int nbPlots = pPlotList.size();
	int option = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P_SCOPE);
	float areaScope;
	switch (option) {
	case FARM_SCOPE : {
	  float totalArea = pEA->GetFloatConstValue(AREA_WITH_TILLED_GRAPEVINE);
	  areaScope = totalArea * (float)0.75; break;
	}
	case PLOT_SCOPE : {
	  areaScope = (float)2.; break;
	}
	case PLOT_GROUP_SCOPE : {
	  areaScope = (float)5.; break;
	}
	}
	//
	// test sur quantit de pluie mini sur l'areaScope
	//
	float aggregatedArea = (float)0.;
	float rainfallThreshold;
	Date* datePrecoce = GetDateParameterValue("finCumulPluie", "declenchementInitSiPluieForte");
	datePrecoce->year = pCurrentSim->BeginningDate()->year+1;
	tm* tmDatePrecoce = StructDateToTm(datePrecoce);
	int clockDatePrecoce = StructTmToClockValue(tmDatePrecoce); 
	delete tmDatePrecoce;
	Date* dateTardive = GetDateParameterValue("finCumulPluie", "declenchementInitSiPluieFaible");
	dateTardive->year = pCurrentSim->BeginningDate()->year+1;
	tm* tmDateTardive = StructDateToTm(dateTardive);
	int clockDateTardive = StructTmToClockValue(tmDateTardive); 
	delete tmDateTardive;

	bool readyForEarlyOPtesting = FALSE;
	bool readyForLateOPtesting = FALSE;
	int now = pCurrentSim->Clock();
	float ub = gRealParam_virtualManager_rainfallThresholdForWinterRainBasedInitSpringTillage_;
	if((now >= clockDatePrecoce) && (now <= clockDatePrecoce + 24)) {
	  rainfallThreshold = ub;
	  readyForEarlyOPtesting = TRUE;
	}
	else if((now >= clockDateTardive) && (now <= clockDateTardive + 24)) {
	  readyForLateOPtesting = TRUE;
	}
	if(readyForEarlyOPtesting) {
	  for(int k=0;k<nbPlots;k++) {
		Entity* pPlot_k = (Entity*)pPlotList[k];
		if(pPlot_k->GetFloatVarValue(PERCENT_INIT_SPRING_TILLED) < 0) continue;
		float rainfall_k = 
		  pPlot_k->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_EARLY_WINTER_FOR_INITST);
		float area_k = pPlot_k->GetFloatConstValue(AREA);
		if(rainfall_k >= rainfallThreshold) {  // modif JPR 130509 (cf. ValidationDhivine p11
		  aggregatedArea += area_k;
//printf("\n\t'%s' [rainfall_k=%f >= %f] sur aggregatedArea = %fha / %fHa", pPlot_k->InstanceName(), rainfall_k, rainfallThreshold, aggregatedArea, areaScope); // 120904
		  if(aggregatedArea >= areaScope) {
//printf("\n!!!!! seuil de pluie depuis debut hiver pour initst (%f) sur le areascope (%f) atteint", rainfallThreshold, areaScope); // modif 130425
			result = TRUE;	
			break;
		  }
		}
	  }
	}
	else if(readyForLateOPtesting) {
	  result = TRUE;
	}
	break;
  }
  default : {
	printf("\n'%s'::OpeningCondition_InitSpringTillages option inconnue : %d", pChantier->InstanceName(), option);
  }
	
  }

  // + JPR 120726
  if(result == TRUE) {
	Entity* pPhase = pChantier->GetSuperSet();
	Entity* pSTIteration = (Entity*)pPhase->GetClassNamedElement(SPRING_TILLAGES_ITERATION);
//printf("\n\t'%s'\t REF_DATE  = -9", pSTIteration->InstanceName());
	pSTIteration->SetIntConstValue(PREVIOUS_REPLICATION_REF_DATE, -9);
  }
//printf("\n'%s'::OpeningCondition_InitSpringTillages returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_Plantations_OnDate (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_PLANTATION_O_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year + 1;
  delete pTm;
  switch (option)  {

  case MID_FEB : {
	int clockOuverture = DateToClockValue(20, 2, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case MID_MAR : {
	int clockOuverture = DateToClockValue(10, 3, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case LATE_MAR : {
	int clockOuverture = DateToClockValue(20, 3, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
  case EARLY_APR : {
	int clockOuverture = DateToClockValue(1, 4, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  };
	
  }
//printf("\n'%s'::OpeningCondition_Plantations_OnDate returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_Prunings_OnDate (Entity* pObj)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  // pObj :    phase 1 
  //        ou chantier Prunings de la phase 2 
  //        ou chantier Fertilization/AutumnTillages de la phase 1
  // selon le client (= code appelant) de la presente fonction

  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pObj);
  int option = App_GetIntDecisionOption(pEA, OPT_PRUNING_O_P);

  int now = pCurrentSim->Clock();
  switch (option)  {
	
  case EARLY_NOV : {
	tm* pTm = ClockValueToTm(now);
	int year = pTm->tm_year + 1900;
	delete pTm;
	int clockOuverture = DateToClockValue(01, 11, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case MID_NOV : {
	tm* pTm = ClockValueToTm(now);
	int year = pTm->tm_year + 1900;
	delete pTm;
	int clockOuverture = DateToClockValue(12, 11, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case LATE_NOV : {
	tm* pTm = ClockValueToTm(now);
	int year = pTm->tm_year + 1900;
	delete pTm;
	int clockOuverture = DateToClockValue(20, 11, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case EARLY_DEC : {
	tm* pTm = ClockValueToTm(now);
	int year = pTm->tm_year + 1900;
	delete pTm;
	int clockOuverture = DateToClockValue(01, 12, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  default : {
	printf("\n'%s'::OpeningCondition_Prunings_OnDate option inconnue : %d", pObj->InstanceName(), option);
  }
	
  }
//printf("\n'%s'::OpeningCondition_Prunings_OnDate returns %d", pObj->InstanceName(), result);
  return result;
}

bool OpeningCondition_ShootThinnings_OnSurface (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  // pChantier :    chantier ShootThinnings de la phase 2 ou 3
  // selon le client (= code appelant) de la presente fonction

  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_SHOOT_THINNINGS_O_P);

  //int now = pCurrentSim->Clock();
  
  int nbPlots = pEA->GetNumberOfElements();
  float seuil = (float) -9.;

  switch (option)  {
	
  case ONE_PLOT_PRUNED : {
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  int isPruned = 
		App_FloatEQ(pPlot_k->GetFloatVarValue(PERCENT_PRUNED), (float)1.);
	  if(isPruned) {
		result = TRUE;
		break;
	  }
	}
	break;
  }
  case SURF_PRUNED_3 : {
	seuil = (float)3.;
	break;
  }
  case SURF_PRUNED_12 : {
	seuil = (float)12.;
	break;
  }
  case SURF_PRUNED_17 : {
	seuil = (float)17.;
	break;
  }
  case SURF_PRUNED_MAJ : {
	float totalArea = pEA->GetFloatConstValue(AREA_WITH_GRAPEVINE);;
	float cumulPruned = (float)0.;
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float surf_k = pPlot_k->GetFloatConstValue(AREA);
	  int isPruned =  
		App_FloatEQ(pPlot_k->GetFloatVarValue(PERCENT_PRUNED), (float)1.);
	  if(isPruned) {
		cumulPruned += surf_k;
		if(cumulPruned > totalArea*0.75) {
		  result = TRUE;
		  break;
		} 
	  }
	}
	break;
  }
  case NONE : {
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  pPlot_k->SetFloatVarValue(PERCENT_SHOOT_THINNED, (float)-1.);
	}
	break;
  }
  default : {
	printf("\n'%s'::OpeningCondition_ShootThinnings_OnSurface option inconnue : %d", pChantier->InstanceName(), option);
  }
	
} // fin switch
  if(seuil > 0.) {
	float cumulPruned = (float)0.;
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float surf_k = pPlot_k->GetFloatConstValue(AREA);
	  int isPruned =  
		App_FloatEQ(pPlot_k->GetFloatVarValue(PERCENT_PRUNED), (float)1.);
	  if(isPruned) {
		cumulPruned += surf_k;
		if(cumulPruned > seuil) {
		  result = TRUE;
		  break;
		}
	  }
	}
  }
//printf("\n'%s'::OpeningCondition_ShootThinnings_OnSurface returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_SpringChemicalWeedings (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_SPRING_CHEMICAL_WEEDING_O_P);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  delete pTm;
  switch (option)  {
	
  case END_DEBR : {
	bool allDone = TRUE;
	Entity* pEA = App_GetVineyard((Activity*)pChantier);
	int nbPlots = pEA->GetNumberOfElements();
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  float percentDone = pPlot_k->GetFloatVarValue(PERCENT_DEBRANCHED);
	  int isDone =    App_FloatEQ(percentDone, (float)1.)
		           || App_FloatEQ(percentDone, (float)-1.);
//printf("\n'%s' percentDone = %f isDone = %d", pPlot_k->InstanceName(), percentDone, isDone);
	  if(! isDone) {
		allDone = FALSE;
		break;
	  }
	}
	if(allDone)
	  result = TRUE;
	break;
  }
  case EARLY_JUN : {
	if(month > 7)       // sept, etc.
	  year = year + 1;
	int clockOuverture = DateToClockValue(01, 06, year);
	if(now >= clockOuverture)
	  result = TRUE; 
	break;
  }
  case NONE : {
	int nbPlots = pEA->GetNumberOfElements();
	for(int k=0;k<nbPlots;k++) {
	  Entity* pPlot_k = pEA->GetElement(k);
	  pPlot_k->SetFloatVarValue(PERCENT_SPRING_WEEDED, (float)-1.);
	}
	break;
  }
  default : {
	printf("\n'%s'::OpeningCondition_SpringChemicalWeedings option inconnue : %d", pChantier->InstanceName(), option);
  }
	
  }
//printf("\n'%s'::OpeningCondition_SpringChemicalWeedings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_SpringTillages (Entity* pChantier, int replicationNumber, int prevTillageClock)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  // ci-dessous - JPR 120730 Dhivine_4.9
  //Entity* pIterate = (Entity*)pChantier->GetFirstContainer(ACTIVITY_ITERATION, FALSE);
  bool result = FALSE;

  int optionFirst = App_GetIntDecisionOption(pEA, OPT_FIRST_SPRING_TILLAGE_O_P);
  int optionGen = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P);
//printf("\n'%s'::OpeningCondition_SpringTillages (%s, %s)", pChantier->InstanceName(), App_EnumToChar(optionFirst), App_EnumToChar(optionGen));

  int localCase = 3;

  if(optionFirst == INIT_SPRING_TILLAGE) {
	if(optionGen == WEED_COVER)
	  localCase = 1;
  }
  else if(optionFirst == WINTER_RAIN_BASED) {// case WINTER_RAIN_BASED
	if(replicationNumber == 0) // + JPR 130309
	  localCase = 4;  // + JPR 130308 (5.5)
  }
  else {
	// ci-dessous - JPR 120730 Dhivine_4.9
//printf("\n'%s'::OpeningCondition_SpringTillages (%s) replicationNumber = %d", pChantier->InstanceName(), App_EnumToChar(optionGen), replicationNumber);
	if(replicationNumber == 0)
	  localCase = 2;	  
  }

  switch (localCase) {
  case 1 : {
	result = OpeningCondition_SpringTillages_OnWeed(pChantier);
	break;
  }
  case 2 : {
	result = TRUE;
	break;
  }
  case 3 : {
	int option2 = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P_SCOPE);
	float seuil;
	switch (option2) {
	case FARM_SCOPE : {
	  float totalArea = pEA->GetFloatConstValue(AREA_WITH_TILLED_GRAPEVINE);
	  seuil = totalArea * (float)0.75;
	  break;
	}
	case PLOT_SCOPE : {
	  seuil = (float)2.;
	  break;
	}
	case PLOT_GROUP_SCOPE : {
	  seuil = (float)5.;
	  break;
	}
	}
	int now = pCurrentSim->Clock();
	pEntityTab pPlotList = pEA->GetElementTab();
	int nbPlots = pPlotList.size();
	
	switch (optionGen) {
	case OPTIMIZATION : {
	  //
	  // on ouvre si une surface definie de l'EA est soumise
	  // a une forte pluie dans les 24h precedentes
	  // ---------------------------------------------
	  // Recuperation des stations meteo pour cette EA
	  //
	  Tableau<DescriptedEntity*>* pWSList = new Tableau<DescriptedEntity*>();
	  for(int i=0;i<nbPlots;i++) {
		Entity* pPlot_i = (Entity*)pPlotList[i];
		Entity* pWS_i = pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
		int added = pWSList->push_back_ifnew(pWS_i);
		if(added) {
		  char* pathName_i = pWS_i->GetStringConstValue(PATH_NAME_ATTRIBUTE);
		  float value_i =  // pluie des 24h precedentes, hormis l'heure en cours
			SumUpMemoryFloatFieldValue(pathName_i, FLD_RAINFALL, 1, 24);
//printf("\n\t%s pluie[-1 -24] = %f", pWS_i->InstanceName(), value_i);
		  pWS_i->SetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE, value_i);
		}
	  }
	  //
	  // Tri par pluie decroissante (pour autoriser l'arret
	  // de la boucle qd tout espoir est perdu -cf. 'else')
	  //
	  //pWSList->display_names();
	  SortDown(pWSList, ANONYMOUS_FLOAT_ATTRIBUTE);
	  //pWSList->display_names();
	  
	  float aggregatedArea = (float)0.;
	  float aggregatedRainfall = (float)0.;
	  int nbWS = pWSList->size();
	  for(int k=0;k<nbWS;k++) {
		Entity* pWS_k = (Entity*)pWSList->get_element(k);
		float rainfall_k =
		  pWS_k->GetFloatVarValue(ANONYMOUS_FLOAT_ATTRIBUTE);
		if((k == 0) && (rainfall_k < (float)30.)) {
		  //
		  // si la pluie de la WS la plus pluvieuse est insuffisante
		  // il n'y a plus d'espoir
		  //
		  break;
		}
		pEntityTab* pPlotList_k = new pEntityTab();
		float totalArea_k = (float)0;
		// recuperation liste de parcelles rattachees a cette pWS
		for(int i=0;i<nbPlots;i++) {
		  Entity* pPlot_i = (Entity*)pPlotList[i];
		  if(! strcmp(pPlot_i->GetStringConstValue(LAND_USE), "Vigne")) {
			if(pPlot_i->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE) == pWS_k) {
			  pPlotList_k->push_back(pPlot_i);
			  totalArea_k += pPlot_i->GetFloatConstValue(AREA);
			}
		  }
		}
		// somme de pluie ponderee
		aggregatedRainfall = (aggregatedRainfall * aggregatedArea) 
		  + (rainfall_k * totalArea_k);      // numerateur 
		aggregatedArea += totalArea_k;       // denominateur  
		// nouvelle somme de pluie ponderee :
		aggregatedRainfall = aggregatedRainfall / aggregatedArea;
//printf("\n\taggregatedRainfall = %fmm sur aggregatedArea = %fha", aggregatedRainfall, aggregatedArea);	
		
		if(aggregatedRainfall >= (float)30.) {
		  if(aggregatedArea >= seuil) {
			result = TRUE;
			break;
		  }
		}
		else {
		  // plus aucune chance de satisfaire le critere : ca va
		  // encore baisser avec les pWS suivantes (moins pluvieuses)
		  break;
		}
	  }
	  break;
	}
	case OPPORTUNITY : {
	  printf("\n'%s'::OpeningCondition_SpringTillages cas %s non cod.\n", pChantier->InstanceName(), App_EnumToChar(optionGen));
	  exit(0);
	  break;
	}
	default : {
	  // ci-dessous - JPR 120730 Dhivine_4.9
	  //int prevTillageClock = pIterate->GetIntConstValue(PREVIOUS_REPLICATION_REF_DATE);
//printf("\n'%s'::OpeningCondition_SpringTillages prevTillageClock = %d\n", pChantier->InstanceName(), prevTillageClock);
	  int minNbDays;
	  int dryPeriodLengthThreshold;   // + JPR 130308
	  float rainfallThreshold;
	  switch (optionGen) {
	  case LOW_RAIN_INTENSITY : {   // modif JPR 130225 (3 fois)
		minNbDays = 30; rainfallThreshold = 40.0; dryPeriodLengthThreshold = 1000; break;
	  }
	  case MEDIUM_RAIN_INTENSITY : {
		minNbDays = 21; rainfallThreshold = 30.0; dryPeriodLengthThreshold = 1000; break;
	  }
	  case HIGH_RAIN_INTENSITY : {
		minNbDays = 15; rainfallThreshold = 20.0; dryPeriodLengthThreshold = 1000; break;
	  }
	  case LOW_RAIN_INTENSITY_OR_LONG_DRY_PERIOD : {   // + JPR 130308 (3 fois)
		minNbDays = 30; rainfallThreshold = 40.0; dryPeriodLengthThreshold = 45; break;
	  }
	  case MEDIUM_RAIN_INTENSITY_OR_LONG_DRY_PERIOD : {
		minNbDays = 21; rainfallThreshold = 30.0; dryPeriodLengthThreshold = 45; break;
	  }
	  case HIGH_RAIN_INTENSITY_OR_LONG_DRY_PERIOD : {
		minNbDays = 15; rainfallThreshold = 20.0; dryPeriodLengthThreshold = 45; break;
	  }
	  }
	  //
	  // test sur nb jours mini
	  //
	  if(prevTillageClock > -9) {// 120731
		if(now - prevTillageClock > 24 * dryPeriodLengthThreshold) {// + JPR 130308
		  result = TRUE;	
		  Entity* pIterate = ((Activity*)pChantier)->IsIterated();  // modif JPR 130425 (5.6)
		  if(pIterate) { // normalement vrai
			int currentCounter = pIterate->GetIntVarValue(REPLICATION_IN_DRY_PERIOD_COUNTER);
			pIterate->SetIntVarValue(REPLICATION_IN_DRY_PERIOD_COUNTER, currentCounter+1);
		  }
		}
		else if(now - prevTillageClock > 24 * minNbDays) {
//printf("\n!!!!! seuil de nb de jours (%d) atteint", minNbDays);
		  int option = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P_SCOPE);
		  float areaScope;
		  switch (option) {
		  case FARM_SCOPE : {
			float totalArea = pEA->GetFloatConstValue(AREA_WITH_TILLED_GRAPEVINE);
			areaScope = totalArea * (float)0.75; break;
		  }
		  case PLOT_SCOPE : {
			areaScope = (float)2.; break;
		  }
		  case PLOT_GROUP_SCOPE : {
			areaScope = (float)5.; break;
		  }
		  }
		  //
		  // test sur quantit de pluie mini sur l'areaScope
		  //
		  float aggregatedArea = (float)0.;
		  for(int k=0;k<nbPlots;k++) {
			Entity* pPlot_k = (Entity*)pPlotList[k];
			if(pPlot_k->GetFloatVarValue(PERCENT_SPRING_TILLED) < 0) continue; // + JPR 120904
			float rainfall_k = 
			  pPlot_k->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_LAST_TILLAGE);
			float area_k = pPlot_k->GetFloatConstValue(AREA);
			
			if(rainfall_k >= rainfallThreshold) {
			  aggregatedArea += area_k;
//printf("\n\t'%s' rainfall_k > %f sur aggregatedArea = %fha / %fHa", pPlot_k->InstanceName(), rainfallThreshold, aggregatedArea, areaScope); // 120904
			  if(aggregatedArea >= areaScope) {
//printf("\n!!!!! seuil de pluie (%f) sur le areascope (%f) atteint", rainfallThreshold, areaScope);
				result = TRUE;	
				break;
			  }
			}
		  }
		}
		else {
//printf("\n!!!!! seuil de nb de jours NON atteint : %d-%d <= 24*%d", now, prevTillageClock, minNbDays);
		}
	  }
	  break; 
	}  // fin default
	}  // fin switch (optionGen)
	break;
  } // fin case 3
  case 4 : {  // + JPR 130308 (5.5)
	pEntityTab pPlotList = pEA->GetElementTab();
	int nbPlots = pPlotList.size();
	int option = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P_SCOPE);
	float areaScope;
	switch (option) {
	case FARM_SCOPE : {
	  float totalArea = pEA->GetFloatConstValue(AREA_WITH_TILLED_GRAPEVINE);
	  areaScope = totalArea * (float)0.75; break;
	}
	case PLOT_SCOPE : {
	  areaScope = (float)2.; break;
	}
	case PLOT_GROUP_SCOPE : {
	  areaScope = (float)5.; break;
	}
	}
	//
	// test sur quantit de pluie mini sur l'areaScope
	//
	float aggregatedArea = (float)0.;
	float lowRainfallThreshold;
	float highRainfallThreshold;
	int year = pCurrentSim->BeginningDate()->year+1;  // 130309
	Date* dateOP1 = GetDateParameterValue("finCumulPluie", "declenchementSiPluieFaible");
	Date* dateOP2 = GetDateParameterValue("finCumulPluie", "declenchementSiPluieMoyenne");
	Date* dateOP3 = GetDateParameterValue("finCumulPluie", "declenchementSiPluieForte");
	int clockDateOP1 = DateToClockValue(dateOP1->mday, dateOP1->month, year);
	int clockDateOP2 = DateToClockValue(dateOP2->mday, dateOP2->month, year);
	int clockDateOP3 = DateToClockValue(dateOP3->mday, dateOP3->month, year);
	bool readyForOPtesting = FALSE;
	int now = pCurrentSim->Clock();
	float lb = gRealParam_virtualManager_lowRainfallThresholdForWinterRainBasedSpringTillage_;
	float ub = gRealParam_virtualManager_highRainfallThresholdForWinterRainBasedSpringTillage_;
	if((now >= clockDateOP1) && (now <= clockDateOP1 + 24)) {
	  lowRainfallThreshold = 0.0;
	  highRainfallThreshold = lb;
	  readyForOPtesting = TRUE;
	}
	else if((now >= clockDateOP2) && (now <= clockDateOP2 + 24)) {
	  lowRainfallThreshold = lb;
	  highRainfallThreshold = ub;
	  readyForOPtesting = TRUE;
	}
	else if((now >= clockDateOP3) && (now <= clockDateOP3 + 24)) {
	  lowRainfallThreshold = ub;
	  highRainfallThreshold = D_FLOATMAX;
	  readyForOPtesting = TRUE;
	}
	if(readyForOPtesting) {
	  for(int k=0;k<nbPlots;k++) {
		Entity* pPlot_k = (Entity*)pPlotList[k];
		if(pPlot_k->GetFloatVarValue(PERCENT_SPRING_TILLED) < 0) continue; // + JPR 120904
		float rainfall_k = 
		  pPlot_k->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_EARLY_WINTER);
		float area_k = pPlot_k->GetFloatConstValue(AREA);
		
		if((rainfall_k >= lowRainfallThreshold)
		   &&
		   (rainfall_k <= highRainfallThreshold)) {
		  aggregatedArea += area_k;
//printf("\n\t'%s' [%f < rainfall_k < %f] sur aggregatedArea = %fha / %fHa", pPlot_k->InstanceName(), lowRainfallThreshold, highRainfallThreshold, aggregatedArea, areaScope); // 120904
		  if(aggregatedArea >= areaScope) {
//printf("\n!!!!! seuil de pluie depuis debut hiver ([%f %f]) sur le areascope (%f) atteint", lowRainfallThreshold, highRainfallThreshold, areaScope); // modif 130425
			result = TRUE;	
			break;
		  }
		}
	  }
	}
	break;
  } // fin case 4

  } // fin switch (localcase)

  // + JPR 120726
  /*  transport 120823 vers le OpeningPrdicate
  if(result == TRUE) {
	Entity* pSTIteration = pChantier->GetSuperSet();
	pSTIteration->SetIntConstValue(PREVIOUS_REPLICATION_REF_DATE, -9);
//printf("\n\t'%s'\t REF_DATE  = -9", pSTIteration->InstanceName());
  }
  */
//printf("\n'%s'::OpeningCondition_SpringTillages(%d, %d) returns %d (%s)", pChantier->InstanceName(),replicationNumber, prevTillageClock, result, App_EnumToChar(optionGen));
  return result;
}

bool OpeningCondition_SpringTillages_OnWeed (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  Entity* pEA = App_GetVineyard((Activity*)pChantier);
  int option = App_GetIntDecisionOption(pEA, OPT_SPRING_TILLAGES_O_P_SCOPE);

  bool result = FALSE;
  
  float areaThreshold;
  switch (option) {
  case FARM_SCOPE : {
	float totalArea = pEA->GetFloatConstValue(AREA_WITH_TILLED_GRAPEVINE);
	areaThreshold = totalArea * (float)0.75;
	break;
  }
  case PLOT_SCOPE : {
	areaThreshold = (float)2.;
	break;
  }
  case PLOT_GROUP_SCOPE : {
	areaThreshold = (float)5.;
	break;
  }
  }

  float cumulCovered = (float)0.;
  int nbPlots = pEA->GetNumberOfElements();
  for(int k=0;k<nbPlots;k++) {
	Entity* pPlot_k = pEA->GetElement(k);

	float aggregatedGrassCover_p = (float)-9.;
	float aggregatedGrassCover = (float)-9.;
	Entity* pVegetalCompartment = pPlot_k->GetComponent(VEGETAL_COMPARTMENT);
	// rang de passage ---------------------------
	Entity* pRow_k_0 = pVegetalCompartment->GetElement(0);
	int modality_p = pRow_k_0->GetIntConstValue(SOIL_MANAGEMENT_MODALITY);
	if((modality_p == TILLAGE) || (modality_p == MIXED_TILLAGE_CW)) {
	  aggregatedGrassCover_p = 
		pRow_k_0->ExecFloatMethod(SUM_UP_GRASS_COVER_VECTOR);
	}
	// rang travaille ---------------------------
	Entity* pRow_k_1 = pVegetalCompartment->GetElement(1);
	int modality_t = pRow_k_1->GetIntConstValue(SOIL_MANAGEMENT_MODALITY);
	if((modality_t == TILLAGE) || (modality_t == MIXED_TILLAGE_CW)) {
	  float meanGrassCover_t = 
		pRow_k_1->ExecFloatMethod(SUM_UP_GRASS_COVER_VECTOR);
	  float q_k = (float)0.;
	  if(App_FloatGT(aggregatedGrassCover_p, (float)0.)) {
		q_k = pPlot_k->GetFloatConstValue(RIDING_ORIENTED_INTER_ROW_PROPORTION);
		aggregatedGrassCover = (aggregatedGrassCover_p * q_k) 
		                       + (meanGrassCover_t     * (1. - q_k));
	  }
	} 
	else aggregatedGrassCover = aggregatedGrassCover_p;
	//             ---------------------------
	// seulement si la parcelle est suffisamment enherbee
	// on regarde la surface de la parcelle
	float weedThreshold = gRealParam_virtualManager_weedThresholdForTillageOpening_;
	if(aggregatedGrassCover >= weedThreshold) {
	  float surf_k = pPlot_k->GetFloatConstValue(AREA);
	  cumulCovered += surf_k;
	  if(cumulCovered > areaThreshold) {
		result = TRUE;
		break;
	  } 
	}		
  }

  // + JPR 120726
  /*  transport 120823 vers le OpeningPrdicate
  if(result == TRUE) {
	Entity* pSTIteration = pChantier->GetSuperSet();
	pSTIteration->SetIntConstValue(PREVIOUS_REPLICATION_REF_DATE, -9);
//printf("\n\t'%s'\t REF_DATE  = -9", pSTIteration->InstanceName());
  }
  */
//printf("\n'%s'::OpeningCondition_SpringTillages_OnWeed returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_Trellisings (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : TRUE ssi la variete-guide precoce est au debut-floraison
//---------------------------------------------
{
  Vineyard* pEA = App_GetVineyard((Activity*)pChantier);

  bool result = 
	App_IsStageReachedForEarlyGuidingVariety(pEA, 
											 "beginningOfFlowering");;

//printf("\n'%s'::OpeningCondition_Trellisings returns %d", pChantier->InstanceName(), result);
  return result;
}

bool OpeningCondition_WinterTillages_OnDate (Entity* pChantier)
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  bool result = FALSE;
  
  //Entity* pEA = App_GetVineyard((Activity*)pChantier);

  int now = pCurrentSim->Clock();
  tm* pTm = ClockValueToTm(now);
  int month = pTm->tm_mon;
  int year = pTm->tm_year + 1900;
  if(month > 7)       // sept, etc.
	year = year +1;
  delete pTm;

  int clockOuverture = DateToClockValue(2, 1, year);
  if(now >= clockOuverture)
	result = TRUE;

//printf("\n'%s'::OpeningCondition_WinterTillages_OnDate returns %d", pChantier->InstanceName(), result);
  return result;
}

int ReturnManagerWakeUpHour ()
//---------------------------------------------
// Description  : 
// Precondition : 
// Retour       : 
//---------------------------------------------
{
  int wakeUpHour = gIntParam_morningUpdateSituation_normalHour_;
  //
  // l'instant courant
  //
  int now = pCurrentSim->Clock();
  tm* pTm_now = ClockValueToTm(now);
  int mon = pTm_now->tm_mon;
  int day = pTm_now->tm_mday;
  delete pTm_now;
  //
  // la date a atteindre pour entrer dans la periode speciale
  //
  if(((mon == 3) && (day == 30))  // 30 avril -> specialHour pour le 1er mai
	 ||
	 ((mon > 3) && (mon < 7))     // mai, ... ,juillet
	 ||
	 (mon == 7) && (day < 31)) {  // 31 aout -> normalHour pour 1er sept
	wakeUpHour = gIntParam_morningUpdateSituation_specialHour_;
  }
  //
  // la date a atteindre pour entrer dans la periode novembre-janvier 
  // + JPR 130121
  else if(((mon == 9) && (day == 31))  // 31 oct -> specialHour pour le 1er nov
	 ||
	 (mon > 9)    // nov, ... ,dec
	 ||
	 (mon == 0) && (day < 31)) {  // 31 jan -> normalHour pour 1er fev
	wakeUpHour = gIntParam_morningUpdateSituation_normalHour_ + 1;
  }
//printf("\n%d %s -> ReturnManagerWakeUpHour returns %d", day, MonthToChar(mon+1), wakeUpHour);
  return wakeUpHour;
}

int main_Auto (int argc, char* argv[])
//---------------------------------------------
// Description  : version de la fonction main pour les simulations autonomes
//                (cad non en position de serveur du client OpenFluid)
// Precondition : 
// Retour       : 
//---------------------------------------------
{
#ifdef _SWIG_
  xs_init = O_App_xs_init;
#endif
  // ci-dessous : ssi non programme dans *.dir
  InitChrono();
  StartChrono();

  // ---------------------------------------------
  // Plus grande tol rance pour l' galit    1 du degre de progression
  // des operations : -> 0.999 considere egal a 1
  // --------------------------------------------- 
  gFloatingPointEqualityTolerance = (float)0.001;

  // ---------------------------------------------
  // interpretation de la ligne de commande
  // ---------------------------------------------
  App_ParseMainArguments(argc, argv);

  // ---------------------------------------------
  // Lecture des parametres generaux du systeme
  // ---------------------------------------------
  ParseParameterFile(argv[1]);

  // ---------------------------------------------
  // Instantiation de pCurrentSim et preambule technique
  // ---------------------------------------------
  InitSimulation();

  // ---------------------------------------------
  // Instanciation superficielle du systeme de production
  // ---------------------------------------------
  Entity* pPS = new VineProducingRegion();
	
  Entity* pDS = new VirtualRegionManager();
					  
  Entity* pStrategy = new Strategy();
  Entity* pARBSet = new ActivitiesResourcesBlockSet();
  pStrategy->AddComponent(pARBSet);
  pDS->AddComponent(pStrategy);
  pPS->AddComponent(pDS);
  Entity* pOS = new VirtualRegionOperatingSystem();
  pPS->AddComponent(pOS);
  Entity* pCS = new VineGrowingTerritory();
  pPS->AddComponent(pCS);
  // ---------------------------------------------
  // Instanciation superficielle du systeme biophysique ...
  // ---------------------------------------------
  Entity* pBPS = new AgroClimaticSystem();
	
  Entity* pAgroSet = new VineyardSet();
  pBPS->AddComponent(pAgroSet);
  Entity* pClimSet = new WeatherStationSet();
  pBPS->AddComponent(pClimSet);
  // ... et attachement au ControlledSystem
  pCS->SetEntityConstValue(ATTACHED_ENTITY, pBPS);

  // ---------------------------------------------
  // Attachement des contraintes sur les ressources a l'OS
  // ---------------------------------------------
  Entity* pRSVC;
  pRSVC= new EquipmentMultiLocalization();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pRSVC);
  pRSVC = new FarmWorkerMultiLocalization();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pRSVC);
  pRSVC = new FarmWorkerMultiOccupation();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pRSVC);
  
  Entity* pARIC = new PlotWithSeveralOperations();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pARIC);
  
  Entity* pAIC;
  pAIC = new TooLateInWorkDayForActivityBeginning();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pAIC);
  
  pAIC = new OnlyPhytoTreatmentsAtEarlyMorning();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pAIC);

  // ---------------------------------------------
  // Designation du systeme de production comme entite simulee
  // ---------------------------------------------
  pCurrentSim->SimulatedEntity(pPS);

  // ---------------------------------------------
  // exploitation des parametres de memoire et de prediction
  // ---------------------------------------------
  int memoryScope = gIntParam_virtualManager_memoryScope_;
  pDS->SetIntVarValue(MEMORY_SCOPE, memoryScope);
  int predictionScope = gIntParam_virtualManager_predictionScope_;
  pDS->SetIntVarValue(PREDICTION_SCOPE, predictionScope);
	
  // ---------------------------------------------
  // Lecture des parametres de la simulation
  // ---------------------------------------------
  ParseSimulationFile(argv[2]);
	
  // ---------------------------------------------
  // Lecture des autres fichiers-argument de la commande
  // ---------------------------------------------
  ParseOutputSpecFile(argv[3]);
  ParseStructureFile(argv[4]);

  // ---------------------------------------------
  // Construction profonde du systeme biophysique
  // ---------------------------------------------
  char* inDir = pCurrentSim->GetInDir();
  char* vineyardFile = gStringParam_install_vineyardFile_;
  char str[100] = {'\0'};
  strcat(str, inDir);
  strcat(str, vineyardFile);
  sprintf(str, "%s%s", inDir, vineyardFile);
  App_DepthBioPhysicalSettings(str);

  // ---------------------------------------------
  // Construction profonde du systeme operant
  // ---------------------------------------------
  char* rscFile = gStringParam_install_resourceFile_;
  char str2[100] = {'\0'};
  strcat(str2, inDir);
  strcat(str2, rscFile);
  sprintf(str2, "%s%s", inDir, rscFile);
  App_ResourceSettings(str2);

  // ---------------------------------------------
  // Construction profonde du systeme de decision
  // ---------------------------------------------
  char* planFile = gStringParam_install_planFile_;
  char str3[100] = {'\0'};
  strcat(str3, inDir);
  strcat(str3, rscFile);
  sprintf(str3, "%s%s", inDir, planFile);
  App_ControlPlanSettings(str3);

  // ---------------------------------------------
  // Etablissement des IsoAgeingEntity attachees aux parcelles,
  // une fois connues les varietes par parcelle (App_DepthBioPhysical.)
  // et les varietes-guides par conduite (App_ControlPlan.)
  // ---------------------------------------------
  App_AssignIsoAgeingEntityToPlots(pAgroSet);

  // ---------------------------------------------
  // Etablissement des operations exclues des SelectPlotsToX
  // ---------------------------------------------
  App_AssignTurnedOffActivitiesOnPlots(pAgroSet);
	
  // ---------------------------------------------
  // Lecture des autres fichiers-argument de la commande
  // ---------------------------------------------
  int nbArb = pARBSet->GetNumberOfElements();
  for(int i=0;i<nbArb;i++) {
	Entity* pARB_i = pARBSet->GetElement(i);
	Activity* pPlan_i = (Activity*)pARB_i->GetComponent(ACTIVITY);
	printf("\nAVANT RUN pPlan[%d] : %s pour %s\n", i, pPlan_i->InstanceName(), pPlan_i->GetEntityConstValue(VINEYARD_ATTRIBUTE)->InstanceName());
	pPlan_i->DisplaySituation(); printf("\n");
  }
  //
  // La preparation des gantt charts R ci-apres necessite
  // de ne pas desallouer les ARB et les chantiers. 
  // Le fichier declaratif *.dir ne doit donc pas contenir
  // les directives de desallocation. Cette desallocation est
  // programmee ici apr s la preparation des gantt charts.
  // 
  C_ParseDirectiveFile(argv[5]);
  //
  // Preparation R gantt charts
  // 
  App_MakeGanttChartCommandFiles();
  
  // chrono ci-dessous : ssi non programme dans *.dir
  PauseChrono();
  PrintChrono();
  printf("\nduree = %s", gTimeString);
  CloseChrono();
  //
  // Desallocation des activites et des operations ...
  // - non commencees (*) ou entamees en l'instant de fin de simulation,
  //   donc non desallouees par un MIOS pour celles qui sont dans un chantier
  // - tq un chantier se termine avec elles, donc non desallouees par le MIOS
  //
  DeallocatePrimitiveActivityTab();
  DeallocateOperationTab();
  //
  // Desallocation des entites creees par l'application (et non par le moteur)
  // en cours de simulation et connues pour ne pas etre desallouees avant.
  //
  App_DeallocateMiscellaneousDynamicEntities();
  //
  // Desallocation generale :
  // - donc a ne pas programmer dans *.dir
  // - appel aux fonctions specialisees (au lieu de C_DeleteAll)
  // pour pouvoir y inserer un MemoryReport sans argument
  // (cad non conditionne a l'option de trace -V)
  //
  DeleteEntitySpecs();
  C_DeleteEntityInstances();
  DeleteMonitors();
  DeleteParameters();
  C_DeleteFileInstances();
  DeleteOutputSpecs();
  delete pCurrentSim;
  O_MemoryReport();
  DeleteEntityClasses();

#ifdef _INTERACTIVE_
  printf("FIN MAIN");
#endif
  return 0;
}

int main_Mhydas (int argc, char* argv[])
//---------------------------------------------
// Description  : fonction d'entr e du simulateur pour simuler
//                le connexion avec OpenFluid/Mhydas
// Precondition : 1) le corps de cette fonction doit remplacer le corps
//                de la fonction main() pour la simulation autonome
//                2) l'appel du simulateur continue   r clamer 5 noms de
//                fichiers en arguments, mais le 5 me peut  tre ""
//                3) le fichier str doit inclure l'instanciation d'un
//                 v nement auto-g n rable 'morningMhydasInteractionEvent'
// Retour       : 
//---------------------------------------------
{
#ifdef _SWIG_
  xs_init = O_App_xs_init;
#endif
  // ci-dessous : ssi non programme dans *.dir
  InitChrono();
  StartChrono();
  
  // ---------------------------------------------
  // interpretation de la ligne de commande
  // ---------------------------------------------
  App_ParseMainArguments(argc, argv);
  
  // ---------------------------------------------
  // Instantiation de pCurrentSim et preambule technique
  // (dont valuation de gFloatingPointEqualityTolerance)
  // ---------------------------------------------
  InitOpenSimulation(argv[1], argv[2], argv[3], argv[4]);
  //                   par      sim      osp      str
  
  Entity* pPS = pCurrentSim->SimulatedEntity();
  Entity* pDS = pPS->GetComponent(MANAGER);
  Entity* pStrategy = pDS->GetComponent(STRATEGY);
  Entity* pARBSet = pStrategy->GetComponent(ACTIVITIES_RESOURCES_BLOCK_SET);
  Activity* pPlan = (Activity*)pARBSet->GetElement(0)->GetComponent(ACTIVITY);
  printf("\nAVANT RUN pPlan : %s\n", pPlan->InstanceName());
  pPlan->DisplaySituation(); printf("\n");
  
  pEntityTab* IN_tab;
  pEntityTab* OUT_tab;

  // ==================================================
  // Lancement d'un premier episode de simulation en t=0 pour passer
  // les RelativeArea et les SoilManagementModality des Row's
  // ==================================================
  //
  // donn es communiqu es par le programme ma tre   la simulation :
  // ------------------------------------------------------------
  IN_tab = new pEntityTab(); 
  //
  // donn es attendues par le programme ma tre de la simulation :
  // ----------------------------------------------------------
  OUT_tab = new pEntityTab();
  InterfaceDataItem* pOutItem;
  
  pOutItem = new RelativeAreaDataItem();
  OUT_tab->push_back(pOutItem);
  pOutItem->SetStringConstValue(ENTITY_NAME_ATTRIBUTE, "MG11_031_2");
  
  pOutItem = new RelativeAreaDataItem();
  OUT_tab->push_back(pOutItem);
  pOutItem->SetStringConstValue(ENTITY_NAME_ATTRIBUTE, "MG11_032_2");
  
  pOutItem = new SoilManagementDataItem();
  OUT_tab->push_back(pOutItem);
  pOutItem->SetStringConstValue(ENTITY_NAME_ATTRIBUTE, "MG11_031_2");
  
  pOutItem = new SoilManagementDataItem();
  OUT_tab->push_back(pOutItem);
  pOutItem->SetStringConstValue(ENTITY_NAME_ATTRIBUTE, "MG11_032_2");
  
  int iterationCounter = 0;
  int pauseClock = 9;
  tm* pTm = ClockValueToTm(pauseClock);
  StructTmToStringISO(pTm);
  delete pTm;
printf("\navant premier episode de simulation pause programmee juste apres '%s'", gTimeString);
  ((OpenSimulation*)pCurrentSim)->RunOpenSimulationToDate(iterationCounter,
														  IN_tab, 
														  gTimeString,
														  OUT_tab);
  // "simulation" de l'exploitation des sorties OUT par MHYDAS
  // ----------------------------------------------------------
  int nbOutItems = OUT_tab->size();
printf("\nsortie de Run...ToDate nbOutItems = %d", nbOutItems);
//OUT_tab->display_names();
  for(int i=0;i<nbOutItems;i++) {
	InterfaceDataItem* pOutItem = (InterfaceDataItem*)OUT_tab->get_element(i);
	char* nomUnite = pOutItem->GetStringConstValue(ENTITY_NAME_ATTRIBUTE);
	char* laDate = pOutItem->GetStringConstValue(DATE_ISO_ATTRIBUTE);
	//int clockValue = pOutItem->GetIntConstValue(INSTANT_ATTRIBUTE));
	//char* laDate = ClockValueToStringISO(clockValue);
//pOutItem->DisplayAttributes();
	if(pOutItem->IsInstanceOf(SOIL_MANAGEMENT_DATA_ITEM)) {
	  int modality = pOutItem->GetIntInterfaceValue();
	  //printf("\nrang :'%s' : modalite TS : '%s' date : '%s'", 
	  //		 nomUnite, App_EnumToChar(modality), laDate);
	}
	else if(pOutItem->IsInstanceOf(RELATIVE_AREA_DATA_ITEM)) {
	  float relativeArea = pOutItem->GetFloatInterfaceValue();
	  //printf("\nrang :'%s' : surface relative : %3.2f date : '%s'", 
	  //		 nomUnite, relativeArea, laDate);
	}
	//free laDate;
  }
  delete IN_tab;
  delete OUT_tab;
 
  // ==================================================
  // Lancement iteratif des episodes de simulation   partir de t=0
  // jusqu'  ce que le main() equiv. MHYDAS decide d'arreter.
  // Ici : MHYDAS d cide de s'arreter quand la simulation DIESE
  // lui signale que son travail est termine.
  // ==================================================
  //int begClock;
  //int endClock = -1;      // le premier  pisode doit d marrer en t=0
  while(TRUE) {
	//
	// l' pisode d marre juste apr s la fin du pr c dent ...
	// -----------------------------------------------------
	//begClock = endClock + 1;
	//
	// donn es communiqu es par le programme ma tre   la simulation :
	// ------------------------------------------------------------
	IN_tab = new pEntityTab(); 
    InterfaceDataItem* pInItem; 
  
	pInItem = new GrassCoverVectorDataItem();
	pInItem->SetStringConstValue(ENTITY_NAME_ATTRIBUTE, "MG11_02_1");
	pInItem->SetStringConstValue(DATE_ISO_ATTRIBUTE, "2005-03-15T08:00:00+01:00");
	pInItem->SetIntConstValue(DESCRIPTOR_ID_ATTRIBUTE, GRASS_COVER_VECTOR_FROM_MHYDAS);
	pFloatTab* vector = new pFloatTab();
	vector->push_back(0.95);
	vector->push_back(0.95);
	vector->push_back(0.95);
	vector->push_back(0.95);
	pInItem->SetInterfaceValue(vector);
	IN_tab->push_back(pInItem); 
  
	pInItem = new GrassCoverVectorDataItem();
	pInItem->SetStringConstValue(ENTITY_NAME_ATTRIBUTE, "MG11_02_2");
	pInItem->SetStringConstValue(DATE_ISO_ATTRIBUTE, "2005-03-15T08:00:00+01:00");
	pInItem->SetIntConstValue(DESCRIPTOR_ID_ATTRIBUTE, GRASS_COVER_VECTOR_FROM_MHYDAS);
	vector = new pFloatTab();
//  --> main.cc_Mhydas idpas entique a  main.cc_Auto
	vector->push_back(0.95);
	vector->push_back(0.95);
	vector->push_back(0.95);
	vector->push_back(0.95);
/*  --> main.cc_Mhydas identique a  main.cc_Auto
	vector->push_back(0.05);
	vector->push_back(0.00);
	vector->push_back(0.00);
	vector->push_back(0.05);
*/
	pInItem->SetInterfaceValue(vector);
	IN_tab->push_back(pInItem);
	
	// donn es attendues par le programme ma tre de la simulation :
	// ----------------------------------------------------------
	OUT_tab = new pEntityTab();
	InterfaceDataItem* pOutItem;

	Entity* pPS = pCurrentSim->SimulatedEntity();
	Entity* pCS = pPS->GetComponent(CONTROLLED_SYSTEM);
	Entity* pACS = pCS->GetEntityConstValue(ATTACHED_ENTITY);
	Entity* pVineyardSet = pACS->GetComponent(VINEYARD_SET);
	int nbEA = pVineyardSet->GetNumberOfElements();
	char rowName[20] = "\0";
	for(int i=0;i<nbEA;i++) {
	  Entity* pVineyard_i = pVineyardSet->GetElement(i);
	  int nbPlots_i = pVineyard_i->GetNumberOfElements();
	  for(int j=0;j<nbPlots_i;j++) {
		Entity* pPlot_i_j = pVineyard_i->GetElement(j);
		sprintf(rowName, "%s_2", pPlot_i_j->InstanceName());
		pOutItem = new CulturalOperationsDataItem();
		OUT_tab->push_back(pOutItem);
		pOutItem->SetStringConstValue(ENTITY_NAME_ATTRIBUTE, strdup(rowName));
	  }
	}
	
	//
	// lancement de l'episode de simulation
	// ------------------------------------
	OpenSimulation* pOpenSim = (OpenSimulation*)pCurrentSim;
	char* clockAtReturn = pOpenSim->RunOpenSimulation(iterationCounter,
													  IN_tab,
													  OUT_tab);
	/*
printf("\nmAgendaEvents.empty = %d", pCurrentSim->AgendaEvents().empty());
printf("\nmToBeStopped = %d", pCurrentSim->ToBeStopped());
printf("\nmClock = %d", pCurrentSim->Clock());
printf("\nmEndClock = %d", pCurrentSim->EndClock());
printf("\nclockAtReturn = '%s'", clockAtReturn);
	*/
 
	//
	// "simulation" de l'exploitation des sorties OUT par MHYDAS
	// ----------------------------------------------------------
	int nbOutItems = OUT_tab->size();
//printf("\nsortie de Run nbOutItems = %d", nbOutItems);
	for(int i=0;i<nbOutItems;i++) {
	  InterfaceDataItem* pOutItem = (InterfaceDataItem*)OUT_tab->get_element(i);
	  Entity* value = pOutItem->GetEntityInterfaceValue();
	  int nbMemoryItems = value->GetNumberOfElements();
//printf("\n\tvalue %s nbMemoryItems = %d\n", value->InstanceName(), nbMemoryItems);
	  for(int j=0;j<nbMemoryItems;j++) {
		Entity* pMemoryItem = value->GetElement(j);
		//int clockValue = pMemoryItem->GetIntConstValue(INSTANT_ATTRIBUTE));
		//char* ISOValue = ClockValueToStringISO(clockValue);
		/*
//printf("\n'%s rang :'%s' : tool : '%s' date : '%s'", pMemoryItem->InstanceName(),
			   pOutItem->GetStringConstValue(ENTITY_NAME_ATTRIBUTE),
			   pMemoryItem->GetStringConstValue(TOOL_CLASS_NAME),
			   pMemoryItem->GetStringConstValue(DATE_ISO_ATTRIBUTE)
			   //ISOValue
			   );
		*/
		//free ISOValue;
	  }
	};
	delete IN_tab;
	delete OUT_tab;
	//
	// note : les xxMemoryItem's (e.g. LastTillageOperationsMemoryItem)
	// elements des entites LastOperationMemory dont le nom d'instance est
	// la valeur  de ENTITY_NAME_ATTRIBUTE des IDI du tableau OUT_tab
	// sont desalloues dans OpenSimulation::RunOpenSimulation, ssi le
	// ADD_VALUE_MODE des IDI est NEW
	//
	bool breakWhile = (strlen(clockAtReturn) == 0);
	delete[] clockAtReturn;

	if(breakWhile)
	  break;
  }
  //
  // Preparation R gantt charts
  // 
  App_MakeGanttChartCommandFiles();

  // chrono ci-dessous : ssi non programme dans *.dir
  PauseChrono();
  PrintChrono();
  printf("\nduree simulation : %s\n", gTimeString);
  CloseChrono();

  // display ci-dessous : ssi non programme dans *.dir
  DisplayAllOutputSpecs();

  //
  // Desallocation des activites et des operations ...
  // - non commencees (*) ou entamees en l'instant de fin de simulation,
  //   donc non desallouees par un MIOS pour celles qui sont dans un chantier
  // - tq un chantier se termine avec elles, donc non desallouees par le MIOS
  //
  DeallocatePrimitiveActivityTab();
  DeallocateOperationTab();
  //
  // Desallocation des entites creees par l'application (et non par le moteur)
  // en cours de simulation et connues pour ne pas etre desallouees avant.
  //
  App_DeallocateMiscellaneousDynamicEntities();
  //
  // Desallocation generale :
  // - donc a ne pas programmer dans *.dir
  // - appel aux fonctions specialisees (au lieu de C_DeleteAll)
  // pour pouvoir y inserer un MemoryReport sans argument
  // (cad non conditionne a l'option de trace -V)
  //
  DeleteEntitySpecs();
  C_DeleteEntityInstances();
  DeleteMonitors();
  DeleteParameters();
  C_DeleteFileInstances();
  DeleteOutputSpecs();
  delete pCurrentSim;
  O_MemoryReport();
  DeleteEntityClasses();

  return 0;
}

int main_core(int argc, char* argv[], int numSim) {

  InitChrono();
  StartChrono();

  // ---------------------------------------------
  // Instantiation de pCurrentSim et preambule technique
  // ---------------------------------------------
  InitSimulation();

  // ---------------------------------------------
  // Instanciation superficielle du systeme de production
  // ---------------------------------------------
  Entity* pPS = new VineProducingRegion();
	
  Entity* pDS = new VirtualRegionManager();
					  
  Entity* pStrategy = new Strategy();
  Entity* pARBSet = new ActivitiesResourcesBlockSet();
  pStrategy->AddComponent(pARBSet);
  pDS->AddComponent(pStrategy);
  pPS->AddComponent(pDS);
  Entity* pOS = new VirtualRegionOperatingSystem();
  pPS->AddComponent(pOS);
  Entity* pCS = new VineGrowingTerritory();
  pPS->AddComponent(pCS);
  // ---------------------------------------------
  // Instanciation superficielle du systeme biophysique ...
  // ---------------------------------------------
  Entity* pBPS = new AgroClimaticSystem();
	
  Entity* pAgroSet = new VineyardSet();
  pBPS->AddComponent(pAgroSet);
  Entity* pClimSet = new WeatherStationSet();
  pBPS->AddComponent(pClimSet);
  // ... et attachement au ControlledSystem
  pCS->SetEntityConstValue(ATTACHED_ENTITY, pBPS);

  // ---------------------------------------------
  // Attachement des contraintes sur les ressources a l'OS
  // ---------------------------------------------
  Entity* pRSVC;
  pRSVC= new EquipmentMultiLocalization();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pRSVC);
  pRSVC = new FarmWorkerMultiLocalization();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pRSVC);
  pRSVC = new FarmWorkerMultiOccupation();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pRSVC);

  Entity* pARIC = new PlotWithSeveralOperations();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pARIC);

  Entity* pAIC;
  pAIC = new TooLateInWorkDayForActivityBeginning();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pAIC);

  pAIC = new OnlyPhytoTreatmentsAtEarlyMorning();
  pOS->AddEntityValueElement(RESOURCE_CONSTRAINT_LIST, pAIC);

  // ---------------------------------------------
  // Designation du systeme de production comme entite simulee
  // ---------------------------------------------
  pCurrentSim->SimulatedEntity(pPS);

  // ---------------------------------------------
  // exploitation des parametres de memoire et de prediction
  // ---------------------------------------------
  int memoryScope = gIntParam_virtualManager_memoryScope_;
  pDS->SetIntVarValue(MEMORY_SCOPE, memoryScope);
  int predictionScope = gIntParam_virtualManager_predictionScope_;
  pDS->SetIntVarValue(PREDICTION_SCOPE, predictionScope);
	
  // ---------------------------------------------
  // Lecture des parametres de la simulation
  // ---------------------------------------------
  ParseSimulationFile(argv[2]);
  if(gMyEndingTraceAllOperations || gMyEndingTraceSomeOperations) { // + JPR 130325
	gFileEndingTrace = new File(ENDING_TRACE_FILE, WRITE, NEW);
	gFileEndingTrace->AssignPhysicalPath(pCurrentSim->GetOutDir()); // repertoire
	gFileEndingTrace->AssignSimpleName(gMyEndingTraceFileName);// nom du fichier
	gFileEndingTrace->Open();
  }
	
  // ---------------------------------------------
  // Lecture des autres fichiers-argument de la commande
  // ---------------------------------------------
  ParseOutputSpecFile(argv[3]);
  ParseStructureFile(argv[4]);

  // ---------------------------------------------
  // Construction profonde du systeme biophysique
  // ---------------------------------------------
  char* inDir = pCurrentSim->GetInDir();
  char* vineyardFile = gStringParam_install_vineyardFile_;
  char str[100] = {'\0'};
  strcat(str, inDir);
  strcat(str, vineyardFile);
  sprintf(str, "%s%s", inDir, vineyardFile);
  App_DepthBioPhysicalSettings(str);

  // ---------------------------------------------
  // Construction profonde du systeme operant
  // ---------------------------------------------
  char* rscFile = gStringParam_install_resourceFile_;
  char str2[100] = {'\0'};
  strcat(str2, inDir);
  strcat(str2, rscFile);
  sprintf(str2, "%s%s", inDir, rscFile);
  App_ResourceSettings(str2);

  // ---------------------------------------------
  // Construction profonde du systeme de decision
  // ---------------------------------------------
  char* planFile = gStringParam_install_planFile_;
  char str3[100] = {'\0'};
  strcat(str3, inDir);
  strcat(str3, rscFile);
  sprintf(str3, "%s%s", inDir, planFile);
  App_ControlPlanSettings(str3);

  // ---------------------------------------------
  // Etablissement des IsoAgeingEntity attachees aux parcelles,
  // une fois connues les varietes par parcelle (App_DepthBioPhysical.)
  // et les varietes-guides par conduite (App_ControlPlan.)
  // ---------------------------------------------
  App_AssignIsoAgeingEntityToPlots(pAgroSet);

  // ---------------------------------------------
  // Etablissement des operations exclues des SelectPlotsToX
  // ---------------------------------------------
  App_AssignTurnedOffActivitiesOnPlots(pAgroSet);
	
  // ---------------------------------------------
  // Lecture des autres fichiers-argument de la commande
  // ---------------------------------------------
  int nbArb = pARBSet->GetNumberOfElements();
  for(int i=0;i<nbArb;i++) {
	Entity* pARB_i = pARBSet->GetElement(i);
	Activity* pPlan_i = (Activity*)pARB_i->GetComponent(ACTIVITY);
	printf("\nAVANT RUN pPlan[%d] : %s pour %s\n", i, pPlan_i->InstanceName(), pPlan_i->GetEntityConstValue(VINEYARD_ATTRIBUTE)->InstanceName());
	pPlan_i->DisplaySituation(); printf("\n");
  }
  //
  // La preparation des gantt charts R ci-apres necessite
  // de ne pas desallouer les ARB et les chantiers. 
  // Le fichier declaratif *.dir ne doit donc pas contenir
  // les directives de desallocation. Cette desallocation est
  // programmee ici apr s la preparation des gantt charts.
  // 
  C_ParseDirectiveFile(argv[5]);
  //
  // Preparation R gantt charts
  // 
  App_MakeGanttChartCommandFiles();

//---- enregistrement operations sur fichier externe -----
  if(gMyRecordOperations) {
    gFileBDD = new File(OPERATIONS_FILE, WRITE, NEW);
    gFileBDD->AssignPhysicalPath(pCurrentSim->GetOutDir()); // repertoire
    gFileBDD->AssignSimpleName(gMyRecordFileName);// nom du fichier
    //gFileBDD->AssignSimpleName(GetStringParameterValue("recordOperations", "file"));// nom du fichier en parametre (option provisoire)
    gFileBDD->Open();
  
	pDS->ExecVoidMethod(DUMP_OPERATION_RECORDS);

    gFileBDD->Close();
    delete gFileBDD;
  }
//----------------------------------------------------

  if(gFileEndingTrace) { // + JPR 130325
    gFileEndingTrace->Close();
    delete gFileEndingTrace;	
  }
  //
  // Desallocation des activites et des operations ...
  // - non commencees (*) ou entamees en l'instant de fin de simulation,
  //   donc non desallouees par un MIOS pour celles qui sont dans un chantier
  // - tq un chantier se termine avec elles, donc non desallouees par le MIOS
  //
  DeallocatePrimitiveActivityTab();
  DeallocateOperationTab();
  //
  // Desallocation des entites creees par l'application (et non par le moteur)
  // en cours de simulation et connues pour ne pas etre desallouees avant.
  //
  App_DeallocateMiscellaneousDynamicEntities();
  //
  // Desallocation generale :
  // - donc a ne pas programmer dans *.dir
  // - appel aux fonctions specialisees (au lieu de C_DeleteAll)
  // pour pouvoir y inserer un MemoryReport sans argument
  // (cad non conditionne a l'option de trace -V)
  //

  DeleteEntitySpecs();
  C_DeleteEntityInstances();
  DeleteMonitors();
  C_DeleteFileInstances();
  DeleteOutputSpecs();
  delete pCurrentSim;
  O_MemoryReport();
  DeleteEntityClasses();

  // ci-dessous : ssi non programme dans *.dir
  PauseChrono();
  PrintChrono();
  printf("\nduree simulation n %d = %s\n", numSim, gTimeString);
  CloseChrono();
}

// ------------------------------------------------------------------
// Initialisation des variables globales correspondant aux parametres
// ------------------------------------------------------------------
// Comment : si un nouveau parametre a ete introduit dans le code de l'appli,
//           1) le code ainsi modifie doit etre regenere : 
//           (menu 'Generation/Function', item 'Fonction globales' ou 'main')
//           2) dans le cas 'main', le code de cette fonction-ci doit etre 
//              regenere (item 'Fonction globales' et 'Types'.
//                          ou 'Tous les sources'.
// ------------------------------------------------------------------
void InitParameterGlobalVariables() {
	gIntParam_virtualManager_memoryScope_ = GetIntParameterValue("virtualManager", "memoryScope");
	gIntParam_virtualManager_predictionScope_ = GetIntParameterValue("virtualManager", "predictionScope");
	gStringParam_install_vineyardFile_ = GetStringParameterValue("install", "vineyardFile");
	gStringParam_install_resourceFile_ = GetStringParameterValue("install", "resourceFile");
	gStringParam_install_planFile_ = GetStringParameterValue("install", "planFile");
	gRealParam_virtualManager_riskLevelForDownyMildewClosing_ = GetRealParameterValue("virtualManager", "riskLevelForDownyMildewClosing");
	gRealParam_virtualManager_rainfallThresholdForPhytoTreatment_ = GetRealParameterValue("virtualManager", "rainfallThresholdForPhytoTreatment");
	gRealParam_virtualManager_satisfactionThresholdForPhytoTreatment_ = GetRealParameterValue("virtualManager", "satisfactionThresholdForPhytoTreatment");
	gRealParam_normalPlan_septemberOctoberMorningBegHour_ = GetRealParameterValue("normalPlan", "septemberOctoberMorningBegHour");
	gRealParam_normalPlan_septemberOctoberMorningEndHour_ = GetRealParameterValue("normalPlan", "septemberOctoberMorningEndHour");
	gRealParam_normalPlan_septemberOctoberMorningExtendedEndHour_ = GetRealParameterValue("normalPlan", "septemberOctoberMorningExtendedEndHour");
	gRealParam_normalPlan_septemberOctoberAfternoonBegHour_ = GetRealParameterValue("normalPlan", "septemberOctoberAfternoonBegHour");
	gRealParam_normalPlan_septemberOctoberAfternoonEndHour_ = GetRealParameterValue("normalPlan", "septemberOctoberAfternoonEndHour");
	gRealParam_normalPlan_septemberOctoberAfternoonExtendedEndHour_ = GetRealParameterValue("normalPlan", "septemberOctoberAfternoonExtendedEndHour");
	gRealParam_reducedPlan_septemberOctoberMorningBegHour_ = GetRealParameterValue("reducedPlan", "septemberOctoberMorningBegHour");
	gRealParam_reducedPlan_septemberOctoberMorningEndHour_ = GetRealParameterValue("reducedPlan", "septemberOctoberMorningEndHour");
	gRealParam_reducedPlan_septemberOctoberMorningExtendedEndHour_ = GetRealParameterValue("reducedPlan", "septemberOctoberMorningExtendedEndHour");
	gRealParam_reducedPlan_septemberOctoberAfternoonBegHour_ = GetRealParameterValue("reducedPlan", "septemberOctoberAfternoonBegHour");
	gRealParam_reducedPlan_septemberOctoberAfternoonEndHour_ = GetRealParameterValue("reducedPlan", "septemberOctoberAfternoonEndHour");
	gRealParam_reducedPlan_septemberOctoberAfternoonExtendedEndHour_ = GetRealParameterValue("reducedPlan", "septemberOctoberAfternoonExtendedEndHour");
	gRealParam_normalPlan_aprilMorningBegHour_ = GetRealParameterValue("normalPlan", "aprilMorningBegHour");
	gRealParam_normalPlan_aprilMorningEndHour_ = GetRealParameterValue("normalPlan", "aprilMorningEndHour");
	gRealParam_normalPlan_aprilMorningExtendedEndHour_ = GetRealParameterValue("normalPlan", "aprilMorningExtendedEndHour");
	gRealParam_normalPlan_aprilAfternoonBegHour_ = GetRealParameterValue("normalPlan", "aprilAfternoonBegHour");
	gRealParam_normalPlan_aprilAfternoonEndHour_ = GetRealParameterValue("normalPlan", "aprilAfternoonEndHour");
	gRealParam_normalPlan_aprilAfternoonExtendedEndHour_ = GetRealParameterValue("normalPlan", "aprilAfternoonExtendedEndHour");
	gRealParam_reducedPlan_aprilMorningBegHour_ = GetRealParameterValue("reducedPlan", "aprilMorningBegHour");
	gRealParam_reducedPlan_aprilMorningEndHour_ = GetRealParameterValue("reducedPlan", "aprilMorningEndHour");
	gRealParam_reducedPlan_aprilMorningExtendedEndHour_ = GetRealParameterValue("reducedPlan", "aprilMorningExtendedEndHour");
	gRealParam_reducedPlan_aprilAfternoonBegHour_ = GetRealParameterValue("reducedPlan", "aprilAfternoonBegHour");
	gRealParam_reducedPlan_aprilAfternoonEndHour_ = GetRealParameterValue("reducedPlan", "aprilAfternoonEndHour");
	gRealParam_reducedPlan_aprilAfternoonExtendedEndHour_ = GetRealParameterValue("reducedPlan", "aprilAfternoonExtendedEndHour");
	gRealParam_normalPlan_februaryMarchMorningBegHour_ = GetRealParameterValue("normalPlan", "februaryMarchMorningBegHour");
	gRealParam_normalPlan_februaryMarchMorningEndHour_ = GetRealParameterValue("normalPlan", "februaryMarchMorningEndHour");
	gRealParam_normalPlan_februaryMarchMorningExtendedEndHour_ = GetRealParameterValue("normalPlan", "februaryMarchMorningExtendedEndHour");
	gRealParam_normalPlan_februaryMarchAfternoonBegHour_ = GetRealParameterValue("normalPlan", "februaryMarchAfternoonBegHour");
	gRealParam_normalPlan_februaryMarchAfternoonEndHour_ = GetRealParameterValue("normalPlan", "februaryMarchAfternoonEndHour");
	gRealParam_normalPlan_februaryMarchAfternoonExtendedEndHour_ = GetRealParameterValue("normalPlan", "februaryMarchAfternoonExtendedEndHour");
	gRealParam_reducedPlan_februaryMarchMorningBegHour_ = GetRealParameterValue("reducedPlan", "februaryMarchMorningBegHour");
	gRealParam_reducedPlan_februaryMarchMorningEndHour_ = GetRealParameterValue("reducedPlan", "februaryMarchMorningEndHour");
	gRealParam_reducedPlan_februaryMarchMorningExtendedEndHour_ = GetRealParameterValue("reducedPlan", "februaryMarchMorningExtendedEndHour");
	gRealParam_reducedPlan_februaryMarchAfternoonBegHour_ = GetRealParameterValue("reducedPlan", "februaryMarchAfternoonBegHour");
	gRealParam_reducedPlan_februaryMarchAfternoonEndHour_ = GetRealParameterValue("reducedPlan", "februaryMarchAfternoonEndHour");
	gRealParam_reducedPlan_februaryMarchAfternoonExtendedEndHour_ = GetRealParameterValue("reducedPlan", "februaryMarchAfternoonExtendedEndHour");
	gRealParam_extendedPlan_mayAugustMorningBegHour_ = GetRealParameterValue("extendedPlan", "mayAugustMorningBegHour");
	gRealParam_extendedPlan_mayAugustMorningEndHour_ = GetRealParameterValue("extendedPlan", "mayAugustMorningEndHour");
	gRealParam_extendedPlan_mayAugustMorningExtendedEndHour_ = GetRealParameterValue("extendedPlan", "mayAugustMorningExtendedEndHour");
	gRealParam_extendedPlan_mayAugustAfternoonBegHour_ = GetRealParameterValue("extendedPlan", "mayAugustAfternoonBegHour");
	gRealParam_extendedPlan_mayAugustAfternoonEndHour_ = GetRealParameterValue("extendedPlan", "mayAugustAfternoonEndHour");
	gRealParam_extendedPlan_mayAugustAfternoonExtendedEndHour_ = GetRealParameterValue("extendedPlan", "mayAugustAfternoonExtendedEndHour");
	gRealParam_normalPlan_mayAugustMorningBegHour_ = GetRealParameterValue("normalPlan", "mayAugustMorningBegHour");
	gRealParam_normalPlan_mayAugustMorningEndHour_ = GetRealParameterValue("normalPlan", "mayAugustMorningEndHour");
	gRealParam_normalPlan_mayAugustMorningExtendedEndHour_ = GetRealParameterValue("normalPlan", "mayAugustMorningExtendedEndHour");
	gRealParam_normalPlan_mayAugustAfternoonBegHour_ = GetRealParameterValue("normalPlan", "mayAugustAfternoonBegHour");
	gRealParam_normalPlan_mayAugustAfternoonEndHour_ = GetRealParameterValue("normalPlan", "mayAugustAfternoonEndHour");
	gRealParam_normalPlan_mayAugustAfternoonExtendedEndHour_ = GetRealParameterValue("normalPlan", "mayAugustAfternoonExtendedEndHour");
	gRealParam_reducedPlan_mayAugustMorningBegHour_ = GetRealParameterValue("reducedPlan", "mayAugustMorningBegHour");
	gRealParam_reducedPlan_mayAugustMorningEndHour_ = GetRealParameterValue("reducedPlan", "mayAugustMorningEndHour");
	gRealParam_reducedPlan_mayAugustMorningExtendedEndHour_ = GetRealParameterValue("reducedPlan", "mayAugustMorningExtendedEndHour");
	gRealParam_reducedPlan_mayAugustAfternoonBegHour_ = GetRealParameterValue("reducedPlan", "mayAugustAfternoonBegHour");
	gRealParam_reducedPlan_mayAugustAfternoonEndHour_ = GetRealParameterValue("reducedPlan", "mayAugustAfternoonEndHour");
	gRealParam_reducedPlan_mayAugustAfternoonExtendedEndHour_ = GetRealParameterValue("reducedPlan", "mayAugustAfternoonExtendedEndHour");
	gRealParam_normalPlan_novemberJanuaryMorningBegHour_ = GetRealParameterValue("normalPlan", "novemberJanuaryMorningBegHour");
	gRealParam_normalPlan_novemberJanuaryMorningEndHour_ = GetRealParameterValue("normalPlan", "novemberJanuaryMorningEndHour");
	gRealParam_normalPlan_novemberJanuaryMorningExtendedEndHour_ = GetRealParameterValue("normalPlan", "novemberJanuaryMorningExtendedEndHour");
	gRealParam_normalPlan_novemberJanuaryAfternoonBegHour_ = GetRealParameterValue("normalPlan", "novemberJanuaryAfternoonBegHour");
	gRealParam_normalPlan_novemberJanuaryAfternoonEndHour_ = GetRealParameterValue("normalPlan", "novemberJanuaryAfternoonEndHour");
	gRealParam_normalPlan_novemberJanuaryAfternoonExtendedEndHour_ = GetRealParameterValue("normalPlan", "novemberJanuaryAfternoonExtendedEndHour");
	gRealParam_reducedPlan_novemberJanuaryMorningBegHour_ = GetRealParameterValue("reducedPlan", "novemberJanuaryMorningBegHour");
	gRealParam_reducedPlan_novemberJanuaryMorningEndHour_ = GetRealParameterValue("reducedPlan", "novemberJanuaryMorningEndHour");
	gRealParam_reducedPlan_novemberJanuaryMorningExtendedEndHour_ = GetRealParameterValue("reducedPlan", "novemberJanuaryMorningExtendedEndHour");
	gRealParam_reducedPlan_novemberJanuaryAfternoonBegHour_ = GetRealParameterValue("reducedPlan", "novemberJanuaryAfternoonBegHour");
	gRealParam_reducedPlan_novemberJanuaryAfternoonEndHour_ = GetRealParameterValue("reducedPlan", "novemberJanuaryAfternoonEndHour");
	gRealParam_reducedPlan_novemberJanuaryAfternoonExtendedEndHour_ = GetRealParameterValue("reducedPlan", "novemberJanuaryAfternoonExtendedEndHour");
	gIntParam_standardWorkingTime_day_ = GetIntParameterValue("standardWorkingTime", "day");
	gIntParam_standardWorkingTime_week_ = GetIntParameterValue("standardWorkingTime", "week");
	gIntParam_standardWorkingTime_year_ = GetIntParameterValue("standardWorkingTime", "year");
	gIntParam_phytoTreatmentsWorkingTime_day_ = GetIntParameterValue("phytoTreatmentsWorkingTime", "day");
	gIntParam_managerWorkingTime_day_ = GetIntParameterValue("managerWorkingTime", "day");
	gIntParam_managerWorkingTime_week_ = GetIntParameterValue("managerWorkingTime", "week");
	gIntParam_phytoTreatmentsWorkingTime_week_ = GetIntParameterValue("phytoTreatmentsWorkingTime", "week");
	gIntParam_morningUpdateSituation_normalHour_ = GetIntParameterValue("morningUpdateSituation", "normalHour");
	gIntParam_morningUpdateSituation_specialHour_ = GetIntParameterValue("morningUpdateSituation", "specialHour");
	gIntParam_virtualManager_pestMemoryScope_ = GetIntParameterValue("virtualManager", "pestMemoryScope");
	gIntParam_virtualManager_actualDownyMildewLevelThreshold_ = GetIntParameterValue("virtualManager", "actualDownyMildewLevelThreshold");
	gRealParam_workabilityHumidityMaxThresholdIfRain_nonPeakPeriod_ = GetRealParameterValue("workabilityHumidityMaxThresholdIfRain", "nonPeakPeriod");
	gRealParam_workabilityHumidityMaxThreshold_nonPeakPeriod_ = GetRealParameterValue("workabilityHumidityMaxThreshold", "nonPeakPeriod");
	gRealParam_workabilityHumidityMaxThreshold_peakPeriod_ = GetRealParameterValue("workabilityHumidityMaxThreshold", "peakPeriod");
	gRealParam_arretMainDOeuvre_seuilCumulPluieJour_ = GetRealParameterValue("arretMainDOeuvre", "seuilCumulPluieJour");
	gRealParam_vineyardActivity_standardMinPercentageToBeginOperation_ = GetRealParameterValue("vineyardActivity", "standardMinPercentageToBeginOperation");
	gRealParam_plantationOperation_overallSpeed_ = GetRealParameterValue("plantationOperation", "overallSpeed");
	gIntParam_trellisingOperation_speed_ = GetIntParameterValue("trellisingOperation", "speed");
	gIntParam_backSprayingOperation_speed_ = GetIntParameterValue("backSprayingOperation", "speed");
	gIntParam_manualDebranchingOperation_speed_ = GetIntParameterValue("manualDebranchingOperation", "speed");
	gRealParam_tillageOperation_speed_ = GetRealParameterValue("tillageOperation", "speed");
	gRealParam_verticalRailOperatedSpraying_speed_ = GetRealParameterValue("verticalRailOperatedSpraying", "speed");
	gRealParam_airAssistedSpraying_speed_ = GetRealParameterValue("airAssistedSpraying", "speed");
	gRealParam_chemicalDebrancherOperatedSpraying_speed_ = GetRealParameterValue("chemicalDebrancherOperatedSpraying", "speed");
	gRealParam_clippingOperation_speed_ = GetRealParameterValue("clippingOperation", "speed");
	gRealParam_fertilizationOperation_speed_ = GetRealParameterValue("fertilizationOperation", "speed");
	gRealParam_grinderOperatedShootThinning_speed_ = GetRealParameterValue("grinderOperatedShootThinning", "speed");
	gRealParam_handHeldGunOperatedSpraying_speed_ = GetRealParameterValue("handHeldGunOperatedSpraying", "speed");
	gRealParam_horizontalRailOperatedSpraying_speed_ = GetRealParameterValue("horizontalRailOperatedSpraying", "speed");
	gRealParam_rotaryOperatedShootThinning_speed_ = GetRealParameterValue("rotaryOperatedShootThinning", "speed");
	gRealParam_virtualManager_weedThresholdForTillageOpening_ = GetRealParameterValue("virtualManager", "weedThresholdForTillageOpening");
	//gStringParam_recordOperations_file_ = GetStringParameterValue("recordOperations", "file");
	gRealParam_trafficabilityRainMaxThreshold_mechanicalOperation_ = GetRealParameterValue("trafficabilityRainMaxThreshold", "mechanicalOperation");
	gRealParam_workabilityRainMaxThreshold_tillageOperation_ = GetRealParameterValue("workabilityRainMaxThreshold", "tillageOperation");
	gIntParam_afternoonUpdateSituation_normalHour_ = GetIntParameterValue("afternoonUpdateSituation", "normalHour");
	gRealParam_tillageOperation_speedReductionRate_ = GetRealParameterValue("tillageOperation", "speedReductionRate");
	gIntParam_virtualManager_nbDaysThresholdForTillageOpening_ = GetIntParameterValue("virtualManager", "nbDaysThresholdForTillageOpening");
	gIntParam_guyotPruning_speedNotPrePruned_ = GetIntParameterValue("guyotPruning", "speedNotPrePruned");
	gRealParam_virtualManager_lowRainfallThresholdForWinterRainBasedSpringTillage_ = GetRealParameterValue("virtualManager", "lowRainfallThresholdForWinterRainBasedSpringTillage");
	gRealParam_virtualManager_highRainfallThresholdForWinterRainBasedSpringTillage_ = GetRealParameterValue("virtualManager", "highRainfallThresholdForWinterRainBasedSpringTillage");
	gIntParam_virtualManager_springTillagesMaxNumberOfReplicationsInDryPeriod_ = GetIntParameterValue("virtualManager", "springTillagesMaxNumberOfReplicationsInDryPeriod");
	gRealParam_virtualManager_rainfallThresholdForWinterRainBasedInitSpringTillage_ = GetRealParameterValue("virtualManager", "rainfallThresholdForWinterRainBasedInitSpringTillage");
	gIntParam_virtualManager_downyMildewLevelThresholdForFlagUp_ = GetIntParameterValue("virtualManager", "downyMildewLevelThresholdForFlagUp");
	gRealParam_virtualManager_downyMildewRiskThresholdForFlagUp_ = GetRealParameterValue("virtualManager", "downyMildewRiskThresholdForFlagUp");
};
 
 
