void initPestInfoFileReading_postReadProcess_Body(ProcessMethod* pM)
//---------------------------------------------
// Definition de la fonction qui code l'exploitation des valeurs
// lues sur un enregistrement.
//---------------------------------------------
{
  ReadFactualDataRecordProcess* pDP
    = (ReadFactualDataRecordProcess*)(pM->DescribedDiscreteProcess());
  Entity* pVineyardSet = pDP->ProcessedEntity();
  FactualDataFile* pF = pDP->GetFile();

  char* fldFlagShoot = pF->GetStringFieldValue(FLD_FLAGSHOOT);
  int fldLevelPM = pF->GetIntFieldValue(FLD_LEVEL_PM);
  char* fldPrimInfectDM = pF->GetStringFieldValue(FLD_PRIM_INFECT_DM);
  int fldLevelDM = pF->GetIntFieldValue(FLD_LEVEL_DM);
  float fldRiskLevelDM = pF->GetFloatFieldValue(FLD_RISK_DM);

  Entity* pestInfoItem = new PestInfoMemoryItem();
  //--------------------------------------------------
  int index = FLD_DMY;
  char* champDate = strdup(pF->GetStringFieldValue(index));

  if(strlen(champDate) == 0)
	return;

//printf("\ninitPestInfoFileReading_PR champDate : '%s'", champDate);
  char* s_d = strtok(champDate,"/");
  char* s_m = strtok(NULL,"/");
  char* s_y = strtok(NULL,"/");
  int d = atoi(s_d);
  int m = atoi(s_m);
  int y = atoi(s_y);
  free(champDate);
  int clockValue = DateToClockValue(d, m, y, 0, 0, 0);
  pestInfoItem->SetIntConstValue(INSTANT_ATTRIBUTE, 
								 clockValue);
  //--------------------------------------------------
  int flagShoot = NON;
  if(! strcmp(fldFlagShoot, "O"))
	flagShoot = OUI;
  pestInfoItem->SetIntConstValue(POWDERY_MILDEW_FLAG_SHOOT,
								 flagShoot);
  //--------------------------------------------------

  pestInfoItem->SetIntConstValue(POWDERY_MILDEW_LEVEL,
								 fldLevelPM);
  //--------------------------------------------------
  int primInfectDM = NON;
  if(! strcmp(fldPrimInfectDM, "O"))
	primInfectDM = OUI;
  pestInfoItem->SetIntConstValue(DOWNY_MILDEW_PRIMARY_INFECTION,
								 primInfectDM);
  //--------------------------------------------------

  pestInfoItem->SetIntConstValue(DOWNY_MILDEW_LEVEL,
								 fldLevelDM);
  //--------------------------------------------------

  pestInfoItem->SetFloatConstValue(DOWNY_MILDEW_RISK_LEVEL,
								   fldRiskLevelDM);
  //--------------------------------------------------

  Entity* pMemory = pVineyardSet->GetEntityConstValue(PEST_INFO_MEMORY_ATTRIBUTE);
  pMemory->InsertElement(0, pestInfoItem);

//printf("\nPestInfo : t:'%s' (clock = %d) %d %d %d %d %4.2f", pF->GetStringFieldValue(FLD_DMY), clockValue, flagShoot, fldLevelPM, primInfectDM, fldLevelDM, fldRiskLevelDM);
//printf("\n\t--> ");pMemory->DisplayElementNames();

};
