void hourlyWeatherFileReading_postReadProcess_Body(ProcessMethod* pM)
//---------------------------------------------
// Definition de la fonction qui code l'exploitation des valeurs
// lues sur un enregistrement.
//---------------------------------------------
{
  //
  // 1) cumul pluie depuis interaction Mhydas
  // 2) cumul pluie depuis dernier tillage (RAZ dans AchievementDegreeMonitor)
  // 3) cumul pluie depuis debut hiver (130308, 5.5) 
  // 3bis) cumul pluie depuis debut hiver pour InitST (130425, 5.6) 
  //
  ReadBufferizedDataFileProcess* pCP 
	= (ReadBufferizedDataFileProcess*)(pM->DescribedContinuousProcess());
  Entity* pWS = pCP->ProcessedEntity();
  BufferizedDataFile* pF = (BufferizedDataFile*)pCP->GetFile();

  // ligne : 2004-01-01 19:00:00 0.5
  char* date = pF->GetStringFieldValue(FLD_DATE);
  //         2004-01-01
  char* heure = pF->GetStringFieldValue(FLD_HOUR);
  //                    19:00:00
  float rain_i = pF->GetFloatFieldValue(FLD_RAINFALL);
  //                     0.5
  pWS->SetFloatValue(RAINFALL, rain_i);
//printf("\ndateLue     : '%s' '%s' rain = %f", date, heure, rain_i);

  //
  // Traduction heure UTC -> heure locale
  //
  char* tmpDate = new char[50];
  sprintf(tmpDate, "%s", date);
  int y = atoi(strtok(tmpDate,"-"));
  int m = atoi(strtok(NULL,"-"));
  int d = atoi(strtok(NULL,"-"));
  char* tmpHeure = new char[50];
  sprintf(tmpHeure, "%s", heure);
  int h = atoi(strtok(tmpHeure,":"));
  int n = atoi(strtok(NULL,":"));
  int s = atoi(strtok(NULL,":"));
  delete[] tmpDate;
  delete[] tmpHeure;

  time_t absT = UTCDateToAbsoluteTime(d, m, y, h, n, s); // modif JPR 130306
  //
  // transformation en date locale, langage de la décision
  //
  tm* pTm = new tm();
  localtime_r(&absT, pTm);
  StructTmToStringISO(pTm);
//printf("\n----pTm_local : '%s' timezone = %d tzname : '%s' '%s' daylight = %d", gTimeString, timezone, tzname[0], tzname[1], daylight);
  int wday = pTm->tm_wday;
  
  int now = pCurrentSim->Clock(); // modif JPR 130306
  int clock = now; // modif JPR 130306

  Entity* pWSSet = pWS->GetSuperSet();
  if(pWSSet->GetIntConstValue(LAST_WEATHER_PRINT_CLOCK) != clock) {
	  printf("\n---- le %s %s (clock = %d) ---- rain %s : %4.1f", ShortWeekDayNameToCharTab[wday], gTimeString, clock, pWS->InstanceName(), rain_i);
	  pWSSet->SetIntConstValue(LAST_WEATHER_PRINT_CLOCK, clock);
  }
  else
	printf(" %s : %4.1f", pWS->InstanceName(), rain_i);

  //
  // tache 2) cumul pluie depuis depuis dernier tillage
  //       3) cumul pluie depuis debut hiver
  //
  pEntityTab* pPlotForThisWS = new pEntityTab();
  Entity* pSystem = pWSSet->GetSuperEntity();
  Entity* pVineyardSet = pSystem->GetComponent(VINEYARD_SET);
  int nbEA = pVineyardSet->GetNumberOfElements();
  for(int i=0;i<nbEA;i++) {
	Entity* pEA_i = pVineyardSet->GetElement(i);
	pEntityTab pPlotList = pEA_i->GetElementTab();
	int nbPlots = pPlotList.size();
	for(int j=0;j<nbPlots;j++) {
	  Entity* pPlot_j = (Entity*)pPlotList[j];
	  Entity* pWS_j = pPlot_j->GetEntityConstValue(WEATHER_STATION_ATTRIBUTE);
	  if(pWS_j == pWS) {
		pPlotForThisWS->push_back(pPlot_j);
		//
		// tache 2)
		//
		float oldValue = 
		  pPlot_j->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_LAST_TILLAGE);
		float newValue = oldValue + rain_i;
//printf("\nplot '%s' new cumul pluie depuis dernier tillage = %f", pPlot_j->InstanceName(), newValue);
		pPlot_j->SetFloatVarValue(CUMULATIVE_RAINFALL_FROM_LAST_TILLAGE,
								  newValue);
		//
		// tache 3)
		//
		int clockDebutHiver = pWS_j->GetIntConstValue(WINTER_BEGINNING_CLOCK);
//printf("\nplot '%s' clockDebutHiver = %d", pPlot_j->InstanceName(), clockDebutHiver);
		if(now >= clockDebutHiver) {
		  oldValue = 
			pPlot_j->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_EARLY_WINTER);
		  newValue = oldValue + rain_i;
//printf("\nplot '%s' new cumul pluie depuis debut hiver = %f", pPlot_j->InstanceName(), newValue);
		  pPlot_j->SetFloatVarValue(CUMULATIVE_RAINFALL_FROM_EARLY_WINTER,
									newValue);
		}
		//
		// tache 3bis) JPR 130425 (5.6)
		//
		int clockDebutHiverPourInit = pWS_j->GetIntConstValue(WINTER_BEGINNING_CLOCK_FOR_INITST);
//printf("\nplot '%s' clockDebutHiver = %d", pPlot_j->InstanceName(), clockDebutHiverPourInit);
		if(now >= clockDebutHiverPourInit) {
		  oldValue = 
			pPlot_j->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_EARLY_WINTER_FOR_INITST);
		  newValue = oldValue + rain_i;
//printf("\nplot '%s' new cumul pluie depuis debut hiver pour initst = %f", pPlot_j->InstanceName(), newValue);
		  pPlot_j->SetFloatVarValue(CUMULATIVE_RAINFALL_FROM_EARLY_WINTER_FOR_INITST,
									newValue);
		}
	  }
	}
  }
  pTm->tm_hour = 21;
  mktime(pTm);
  int julianDay = pTm->tm_yday;
  int leSoir = StructTmToClockValue(pTm);
  delete pTm;
  //
  // recherche dans l'agenda d'un event MhydasInteraction
  //
  Event* pMhydasInteractionEvent = NULL;
  pCurrentSim->GoHeadInAgenda();
  while(pCurrentSim->IsCurrentInAgenda()) {
	Event* pEvent = pCurrentSim->GetCurrentInAgenda();
	if(! strcmp(pEvent->ClassName(), "morningMhydasInteractionEvent")) {
	  pMhydasInteractionEvent = pEvent;
	  break;
	}
	pCurrentSim->GoNextInAgenda();
  };
  if(pMhydasInteractionEvent) {
	//
	// cumul pluie depuis la derniere interaction Mhydas 
	// et debrayage apres 21h jusqu'a l'interaction du matin
	//
	int nextInteractionClock = pMhydasInteractionEvent->OccurrenceClockTime();
//printf("\n\tnextInteractionClock = %d   leSoir = %d", nextInteractionClock, leSoir);
	tm* pTm_interaction = ClockValueToTm(nextInteractionClock);
	int julianDay_interaction = pTm_interaction->tm_yday;
	delete pTm_interaction;
	bool nextInteractionCeJour = FALSE;
	if(julianDay_interaction == julianDay)
	  nextInteractionCeJour = TRUE;
	int nbPlots = pPlotForThisWS->size();
	for(int j=0;j<nbPlots;j++) {
	  Entity* pPlot_j = (Entity*)pPlotForThisWS->get_element(j);
	  if((clock > leSoir)
		 ||
		 ((clock < nextInteractionClock)
		  &&
		  nextInteractionCeJour)) {
		// no action
	  }
	  else {
		float oldValue = 
		  pPlot_j->GetFloatVarValue(CUMULATIVE_RAINFALL_FROM_MHYDAS_INTERACTION);
		float newValue = oldValue + rain_i;
//printf("\nplot '%s' new cumul pluie depuis Mhydas = %f", pPlot_j->InstanceName(), newValue);
		pPlot_j->SetFloatVarValue(CUMULATIVE_RAINFALL_FROM_MHYDAS_INTERACTION,
								  newValue);
	  }
	}
  }
  delete pPlotForThisWS;
};
