void initPhenoStageFileReading_postReadProcess_Body(ProcessMethod* pM)
//---------------------------------------------
// Definition de la fonction qui code l'exploitation des valeurs
// lues sur un enregistrement.
//---------------------------------------------
{
  ReadFactualDataRecordProcess* pDP
    = (ReadFactualDataRecordProcess*)(pM->DescribedDiscreteProcess());
  //Entity* pEntity = pDP->ProcessedEntity();
  FactualDataFile* pF = pDP->GetFile();

  int codeStade = pF->GetIntFieldValue(FLD_CODE_STADE);
  char* nomVariete = pF->GetStringFieldValue(FLD_VARIETE);

  pEntityTab* isoAgeingEntityTab = GetEntityList(ISO_AGEING_ENTITY);
  int nbElem = isoAgeingEntityTab->size();
  for(int k=0;k<nbElem;k++) {
	Entity* pIsoAgeingEntity = (Entity*)isoAgeingEntityTab->get_element(k);
	Entity* pVariety = pIsoAgeingEntity->GetEntityConstValue(GRAPE_VARIETY_ATTRIBUTE);
	if(! strcmp(pVariety->InstanceName(), nomVariete)) {
	  Entity* pAge = pIsoAgeingEntity->GetEntityConstValue(AGE_ATTRIBUTE);
	  pAge->SetIntVarValue(CURRENT_STAGE_INDEX, codeStade);
	  pEntityTab* stageTab = pAge->GetEntityTabConstValue(STAGE_TAB);
	  Entity* pCurrentStage = (Entity*)stageTab->get_element(codeStade);
//printf("\nPhenoStage : '%s' passe au stade %d", nomVariete, codeStade);
	  tm* pTm = ClockValueToTm(pCurrentSim->Clock());
	  pCurrentStage->SetIntVarValue(DAY_WHEN_ACHIEVED, pTm->tm_yday);
	  delete pTm;

	  //break;  // !! - JPR 101020
	}
  }
};
